@echo off

::------------------------------------------------------------------------------
:: MSMG ToolKit v10.0
:: Copyright (c) 2013-2020 MSMG. All rights reserved.
::------------------------------------------------------------------------------
::
:: Credits: CREDITS.TXT
:: License: LICENSE.TXT
:: 3rd Party License: <Bin\LICENSES>
::
::-------------------------------------------------------------------------------------------

color 1f
title MSMG Toolkit v10.0

reg add "HKCU\Console\%%SystemRoot%%_system32_cmd.exe" /v "ScreenBufferSize" /t REG_DWORD /d "0x23290050" /f >nul
reg add "HKCU\Console\%%SystemRoot%%_system32_cmd.exe" /v "WindowSize" /t REG_DWORD /d "0x190050" /f >nul

setlocal EnableExtensions
setlocal EnableDelayedExpansion

:: Setting Toolkit environment path variables
set "Bin=%~dp0Bin"
set "Custom=%~dp0Custom"
set "Drivers=%~dp0Drivers"
set "DVD=%~dp0DVD"
set "ISO=%~dp0ISO"
set "Logs=%~dp0Logs"
set "Mount=%~dp0Mount"
set "Packs=%~dp0Packs"
set "ROOT=%~dp0"
set "Temp=%~dp0Temp"
set "Updates=%~dp0Updates"
set "WHD=%~dp0WHD"

:: Setting Host OS version, architecture and language variables
for /f "tokens=4-5 delims=. " %%i in ('ver 2^>nul') do set "HostVersion=%%i.%%j"
If exist "%WinDir%\SysWOW64" set "HostArchitecture=x64"
If not exist "%WinDir%\SysWOW64" set "HostArchitecture=x86"
set HostLanguage=

:: Setting WADK tools environment path variables
if "%HostVersion%" equ "6.1" set "DISM=%Bin%\%HostArchitecture%\DISM81\Dism.exe"
if "%HostVersion%" neq "6.1" set "DISM=%Bin%\%HostArchitecture%\DISM10\Dism.exe"
set "DismScratch=%Temp%\DISM"
set "DismFormat=/English /ScratchDir:%DismScratch% /LogPath:%Logs%\Dism.txt /LogLevel:3 /NoRestart"
set "Imagex=%Bin%\%HostArchitecture%\imagex.exe"
set "Oscdimg=%Bin%\%HostArchitecture%\oscdimg.exe"
set "Dvdburn=%Bin%\dvdburn.exe"
set "WimConfigFile=%Bin%\wimscript.ini"

:: Setting Source OS variables
set SelectedSourceOS=
set "BootWim=%DVD%\sources\boot.wim"
set "InstallWim=%DVD%\sources\install.wim"
set "InstallEsd=%DVD%\sources\install.esd"
set "WinReWim=Windows\System32\Recovery\winre.wim"
set "BootMount=%Mount%\Boot"
set "InstallMount=%Mount%\Install"
set "WinReMount=%Mount%\WinRE"

:: Setting Source Image information variables
set ImageCount=
set ImageIndexNo=
set ImageArchitecture=
set ImageName=
set ImageDescription=
set ImageFlag=
set ImageEdition=
set ImageInstallationType=
set ImageDefaultLanguage=
set ImageMajorVersion=
set ImageMinorVersion=
set ImageBuild=
set ImageVersion=
set ImageServicePackBuild=
set PackageServicePackBuild=
set ImageServicePackLevel=
set ImageSize=

:: Setting Toolkit's control flag variables
set IsSourceSelected=No
set IsBootImageSelected=No
set IsRecoveryImageSelected=No
set IsRecoveryImageModified=
set IsDialogsEnabled=Yes
set IsLogsEnabled=Yes
set IsImageRegistryLoaded=No
set IsW7SP1CRUSelected=

set "PreActTokens=%Custom%\ActivationTokens"
set "CustomFiles=%Custom%\Files"
set "CustomRecoveryImage=%Custom%\RecoveryImage"
set "CustomRegistry=%Custom%\Registry"
set "CustomTerminalServer=%Custom%\TerminalServer"
set "CustomUxTheme=%Custom%\UxTheme"

:: Setting Toolkit's packs environment path variables
set "Apps=%Packs%\Apps"
set "Braille=%Packs%\Braille"
set "DaRT=%Packs%\DaRT"
set "Dedup=%Packs%\Dedup"
set "DirectX9c=%Packs%\DirectX9c"
set "EdgeClassic=%Packs%\EdgeBrowser"
set "EdgeChromium=%Packs%\EdgeChromium"
set "Games=%Packs%\Games"
set "IE11=%Packs%\IE11"
set "LanguagePacks=%Packs%\LanguagePacks"
set "MediaFeaturePack=%Packs%\MediaFeaturePack"
set "MMRC=%Packs%\MultimediaRestrictedCodecs"
set "NetFx35=%Packs%\NetFX35"
set "NetFx462=%Packs%\NetFX462"
set "NetFx48=%Packs%\NetFX48"
set "OfficeUWP=%Packs%\OfficeUWP"
set "OpenSSH=%Packs%\OpenSSH"
set "PortableDevices=%Packs%\PortableDevices"
set "RDP81=%Packs%\RDP81"
set "RSAT=%Packs%\RSAT"
set "Sidebar=%Packs%\Sidebar"
set "Skins=%Packs%\Skins"
set "SystemRestore=%Packs%\SystemRestore"
set "ThinPC=%Packs%\ThinPC"
set "UAP=%Packs%\UAP"
set "VCRuntime=%Packs%\VCRuntime"
set "Win32Calc=%Packs%\Win32Calc"
set "WinToGo=%Packs%\WinToGo"
set "WMF=%Packs%\WMF"
set "WSL=%Packs%\WSL"

:: Setting Toolkit's dependent tools environment path variables
set "Lists=%Bin%\Lists"
set "Patches=%Bin%\Patches"
set "ResourceHacker=%Bin%\ResourceHacker.exe"
set "ToolKitHelper=%Bin%\ToolKitHelper.exe"
set "W10EsdDecrypter=%Bin%\Dism++CUI.exe /ESDFile"
set "W81EsdDecrypter=%Bin%\esddecrypt.exe"
set "WimlibImagex=%Bin%\%HostArchitecture%\wimlib-imagex.exe"
set "XCopy=xcopy.exe /E /I /H /R /Y /J"
set "XMLs=%Bin%\XMLs"
set "W7ESUFix=%Bin%\Patches\W7ESUFix"
set "W10CUFix=%Bin%\Patches\W10CUFix"
set "WMCGActTokens=%Bin%\Patches\WMCGActTokens.tpk"
set "Zip=%Bin%\%HostArchitecture%\7z.exe"

::-------------------------------------------------------------------------------------------
:: MSMG ToolKit - EULA
::-------------------------------------------------------------------------------------------
cls

echo.===============================================================================
echo.########################## MSMG ToolKit - EULA ################################
echo.===============================================================================
echo.
echo.
echo. The MSMG Toolkit is basically a tool to service, customize, add or remove
echo. features and components, enable or disable features to Windows operating
echo. system.
echo.
echo. The MSMG Toolkit is intended to be used with licensed Microsoft Windows
echo. operating systems only.
echo.
echo. This MSMG Toolkit is provided 'as-is', without any express or implied warranty.
echo. In no event will the author be held liable for any damages arising from the
echo. use of this script.
echo.
echo. The MSMG Toolkit uses various 3rd party tools to accomplish some of it's
echo. tasks.
echo.
echo. MSMG ToolKit, Windows are registered trademarks of their respective authors
echo. or companies.
echo.
echo.
echo.===============================================================================
choice /C AR /N /M "###########################[ 'A'ccept / 'R'eject ]############################"
if errorlevel 2 (
	reg delete "HKCU\Console\%%SystemRoot%%_system32_cmd.exe" /f >nul

	color 00
	endlocal EnableExtensions
	endlocal EnableDelayedExpansion

	exit
)

::-------------------------------------------------------------------------------------------
:: MSMG Toolkit - Startup function
::-------------------------------------------------------------------------------------------
cls

echo.
echo.Performing Toolkit pre-cleanup operation, please wait...
call :Cleanup >nul
cls
echo.===============================================================================
echo.                           MSMG ToolKit - StartUp
echo.===============================================================================
echo.
echo.Reading Host OS Information...
for /f "tokens=6 delims= " %%a in ('DISM /Online /English /Get-Intl ^| findstr /i /C:"Default system UI language"') do (set HostLanguage=%%a)
echo.
if "%HostArchitecture%" equ "x86" (
	if "%HostVersion%" equ "6.1" echo. - Microsoft Windows 7 ^(%HostArchitecture%^) [%HostLanguage%]
	if "%HostVersion%" equ "6.3" echo. - Microsoft Windows 8.1 ^(%HostArchitecture%^) [%HostLanguage%]
	if "%HostVersion%" equ "10.0" echo. - Microsoft Windows 10 ^(%HostArchitecture%^) [%HostLanguage%]
)

if "%HostArchitecture%" equ "x64" (
	if "%HostVersion%" equ "6.1" echo. - Microsoft Windows 7 / Server 2008 R2 ^(%HostArchitecture%^) [%HostLanguage%]
	if "%HostVersion%" equ "6.3" echo. - Microsoft Windows 8.1 / Server 2012 R2 ^(%HostArchitecture%^) [%HostLanguage%]
	if "%HostVersion%" equ "10.0" echo. - Microsoft Windows 10 / Server 2016/2019 ^(%HostArchitecture%^) [%HostLanguage%]
)

:: Setting DOS character codepage
if "%HostLanguage%" equ "en-GB" chcp 437 >nul
if "%HostLanguage%" equ "en-US" chcp 437 >nul
if "%HostLanguage%" equ "zh-CN" chcp 936 >nul

echo.
echo.Setting Toolkit and WADK tools environment path variables...
echo.
echo.DISM.exe           =  %DISM%
call :CreateFolder "%DismScratch%"
set "DISM=%DISM% %DismFormat%"
echo.Imagex.exe         =  %Imagex%
echo.Oscdimg.exe        =  %Oscdimg%
echo.Dvdburn.exe        =  %Dvdburn%
echo.7zip.exe           =  %Zip%
echo.Dism++CUI.exe      =  %W10EsdDecrypter%
echo.EsdDecrypt.exe     =  %W81EsdDecrypter%
echo.ToolKitHelper.exe  =  %ToolKitHelper%
echo.ResourceHacker.exe =  %ResourceHacker%
echo.WimlibImagex.exe   =  %WimlibImagex%
echo.
echo.===============================================================================
echo.
echo Press ENTER Key to Continue... 
pause >nul
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: MSMG Toolkit - Main Menu
::-------------------------------------------------------------------------------------------
:MainMenu

cls
echo.===============================================================================
echo.                           MSMG ToolKit - Main Menu
echo.===============================================================================
echo.
echo.                             [1]   Source
echo.
echo.                             [2]   Convert
echo.
echo.                             [3]   Integrate
echo.
echo.                             [4]   Remove
echo.
echo.                             [5]   Customize
echo.
echo.                             [6]   Apply
echo.
echo.                             [7]   Target
echo.
echo.                             [8]   Tools
echo.
echo.                             [X]   Quit
echo.
echo.===============================================================================
choice /C:12345678X /N /M "Enter Your Choice : "
if errorlevel 9 goto :Quit
if errorlevel 8 goto :ToolsMenu
if errorlevel 7 goto :TargetMenu
if errorlevel 6 goto :ApplyMenu
if errorlevel 5 goto :CustomizeMenu
if errorlevel 4 goto :RemoveMenu
if errorlevel 3 goto :IntegrateMenu
if errorlevel 2 goto :ConvertMenu
if errorlevel 1 goto :SourceMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: MSMG Toolkit - Select Source Menu
::-------------------------------------------------------------------------------------------
:SourceMenu

cls
echo.===============================================================================
echo.                         MSMG ToolKit - Source Menu
echo.===============================================================================
echo.

:: Checking whether Source OS is selected
if "%IsSourceSelected%" equ "Yes" (
	echo.Source OS has already been selected..
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu
)

:: Checking whether Image Registry is loaded
if "%IsImageRegistryLoaded%" equ "Yes" (
	echo.Source OS Image Registry is loaded, please do unload it using Tools-^>Options..
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu
)

echo.  [1]   Select Source from ^<DVD^> Folder
echo.
echo.  [2]   Copy Source from DVD Drive
echo.
echo.  [3]   Extract Source from DVD ISO Image
echo.
echo.  [4]   Extract Source from OEM IMG Image
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.  [X]   Go Back
echo.
echo.===============================================================================
echo.
choice /C:1234X /N /M "Enter Your Choice : "
if errorlevel 5 goto :MainMenu
if errorlevel 4 goto :SelectSourceIMG
if errorlevel 3 goto :SelectSourceISO
if errorlevel 2 goto :SelectSourceCopy
if errorlevel 1 goto :SelectSourceDVD
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: MSMG ToolKit - Convert Source Image/Edition Menu
::-------------------------------------------------------------------------------------------
:ConvertMenu

cls
echo.===============================================================================
echo.                   MSMG ToolKit - Convert Source Image Menu
echo.===============================================================================
echo.

:: Checking whether Source OS is selected
if "%IsSourceSelected%" equ "Yes" (
	echo.Can't use this feature when the Source OS is selected...
	echo.
	echo.===============================================================================
	echo.
	pause
	
	goto :Mainmenu
)

echo.  [1]   Convert Store ESD Image to WIM Image
echo.
echo.  [2]   Convert Install ESD Image to WIM Image
echo.
echo.  [3]   Convert MCT Image to WIM Image
echo.
echo.  [4]   Convert WIM Image to ESD Image
echo.
echo.  [X]   Go Back
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.        
echo.===============================================================================
echo.
choice /C:1234X /N /M "Enter Your Choice : "
if errorlevel 5 goto :MainMenu
if errorlevel 4 goto :ConvertWim2Esd
if errorlevel 3 goto :ConvertMCT2Wim
if errorlevel 2 goto :ConvertEsd2Wim
if errorlevel 1 goto :ConvertStoreEsd2Wim
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: MSMG ToolKit - Integrate Menu
::-------------------------------------------------------------------------------------------
:IntegrateMenu

cls
echo.===============================================================================
echo.                         MSMG ToolKit - Integrate Menu
echo.===============================================================================
echo.
:: Checking whether Source OS is selected
if "%IsSourceSelected%" equ "No" (
	echo.Source OS is not selected, please do select source from "Source" menu..
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu
)

:: Checking whether Image Registry is loaded
if "%IsImageRegistryLoaded%" equ "Yes" (
	echo.Source OS Image Registry is loaded, please do unload it using Tools-^>Options..
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu
)

echo.  [1]   Windows Language Packs
echo.
echo.  [2]   Windows Drivers
echo.
echo.  [3]   Windows Features
echo.
echo.  [4]   Windows Updates
echo.
echo.  [5]   Windows Custom Features
echo.
echo.
echo.
echo.
echo.
echo.
echo.  [X]   Go Back
echo.
echo.===============================================================================
echo.
choice /C:12345X /N /M "Enter Your Choice : "
if errorlevel 6 goto :MainMenu
if errorlevel 5 goto :IntCustomFeatures
if errorlevel 4 goto :IntUpdatesMenu
if errorlevel 3 goto :IntFeatures
if errorlevel 2 goto :IntDrivers
if errorlevel 1 goto :IntLanguagePacks
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: MSMG ToolKit - Integrate Windows Features Menu
::-------------------------------------------------------------------------------------------
:IntFeatures

cls
echo.===============================================================================
echo.                MSMG ToolKit - Integrate Windows Features Menu
echo.===============================================================================

:: Checking whether the selected Source OS is a Windows 7 Client
if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType%" equ "Client" (
	echo.
	echo.  [A]   Microsoft .NET Framework 4.8
	echo.  [B]   Microsoft Internet Explorer 11
	echo.  [C]   Microsoft Edge Chromium Browser
	echo.  [D]   Remote Desktop Protocol ^(RDP^) 8.0 ^& 8.1
	echo.  [E]   Windows Media Feature Pack
	echo.  [F]   Windows Management Framework ^(WMF^) 5.1
	echo.  [G]   Remote Server Administration Tool ^(RSAT^)
	echo.  [H]   Microsoft DaRT 7.0 Tools
	echo.  [I]   Microsoft DirectX 9.0c
	echo.  [J]   Microsoft Games
	echo.  [K]   Microsoft Visual C++ Runtime
	echo.
	echo.
	echo.
	echo.
	echo.  [X]   Go Back
	echo.
	echo.===============================================================================
	echo.
	choice /C:ABCDEFGHIJKX /N /M "Enter Your Choice : "
	if errorlevel 12 goto :IntegrateMenu
	if errorlevel 11 goto :IntVCRuntime
	if errorlevel 10 goto :IntGames
	if errorlevel 9  goto :IntDirectX9c
	if errorlevel 8  goto :IntDaRT
	if errorlevel 7  goto :IntRSAT
	if errorlevel 6  goto :IntWMF
	if errorlevel 5  goto :IntMediaFeaturePack
	if errorlevel 4  goto :IntRDP81
	if errorlevel 3  goto :IntEdgeChromium
	if errorlevel 2  goto :IntIE11
	if errorlevel 1  goto :IntNetFX48
)

:: Checking whether the selected Source OS is a Windows 7 Embedded Edition
if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType%" equ "Embedded" (
	echo.
	echo.  [A]   Microsoft .NET Framework 4.8
	echo.  [B]   Microsoft Internet Explorer 11
	echo.  [C]   Microsoft Edge Chromium Browser
	echo.  [D]   Remote Desktop Protocol ^(RDP^) 8.0 ^& 8.1
	echo.  [E]   Windows Management Framework ^(WMF^) 5.1
	echo.  [F]   Windows Thin PC Add-on Features
	echo.  [G]   Microsoft DaRT 7.0 Tools
	echo.  [H]   Microsoft DirectX 9.0c
	echo.  [I]   Microsoft Games
	echo.  [J]   Microsoft Visual C++ Runtime
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.  [X]   Go Back
	echo.
	echo.===============================================================================
	echo.
	choice /C:ABCDEFGHIJX /N /M "Enter Your Choice : "
	if errorlevel 11 goto :IntegrateMenu
	if errorlevel 10 goto :IntVCRuntime
	if errorlevel 9  goto :IntGames
	if errorlevel 8  goto :IntDirectX9c
	if errorlevel 7  goto :IntDaRT
	if errorlevel 6  goto :IntThinPcPkgs
	if errorlevel 5  goto :IntWMF
	if errorlevel 4  goto :IntRDP81
	if errorlevel 3  goto :IntEdgeChromium
	if errorlevel 2  goto :IntIE11
	if errorlevel 1  goto :IntNetFX48
)

:: Checking whether the selected Source OS is a Windows Server 2008 R2 Core Edition
if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType%" equ "Server Core" (
	echo.
	echo.  [A]   Microsoft .NET Framework 4.8
	echo.  [B]   Microsoft Internet Explorer 11
	echo.  [C]   Microsoft Edge Chromium Browser
	echo.  [D]   Remote Desktop Protocol ^(RDP^) 8.0 ^& 8.1
	echo.  [E]   Windows Management Framework ^(WMF^) 5.1
	echo.  [F]   Microsoft DaRT 7.0 Tools
	echo.  [G]   Microsoft DirectX 9.0c
	echo.  [H]   Microsoft Games
	echo.  [I]   Microsoft Visual C++ Runtime
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.  [X]   Go Back
	echo.
	echo.===============================================================================
	echo.
	choice /C:ABCDEFGHIX /N /M "Enter Your Choice : "
	if errorlevel 10 goto :IntegrateMenu
	if errorlevel 9  goto :IntVCRuntime
	if errorlevel 8  goto :IntGames
	if errorlevel 7  goto :IntDirectX9c
	if errorlevel 6  goto :IntDaRT
	if errorlevel 5  goto :IntWMF
	if errorlevel 4  goto :IntRDP81
	if errorlevel 3  goto :IntEdgeChromium
	if errorlevel 2  goto :IntIE11
	if errorlevel 1  goto :IntNetFX48
)

:: Checking whether the selected Source OS is a Windows Server 2008 R2
if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType%" equ "Server" (
	echo.
	echo.  [A]   Microsoft .NET Framework 4.8
	echo.  [B]   Microsoft Internet Explorer 11
	echo.  [C]   Microsoft Edge Chromium Browser
	echo.  [D]   Remote Desktop Protocol ^(RDP^) 8.0 ^& 8.1
	echo.  [E]   Windows Management Framework ^(WMF^) 5.1
	echo.  [F]   Windows System Restore
	echo.  [G]   Microsoft DaRT 7.0 Tools
	echo.  [H]   Microsoft DirectX 9.0c
	echo.  [I]   Microsoft Games
	echo.  [J]   Windows Sidebar
	echo.  [K]   Microsoft Visual C++ Runtime
	echo.
	echo.
	echo.
	echo.
	echo.  [X]   Go Back
	echo.
	echo.===============================================================================
	echo.
	choice /C:ABCDEFGHIJKX /N /M "Enter Your Choice : "
	if errorlevel 12 goto :IntegrateMenu
	if errorlevel 11 goto :IntVCRuntime
	if errorlevel 10 goto :IntSidebar
	if errorlevel 9  goto :IntGames
	if errorlevel 8  goto :IntDirectX9c
	if errorlevel 7  goto :IntDaRT
	if errorlevel 6  goto :IntSystemRestore
	if errorlevel 5  goto :IntWMF
	if errorlevel 4  goto :IntRDP81
	if errorlevel 3  goto :IntEdgeChromium
	if errorlevel 2  goto :IntIE11
	if errorlevel 1  goto :IntNetFX48
)

:: Checking whether the selected Source OS is a Windows 8.1 RT (ARM)
if "%SelectedSourceOS%" equ "w81" if "%ImageArchitecture%" equ "arm" (
	echo.
	echo.  [1]   Microsoft .NET Framework 4.8
	echo.
	echo.  [2]   Microsoft Default Metro Apps
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.  [X]   Go Back
	echo.
	echo.===============================================================================
	echo.
	choice /C:12X /N /M "Enter Your Choice : "
	if errorlevel 3 goto :IntegrateMenu
	if errorlevel 2 goto :IntMetroApps
	if errorlevel 1 goto :IntNetFX48
)

:: Checking whether the selected Source OS is a Windows 8.1 32-Bit
if "%SelectedSourceOS%" equ "w81" if "%ImageArchitecture%" equ "x86" (
	echo.
	echo.  [A]   Microsoft .NET Framework 3.5
	echo.  [B]   Microsoft .NET Framework 4.8
	echo.  [C]   Microsoft Edge Chromium Browser
	echo.  [D]   Windows To Go Workspace
	echo.  [E]   Windows Media Feature Pack
	echo.  [F]   Microsoft Default Metro Apps
	echo.  [G]   Windows Management Framework ^(WMF^) 5.1
	echo.  [H]   Remote Server Administration Tool ^(RSAT^)
	echo.  [I]   Microsoft DaRT 8.1 Tools
	echo.  [J]   Microsoft DirectX 9.0c
	echo.  [K]   Microsoft Games
	echo.  [L]   Windows Sidebar
	echo.  [M]   Microsoft Visual C++ Runtime
	echo.
	echo.
	echo.  [X]   Go Back
	echo.
	echo.===============================================================================
	echo.
	choice /C:ABCDEFGHIJKLMX /N /M "Enter Your Choice : "
	if errorlevel 14 goto :IntegrateMenu
	if errorlevel 13 goto :IntVCRuntime
	if errorlevel 12 goto :IntSidebar
	if errorlevel 11 goto :IntGames
	if errorlevel 10 goto :IntDirectX9c
	if errorlevel 9  goto :IntDaRT
	if errorlevel 8  goto :IntRSAT
	if errorlevel 7  goto :IntWMF
	if errorlevel 6  goto :IntMetroApps
	if errorlevel 5  goto :IntMediaFeaturePack
	if errorlevel 4  goto :IntWinToGo
	if errorlevel 3  goto :IntEdgeChromium
	if errorlevel 2  goto :IntNetFX48
	if errorlevel 1  goto :IntNetFX35
)

:: Checking whether the selected Source OS is a Windows 8.1 64-Bit Non-Server
if "%SelectedSourceOS%" equ "w81" if "%ImageInstallationType:~,6%" neq "Server" if "%ImageArchitecture%" equ "x64" (
	echo.
	echo.  [A]   Microsoft .NET Framework 3.5
	echo.  [B]   Microsoft .NET Framework 4.8
	echo.  [C]   Microsoft Edge Chromium Browser
	echo.  [D]   Windows Data Deduplication
	echo.  [E]   Windows To Go Workspace
	echo.  [F]   Windows Media Feature Pack
	echo.  [G]   Microsoft Default Metro Apps
	echo.  [H]   Windows Management Framework ^(WMF^) 5.1
	echo.  [I]   Remote Server Administration Tool ^(RSAT^)
	echo.  [J]   Microsoft DaRT 8.1 Tools
	echo.  [K]   Microsoft DirectX 9.0c
	echo.  [L]   Microsoft Games
	echo.  [M]   Windows Sidebar
	echo.  [N]   Microsoft Visual C++ Runtime
	echo.
	echo.  [X]   Go Back
	echo.
	echo.===============================================================================
	echo.
	choice /C:ABCDEFGHIJKLMNX /N /M "Enter Your Choice : "
	if errorlevel 15 goto :IntegrateMenu
	if errorlevel 14 goto :IntVCRuntime
	if errorlevel 13 goto :IntSidebar
	if errorlevel 12 goto :IntGames
	if errorlevel 11 goto :IntDirectX9c
	if errorlevel 10 goto :IntDaRT
	if errorlevel 9  goto :IntRSAT
	if errorlevel 8  goto :IntWMF
	if errorlevel 7  goto :IntMetroApps
	if errorlevel 6  goto :IntMediaFeaturePack
	if errorlevel 5  goto :IntWinToGo
	if errorlevel 4  goto :IntDedup
	if errorlevel 3  goto :IntEdgeChromium
	if errorlevel 2  goto :IntNetFX48
	if errorlevel 1  goto :IntNetFX35
)

:: Checking whether the selected Source OS is a Windows Server 2012 R2 Core Edition
if "%SelectedSourceOS%" equ "w81" if "%ImageInstallationType%" equ "Server Core" (
	echo.
	echo.  [1]   Microsoft .NET Framework 3.5
	echo.
	echo.  [2]   Microsoft .NET Framework 4.8
	echo.
	echo.  [3]   Windows Management Framework ^(WMF^) 5.1
	echo.
	echo.  [4]   Microsoft DaRT 8.1 Tools
	echo.
	echo.  [5]   Microsoft DirectX 9.0c
	echo.
	echo.  [6]   Microsoft Games
	echo.
	echo.  [7]   Microsoft Visual C++ Runtime
	echo.
	echo.
	echo.  [X]   Go Back
	echo.
	echo.===============================================================================
	echo.
	choice /C:1234567X /N /M "Enter Your Choice : "
	if errorlevel 8 goto :IntegrateMenu
	if errorlevel 7 goto :IntVCRuntime
	if errorlevel 6 goto :IntGames
	if errorlevel 5 goto :IntDirectX9c
	if errorlevel 4 goto :IntDaRT
	if errorlevel 3 goto :IntWMF
	if errorlevel 2 goto :IntNetFX48
	if errorlevel 1 goto :IntNetFX35
)

:: Checking whether the selected Source OS is a Windows Server 2012 R2
if "%SelectedSourceOS%" equ "w81" if "%ImageInstallationType%" equ "Server" (
	echo.
	echo.  [A]   Microsoft .NET Framework 3.5
	echo.  [B]   Microsoft .NET Framework 4.8
	echo.  [C]   Microsoft Edge Chromium Browser
	echo.  [D]   Microsoft Default Metro Apps
	echo.  [E]   Windows Management Framework ^(WMF^) 5.1
	echo.  [F]   Microsoft DaRT 8.1 Tools
	echo.  [G]   Microsoft DirectX 9.0c
	echo.  [H]   Microsoft Games
	echo.  [I]   Windows Sidebar
	echo.  [J]   Microsoft Visual C++ Runtime
	echo.
	echo.
	echo.
	echo.
	echo.  [X]   Go Back
	echo.
	echo.===============================================================================
	choice /C:ABCDEFGHIJX /N /M "Enter Your Choice : "
	if errorlevel 11 goto :IntegrateMenu
	if errorlevel 10 goto :IntVCRuntime
	if errorlevel 9  goto :IntSidebar
	if errorlevel 8  goto :IntGames
	if errorlevel 7  goto :IntDirectX9c
	if errorlevel 6  goto :IntDaRT
	if errorlevel 5  goto :IntWMF
	if errorlevel 4  goto :IntMetroApps
	if errorlevel 3  goto :IntEdgeChromium
	if errorlevel 2  goto :IntNetFX48
	if errorlevel 1  goto :IntNetFX35  	
)

:: Checking whether the selected Source OS is a Windows 10 v1507 Client
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "10240" (
	echo.
	echo.  [A]   Microsoft .NET Framework 3.5
	echo.  [B]   Microsoft .NET Framework 4.6.2
	echo.  [C]   Microsoft Edge Classic Browser
	echo.  [D]   Microsoft Edge Chromium Browser
	echo.  [E]   Microsoft Win32 Calculator
	echo.  [F]   Windows To Go Workspace
	echo.  [G]   Windows Media Feature Pack
	echo.  [H]   Remote Server Administration Tool ^(RSAT^)
	echo.  [I]   Microsoft Default Metro Apps
	echo.  [J]   Microsoft DaRT 10.0 Tools
	echo.  [K]   Microsoft DirectX 9.0c
	echo.  [L]   Microsoft Games
	echo.  [M]   Windows Sidebar ^| Depends on: Windows Mail App
	echo.  [N]   Microsoft Visual C++ Runtime
	echo.
	echo.  [X]   Go Back
	echo.
	echo.===============================================================================
	echo.
	choice /C:ABCDEFGHIJKLMNX /N /M "Enter Your Choice : "
	if errorlevel 15 goto :IntegrateMenu
	if errorlevel 14 goto :IntVCRuntime
	if errorlevel 13 goto :IntSidebar
	if errorlevel 12 goto :IntGames
	if errorlevel 11 goto :IntDirectX9c
	if errorlevel 10 goto :IntDaRT
	if errorlevel 9  goto :IntMetroApps
	if errorlevel 8  goto :IntRSAT
	if errorlevel 7  goto :IntMediaFeaturePack
	if errorlevel 6  goto :IntWinToGo
	if errorlevel 5  goto :IntWin32Calc
	if errorlevel 4  goto :IntEdgeChromium
	if errorlevel 3  goto :IntEdgeClassic
	if errorlevel 2  goto :IntNetFX462
	if errorlevel 1  goto :IntNetFX35
)

:: Checking whether the selected Source OS is a Windows 10 v1511 32-Bit Client
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "10586" if "%ImageArchitecture%" equ "x86" (
	echo.
	echo.  [A]   Microsoft .NET Framework 3.5
	echo.  [B]   Microsoft .NET Framework 4.6.2
	echo.  [C]   Microsoft Edge Chromium Browser
	echo.  [D]   Microsoft Win32 Calculator
	echo.  [E]   Windows To Go Workspace
	echo.  [F]   Windows Media Feature Pack
	echo.  [G]   Remote Server Administration Tool ^(RSAT^)
	echo.  [H]   Microsoft Default Metro Apps
	echo.  [I]   Microsoft DaRT 10.0 Tools
	echo.  [J]   Microsoft DirectX 9.0c
	echo.  [K]   Microsoft Games
	echo.  [L]   Windows Sidebar
	echo.  [M]   Microsoft Visual C++ Runtime
	echo.
	echo.
	echo.  [X]   Go Back
	echo.
	echo.===============================================================================
	echo.
	choice /C:ABCDEFGHIJKLMX /N /M "Enter Your Choice : "
	if errorlevel 14 goto :IntegrateMenu
	if errorlevel 13 goto :IntVCRuntime
	if errorlevel 12 goto :IntSidebar
	if errorlevel 11 goto :IntGames
	if errorlevel 10 goto :IntDirectX9c
	if errorlevel 9  goto :IntDaRT
	if errorlevel 8  goto :IntMetroApps
	if errorlevel 7  goto :IntRSAT
	if errorlevel 6  goto :IntMediaFeaturePack
	if errorlevel 5  goto :IntWinToGo
	if errorlevel 4  goto :IntWin32Calc
	if errorlevel 3  goto :IntEdgeChromium
	if errorlevel 2  goto :IntNetFX462
	if errorlevel 1  goto :IntNetFX35
)

:: Checking whether the selected Source OS is a Windows 10 v1607 32-Bit Client Enterprise LTSB 2016 Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "14393" if "%ImageInstallationType%" equ "Client" if "%ImageArchitecture%" equ "x86" if "%ImageFlag%" equ "EnterpriseS" (
	echo.
	echo.  [A]   Microsoft .NET Framework 3.5
	echo.  [B]   Microsoft .NET Framework 4.8
	echo.  [C]   Microsoft Edge Classic Browser
	echo.  [D]   Microsoft Edge Chromium Browser
	echo.  [E]   Microsoft Win32 Calculator
	echo.  [F]   Windows To Go Workspace
	echo.  [G]   Windows Media Feature Pack
	echo.  [H]   Remote Server Administration Tool ^(RSAT^)
	echo.  [I]   Microsoft Default Metro Apps
	echo.  [J]   Microsoft DaRT 10.0 Tools
	echo.  [K]   Microsoft DirectX 9.0c
	echo.  [L]   Microsoft Games
	echo.  [M]   Windows Sidebar
	echo.  [N]   Microsoft Visual C++ Runtime
	echo.
	echo.  [X]   Go Back
	echo.
	echo.===============================================================================
	echo.
	choice /C:ABCDEFGHIJKLMNX /N /M "Enter Your Choice : "
	if errorlevel 15 goto :IntegrateMenu
	if errorlevel 14 goto :IntVCRuntime
	if errorlevel 13 goto :IntSidebar
	if errorlevel 12 goto :IntGames
	if errorlevel 11 goto :IntDirectX9c
	if errorlevel 10 goto :IntDaRT
	if errorlevel 9  goto :IntMetroApps
	if errorlevel 8  goto :IntRSAT
	if errorlevel 7  goto :IntMediaFeaturePack
	if errorlevel 6  goto :IntWinToGo
	if errorlevel 5  goto :IntWin32Calc
	if errorlevel 4  goto :IntEdgeChromium
	if errorlevel 3  goto :IntEdgeClassic
	if errorlevel 2  goto :IntNetFX48
	if errorlevel 1  goto :IntNetFX35
)

:: Checking whether the selected Source OS is a Windows 10 v1607 32-Bit Client Enterprise N LTSB 2016 Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "14393" if "%ImageInstallationType%" equ "Client" if "%ImageArchitecture%" equ "x86" if "%ImageFlag%" equ "EnterpriseSN" (
	echo.
	echo.  [A]   Microsoft .NET Framework 3.5
	echo.  [B]   Microsoft .NET Framework 4.8
	echo.  [C]   Microsoft Edge Classic Browser
	echo.  [D]   Microsoft Edge Chromium Browser
	echo.  [E]   Microsoft Win32 Calculator
	echo.  [F]   Windows To Go Workspace
	echo.  [G]   Windows Media Feature Pack
	echo.  [H]   Remote Server Administration Tool ^(RSAT^)
	echo.  [I]   Microsoft Default Metro Apps
	echo.  [J]   Microsoft DaRT 10.0 Tools
	echo.  [K]   Microsoft DirectX 9.0c
	echo.  [L]   Microsoft Games
	echo.  [M]   Windows Sidebar
	echo.  [N]   Microsoft Visual C++ Runtime
	echo.
	echo.  [X]   Go Back
	echo.
	echo.===============================================================================
	echo.
	choice /C:ABCDEFGHIJKLMNX /N /M "Enter Your Choice : "
	if errorlevel 15 goto :IntegrateMenu
	if errorlevel 14 goto :IntVCRuntime
	if errorlevel 13 goto :IntSidebar
	if errorlevel 12 goto :IntGames
	if errorlevel 11 goto :IntDirectX9c
	if errorlevel 10 goto :IntDaRT
	if errorlevel 9  goto :IntMetroApps
	if errorlevel 8  goto :IntRSAT
	if errorlevel 7  goto :IntMediaFeaturePack
	if errorlevel 6  goto :IntWinToGo
	if errorlevel 5  goto :IntWin32Calc
	if errorlevel 4  goto :IntEdgeChromium
	if errorlevel 3  goto :IntEdgeClassic
	if errorlevel 2  goto :IntNetFX48
	if errorlevel 1  goto :IntNetFX35
)

:: Checking whether the selected Source OS is a Windows 10 v1607 32-Bit Client Non Enterprise (N) LTSB 2016 Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "14393" if "%ImageInstallationType%" equ "Client" if "%ImageArchitecture%" equ "x86" if "%ImageFlag%" neq "EnterpriseS" if "%ImageFlag%" neq "EnterpriseSN" (
	echo.
	echo.  [A]   Microsoft .NET Framework 3.5
	echo.  [B]   Microsoft .NET Framework 4.8
	echo.  [C]   Microsoft Edge Chromium Browser
	echo.  [D]   Microsoft Win32 Calculator
	echo.  [E]   Windows To Go Workspace
	echo.  [F]   Windows Media Feature Pack
	echo.  [G]   Remote Server Administration Tool ^(RSAT^)
	echo.  [H]   Microsoft Default Metro Apps
	echo.  [I]   Microsoft DaRT 10.0 Tools
	echo.  [J]   Microsoft DirectX 9.0c
	echo.  [K]   Microsoft Games
	echo.  [L]   Windows Sidebar
	echo.  [M]   Microsoft Visual C++ Runtime
	echo.
	echo.
	echo.  [X]   Go Back
	echo.
	echo.===============================================================================
	echo.
	choice /C:ABCDEFGHIJKLMX /N /M "Enter Your Choice : "
	if errorlevel 14 goto :IntegrateMenu
	if errorlevel 13 goto :IntVCRuntime
	if errorlevel 12 goto :IntSidebar
	if errorlevel 11 goto :IntGames
	if errorlevel 10 goto :IntDirectX9c
	if errorlevel 9  goto :IntDaRT
	if errorlevel 8  goto :IntMetroApps
	if errorlevel 7  goto :IntRSAT
	if errorlevel 6  goto :IntMediaFeaturePack
	if errorlevel 5  goto :IntWinToGo
	if errorlevel 4  goto :IntWin32Calc
	if errorlevel 3  goto :IntEdgeChromium
	if errorlevel 2  goto :IntNetFX48
	if errorlevel 1  goto :IntNetFX35
)

:: Checking whether the selected Source OS is a Windows 10 v1703 32-Bit Client
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "15063" if "%ImageArchitecture%" equ "x86" (
	echo.
	echo.  [A]   Microsoft .NET Framework 3.5
	echo.  [B]   Microsoft .NET Framework 4.8
	echo.  [C]   Microsoft Edge Chromium Browser
	echo.  [D]   Microsoft Win32 Calculator
	echo.  [E]   Windows Accessibility Braille
	echo.  [F]   Windows To Go Workspace
	echo.  [G]   Windows Media Feature Pack
	echo.  [J]   Remote Server Administration Tool ^(RSAT^)
	echo.  [I]   Microsoft Default Metro Apps
	echo.  [J]   Microsoft DaRT 10.0 Tools
	echo.  [K]   Microsoft DirectX 9.0c
	echo.  [L]   Microsoft Games
	echo.  [M]   Windows Sidebar
	echo.  [N]   Microsoft Visual C++ Runtime
	echo.
	echo.  [X]   Go Back
	echo.
	echo.===============================================================================
	echo.
	choice /C:ABCDEFGHIJKLMNX /N /M "Enter Your Choice : "
	if errorlevel 15 goto :IntegrateMenu
	if errorlevel 14 goto :IntVCRuntime
	if errorlevel 13 goto :IntSidebar
	if errorlevel 12 goto :IntGames
	if errorlevel 11 goto :IntDirectX9c
	if errorlevel 10 goto :IntDaRT
	if errorlevel 9  goto :IntMetroApps
	if errorlevel 8  goto :IntRSAT
	if errorlevel 7  goto :IntMediaFeaturePack
	if errorlevel 6  goto :IntWinToGo
	if errorlevel 5  goto :IntBraille
	if errorlevel 4  goto :IntWin32Calc
	if errorlevel 3  goto :IntEdgeChromium
	if errorlevel 2  goto :IntNetFX48
	if errorlevel 1  goto :IntNetFX35
)

:: Checking whether the selected Source OS is a Windows 10 v1709 32-Bit Client
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "16299" if "%ImageArchitecture%" equ "x86" (
	echo.  [A]   Microsoft .NET Framework 3.5
	echo.  [B]   Microsoft .NET Framework 4.8
	echo.  [C]   Microsoft Edge Chromium Browser
	echo.  [D]   Microsoft Win32 Calculator
	echo.  [E]   Windows Accessibility Braille
	echo.  [F]   Windows To Go Workspace
	echo.  [G]   Windows Media Feature Pack
	echo.  [H]   Remote Server Administration Tool ^(RSAT^)
	echo.  [I]   Open Secure Shell ^(SSH^) Client ^& Server
	echo.  [J]   Microsoft Default Metro Apps
	echo.  [K]   Microsoft DaRT 10.0 Tools
	echo.  [L]   Microsoft DirectX 9.0c
	echo.  [M]   Microsoft Games
	echo.  [N]   Windows Sidebar
	echo.  [O]   Microsoft Visual C++ Runtime
	echo.
	echo.
	echo.  [X]   Go Back
	echo.===============================================================================
	choice /C:ABCDEFGHIJKLMNOX /N /M "Enter Your Choice : "
	if errorlevel 16 goto :IntegrateMenu
	if errorlevel 15 goto :IntVCRuntime
	if errorlevel 14 goto :IntSidebar
	if errorlevel 13 goto :IntGames
	if errorlevel 12 goto :IntDirectX9c
	if errorlevel 11  goto :IntDaRT
	if errorlevel 10 goto :IntMetroApps
	if errorlevel 9  goto :IntOpenSSH
	if errorlevel 8  goto :IntRSAT
	if errorlevel 7  goto :IntMediaFeaturePack
	if errorlevel 6  goto :IntWinToGo
	if errorlevel 5  goto :IntBraille
	if errorlevel 4  goto :IntWin32Calc
	if errorlevel 3  goto :IntEdgeChromium
	if errorlevel 2  goto :IntNetFX48
	if errorlevel 1  goto :IntNetFX35
)

:: Checking whether the selected Source OS is a Windows 10 v1803 32-Bit Client
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "17134" if "%ImageArchitecture%" equ "x86" (
	echo.  [A]   Microsoft .NET Framework 3.5
	echo.  [B]   Microsoft .NET Framework 4.8
	echo.  [C]   Microsoft Edge Chromium Browser
	echo.  [D]   Microsoft Win32 Calculator
	echo.  [E]   Windows Accessibility Braille
	echo.  [F]   Windows To Go Workspace
	echo.  [G]   Windows Media Feature Pack
	echo.  [H]   Remote Server Administration Tool ^(RSAT^)
	echo.  [I]   Open Secure Shell ^(SSH^) Client ^& Server
	echo.  [J]   Microsoft Default Metro Apps
	echo.  [K]   Microsoft Office Desktop UWP Apps
	echo.  [L]   Microsoft DaRT 10.0 Tools
	echo.  [M]   Microsoft DirectX 9.0c
	echo.  [N]   Microsoft Games
	echo.  [O]   Windows Sidebar
	echo.  [P]   Microsoft Visual C++ Runtime
	echo.
	echo.  [X]   Go Back
	echo.===============================================================================
	echo.
	choice /C:ABCDEFGHIJKLMNOPX /N /M "Enter Your Choice : "
	if errorlevel 17 goto :IntegrateMenu
	if errorlevel 16 goto :IntVCRuntime
	if errorlevel 15 goto :IntSidebar
	if errorlevel 14 goto :IntGames
	if errorlevel 13 goto :IntDirectX9c
	if errorlevel 12 goto :IntDaRT
	if errorlevel 11 goto :IntOfficeUWPApps
	if errorlevel 10 goto :IntMetroApps
	if errorlevel 9  goto :IntOpenSSH
	if errorlevel 8  goto :IntRSAT
	if errorlevel 7  goto :IntMediaFeaturePack
	if errorlevel 6  goto :IntWinToGo
	if errorlevel 5  goto :IntBraille
	if errorlevel 4  goto :IntWin32Calc
	if errorlevel 3  goto :IntEdgeChromium
	if errorlevel 2  goto :IntNetFX48
	if errorlevel 1  goto :IntNetFX35
)

:: Checking whether the selected Source OS is a Windows 10 v1809 32-Bit Client Enterprise LTSC 2019 Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "17763" if "%ImageInstallationType%" equ "Client" if "%ImageArchitecture%" equ "x86" if "%ImageFlag%" equ "EnterpriseS" (
	echo.  [A]   Microsoft .NET Framework 3.5
	echo.  [B]   Microsoft .NET Framework 4.8
	echo.  [C]   Microsoft Edge Classic Browser
	echo.  [D]   Microsoft Edge Chromium Browser
	echo.  [E]   Microsoft Win32 Calculator
	echo.  [F]   Windows Accessibility Braille
	echo.  [G]   Windows To Go Workspace
	echo.  [H]   Windows Media Feature Pack
	echo.  [I]   Windows Portable Devices	
	echo.  [J]   Open Secure Shell ^(SSH^) Client ^& Server
	echo.  [K]   Microsoft Default Metro Apps
	echo.  [L]   Microsoft Office Desktop UWP Apps
	echo.  [M]   Microsoft DaRT 10.0 Tools
	echo.  [N]   Microsoft DirectX 9.0c
	echo.  [O]   Microsoft Games
	echo.  [P]   Windows Sidebar
	echo.  [Q]   Microsoft Visual C++ Runtime
	echo.  [X]   Go Back
	echo.===============================================================================
	choice /C:ABCDEFGHIJKLMNOPQX /N /M "Enter Your Choice : "
	if errorlevel 18 goto :IntegrateMenu
	if errorlevel 17 goto :IntVCRuntime
	if errorlevel 16 goto :IntSidebar
	if errorlevel 15 goto :IntGames
	if errorlevel 14 goto :IntDirectX9c
	if errorlevel 13 goto :IntDaRT
	if errorlevel 12 goto :IntOfficeUWPApps
	if errorlevel 11 goto :IntMetroApps
	if errorlevel 10 goto :IntOpenSSH
	if errorlevel 9  goto :IntPortableDevices
	if errorlevel 8  goto :IntMediaFeaturePack
	if errorlevel 7  goto :IntWinToGo
	if errorlevel 6  goto :IntBraille
	if errorlevel 5  goto :IntEdgeChromium
	if errorlevel 4  goto :IntEdgeClassic
	if errorlevel 3  goto :IntWin32Calc
	if errorlevel 2  goto :IntNetFX48
	if errorlevel 1  goto :IntNetFX35
)

:: Checking whether the selected Source OS is a Windows 10 v1809 32-Bit Client Enterprise N LTSC 2019 Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ 17763 if "%ImageInstallationType%" equ "Client" if "%ImageArchitecture%" equ "x86" if "%ImageFlag%" equ "EnterpriseSN" (
	echo.  [A]   Microsoft .NET Framework 3.5
	echo.  [B]   Microsoft .NET Framework 4.8
	echo.  [C]   Microsoft Edge Classic Browser
	echo.  [D]   Microsoft Edge Chromium Browser
	echo.  [E]   Microsoft Win32 Calculator
	echo.  [F]   Windows Accessibility Braille
	echo.  [G]   Windows To Go Workspace
	echo.  [H]   Windows Media Feature Pack
	echo.  [I]   Windows Portable Devices	
	echo.  [J]   Open Secure Shell ^(SSH^) Client ^& Server
	echo.  [K]   Microsoft Default Metro Apps
	echo.  [L]   Microsoft Office Desktop UWP Apps
	echo.  [M]   Microsoft DaRT 10.0 Tools
	echo.  [N]   Microsoft DirectX 9.0c
	echo.  [O]   Microsoft Games
	echo.  [P]   Windows Sidebar
	echo.  [Q]   Microsoft Visual C++ Runtime
	echo.  [X]   Go Back
	echo.===============================================================================
	choice /C:ABCDEFGHIJKLMNOPQX /N /M "Enter Your Choice : "
	if errorlevel 18 goto :IntegrateMenu
	if errorlevel 17 goto :IntVCRuntime
	if errorlevel 16 goto :IntSidebar
	if errorlevel 15 goto :IntGames
	if errorlevel 14 goto :IntDirectX9c
	if errorlevel 13 goto :IntDaRT
	if errorlevel 12 goto :IntOfficeUWPApps
	if errorlevel 11 goto :IntMetroApps
	if errorlevel 10 goto :IntOpenSSH
	if errorlevel 9  goto :IntPortableDevices
	if errorlevel 8  goto :IntMediaFeaturePack
	if errorlevel 7  goto :IntWinToGo
	if errorlevel 6  goto :IntBraille
	if errorlevel 5  goto :IntEdgeChromium
	if errorlevel 4  goto :IntEdgeClassic
	if errorlevel 3  goto :IntWin32Calc
	if errorlevel 2  goto :IntNetFX48
	if errorlevel 1  goto :IntNetFX35
)

:: Checking whether the selected Source OS is a Windows 10 v1809 32-Bit Client Non Enterprise (N) LTSC 2019 Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "17763" if "%ImageInstallationType%" equ "Client" if "%ImageArchitecture%" equ "x86" if "%ImageFlag%" neq "EnterpriseS" if "%ImageFlag%" neq "EnterpriseSN" (
	echo.  [A]   Microsoft .NET Framework 3.5
	echo.  [B]   Microsoft .NET Framework 4.8
	echo.  [C]   Microsoft Edge Chromium Browser
	echo.  [D]   Microsoft Win32 Calculator
	echo.  [E]   Windows Accessibility Braille
	echo.  [F]   Windows To Go Workspace
	echo.  [G]   Windows Media Feature Pack
	echo.  [H]   Windows Portable Devices
	echo.  [I]   Open Secure Shell ^(SSH^) Client ^& Server
	echo.  [J]   Microsoft Default Metro Apps
	echo.  [K]   Microsoft Office Desktop UWP Apps
	echo.  [L]   Microsoft DaRT 10.0 Tools
	echo.  [M]   Microsoft DirectX 9.0c
	echo.  [N]   Microsoft Games
	echo.  [O]   Windows Sidebar
	echo.  [P]   Microsoft Visual C++ Runtime
	echo.
	echo.  [X]   Go Back
	echo.===============================================================================
	echo.
	choice /C:ABCDEFGHIJKLMNOPX /N /M "Enter Your Choice : "
	if errorlevel 17 goto :IntegrateMenu
	if errorlevel 16 goto :IntVCRuntime
	if errorlevel 15 goto :IntSidebar
	if errorlevel 14 goto :IntGames
	if errorlevel 13 goto :IntDirectX9c
	if errorlevel 12 goto :IntDaRT
	if errorlevel 11 goto :IntOfficeUWPApps
	if errorlevel 10 goto :IntMetroApps
	if errorlevel 9  goto :IntOpenSSH
	if errorlevel 8  goto :IntPortableDevices
	if errorlevel 7  goto :IntMediaFeaturePack
	if errorlevel 6  goto :IntWinToGo
	if errorlevel 5  goto :IntBraille
	if errorlevel 4  goto :IntWin32Calc
	if errorlevel 3  goto :IntEdgeChromium
	if errorlevel 2  goto :IntNetFX48
	if errorlevel 1  goto :IntNetFX35
)

:: Checking whether the selected Source OS is a Windows 10 v1903/v1909 32-Bit Client Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "18362" if "%ImageBuild%" leq "18363" if "%ImageInstallationType%" equ "Client" if "%ImageArchitecture%" equ "x86" (
	echo.
	echo.  [A]   Microsoft .NET Framework 3.5
	echo.  [B]   Microsoft Edge Chromium Browser
	echo.  [C]   Microsoft Win32 Calculator
	echo.  [D]   Windows Accessibility Braille
	echo.  [E]   Windows To Go Workspace
	echo.  [F]   Windows Media Feature Pack
	echo.  [G]   Windows Portable Devices
	echo.  [H]   Open Secure Shell ^(SSH^) Client ^& Server
	echo.  [I]   Microsoft Default Metro Apps
	echo.  [J]   Microsoft Office Desktop UWP Apps
	echo.  [K]   Microsoft DaRT 10.0 Tools
	echo.  [L]   Microsoft DirectX 9.0c
	echo.  [M]   Microsoft Games
	echo.  [N]   Windows Sidebar
	echo.  [O]   Microsoft Visual C++ Runtime
	echo.
	echo.  [X]   Go Back
	echo.===============================================================================
	echo.
	choice /C:ABCDEFGHIJKLMNOX /N /M "Enter Your Choice : "
	if errorlevel 16 goto :IntegrateMenu
	if errorlevel 15 goto :IntVCRuntime
	if errorlevel 14 goto :IntSidebar
	if errorlevel 13 goto :IntGames
	if errorlevel 12 goto :IntDirectX9c
	if errorlevel 11 goto :IntDaRT
	if errorlevel 10 goto :IntOfficeUWPApps
	if errorlevel 9  goto :IntMetroApps
	if errorlevel 8  goto :IntOpenSSH
	if errorlevel 7  goto :IntPortableDevices
	if errorlevel 6  goto :IntMediaFeaturePack
	if errorlevel 5  goto :IntWinToGo
	if errorlevel 4  goto :IntBraille
	if errorlevel 3  goto :IntWin32Calc
	if errorlevel 2  goto :IntEdgeChromium
	if errorlevel 1  goto :IntNetFX35
)

:: Checking whether the selected Source OS is a Windows 10 v2004 32-Bit Client Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "19041" if "%ImageInstallationType%" equ "Client" if "%ImageArchitecture%" equ "x86" (
	echo.
	echo.  [A]   Microsoft .NET Framework 3.5
	echo.  [B]   Microsoft Edge Chromium Browser
	echo.  [C]   Microsoft Win32 Calculator
	echo.  [D]   Windows Accessibility Braille
	echo.  [E]   Windows Media Feature Pack
	echo.  [F]   Windows Portable Devices
	echo.  [G]   Open Secure Shell ^(SSH^) Client ^& Server
	echo.  [H]   Microsoft Default Metro Apps
	echo.  [I]   Microsoft Office Desktop UWP Apps
	echo.  [J]   Microsoft DaRT 10.0 Tools
	echo.  [K]   Microsoft DirectX 9.0c
	echo.  [L]   Microsoft Games
	echo.  [M]   Windows Sidebar
	echo.  [N]   Microsoft Visual C++ Runtime
	echo.
	echo.
	echo.  [X]   Go Back
	echo.===============================================================================
	echo.
	choice /C:ABCDEFGHIJKLMNX /N /M "Enter Your Choice : "
	if errorlevel 15 goto :IntegrateMenu
	if errorlevel 14 goto :IntVCRuntime
	if errorlevel 13 goto :IntSidebar
	if errorlevel 12 goto :IntGames
	if errorlevel 11 goto :IntDirectX9c
	if errorlevel 10 goto :IntDaRT
	if errorlevel 9  goto :IntOfficeUWPApps
	if errorlevel 8  goto :IntMetroApps
	if errorlevel 7  goto :IntOpenSSH
	if errorlevel 6  goto :IntPortableDevices
	if errorlevel 5  goto :IntMediaFeaturePack
	if errorlevel 4  goto :IntBraille
	if errorlevel 3  goto :IntWin32Calc
	if errorlevel 2  goto :IntEdgeChromium
	if errorlevel 1  goto :IntNetFX35
)

:: Checking whether the selected Source OS is a Windows 10 v1511 64-Bit Client
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "10586" if "%ImageArchitecture%" equ "x64" (
	echo.
	echo.  [A]   Microsoft .NET Framework 3.5
	echo.  [B]   Microsoft .NET Framework 4.6.2
	echo.  [C]   Microsoft Edge Chromium Browser
	echo.  [D]   Microsoft Win32 Calculator
	echo.  [E]   Windows Data Deduplication
	echo.  [F]   Windows To Go Workspace
	echo.  [G]   Windows Media Feature Pack
	echo.  [H]   Remote Server Administration Tool ^(RSAT^)
	echo.  [I]   Microsoft Default Metro Apps
	echo.  [J]   Microsoft DaRT 10.0 Tools
	echo.  [K]   Microsoft DirectX 9.0c
	echo.  [L]   Microsoft Games
	echo.  [M]   Windows Sidebar
	echo.  [N]   Microsoft Visual C++ Runtime
	echo.
	echo.  [X]   Go Back
	echo.
	echo.===============================================================================
	echo.
	choice /C:ABCDEFGHIJKLMNX /N /M "Enter Your Choice : "
	if errorlevel 15 goto :IntegrateMenu
	if errorlevel 14 goto :IntVCRuntime
	if errorlevel 13 goto :IntSidebar
	if errorlevel 12 goto :IntGames
	if errorlevel 11 goto :IntDirectX9c
	if errorlevel 10 goto :IntDaRT
	if errorlevel 9  goto :IntMetroApps
	if errorlevel 8  goto :IntRSAT
	if errorlevel 7  goto :IntMediaFeaturePack
	if errorlevel 6  goto :IntWinToGo
	if errorlevel 5  goto :IntDedup
	if errorlevel 4  goto :IntWin32Calc
	if errorlevel 3  goto :IntEdgeChromium
	if errorlevel 2  goto :IntNetFX462
	if errorlevel 1  goto :IntNetFX35
)

:: Checking whether the selected Source OS is a Windows 10 v1607 64-Bit Client Enterprise LTSB 2016 Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "14393" if "%ImageInstallationType%" equ "Client" if "%ImageArchitecture%" equ "x64" if "%ImageFlag%" equ "EnterpriseS" (
	echo.
	echo.  [A]   Microsoft .NET Framework 3.5
	echo.  [B]   Microsoft .NET Framework 4.8
	echo.  [C]   Microsoft Edge Classic Browser
	echo.  [D]   Microsoft Edge Chromium Browser
	echo.  [E]   Windows Data Deduplication
	echo.  [F]   Windows To Go Workspace
	echo.  [G]   Windows Media Feature Pack
	echo.  [H]   Remote Server Administration Tool ^(RSAT^)
	echo.  [I]   Microsoft Default Metro Apps
	echo.  [J]   Microsoft DaRT 10.0 Tools
	echo.  [K]   Microsoft DirectX 9.0c
	echo.  [L]   Microsoft Games
	echo.  [M]   Windows Sidebar
	echo.  [N]   Microsoft Visual C++ Runtime
	echo.
	echo.  [X]   Go Back
	echo.
	echo.===============================================================================
	echo.
	choice /C:ABCDEFGHIJKLMNX /N /M "Enter Your Choice : "
	if errorlevel 15 goto :IntegrateMenu
	if errorlevel 14 goto :IntVCRuntime
	if errorlevel 13 goto :IntSidebar
	if errorlevel 12 goto :IntGames
	if errorlevel 11 goto :IntDirectX9c
	if errorlevel 10 goto :IntDaRT
	if errorlevel 9  goto :IntMetroApps
	if errorlevel 8  goto :IntRSAT
	if errorlevel 7  goto :IntMediaFeaturePack
	if errorlevel 6  goto :IntWinToGo
	if errorlevel 5  goto :IntDedup
	if errorlevel 4  goto :IntEdgeChromium
	if errorlevel 3  goto :IntEdgeClassic
	if errorlevel 2  goto :IntNetFX48
	if errorlevel 1  goto :IntNetFX35
)

:: Checking whether the selected Source OS is a Windows 10 v1607 64-Bit Client Enterprise N LTSB 2016 Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "14393" if "%ImageInstallationType%" equ "Client" if "%ImageArchitecture%" equ "x64" if "%ImageFlag%" equ "EnterpriseSN" (
	echo.
	echo.  [A]   Microsoft .NET Framework 3.5
	echo.  [B]   Microsoft .NET Framework 4.8
	echo.  [C]   Microsoft Edge Classic Browser
	echo.  [D]   Microsoft Edge Chromium Browser
	echo.  [E]   Windows Data Deduplication
	echo.  [F]   Windows To Go Workspace
	echo.  [G]   Windows Media Feature Pack
	echo.  [H]   Remote Server Administration Tool ^(RSAT^)
	echo.  [I]   Microsoft Default Metro Apps
	echo.  [J]   Microsoft DaRT 10.0 Tools
	echo.  [K]   Microsoft DirectX 9.0c
	echo.  [L]   Microsoft Games
	echo.  [M]   Windows Sidebar
	echo.  [N]   Microsoft Visual C++ Runtime
	echo.
	echo.  [X]   Go Back
	echo.
	echo.===============================================================================
	echo.
	choice /C:ABCDEFGHIJKLMNX /N /M "Enter Your Choice : "
	if errorlevel 15 goto :IntegrateMenu
	if errorlevel 14 goto :IntVCRuntime
	if errorlevel 13 goto :IntSidebar
	if errorlevel 12 goto :IntGames
	if errorlevel 11 goto :IntDirectX9c
	if errorlevel 10 goto :IntDaRT
	if errorlevel 9  goto :IntMetroApps
	if errorlevel 8  goto :IntRSAT
	if errorlevel 7  goto :IntMediaFeaturePack
	if errorlevel 6  goto :IntWinToGo
	if errorlevel 5  goto :IntDedup
	if errorlevel 4  goto :IntEdgeChromium
	if errorlevel 3  goto :IntEdgeClassic
	if errorlevel 2  goto :IntNetFX48
	if errorlevel 1  goto :IntNetFX35
)

:: Checking whether the selected Source OS is a Windows 10 v1607 64-Bit Client Non Enterprise (N) LTSB 2016 Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "14393" if "%ImageInstallationType%" equ "Client" if "%ImageArchitecture%" equ "x64" if "%ImageFlag%" neq "EnterpriseS" if "%ImageFlag%" neq "EnterpriseSN" (
	echo.
	echo.  [A]   Microsoft .NET Framework 3.5
	echo.  [B]   Microsoft .NET Framework 4.8
	echo.  [C]   Microsoft Edge Chromium Browser
	echo.  [D]   Microsoft Win32 Calculator
	echo.  [E]   Windows Data Deduplication
	echo.  [F]   Windows To Go Workspace
	echo.  [G]   Windows Media Feature Pack
	echo.  [H]   Remote Server Administration Tool ^(RSAT^)
	echo.  [I]   Microsoft Default Metro Apps
	echo.  [J]   Microsoft DaRT 10.0 Tools
	echo.  [K]   Microsoft DirectX 9.0c
	echo.  [L]   Microsoft Games
	echo.  [M]   Windows Sidebar
	echo.  [N]   Microsoft Visual C++ Runtime
	echo.
	echo.  [X]   Go Back
	echo.
	echo.===============================================================================
	echo.
	choice /C:ABCDEFGHIJKLMNX /N /M "Enter Your Choice : "
	if errorlevel 15 goto :IntegrateMenu
	if errorlevel 14 goto :IntVCRuntime
	if errorlevel 13 goto :IntSidebar
	if errorlevel 12 goto :IntGames
	if errorlevel 11 goto :IntDirectX9c
	if errorlevel 10 goto :IntDaRT
	if errorlevel 9  goto :IntMetroApps
	if errorlevel 8  goto :IntRSAT
	if errorlevel 7  goto :IntMediaFeaturePack
	if errorlevel 6  goto :IntWinToGo
	if errorlevel 5  goto :IntDedup
	if errorlevel 4  goto :IntWin32Calc
	if errorlevel 3  goto :IntEdgeChromium
	if errorlevel 2  goto :IntNetFX48
	if errorlevel 1  goto :IntNetFX35
)

:: Checking whether the selected Source OS is a Windows 10 v1703 64-Bit Client
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "15063" if "%ImageArchitecture%" equ "x64" (
	echo.
	echo.  [A]   Microsoft .NET Framework 3.5
	echo.  [B]   Microsoft .NET Framework 4.8
	echo.  [C]   Microsoft Edge Chromium Browser
	echo.  [D]   Microsoft Win32 Calculator
	echo.  [E]   Windows Accessibility Braille
	echo.  [F]   Windows Data Deduplication
	echo.  [G]   Windows To Go Workspace
	echo.  [H]   Windows Media Feature Pack
	echo.  [I]   Remote Server Administration Tool ^(RSAT^)
	echo.  [J]   Microsoft Default Metro Apps
	echo.  [K]   Microsoft DaRT 10.0 Tools
	echo.  [L]   Microsoft DirectX 9.0c
	echo.  [M]   Microsoft Games
	echo.  [N]   Windows Sidebar
	echo.  [O]   Microsoft Visual C++ Runtime
	echo.  [X]   Go Back
	echo.
	echo.===============================================================================
	choice /C:ABCDEFGHIJKLMNOX /N /M "Enter Your Choice : "
	if errorlevel 16 goto :IntegrateMenu
	if errorlevel 15 goto :IntVCRuntime
	if errorlevel 14 goto :IntSidebar
	if errorlevel 13 goto :IntGames
	if errorlevel 12 goto :IntDirectX9c
	if errorlevel 11 goto :IntDaRT
	if errorlevel 10 goto :IntMetroApps
	if errorlevel 9  goto :IntRSAT
	if errorlevel 8  goto :IntMediaFeaturePack
	if errorlevel 7  goto :IntWinToGo
	if errorlevel 6  goto :IntDedup
	if errorlevel 5  goto :IntBraille
	if errorlevel 4  goto :IntWin32Calc
	if errorlevel 3  goto :IntEdgeChromium
	if errorlevel 2  goto :IntNetFX48
	if errorlevel 1  goto :IntNetFX35
)

:: Checking whether the selected Source OS is a Windows 10 v1709 64-Bit Client
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "16299" if "%ImageInstallationType%" equ "Client" if "%ImageArchitecture%" equ "x64" (
	echo.  [A]   Microsoft .NET Framework 3.5
	echo.  [B]   Microsoft .NET Framework 4.8
	echo.  [C]   Microsoft Edge Chromium Browser
	echo.  [D]   Microsoft Win32 Calculator
	echo.  [E]   Windows Accessibility Braille
	echo.  [F]   Windows Data Deduplication
	echo.  [G]   Windows To Go Workspace
	echo.  [H]   Windows Media Feature Pack
	echo.  [I]   Remote Server Administration Tool ^(RSAT^)
	echo.  [J]   Open Secure Shell ^(SSH^) Client ^& Server
	echo.  [K]   Microsoft Default Metro Apps
	echo.  [L]   Microsoft DaRT 10.0 Tools
	echo.  [M]   Microsoft DirectX 9.0c
	echo.  [N]   Microsoft Games
	echo.  [O]   Windows Sidebar
	echo.  [P]   Microsoft Visual C++ Runtime
	echo.
	echo.  [X]   Go Back
	echo.===============================================================================
	echo.
	choice /C:ABCDEFGHIJKLMNOPX /N /M "Enter Your Choice : "
	if errorlevel 17 goto :IntegrateMenu
	if errorlevel 16 goto :IntVCRuntime
	if errorlevel 15 goto :IntSidebar
	if errorlevel 14 goto :IntGames
	if errorlevel 13 goto :IntDirectX9c
	if errorlevel 12 goto :IntDaRT
	if errorlevel 11 goto :IntMetroApps
	if errorlevel 10 goto :IntOpenSSH
	if errorlevel 9  goto :IntRSAT
	if errorlevel 8  goto :IntMediaFeaturePack
	if errorlevel 7  goto :IntWinToGo
	if errorlevel 6  goto :IntDedup
	if errorlevel 5  goto :IntBraille
	if errorlevel 4  goto :IntWin32Calc
	if errorlevel 3  goto :IntEdgeChromium
	if errorlevel 2  goto :IntNetFX48
	if errorlevel 1  goto :IntNetFX35
)

:: Checking whether the selected Source OS is a Windows 10 v1803 64-Bit Client
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "17134" if "%ImageInstallationType%" equ "Client" if "%ImageArchitecture%" equ "x64" (
	echo.  [A]   Microsoft .NET Framework 3.5
	echo.  [B]   Microsoft .NET Framework 4.8
	echo.  [C]   Microsoft Edge Chromium Browser
	echo.  [D]   Microsoft Win32 Calculator
	echo.  [E]   Windows Accessibility Braille
	echo.  [F]   Windows Data Deduplication
	echo.  [G]   Windows To Go Workspace
	echo.  [H]   Windows Media Feature Pack
	echo.  [I]   Remote Server Administration Tool ^(RSAT^)
	echo.  [J]   Open Secure Shell ^(SSH^) Client ^& Server
	echo.  [K]   Microsoft Default Metro Apps
	echo.  [L]   Microsoft Office Desktop UWP Apps
	echo.  [M]   Microsoft DaRT 10.0 Tools
	echo.  [N]   Microsoft DirectX 9.0c
	echo.  [O]   Microsoft Games
	echo.  [P]   Windows Sidebar
	echo.  [Q]   Microsoft Visual C++ Runtime
	echo.  [X]   Go Back
	echo.===============================================================================
	choice /C:ABCDEFGHIJKLMNOPQX /N /M "Enter Your Choice : "
	if errorlevel 18 goto :IntegrateMenu
	if errorlevel 17 goto :IntVCRuntime
	if errorlevel 16 goto :IntSidebar
	if errorlevel 15 goto :IntGames
	if errorlevel 14 goto :IntDirectX9c
	if errorlevel 13 goto :IntDaRT
	if errorlevel 12 goto :IntOfficeUWPApps
	if errorlevel 11 goto :IntMetroApps
	if errorlevel 10 goto :IntOpenSSH
	if errorlevel 9  goto :IntRSAT
	if errorlevel 8  goto :IntMediaFeaturePack
	if errorlevel 7  goto :IntWinToGo
	if errorlevel 6  goto :IntDedup
	if errorlevel 5  goto :IntBraille
	if errorlevel 4  goto :IntWin32Calc
	if errorlevel 3  goto :IntEdgeChromium
	if errorlevel 2  goto :IntNetFX48
	if errorlevel 1  goto :IntNetFX35
)

:: Checking whether the selected Source OS is a Windows 10 v1809 64-Bit Client Enterprise LTSC 2019 Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "17763" if "%ImageInstallationType%" equ "Client" if "%ImageArchitecture%" equ "x64" if "%ImageFlag%" equ "EnterpriseS" (
	echo.  [A]   Microsoft .NET Framework 3.5
	echo.  [B]   Microsoft .NET Framework 4.8
	echo.  [C]   Microsoft Edge Classic Browser
	echo.  [D]   Microsoft Edge Chromium Browser
	echo.  [E]   Microsoft Win32 Calculator
	echo.  [F]   Windows Accessibility Braille
	echo.  [G]   Windows Data Deduplication
	echo.  [H]   Windows To Go Workspace
	echo.  [I]   Windows Media Feature Pack
	echo.  [J]   Windows Portable Devices
	echo.  [K]   Open Secure Shell ^(SSH^) Client ^& Server
	echo.  [L]   Microsoft Default Metro Apps
	echo.  [M]   Microsoft Office Desktop UWP Apps
	echo.  [N]   Microsoft DaRT 10.0 Tools
	echo.  [O]   Microsoft DirectX 9.0c
	echo.  [P]   Microsoft Games
	echo.  [Q]   Windows Sidebar
	echo.  [R]   Microsoft Visual C++ Runtime
	echo.  [X]   Go Back
	echo.===============================================================================
	choice /C:ABCDEFGHIJKLMNOPQRX /N /M "Enter Your Choice : "
	if errorlevel 19 goto :IntegrateMenu
	if errorlevel 18 goto :IntVCRuntime
	if errorlevel 17 goto :IntSidebar
	if errorlevel 16 goto :IntGames
	if errorlevel 15 goto :IntDirectX9c
	if errorlevel 14 goto :IntDaRT
	if errorlevel 13 goto :IntOfficeUWPApps
	if errorlevel 12 goto :IntMetroApps
	if errorlevel 11 goto :IntOpenSSH
	if errorlevel 10 goto :IntPortableDevices
	if errorlevel 9  goto :IntMediaFeaturePack
	if errorlevel 8  goto :IntWinToGo
	if errorlevel 7  goto :IntDedup
	if errorlevel 6  goto :IntBraille
	if errorlevel 5  goto :IntWin32Calc
	if errorlevel 4  goto :IntEdgeChromium
	if errorlevel 3  goto :IntEdgeClassic
	if errorlevel 2  goto :IntNetFX48
	if errorlevel 1  goto :IntNetFX35
)

:: Checking whether the selected Source OS is a Windows 10 v1809 64-Bit Client Enterprise N LTSC 2019 Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "17763" if "%ImageInstallationType%" equ "Client" if "%ImageArchitecture%" equ "x64" if "%ImageFlag%" equ "EnterpriseSN" (
	echo.  [A]   Microsoft .NET Framework 3.5
	echo.  [B]   Microsoft .NET Framework 4.8
	echo.  [C]   Microsoft Edge Classic Browser
	echo.  [D]   Microsoft Edge Chromium Browser
	echo.  [E]   Microsoft Win32 Calculator
	echo.  [F]   Windows Accessibility Braille
	echo.  [G]   Windows Data Deduplication
	echo.  [H]   Windows To Go Workspace
	echo.  [I]   Windows Media Feature Pack
	echo.  [J]   Windows Portable Devices
	echo.  [K]   Open Secure Shell ^(SSH^) Client ^& Server
	echo.  [L]   Microsoft Default Metro Apps
	echo.  [M]   Microsoft Office Desktop UWP Apps
	echo.  [N]   Microsoft DaRT 10.0 Tools
	echo.  [O]   Microsoft DirectX 9.0c
	echo.  [P]   Microsoft Games
	echo.  [Q]   Windows Sidebar
	echo.  [R]   Microsoft Visual C++ Runtime
	echo.  [X]   Go Back
	echo.===============================================================================
	choice /C:ABCDEFGHIJKLMNOPQRX /N /M "Enter Your Choice : "
	if errorlevel 19 goto :IntegrateMenu
	if errorlevel 18 goto :IntVCRuntime
	if errorlevel 17 goto :IntSidebar
	if errorlevel 16 goto :IntGames
	if errorlevel 15 goto :IntDirectX9c
	if errorlevel 14 goto :IntDaRT
	if errorlevel 13 goto :IntOfficeUWPApps
	if errorlevel 12 goto :IntMetroApps
	if errorlevel 11 goto :IntOpenSSH
	if errorlevel 10 goto :IntPortableDevices
	if errorlevel 9  goto :IntMediaFeaturePack
	if errorlevel 8  goto :IntWinToGo
	if errorlevel 7  goto :IntDedup
	if errorlevel 6  goto :IntBraille
	if errorlevel 5  goto :IntWin32Calc
	if errorlevel 4  goto :IntEdgeChromium
	if errorlevel 3  goto :IntEdgeClassic
	if errorlevel 2  goto :IntNetFX48
	if errorlevel 1  goto :IntNetFX35
)

:: Checking whether the selected Source OS is a Windows 10 v1809 64-Bit Client Non Enterprise (N) LTSC 2019 Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "17763" if "%ImageInstallationType%" equ "Client" if "%ImageArchitecture%" equ "x64" if "%ImageFlag%" neq "EnterpriseS" if "%ImageFlag%" neq "EnterpriseSN" (
	echo.  [A]   Microsoft .NET Framework 3.5
	echo.  [B]   Microsoft .NET Framework 4.8
	echo.  [C]   Microsoft Edge Chromium Browser
	echo.  [D]   Microsoft Win32 Calculator
	echo.  [E]   Windows Accessibility Braille
	echo.  [F]   Windows Data Deduplication
	echo.  [G]   Windows To Go Workspace
	echo.  [H]   Windows Media Feature Pack
	echo.  [I]   Windows Portable Devices
	echo.  [J]   Open Secure Shell ^(SSH^) Client ^& Server
	echo.  [K]   Microsoft Default Metro Apps
	echo.  [L]   Microsoft Office Desktop UWP Apps
	echo.  [M]   Microsoft DaRT 10.0 Tools
	echo.  [N]   Microsoft DirectX 9.0c
	echo.  [O]   Microsoft Games
	echo.  [P]   Windows Sidebar
	echo.  [Q]   Microsoft Visual C++ Runtime
	echo.
	echo.  [X]   Go Back
	echo.===============================================================================
	choice /C:ABCDEFGHIJKLMNOPQX /N /M "Enter Your Choice : "
	if errorlevel 18 goto :IntegrateMenu
	if errorlevel 17 goto :IntVCRuntime
	if errorlevel 16 goto :IntSidebar
	if errorlevel 17 goto :IntGames
	if errorlevel 14 goto :IntDirectX9c
	if errorlevel 13 goto :IntDaRT
	if errorlevel 12 goto :IntOfficeUWPApps
	if errorlevel 11 goto :IntMetroApps
	if errorlevel 10 goto :IntOpenSSH
	if errorlevel 9  goto :IntPortableDevices
	if errorlevel 8  goto :IntMediaFeaturePack
	if errorlevel 7  goto :IntWinToGo
	if errorlevel 6  goto :IntDedup
	if errorlevel 5  goto :IntBraille
	if errorlevel 4  goto :IntWin32Calc
	if errorlevel 3  goto :IntEdgeChromium
	if errorlevel 2  goto :IntNetFX48
	if errorlevel 1  goto :IntNetFX35
)

:: Checking whether the selected Source OS is a Windows 10 v1903/v1909 64-Bit Client Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "18362" if "%ImageBuild%" leq "18363" if "%ImageInstallationType%" equ "Client" if "%ImageArchitecture%" equ "x64" (
	echo.  [A]   Microsoft .NET Framework 3.5
	echo.  [B]   Microsoft Edge Chromium Browser
	echo.  [C]   Microsoft Win32 Calculator
	echo.  [D]   Windows Accessibility Braille
	echo.  [E]   Windows Data Deduplication
	echo.  [F]   Windows To Go Workspace
	echo.  [G]   Windows Media Feature Pack
	echo.  [H]   Windows Portable Devices
	echo.  [I]   Open Secure Shell ^(SSH^) Client ^& Server
	echo.  [J]   Microsoft Default Metro Apps
	echo.  [K]   Microsoft Office Desktop UWP Apps
	echo.  [L]   Microsoft DaRT 10.0 Tools
	echo.  [M]   Microsoft DirectX 9.0c
	echo.  [N]   Microsoft Games
	echo.  [O]   Windows Sidebar
	echo.  [P]   Microsoft Visual C++ Runtime
	echo.
	echo.  [X]   Go Back
	echo.===============================================================================
	echo.
	choice /C:ABCDEFGHIJKLMNOPX /N /M "Enter Your Choice : "
	if errorlevel 17 goto :IntegrateMenu
	if errorlevel 16 goto :IntVCRuntime
	if errorlevel 15 goto :IntSidebar
	if errorlevel 14 goto :IntGames
	if errorlevel 13 goto :IntDirectX9c
	if errorlevel 12 goto :IntDaRT
	if errorlevel 11 goto :IntOfficeUWPApps
	if errorlevel 10 goto :IntMetroApps
	if errorlevel 9  goto :IntOpenSSH
	if errorlevel 8  goto :IntPortableDevices
	if errorlevel 7  goto :IntMediaFeaturePack
	if errorlevel 6  goto :IntWinToGo
	if errorlevel 5  goto :IntDedup
	if errorlevel 4  goto :IntBraille
	if errorlevel 3  goto :IntWin32Calc
	if errorlevel 2  goto :IntEdgeChromium
	if errorlevel 1  goto :IntNetFX35
)

:: Checking whether the selected Source OS is a Windows 10 v2004 64-Bit Client Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "19041" if "%ImageInstallationType%" equ "Client" if "%ImageArchitecture%" equ "x64" (
	echo.  [A]   Microsoft .NET Framework 3.5
	echo.  [B]   Microsoft Edge Chromium Browser
	echo.  [C]   Microsoft Win32 Calculator
	echo.  [D]   Windows Accessibility Braille
	echo.  [E]   Windows Data Deduplication
	echo.  [F]   Windows Media Feature Pack
	echo.  [G]   Windows Portable Devices
	echo.  [H]   Open Secure Shell ^(SSH^) Client ^& Server
	echo.  [I]   Microsoft Default Metro Apps
	echo.  [J]   Microsoft Office Desktop UWP Apps
	echo.  [K]   Microsoft DaRT 10.0 Tools
	echo.  [L]   Microsoft DirectX 9.0c
	echo.  [M]   Microsoft Games
	echo.  [N]   Windows Sidebar
	echo.  [O]   Microsoft Visual C++ Runtime
	echo.
	echo.
	echo.  [X]   Go Back
	echo.===============================================================================
	echo.
	choice /C:ABCDEFGHIJKLMNOX /N /M "Enter Your Choice : "
	if errorlevel 16 goto :IntegrateMenu
	if errorlevel 15 goto :IntVCRuntime
	if errorlevel 14 goto :IntSidebar
	if errorlevel 13 goto :IntGames
	if errorlevel 12 goto :IntDirectX9c
	if errorlevel 11 goto :IntDaRT
	if errorlevel 10 goto :IntOfficeUWPApps
	if errorlevel 9  goto :IntMetroApps
	if errorlevel 8  goto :IntOpenSSH
	if errorlevel 7  goto :IntPortableDevices
	if errorlevel 6  goto :IntMediaFeaturePack
	if errorlevel 5  goto :IntDedup
	if errorlevel 4  goto :IntBraille
	if errorlevel 3  goto :IntWin32Calc
	if errorlevel 2  goto :IntEdgeChromium
	if errorlevel 1  goto :IntNetFX35
)

:: Checking whether the selected Source OS is a Windows 10 v1803/v1809/v1903/v1909 ARM64-Bit Client
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "17134" if "%ImageArchitecture%" equ "arm64" (
	echo.
	echo.  [1]   Microsoft .NET Framework 3.5
	echo.
	echo.  [2]   Microsoft Default Metro Apps
	echo.
	echo.  [3]   Microsoft Office Desktop UWP Apps
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.  [X]   Go Back
	echo.
	echo.===============================================================================
	echo.
	choice /C:123X /N /M "Enter Your Choice : "
	if errorlevel 4 goto :IntegrateMenu
	if errorlevel 3  goto :IntOfficeUWPApps
	if errorlevel 2  goto :IntMetroApps
	if errorlevel 1  goto :IntNetFX35
)

:: Checking whether the selected Source OS is a Windows Server 2016 Core Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "14393" if "%ImageInstallationType%" equ "Server Core" (
	echo.
	echo.  [1]   Microsoft .NET Framework 3.5
	echo.
	echo.  [2]   Microsoft .NET Framework 4.8
	echo.
	echo.  [3]   Windows Subsystem for Linux ^(WSL^)
	echo.
	echo.  [4]   Microsoft DaRT 10.0 Tools
	echo.
	echo.  [5]   Microsoft DirectX 9.0c
	echo.
	echo.  [6]   Microsoft Visual C++ Runtime
	echo.
	echo.
	echo.
	echo.
	echo.  [X]   Go Back
	echo.
	echo.===============================================================================
	echo.
	choice /C:123456X /N /M "Enter Your Choice : "
	if errorlevel 7 goto :IntegrateMenu
	if errorlevel 6 goto :IntVCRuntime
	if errorlevel 5 goto :IntDirectX9c
	if errorlevel 4 goto :IntDaRT
	if errorlevel 3 goto :IntWSL
	if errorlevel 2 goto :IntNetFX48
	if errorlevel 1 goto :IntNetFX35
)

:: Checking whether the selected Source OS is a Windows Server 2016
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "14393" if "%ImageInstallationType%" equ "Server" (
	echo.
	echo.  [A]   Microsoft .NET Framework 3.5
	echo.  [B]   Microsoft .NET Framework 4.8
	echo.  [C]   Microsoft Edge Classic Browser
	echo.  [D]   Microsoft Edge Chromium Browser
	echo.  [E]   Windows Multimedia Restricted Codecs
	echo.  [F]   Windows System Restore
	echo.  [G]   Windows Subsystem for Linux ^(WSL^) 
	echo.  [H]   Windows To Go Workspace
	echo.  [I]   Microsoft Default Metro Apps
	echo.  [J]   Microsoft DaRT 10.0 Tools
	echo.  [K]   Microsoft DirectX 9.0c
	echo.  [L]   Microsoft Games
	echo.  [M]   Windows Sidebar
	echo.  [N]   Microsoft Visual C++ Runtime
	echo.
	echo.  [X]   Go Back
	echo.
	echo.===============================================================================
	echo.
	choice /C:ABCDEFGHIJKLMNX /N /M "Enter Your Choice : "
	if errorlevel 15 goto :IntegrateMenu
	if errorlevel 14 goto :IntVCRuntime
	if errorlevel 13 goto :IntSidebar
	if errorlevel 12 goto :IntGames
	if errorlevel 11 goto :IntDirectX9c
	if errorlevel 10 goto :IntDaRT
	if errorlevel 9  goto :IntMetroApps
	if errorlevel 8  goto :IntWinToGo
	if errorlevel 7  goto :IntWSL
	if errorlevel 6  goto :IntSystemRestore
	if errorlevel 5  goto :IntMMRC
	if errorlevel 4  goto :IntEdgeChromium
	if errorlevel 3  goto :IntEdgeClassic
	if errorlevel 2  goto :IntNetFX48
	if errorlevel 1  goto :IntNetFX35
)

:: Checking whether the selected Source OS is a Windows Server v1709/v1803/Server 2019/v1809 Core Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "16299" if "%ImageBuild%" leq "17763" if "%ImageInstallationType%" equ "Server Core" (
	echo.
	echo.  [1]   Microsoft .NET Framework 3.5
	echo.
	echo.  [2]   Microsoft .NET Framework 4.8
	echo.
	echo.  [3]   Windows Subsystem for Linux ^(WSL^)
	echo.
	echo.  [4]   Microsoft DaRT 10.0 Tools
	echo.
	echo.  [5]   Microsoft DirectX 9.0c
	echo.
	echo.  [6]   Microsoft Visual C++ Runtime
	echo.
	echo.
	echo.
	echo.
	echo.  [X]   Go Back
	echo.
	echo.===============================================================================
	echo.
	choice /C:123456X /N /M "Enter Your Choice : "
	if errorlevel 7 goto :IntegrateMenu
	if errorlevel 6 goto :IntVCRuntime
	if errorlevel 5 goto :IntDirectX9c
	if errorlevel 4 goto :IntDaRT
	if errorlevel 3 goto :IntWSL
	if errorlevel 2 goto :IntNetFX48
	if errorlevel 1 goto :IntNetFX35
)

:: Checking whether the selected Source OS is a Windows Server v1709/v1803/Server 2019/v1809
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "16299" if "%ImageBuild%" leq "17763" if "%ImageInstallationType%" equ "Server" (
	echo.
	echo.  [A]   Microsoft .NET Framework 3.5
	echo.  [B]   Microsoft .NET Framework 4.8
	echo.  [C]   Microsoft Edge Classic Browser
	echo.  [D]   Microsoft Edge Chromium Browser
	echo.  [E]   Windows Multimedia Restricted Codecs
	echo.  [F]   Windows System Restore
	echo.  [G]   Windows Subsystem for Linux ^(WSL^) 
	echo.  [H]   Windows To Go Workspace
	echo.  [I]   Microsoft Default Metro Apps
	echo.  [J]   Microsoft DaRT 10.0 Tools
	echo.  [K]   Microsoft DirectX 9.0c
	echo.  [L]   Microsoft Games
	echo.  [M]   Windows Sidebar
	echo.  [N]   Microsoft Visual C++ Runtime
	echo.
	echo.  [X]   Go Back
	echo.
	echo.===============================================================================
	echo.
	choice /C:ABCDEFGHIJKLMNX /N /M "Enter Your Choice : "
	if errorlevel 15 goto :IntegrateMenu
	if errorlevel 14 goto :IntVCRuntime
	if errorlevel 13 goto :IntSidebar
	if errorlevel 12 goto :IntGames
	if errorlevel 11 goto :IntDirectX9c
	if errorlevel 10 goto :IntDaRT
	if errorlevel 9  goto :IntMetroApps
	if errorlevel 8  goto :IntWinToGo
	if errorlevel 7  goto :IntWSL
	if errorlevel 6  goto :IntSystemRestore
	if errorlevel 5  goto :IntMMRC
	if errorlevel 4  goto :IntEdgeChromium
	if errorlevel 3  goto :IntEdgeClassic
	if errorlevel 2  goto :IntNetFX48
	if errorlevel 1  goto :IntNetFX35
)

:: Checking whether the selected Source OS is a Windows Server v1903/v1909 Core Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "18362" if "%ImageInstallationType%" equ "Server Core" (
	echo.
	echo.  [1]   Microsoft .NET Framework 3.5
	echo.
	echo.  [2]   Windows Subsystem for Linux ^(WSL^)
	echo.
	echo.  [3]   Microsoft DaRT 10.0 Tools
	echo.
	echo.  [4]   Microsoft DirectX 9.0c
	echo.
	echo.  [5]   Microsoft Visual C++ Runtime
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.  [X]   Go Back
	echo.
	echo.===============================================================================
	echo.
	choice /C:12345X /N /M "Enter Your Choice : "
	if errorlevel 6 goto :IntegrateMenu
	if errorlevel 5 goto :IntVCRuntime
	if errorlevel 4 goto :IntDirectX9c
	if errorlevel 3 goto :IntDaRT
	if errorlevel 2 goto :IntWSL
	if errorlevel 1 goto :IntNetFX35
)

:: Checking whether the selected Source OS is a Windows Server v1903/v1909
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "18362" if "%ImageBuild%" leq "18363" if "%ImageInstallationType%" equ "Server" (
	echo.
	echo.  [A]   Microsoft .NET Framework 3.5
	echo.  [B]   Microsoft Edge Classic Browser
	echo.  [C]   Microsoft Edge Chromium Browser
	echo.  [D]   Windows Multimedia Restricted Codecs
	echo.  [E]   Windows Subsystem for Linux ^(WSL^) 
	echo.  [F]   Windows To Go Workspace
	echo.  [G]   Microsoft Default Metro Apps
	echo.  [H]   Microsoft DaRT 10.0 Tools
	echo.  [I]   Microsoft DirectX 9.0c
	echo.  [J]   Microsoft Games
	echo.  [K]   Windows Sidebar
	echo.  [L]   Microsoft Visual C++ Runtime
	echo.
	echo.
	echo.
	echo.  [X]   Go Back
	echo.
	echo.===============================================================================
	echo.
	choice /C:ABCDEFGHIJKLX /N /M "Enter Your Choice : "
	if errorlevel 13 goto :IntegrateMenu
	if errorlevel 12 goto :IntVCRuntime
	if errorlevel 11 goto :IntSidebar
	if errorlevel 10 goto :IntGames
	if errorlevel 9  goto :IntDirectX9c
	if errorlevel 8  goto :IntDaRT
	if errorlevel 7  goto :IntMetroApps
	if errorlevel 6  goto :IntWinToGo
	if errorlevel 5  goto :IntWSL
	if errorlevel 4  goto :IntMMRC
	if errorlevel 3  goto :IntEdgeChromium
	if errorlevel 2  goto :IntEdgeClassic
	if errorlevel 1  goto :IntNetFX35
)

:: Checking whether the selected Source OS is a Windows Server v2004
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "19041" if "%ImageInstallationType%" equ "Server" (
	echo.
	echo.  [A]   Microsoft .NET Framework 3.5
	echo.  [B]   Microsoft Edge Classic Browser
	echo.  [C]   Microsoft Edge Chromium Browser
	echo.  [D]   Windows Multimedia Restricted Codecs
	echo.  [E]   Windows Subsystem for Linux ^(WSL^) 
	echo.  [F]   Microsoft Default Metro Apps
	echo.  [G]   Microsoft DaRT 10.0 Tools
	echo.  [H]   Microsoft DirectX 9.0c
	echo.  [I]   Microsoft Games
	echo.  [J]   Windows Sidebar
	echo.  [K]   Microsoft Visual C++ Runtime
	echo.
	echo.
	echo.
	echo.
	echo.  [X]   Go Back
	echo.
	echo.===============================================================================
	echo.
	choice /C:ABCDEFGHIJKX /N /M "Enter Your Choice : "
	if errorlevel 12 goto :IntegrateMenu
	if errorlevel 11 goto :IntVCRuntime
	if errorlevel 10 goto :IntSidebar
	if errorlevel 9  goto :IntGames
	if errorlevel 8  goto :IntDirectX9c
	if errorlevel 7  goto :IntDaRT
	if errorlevel 6  goto :IntMetroApps
	if errorlevel 5  goto :IntWSL
	if errorlevel 4  goto :IntMMRC
	if errorlevel 3  goto :IntEdgeChromium
	if errorlevel 2  goto :IntEdgeClassic
	if errorlevel 1  goto :IntNetFX35
)
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: MSMG Toolkit - Integrate Windows Custom Features Menu
::-------------------------------------------------------------------------------------------
:IntCustomFeatures

cls
echo.===============================================================================
echo.            MSMG ToolKit - Integrate Windows Custom Features Menu
echo.===============================================================================

if "%IsDialogsEnabled%" equ "Yes" (
	cls
	echo.===============================================================================
	echo.            MSMG ToolKit - Integrate Windows Custom Features Menu
	echo.===============================================================================
	echo.
	echo.
	echo.
	echo.                                W A R N I N G
	echo.                                =============
	echo.
	echo.   Integrating Windows Custom Features involves patching system files and so
	echo.   the SFC can report about Windows System Files corruption, This is normal.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.   To turn off Warning Dialogs, Choose Disable Dialogs in Tools-^>Options Menu
	echo.
	echo.===============================================================================
	echo.
	choice /C:YN /N /M "Do You Want to Continue ? ['Y'es/'N'o] : "
	if errorlevel 2 goto :IntegrateMenu
)

cls
echo.===============================================================================
echo.            MSMG ToolKit - Integrate Windows Custom Features Menu
echo.===============================================================================
:: Checking whether the selected Source OS is a Windows 7 Client/Server 2008 R2 Non-Core Edition
if "%selectedSourceOS%" equ "w7" if "%ImageInstallationType%" neq "Embedded" if "%ImageInstallationType%" neq "Server Core" (
	echo.
	echo.  [1]   Microsoft Terminal Server Patch
	echo.
	echo.  [2]   Custom Themes UxTheme Patch
	echo.
	echo.  [3]   Custom Windows Recovery Environment ^(WinRE^)
	echo.
	echo.  [4]   Custom Default User Account Pictures
	echo.
	echo.  [5]   Custom System Files
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.  [X]   Go Back
	echo.
	echo.===============================================================================
	echo.
	choice /C:12345X /N /M "Enter Your Choice : "
	if errorlevel 6 goto :IntegrateMenu
	if errorlevel 5 goto :IntCustomFiles
	if errorlevel 4 goto :IntUAP
	if errorlevel 3 goto :IntCustomRecoveryImage
	if errorlevel 2 goto :IntCustomUxTheme
	if errorlevel 1 goto :IntCustomTerminalServer
)

:: Checking whether the selected Source OS is a Windows 7 Embedded Edition
if "%selectedSourceOS%" equ "w7" if "%ImageInstallationType%" equ "Embedded" (
	echo.
	echo.  [1]   Microsoft Terminal Server Patch
	echo.
	echo.  [2]   Custom Themes UxTheme Patch
	echo.
	echo.  [3]   Custom Default User Account Pictures
	echo.
	echo.  [4]   Custom System Files
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.  [X]   Go Back
	echo.
	echo.===============================================================================
	echo.
	choice /C:1234X /N /M "Enter Your Choice : "
	if errorlevel 5 goto :IntegrateMenu
	if errorlevel 4 goto :IntCustomFiles
	if errorlevel 3 goto :IntUAP
	if errorlevel 2 goto :IntCustomUxTheme
	if errorlevel 1 goto :IntCustomTerminalServer
)

:: Checking whether the selected Source OS is a Windows Server 2008 Core Edition
if "%selectedSourceOS%" equ "w7" if "%ImageInstallationType%" equ "Server Core" (
	echo.
	echo.  [1]   Microsoft Terminal Server Patch
	echo.
	echo.  [2]   Custom Windows Recovery Environment ^(WinRE^)
	echo.
	echo.  [3]   Custom System Files
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.  [X]   Go Back
	echo.
	echo.===============================================================================
	echo.
	choice /C:123X /N /M "Enter Your Choice : "
	if errorlevel 4 goto :IntegrateMenu
	if errorlevel 3 goto :IntCustomFiles
	if errorlevel 2 goto :IntCustomRecoveryImage
	if errorlevel 1 goto :IntCustomTerminalServer
)

:: Checking whether the selected Source OS is a Windows 8.1 Client Non-Professioanl WMC/Server 2012 R2 Non-Core Edition
if "%selectedSourceOS%" equ "w81" if "%ImageFlag%" neq "ProfessionalWMC" if "%ImageInstallationType%" neq "Server Core" (
	echo.
	echo.  [1]   Windows 8.1 Pre-Activation Data
	echo.
	echo.  [2]   Microsoft Terminal Server Patch
	echo.
	echo.  [3]   Custom Themes UxTheme Patch
	echo.
	echo.  [4]   Custom Windows Recovery Environment ^(WinRE^)
	echo.
	echo.  [5]   Custom Default User Account Pictures
	echo.
	echo.  [6]   Custom System Files
	echo.
	echo.
	echo.
	echo.
	echo.  [X]   Go Back
	echo.
	echo.===============================================================================
	echo.
	choice /C:123456X /N /M "Enter Your Choice : "
	if errorlevel 7 goto :IntegrateMenu
	if errorlevel 6 goto :IntCustomFiles
	if errorlevel 5 goto :IntUAP
	if errorlevel 4 goto :IntCustomRecoveryImage
	if errorlevel 3 goto :IntCustomUxTheme
	if errorlevel 2 goto :IntCustomTerminalServer
	if errorlevel 1 goto :IntPreActTokens
)

:: Checking whether the selected Source OS is a Windows 8.1 Professioanl WMC Edition
if "%selectedSourceOS%" equ "w81" if "%ImageEdition%" equ "ProfessionalWMC" (
	echo.
	echo.  [1]   Windows 8.1 Media Center Generic Activation Tokens
	echo.
	echo.  [2]   Windows 8.1 Pre-Activation Data
	echo.
	echo.  [3]   Microsoft Terminal Server Patch
	echo.
	echo.  [4]   Custom Themes UxTheme Patch
	echo.
	echo.  [5]   Custom Windows Recovery Environment ^(WinRE^)
	echo.
	echo.  [6]   Custom Default User Account Pictures
	echo.
	echo.  [7]   Custom System Files
	echo.
	echo.
	echo.
	echo.  [X]   Go Back
	echo.
	echo.===============================================================================
	choice /C:1234567X /N /M "Enter Your Choice : "
	if errorlevel 8 goto :IntegrateMenu
	if errorlevel 7 goto :IntCustomFiles
	if errorlevel 6 goto :IntUAP
	if errorlevel 5 goto :IntCustomRecoveryImage
	if errorlevel 4 goto :IntCustomUxTheme
	if errorlevel 3 goto :IntCustomTerminalServer
	if errorlevel 2 goto :IntPreActTokens
	if errorlevel 1 goto :IntWMCGActTokens
)

:: Checking whether the selected Source OS is a Windows Server 2012 R2 Core Edition
if "%selectedSourceOS%" equ "w81" if "%ImageInstallationType%" equ "Server Core" (
	echo.
	echo.  [1]   Microsoft Terminal Server Patch
	echo.
	echo.  [2]   Custom Windows Recovery Environment ^(WinRE^)
	echo.
	echo.  [3]   Custom System Files
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.  [X]   Go Back
	echo.
	echo.===============================================================================
	echo.
	choice /C:123X /N /M "Enter Your Choice : "
	if errorlevel 4 goto :IntegrateMenu
	if errorlevel 3 goto :IntCustomFiles
	if errorlevel 2 goto :IntCustomRecoveryImage
	if errorlevel 1 goto :IntCustomTerminalServer
)

:: Checking whether the selected Source OS is a Windows Server Core Edition
if "%selectedSourceOS%" equ "w10" if "%ImageInstallationType%" equ "Server Core" (
	echo.
	echo.  [1]   Microsoft Terminal Server Patch
	echo.
	echo.  [2]   Custom Windows Recovery Environment ^(WinRE^)
	echo.
	echo.  [3]   Custom System Files
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.  [X]   Go Back
	echo.
	echo.===============================================================================
	echo.
	choice /C:123X /N /M "Enter Your Choice : "
	if errorlevel 4 goto :IntegrateMenu
	if errorlevel 3 goto :IntCustomFiles
	if errorlevel 2 goto :IntCustomRecoveryImage
	if errorlevel 1 goto :IntCustomTerminalServer
)

:: Checking whether the selected Source OS is a Windows 10 Client/Server Non-Core Edition
if "%selectedSourceOS%" equ "w10" if "%ImageInstallationType%" neq "Server Core" (
	echo.  [1]   Microsoft Terminal Server Patch
	echo.
	echo.  [2]   Custom Themes UxTheme Patch
	echo.
	echo.  [3]   Custom Windows Recovery Environment ^(WinRE^)
	echo.
	echo.  [4]   Custom Default User Account Pictures
	echo.
	echo.  [5]   Custom System Files
	echo.
	echo.  [6]   Microsoft Win32Calc Metro Skin
	echo.
	echo.  [7]   Windows Photo Viewer Metro Skin
	echo.
	echo.  [8]   Windows Media Player Metro Skin
	echo.
	echo.
	echo.  [X]   Go Back
	echo.===============================================================================
	echo.
	choice /C:12345678X /N /M "Enter Your Choice : "
	if errorlevel 9 goto :IntegrateMenu
	if errorlevel 8 goto :IntWMPMetroSkin
	if errorlevel 7 goto :IntWPVMetroSkin
	if errorlevel 6 goto :IntWin32CalcMetroSkin	
	if errorlevel 5 goto :IntCustomFiles
	if errorlevel 4 goto :IntUAP
	if errorlevel 3 goto :IntCustomRecoveryImage
	if errorlevel 2 goto :IntCustomUxTheme
	if errorlevel 1 goto :IntCustomTerminalServer
)
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: MSMG Toolkit - Remove Menu
::-------------------------------------------------------------------------------------------
:RemoveMenu

cls
echo.===============================================================================
echo.                          MSMG ToolKit - Remove Menu
echo.===============================================================================
echo.

:: Checking whether Source OS is selected
if "%IsSourceselected%" equ "No" (
	echo.Source OS is not selected, please do select source from "Source" menu..
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu
)

:: Checking whether Image Registry is loaded
if "%IsImageRegistryLoaded%" equ "Yes" (
	echo.Source OS Image Registry is loaded, please do unload it using Tools-^>Options..
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu
)

:: Checking whether the selected Source OS is not Windows 10
if "%selectedSourceOS%" neq "w10" (
	echo.  [1]   Remove Windows Components Using Package List
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
)

:: Checking whether the selected Source OS is Windows 10 Enterprise 2015/2016 LTSB Edition
if "%selectedSourceOS%" equ "w10" if "%ImageBuild%" leq "17134" if "%ImageFlag%" equ "EnterpriseS" (
	echo.  [1]   Remove Windows Components Using Package List
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
)

:: Checking whether the selected Source OS is Windows 10 Enterprise N 2015/2016 LTSB Edition
if "%selectedSourceOS%" equ "w10" if "%ImageBuild%" leq "17134" if "%ImageFlag%" equ "EnterpriseSN" (
	echo.  [1]   Remove Windows Components Using Package List
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
)

:: Checking whether the selected Source OS is Windows 10 v1507/v1511/v1607/v1703/v1709/v1803 Client Edition
if "%selectedSourceOS%" equ "w10" if "%ImageBuild%" leq "17134" if "%ImageInstallationType%" equ "Client" if "%ImageFlag%" neq "EnterpriseS" if "%ImageFlag%" neq "EnterpriseSN" (
	echo.  [1]   Remove Windows Apps Using Apps List
	echo. 
	echo.  [2]   Remove Windows Components Using Package List
	echo.
	echo.
	echo.
	echo.
)

:: Checking whether the selected Source OS is a Windows 10 Enterprise 2019 LTSC Edition
if "%selectedSourceOS%" equ "w10" if "%ImageBuild%" equ "17763" if "%ImageFlag%" equ "EnterpriseS" (
	echo.  [1]   Remove Windows Components
	echo. 
	echo.  [2]   Remove Windows Components Using Package List
	echo.
	echo.
	echo.
	echo.
)

:: Checking whether the selected Source OS is a Windows 10 Enterprise N 2019 LTSC Edition
if "%selectedSourceOS%" equ "w10" if "%ImageBuild%" equ "17763" if "%ImageFlag%" equ "EnterpriseSN" (
	echo.  [1]   Remove Windows Components
	echo. 
	echo.  [2]   Remove Windows Components Using Package List
	echo.
	echo.
	echo.
	echo.
)

:: Checking whether the selected Source OS is a Windows 10 Client Non-EnterpriseS/EnterpriseSN Edition
if "%selectedSourceOS%" equ "w10" if "%ImageBuild%" equ "17763" if "%ImageInstallationType%" equ "Client" if "%ImageFlag%" neq "EnterpriseS" if "%ImageFlag%" neq "EnterpriseSN" (
	echo.  [1]   Remove Windows Components
	echo.
	echo.  [2]   Remove Windows Apps Using Apps List
	echo.
	echo.  [3]   Remove Windows Components Using Package List
	echo.
	echo.
)

:: Checking whether the selected Source OS is a Windows 10 Client
if "%selectedSourceOS%" equ "w10" if "%ImageBuild%" geq "18362" if "%ImageBuild%" leq "18363" if "%ImageInstallationType%" equ "Client" (
	echo.  [1]   Remove Windows Components
	echo.
	echo.  [2]   Remove Windows Apps Using Apps List
	echo.
	echo.  [3]   Remove Windows Components Using Package List
	echo.
	echo.
)

:: Checking whether the selected Source OS is a Windows 10 Client
if "%selectedSourceOS%" equ "w10" if "%ImageBuild%" equ "19041" if "%ImageInstallationType%" equ "Client" (
	echo.  [1]   Remove Windows Components
	echo.
	echo.  [2]   Remove Windows Apps Using Apps List
	echo.
	echo.  [3]   Remove Windows Components Using Package List
	echo.
	echo.
)

:: Checking whether the selected Source OS is a Windows 10 Client
if "%selectedSourceOS%" equ "w10" if "%ImageBuild%" gtr "19041" if "%ImageInstallationType%" equ "Client" (
	echo.  [1]   Remove Windows Apps Using Apps List
	echo. 
	echo.  [2]   Remove Windows Components Using Package List
	echo.
	echo.
	echo.
	echo.
)

:: Checking whether the selected Source OS is a Windows Server Edition
if "%selectedSourceOS%" equ "w10" if "%ImageInstallationType:~,6%" equ "Server" (
	echo.  [1]   Remove Windows Components Using Package List
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
)

echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.  [X]   Go Back
echo.
echo.===============================================================================
echo.
:: Checking whether the selected Source OS is not Windows 10
if "%selectedSourceOS%" neq "w10" (
	choice /C:1X /N /M "Enter Your Choice : "
	if errorlevel 2 goto :MainMenu
	if errorlevel 1 goto :RemoveWindowsComponentsList
)

:: Checking whether the selected Source OS is Windows 10 Enterprise 2015/2016 LTSB Edition
if "%selectedSourceOS%" equ "w10" if "%ImageBuild%" leq "17134" if "%ImageFlag%" equ "EnterpriseS" (
	choice /C:1X /N /M "Enter Your Choice : "
	if errorlevel 2 goto :MainMenu
	if errorlevel 1 goto :RemoveWindowsComponentsList
)

:: Checking whether the selected Source OS is Windows 10 Enterprise N 2015/2016 LTSB Edition
if "%selectedSourceOS%" equ "w10" if "%ImageBuild%" leq "17134" if "%ImageFlag%" equ "EnterpriseSN" (
	choice /C:1X /N /M "Enter Your Choice : "
	if errorlevel 2 goto :MainMenu
	if errorlevel 1 goto :RemoveWindowsComponentsList
)

:: Checking whether the selected Source OS is Windows 10 v1507/v1511/v1607/v1703/v1709/v1803 Client Edition
if "%selectedSourceOS%" equ "w10" if "%ImageBuild%" leq "17134" if "%ImageInstallationType%" equ "Client" if "%ImageFlag%" neq "EnterpriseS" if "%ImageFlag%" neq "EnterpriseSN" (
	choice /C:12X /N /M "Enter Your Choice : "
	if errorlevel 3 goto :MainMenu
	if errorlevel 2 goto :RemoveWindowsComponentsList
	if errorlevel 1 goto :RemoveWindowsAppsList
)

:: Checking whether the selected Source OS is a Windows 10 Enterprise 2019 LTSC Edition
if "%selectedSourceOS%" equ "w10" if "%ImageBuild%" equ "17763" if "%ImageFlag%" equ "EnterpriseS" (
	choice /C:12X /N /M "Enter Your Choice : "
	if errorlevel 3 goto :MainMenu
	if errorlevel 2 goto :RemoveWindowsComponentsList
	if errorlevel 1 goto :RemoveWindowsComponentsMenu
)

:: Checking whether the selected Source OS is a Windows 10 Enterprise N 2019 LTSC Edition
if "%selectedSourceOS%" equ "w10" if "%ImageBuild%" equ "17763" if "%ImageFlag%" equ "EnterpriseSN" (
	choice /C:12X /N /M "Enter Your Choice : "
	if errorlevel 3 goto :MainMenu
	if errorlevel 2 goto :RemoveWindowsComponentsList
	if errorlevel 1 goto :RemoveWindowsComponentsMenu
)

:: Checking whether the selected Source OS is a Windows 10 Client Non-EnterpriseS/EnterpriseSN Edition
if "%selectedSourceOS%" equ "w10" if "%ImageBuild%" equ "17763" if "%ImageInstallationType%" equ "Client" if "%ImageFlag%" neq "EnterpriseS" if "%ImageFlag%" neq "EnterpriseSN" (
	choice /C:123X /N /M "Enter Your Choice : "
	if errorlevel 4 goto :MainMenu
	if errorlevel 3 goto :RemoveWindowsComponentsList
	if errorlevel 2 goto :RemoveWindowsAppsList
	if errorlevel 1 goto :RemoveWindowsComponentsMenu
)

:: Checking whether the selected Source OS is a Windows 10 Client
if "%selectedSourceOS%" equ "w10" if "%ImageBuild%" geq "18362" if "%ImageBuild%" leq "18363" if "%ImageInstallationType%" equ "Client" (
	choice /C:123X /N /M "Enter Your Choice : "
	if errorlevel 4 goto :MainMenu
	if errorlevel 3 goto :RemoveWindowsComponentsList
	if errorlevel 2 goto :RemoveWindowsAppsList
	if errorlevel 1 goto :RemoveWindowsComponentsMenu
)

:: Checking whether the selected Source OS is a Windows 10 Client
if "%selectedSourceOS%" equ "w10" if "%ImageBuild%" equ "19041" if "%ImageInstallationType%" equ "Client" (
	choice /C:123X /N /M "Enter Your Choice : "
	if errorlevel 4 goto :MainMenu
	if errorlevel 3 goto :RemoveWindowsComponentsList
	if errorlevel 2 goto :RemoveWindowsAppsList
	if errorlevel 1 goto :RemoveWindowsComponentsMenu
)

:: Checking whether the selected Source OS is a Windows 10 Client
if "%selectedSourceOS%" equ "w10" if "%ImageBuild%" gtr "19041" if "%ImageInstallationType%" equ "Client" (
	choice /C:12X /N /M "Enter Your Choice : "
	if errorlevel 3 goto :MainMenu
	if errorlevel 2 goto :RemoveWindowsComponentsList
	if errorlevel 1 goto :RemoveWindowsAppsList
)

:: Checking whether the selected Source OS is a Windows Server Edition
if "%selectedSourceOS%" equ "w10" if "%ImageInstallationType:~,6%" equ "Server" (
	choice /C:1X /N /M "Enter Your Choice : "
	if errorlevel 2 goto :MainMenu
	if errorlevel 1 goto :RemoveWindowsComponentsList
)
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: MSMG Toolkit - Customize Menu
::-------------------------------------------------------------------------------------------
:CustomizeMenu

cls
echo.===============================================================================
echo.                         MSMG ToolKit - Customize Menu
echo.===============================================================================
echo.
:: Checking whether Source OS is selected
if "%IsSourceselected%" equ "No" (
	echo.Source OS is not selected, please do select source from "Source" menu..
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu
)

:: Checking whether Image Registry is loaded
if "%IsImageRegistryLoaded%" equ "Yes" (
	echo.Source OS Image Registry is loaded, please do unload it using Tools-^>Options..
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu
)

:: Checking whether the selected Source OS is a Windows 7/Server 2008 R2 Edition
if "%selectedSourceOS%" equ "w7" (
	echo.This feature is not yet implemented...
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu
)

echo.  [1]   Enable Windows Features using Features List
echo.  [2]   Disable Windows Features using Features List
echo.  [3]   Import Custom Default Metro Apps Association from XML File
echo.  [4]   Export Default Metro Apps Association to XML File
echo.  [5]   Remove Default Metro Apps Association XML
echo.  [6]   Import Custom StartMenu Layout from XML File
echo.  [7]   Import Custom Registry Setting from Registry File
echo.  [8]   Apply Tweaks
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.  [X]   Go Back
echo.
echo.===============================================================================
echo.
choice /C:12345678X /N /M "Enter Your Choice : "
if errorlevel 9 goto :MainMenu
if errorlevel 8 goto :ApplyTweaks
if errorlevel 7 goto :ImportCustomRegistry
if errorlevel 6 goto :ImportStartMenuLayout
if errorlevel 5 goto :RemoveMetroAppsAssociation
if errorlevel 4 goto :ExportMetroAppsAssociation
if errorlevel 3 goto :ImportMetroAppsAssociation
if errorlevel 2 goto :DisableFeatures
if errorlevel 1 goto :EnableFeatures
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: MSMG Toolkit - Apply Source Menu
::-------------------------------------------------------------------------------------------
:ApplyMenu

cls
echo.===============================================================================
echo.                       MSMG ToolKit - Apply Source Menu
echo.===============================================================================
echo.
:: Checking whether Image Registry is loaded
if "%IsImageRegistryLoaded%" equ "Yes" (
	echo.Source OS Image Registry is loaded, please do unload it using Tools-^>Options..
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu
)

if "%IsSourceselected%" equ "No" (
	echo.  [1]   Rebuild Source Images
	echo.
	echo.
	echo.
	echo.
)

if "%IsSourceselected%" equ "Yes" if "%selectedSourceOS%" equ "w7" (
	echo.  [1]   Apply ^& Save Changes to Source Images
	echo.
	echo.  [2]   Discard Changes ^& Unmount Source Images
	echo.
	echo.
)

if "%IsSourceselected%" equ "Yes" if "%selectedSourceOS%" neq "w7" (
	echo.  [1]   Cleanup Source Images
	echo.
	echo.  [2]   Apply ^& Save Changes to Source Images
	echo.
	echo.  [3]   Discard Changes ^& Unmount Source Images
)
echo.
echo.
echo.
echo.
echo. 
echo.
echo.
echo.
echo.
echo.
echo.  [X]   Go Back
echo.
echo.===============================================================================
echo.

if "%IsSourceselected%" equ "No" (
	choice /C:1X /N /M "Enter Your Choice : "
	if errorlevel 2 goto :MainMenu
	if errorlevel 1 goto :RebuildSource
)

if "%IsSourceselected%" equ "Yes" if "%selectedSourceOS%" equ "w7" (
	choice /C:12X /N /M "Enter Your Choice : "
	if errorlevel 3 goto :MainMenu
	if errorlevel 2 goto :DiscardSource
	if errorlevel 1 goto :SaveSource
)

if "%IsSourceselected%" equ "Yes" if "%selectedSourceOS%" neq "w7" (
	choice /C:1234X /N /M "Enter Your Choice : "
	if errorlevel 5 goto :MainMenu
	if errorlevel 3 goto :DiscardSource
	if errorlevel 2 goto :SaveSource
	if errorlevel 1 goto :CleanupSource
)
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: MSMG Toolkit - Select Target Menu
::-------------------------------------------------------------------------------------------
:TargetMenu

cls
echo.===============================================================================
echo.                      MSMG ToolKit - Select Target Menu
echo.===============================================================================
echo.
echo.  [1]   Make a DVD ISO Image
echo.
echo.  [2]   Burn an ISO Image to DVD
echo.
echo.  [3]   Copy Source to USB Flash Drive
echo.
echo.  [4]   Sync Source Boot ^& Install Images to USB Flash Drive
echo.
echo.  [5]   Burn an ISO Image to Bootable USB Flash Drive
echo.
echo.  [6]   Format a USB Flash Drive
echo.
echo.
echo.
echo.
echo.  [X]   Go Back
echo.
echo.===============================================================================
echo.
choice /C:123456X /N /M "Enter Your Choice : "
if errorlevel 7 goto :MainMenu
if errorlevel 6 goto :FormatUSB
if errorlevel 5 goto :BurnUSB
if errorlevel 4 goto :SyncUSB
if errorlevel 3 goto :CopyUSB
if errorlevel 2 goto :BurnISO
if errorlevel 1 goto :MakeISO
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: MSMG Toolkit - Tools Menu
::-------------------------------------------------------------------------------------------
:ToolsMenu

cls
echo.===============================================================================
echo.                         MSMG ToolKit - Tools Menu
echo.===============================================================================
echo.
echo.  [1]   WIM Manager
echo.
echo.  [2]   Debug Info
echo.
echo.  [3]   Options
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.  [X]   Go Back
echo.
echo.===============================================================================
echo.
choice /C:123X /N /M "Enter Your Choice : "
if errorlevel 4 goto :MainMenu
if errorlevel 3 goto :Options
if errorlevel 2 goto :Debug
if errorlevel 1 goto :WIMManager
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: MSMG Toolkit - Select Source from <DVD> folder
::-------------------------------------------------------------------------------------------
:SelectSourceDVD

cls
echo.===============================================================================
echo.               MSMG ToolKit - Select Source from ^<DVD^> folder
echo.===============================================================================
echo.

:: Checking whether Windows Source Boot Image exist
if not exist "%BootWim%" (
	echo.Can't find Windows Setup "Boot.wim" Image in ^<DVD\Sources^> folder...
	echo.
	echo.Please copy Windows Setup "Boot.wim" Image to ^<DVD\Sources^> folder...
	goto :Stop
)

:: Checking whether Windows Source Install Image is a ESD Image
if exist "%InstallEsd%" (
	echo.ToolKit found Windows Installation image in a .esd format, an ESD image 
	echo.is a highly compressed image which cannot be directly serviced.
	echo.
	echo.The Toolkit requires the Windows Installation image to be in a .wim 
	echo.format for servciing.
	echo.
	echo.Please use a Windows Installation image in a .wim format or use the
	echo.Convert menu to convert a .esd Image to .wim format	
	goto :Stop
)

:: Checking whether Windows Source Install Image exist
if not exist "%InstallWim%" (
	echo.Can't find Windows Setup "Install.wim" Image in ^<DVD\Sources^> folder...
	echo.
	echo.Please copy Windows Setup "Install.wim" Image to ^<DVD\Sources^> folder...
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Selecting Source Images####################################################
echo.-------------------------------------------------------------------------------

:: Getting Image Index Number to Service
call :GetImageIndexNo "!InstallWim!"

:: Checking for Image Index Validation
if "!ImageIndexNo!" equ "" (
	echo.
	echo.Invalid Index # Entered, Valid Range is [1-!ImageCount!]
	echo.
	echo.Press Enter to Try Again...
	pause >nul
	goto :SelectSourceDVD
)

:: Checking for Image Index Validation
if "!ImageIndexNo!" neq "*" if "!ImageIndexNo!" lss "1" (
	echo.
	echo.Invalid Index # Entered, Valid Range is [1-!ImageCount!]
	echo.
	echo.Press Enter to Try Again...
	pause >nul
	goto :SelectSourceDVD
)

:: Checking for Image Index Validation
if "!ImageIndexNo!" neq "*" if "!ImageIndexNo!" gtr "!ImageCount!" (
	echo.
	echo.Invalid Index # Entered, Valid Range is [1-!ImageCount!]
	echo.
	echo.Press Enter to Try Again...
	pause >nul
	goto :SelectSourceDVD
)

:: Getting selected Image Index Information
if "%ImageIndexNo%" equ "*" call :GetImageIndexInfo "%InstallWim%", 1 >nul
if "%ImageIndexNo%" neq "*" call :GetImageIndexInfo "%InstallWim%", %ImageIndexNo% >nul

:: Setting selected Source OS version
if "%ImageVersion%" equ "6.1.7601" set "SelectedSourceOS=w7"
if "%ImageVersion%" equ "6.3.9600" set "SelectedSourceOS=w81"
if "%ImageVersion:~0,-6%" equ "10.0" set "SelectedSourceOS=w10"

:: Checking whether the HOST OS is Windows 7 and selected Source OS is Windows 10
if "%HostVersion%" equ "6.1" if "%SelectedSourceOS%" equ "w10" (
	echo.
	echo.ToolKit cannot service Windows 10 Source OS on Windows 7 HOST OS... 
	echo.
	echo.ToolKit requires a Windows 8.1/10 HOST OS for servicing Windows 10 Source OS...
	goto :Stop	
)

echo.
choice /C:YN /N /M "Do you want to mount Windows Setup Boot Image ? ['Y'es/'N'o] : "
if "%errorlevel%" equ "1" set "IsBootImageSelected=Yes"
if "%errorlevel%" equ "2" set "IsBootImageSelected=No"

echo.
choice /C:YN /N /M "Do you want to mount Windows Recovery Image ? ['Y'es/'N'o] : "
if "%errorlevel%" equ "1" set "IsRecoveryImageSelected=Yes"
if "%errorlevel%" equ "2" set "IsRecoveryImageSelected=No"

echo.
echo.-------------------------------------------------------------------------------
echo.####Source Image Information###################################################
echo.-------------------------------------------------------------------------------
echo.
if "%ImageIndexNo%" equ "*" (
	echo.    Image                    :  Install.wim
	echo.    Image Indexes No         :  1-%ImageCount%
	echo.    Image Architecture       :  %ImageArchitecture%
	echo.    Image Version            :  %ImageVersion%
	echo.    Image Service Pack Build :  %ImageServicePackBuild%
	echo.    Image Service Pack Level :  %ImageServicePackLevel%
	echo.    Image Build              :  %ImageBuild%
	echo.    Image Default Language   :  %ImageDefaultLanguage%
) else (
	echo.    Image                    :  Install.wim
	echo.    Image Index No           :  %ImageIndexNo%
	echo.    Image Name               :  %ImageName%
	echo.    Image Description        :  %ImageDescription%
	echo.    Image Architecture       :  %ImageArchitecture%
	echo.    Image Version            :  %ImageVersion%
	echo.    Image Service Pack Build :  %ImageServicePackBuild%
	echo.    Image Service Pack Level :  %ImageServicePackLevel%
	echo.    Image Build              :  %ImageBuild%
	echo.    Image Edition            :  %ImageEdition%
	echo.    Image Flag               :  %ImageFlag%
	echo.    Image Installation Type  :  %ImageInstallationType%
	echo.    Image Default Language   :  %ImageDefaultLanguage%
)
echo.
echo.-------------------------------------------------------------------------------
echo.####Mounting Source Images#####################################################
echo.-------------------------------------------------------------------------------
echo.
if "%IsBootImageSelected%" equ "Yes" (
	:: Mounting Source Boot Image Index 1 to Service
	echo.-------------------------------------------------------------------------------
	echo.Mounting [Boot.wim, Index : 1] Image at ^<\Mount\Boot\1^>...
	echo.-------------------------------------------------------------------------------
	call :MountImage "%BootWim%", 1, "%BootMount%\1"
	echo.-------------------------------------------------------------------------------

	:: Mounting Source Boot Image Index 2 to Service
	echo.Mounting [Boot.wim, Index : 2] Image at ^<\Mount\Boot\2^>...
	echo.-------------------------------------------------------------------------------
	call :MountImage "%BootWim%", 2, "%BootMount%\2"
)

:: Mounting Source Install & Recovery Images Index to Service
if "%ImageIndexNo%" equ "*" (
	for /L %%i in (1, 1, %ImageCount%) do (
		call :CreateFolder "%InstallMount%\%%i"

		:: Mounting Source Install Image Indexes to Service
		echo.-------------------------------------------------------------------------------
		echo.Mounting [Install.wim, Index : %%i] Image at ^<\Mount\Install\%%i^>...
		echo.-------------------------------------------------------------------------------
		call :MountImage "%InstallWim%", %%i, "%InstallMount%\%%i"

		rem if "%%i" neq "%ImageCount%" echo.-------------------------------------------------------------------------------
	)
	if "%IsRecoveryImageSelected%" equ "Yes" (
		:: Mounting Source Recovery Image Indexes to Service
		echo.-------------------------------------------------------------------------------
		echo.Mounting [WinRE.wim, Index : 1] Image at ^<\Mount\WinRE^>...
		echo.-------------------------------------------------------------------------------
		call :MountImage "%InstallMount%\1\%WinReWim%", 1, "%WinReMount%"
	)
) else (
	:: Mounting Source Install Image Index to Service
	echo.-------------------------------------------------------------------------------
	echo.Mounting [Install.wim, Index : %ImageIndexNo%] Image at ^<\Mount\Install^>...
	echo.-------------------------------------------------------------------------------
	call :MountImage "%InstallWim%", %ImageIndexNo%, "%InstallMount%"

	:: Mounting Source Recovery Image Index 1 to Service
	if "%IsRecoveryImageSelected%" equ "Yes" if exist "%InstallMount%\%WinReWim%" (
		echo.-------------------------------------------------------------------------------
		echo.Mounting [WinRE.wim, Index : 1] Image at ^<\Mount\WinRE^>...
		echo.-------------------------------------------------------------------------------
		call :MountImage "%InstallMount%\%WinReWim%", 1, "%WinReMount%"
	)
)
echo.-------------------------------------------------------------------------------
echo.####Finished Selecting ^& Mounting Source Images################################
echo.-------------------------------------------------------------------------------

set "IsSourceSelected=Yes"

:Stop
echo.
echo.===============================================================================
echo.
pause

goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: MSMG Toolkit - Copy Source from DVD Drive to ^<DVD^> folder
::-------------------------------------------------------------------------------------------
:SelectSourceCopy

setlocal

set DriveLetter=

cls
echo.===============================================================================
echo.          MSMG ToolKit - Copy Source from DVD Drive to ^<DVD^> folder
echo.===============================================================================
echo.

:: Checking whether Windows Source DVD folder is empty
if exist "%DVD%\sources\*.wim" (
	echo.Toolkit's Source ^<DVD^> folder is not empty...
	echo.
	choice /C:YN /N /M "Do you want to remove it & continue ? ['Y'es/'N'o] : "
	if errorlevel 2 goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Starting Copying Source from DVD Drive to ^<DVD^> folder#####################
echo.-------------------------------------------------------------------------------
echo.
echo.-------------------------------------------------------------------------------
echo.####Getting DVD Drive Options##################################################
echo.-------------------------------------------------------------------------------
echo.
:: Getting DVD Drive Letter
set /p DriveLetter=Enter DVD Drive Letter : 

:: Setting DVD Drive Letter
set "DriveLetter=%DriveLetter%:"
echo.

:: Checking whether the specified DVD Drive letter is empty
if not exist "%DriveLetter%\sources\boot.wim" (
	echo.Can't find Windows OS Installation files in the specified Drive Letter..
	echo.
	echo.Please enter the correct DVD Drive Letter..
	goto :Stop
)

:: Checking whether the specified DVD Drive Letter is empty
if not exist "%DriveLetter%\sources\install.wim" (
	echo.Can't find Windows OS Installation files in the specified Drive Letter..
	echo.
	echo.Please enter the correct DVD Drive Letter..
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Copying Source from DVD Drive to ^<DVD^> folder##############################
echo.-------------------------------------------------------------------------------
echo.
call :RemoveFolder "%DVD%"
echo.Copying Source from DVD Drive ^<%DriveLetter%^> to Source ^<DVD^> folder...
echo.
echo.Copying from DVD Drive may take some time, so please wait...
%XCopy% %DriveLetter% "%DVD%" >nul
echo.
echo.Copying Complete...
echo.
echo.-------------------------------------------------------------------------------
echo.####Finished Copying Source from DVD Drive to ^<DVD^> folder#####################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set DriveLetter=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: MSMG Toolkit - Extract Source from DVD ISO Image to <DVD> folder
::-------------------------------------------------------------------------------------------
:SelectSourceISO

setlocal

set ISOFileName=

cls
echo.===============================================================================
echo.      MSMG ToolKit - Extract Source from DVD ISO Image to ^<DVD^> folder
echo.===============================================================================
echo.

:: Checking whether Windows Source DVD folder is empty
if exist "%DVD%\sources\*.wim" (
	echo.Toolkit's Source ^<DVD^> folder is not empty...
	echo.
	choice /C:YN /N /M "Do you want to remove it & continue ? ['Y'es/'N'o] : "
	if errorlevel 2 goto :Stop
	echo.
)

:: Checking whether DVD ISO Image folder is empty
if not exist "%ISO%\*.iso" (	
	echo.DVD ISO Image folder ^<ISO^> is empty...
	echo.
	echo.Please copy DVD ISO Images to ^<ISO^> folder...
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Starting Extracting Source from DVD ISO Image to ^<DVD^> folder##############
echo.-------------------------------------------------------------------------------
echo.
echo.-------------------------------------------------------------------------------
echo.####Getting DVD ISO Image Options##############################################
echo.-------------------------------------------------------------------------------
echo.
:: Getting DVD ISO Image file Name
set /p ISOFileName=Enter the ISO Image filename without .iso : 

:: Setting DVD ISO Image file Name
set "ISOFileName=%ISOFileName%.iso"
echo.

:: Checking whether the specified DVD ISO Image file exist
if not exist "%ISO%\%ISOFileName%" (
	echo.Can't find the specified DVD ISO Image in ^<ISO^> folder...
	echo.
	echo.Please enter the correct DVD ISO Image filename...
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Extracting Source from DVD ISO Image to ^<DVD^> folder#######################
echo.-------------------------------------------------------------------------------
echo.
call :RemoveFolder "%DVD%"
echo.Extracting DVD ISO Image contents to Source ^<DVD^> folder...
echo.
echo.Extraction may take some time, so please wait...
%Zip% x -y "%ISO%\%ISOFileName%" -o"%DVD%" >nul
echo.
set /a n=0
if exist "%DVD%\sources\boot.wim" set /a n+=1
if exist "%DVD%\sources\install.wim" set /a n+=1
if exist "%DVD%\sources\install.esd" set /a n+=1
if "%n%" equ "2" (echo.Extraction Complete...) else echo.Extraction Failed...
echo.
echo.-------------------------------------------------------------------------------
echo.####Finished Extracting Source from DVD ISO Image to ^<DVD^> folder##############
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set ISOFileName=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: MSMG Toolkit - Extract Source from OEM IMG Image to <DVD> folder
::-------------------------------------------------------------------------------------------
:SelectSourceIMG

setlocal

set IMGFileName=

cls
echo.===============================================================================
echo.      MSMG ToolKit - Extract Source from OEM IMG Image to ^<DVD^> folder
echo.===============================================================================
echo.

:: Checking whether Windows Source DVD folder is empty
if exist "%DVD%\sources\*.wim" (
	echo.Toolkit's Source ^<DVD^> folder is not empty...
	echo.
	choice /C:YN /N /M "Do you want to remove it & continue ? ['Y'es/'N'o] : "
	if errorlevel 2 goto :Stop
)

:: Checking whether OEM IMG folder is empty
if not exist "%ISO%\*.img" (
	echo.Can't find Windows Install OEM IMG Image file in ^<ISO^> folder...
	echo.
	echo.Please copy Windows Install OEM IMG Image file to ^<ISO^> folder...
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Starting Extracting Source from OEM IMG Image to ^<DVD^> folder##############
echo.-------------------------------------------------------------------------------
echo.
echo.-------------------------------------------------------------------------------
echo.####Getting OEM IMG Image Options##############################################
echo.-------------------------------------------------------------------------------
echo.
:: Getting OEM IMG file Name
set /p IMGFileName=Enter the OEM IMG filename without .img : 

:: Setting OEM IMG file Name
set "IMGFileName=%IMGFileName%.img"
echo.

:: Checking whether the specified OEM IMG Image file exist
if not exist "%ISO%\%IMGFileName%" (
	echo.Can't find the specified OEM IMG Image file...
	echo.
	echo.Please enter the correct OEM IMG Image filename...
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Extracting Source from OEM IMG Image to ^<DVD^> folder#######################
echo.-------------------------------------------------------------------------------
echo.
call :RemoveFolder "%DVD%"
echo.Extracting OEM IMG Image Contents to Source ^<DVD^> folder...
echo.
echo.Extraction may take some time, so please wait...
%Zip% x -y "%ISO%\%IMGFileName%" -o"%DVD%" >nul
echo.
set /a n=0
if exist "%DVD%\sources\boot.wim" set /a n+=1
if exist "%DVD%\sources\install.wim" set /a n+=1
if "%n%" equ "2" (echo.Extraction Complete...) else echo.Extraction Failed...
echo.
echo.-------------------------------------------------------------------------------
echo.####Finished Extracting Source from OEM IMG Image to ^<DVD^> folder##############
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set IMGFileName=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: MSMG Toolkit - Convert Windows 8.1/10 Store ESD Image to WIM Image
::-------------------------------------------------------------------------------------------
:ConvertStoreEsd2Wim

setlocal

set ESDBuild=
set ESDImageCount=
set ESDImageIndex=

cls
echo.===============================================================================
echo.         MSMG ToolKit - Convert Windows Store ESD Image to WIM Image
echo.===============================================================================
echo.

:: Checking whether Windows Source DVD folder is empty
if not exist "%InstallEsd%" (
	echo.Can't find Windows Store ESD Image file "Install.esd" in ^<DVD\Sources^> folder.
	echo.
	echo.Please copy Windows Store ESD Image file to ^<DVD\Sources^> folder...
	goto :Stop
)

:: Finding total no of indexes present inside the ESD Image
for /f "tokens=2 delims=: " %%i in ('%DISM% /Get-WimInfo /WimFile:"%InstallEsd%" ^| findstr /i Index') do (set ESDImageCount=%%i)

echo.-------------------------------------------------------------------------------
echo.####Starting Converting Windows Store ESD Image to WIM Image###################
echo.-------------------------------------------------------------------------------
echo.
echo.Reading Image Information...
echo.
echo.===============================================================================
echo.^|Index^| Arch ^| Name
echo.===============================================================================
for /f "tokens=2 delims=: " %%a in ('%DISM% /Get-WimInfo /WimFile:"%InstallEsd%" ^| findstr /i Index') do (
	for /f "tokens=2 delims=:" %%b in ('%DISM% /Get-WimInfo /WimFile:"%InstallEsd%" /Index:%%a ^| findstr /i Architecture') do (
		for /f "tokens=2 delims=:  " %%c in ('%DISM% /Get-WimInfo /WimFile:"%InstallEsd%" /Index:%%a ^| findstr /i Name') do (
			if %%a equ 1 echo.^|  %%a  ^|  -   ^|%%c
			if %%a gtr 1 if %%a leq 9 echo.^|  %%a  ^|%%b  ^|%%c
			if %%a gtr 9 echo.^|  %%a ^|%%b  ^|%%c
		)
	)
)
echo.===============================================================================
echo.
if "!ESDImageCount!" gtr "4" ( 
	set /p ESDImageIndex=Enter the ESD Image Index's # [Range : 4-!ESDImageCount!, * - All] : 

	if "!ESDImageIndex!" neq "*" if "!ESDImageIndex!" lss "1" (
		echo. 
		echo.Invalid Index # Entered, Valid Range is [4-!ESDImageCount!]
		echo.
		echo.Press Enter to Try Again...
		pause >nul

		goto :ConvertStoreEsd2Wim
	)

	if "!ESDImageIndex!" neq "*" if "!ESDImageIndex!" gtr "!ESDImageCount!" (
		echo. 
		echo.Invalid Index # Entered, Valid Range is [4-!ESDImageCount!]
		echo.
		echo.Press Enter to Try Again...
		pause >nul

		goto :ConvertStoreEsd2Wim
	)

	echo.
)
echo.-------------------------------------------------------------------------------
echo.####Converting Windows Store ESD Image to WIM Image############################
echo.-------------------------------------------------------------------------------
echo.
echo.Decrypting Windows Store ESD Image if it's been encrypted...
attrib -r -h -s -a "%InstallEsd%" >nul
for /f "skip=1 tokens=4 delims=:." %%e in ('%DISM% /Get-WimInfo /WimFile:"%InstallEsd%" /Index:4 ^| find /i "Version"') do set ESDBuild=%%e
if "%ESDBuild%" equ "9600" %W81EsdDecrypter% "%InstallEsd%" 2>nul
if "%ESDBuild%" gtr "9600" %W10EsdDecrypter% "%InstallEsd%" >nul
echo.
:: Creating Temporary Boot and Install Images
echo.Creating Temporary Container Images...
call :RemoveFolder "%Temp%\ESD"
call :CreateFolder "%Temp%\ESD"
call :CaptureImage "%BootWim%", "%Temp%\ESD", "BootWim", "BootWim", "No" >nul

call :RemoveFolder "%Temp%\ESD"
call :CreateFolder "%Temp%\ESD"
call :CaptureImage "%InstallWim%", "%Temp%\ESD", "InstallWim", "InstallWim", "No" >nul
call :RemoveFolder "%Temp%\ESD"
echo.
echo.-------------------------------------------------------------------------------
echo.Applying Windows Store ESD Image [Install.esd, Index : 1] to ^<Temp\DVD^>...
echo.-------------------------------------------------------------------------------
:: Creating Windows Setup Installation Media folder "%Temp%\DVD"
call :RemoveFolder "%Temp%\DVD"
call :CreateFolder "%Temp%\DVD"
call :ApplyImage "%InstallEsd%", 1, "%Temp%\DVD"
move /y "%DVD%\sources\*.wim" "%Temp%\DVD\sources" >nul
echo.-------------------------------------------------------------------------------
echo.Exporting Windows Store ESD Image [Install.esd, Index : 2] to Boot Image...
echo.-------------------------------------------------------------------------------
call :ExportImageIndex "%InstallEsd%", 2, "%Temp%\DVD\sources\boot.wim", "WIM", "Yes"
call :DeleteImage "%Temp%\DVD\sources\boot.wim", 1 >nul
echo.-------------------------------------------------------------------------------
echo.Exporting Windows Store ESD Image [Install.esd, Index : 3] to Boot Image...
echo.-------------------------------------------------------------------------------
call :ExportImageIndex "%InstallEsd%", 3, "%Temp%\DVD\sources\boot.wim", "WIM", "Yes"

if "%ESDBuild%" equ "9600" (
	echo.-------------------------------------------------------------------------------
	echo.Exporting Windows Store ESD Image [Install.esd, Index : 4] to Install Image
	echo.-------------------------------------------------------------------------------
	call :ExportImageIndex "%InstallEsd%", 4, "%Temp%\DVD\sources\install.wim", "WIM", "No"
)

if "%ESDBuild%" gtr "9600" (
	if "%ESDImageIndex%" neq "*" (
		echo.-------------------------------------------------------------------------------
		echo.Exporting Windows Store ESD Image [Install.esd, Index : %ESDImageIndex%] to Install Image
		echo.-------------------------------------------------------------------------------
		call :ExportImageIndex "%InstallEsd%", %ESDImageIndex%, "%Temp%\DVD\sources\install.wim", "WIM", "No"
	) else (
		for /l %%i in (3, 1, %ESDImageCount%) do (
			echo.-------------------------------------------------------------------------------
			echo.Exporting Windows Store ESD Image [Install.esd, Index : %%i] to Install Image
			echo.-------------------------------------------------------------------------------
			call :ExportImageIndex "%InstallEsd%", %%i, "%Temp%\DVD\sources\install.wim", "WIM", "No"
		)
	)
)

:: Deleting the First Empty Index
call :DeleteImage "%Temp%\DVD\sources\install.wim", 1 >nul

:: Moving ESD to WIM converted folder <Temp\DVD> to <DVD> Source Folder
call :RemoveFolder "%DVD%"
move /y "%Temp%\DVD" "%ROOT%" >nul

echo.-------------------------------------------------------------------------------
echo.####Copying EI.CFG Config file to Source ^<DVD\sources^> folder##################
echo.-------------------------------------------------------------------------------
echo.
:: Getting Install Image Index Edition
call :GetImageEdition "%InstallWim%", 1

:: Writing EI.cfg Config file to <DVD\sources> folder
echo.Copying EI.CFG file to ^<DVD\sources^> folder...
if exist "%DVD%\sources\EI.CFG" del /f /q "%DVD%\sources\EI.CFG" >nul
(
	echo.[EditionID]
	if "%ESDImageIndex%" neq "*" echo.%ImageEdition%
	if "%ESDImageIndex%" equ "*" echo.
	echo.
	echo.[Channel]
	echo.Retail
	echo.
	echo.[VL]
	echo.0
	echo.
)>"%DVD%\sources\EI.CFG"

:: Cleaning Up Unwanted files from Source folder
call :RemoveFile "%DVD%\MediaMeta.xml"
echo.
echo.-------------------------------------------------------------------------------
echo.####Finished Converting Windows Store ESD Image to WIM Image###################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set ESDBuild=
set ESDImageCount=
set ESDImageIndex=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: MSMG Toolkit - Convert Windows Install ESD Image to WIM Image
::-------------------------------------------------------------------------------------------
:ConvertEsd2Wim

setlocal

set ESDImageIndex=
set ESDImageCount=

cls
echo.===============================================================================
echo.        MSMG ToolKit - Convert Windows Install ESD Image to WIM Image
echo.===============================================================================
echo.

:: Checking whether Windows Source Boot Image exist
if not exist "%BootWim%" (
	echo.Can't find Windows Setup "Boot.wim" Image in ^<DVD\Sources^> folder...
	echo.
	echo.Please copy Windows Setup "Boot.wim" Image to ^<DVD\Sources^> folder...
	goto :Stop
)

:: Checking whether Windows Source Install ESD Image exist
if not exist "%InstallEsd%" (
	echo.Can't find Windows Setup "Install.esd" Image in ^<DVD\Sources^> folder...
	echo.
	echo.Please copy Windows Setup "Install.esd" Image to ^<DVD\Sources^> folder...
	goto :Stop
)

:: Finding total no of indexes present inside the ESD Image
for /f "tokens=2 delims=: " %%i in ('%DISM% /Get-WimInfo /WimFile:"%InstallEsd%" ^| findstr /i Index') do (set ESDImageCount=%%i)

echo.-------------------------------------------------------------------------------
echo.####Starting Converting Windows Install ESD Image to WIM Image#################
echo.-------------------------------------------------------------------------------
echo.
echo.Reading Windows Install ESD Image Information...
echo.
echo.===============================================================================
echo.^|Index^| Arch ^| Name
echo.===============================================================================
for /f "tokens=2 delims=: " %%a in ('%DISM% /Get-WimInfo /WimFile:"%InstallEsd%" ^| findstr /i Index') do (
	for /f "tokens=2 delims=:" %%b in ('%DISM% /Get-WimInfo /WimFile:"%InstallEsd%" /Index:%%a ^| findstr /i Architecture') do (
		for /f "tokens=2 delims=:  " %%c in ('%DISM% /Get-WimInfo /WimFile:"%InstallEsd%" /Index:%%a ^| findstr /i Name') do (
			if %%a leq 9 echo.^|  %%a  ^|%%b  ^|%%c
			if %%a gtr 9 echo.^|  %%a ^|%%b  ^|%%c
		)
	)
)
echo.===============================================================================
echo.
if "!ESDImageCount!" equ "1" ( 
	set /p ESDImageIndex=Enter the ESD Image Index # : 
) else set /p ESDImageIndex=Enter the ESD Image Index's # [Range : 1-!ESDImageCount!, * - All] : 

if "!ESDImageIndex!" neq "*" if "!ESDImageIndex!" lss "1" (
	echo. 
	echo.Invalid Index # Entered, Valid Range is [1-!ESDImageCount!]
	echo.
	echo.Press Enter to Try Again...
	pause >nul

	goto :ConvertEsd2Wim
)

if "!ESDImageIndex!" neq "*" if "!ESDImageIndex!" gtr "!ESDImageCount!" (
	echo. 
	echo.Invalid Index # Entered, Valid Range is [1-!ESDImageCount!]
	echo.
	echo.Press Enter to Try Again...
	pause >nul

	goto :ConvertEsd2Wim
)
echo.
echo.-------------------------------------------------------------------------------
echo.####Converting Windows Install ESD Image to WIM Image##########################
echo.-------------------------------------------------------------------------------

:: Creating Temporary Boot and Install Images
call :RemoveFolder "%Temp%\ESD"
call :CreateFolder "%Temp%\ESD"

call :CaptureImage "%InstallWim%", "%Temp%\ESD", "InstallWim", "InstallWim", "No" >nul
call :RemoveFolder "%Temp%\ESD"

:: Converting Windows Install ESD Image to WIM Image
if "%ESDImageIndex%" equ "*" call :ExportImage "%InstallEsd%", "%InstallWim%", "WIM", "No"	
if "%ESDImageIndex%" neq "*" call :ExportImageIndex "%InstallEsd%", %ESDImageIndex%, "%InstallWim%", "WIM", "No"

:: Deleting converted Windows Install WIM Image Index 1 which is an empty Index
call :DeleteImage "%InstallWim%", 1 >nul

:: Deleting original Windows Install ESD Image
call :RemoveFile "%InstallEsd%"

echo.-------------------------------------------------------------------------------
echo.####Finished Converting Windows Install ESD Image to WIM Image#################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set ESDImageIndex=
set ESDImageCount=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: MSMG Toolkit - Convert Windows Media Creation Tool Image to WIM Image
::-------------------------------------------------------------------------------------------
:ConvertMCT2Wim

setlocal

cls
echo.===============================================================================
echo.    MSMG ToolKit - Convert Windows Media Creation Tool Image to WIM Image
echo.===============================================================================
echo.

:: Checking whether Windows Source Boot Image exist
if not exist "%BootWim%" (
	echo.Can't find Windows Setup "Boot.wim" Image in ^<DVD\Sources^> folder...
	echo.
	echo.Please copy Windows Setup "Boot.wim" Image to ^<DVD\Sources^> folder...
	goto :Stop
)

:: Checking whether Windows Source Install Image exist
if not exist "%InstallEsd%" (
	echo.Can't find Windows Setup "Install.esd" Image in ^<DVD\Sources^> folder...
	echo.
	echo.Please copy Windows Setup "Install.esd" Image to ^<DVD\Sources^> folder...
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Starting Converting Windows Media Creation Tool Image to WIM Image#########
echo.-------------------------------------------------------------------------------

:: Exporting Microsoft Windows Media Creation Tool created Install.wim to New Image
call :ExportImageIndex "%InstallEsd%", 1, "%DVD%\sources\install1.wim", "WIM", "No"

:: Deleting Microsoft Windows Media Creation Tool created Install.wim
call :RemoveFile "%InstallEsd%"

:: Renaming newly created Image to Install.wim
move /y "%DVD%\sources\install1.wim" %InstallWim% >nul

echo.-------------------------------------------------------------------------------
echo.####Finished Converting Windows Media Creation Tool Image to WIM Image#########
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: MSMG Toolkit - Convert Source WIM Image to ESD Image
::-------------------------------------------------------------------------------------------
:ConvertWim2ESD

cls
echo.===============================================================================
echo.           MSMG ToolKit - Convert Source WIM Image to ESD Image
echo.===============================================================================
echo.

:: Checking whether Windows Source Boot Image exist
if not exist "%BootWim%" (
	echo.Can't find Windows Setup "Boot.wim" Image in ^<DVD\Sources^> folder...
	echo.
	echo.Please copy Windows Setup "Boot.wim" Image to ^<DVD\Sources^> folder...
	goto :Stop
)

:: Checking whether Windows Source Install Image exist
if not exist "%InstallWim%" (
	echo.Can't find Windows Setup "Install.wim" Image in ^<DVD\Sources^> folder...
	echo.
	echo.Please copy Windows Setup "Install.wim" Image to ^<DVD\Sources^> folder...
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Starting Converting Source WIM Image to ESD Image##########################
echo.-------------------------------------------------------------------------------

:: Getting Image Index Number to Service
call :GetImageIndexNo "!InstallWim!"

if "!ImageIndexNo!" neq "*" if "!ImageIndexNo!" lss "1" (
	echo.
	echo.Invalid Index # Entered, Valid Range is [1-!ImageCount!]
	echo.
	echo.Press Enter to Try Again...
	pause >nul

	goto :SelectSourceDVD
)

if "!ImageIndexNo!" neq "*" if "!ImageIndexNo!" gtr "!ImageCount!" (
	echo.
	echo.Invalid Index # Entered, Valid Range is [1-!ImageCount!]
	echo.
	echo.Press Enter to Try Again...
	pause >nul

	goto :SelectSourceDVD
)
echo.
echo.-------------------------------------------------------------------------------
echo.####Converting Source WIM Image to ESD Image###################################
echo.-------------------------------------------------------------------------------

:: Exporting Source Image to ESD Image
if "%ImageIndexNo%" equ "*" call :ExportImage "%InstallWim%", "%InstallEsd%", "ESD", "No"
if "%ImageIndexNo%" neq "*" call :ExportImageIndex "%InstallWim%", %ImageIndexNo%, "%InstallEsd%", "ESD", "No"

:: Deleting Source Image File
call :RemoveFile "%InstallWim%"

echo.-------------------------------------------------------------------------------
echo.####Finished Converting Source WIM Image to ESD Image##########################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Windows Language Packs
::-------------------------------------------------------------------------------------------
:IntLanguagePacks

if "%IsDialogsEnabled%" equ "Yes" (
	cls
	echo.===============================================================================
	echo.               MSMG ToolKit - Integrate Windows Language Packs
	echo.===============================================================================
	echo.
	echo.
	echo.
	echo.                                W A R N I N G
	echo.                                =============
	echo.
	echo.   Do not integrate a language pack after an update. If you integrate any
	echo.   updates ^(Hotfix, General Distribution Release [GDR], Zero Day Patch [ZDP]
	echo.   or Service Pack [SP]^) that contains language-dependent resources before
	echo.   you integrate a language pack, The language-specific changes that are 
	echo.   contained in the update are not applied and you will have to re-integrate
	echo.   the update. Always integrate language packs before you integrate updates. 
	echo.
	echo.
	echo.
	echo.
	echo.   To turn off Warning Dialogs, Choose Disable Dialogs in Tools-^>Options Menu
	echo.
	echo.===============================================================================
	echo.
	choice /C:YN /N /M "Do you want to Continue ? ['Y'es/'N'o] : "
	if errorlevel 2 goto :IntegrateMenu
)

setlocal

set LanguagePackType=
set LanguagePackCode=

cls
echo.===============================================================================
echo.             MSMG ToolKit - Integrate Windows Language Packs Menu
echo.===============================================================================
echo.
echo.  [1]   Integrate to Windows Setup Boot Image
echo.
echo.  [2]   Integrate to Windows Installation Image
echo.
echo.  [3]   Integrate to Windows Recovery Image
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.  [X]   Go Back
echo.
echo.===============================================================================
echo.
choice /C:123X /N /M "Enter Your Choice : "
if errorlevel 4 goto :IntegrateMenu
if errorlevel 3 set LanguagePackType=Recovery
if errorlevel 2 set LanguagePackType=Install
if errorlevel 1 set LanguagePackType=Boot

cls
echo.===============================================================================
echo.             MSMG ToolKit - Integrate Windows Language Packs Menu
echo.===============================================================================
echo.
if "%LanguagePackType%" equ "Boot" if "%IsBootImageSelected%" equ "No" (
	echo.Windows Setup Boot Image is not selected...
	echo.
	echo.Please choose Windows Setup Boot Image while selecting Source...
	goto :Stop	
)

if "%LanguagePackType%" equ "Recovery" if "%IsRecoveryImageSelected%" equ "No" (
	echo.Windows Recovery Image is not selected...
	echo.
	echo.Please choose Windows Recovery Image while selecting Source...
	goto :Stop	
)

cls
echo.===============================================================================
echo.    MSMG ToolKit - Integrate Windows Language Packs - Choose Language Menu
echo.===============================================================================
if "%SelectedSourceOS%" equ "w7" (
	echo. Arabic - Saudi Arabia    [ar-SA]    Latvian - Latvia         [lv-LV]
	echo. Bulgarian - Bulgaria     [bg-BG]    Lithuanian - Lithuania   [lt-LT]
	echo. Chinese - Hong Kong SAR  [zh-HK]    Norwegian - Norway       [nb-NO]
	echo. Chinese - Simplified     [zh-CN]    Polish - Poland          [pl-PL]
	echo. Chinese - Taiwan         [zh-TW]    Portuguese - Brazil      [pt-BR]
	echo. Croatian - Croatia       [hr-HR]    Portuguese - Portugal    [pt-PT]
	echo. Czech - Czech Republic   [cs-CZ]    Romanian - Romania       [ro-RO]
	echo. Danish - Denmark         [da-DK]    Russian - Russia         [ru-RU]
	echo. Dutch - The Netherlands  [nl-NL]    Serbian - Serbia         [sr-Latn-CS]
	echo. English - United States  [en-US]    Slovak - Slovakia        [sk-SK]
	echo. Estonian - Estonia       [et-EE]    Slovenian - Slovenia     [sl-SI]
	echo. Finnish - Finland        [fi-FI]    Spanish - Spain          [es-ES]
	echo. French - France          [fr-FR]    Swedish - Sweden         [sv-SE]
	echo. German - Germany         [de-DE]    Thai - Thailand          [th-TH]
	echo. Greek - Greece           [el-GR]    Turkish - Turkey         [tr-TR]
	echo. Hebrew - israel          [he-IL]    Ukrainian - Ukraine      [uk-UA]
	echo. Hungarian - Hungary      [hu-HU]    
	echo. Italian - Italy          [it-IT]    
	echo. Japanese - Japan         [ja-JP]
	echo. Korean - Korea           [ko-KR]   [X] Go-Back 
)

if "%SelectedSourceOS%" equ "w81" (
	echo. Arabic - Saudi Arabia    [ar-SA]    Korean - Korea           [ko-KR]
	echo. Bulgarian - Bulgaria     [bg-BG]    Latvian - Latvia         [lv-LV]
	echo. Chinese - Hong Kong SAR  [zh-HK]    Lithuanian - Lithuania   [lt-LT]
	echo. Chinese - Simplified     [zh-CN]    Norwegian - Norway       [nb-NO]
	echo. Chinese - Taiwan         [zh-TW]    Polish - Poland          [pl-PL]
	echo. Croatian - Croatia       [hr-HR]    Portuguese - Brazil      [pt-BR]
	echo. Czech - Czech Republic   [cs-CZ]    Portuguese - Portugal    [pt-PT]
	echo. Danish - Denmark         [da-DK]    Romanian - Romania       [ro-RO]
	echo. Dutch - The Netherlands  [nl-NL]    Russian - Russia         [ru-RU]
	echo. English - United Kingdom [en-GB]    Serbian - Serbia         [sr-Latn-CS]
	echo. English - United States  [en-US]    Slovak - Slovakia        [sk-SK]
	echo. Estonian - Estonia       [et-EE]    Slovenian - Slovenia     [sl-SI]
	echo. Finnish - Finland        [fi-FI]    Spanish - Spain          [es-ES]
	echo. French - France          [fr-FR]    Swedish - Sweden         [sv-SE]
	echo. German - Germany         [de-DE]    Thai - Thailand          [th-TH]
	echo. Greek - Greece           [el-GR]    Turkish - Turkey         [tr-TR]
	echo. Hebrew - israel          [he-IL]    Ukrainian - Ukraine      [uk-UA]
	echo. Hungarian - Hungary      [hu-HU]    
	echo. Italian - Italy          [it-IT]    
	echo. Japanese - Japan         [ja-JP]	  [X] Go-Back
)

if "%SelectedSourceOS%" equ "w10" (
	echo. Arabic - Saudi Arabia    [ar-SA]    Japanese - Japan         [ja-JP]
	echo. Bulgarian - Bulgaria     [bg-BG]    Korean - Korea           [ko-KR]
	echo. Chinese - Hong Kong SAR  [zh-HK]    Latvian - Latvia         [lv-LV]
	echo. Chinese - Simplified     [zh-CN]    Lithuanian - Lithuania   [lt-LT]
	echo. Chinese - Taiwan         [zh-TW]    Norwegian - Norway       [nb-NO]
	echo. Croatian - Croatia       [hr-HR]    Polish - Poland          [pl-PL]
	echo. Czech - Czech Republic   [cs-CZ]    Portuguese - Brazil      [pt-BR]
	echo. Danish - Denmark         [da-DK]    Portuguese - Portugal    [pt-PT]
	echo. Dutch - The Netherlands  [nl-NL]    Romanian - Romania       [ro-RO]
	echo. English - United Kingdom [en-GB]    Russian - Russia         [ru-RU]
	echo. English - United States  [en-US]    Serbian - Serbia         [sr-Latn-RS]
	echo. Estonian - Estonia       [et-EE]    Slovak - Slovakia        [sk-SK]
	echo. Finnish - Finland        [fi-FI]    Slovenian - Slovenia     [sl-SI]
	echo. French - Canada          [fr-CA]    Spanish - Mexico         [es-MX]
	echo. French - France          [fr-FR]    Spanish - Spain          [es-ES]
	echo. German - Germany         [de-DE]    Swedish - Sweden         [sv-SE]
	echo. Greek - Greece           [el-GR]    Thai - Thailand          [th-TH]
	echo. Hebrew - israel          [he-IL]    Turkish - Turkey         [tr-TR]
	echo. Hungarian - Hungary      [hu-HU]    Ukrainian - Ukraine      [uk-UA]
	echo. Italian - Italy          [it-IT]    [X] Go-Back
)
echo.===============================================================================
set /p LanguagePackCode=Enter Language Code without '[' ']' : 

if /i "%LanguagePackCode%" equ "X" goto :IntegrateMenu

cls
echo.===============================================================================
if "%LanguagePackType%" equ "Boot" echo.  MSMG ToolKit - Integrate Windows Language Packs to Windows Setup Boot Image
if "%LanguagePackType%" equ "Install" echo. MSMG ToolKit - Integrate Windows Language Packs to Windows Installation Image
if "%LanguagePackType%" equ "Recovery" echo.   MSMG ToolKit - Integrate Windows Language Packs to Windows Recovery Image
echo.===============================================================================
echo.
:: Getting Source Image Index Architecture
if "%LanguagePackType%" equ "Boot" call :GetImageArchitecture "%BootWim%", 1 >nul
if "%LanguagePackType%" equ "Recovery" (
	if "%ImageIndexNo%" equ "*" call :GetImageArchitecture "%InstallMount%\1\%WinReWim%", 1 >nul
	if "%ImageIndexNo%" neq "*" call :GetImageArchitecture "%InstallMount%\%WinReWim%", 1 >nul
)
if "%LanguagePackType%" equ "Install" (
	if "%ImageIndexNo%" equ "*" call :GetImageArchitecture "%InstallWim%", 1 >nul
	if "%ImageIndexNo%" neq "*" call :GetImageArchitecture "%InstallWim%", %ImageIndexNo% >nul
)

:: Settings Windows Language Packs folder path
if "%SelectedSourceOS%" neq "w10" set "LanguagePacks=%LanguagePacks%\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%"
if "%SelectedSourceOS%" equ "w10" set "LanguagePacks=%LanguagePacks%\%SelectedSourceOS%\10.0.%ImageBuild%\%ImageArchitecture%\%LanguagePackCode%"

:: Setting Package Service Pack Build Version
if "%SelectedSourceOS%" equ "w7" set "PackageServicePackBuild=17514"
if "%SelectedSourceOS%" equ "w81" set "PackageServicePackBuild=16384"
if "%SelectedSourceOS%" equ "w10" (
	if "%ImageBuild%" equ "10240" set "PackageServicePackBuild=16384"
	if "%ImageBuild%" equ "10586" set "PackageServicePackBuild=0"
	if "%ImageBuild%" equ "14393" set "PackageServicePackBuild=0"
	if "%ImageBuild%" equ "15063" set "PackageServicePackBuild=0"
	if "%ImageBuild%" equ "16299" set "PackageServicePackBuild=15"
	if "%ImageBuild%" equ "17134" set "PackageServicePackBuild=1"
	if "%ImageBuild%" equ "17763" set "PackageServicePackBuild=1"
	if "%ImageBuild%" equ "18362" set "PackageServicePackBuild=1"
	if "%ImageBuild%" equ "18363" set "PackageServicePackBuild=1"
	if "%ImageBuild%" equ "19041" set "PackageServicePackBuild=1"
)

:: Setting Package Architecture
if "%ImageArchitecture%" equ "x86" set "PackageArchitecture=x86"
if "%ImageArchitecture%" equ "x64" set "PackageArchitecture=amd64"
if "%ImageArchitecture%" equ "arm" set "PackageArchitecture=arm"
if "%ImageArchitecture%" equ "arm64" set "PackageArchitecture=arm64"

:: Checking whether Windows PE Language Packs folder is empty
if "%LanguagePackType%" equ "Boot" (
	if "%SelectedSourceOS%" equ "w7" if not exist "%LanguagePacks%\Microsoft-Windows-WinPE-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."Microsoft-Windows-WinPE-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop	
	)
	if "%SelectedSourceOS%" equ "w7" if not exist "%LanguagePacks%\WinPE-Scripting-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-Scripting-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop	
	)
	if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType:~,6%" neq "Server" if not exist "%LanguagePacks%\WinPE-Setup-Client-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-Setup-Client-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType:~,6%" equ "Server" if not exist "%LanguagePacks%\WinPE-Setup-Server-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-Setup-Server-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop	
	)
	if "%SelectedSourceOS%" equ "w7" if not exist "%LanguagePacks%\WinPE-Setup-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-Setup-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop	
	)
	if "%SelectedSourceOS%" equ "w7" if not exist "%LanguagePacks%\WinPE-SRT-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-SRT-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop	
	)
	if "%SelectedSourceOS%" equ "w7" if not exist "%LanguagePacks%\WinPE-WDS-Tools-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-WDS-Tools-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop	
	)
	if "%SelectedSourceOS%" equ "w7" if not exist "%LanguagePacks%\WinPE-WMI-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-WMI-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop	
	)
	if "%SelectedSourceOS%" equ "w81" if not exist "%LanguagePacks%\Microsoft-Windows-WinPE-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."Microsoft-Windows-WinPE-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop	
	)
	if "%SelectedSourceOS%" equ "w81" if not exist "%LanguagePacks%\WinPE-EnhancedStorage-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-EnhancedStorage-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop	
	)
	if "%SelectedSourceOS%" equ "w81" if "%PackageArchitecture%" neq "arm" if not exist "%LanguagePacks%\WinPE-Rejuv-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-Rejuv-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop	
	)
	if "%SelectedSourceOS%" equ "w81" if not exist "%LanguagePacks%\WinPE-Scripting-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-Scripting-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop	
	)
	if "%SelectedSourceOS%" equ "w81" if not exist "%LanguagePacks%\WinPE-SecureStartup-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-SecureStartup-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop	
	)
	if "%SelectedSourceOS%" equ "w81" if "%ImageInstallationType:~,6%" neq "Server" if not exist "%LanguagePacks%\WinPE-Setup-Client-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-Setup-Client-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop	
	)
	if "%SelectedSourceOS%" equ "w81" if "%ImageInstallationType:~,6%" equ "Server" if not exist "%LanguagePacks%\WinPE-Setup-Server-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-Setup-Server-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop	
	)
	if "%SelectedSourceOS%" equ "w81" if not exist "%LanguagePacks%\WinPE-Setup-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-Setup-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop	
	)
	if "%SelectedSourceOS%" equ "w81" if not exist "%LanguagePacks%\WinPE-SRT-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-SRT-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop	
	)
	if "%SelectedSourceOS%" equ "w81" if "%PackageArchitecture%" neq "arm" if not exist "%LanguagePacks%\WinPE-StorageWMI-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-StorageWMI-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop	
	)
	if "%SelectedSourceOS%" equ "w81" if not exist "%LanguagePacks%\WinPE-WDS-Tools-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-WDS-Tools-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop	
	)
	if "%SelectedSourceOS%" equ "w81" if not exist "%LanguagePacks%\WinPE-WMI-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-WMI-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop	
	)
	if "%SelectedSourceOS%" equ "w10" if not exist "%LanguagePacks%\Microsoft-Windows-WinPE-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."Microsoft-Windows-WinPE-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%ImageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "15063" if not exist "%LanguagePacks%\WinPE-ATBroker-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-ATBroker-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%ImageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "15063" if not exist "%LanguagePacks%\WinPE-AudioCore-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-AudioCore-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%ImageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "15063" if not exist "%LanguagePacks%\WinPE-AudioDrivers-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-AudioDrivers-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%ImageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if not exist "%LanguagePacks%\WinPE-EnhancedStorage-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-EnhancedStorage-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%ImageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "15063" if not exist "%LanguagePacks%\WinPE-Narrator-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-Narrator-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%ImageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop	
	)
	if "%SelectedSourceOS%" equ "w10" if not exist "%LanguagePacks%\WinPE-Scripting-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-Scripting-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%ImageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if not exist "%LanguagePacks%\WinPE-SecureStartup-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-SecureStartup-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%ImageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if "%ImageInstallationType:~,6%" neq "Server" if not exist "%LanguagePacks%\WinPE-Setup-Client-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-Setup-Client-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%ImageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if "%ImageInstallationType:~,6%" equ "Server" if not exist "%LanguagePacks%\WinPE-Setup-Server-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-Setup-Server-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%ImageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if not exist "%LanguagePacks%\WinPE-Setup-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-Setup-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%ImageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "15063" if "%ImageBuild%" leq "17134" (
		for /d %%i in (de-DE, en-GB, en-IN, es-ES, es-MX, fr-CA, fr-FR, it-IT, ja-JP, ko-KR, pl-PL, pt-BR, pt-PT, ru-RU, zh-CN, zh-HK, zh-TW) do (
			if "%LanguagePackCode%" equ "%%i" if not exist "%LanguagePacks%\WinPE-Speech-TTS-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab" (
				echo.Windows Language Pack folder is missing the below file...
				echo.
				echo."WinPE-Speech-TTS-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab"
				echo.
				echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%ImageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
				goto :Stop
			)
		)
	)
	if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "15063" if not exist "%LanguagePacks%\WinPE-Speech-TTS-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-Speech-TTS-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%ImageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "15063" if not exist "%LanguagePacks%\WinPE-SRH-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-SRH-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%ImageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if not exist "%LanguagePacks%\WinPE-SRT-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-SRT-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%ImageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if not exist "%LanguagePacks%\WinPE-WDS-Tools-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-WDS-Tools-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%ImageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if not exist "%LanguagePacks%\WinPE-WMI-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-WMI-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%ImageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
)

:: Checking whether Windows Language or Language Features Packs folder is empty
if "%LanguagePackType%" equ "Install" (
	if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType%" equ "Client" if not exist "%LanguagePacks%\Microsoft-Windows-Client-Refresh-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."Microsoft-Windows-Client-Refresh-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType%" equ "Embedded" if not exist "%LanguagePacks%\Microsoft-Windows-Embedded-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."Microsoft-Windows-Embedded-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType:~,6%" equ "Server" if not exist "%LanguagePacks%\Microsoft-Windows-Server-Refresh-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."Microsoft-Windows-Server-Refresh-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w81" if "%ImageInstallationType:~,6%" neq "Server" if not exist "%LanguagePacks%\Microsoft-Windows-Client-Refresh-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."Microsoft-Windows-Client-Refresh-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w81" if "%ImageInstallationType:~,6%" equ "Server" if not exist "%LanguagePacks%\Microsoft-Windows-Server-Refresh-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."Microsoft-Windows-Server-Refresh-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if "%ImageInstallationType%" equ "Client" if not exist "%LanguagePacks%\Microsoft-Windows-Client-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."Microsoft-Windows-Client-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%ImageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if "%ImageInstallationType:~,6%" equ "Server" if not exist "%LanguagePacks%\Microsoft-Windows-Server-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."Microsoft-Windows-Server-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%ImageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
)

:: Checking whether Windows PE Language Packs folder is empty
if "%LanguagePackType%" equ "Recovery" (
	if "%SelectedSourceOS%" equ "w7" if not exist "%LanguagePacks%\Microsoft-Windows-WinPE-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."Microsoft-Windows-WinPE-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w7" if not exist "%LanguagePacks%\WinPE-Scripting-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-Scripting-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w7" if not exist "%LanguagePacks%\WinPE-Setup-Client-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-Setup-Client-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w7" if not exist "%LanguagePacks%\WinPE-Setup-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-Setup-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w7" if not exist "%LanguagePacks%\WinPE-SRT-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-SRT-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w7" if not exist "%LanguagePacks%\WinPE-WDS-Tools-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-WDS-Tools-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w7" if not exist "%LanguagePacks%\WinPE-WMI-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-WMI-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w81" if not exist "%LanguagePacks%\Microsoft-Windows-WinPE-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."Microsoft-Windows-WinPE-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w81" if not exist "%LanguagePacks%\WinPE-EnhancedStorage-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-EnhancedStorage-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w81" if not exist "%LanguagePacks%\WinPE-Rejuv-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-Rejuv-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)	
	if "%SelectedSourceOS%" equ "w81" if not exist "%LanguagePacks%\WinPE-Scripting-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-Scripting-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w81" if not exist "%LanguagePacks%\WinPE-SecureStartup-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-SecureStartup-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)	
	if "%SelectedSourceOS%" equ "w81" if "%PackageArchitecture%" neq "arm" if "%ImageInstallationType:~,6%" neq "Server" if not exist "%LanguagePacks%\WinPE-Setup-Client-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-Setup-Client-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w81" if "%ImageInstallationType:~,6%" equ "Server" if not exist "%LanguagePacks%\WinPE-Setup-Server-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-Setup-Server-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w81" if "%PackageArchitecture%" neq "arm" if not exist "%LanguagePacks%\WinPE-Setup-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-Setup-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w81" if not exist "%LanguagePacks%\WinPE-SRT-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-SRT-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w81" if not exist "%LanguagePacks%\WinPE-StorageWMI-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-StorageWMI-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w81" if not exist "%LanguagePacks%\WinPE-WDS-Tools-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-WDS-Tools-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w81" if not exist "%LanguagePacks%\WinPE-WMI-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-WMI-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if not exist "%LanguagePacks%\Microsoft-Windows-WinPE-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."Microsoft-Windows-WinPE-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%ImageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "17134" if not exist "%LanguagePacks%\WinPE-AppxPackaging-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-AppxPackaging-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%ImageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop	
	)	
	if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "15063" if not exist "%LanguagePacks%\WinPE-ATBroker-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-ATBroker-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%ImageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "15063" if not exist "%LanguagePacks%\WinPE-AudioCore-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-AudioCore-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%ImageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "15063" if not exist "%LanguagePacks%\WinPE-AudioDrivers-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-AudioDrivers-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%ImageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if not exist "%LanguagePacks%\WinPE-EnhancedStorage-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-EnhancedStorage-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%ImageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if not exist "%LanguagePacks%\WinPE-HTA-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-HTA-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%ImageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "15063" if not exist "%LanguagePacks%\WinPE-Narrator-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-Narrator-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%ImageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop	
	)
	if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "17134" if not exist "%LanguagePacks%\WinPE-OpcServices-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-OpcServices-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%ImageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if not exist "%LanguagePacks%\WinPE-Rejuv-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-Rejuv-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%ImageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if not exist "%LanguagePacks%\WinPE-Scripting-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-Scripting-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%ImageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if not exist "%LanguagePacks%\WinPE-SecureStartup-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-SecureStartup-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%ImageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "15063" if "%ImageBuild%" leq "17134" (
		for /d %%i in (de-DE, en-GB, en-IN, es-ES, es-MX, fr-CA, fr-FR, it-IT, ja-JP, ko-KR, pl-PL, pt-BR, pt-PT, ru-RU, zh-CN, zh-HK, zh-TW) do (
			if "%LanguagePackCode%" equ "%%i" if not exist "%LanguagePacks%\WinPE-Speech-TTS-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab" (
				echo.Windows Language Pack folder is missing the below file...
				echo.
				echo."WinPE-Speech-TTS-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab"
				echo.
				echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%ImageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
				goto :Stop
			)
		)
	)
	if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "15063" if not exist "%LanguagePacks%\WinPE-Speech-TTS-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-Speech-TTS-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%ImageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "15063" if not exist "%LanguagePacks%\WinPE-SRH-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-SRH-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%ImageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if not exist "%LanguagePacks%\WinPE-SRT-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-SRT-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%ImageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if not exist "%LanguagePacks%\WinPE-StorageWMI-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-StorageWMI-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%ImageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if not exist "%LanguagePacks%\WinPE-WDS-Tools-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-WDS-Tools-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%ImageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "14393" if not exist "%LanguagePacks%\WinPE-WiFi-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-WiFi-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%ImageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if not exist "%LanguagePacks%\WinPE-WMI-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-WMI-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%ImageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
)
echo.-------------------------------------------------------------------------------
if "%LanguagePackType%" equ "Boot" echo.####Starting Integrating Windows Language Packs to Windows Boot Image##########
if "%LanguagePackType%" equ "Install" echo.####Starting Integrating Windows Language Packs to Windows Installation Image##
if "%LanguagePackType%" equ "Recovery" echo.####Starting Integrating Windows Language Packs to Windows Reocvery Image######
echo.-------------------------------------------------------------------------------
echo.
if "%LanguagePackType%" equ "Boot" (
	echo.    Image                    : Boot.wim
	echo.    Image Index              : 1, 2
	echo.    Image Architecture       : %ImageArchitecture%
	echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
	echo.    Image Default Language   : %ImageDefaultLanguage%	
)
if "%LanguagePackType%" equ "Install" (
	echo.    Image                    : Install.wim
	if "%ImageIndexNo%" equ "*" echo.    Image Indexes            : 1-%ImageCount%
	if "%ImageIndexNo%" neq "*" echo.    Image Index              : %ImageIndexNo%
	echo.    Image Architecture       : %ImageArchitecture%
	echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
	if "%ImageIndexNo%" neq "*" echo.    Image Edition            : %ImageEdition%
	echo.    Image Default Language   : %ImageDefaultLanguage%
)
if "%LanguagePackType%" equ "Recovery" (
	echo.    Image                    : WinRE.wim
	echo.    Image Index              : 1
	echo.    Image Architecture       : %ImageArchitecture%
	echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
	echo.    Image Default Language   : %ImageDefaultLanguage%	
)
echo.
echo.-------------------------------------------------------------------------------
if "%LanguagePackType%" equ "Boot" echo.####Integrating Windows Language Packs to Windows Boot Image###################
if "%LanguagePackType%" equ "Install" echo.####Integrating Windows Language Packs to Windows Installation Image###########
if "%LanguagePackType%" equ "Recovery" echo.####Integrating Windows Language Packs to Windows Reocvery Image###############
echo.-------------------------------------------------------------------------------
echo.
if "%LanguagePackType%" equ "Boot" (
	for /L %%i in (1, 1, 2) do (
		echo.-------------------------------------------------------------------------------
		echo.Integrating WinPE Language Pack [%LanguagePackCode%] to Windows Boot Image...
		echo.-------------------------[Boot.wim, Index : %%i]---------------------------------
		if "%SelectedSourceOS%" equ "w7" call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\Microsoft-Windows-WinPE-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
		if "%SelectedSourceOS%" equ "w81" call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\Microsoft-Windows-WinPE-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		if "%SelectedSourceOS%" equ "w10" (
			call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\Microsoft-Windows-WinPE-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
			if "%ImageBuild%" geq "15063" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating WinPE - AT Broker [%LanguagePackCode%] to Windows Boot Image...
				echo.-------------------------[Boot.wim, Index : %%i]---------------------------------
				call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\WinPE-ATBroker-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating WinPE - Audio Core [%LanguagePackCode%] to Windows Boot Image...
				echo.-------------------------[Boot.wim, Index : %%i]---------------------------------
				call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\WinPE-AudioCore-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating WinPE - Audio Drivers [%LanguagePackCode%] to Windows Boot Image...
				echo.-------------------------[Boot.wim, Index : %%i]---------------------------------
				call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\WinPE-AudioDrivers-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
			)
		)	
		if "%SelectedSourceOS%" neq "w7" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating WinPE - Enhanced Storage Pack [%LanguagePackCode%] to Windows Boot Image...
			echo.-------------------------[Boot.wim, Index : %%i]---------------------------------
			if "%SelectedSourceOS%" equ "w81" call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\WinPE-EnhancedStorage-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
			if "%SelectedSourceOS%" equ "w10" call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\WinPE-EnhancedStorage-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
		)
		if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "15063" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating WinPE - Narrator [%LanguagePackCode%] to Windows Boot Image...
			echo.-------------------------[Boot.wim, Index : %%i]---------------------------------
			call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\WinPE-Narrator-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"				
		)
		if "%SelectedSourceOS%" equ "w81" if exist "%LanguagePacks%\WinPE-IbsProvider-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating WinPE - IBS Provider Pack [%LanguagePackCode%] to Windows Boot Image...
			echo.-------------------------[Boot.wim, Index : %%i]---------------------------------
			call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\WinPE-IbsProvider-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		)
		echo.-------------------------------------------------------------------------------
		echo.Integrating WinPE - Scripting Pack [%LanguagePackCode%] to Windows Boot Image...
		echo.-------------------------[Boot.wim, Index : %%i]---------------------------------
		if "%SelectedSourceOS%" equ "w7" call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\WinPE-Scripting-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
		if "%SelectedSourceOS%" equ "w81" call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\WinPE-Scripting-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		if "%SelectedSourceOS%" equ "w10" call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\WinPE-Scripting-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
		if "%SelectedSourceOS%" neq "w7" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating WinPE - Secure Startup Pack [%LanguagePackCode%] to Windows Boot Image...
			echo.-------------------------[Boot.wim, Index : %%i]---------------------------------
			if "%SelectedSourceOS%" equ "w81" call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\WinPE-SecureStartup-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
			if "%SelectedSourceOS%" equ "w10" call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\WinPE-SecureStartup-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
		)
	)
	
	if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "18362" if not exist "%BootMount%\2\Windows\servicing\Packages\WinPE-Setup-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab" (
		echo.-------------------------------------------------------------------------------
		echo.Integrating WinPE - Setup Pack to Windows Boot Image...
		echo.-------------------------[Boot.wim, Index : 2]---------------------------------
		call :AddPackage "%BootMount%\2", "%Patches%\WinPE\WinPE-Setup-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab"
	)
	echo.-------------------------------------------------------------------------------
	echo.Integrating WinPE - Setup Pack [%LanguagePackCode%] to Windows Boot Image...
	echo.-------------------------[Boot.wim, Index : 2]---------------------------------
	if "%SelectedSourceOS%" equ "w7" call :AddPackage "%BootMount%\2", "%LanguagePacks%\WinPE-Setup-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
	if "%SelectedSourceOS%" equ "w81" call :AddPackage "%BootMount%\2", "%LanguagePacks%\WinPE-Setup-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
	if "%SelectedSourceOS%" equ "w10" call :AddPackage "%BootMount%\2", "%LanguagePacks%\WinPE-Setup-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
	if "%ImageInstallationType:~,6%" neq "Server" (
		if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "18362" if not exist "%BootMount%\2\Windows\servicing\Packages\WinPE-Setup-Client-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating WinPE - Setup Client Pack to Windows Boot Image...
			echo.-------------------------[Boot.wim, Index : 2]---------------------------------
			call :AddPackage "%BootMount%\2", "%Patches%\WinPE\WinPE-Setup-Client-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab"
		)
		echo.-------------------------------------------------------------------------------
		echo.Integrating WinPE - Setup Client Pack [%LanguagePackCode%] to Windows Boot Image...
		echo.-------------------------[Boot.wim, Index : 2]---------------------------------
		if "%SelectedSourceOS%" equ "w7" call :AddPackage "%BootMount%\2", "%LanguagePacks%\WinPE-Setup-Client-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
		if "%SelectedSourceOS%" equ "w81" call :AddPackage "%BootMount%\2", "%LanguagePacks%\WinPE-Setup-Client-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		if "%SelectedSourceOS%" equ "w10" call :AddPackage "%BootMount%\2", "%LanguagePacks%\WinPE-Setup-Client-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
	)
	if "%ImageInstallationType:~,6%" equ "Server" (
		if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "18362" if not exist "%BootMount%\2\Windows\servicing\Packages\WinPE-Setup-Server-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating WinPE - Setup Server Pack to Windows Boot Image...
			echo.-------------------------[Boot.wim, Index : 2]---------------------------------
			call :AddPackage "%BootMount%\2", "%Patches%\WinPE\WinPE-Setup-Server-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab"
		)
		echo.-------------------------------------------------------------------------------
		echo.Integrating WinPE - Setup Server Pack [%LanguagePackCode%] to Windows Boot Image...
		echo.-------------------------[Boot.wim, Index : 2]---------------------------------
		if "%SelectedSourceOS%" equ "w7" call :AddPackage "%BootMount%\2", "%LanguagePacks%\WinPE-Setup-Server-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
		if "%SelectedSourceOS%" equ "w81" call :AddPackage "%BootMount%\2", "%LanguagePacks%\WinPE-Setup-Server-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		if "%SelectedSourceOS%" equ "w10" call :AddPackage "%BootMount%\2", "%LanguagePacks%\WinPE-Setup-Server-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
	)		
	for /L %%i in (1, 1, 2) do (
		if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "15063" if "%ImageBuild%" leq "17134" (
			for /d %%z in (de-DE, en-GB, en-IN, es-ES, es-MX, fr-CA, fr-FR, it-IT, ja-JP, ko-KR, pl-PL, pt-BR, pt-PT, ru-RU, zh-CN, zh-HK, zh-TW) do (
				if "%LanguagePackCode%" equ "%%z" (
					echo.-------------------------------------------------------------------------------
					echo.Integrating WinPE - Speech TextToSpeech [%LanguagePackCode%] to Windows Boot Image...
					echo.-------------------------[Boot.wim, Index : %%i]---------------------------------
					call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\WinPE-Speech-TTS-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab"
				)
			)
		)
		if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "15063" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating WinPE - Speech TextToSpeech [%LanguagePackCode%] to Windows Boot Image...
			echo.-------------------------[Boot.wim, Index : %%i]---------------------------------
			call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\WinPE-Speech-TTS-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WinPE - SRH [%LanguagePackCode%] to Windows Boot Image...
			echo.-------------------------[Boot.wim, Index : %%i]---------------------------------
			call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\WinPE-SRH-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
		)
		echo.-------------------------------------------------------------------------------
		echo.Integrating WinPE - SRT Pack [%LanguagePackCode%] to Windows Boot Image...
		echo.-------------------------[Boot.wim, Index : %%i]---------------------------------
		if "%SelectedSourceOS%" equ "w7" call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\WinPE-SRT-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
		if "%SelectedSourceOS%" equ "w81" call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\WinPE-SRT-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		if "%SelectedSourceOS%" equ "w10" call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\WinPE-SRT-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WinPE - WDS Pack [%LanguagePackCode%] to Windows Boot Image...
		echo.-------------------------[Boot.wim, Index : %%i]---------------------------------
		if "%SelectedSourceOS%" equ "w7" call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\WinPE-WDS-Tools-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
		if "%SelectedSourceOS%" equ "w81" call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\WinPE-WDS-Tools-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		if "%SelectedSourceOS%" equ "w10" call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\WinPE-WDS-Tools-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WinPE - WMI Pack [%LanguagePackCode%] to Windows Boot Image...
		echo.-------------------------[Boot.wim, Index : %%i]---------------------------------
		if "%SelectedSourceOS%" equ "w7" call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\WinPE-WMI-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
		if "%SelectedSourceOS%" equ "w81" call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\WinPE-WMI-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		if "%SelectedSourceOS%" equ "w10" call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\WinPE-WMI-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
		for /d %%z in (ja-JP, ko-KR, zh-HK, zh-CN, zh-TW) do (
			if "%LanguagePackCode%" equ "%%z" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating WinPE - Font Support Pack [%LanguagePackCode%] to Windows Boot Image...
				echo.-------------------------[Boot.wim, Index : %%i]---------------------------------
				if "%SelectedSourceOS%" equ "w7" call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\WinPE-FontSupport-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
				if "%SelectedSourceOS%" equ "w81" call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\WinPE-FontSupport-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
				if "%SelectedSourceOS%" equ "w10" call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\WinPE-FontSupport-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
			)
		)	
	)
	echo.-------------------------------------------------------------------------------
	echo.Creating Windows Setup language configuration file [Lang.ini]...
	echo.-------------------------[Boot.wim, Index : 2]---------------------------------
	%DISM% /Image:"%BootMount%\2" /Gen-LangINI /Distribution:"%DVD%"
	echo.
	if "%SelectedSourceOS%" neq "w10" (
		echo.-------------------------------------------------------------------------------
		echo.Integrating [%LanguagePackCode%] Localized Windows Setup resources to the Source DVD...
		echo.-------------------------------------------------------------------------------
		echo.
		echo.Extracting Windows PE Language Pack [%LanguagePackCode%] to Temporary folder...
		call :RemoveFolder "%Temp%\LanguagePack"
		call :CreateFolder "%Temp%\LanguagePack"
		if "%SelectedSourceOS%" equ "w7" expand "%LanguagePacks%\Microsoft-Windows-WinPE-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab" -f:* "%Temp%\LanguagePack" >nul
		if "%SelectedSourceOS%" equ "w81" expand "%LanguagePacks%\Microsoft-Windows-WinPE-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" -f:* "%Temp%\LanguagePack" >nul
		echo.
		echo.Copying Localized Windows Setup resources files to the Source DVD...
		call :CreateFolder "%DVD%\sources\%LanguagePackCode%"
		if "%SelectedSourceOS%" equ "w81" if "%ImageInstallationType:~,6%" neq "Server" call :CreateFolder "%DVD%\sources\cli"
		if "%ImageArchitecture%" equ "x86" call :CreateFolder "%DVD%\sources\dlmanifests\microsoft-windows-iasserver-migplugin\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\dlmanifests\microsoft-windows-storagemigration\%LanguagePackCode%"
		if "%SelectedSourceOS%" equ "w81" call :CreateFolder "%DVD%\sources\dlmanifests\microsoft-windows-sxs\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\etwproviders\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\replacementmanifests\microsoft-windows-offlinefiles-core\%LanguagePackCode%"
		if "%SelectedSourceOS%" equ "w81" call :CreateFolder "%DVD%\sources\replacementmanifests\microsoft-windows-storagemigration\%LanguagePackCode%"
		if "%SelectedSourceOS%" equ "w81" call :CreateFolder "%DVD%\sources\replacementmanifests\microsoft-windows-sxs\%LanguagePackCode%"
		
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\*.*" "%DVD%\sources\%LanguagePackCode%" >nul
		if "%SelectedSourceOS%" equ "w81" if "%ImageInstallationType:~,6%" neq "Server" xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\cli\*.*" "%DVD%\sources\cli" >nul
		if "%ImageArchitecture%" equ "x86" xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\dlmanifests\microsoft-windows-iasserver-migplugin\*.*" "%DVD%\sources\dlmanifests\microsoft-windows-iasserver-migplugin\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\dlmanifests\microsoft-windows-storagemigration\*.*" "%DVD%\sources\dlmanifests\microsoft-windows-storagemigration\%LanguagePackCode%" >nul
		if "%SelectedSourceOS%" equ "w81" xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\dlmanifests\microsoft-windows-sxs\*.*" "%DVD%\sources\dlmanifests\microsoft-windows-sxs\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\etwproviders\*.*" "%DVD%\sources\etwproviders\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\replacementmanifests\microsoft-windows-offlinefiles-core\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-offlinefiles-core\%LanguagePackCode%" >nul
		if "%SelectedSourceOS%" equ "w81" xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\replacementmanifests\microsoft-windows-storagemigration\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-storagemigration\%LanguagePackCode%" >nul
		if "%SelectedSourceOS%" equ "w81" xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\replacementmanifests\microsoft-windows-sxs\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-sxs\%LanguagePackCode%" >nul
		echo.
	)

	if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" leq "15063" (
		echo.-------------------------------------------------------------------------------
		echo.Integrating [%LanguagePackCode%] Localized Windows Setup resources to the Source DVD...
		echo.-------------------------------------------------------------------------------
		echo.
		echo.Extracting Windows PE Language Pack [%LanguagePackCode%] to Temporary folder...
		call :RemoveFolder "%Temp%\LanguagePack"
		call :CreateFolder "%Temp%\LanguagePack"
		if "%SelectedSourceOS%" equ "w10" expand "%LanguagePacks%\Microsoft-Windows-WinPE-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab" -f:* "%Temp%\LanguagePack" >nul
		echo.
		echo.Copying Localized Windows Setup resources files to the Source DVD...
		call :CreateFolder "%DVD%\sources\%LanguagePackCode%"
		if "%ImageBuild%" leq 10586 if "%ImageInstallationType:~,6%" neq "Server" call :CreateFolder "%DVD%\sources\cli\%LanguagePackCode%"
		if "%ImageArchitecture%" equ "x86" call :CreateFolder "%DVD%\sources\dlmanifests\microsoft-windows-iasserver-migplugin\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\dlmanifests\microsoft-windows-shmig-dl\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\dlmanifests\microsoft-windows-storagemigration\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\dlmanifests\microsoft-windows-sxs\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\etwproviders\%LanguagePackCode%"
		if "%ImageBuild%" neq "10240" if "%ImageBuild%" neq "10586" if "%ImageArchitecture%" equ "x64" call :CreateFolder "%DVD%\sources\replacementmanifests\microsoft-windows-fabric-core\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\replacementmanifests\microsoft-windows-offlinefiles-core\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\replacementmanifests\microsoft-windows-shmig\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\replacementmanifests\microsoft-windows-storagemigration\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\replacementmanifests\microsoft-windows-sxs\%LanguagePackCode%"
		
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\*.*" "%DVD%\sources\%LanguagePackCode%" >nul
		if "%ImageBuild%" leq 10586 if "%ImageInstallationType:~,6%" neq "Server" xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\cli\*.*" "%DVD%\sources\cli\%LanguagePackCode%" >nul
		if "%ImageArchitecture%" equ "x86" xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\dlmanifests\microsoft-windows-iasserver-migplugin\*.*" "%DVD%\sources\dlmanifests\microsoft-windows-iasserver-migplugin\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\dlmanifests\microsoft-windows-shmig-dl\*.*" "%DVD%\sources\dlmanifests\microsoft-windows-shmig-dl\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\dlmanifests\microsoft-windows-storagemigration\*.*" "%DVD%\sources\dlmanifests\microsoft-windows-storagemigration\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\dlmanifests\microsoft-windows-sxs\*.*" "%DVD%\sources\dlmanifests\microsoft-windows-sxs\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\etwproviders\*.*" "%DVD%\sources\etwproviders\%LanguagePackCode%" >nul
		if "%ImageBuild%" neq "10240" if "%ImageBuild%" neq "10586" if "%ImageArchitecture%" equ "x64" xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\replacementmanifests\microsoft-windows-fabric-core\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-fabric-core\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\replacementmanifests\microsoft-windows-offlinefiles-core\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-offlinefiles-core\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\replacementmanifests\microsoft-windows-shmig\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-shmig\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\replacementmanifests\microsoft-windows-storagemigration\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-storagemigration\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\replacementmanifests\microsoft-windows-sxs\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-sxs\%LanguagePackCode%" >nul
		echo.
	)

	if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "16299" if "%ImageBuild%" leq "17763" if "%LanguagePackCode%" neq "en-US" (
		echo.-------------------------------------------------------------------------------
		echo.Integrating [%LanguagePackCode%] Localized Windows Setup resources to the Source DVD...
		echo.-------------------------------------------------------------------------------
		echo.
		echo.Extracting Windows PE Language Pack [%LanguagePackCode%] to Temporary folder...
		call :RemoveFolder "%Temp%\LanguagePack"
		call :CreateFolder "%Temp%\LanguagePack"
		if "%SelectedSourceOS%" equ "w10" expand "%LanguagePacks%\Microsoft-Windows-WinPE-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab" -f:* "%Temp%\LanguagePack" >nul
		echo.
		echo.Copying Localized Windows Setup resources files to the Source DVD...
		call :CreateFolder "%DVD%\sources\%LanguagePackCode%"
		if "%ImageBuild%" leq "17134" if "%ImageArchitecture%" equ "x86" call :CreateFolder "%DVD%\sources\dlmanifests\microsoft-windows-iasserver-migplugin\%LanguagePackCode%"
		if "%ImageBuild%" leq "17134" call :CreateFolder "%DVD%\sources\dlmanifests\microsoft-windows-storagemigration\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\etwproviders\%LanguagePackCode%"
		if "%ImageBuild%" equ "16299" if "%ImageArchitecture%" equ "x64" call :CreateFolder "%DVD%\sources\replacementmanifests\microsoft-windows-fabric-core\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\replacementmanifests\microsoft-windows-offlinefiles-core\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\replacementmanifests\microsoft-windows-shmig\%LanguagePackCode%"
		if "%ImageBuild%" leq "17134" call :CreateFolder "%DVD%\sources\replacementmanifests\microsoft-windows-storagemigration\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\replacementmanifests\microsoft-windows-sxs\%LanguagePackCode%"
		
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\*.*" "%DVD%\sources\%LanguagePackCode%" >nul
		if "%ImageBuild%" leq "17134" if "%ImageArchitecture%" equ "x86" xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\dlmanifests\microsoft-windows-iasserver-migplugin\*.*" "%DVD%\sources\dlmanifests\microsoft-windows-iasserver-migplugin\%LanguagePackCode%" >nul
		if "%ImageBuild%" leq "17134" xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\dlmanifests\microsoft-windows-storagemigration\*.*" "%DVD%\sources\dlmanifests\microsoft-windows-storagemigration\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\etwproviders\*.*" "%DVD%\sources\etwproviders\%LanguagePackCode%" >nul
		if "%ImageBuild%" equ "16299" if "%ImageArchitecture%" equ "x64" xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\replacementmanifests\microsoft-windows-fabric-core\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-fabric-core\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\replacementmanifests\microsoft-windows-offlinefiles-core\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-offlinefiles-core\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\replacementmanifests\microsoft-windows-shmig\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-shmig\%LanguagePackCode%" >nul
		if "%ImageBuild%" leq "17134" xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\replacementmanifests\microsoft-windows-storagemigration\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-storagemigration\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\replacementmanifests\microsoft-windows-sxs\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-sxs\%LanguagePackCode%" >nul
		echo.
	)

	echo.Copying Windows Setup language configuration file to the Boot Image...
	copy /y "%DVD%\sources\lang.ini" "%BootMount%\2\sources\lang.ini" >nul
	echo.
)

if "%LanguagePackType%" equ "Install" (
	if "%ImageIndexNo%" equ "*" (
		for /L %%i in (1, 1, %ImageCount%) do (
			if not %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]#############################
			if %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]############################
			echo.
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows Language Pack...
			echo.-------------------------------------------------------------------------------
			if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType%" equ "Client" call :AddPackage "%InstallMount%\%%i", "%LanguagePacks%\Microsoft-Windows-Client-Refresh-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
			if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType%" equ "Embedded" call :AddPackage "%InstallMount%\%%i", "%LanguagePacks%\Microsoft-Windows-Embedded-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
			if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType:~,6%" equ "Server" call :AddPackage "%InstallMount%\%%i", "%LanguagePacks%\Microsoft-Windows-Server-Refresh-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
			if "%SelectedSourceOS%" equ "w81" if "%ImageInstallationType%" equ "Client" call :AddPackage "%InstallMount%\%%i", "%LanguagePacks%\Microsoft-Windows-Client-Refresh-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
			if "%SelectedSourceOS%" equ "w81" if "%ImageInstallationType:~,6%" equ "Server" call :AddPackage "%InstallMount%\%%i", "%LanguagePacks%\Microsoft-Windows-Server-Refresh-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
			if "%SelectedSourceOS%" equ "w10" (
				if "%ImageInstallationType%" equ "Client" call :AddPackage "%InstallMount%\%%i", "%LanguagePacks%\Microsoft-Windows-Client-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
				if "%ImageInstallationType:~,6%" equ "Server" call :AddPackage "%InstallMount%\%%i", "%LanguagePacks%\Microsoft-Windows-Server-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
				if exist "%LanguagePacks%\Microsoft-Windows-LanguageFeatures-Basic-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab" (
					echo.-------------------------------------------------------------------------------
					echo.Integrating Windows Language Features - Basic Pack...
					echo.-------------------------------------------------------------------------------
					if "%ImageBuild%" leq "17134" call :AddPackage "%InstallMount%\%%i", "%LanguagePacks%\Microsoft-Windows-LanguageFeatures-Basic-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab"
					if "%ImageBuild%" geq "17763" (
						call :CreateFolder "%Temp%\LanguagePacks"
						copy /y "%LanguagePacks%\Microsoft-Windows-LanguageFeatures-Basic-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab" "%Temp%\LanguagePacks\Microsoft-Windows-LanguageFeatures-Basic-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~.cab" >nul
						call :AddPackage "%InstallMount%\%%i", "%Temp%\LanguagePacks\Microsoft-Windows-LanguageFeatures-Basic-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~.cab"
					)
				)
				if exist "%LanguagePacks%\Microsoft-Windows-LanguageFeatures-Handwriting-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab" (
					echo.-------------------------------------------------------------------------------
					echo.Integrating Windows Language Features - Handwriting Pack...
					echo.-------------------------------------------------------------------------------
					if "%ImageBuild%" leq "17134" call :AddPackage "%InstallMount%\%%i", "%LanguagePacks%\Microsoft-Windows-LanguageFeatures-Handwriting-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab"
					if "%ImageBuild%" geq "17763" (
						call :CreateFolder "%Temp%\LanguagePacks"
						copy /y "%LanguagePacks%\Microsoft-Windows-LanguageFeatures-Handwriting-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab" "%Temp%\LanguagePacks\Microsoft-Windows-LanguageFeatures-Handwriting-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~.cab" >nul
						call :AddPackage "%InstallMount%\%%i", "%Temp%\LanguagePacks\Microsoft-Windows-LanguageFeatures-Handwriting-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~.cab"
					)
				)
				if exist "%LanguagePacks%\Microsoft-Windows-LanguageFeatures-OCR-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab" (
					echo.-------------------------------------------------------------------------------
					echo.Integrating Windows Language Features - OCR Pack...
					echo.-------------------------------------------------------------------------------
					if "%ImageBuild%" leq "17134" call :AddPackage "%InstallMount%\%%i", "%LanguagePacks%\Microsoft-Windows-LanguageFeatures-OCR-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab"
					if "%ImageBuild%" geq "17763" (
						call :CreateFolder "%Temp%\LanguagePacks"
						copy /y "%LanguagePacks%\Microsoft-Windows-LanguageFeatures-OCR-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab" "%Temp%\LanguagePacks\Microsoft-Windows-LanguageFeatures-OCR-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~.cab" >nul
						call :AddPackage "%InstallMount%\%%i", "%Temp%\LanguagePacks\Microsoft-Windows-LanguageFeatures-OCR-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~.cab"
					)
				)
				if exist "%LanguagePacks%\Microsoft-Windows-LanguageFeatures-TextToSpeech-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab" (
					echo.-------------------------------------------------------------------------------
					echo.Integrating Windows Language Features - Text To Speech Pack...
					echo.-------------------------------------------------------------------------------
					if "%ImageBuild%" leq "17134" call :AddPackage "%InstallMount%\%%i", "%LanguagePacks%\Microsoft-Windows-LanguageFeatures-TextToSpeech-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab"
					if "%ImageBuild%" geq "17763" (
						call :CreateFolder "%Temp%\LanguagePacks"
						copy /y "%LanguagePacks%\Microsoft-Windows-LanguageFeatures-TextToSpeech-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab" "%Temp%\LanguagePacks\Microsoft-Windows-LanguageFeatures-TextToSpeech-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~.cab" >nul
						call :AddPackage "%InstallMount%\%%i", "%Temp%\LanguagePacks\Microsoft-Windows-LanguageFeatures-TextToSpeech-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~.cab"
					)
				)
				if exist "%LanguagePacks%\Microsoft-Windows-LanguageFeatures-Speech-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab" (
					echo.-------------------------------------------------------------------------------
					echo.Integrating Windows Language Features - Speech Pack...
					echo.-------------------------------------------------------------------------------
					if "%ImageBuild%" leq "17134" call :AddPackage "%InstallMount%\%%i", "%LanguagePacks%\Microsoft-Windows-LanguageFeatures-Speech-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab"
					if "%ImageBuild%" geq "17763" (
						call :CreateFolder "%Temp%\LanguagePacks"
						copy /y "%LanguagePacks%\Microsoft-Windows-LanguageFeatures-Speech-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab" "%Temp%\LanguagePacks\Microsoft-Windows-LanguageFeatures-Speech-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~.cab" >nul
						call :AddPackage "%InstallMount%\%%i", "%Temp%\LanguagePacks\Microsoft-Windows-LanguageFeatures-Speech-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~.cab"
					)
				)
			)
			echo.-------------------------------------------------------------------------------
			echo.Updating Windows Setup language configuration file [Lang.ini]...
			echo.-------------------------------------------------------------------------------
			%DISM% /Image:"%InstallMount%\%%i" /Gen-LangINI /Distribution:"%DVD%"
			echo.
		)
	) else (
		echo.-------------------------------------------------------------------------------
		echo.Integrating Windows Language Pack...
		echo.-------------------------------------------------------------------------------
		if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType%" equ "Client" call :AddPackage "%InstallMount%", "%LanguagePacks%\Microsoft-Windows-Client-Refresh-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
		if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType%" equ "Embedded" call :AddPackage "%InstallMount%", "%LanguagePacks%\Microsoft-Windows-Embedded-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
		if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType:~,6%" equ "Server" call :AddPackage "%InstallMount%", "%LanguagePacks%\Microsoft-Windows-Server-Refresh-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
		if "%SelectedSourceOS%" equ "w81" if "%ImageInstallationType%" equ "Client" call :AddPackage "%InstallMount%", "%LanguagePacks%\Microsoft-Windows-Client-Refresh-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		if "%SelectedSourceOS%" equ "w81" if "%ImageInstallationType:~,6%" equ "Server" call :AddPackage "%InstallMount%", "%LanguagePacks%\Microsoft-Windows-Server-Refresh-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		if "%SelectedSourceOS%" equ "w10" (
			if "%ImageInstallationType%" equ "Client" call :AddPackage "%InstallMount%", "%LanguagePacks%\Microsoft-Windows-Client-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
			if "%ImageInstallationType:~,6%" equ "Server" call :AddPackage "%InstallMount%", "%LanguagePacks%\Microsoft-Windows-Server-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
			if exist "%LanguagePacks%\Microsoft-Windows-LanguageFeatures-Basic-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows Language Features - Basic Pack...
				echo.-------------------------------------------------------------------------------
				if "%ImageBuild%" leq "17134" call :AddPackage "%InstallMount%", "%LanguagePacks%\Microsoft-Windows-LanguageFeatures-Basic-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab"
				if "%ImageBuild%" geq "17763" (
					call :CreateFolder "%Temp%\LanguagePacks"
					copy /y "%LanguagePacks%\Microsoft-Windows-LanguageFeatures-Basic-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab" "%Temp%\LanguagePacks\Microsoft-Windows-LanguageFeatures-Basic-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~.cab" >nul
					call :AddPackage "%InstallMount%", "%Temp%\LanguagePacks\Microsoft-Windows-LanguageFeatures-Basic-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~.cab"
				)
			)
			if exist "%LanguagePacks%\Microsoft-Windows-LanguageFeatures-Handwriting-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows Language Features - Handwriting Pack...
				echo.-------------------------------------------------------------------------------
				if "%ImageBuild%" leq "17134" call :AddPackage "%InstallMount%", "%LanguagePacks%\Microsoft-Windows-LanguageFeatures-Handwriting-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab"
				if "%ImageBuild%" geq "17763" (
					call :CreateFolder "%Temp%\LanguagePacks"
					copy /y "%LanguagePacks%\Microsoft-Windows-LanguageFeatures-Handwriting-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab" "%Temp%\LanguagePacks\Microsoft-Windows-LanguageFeatures-Handwriting-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~.cab" >nul
					call :AddPackage "%InstallMount%", "%Temp%\LanguagePacks\Microsoft-Windows-LanguageFeatures-Handwriting-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~.cab"
				)
			)
			if exist "%LanguagePacks%\Microsoft-Windows-LanguageFeatures-OCR-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows Language Features - OCR Pack...
				echo.-------------------------------------------------------------------------------
				if "%ImageBuild%" leq "17134" call :AddPackage "%InstallMount%", "%LanguagePacks%\Microsoft-Windows-LanguageFeatures-OCR-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab"
				if "%ImageBuild%" geq "17763" (
					call :CreateFolder "%Temp%\LanguagePacks"
					copy /y "%LanguagePacks%\Microsoft-Windows-LanguageFeatures-OCR-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab" "%Temp%\LanguagePacks\Microsoft-Windows-LanguageFeatures-OCR-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~.cab" >nul
					call :AddPackage "%InstallMount%", "%Temp%\LanguagePacks\Microsoft-Windows-LanguageFeatures-OCR-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~.cab"
				)
			)
			if exist "%LanguagePacks%\Microsoft-Windows-LanguageFeatures-TextToSpeech-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows Language Features - Text To Speech Pack...
				echo.-------------------------------------------------------------------------------
				if "%ImageBuild%" leq "17134" call :AddPackage "%InstallMount%", "%LanguagePacks%\Microsoft-Windows-LanguageFeatures-TextToSpeech-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab"
				if "%ImageBuild%" geq "17763" (
					call :CreateFolder "%Temp%\LanguagePacks"
					copy /y "%LanguagePacks%\Microsoft-Windows-LanguageFeatures-TextToSpeech-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab" "%Temp%\LanguagePacks\Microsoft-Windows-LanguageFeatures-TextToSpeech-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~.cab" >nul
					call :AddPackage "%InstallMount%", "%Temp%\LanguagePacks\Microsoft-Windows-LanguageFeatures-TextToSpeech-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~.cab"
				)
			)				
			if exist "%LanguagePacks%\Microsoft-Windows-LanguageFeatures-Speech-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows Language Features - Speech Pack...
				echo.-------------------------------------------------------------------------------
				if "%ImageBuild%" leq "17134" call :AddPackage "%InstallMount%", "%LanguagePacks%\Microsoft-Windows-LanguageFeatures-Speech-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab"
				if "%ImageBuild%" geq "17763" (
					call :CreateFolder "%Temp%\LanguagePacks"
					copy /y "%LanguagePacks%\Microsoft-Windows-LanguageFeatures-Speech-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab" "%Temp%\LanguagePacks\Microsoft-Windows-LanguageFeatures-Speech-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~.cab" >nul
					call :AddPackage "%InstallMount%", "%Temp%\LanguagePacks\Microsoft-Windows-LanguageFeatures-Speech-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~.cab"
				)
			)
		)
		echo.-------------------------------------------------------------------------------
		echo.Updating Windows Setup language configuration file [Lang.ini]...
		echo.-------------------------------------------------------------------------------
		%DISM% /Image:"%InstallMount%" /Gen-LangINI /Distribution:"%DVD%"
		echo.
	)
	echo.-------------------------------------------------------------------------------
	echo.Integrating [%LanguagePackCode%] Localized Windows Setup resources to Source DVD...
	echo.-------------------------------------------------------------------------------
	echo.
	echo.Extracting Windows Language Pack [%LanguagePackCode%] to Temporary folder...
	call :RemoveFolder "%Temp%\LanguagePack"
	call :CreateFolder "%Temp%\LanguagePack"
	if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType%" equ "Client" expand "%LanguagePacks%\Microsoft-Windows-Client-Refresh-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab" -f:* "%Temp%\LanguagePack" >nul
	if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType%" equ "Embedded" expand "%LanguagePacks%\Microsoft-Windows-Embedded-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab" -f:* "%Temp%\LanguagePack" >nul
	if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType:~,6%" equ "Server" expand "%LanguagePacks%\Microsoft-Windows-Server-Refresh-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab" -f:* "%Temp%\LanguagePack" >nul
	if "%SelectedSourceOS%" equ "w81" if "%ImageInstallationType%" equ "Client" expand "%LanguagePacks%\Microsoft-Windows-Client-Refresh-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" -f:* "%Temp%\LanguagePack" >nul
	if "%SelectedSourceOS%" equ "w81" if "%ImageInstallationType:~,6%" equ "Server" expand "%LanguagePacks%\Microsoft-Windows-Server-Refresh-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" -f:* "%Temp%\LanguagePack" >nul
	if "%SelectedSourceOS%" equ "w10" if "%ImageInstallationType%" equ "Client" expand "%LanguagePacks%\Microsoft-Windows-Client-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab" -f:* "%Temp%\LanguagePack" >nul
	if "%SelectedSourceOS%" equ "w10" if "%ImageInstallationType:~,6%" equ "Server" expand "%LanguagePacks%\Microsoft-Windows-Server-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab" -f:* "%Temp%\LanguagePack" >nul
	echo.
	echo.Copying Localized Windows Setup resources files to the Source DVD...
	call :CreateFolder "%DVD%\sources\%LanguagePackCode%"

	if "%SelectedSourceOS%" equ "w7" (
		if "%ImageArchitecture%" equ "x86" call :CreateFolder "%DVD%\sources\dlmanifests\microsoft-windows-iasserver-migplugin\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\dlmanifests\microsoft-windows-storagemigration\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\etwproviders\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\replacementmanifests\microsoft-windows-offlinefiles-core\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\replacementmanifests\microsoft-windows-storagemigration\%LanguagePackCode%"

		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\*.*" "%DVD%\sources\%LanguagePackCode%" >nul
		if "%ImageArchitecture%" equ "x86" xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\dlmanifests\microsoft-windows-iasserver-migplugin\*.*" "%DVD%\sources\dlmanifests\microsoft-windows-iasserver-migplugin\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\dlmanifests\microsoft-windows-storagemigration\*.*" "%DVD%\sources\dlmanifests\microsoft-windows-storagemigration\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\etwproviders\*.*" "%DVD%\sources\etwproviders\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\replacementmanifests\microsoft-windows-offlinefiles-core\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-offlinefiles-core\%LanguagePackCode%" >nul

		if "%ImageInstallationType%" neq "Embedded" (
			call :CreateFolder "%DVD%\sources\sp1\%LanguagePackCode%"
			call :CreateFolder "%DVD%\sources\sp1\dlmanifests\microsoft-windows-iasserver-migplugin\%LanguagePackCode%"
			call :CreateFolder "%DVD%\sources\sp1\dlmanifests\microsoft-windows-storagemigration\%LanguagePackCode%"
			call :CreateFolder "%DVD%\sources\sp1\etwproviders\%LanguagePackCode%"
			call :CreateFolder "%DVD%\sources\sp1\replacementmanifests\microsoft-windows-offlinefiles-core\%LanguagePackCode%"

			xcopy /y "%Temp%\LanguagePack\sp1\setup\sources\%LanguagePackCode%\*.*" "%DVD%\sources\sp1\%LanguagePackCode%" >nul
			if "%ImageArchitecture%" equ "x86" xcopy /y "%Temp%\LanguagePack\sp1\setup\sources\%LanguagePackCode%\dlmanifests\microsoft-windows-iasserver-migplugin\*.*" "%DVD%\sources\sp1\dlmanifests\microsoft-windows-iasserver-migplugin\%LanguagePackCode%" >nul
			xcopy /y "%Temp%\LanguagePack\sp1\setup\sources\%LanguagePackCode%\dlmanifests\microsoft-windows-storagemigration\*.*" "%DVD%\sources\sp1\dlmanifests\microsoft-windows-storagemigration\%LanguagePackCode%" >nul
			xcopy /y "%Temp%\LanguagePack\sp1\setup\sources\%LanguagePackCode%\etwproviders\*.*" "%DVD%\sources\sp1\etwproviders\%LanguagePackCode%" >nul
			xcopy /y "%Temp%\LanguagePack\sp1\setup\sources\%LanguagePackCode%\replacementmanifests\microsoft-windows-offlinefiles-core\*.*" "%DVD%\sources\sp1\replacementmanifests\microsoft-windows-offlinefiles-core\%LanguagePackCode%" >nul

			echo.Copying Localized Windows Setup license files to the Source DVD...
			call :CreateFolder "%DVD%\sources\license\%LanguagePackCode%"
			call :CreateFolder "%DVD%\sources\sp1\license\%LanguagePackCode%"
			xcopy /y "%Temp%\LanguagePack\sources\license\%LanguagePackCode%\*.*" "%DVD%\sources\license\%LanguagePackCode%" >nul
			xcopy /y "%Temp%\LanguagePack\sp1\sources\license\%LanguagePackCode%\*.*" "%DVD%\sources\sp1\license\%LanguagePackCode%" >nul
		)
	)

	if "%SelectedSourceOS%" equ "w81" (
		if "%ImageInstallationType:~,6%" neq "Server" call :CreateFolder "%DVD%\sources\cli\%LanguagePackCode%"
		if "%ImageArchitecture%" equ "x86" call :CreateFolder "%DVD%\sources\dlmanifests\microsoft-windows-iasserver-migplugin\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\dlmanifests\microsoft-windows-storagemigration\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\dlmanifests\microsoft-windows-sxs\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\etwproviders\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\replacementmanifests\microsoft-windows-offlinefiles-core\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\replacementmanifests\microsoft-windows-sxs\%LanguagePackCode%"

		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\*.*" "%DVD%\sources\%LanguagePackCode%" >nul
		if "%ImageInstallationType:~,6%" neq "Server" xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\cli\*.*" "%DVD%\sources\cli\%LanguagePackCode%" >nul
		if "%ImageArchitecture%" equ "x86" xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\dlmanifests\microsoft-windows-iasserver-migplugin\*.*" "%DVD%\sources\dlmanifests\microsoft-windows-iasserver-migplugin\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\dlmanifests\microsoft-windows-storagemigration\*.*" "%DVD%\sources\dlmanifests\microsoft-windows-storagemigration\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\dlmanifests\microsoft-windows-sxs\*.*" "%DVD%\sources\dlmanifests\microsoft-windows-sxs\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\etwproviders\*.*" "%DVD%\sources\etwproviders\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\replacementmanifests\microsoft-windows-offlinefiles-core\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-offlinefiles-core\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\replacementmanifests\microsoft-windows-sxs\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-sxs\%LanguagePackCode%" >nul
	)

	if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" leq "15063" (
		if "%ImageBuild%" leq "10586" if "%ImageInstallationType:~,6%" neq "Server" call :CreateFolder "%DVD%\sources\cli\%LanguagePackCode%"
		if "%ImageArchitecture%" equ "x86" call :CreateFolder "%DVD%\sources\dlmanifests\microsoft-windows-iasserver-migplugin\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\dlmanifests\microsoft-windows-shmig-dl\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\dlmanifests\microsoft-windows-storagemigration\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\dlmanifests\microsoft-windows-sxs\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\etwproviders\%LanguagePackCode%"
		if "%ImageBuild%" neq "10240" if "%ImageBuild%" neq "10586" if "%ImageArchitecture%" equ "x64" call :CreateFolder "%DVD%\sources\replacementmanifests\microsoft-windows-fabric-core\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\replacementmanifests\microsoft-windows-offlinefiles-core\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\replacementmanifests\microsoft-windows-shmig\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\replacementmanifests\microsoft-windows-storagemigration\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\replacementmanifests\microsoft-windows-sxs\%LanguagePackCode%"

		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\*.*" "%DVD%\sources\%LanguagePackCode%" >nul
		if "%ImageBuild%" leq "10586" if "%ImageInstallationType:~,6%" neq "Server" xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\cli\*.*" "%DVD%\sources\cli\%LanguagePackCode%" >nul
		if "%ImageArchitecture%" equ "x86" xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\dlmanifests\microsoft-windows-iasserver-migplugin\*.*" "%DVD%\sources\dlmanifests\microsoft-windows-iasserver-migplugin\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\dlmanifests\microsoft-windows-shmig-dl\*.*" "%DVD%\sources\dlmanifests\microsoft-windows-shmig-dl\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\dlmanifests\microsoft-windows-storagemigration\*.*" "%DVD%\sources\dlmanifests\microsoft-windows-storagemigration\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\dlmanifests\microsoft-windows-sxs\*.*" "%DVD%\sources\dlmanifests\microsoft-windows-sxs\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\etwproviders\*.*" "%DVD%\sources\etwproviders\%LanguagePackCode%" >nul
		if "%ImageBuild%" neq "10240" if "%ImageBuild%" neq "10586" if "%ImageArchitecture%" equ "x64" xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\replacementmanifests\microsoft-windows-fabric-core\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-fabric-core\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\replacementmanifests\microsoft-windows-offlinefiles-core\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-offlinefiles-core\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\replacementmanifests\microsoft-windows-shmig\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-shmig\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\replacementmanifests\microsoft-windows-storagemigration\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-storagemigration\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\replacementmanifests\microsoft-windows-sxs\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-sxs\%LanguagePackCode%" >nul
	)
	
	if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "16299" if "%ImageBuild%" leq "18363" (
		if "%ImageArchitecture%" equ "x86" call :CreateFolder "%DVD%\sources\dlmanifests\microsoft-windows-iasserver-migplugin\%LanguagePackCode%"
		if "%ImageBuild%" leq "17134" call :CreateFolder "%DVD%\sources\dlmanifests\microsoft-windows-storagemigration\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\etwproviders\%LanguagePackCode%"
		if "%ImageBuild%" equ "16299" if "%ImageArchitecture%" equ "x64" call :CreateFolder "%DVD%\sources\replacementmanifests\microsoft-windows-fabric-core\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\replacementmanifests\microsoft-windows-offlinefiles-core\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\replacementmanifests\microsoft-windows-shmig\%LanguagePackCode%"
		if "%ImageBuild%" leq "17134" call :CreateFolder "%DVD%\sources\replacementmanifests\microsoft-windows-storagemigration\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\replacementmanifests\microsoft-windows-sxs\%LanguagePackCode%"

		if "%LanguagePackCode%" neq "en-US" (
			xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\*.*" "%DVD%\sources\%LanguagePackCode%" >nul
			if "%ImageArchitecture%" equ "x86" xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\dlmanifests\microsoft-windows-iasserver-migplugin\*.*" "%DVD%\sources\dlmanifests\microsoft-windows-iasserver-migplugin\%LanguagePackCode%" >nul
			if "%ImageBuild%" leq "17134" xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\dlmanifests\microsoft-windows-storagemigration\*.*" "%DVD%\sources\dlmanifests\microsoft-windows-storagemigration\%LanguagePackCode%" >nul
			xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\etwproviders\*.*" "%DVD%\sources\etwproviders\%LanguagePackCode%" >nul
			if "%ImageBuild%" equ "16299" if "%ImageArchitecture%" equ "x64" xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\replacementmanifests\microsoft-windows-fabric-core\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-fabric-core\%LanguagePackCode%" >nul
			xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\replacementmanifests\microsoft-windows-offlinefiles-core\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-offlinefiles-core\%LanguagePackCode%" >nul
			xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\replacementmanifests\microsoft-windows-shmig\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-shmig\%LanguagePackCode%" >nul
			if "%ImageBuild%" leq "17134" xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\replacementmanifests\microsoft-windows-storagemigration\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-storagemigration\%LanguagePackCode%" >nul
			xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\replacementmanifests\microsoft-windows-sxs\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-sxs\%LanguagePackCode%" >nul
		)

		if "%LanguagePackCode%" equ "en-US" (
			xcopy /y "%Temp%\LanguagePack\setup\sources\*.*" "%DVD%\sources\%LanguagePackCode%" >nul
			if "%ImageArchitecture%" equ "x86" xcopy /y "%Temp%\LanguagePack\setup\sources\dlmanifests\microsoft-windows-iasserver-migplugin\*.*" "%DVD%\sources\dlmanifests\microsoft-windows-iasserver-migplugin\%LanguagePackCode%" >nul
			if "%ImageBuild%" leq "17134" xcopy /y "%Temp%\LanguagePack\setup\sources\dlmanifests\microsoft-windows-storagemigration\*.*" "%DVD%\sources\dlmanifests\microsoft-windows-storagemigration\%LanguagePackCode%" >nul
			xcopy /y "%Temp%\LanguagePack\setup\sources\etwproviders\*.*" "%DVD%\sources\etwproviders\%LanguagePackCode%" >nul
			if "%ImageBuild%" equ "16299" if "%ImageArchitecture%" equ "x64" xcopy /y "%Temp%\LanguagePack\setup\sources\replacementmanifests\microsoft-windows-fabric-core\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-fabric-core\%LanguagePackCode%" >nul
			xcopy /y "%Temp%\LanguagePack\setup\sources\replacementmanifests\microsoft-windows-offlinefiles-core\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-offlinefiles-core\%LanguagePackCode%" >nul
			xcopy /y "%Temp%\LanguagePack\setup\sources\replacementmanifests\microsoft-windows-shmig\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-shmig\%LanguagePackCode%" >nul
			if "%ImageBuild%" leq "17134" xcopy /y "%Temp%\LanguagePack\setup\sources\replacementmanifests\microsoft-windows-storagemigration\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-storagemigration\%LanguagePackCode%" >nul
			xcopy /y "%Temp%\LanguagePack\setup\sources\replacementmanifests\microsoft-windows-sxs\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-sxs\%LanguagePackCode%" >nul
		)
	)
	echo.
)

if "%LanguagePackType%" equ "Recovery" (
	echo.-------------------------------------------------------------------------------
	echo.Integrating WinPE Language Pack [%LanguagePackCode%] to Windows Recovery Image...
	echo.-------------------------[WinRE.wim, Index : 1]--------------------------------
	if "%SelectedSourceOS%" equ "w7" call :AddPackage "%WinReMount%", "%LanguagePacks%\Microsoft-Windows-WinPE-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
	if "%SelectedSourceOS%" equ "w81" call :AddPackage "%WinReMount%", "%LanguagePacks%\Microsoft-Windows-WinPE-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
	if "%SelectedSourceOS%" equ "w10" (
		call :AddPackage "%WinReMount%", "%LanguagePacks%\Microsoft-Windows-WinPE-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
		if "%ImageBuild%" geq "17134" (
			if exist "%LanguagePacks%\Microsoft-Windows-WinPE-AppxPackaging-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating WinPE - Appx Packaging [%LanguagePackCode%] to Windows Recovery Image...
				echo.-------------------------[WinRE.wim, Index : 1]--------------------------------
				call :AddPackage "%WinReMount%", "%LanguagePacks%\Microsoft-Windows-WinPE-AppxPackaging-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
			)
			if exist "%LanguagePacks%\Microsoft-Windows-WinPE-OpcServices-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating WinPE - Opc Services [%LanguagePackCode%] to Windows Recovery Image...
				echo.-------------------------[WinRE.wim, Index : 1]--------------------------------
				call :AddPackage "%WinReMount%", "%LanguagePacks%\Microsoft-Windows-WinPE-OpcServices-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
			)
			echo.-------------------------------------------------------------------------------
			echo.Integrating WinPE - Appx Packaging [%LanguagePackCode%] to Windows Recovery Image...
			echo.-------------------------[WinRE.wim, Index : 1]--------------------------------
			call :AddPackage "%WinReMount%", "%LanguagePacks%\WinPE-AppxPackaging-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
		)
		if "%ImageBuild%" geq "15063" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating WinPE - AT Broker [%LanguagePackCode%] to Windows Recovery Image...
			echo.-------------------------[WinRE.wim, Index : 1]--------------------------------
			call :AddPackage "%WinReMount%", "%LanguagePacks%\WinPE-ATBroker-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WinPE - Audio Core [%LanguagePackCode%] to Windows Recovery Image...
			echo.-------------------------[WinRE.wim, Index : 1]--------------------------------
			call :AddPackage "%WinReMount%", "%LanguagePacks%\WinPE-AudioCore-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WinPE - Audio Drivers [%LanguagePackCode%] to Windows Recovery Image...
			echo.-------------------------[WinRE.wim, Index : 1]--------------------------------
			call :AddPackage "%WinReMount%", "%LanguagePacks%\WinPE-AudioDrivers-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
		)
	)
	if "%SelectedSourceOS%" neq "w7" (
		echo.-------------------------------------------------------------------------------
		echo.Integrating WinPE - Enhanced Storage Pack [%LanguagePackCode%] to Windows Recovery Image...
		echo.-------------------------[WinRE.wim, Index : 1]--------------------------------
		if "%SelectedSourceOS%" equ "w81" call :AddPackage "%WinReMount%", "%LanguagePacks%\WinPE-EnhancedStorage-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		if "%SelectedSourceOS%" equ "w10" call :AddPackage "%WinReMount%", "%LanguagePacks%\WinPE-EnhancedStorage-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
	)
	if "%SelectedSourceOS%" equ "w81" if exist "%LanguagePacks%\WinPE-IbsProvider-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" (
		echo.-------------------------------------------------------------------------------
		echo.Integrating WinPE - IBS Provider Pack [%LanguagePackCode%] to Windows Recovery Image...
		echo.-------------------------[WinRE.wim, Index : 1]--------------------------------
		call :AddPackage "%WinReMount%", "%LanguagePacks%\WinPE-IbsProvider-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
	)
	if "%SelectedSourceOS%" equ "w10" (
		echo.-------------------------------------------------------------------------------
		echo.Integrating WinPE - HTA Pack [%LanguagePackCode%] to Windows Recovery Image...
		echo.-------------------------[WinRE.wim, Index : 1]--------------------------------
		call :AddPackage "%WinReMount%", "%LanguagePacks%\WinPE-HTA-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
		if "%ImageBuild%" geq "15063" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating WinPE - Narrator [%LanguagePackCode%] to Windows Recovery Image...
			echo.-------------------------[WinRE.wim, Index : 1]--------------------------------
			call :AddPackage "%WinReMount%", "%LanguagePacks%\WinPE-Narrator-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"				
		)
		if "%ImageBuild%" geq "17134" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating WinPE - Opc Services [%LanguagePackCode%] to Windows Recovery Image...
			echo.-------------------------[WinRE.wim, Index : 1]--------------------------------
			call :AddPackage "%WinReMount%", "%LanguagePacks%\WinPE-OpcServices-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
		)		
	)
	if "%SelectedSourceOS%" neq "w7" (
		echo.-------------------------------------------------------------------------------
		echo.Integrating WinPE - Rejuv Pack [%LanguagePackCode%] to Windows Recovery Image...
		echo.-------------------------[WinRE.wim, Index : 1]--------------------------------
		if "%SelectedSourceOS%" equ "w81" call :AddPackage "%WinReMount%", "%LanguagePacks%\WinPE-Rejuv-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		if "%SelectedSourceOS%" equ "w10" call :AddPackage "%WinReMount%", "%LanguagePacks%\WinPE-Rejuv-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
	)
	echo.-------------------------------------------------------------------------------
	echo.Integrating WinPE - Scripting Pack [%LanguagePackCode%] to Windows Recovery Image...
	echo.-------------------------[WinRE.wim, Index : 1]--------------------------------
	if "%SelectedSourceOS%" equ "w7" call :AddPackage "%WinReMount%", "%LanguagePacks%\WinPE-Scripting-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
	if "%SelectedSourceOS%" equ "w81" call :AddPackage "%WinReMount%", "%LanguagePacks%\WinPE-Scripting-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
	if "%SelectedSourceOS%" equ "w10" call :AddPackage "%WinReMount%", "%LanguagePacks%\WinPE-Scripting-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
	if "%SelectedSourceOS%" neq "w7" (
		echo.-------------------------------------------------------------------------------
		echo.Integrating WinPE - Secure Startup Pack [%LanguagePackCode%] to Windows Recovery Image...
		echo.-------------------------[WinRE.wim, Index : 1]--------------------------------
		if "%SelectedSourceOS%" equ "w81" call :AddPackage "%WinReMount%", "%LanguagePacks%\WinPE-SecureStartup-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		if "%SelectedSourceOS%" equ "w10" call :AddPackage "%WinReMount%", "%LanguagePacks%\WinPE-SecureStartup-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
	)
	if "%SelectedSourceOS%" equ "w7" (
		echo.-------------------------------------------------------------------------------
		echo.Integrating WinPE - Setup Pack [%LanguagePackCode%] to Windows Recovery Image...
		echo.-------------------------[WinRE.wim, Index : 1]--------------------------------
		call :AddPackage "%WinReMount%", "%LanguagePacks%\WinPE-Setup-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WinPE - Setup Client Pack [%LanguagePackCode%] to Windows Recovery Image...
		echo.-------------------------[WinRE.wim, Index : 1]--------------------------------
		call :AddPackage "%WinReMount%", "%LanguagePacks%\WinPE-Setup-Client-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
	)
	if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "15063" if "%ImageBuild%" leq "17134" (
		for /d %%z in (de-DE, en-GB, en-IN, es-ES, es-MX, fr-CA, fr-FR, it-IT, ja-JP, ko-KR, pl-PL, pt-BR, pt-PT, ru-RU, zh-CN, zh-HK, zh-TW) do (
			if "%LanguagePackCode%" equ "%%z" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating WinPE - Speech TextToSpeech [%LanguagePackCode%] to Windows Recovery Image...
				echo.-------------------------[WinRE.wim, Index : 1]--------------------------------
				call :AddPackage "%WinReMount%", "%LanguagePacks%\WinPE-Speech-TTS-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab"
			)
		)
	)
	if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "15063" (
		echo.-------------------------------------------------------------------------------
		echo.Integrating WinPE - Speech TextToSpeech [%LanguagePackCode%] to Windows Recovery Image...
		echo.-------------------------[WinRE.wim, Index : 1]--------------------------------
		call :AddPackage "%WinReMount%", "%LanguagePacks%\WinPE-Speech-TTS-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WinPE - SRH [%LanguagePackCode%] to Windows Recovery Image...
		echo.-------------------------[WinRE.wim, Index : 1]--------------------------------
		call :AddPackage "%WinReMount%", "%LanguagePacks%\WinPE-SRH-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
	)
	echo.-------------------------------------------------------------------------------
	echo.Integrating WinPE - SRT Pack [%LanguagePackCode%] to Windows Recovery Image...
	echo.-------------------------[WinRE.wim, Index : 1]--------------------------------
	if "%SelectedSourceOS%" equ "w7" call :AddPackage "%WinReMount%", "%LanguagePacks%\WinPE-SRT-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
	if "%SelectedSourceOS%" equ "w81" call :AddPackage "%WinReMount%", "%LanguagePacks%\WinPE-SRT-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
	if "%SelectedSourceOS%" equ "w10" call :AddPackage "%WinReMount%", "%LanguagePacks%\WinPE-SRT-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
	if "%SelectedSourceOS%" neq "w7" (
		echo.-------------------------------------------------------------------------------
		echo.Integrating WinPE - Storage WMI Pack [%LanguagePackCode%] to Windows Recovery Image...
		echo.-------------------------[WinRE.wim, Index : 1]--------------------------------
		if "%SelectedSourceOS%" equ "w81" call :AddPackage "%WinReMount%", "%LanguagePacks%\WinPE-StorageWMI-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		if "%SelectedSourceOS%" equ "w10" call :AddPackage "%WinReMount%", "%LanguagePacks%\WinPE-StorageWMI-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
	)
	echo.-------------------------------------------------------------------------------
	echo.Integrating WinPE - WDS Pack [%LanguagePackCode%] to Windows Recovery Image...
	echo.-------------------------[WinRE.wim, Index : 1]--------------------------------
	if "%SelectedSourceOS%" equ "w7" call :AddPackage "%WinReMount%", "%LanguagePacks%\WinPE-WDS-Tools-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
	if "%SelectedSourceOS%" equ "w81" call :AddPackage "%WinReMount%", "%LanguagePacks%\WinPE-WDS-Tools-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
	if "%SelectedSourceOS%" equ "w10" call :AddPackage "%WinReMount%", "%LanguagePacks%\WinPE-WDS-Tools-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
	if "%SelectedSourceOS%" equ "w10" if exist "%LanguagePacks%\WinPE-WiFi-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab" (
		echo.-------------------------------------------------------------------------------
		echo.Integrating WinPE - WiFi Pack [%LanguagePackCode%] to Windows Recovery Image...
		echo.-------------------------[WinRE.wim, Index : 1]--------------------------------
		call :AddPackage "%WinReMount%", "%LanguagePacks%\WinPE-WiFi-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
	)			
	echo.-------------------------------------------------------------------------------
	echo.Integrating WinPE - WMI Pack [%LanguagePackCode%] to Windows Recovery Image...
	echo.-------------------------[WinRE.wim, Index : 1]--------------------------------
	if "%SelectedSourceOS%" equ "w7" call :AddPackage "%WinReMount%", "%LanguagePacks%\WinPE-WMI-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
	if "%SelectedSourceOS%" equ "w81" call :AddPackage "%WinReMount%", "%LanguagePacks%\WinPE-WMI-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
	if "%SelectedSourceOS%" equ "w10" call :AddPackage "%WinReMount%", "%LanguagePacks%\WinPE-WMI-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
	for /d %%z in (ja-JP, ko-KR, zh-HK, zh-CN, zh-TW) do (
		if "%LanguagePackCode%" equ "%%z" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating WinPE - Font Support Pack [%LanguagePackCode%] to Windows Recovery Image...
			echo.-------------------------[WinRE.wim, Index : 1]--------------------------------
			if "%SelectedSourceOS%" equ "w7" call :AddPackage "%WinReMount%", "%LanguagePacks%\WinPE-FontSupport-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
			if "%SelectedSourceOS%" equ "w81" call :AddPackage "%WinReMount%", "%LanguagePacks%\WinPE-FontSupport-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
			if "%SelectedSourceOS%" equ "w10" call :AddPackage "%WinReMount%", "%LanguagePacks%\WinPE-FontSupport-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~%ImageVersion%.%PackageServicePackBuild%.cab"
		)
	)
)

if "%IsLogsEnabled%" equ "Yes" (
	echo.-------------------------------------------------------------------------------
	echo.####Generating Windows Language Packs Integration Log Files####################
	echo.-------------------------------------------------------------------------------
	echo.
	if "%LanguagePackType%" equ "Boot" (
		for /l %%i in (1, 1, 2) do (
			echo.Windows Language Packs Integration [Boot.wim, Index : %%i] Log...
			call :GetPackages "%BootMount%\%%i", "Boot-%%i.txt"
			echo.
		)
	)
	if "%LanguagePackType%" equ "Install" (
		if "%ImageIndexNo%" equ "*" (
			echo.Windows Language Packs Integration [Install.wim, Index : 1-%ImageCount%] Log...
			for /L %%i in (1, 1, %ImageCount%) do (
				call :GetPackages "%InstallMount%\%%i", "LanguagePacks_Install-%%i.txt"
				echo.
			)
		) else (
			echo.Windows Language Packs Integration [Install.wim, Index : %ImageIndexNo%] Log...
			call :GetPackages "%InstallMount%", "LanguagePacks_Install.txt"
			echo.
		)
	)
	if "%LanguagePackType%" equ "Recovery" (
		echo.Windows Language Packs Integration [WinRE.wim, Index : 1] Log...
		call :GetPackages "%WinReMount%", "LanguagePacks_Install_WinRE.txt"
		echo.
	)
)
echo.-------------------------------------------------------------------------------
echo.####Cleaning Up Temporary Files ^& Folders######################################
echo.-------------------------------------------------------------------------------
echo.
echo.Cleaning Up Temporary folder...
call :RemoveFolder "%Temp%\LanguagePack"
echo.
echo.-------------------------------------------------------------------------------
if "%LanguagePackType%" equ "Boot" echo.####Finished Integrating Windows Language Packs to Windows Boot Image##########
if "%LanguagePackType%" equ "Install" echo.####Finished Integrating Windows Language Packs to Windows Installation Image##
if "%LanguagePackType%" equ "Recovery" echo.####Finished Integrating Windows Language Packs to Windows Reocvery Image######
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set LanguagePacks=
set LanguagePackType=
set LanguagePackCode=
set PackageArchitecture=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Windows Drivers
::-------------------------------------------------------------------------------------------
:IntDrivers

setlocal

set DriverType=

cls
echo.===============================================================================
echo.                MSMG ToolKit - Integrate Windows Drivers Menu
echo.===============================================================================
echo.
echo.  [1]   Integrate to Windows Setup Boot Image
echo.
echo.  [2]   Integrate to Windows Installation Image
echo.
echo.  [3]   Integrate to Windows Recovery Image
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.  [X]   Go Back
echo.
echo.===============================================================================
echo.
choice /C:123X /N /M "Enter Your Choice : "
if errorlevel 4 goto :IntegrateMenu
if errorlevel 3 set DriverType=Recovery
if errorlevel 2 set DriverType=Install
if errorlevel 1 set DriverType=Boot

cls
echo.===============================================================================
if "%DriverType%" equ "Boot" echo.     MSMG ToolKit - Integrate Windows Drivers to Windows Setup Boot Image
if "%DriverType%" equ "Install" echo.    MSMG ToolKit - Integrate Windows Drivers to Windows Installation Image
if "%DriverType%" equ "Recovery" echo.      MSMG ToolKit - Integrate Windows Drivers to Windows Recovery Image
echo.===============================================================================
echo.
if "%DriverType%" equ "Boot" if "%IsBootImageSelected%" equ "No" (
	echo.Windows Setup Boot Image is not selected...
	echo.
	echo.Please choose Windows Setup Boot Image while selecting Source...
	goto :Stop	
)

if "%DriverType%" equ "Recovery" if "%IsRecoveryImageSelected%" equ "No" (
	echo.Windows Recovery Image is not selected...
	echo.
	echo.Please choose Windows Recovery Image while selecting Source...
	goto :Stop	
)

:: Getting Source Image Index Architecture
if "%DriverType%" equ "Boot" call :GetImageArchitecture "%BootWim%", 1 >nul
if "%DriverType%" equ "Recovery" (
	if "%ImageIndexNo%" equ "*" call :GetImageArchitecture "%InstallMount%\1\%WinReWim%", 1 >nul
	if "%ImageIndexNo%" neq "*" call :GetImageArchitecture "%InstallMount%\%WinReWim%", 1 >nul
)
if "%DriverType%" equ "Install" (
	if "%ImageIndexNo%" equ "*" call :GetImageArchitecture "%InstallWim%", 1 >nul
	if "%ImageIndexNo%" neq "*" call :GetImageArchitecture "%InstallWim%", %ImageIndexNo% >nul
)

:: Settings Windows Drivers folder path
if "%DriverType%" equ "Boot" set "Drivers=%Drivers%\WinPE\%SelectedSourceOS%\%ImageArchitecture%"
if "%DriverType%" equ "Install" set "Drivers=%Drivers%\Install\%SelectedSourceOS%\%ImageArchitecture%"
if "%DriverType%" equ "Recovery" set "Drivers=%Drivers%\WinPE\%SelectedSourceOS%\%ImageArchitecture%"

:: Checking whether Windows Drivers folder is empty
for /f %%i in ('dir /b /s /a:-d "%Drivers%\*.*" 2^>nul ^| find /v /c ""') do (
	if "%%i" equ "0" (
		if "%DriverType%" equ "Boot" echo.Windows Drivers folder ^<Drivers\WinPE\%SelectedSourceOS%\%ImageArchitecture%^> is empty...
		if "%DriverType%" equ "Install" echo.Windows Drivers folder ^<Drivers\Install\%SelectedSourceOS%\%ImageArchitecture%^> is empty...
		if "%DriverType%" equ "Recovery" echo.Windows Drivers folder ^<Drivers\WinPE\%SelectedSourceOS%\%ImageArchitecture%^> is empty...
		echo.
		echo.Please copy Windows Drivers files to respective folder...
		goto :Stop
	)
)
echo.-------------------------------------------------------------------------------
if "%DriverType%" equ "Boot" echo.####Starting Integrating Windows Drivers to Windows Boot Image#################
if "%DriverType%" equ "Install" echo.####Starting Integrating Windows Drivers to Windows Installation Image#########
if "%DriverType%" equ "Recovery" echo.####Starting Integrating Windows Drivers to Windows Reocvery Image#############
echo.-------------------------------------------------------------------------------
echo.
if "%DriverType%" equ "Boot" (
	echo.    Image                    : Boot.wim
	echo.    Image Index              : 2
)
if "%DriverType%" equ "Install" (
	echo.    Image                    : Install.wim
	if "%ImageIndexNo%" equ "*" echo.    Image Indexes            : 1-%ImageCount%
	if "%ImageIndexNo%" neq "*" echo.    Image Index              : %ImageIndexNo%
)
if "%DriverType%" equ "Recovery" (
	echo.    Image                    : WinRE.wim
	echo.    Image Index              : 1
)
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
if "%ImageIndexNo%" neq "*" echo.    Image Edition            : %ImageEdition%
echo.    Image Default Language   : %ImageDefaultLanguage%
echo.
echo.-------------------------------------------------------------------------------
if "%DriverType%" equ "Boot" echo.####Integrating Windows Drivers to Windows Boot Image##########################
if "%DriverType%" equ "Install" echo.####Integrating Windows Drivers to Windows Installation Image##################
if "%DriverType%" equ "Recovery" echo.####Integrating Windows Drivers to Windows Reocvery Image######################
echo.-------------------------------------------------------------------------------

if "%DriverType%" equ "Boot" call :AddDriver "%BootMount%\2", "%Drivers%"

if "%DriverType%" equ "Install" (
	if "%ImageIndexNo%" equ "*" (
		echo.
		for /L %%i in (1, 1, %ImageCount%) do (
			echo.-------------------------[Install.wim, Index : %%i]---------------------------------
			call :AddDriver "%InstallMount%\%%i", "%Drivers%"
		)
	) else (
		call :AddDriver "%InstallMount%", "%Drivers%"
	)
)

if "%DriverType%" equ "Recovery" call :AddDriver "%WinReMount%", "%Drivers%"

echo.-------------------------------------------------------------------------------
if "%DriverType%" equ "Boot" echo.####Finished Integrating Windows Drivers to Windows Boot Image#################
if "%DriverType%" equ "Install" echo.####Finished Integrating Windows Drivers to Windows Installation Image#########
if "%DriverType%" equ "Recovery" echo.####Finished Integrating Windows Drivers to Windows Reocvery Image#############
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set Drivers=
set DriverType=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Microsoft .NET Framework 3.5
::-------------------------------------------------------------------------------------------
:IntNetFX35

setlocal

set PackageArchitecture=

cls
echo.===============================================================================
echo.            MSMG ToolKit - Integrate Microsoft .NET Framework 3.5
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
if "%ImageIndexNo%" equ "*" call :GetImageArchitecture "%InstallWim%", 1 >nul
if "%ImageIndexNo%" neq "*" call :GetImageArchitecture "%InstallWim%", %ImageIndexNo% >nul

:: Setting Package Service Pack Build
if "%SelectedSourceOS%" equ "w10" (
	if "%ImageBuild%" equ "10240" set "PackageServicePackBuild=16384"
	if "%ImageBuild%" equ "10586" set "PackageServicePackBuild=0"
	if "%ImageBuild%" equ "14393" set "PackageServicePackBuild=0"
	if "%ImageBuild%" equ "15063" set "PackageServicePackBuild=0"
	if "%ImageBuild%" equ "16299" set "PackageServicePackBuild=15"
	if "%ImageBuild%" equ "17134" set "PackageServicePackBuild=1"
	if "%ImageBuild%" equ "17763" set "PackageServicePackBuild=1"
	if "%ImageBuild%" equ "18362" set "PackageServicePackBuild=1"
	if "%ImageBuild%" equ "19041" set "PackageServicePackBuild=1"
)

:: Setting Package Architecture
if "%ImageArchitecture%" equ "x86" set "PackageArchitecture=x86"
if "%ImageArchitecture%" equ "x64" set "PackageArchitecture=amd64"
if "%ImageArchitecture%" equ "arm" set "PackageArchitecture=arm"
if "%ImageArchitecture%" equ "arm64" set "PackageArchitecture=arm64"

:: Setting Microsoft .NET Framework 3.5 Feature Pack folder path according to Source Image Architecture
if exist "%DVD%\sources\sxs" (
	if "%SelectedSourceOS%" equ "w81" set "NetFX35=%DVD%\sources\sxs"
	if "%SelectedSourceOS%" equ "w10" (
		if "%ImageBuild%" leq "16299" set "NetFX35=%DVD%\sources\sxs\microsoft-windows-netfx3-ondemand-package.cab"
		if "%ImageBuild%" geq "17134" set "NetFX35=%DVD%\sources\sxs\microsoft-windows-netfx3-ondemand-package~31bf3856ad364e35~%PackageArchitecture%~~.cab"
	)
) else (
	if "%SelectedSourceOS%" equ "w81" set "NetFX35=%NetFX35%\%SelectedSourceOS%\%ImageArchitecture%"
	if "%SelectedSourceOS%" equ "w10" set "NetFX35=%NetFX35%\%SelectedSourceOS%\10.0.%ImageBuild%\Microsoft-Windows-NetFx3-OnDemand-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab"
)

:: Checking whether Microsoft .NET Framework 3.5 Feature Pack folder exist
if "%SelectedSourceOS%" equ "w81" if not exist "%NetFX35%\msil_system.net_b03f5f7f11d50a3a_6.3.9600.16384_none_78f2900af99c8442\system.net.dll" (
	echo.Microsoft .NET Framework 3.5 Pack folder is missing or empty...
	echo.
	echo.Please copy the files to ^<Packs\NetFX35\w81\%ImageArchitecture%^> folder...
	echo.
	goto :Stop
)

:: Checking whether Microsoft .NET Framework 3.5 Feature Pack folder exist
if "%SelectedSourceOS%" equ "w10" if not exist %NetFX35% (
	echo.Microsoft .NET Framework 3.5 Pack file is missing...
	echo.
	if "%ImageBuild%" leq "16299" echo.Either copy the "microsoft-windows-netfx3-ondemand-package.cab" file from Source DVD to ^<DVD\sources\sxs^> folder
	if "%ImageBuild%" geq "17134" echo.Either copy the "microsoft-windows-netfx3-ondemand-package~31bf3856ad364e35~%PackageArchitecture%~~.cab" from Source DVD to ^<DVD\sources\sxs^> folder
	echo.
	echo.or Copy the below ToolKit Pack file to ^<Packs\NetFX35\%SelectedSourceOS%\10.0.%ImageBuild%^> folder..
	echo.	
	echo."Microsoft-Windows-NetFx3-OnDemand-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	goto :Stop
)

if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "17763" if "%NetFX35%" neq "%DVD%\sources\sxs\microsoft-windows-netfx3-ondemand-package~31bf3856ad364e35~%PackageArchitecture%~~.cab" if exist %NetFX35% (
	copy /y %NetFX35% "%Temp%\microsoft-windows-netfx3-ondemand-package~31bf3856ad364e35~%PackageArchitecture%~~.cab" >nul
	set "NetFX35=%Temp%\microsoft-windows-netfx3-ondemand-package~31bf3856ad364e35~%PackageArchitecture%~~.cab"
)
echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Microsoft .NET Framework 3.5##########################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if "%ImageIndexNo%" equ "*" echo.    Image Indexes            : 1-%ImageCount%
if "%ImageIndexNo%" neq "*" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
if "%ImageIndexNo%" neq "*" echo.    Image Edition            : %ImageEdition%
echo.    Image Default Language   : %ImageDefaultLanguage%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Microsoft .NET Framework 3.5###################################
echo.-------------------------------------------------------------------------------
if "%ImageIndexNo%" equ "*" (
	echo.
	for /L %%i in (1, 1, %ImageCount%) do (
		if not %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]#############################
		if %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]############################
		echo.
		echo.Checking whether Microsoft .NET Framework 3.5 is enabled...
		if "%SelectedSourceOS%" equ "w81" (
			%DISM% /Image:"%InstallMount%\%%i" /Get-FeatureInfo /FeatureName:NetFX3 | findstr /c:"State : Enable Pending" >nul
			if errorlevel 1 (
				echo.Microsoft .NET Framework 3.5 is not enabled...
				echo.
				echo.-------------------------------------------------------------------------------
				echo.Integrating Microsoft .NET Framework 3.5 Package...
				echo.-------------------------------------------------------------------------------
				%DISM% /Image:"%InstallMount%\%%i" /Enable-Feature /All /LimitAccess /FeatureName:NetFX3 /Source:%NetFX35%
				echo.
				if "%IsLogsEnabled%" equ "Yes" (
					echo.-------------------------------------------------------------------------------
					echo.####Generating Microsoft .NET Framework 3.5 Integration log files##############
					echo.-------------------------------------------------------------------------------
					echo.
					echo.Writing Microsoft .NET Framework 3.5 Integration log file...
					call :GetFeatures "%InstallMount%\%%i", "NetFX35-%%i.txt"
					echo.
				)
				if "%%i" equ "%ImageCount%" (
					echo.-------------------------------------------------------------------------------
					echo.####Finished Integrating Microsoft .NET Framework 3.5##########################
					echo.-------------------------------------------------------------------------------
					echo.
				)
			) else (
				echo.Microsoft .NET Framework 3.5 has already been enabled...
				echo.
				echo.Skipping Integrating Microsoft .NET Framework 3.5...
				if "%%i" equ "%ImageCount%" (
					echo.
					echo.-------------------------------------------------------------------------------
					echo.####Stopped Integrating Microsoft .NET Framework 3.5###########################
					echo.-------------------------------------------------------------------------------
					echo.
				)
			)
		)
		if "%SelectedSourceOS%" equ "w10" (
			%DISM% /Image:"%InstallMount%\%%i" /Get-FeatureInfo /FeatureName:NetFx3 | findstr /c:"State : Enabled" >nul
			if errorlevel 1 (
				echo.Microsoft .NET Framework 3.5 is not enabled...
				echo.
				echo.-------------------------------------------------------------------------------
				echo.Integrating Microsoft .NET Framework 3.5 Package...
				echo.-------------------------------------------------------------------------------
				%DISM% /Image:"%InstallMount%\%%i" /Add-Package:%NetFX35%
				echo.
			
				if "%IsLogsEnabled%" equ "Yes" (
					echo.-------------------------------------------------------------------------------
					echo.####Generating Microsoft .NET Framework 3.5 Integration log files##############
					echo.-------------------------------------------------------------------------------
					echo.
					echo.Writing Microsoft .NET Framework 3.5 Integration log file...
					call :GetFeatures "%InstallMount%\%%i", "NetFX35-%%i.txt"
					echo.          
				)
				if "%%i" equ "%ImageCount%" (
					echo.-------------------------------------------------------------------------------
					echo.####Finished Integrating Microsoft .NET Framework 3.5##########################
					echo.-------------------------------------------------------------------------------
					echo.
				)
			) else (
				echo.Microsoft .NET Framework 3.5 has already been enabled...
				echo.
				echo.Skipping Integrating Microsoft .NET Framework 3.5...
				if "%%i" equ "%ImageCount%" (
					echo.
					echo.-------------------------------------------------------------------------------
					echo.####Stopped Integrating Microsoft .NET Framework 3.5###########################
					echo.-------------------------------------------------------------------------------
					echo.
				)
			)
		)
	)
) else (
	echo.
	echo.Checking whether Microsoft .NET Framework 3.5 is enabled...
	if "%SelectedSourceOS%" equ "w81" (
		%DISM% /Image:"%InstallMount%" /Get-FeatureInfo /FeatureName:NetFX3 | findstr /c:"State : Enable Pending" >nul
		if errorlevel 1 (
			echo.Microsoft .NET Framework 3.5 is not enabled...
			echo.
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft .NET Framework 3.5 Package...
			echo.-------------------------------------------------------------------------------
			%DISM% /Image:"%InstallMount%" /Enable-Feature /All /LimitAccess /FeatureName:NetFX3 /Source:%NetFX35%
			echo.
			if "%IsLogsEnabled%" equ "Yes" (
				echo.-------------------------------------------------------------------------------
				echo.####Generating Microsoft .NET Framework 3.5 Integration log files##############
				echo.-------------------------------------------------------------------------------
				echo.
				echo.Writing Microsoft .NET Framework 3.5 Integration log file...
				call :GetFeatures "%InstallMount%", "NetFX35.txt"
				echo.
			)
			echo.-------------------------------------------------------------------------------
			echo.####Finished Integrating Microsoft .NET Framework 3.5##########################
			echo.-------------------------------------------------------------------------------
			echo.
		) else (
			echo.Microsoft .NET Framework 3.5 has already been enabled...
			echo.
			echo.-------------------------------------------------------------------------------
			echo.####Stopped Integrating Microsoft .NET Framework 3.5###########################
			echo.-------------------------------------------------------------------------------
			echo.
			goto :Stop
		)
	)
	if "%SelectedSourceOS%" equ "w10" (
		%DISM% /Image:"%InstallMount%" /Get-FeatureInfo /FeatureName:NetFx3 | findstr /c:"State : Enabled" >nul
		if errorlevel 1 (
			echo.Microsoft .NET Framework 3.5 is not enabled...
			echo.
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft .NET Framework 3.5 Package...
			echo.-------------------------------------------------------------------------------
			%DISM% /Image:"%InstallMount%" /Add-Package:%NetFX35%
			echo.
			
			if "%IsLogsEnabled%" equ "Yes" (
				echo.-------------------------------------------------------------------------------
				echo.####Generating Microsoft .NET Framework 3.5 Integration log files##############
				echo.-------------------------------------------------------------------------------
				echo.
				echo.Writing Microsoft .NET Framework 3.5 Integration log file...
				call :GetFeatures "%InstallMount%", "NetFX35.txt"
				echo.          
			)
			echo.-------------------------------------------------------------------------------
			echo.####Finished Integrating Microsoft .NET Framework 3.5##########################
			echo.-------------------------------------------------------------------------------
			echo.
		) else (
			echo.Microsoft .NET Framework 3.5 has already been enabled...
			echo.
			echo.-------------------------------------------------------------------------------
			echo.####Stopped Integrating Microsoft .NET Framework 3.5###########################
			echo.-------------------------------------------------------------------------------
			echo.
			goto :Stop
		)
	)
)
call :RemoveFile "%Temp%\microsoft-windows-netfx3-ondemand-package~31bf3856ad364e35~%PackageArchitecture%~~.cab"
:Stop
echo.===============================================================================
echo.
pause

set NetFX35=
set PackageArchitecture=
set PackageServicePackBuild=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Microsoft .NET Framework 4.6.2 for Windows 10 v1507 & v1511 Source OS
::-------------------------------------------------------------------------------------------
:IntNetFX462

setlocal

cls
echo.===============================================================================
echo.           MSMG ToolKit - Integrate Microsoft .NET Framework 4.6.2
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
if "%ImageIndexNo%" equ "*" call :GetImageArchitecture "%InstallWim%", 1 >nul
if "%ImageIndexNo%" neq "*" call :GetImageArchitecture "%InstallWim%", %ImageIndexNo% >nul

:: Setting Image Package Architecture
if "%ImageArchitecture%" equ "x86" set "PackageArchitecture=x86"
if "%ImageArchitecture%" equ "x64" set "PackageArchitecture=amd64"

:: Checking whether Microsoft .NET Framework 4.6.2 Pack file exist
if not exist "%NetFX462%\Microsoft-Windows-NetFX462-Package~31bf3856ad364e35~%PackageArchitecture%.cab" (
	echo.Microsoft .NET Framework 4.6.2 Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-NetFX462-Package~31bf3856ad364e35~%PackageArchitecture%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\NetFX462^> folder...
	goto :Stop
)

:: Checking whether Microsoft .NET Framework 4.6.2 Pack file exist
if "%ImageBuild%" equ "10240" if "%ImageEdition%" neq "Core" if "%ImageEdition%" neq "CoreN" if "%ImageEdition%" neq "CoreSingleLanguage" if "%ImageEdition%" neq "Education" if "%ImageEdition%" neq "EducationN" if "%ImageEdition%" neq "Professional" if "%ImageEdition%" neq "ProfessionalN" if "%ImageEdition%" neq "Enterprise" if "%ImageEdition%" neq "EnterpriseN" (
	if not exist "%NetFX462%\Windows10.0-KB4051600-%ImageArchitecture%.cab" (
		echo.Microsoft .NET Framework 4.6.2 Pack folder is missing the below file...
		echo.
		echo."Windows10.0-KB4051600-%ImageArchitecture%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\NetFX462^> folder...
		goto :Stop
	)
)

:: Checking whether Microsoft .NET Framework 4.6.2 Pack file exist
if "%ImageBuild%" equ "10586" if "%ImageEdition%" neq "Core" if "%ImageEdition%" neq "CoreN" if "%ImageEdition%" neq "CoreSingleLanguage" if "%ImageEdition%" neq "Professional" if "%ImageEdition%" neq "ProfessionalN" (
	if not exist "%NetFX462%\Windows10.0-KB4054057-%ImageArchitecture%.cab" (
		echo.Microsoft .NET Framework 4.6.2 Pack folder is missing the below file...
		echo.
		echo."Windows10.0-KB4054057-%ImageArchitecture%.cab""
		echo.
		echo.Please copy the above file to ^<Packs\NetFX462^> folder...
		goto :Stop
	)
)
echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Microsoft .NET Framework 4.6.2########################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if "%ImageIndexNo%" equ "*" echo.    Image Indexes            : 1-%ImageCount%
if "%ImageIndexNo%" neq "*" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
if "%ImageIndexNo%" neq "*" echo.    Image Edition            : %ImageEdition%
echo.    Image Default Language   : %ImageDefaultLanguage%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Microsoft .NET Framework 4.6.2#################################
echo.-------------------------------------------------------------------------------
echo.
if "%ImageIndexNo%" equ "*" (
	for /L %%i in (1, 1, %ImageCount%) do (		
		if not %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]#############################
		if %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]############################

		:: Getting Image Index Information
		call :GetImageIndexInfo "%InstallWim%", %%i >nul

		echo.
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft .NET Framework 4.6.2 Base Package...
		echo.-------------------------------------------------------------------------------
		call :AddPackage "%InstallMount%\%%i", "%NetFX462%\Microsoft-Windows-NetFX462-Package~31bf3856ad364e35~%PackageArchitecture%.cab"
		if exist "%NetFX462%\Microsoft-Windows-NetFX462-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%.cab" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft .NET Framework 4.6.2 [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%\%%i", "%NetFX462%\Microsoft-Windows-NetFX462-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%.cab"
		)
		if "%ImageBuild%" equ "10240" if "%ImageEdition%" neq "Core" if "%ImageEdition%" neq "CoreN" if "%ImageEdition%" neq "CoreSingleLanguage" if "%ImageEdition%" neq "Education" if "%ImageEdition%" neq "EducationN" if "%ImageEdition%" neq "Professional" if "%ImageEdition%" neq "ProfessionalN" if "%ImageEdition%" neq "Enterprise" if "%ImageEdition%" neq "EnterpriseN" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft .NET Framework 4.6.2 Update Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%\%%i", "%NetFX462%\Windows10.0-KB4051600-%ImageArchitecture%.cab"
		)
		if "%ImageBuild%" equ "10586" if "%ImageEdition%" neq "Core" if "%ImageEdition%" neq "CoreN" if "%ImageEdition%" neq "CoreSingleLanguage" if "%ImageEdition%" neq "Professional" if "%ImageEdition%" neq "ProfessionalN" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft .NET Framework 4.6.2 Update Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%\%%i", "%NetFX462%\Windows10.0-KB4054057-%ImageArchitecture%.cab"
		)
	)
) else (
	echo.-------------------------------------------------------------------------------
	echo.Integrating Microsoft .NET Framework 4.6.2 Base Package...
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%NetFX462%\Microsoft-Windows-NetFX462-Package~31bf3856ad364e35~%PackageArchitecture%.cab"
	if exist "%NetFX462%\Microsoft-Windows-NetFX462-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%.cab" (
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft .NET Framework 4.6.2 [%ImageDefaultLanguage%] Language Package...
		echo.-------------------------------------------------------------------------------
		call :AddPackage "%InstallMount%", "%NetFX462%\Microsoft-Windows-NetFX462-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%.cab"
	)
	if "%ImageBuild%" equ "10240" if "%ImageEdition%" neq "Core" if "%ImageEdition%" neq "CoreN" if "%ImageEdition%" neq "CoreSingleLanguage" if "%ImageEdition%" neq "Education" if "%ImageEdition%" neq "EducationN" if "%ImageEdition%" neq "Professional" if "%ImageEdition%" neq "ProfessionalN" if "%ImageEdition%" neq "Enterprise" if "%ImageEdition%" neq "EnterpriseN" (
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft .NET Framework 4.6.2 Update Package...
		echo.-------------------------------------------------------------------------------
		call :AddPackage "%InstallMount%", "%NetFX462%\Windows10.0-KB4051600-%ImageArchitecture%.cab"
	)
	if "%ImageBuild%" equ "10586" if "%ImageEdition%" neq "Core" if "%ImageEdition%" neq "CoreN" if "%ImageEdition%" neq "CoreSingleLanguage" if "%ImageEdition%" neq "Professional" if "%ImageEdition%" neq "ProfessionalN" (
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft .NET Framework 4.6.2 Update Package...
		echo.-------------------------------------------------------------------------------
		call :AddPackage "%InstallMount%", "%NetFX462%\Windows10.0-KB4054057-%ImageArchitecture%.cab"
	)
)
echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Microsoft .NET Framework 4.6.2########################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set NetFX462=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Microsoft .NET Framework 4.8
::-------------------------------------------------------------------------------------------
:IntNetFX48

setlocal

set NetFX48Pkg=
set NetFX48LpPkg=

cls
echo.===============================================================================
echo.          MSMG ToolKit - Integrate Microsoft .NET Framework 4.8
echo.===============================================================================
echo.

:: Setting Microsoft .NET Framework 4.8 Pack folder path
set "NetFX48=%NetFX48%\%SelectedSourceOS%"

:: Getting Install Image Index Architecture
if "%ImageIndexNo%" equ "*" call :GetImageArchitecture "%InstallWim%", 1 >nul
if "%ImageIndexNo%" neq "*" call :GetImageArchitecture "%InstallWim%", %ImageIndexNo% >nul

:: Setting Image Package Architecture
if "%ImageArchitecture%" equ "x86" set "PackageArchitecture=x86"
if "%ImageArchitecture%" equ "x64" set "PackageArchitecture=amd64"
if "%ImageArchitecture%" equ "arm" set "PackageArchitecture=arm"
if "%ImageArchitecture%" equ "arm64" set "PackageArchitecture=arm64"

:: Setting Image Package ServicePackBuildLevel
if "%SelectedSourceOS%" equ "w10" (
	if "%ImageBuild%" equ "14393" set "NetFX48Pkg=Microsoft-Windows-NetFX48-Package~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0.cab"
	if "%ImageBuild%" equ "14393" set "NetFX48LpPkg=Microsoft-Windows-NetFX48-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%~10.0.14393.0.cab"	
	if "%ImageBuild%" equ "15063" set "NetFX48Pkg=Microsoft-Windows-NetFX48-Package~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0.cab"
	if "%ImageBuild%" equ "15063" set "NetFX48LpPkg=Microsoft-Windows-NetFX48-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%~10.0.14393.0.cab"	
	if "%ImageBuild%" equ "16299" set "NetFX48Pkg=Microsoft-Windows-NetFX48-Package~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15.cab"
	if "%ImageBuild%" equ "16299" set "NetFX48LpPkg=Microsoft-Windows-NetFX48-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%~10.0.16299.15.cab"	
	if "%ImageBuild%" equ "17134" set "NetFX48Pkg=Microsoft-Windows-NetFX48-Package~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15.cab"
	if "%ImageBuild%" equ "17134" set "NetFX48LpPkg=Microsoft-Windows-NetFX48-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%~10.0.16299.15.cab"	
	if "%ImageBuild%" equ "17763" set "NetFX48Pkg=Microsoft-Windows-NetFX48-Package~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15.cab"
	if "%ImageBuild%" equ "17763" set "NetFX48LpPkg=Microsoft-Windows-NetFX48-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%~10.0.16299.15.cab"
)

:: Checking whether Microsoft .NET Framework 4.8 Pack file exist
if "%SelectedSourceOS%" equ "w7" if not exist "%NetFX48%\Windows6.1-KB4019990-%ImageArchitecture%.cab" (
	echo.Microsoft .NET Framework 4.8 Pack folder is missing the below file...
	echo.
	echo."Windows6.1-KB4019990-%ImageArchitecture%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\NetFX48\%SelectedSourceOS%^> folder...
	goto :Stop
)

:: Checking whether Microsoft .NET Framework 4.8 Pack file exist
if "%SelectedSourceOS%" equ "w7" if not exist "%NetFX48%\NetFX48.tpk" (
	echo.Microsoft .NET Framework 4.8 Pack folder is missing the below file...
	echo.
	echo."NetFX48.tpk"
	echo.
	echo.Please copy the above file to ^<Packs\NetFX48\%SelectedSourceOS%^> folder...
	goto :Stop
)

:: Checking whether Microsoft .NET Framework 4.8 Pack file exist
if "%SelectedSourceOS%" equ "w7" if not exist "%NetFX48%\NetFX48_%ImageArchitecture%.reg" (
	echo.Microsoft .NET Framework 4.8 Pack folder is missing the below file...
	echo.
	echo."NetFX48_%ImageArchitecture%.reg"
	echo.
	echo.Please copy the above file to ^<Packs\NetFX48\%SelectedSourceOS%^> folder...
	goto :Stop
)

:: Checking whether Microsoft .NET Framework 4.8 Pack file exist
if "%SelectedSourceOS%" equ "w81" if not exist "%NetFX48%\Microsoft-Windows-NetFx48-Package~31bf3856ad364e35~%PackageArchitecture%~~6.3.9600.16384.cab" (
	echo.Microsoft .NET Framework 4.8 Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-NetFx48-Package~31bf3856ad364e35~%PackageArchitecture%~~6.3.9600.16384.cab"
	echo.
	echo.Please copy the above file to ^<Packs\NetFX48\%SelectedSourceOS%^> folder...
	goto :Stop
)

:: Checking whether Microsoft .NET Framework 4.8 Pack file exist
if "%SelectedSourceOS%" equ "w10" if not exist "%NetFX48%\%NetFX48Pkg%" (
	echo.Microsoft .NET Framework 4.8 Pack folder is missing the below file...
	echo.
	echo."%NetFX48Pkg%"
	echo.
	echo.Please copy the above file to ^<Packs\NetFX48\%SelectedSourceOS%^> folder...
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Microsoft .NET Framework 4.8##########################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if "%ImageIndexNo%" equ "*" echo.    Image Indexes            : 1-%ImageCount%
if "%ImageIndexNo%" neq "*" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
if "%ImageIndexNo%" neq "*" echo.    Image Edition            : %ImageEdition%
echo.    Image Default Language   : %ImageDefaultLanguage%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Microsoft .NET Framework 4.8###################################
echo.-------------------------------------------------------------------------------
if "%ImageIndexNo%" equ "*" (
	echo.
	for /L %%i in (1, 1, %ImageCount%) do (		
		if not %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]#############################
		if %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]############################

		:: Getting Image Index Information
		call :GetImageIndexInfo "%InstallWim%", %%i >nul

		if "%SelectedSourceOS%" equ "w7" (
			echo.
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft .NET Framework 4.8 Prerequisite Update Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%\%%i", "%NetFX48%\Windows6.1-KB4019990-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft .NET Framework 4.8 Base Package...
			echo.-------------------------------------------------------------------------------
			if "%ImageArchitecture%" equ "x86" call :ApplyImage "%NetFX48%\NetFX48.tpk", 1, "%InstallMount%\%%i"
			if "%ImageArchitecture%" equ "x64" call :ApplyImage "%NetFX48%\NetFX48.tpk", 2, "%InstallMount%\%%i"
			
			if exist "%NetFX48%\NetFX48_%ImageDefaultLanguage%.tpk" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Microsoft .NET Framework 4.8 [%ImageDefaultLanguage%] Language Package...
				echo.-------------------------------------------------------------------------------
				if "%ImageArchitecture%" equ "x86" call :ApplyImage "%NetFX48%\NetFX48_%ImageDefaultLanguage%.tpk", 1, "%InstallMount%\%%i"
				if "%ImageArchitecture%" equ "x64" call :ApplyImage "%NetFX48%\NetFX48_%ImageDefaultLanguage%.tpk", 2, "%InstallMount%\%%i"
			)

			echo.-------------------------------------------------------------------------------
			echo.####Importing Microsoft .NET Framework 4.8 Registry Settings###################
			echo.-------------------------------------------------------------------------------
			echo.
			echo.Mounting Image Registry...
			call :MountImageRegistry "%InstallMount%\%%i"
			echo.Importing Registry Settings to Image Registry...
			call :ImportRegistry2Image "%NetFX48%\NetFX48_%ImageArchitecture%.reg"

			if exist "%NetFX48%\NetFX48_%ImageArchitecture%_%ImageDefaultLanguage%.reg" (
				call :ImportRegistry2Image "%NetFX48%\NetFX48_%ImageArchitecture%_%ImageDefaultLanguage%.reg"
			)

			echo.Un-Mounting Image Registry...
			call :UnMountImageRegistry
			echo.
		)
		
		if "%SelectedSourceOS%" equ "w81" (
			if not exist "%NetFX48%\Microsoft-Windows-NetFX48-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%~6.3.9600.16384.cab" (
				call :AddPackage "%InstallMount%\%%i", "%NetFX48%\Microsoft-Windows-NetFX48-Package~31bf3856ad364e35~%PackageArchitecture%~~6.3.9600.16384.cab"
			)

			if exist "%NetFX48%\Microsoft-Windows-NetFX48-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%~6.3.9600.16384.cab" (
				echo.
				echo.-------------------------------------------------------------------------------
				echo.Integrating Microsoft .NET Framework 4.8 Base Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%NetFX48%\Microsoft-Windows-NetFX48-Package~31bf3856ad364e35~%PackageArchitecture%~~6.3.9600.16384.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Microsoft .NET Framework 4.8 [%ImageDefaultLanguage%] Language Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%NetFX48%\Microsoft-Windows-NetFX48-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%~6.3.9600.16384.cab"
			)		
		)

		if "%SelectedSourceOS%" equ "w10" (
			if not exist "%NetFX48%\%NetFX48LpPkg%" (
				call :AddPackage "%InstallMount%\%%i", "%NetFX48%\%NetFX48Pkg%"
			)

			if exist "%NetFX48%\%NetFX48LpPkg%" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Microsoft .NET Framework 4.8 Base Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%NetFX48%\%NetFX48Pkg%"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Microsoft .NET Framework 4.8 [%ImageDefaultLanguage%] Language Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%NetFX48%\%NetFX48LpPkg%"
			)		
		)
	)
) else (
	if "%SelectedSourceOS%" equ "w7" (
		echo.
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft .NET Framework 4.8 Prerequisite Update Package...
		echo.-------------------------------------------------------------------------------
		call :AddPackage "%InstallMount%", "%NetFX48%\Windows6.1-KB4019990-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft .NET Framework 4.8 Base Package...
		echo.-------------------------------------------------------------------------------
		if "%ImageArchitecture%" equ "x86" call :ApplyImage "%NetFX48%\NetFX48.tpk", 1, "%InstallMount%"
		if "%ImageArchitecture%" equ "x64" call :ApplyImage "%NetFX48%\NetFX48.tpk", 2, "%InstallMount%"

		if exist "%NetFX48%\NetFX48_%ImageDefaultLanguage%.tpk" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft .NET Framework 4.8 [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			if "%ImageArchitecture%" equ "x86" call :ApplyImage "%NetFX48%\NetFX48_%ImageDefaultLanguage%.tpk", 1, "%InstallMount%"
			if "%ImageArchitecture%" equ "x64" call :ApplyImage "%NetFX48%\NetFX48_%ImageDefaultLanguage%.tpk", 2, "%InstallMount%"
		)

		echo.-------------------------------------------------------------------------------
		echo.####Importing Microsoft .NET Framework 4.8 Registry Settings###################
		echo.-------------------------------------------------------------------------------
		echo.
		echo.Mounting Image Registry...
		call :MountImageRegistry "%InstallMount%"
		echo.Importing Registry Settings to Image Registry...
		call :ImportRegistry2Image "%NetFX48%\NetFX48_%ImageArchitecture%.reg"

		if exist "%NetFX48%\NetFX48_%ImageArchitecture%_%ImageDefaultLanguage%.reg" (
			call :ImportRegistry2Image "%NetFX48%\NetFX48_%ImageArchitecture%_%ImageDefaultLanguage%.reg"
		)

		echo.Un-Mounting Image Registry...
		call :UnMountImageRegistry
		echo.
	)
		
	if "%SelectedSourceOS%" equ "w81" (
		if not exist "%NetFX48%\Microsoft-Windows-NetFX48-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%~6.3.9600.16384.cab" (
			call :AddPackage "%InstallMount%", "%NetFX48%\Microsoft-Windows-NetFX48-Package~31bf3856ad364e35~%PackageArchitecture%~~6.3.9600.16384.cab"
		)

		if exist "%NetFX48%\Microsoft-Windows-NetFX48-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%~6.3.9600.16384.cab" (
			echo.
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft .NET Framework 4.8 Base Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%", "%NetFX48%\Microsoft-Windows-NetFX48-Package~31bf3856ad364e35~%PackageArchitecture%~~6.3.9600.16384.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft .NET Framework 4.8 [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%", "%NetFX48%\Microsoft-Windows-NetFX48-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%~6.3.9600.16384.cab"
		)		
	)

	if "%SelectedSourceOS%" equ "w10" (
		if not exist "%NetFX48%\%NetFX48LpPkg%" (
			call :AddPackage "%InstallMount%", "%NetFX48%\%NetFX48Pkg%"
		)

		if exist "%NetFX48%\%NetFX48LpPkg%" (
			echo.
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft .NET Framework 4.8 Base Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%", "%NetFX48%\%NetFX48Pkg%"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft .NET Framework 4.8 [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%", "%NetFX48%\%NetFX48LpPkg%"
		)		
	)
)
echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Microsoft .NET Framework 4.8##########################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set NetFX48=
set NetFX48Pkg=
set NetFX48LpPkg=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Microsoft Internet Explorer 11
::-------------------------------------------------------------------------------------------
:IntIE11

setlocal

cls
echo.===============================================================================
echo.             MSMG ToolKit - Integrate Microsoft Internet Explorer 11
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
if "%ImageIndexNo%" equ "*" call :GetImageArchitecture "%InstallWim%", 1 >nul
if "%ImageIndexNo%" neq "*" call :GetImageArchitecture "%InstallWim%", %ImageIndexNo% >nul

:: Setting Image Package Architecture
if "%ImageArchitecture%" equ "x86" set "PackageArchitecture=x86"
if "%ImageArchitecture%" equ "x64" set "PackageArchitecture=amd64"

:: Checking whether Microsoft Internet Explorer 11 Pack file exist
if not exist "%IE11%\Microsoft-Windows-PlatformUpdate-Win7-SRV08R2-Package~31bf3856ad364e35~%PackageArchitecture%.cab" (
	echo.Microsoft Internet Explorer 11 Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-PlatformUpdate-Win7-SRV08R2-Package~31bf3856ad364e35~%PackageArchitecture%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\IE11^> folder...
	goto :Stop
)

:: Checking whether Microsoft Internet Explorer 11 Pack file exist
if not exist "%IE11%\Microsoft-Windows-InternetExplorer-Package~31bf3856ad364e35~%PackageArchitecture%.cab" (
	echo.Microsoft Internet Explorer 11 Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-InternetExplorer-Package~31bf3856ad364e35~%PackageArchitecture%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\IE11^> folder...
	goto :Stop
)

:: Checking whether Microsoft Internet Explorer 11 Pack file exist
if "%ImageDefaultLanguage%" equ "en-US" if not exist "%IE11%\Microsoft-Windows-IE-Hyphenation-Package~31bf3856ad364e35~en-US.cab" (
	echo.Microsoft Internet Explorer 11 Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-IE-Hyphenation-Package~31bf3856ad364e35~en-US.cab"
	echo.
	echo.Please copy the above file to ^<Packs\IE11^> folder...
	goto :Stop
)

:: Checking whether Microsoft Internet Explorer 11 Pack file exist
if "%ImageDefaultLanguage%" equ "en-US" if not exist "%IE11%\Microsoft-Windows-IE-Spelling-Package~31bf3856ad364e35~en-US.cab" (
	echo.Microsoft Internet Explorer 11 Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-IE-Spelling-Package~31bf3856ad364e35~en-US.cab"
	echo.
	echo.Please copy the above file to ^<Packs\IE11^> folder...
	goto :Stop
)

:: Checking whether Microsoft Internet Explorer 11 Pack file exist
if "%ImageDefaultLanguage%" neq "en-US" if not exist "%IE11%\Microsoft-Windows-InternetExplorer-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%.cab" (
	echo.Microsoft Internet Explorer 11 Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-InternetExplorer-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\IE11^> folder...
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Microsoft Internet Explorer 11########################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if "%ImageIndexNo%" equ "*" echo.    Image Indexes            : 1-%ImageCount%
if "%ImageIndexNo%" neq "*" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
if "%ImageIndexNo%" neq "*" echo.    Image Edition            : %ImageEdition%
echo.    Image Default Language   : %ImageDefaultLanguage%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Microsoft Internet Explorer 11#################################
echo.-------------------------------------------------------------------------------
echo.
if "%ImageIndexNo%" equ "*" (
	for /L %%i in (1, 1, %ImageCount%) do (
		if not %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]#############################
		if %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]############################
		echo.
			
		:: Getting Image Index Information
		call :GetImageIndexInfo "%InstallWim%", %%i >nul

		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Internet Explorer 11 Prerequisite Package...
		echo.-------------------------------------------------------------------------------
		call :AddPackage "%InstallMount%\%%i", "%IE11%\Microsoft-Windows-PlatformUpdate-Win7-SRV08R2-Package~31bf3856ad364e35~%PackageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Internet Explorer 11 Base Package...
		echo.-------------------------------------------------------------------------------
		call :AddPackage "%InstallMount%\%%i", "%IE11%\Microsoft-Windows-InternetExplorer-Package~31bf3856ad364e35~%PackageArchitecture%.cab"

		if "%ImageDefaultLanguage%" equ "en-US" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Internet Explorer 11 Hyphenation Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%\%%i", "%IE11%\Microsoft-Windows-IE-Hyphenation-Package~31bf3856ad364e35~en-US.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Internet Explorer 11 Spelling Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%\%%i", "%IE11%\Microsoft-Windows-IE-Spelling-Package~31bf3856ad364e35~en-US.cab"
		)
		if "%ImageDefaultLanguage%" neq "en-US" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Internet Explorer 11 [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%\%%i", "%IE11%\Microsoft-Windows-InternetExplorer-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%.cab"
			
			if exist "%IE11%\Microsoft-Windows-IE-Hyphenation-Package~31bf3856ad364e35~%ImageDefaultLanguage%.cab" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Microsoft Internet Explorer 11 Hyphenation Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%IE11%\Microsoft-Windows-IE-Hyphenation-Package~31bf3856ad364e35~%ImageDefaultLanguage%.cab"
			) else (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Microsoft Internet Explorer 11 Hyphenation Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%IE11%\Microsoft-Windows-IE-Hyphenation-Package~31bf3856ad364e35~en-US.cab"
			)
			if exist "%IE11%\Microsoft-Windows-IE-Spelling-Package~31bf3856ad364e35~%ImageDefaultLanguage%.cab" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Microsoft Internet Explorer 11 Spelling Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%IE11%\Microsoft-Windows-IE-Spelling-Package~31bf3856ad364e35~%ImageDefaultLanguage%.cab"
			) else (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Microsoft Internet Explorer 11 Spelling Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%IE11%\Microsoft-Windows-IE-Spelling-Package~31bf3856ad364e35~en-US.cab"
			)			
		)
	)
) else (
	echo.-------------------------------------------------------------------------------
	echo.Integrating Microsoft Internet Explorer 11 Prerequisite Package...
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%IE11%\Microsoft-Windows-PlatformUpdate-Win7-SRV08R2-Package~31bf3856ad364e35~%PackageArchitecture%.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating Microsoft Internet Explorer 11 Base Package...
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%IE11%\Microsoft-Windows-InternetExplorer-Package~31bf3856ad364e35~%PackageArchitecture%.cab"

	if "%ImageDefaultLanguage%" equ "en-US" (
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Internet Explorer 11 Hyphenation Package...
		echo.-------------------------------------------------------------------------------
		call :AddPackage "%InstallMount%", "%IE11%\Microsoft-Windows-IE-Hyphenation-Package~31bf3856ad364e35~en-US.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Internet Explorer 11 Spelling Package...
		echo.-------------------------------------------------------------------------------
		call :AddPackage "%InstallMount%", "%IE11%\Microsoft-Windows-IE-Spelling-Package~31bf3856ad364e35~en-US.cab"
	)
	if "%ImageDefaultLanguage%" neq "en-US" (
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Internet Explorer 11 [%ImageDefaultLanguage%] Language Package...
		echo.-------------------------------------------------------------------------------
		call :AddPackage "%InstallMount%", "%IE11%\Microsoft-Windows-InternetExplorer-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%.cab"
			
		if exist "%IE11%\Microsoft-Windows-IE-Hyphenation-Package~31bf3856ad364e35~%ImageDefaultLanguage%.cab" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Internet Explorer 11 Hyphenation Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%", "%IE11%\Microsoft-Windows-IE-Hyphenation-Package~31bf3856ad364e35~%ImageDefaultLanguage%.cab"
		) else (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Internet Explorer 11 Hyphenation Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%", "%IE11%\Microsoft-Windows-IE-Hyphenation-Package~31bf3856ad364e35~en-US.cab"
		)
		if exist "%IE11%\Microsoft-Windows-IE-Spelling-Package~31bf3856ad364e35~%ImageDefaultLanguage%.cab" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Internet Explorer 11 Spelling Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%", "%IE11%\Microsoft-Windows-IE-Spelling-Package~31bf3856ad364e35~%ImageDefaultLanguage%.cab"
		) else (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Internet Explorer 11 Spelling Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%", "%IE11%\Microsoft-Windows-IE-Spelling-Package~31bf3856ad364e35~en-US.cab"
		)			
	)
)	
echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Internet Explorer 11##################################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set IE11=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Remote Desktop Protocol (RDP) 8.0 & 8.1
::-------------------------------------------------------------------------------------------
:IntRDP81

setlocal

cls
echo.===============================================================================
echo.       MSMG ToolKit - Integrate Remote Desktop Protocol ^(RDP^) 8.0 ^& 8.1
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
if "%ImageIndexNo%" equ "*" call :GetImageArchitecture "%InstallWim%", 1 >nul
if "%ImageIndexNo%" neq "*" call :GetImageArchitecture "%InstallWim%", %ImageIndexNo% >nul

:: Setting Image Package Architecture
if "%ImageArchitecture%" equ "x86" set "PackageArchitecture=x86"
if "%ImageArchitecture%" equ "x64" set "PackageArchitecture=amd64"

:: Checking whether Remote Desktop Protocol (RDP) 8.0 & 8.1 Pack file exist
if not exist "%RDP81%\Microsoft-Windows-WinPE-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%.cab" (
	echo.Remote Desktop Protocol ^(RDP^) 8.0 ^& 8.1 Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-WinPE-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\RDP81^> folder...
	goto :Stop
)

:: Checking whether Remote Desktop Protocol (RDP) 8.0 & 8.1 Pack file exist
if not exist "%RDP81%\Microsoft-Windows-RDP-WinIP-Package~31bf3856ad364e35~%PackageArchitecture%.cab" (
	echo.Remote Desktop Protocol ^(RDP^) 8.0 ^& 8.1 Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-RDP-WinIP-Package~31bf3856ad364e35~%PackageArchitecture%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\RDP81^> folder...
	goto :Stop
)

:: Checking whether Remote Desktop Protocol (RDP) 8.0 & 8.1 Pack file exist
if not exist "%RDP81%\Microsoft-Windows-RDP-BlueIP-Package~31bf3856ad364e35~%PackageArchitecture%.cab" (
	echo.Remote Desktop Protocol ^(RDP^) 8.0 ^& 8.1 Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-RDP-BlueIP-Package~31bf3856ad364e35~%PackageArchitecture%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\RDP81^> folder...
	goto :Stop
)
echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Remote Desktop Protocol ^(RDP^) 8.0 ^& 8.1###############
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if "%ImageIndexNo%" equ "*" echo.    Image Indexes            : 1-%ImageCount%
if "%ImageIndexNo%" neq "*" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
if "%ImageIndexNo%" neq "*" echo.    Image Edition            : %ImageEdition%
echo.    Image Default Language   : %ImageDefaultLanguage%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Remote Desktop Protocol ^(RDP^) 8.0 ^& 8.1########################
echo.-------------------------------------------------------------------------------
echo.
if "%ImageIndexNo%" equ "*" (
	for /L %%i in (1, 1, %ImageCount%) do (
		if not %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]#############################
		if %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]############################
		echo.
			
		:: Getting Image Index Information
		call :GetImageIndexInfo "%InstallWim%", %%i >nul

		echo.-------------------------------------------------------------------------------
		echo.Integrating Remote Desktop Protocol ^(RDP^) 8.0 ^& 8.1 Prerequisite Package...
		echo.-------------------------------------------------------------------------------
		call :AddPackage "%InstallMount%\%%i", "%RDP81%\Microsoft-Windows-WinPE-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Remote Desktop Protocol ^(RDP^) 8.0 ^& 8.1 Prerequisite Package...
		echo.-------------------------------------------------------------------------------
		call :AddPackage "%InstallMount%\%%i", "%RDP81%\Microsoft-Windows-RDP-WinIP-Package~31bf3856ad364e35~%PackageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Remote Desktop Protocol ^(RDP^) 8.0 ^& 8.1 Package...
		echo.-------------------------------------------------------------------------------
		call :AddPackage "%InstallMount%\%%i", "%RDP81%\Microsoft-Windows-RDP-BlueIP-Package~31bf3856ad364e35~%PackageArchitecture%.cab"
	)
) else (
	echo.-------------------------------------------------------------------------------
	echo.Integrating Remote Desktop Protocol ^(RDP^) 8.0 ^& 8.1 Prerequisite Package...
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%RDP81%\Microsoft-Windows-WinPE-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating Remote Desktop Protocol ^(RDP^) 8.0 ^& 8.1 Prerequisite Package...
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%RDP81%\Microsoft-Windows-RDP-WinIP-Package~31bf3856ad364e35~%PackageArchitecture%.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating Remote Desktop Protocol ^(RDP^) 8.0 ^& 8.1 Package...
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%RDP81%\Microsoft-Windows-RDP-BlueIP-Package~31bf3856ad364e35~%PackageArchitecture%.cab"
)	
echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Remote Desktop Protocol ^(RDP^) 8.0 ^& 8.1###############
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set RDP81=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Windows Management Framework (WMF) 5.1
::-------------------------------------------------------------------------------------------
:IntWMF

setlocal

cls
echo.===============================================================================
echo.       MSMG ToolKit - Integrate Windows Management Framework ^(WMF^) 5.1
echo.===============================================================================
echo.

:: Setting Windows Management Framework (WMF) 5.1 Pack folder path accroding to selected Source OS
set "WMF=%WMF%\%SelectedSourceOS%"

:: Getting Install Image Index Architecture
if "%ImageIndexNo%" equ "*" call :GetImageArchitecture "%InstallWim%", 1 >nul
if "%ImageIndexNo%" neq "*" call :GetImageArchitecture "%InstallWim%", %ImageIndexNo% >nul

:: Checking whether Windows Management Framework (WMF) 5.1 Pack file exist
if "%SelectedSourceOS%" equ "w7" if "%ImageArchitecture%" equ "x64" if not exist "%WMF%\Windows6.1-KB2809215-%ImageArchitecture%.cab" (
	echo.Windows Management Framework 5 Pack folder is missing the below file...
	echo.
	echo."Windows6.1-KB2809215-%ImageArchitecture%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\WMF\%SelectedSourceOS%^> folder...
	goto :Stop
)

:: Checking whether Windows Management Framework (WMF) 5.1 Pack file exist
if "%SelectedSourceOS%" equ "w7" if not exist "%WMF%\Windows6.1-KB2872035-%ImageArchitecture%.cab" (
	echo.Windows Management Framework 5 Pack folder is missing the below file...
	echo.
	echo."Windows6.1-KB2872035-%ImageArchitecture%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\WMF\%SelectedSourceOS%^> folder...
	goto :Stop
)

:: Checking whether Windows Management Framework (WMF) 5.1 Pack file exist
if "%SelectedSourceOS%" equ "w7" if not exist "%WMF%\Windows6.1-KB3033929-%ImageArchitecture%.cab" (
	echo.Windows Management Framework 5 Pack folder is missing the below file...
	echo.
	echo."Windows6.1-KB3033929-%ImageArchitecture%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\WMF\%SelectedSourceOS%^> folder...
	goto :Stop
)

:: Checking whether Windows Management Framework (WMF) 5.1 Pack file exist
if "%SelectedSourceOS%" equ "w7" if not exist "%WMF%\Windows6.1-KB3191566-%ImageArchitecture%.cab" (
	echo.Windows Management Framework 5 Pack folder is missing the below file...
	echo.
	echo."Windows6.1-KB3191566-%ImageArchitecture%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\WMF\%SelectedSourceOS%^> folder...
	goto :Stop
)

:: Checking whether Windows Management Framework (WMF) 5.1 Pack file exist
if "%SelectedSourceOS%" equ "w81" if not exist "%WMF%\Windows8.1-KB3191564-%ImageArchitecture%.cab" (
	echo.Windows Management Framework 5 Pack folder is missing the below file...
	echo.
	echo."Windows8.1-KB3191564-%ImageArchitecture%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\WMF\%SelectedSourceOS%^> folder...
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Windows Management Framework ^(WMF^) 5.1################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if "%ImageIndexNo%" equ "*" echo.    Image Indexes            : 1-%ImageCount%
if "%ImageIndexNo%" neq "*" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
if "%ImageIndexNo%" neq "*" echo.    Image Edition            : %ImageEdition%
echo.    Image Default Language   : %ImageDefaultLanguage%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Windows Management Framework ^(WMF^) 5.1#########################
echo.-------------------------------------------------------------------------------
if "%ImageIndexNo%" equ "*" (
	for /L %%i in (1, 1, %ImageCount%) do (
		if not %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]#############################
		if %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]############################
		 
		:: Getting Image Index Information
		call :GetImageIndexInfo "%InstallWim%", %%i >nul
				
		if "%SelectedSourceOS%" equ "w7" (
			echo.
			if "%ImageArchitecture%" equ "x64" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows Management Framework ^(WMF^) 5.1 Prerequisite Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%WMF%\Windows6.1-KB2809215-%ImageArchitecture%.cab"
			)
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows Management Framework ^(WMF^) 5.1 Prerequisite Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%\%%i", "%WMF%\Windows6.1-KB2872035-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows Management Framework ^(WMF^) 5.1 Prerequisite Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%\%%i", "%WMF%\Windows6.1-KB3033929-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows Management Framework ^(WMF^) 5.1 Feature Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%\%%i", "%WMF%\Windows6.1-KB3191566-%ImageArchitecture%.cab"
		)		
		if "%SelectedSourceOS%" equ "w81" call :AddPackage "%InstallMount%\%%i", "%WMF%\Windows8.1-KB3191564-%ImageArchitecture%.cab"
	)
) else (	
	if "%SelectedSourceOS%" equ "w7" (
		echo.
		if "%ImageArchitecture%" equ "x64" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows Management Framework ^(WMF^) 5.1 Prerequisite Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%", "%WMF%\Windows6.1-KB2809215-%ImageArchitecture%.cab"
		)
		echo.-------------------------------------------------------------------------------
		echo.Integrating Windows Management Framework ^(WMF^) 5.1 Prerequisite Package...
		echo.-------------------------------------------------------------------------------
		call :AddPackage "%InstallMount%", "%WMF%\Windows6.1-KB2872035-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Windows Management Framework ^(WMF^) 5.1 Prerequisite Package...
		echo.-------------------------------------------------------------------------------
		call :AddPackage "%InstallMount%", "%WMF%\Windows6.1-KB3033929-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Windows Management Framework ^(WMF^) 5.1 Feature Package...
		echo.-------------------------------------------------------------------------------
		call :AddPackage "%InstallMount%", "%WMF%\Windows6.1-KB3191566-%ImageArchitecture%.cab"
	)
	if "%SelectedSourceOS%" equ "w81" call :AddPackage "%InstallMount%", "%WMF%\Windows8.1-KB3191564-%ImageArchitecture%.cab"
)	
echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Windows Management Framework ^(WMF^) 5.1################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set WMF=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Microsoft Win32 Calculator
::-------------------------------------------------------------------------------------------
:IntWin32Calc

setlocal

set PackageArchitecture=

cls
echo.===============================================================================
echo.             MSMG ToolKit - Integrate Microsoft Win32 Calculator
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
if "%ImageIndexNo%" equ "*" call :GetImageArchitecture "%InstallWim%", 1 >nul
if "%ImageIndexNo%" neq "*" call :GetImageArchitecture "%InstallWim%", %ImageIndexNo% >nul

:: Setting Package Index
if "%ImageArchitecture%" equ "x86" set "PackageIndex=1"
if "%ImageArchitecture%" equ "x64" set "PackageIndex=2"
if "%ImageArchitecture%" equ "arm64" set "PackageIndex=3"

:: Checking whether Microsoft Win32 Calculator Pack file exist
if not exist "%Win32Calc%\Win32Calc.tpk" (
	echo.Microsoft Win32 Calculator Pack folder is missing the below file...
	echo.
	echo."Win32Calc.tpk"
	echo.
	echo.Please copy the above file to ^<Packs\Win32Calc^> folder...
	goto :Stop
)

:: Checking whether Microsoft Win32 Calculator Pack file exist
if not exist "%Win32Calc%\Win32Calc_%ImageDefaultLanguage%.tpk" (
	echo.Microsoft Win32 Calculator Pack folder is missing the below file...
	echo.
	echo."Win32Calc_%ImageDefaultLanguage%.tpk"
	echo.
	echo.Please copy the above file to ^<Packs\Win32Calc^> folder...
	goto :Stop
)

:: Checking whether Microsoft Win32 Calculator Pack file exist
if not exist "%Win32Calc%\Win32Calc_%ImageArchitecture%.reg" (
	echo.Microsoft Win32 Calculator Pack folder is missing the below file...
	echo.
	echo."Win32Calc_%ImageArchitecture%.reg"
	echo.
	echo.Please copy the above file to ^<Packs\Win32Calc^> folder...
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Microsoft Win32 Calculator############################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if "%ImageIndexNo%" equ "*" echo.    Image Indexes            : 1-%ImageCount%
if "%ImageIndexNo%" neq "*" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
if "%ImageIndexNo%" neq "*" echo.    Image Edition            : %ImageEdition%
echo.    Image Default Language   : %ImageDefaultLanguage%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Microsoft Win32 Calculator#####################################
echo.-------------------------------------------------------------------------------
echo.
if "%ImageIndexNo%" equ "*" (
	for /L %%i in (1, 1, %ImageCount%) do (
		if not %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]#############################
		if %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]############################
		echo.
			
		:: Getting Image Index Information
		call :GetImageIndexInfo "%InstallWim%", %%i >nul

		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Win32 Calculator Base Package...	
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Win32Calc%\Win32Calc.tpk", %PackageIndex%, "%InstallMount%\%%i"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Win32 Calculator [%ImageDefaultLanguage%] Language Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Win32Calc%\Win32Calc_%ImageDefaultLanguage%.tpk", %PackageIndex%, "%InstallMount%\%%i"
		echo.-------------------------------------------------------------------------------
		echo.####Importing Microsoft Win32 Calculator Registry Settings#####################
		echo.-------------------------------------------------------------------------------
		echo.
		echo.Mounting Image Registry...
		call :MountImageRegistry "%InstallMount%\%%i"
		echo.Importing Registry Settings to Image Registry...
		call :ImportRegistry2Image "%Win32Calc%\Win32Calc_%ImageArchitecture%.reg"
		echo.Un-Mounting Image Registry...
		call :UnMountImageRegistry
	)
) else (
	echo.-------------------------------------------------------------------------------
	echo.Integrating Microsoft Win32 Calculator Base Package...	
	echo.-------------------------------------------------------------------------------
	call :ApplyImage "%Win32Calc%\Win32Calc.tpk", %PackageIndex%, "%InstallMount%"
	echo.-------------------------------------------------------------------------------
	echo.Integrating Microsoft Win32 Calculator [%ImageDefaultLanguage%] Language Package...
	echo.-------------------------------------------------------------------------------
	call :ApplyImage "%Win32Calc%\Win32Calc_%ImageDefaultLanguage%.tpk", %PackageIndex%, "%InstallMount%"
	echo.-------------------------------------------------------------------------------
	echo.####Importing Microsoft Win32 Calculator Registry Settings#####################
	echo.-------------------------------------------------------------------------------
	echo.
	echo.Mounting Image Registry...
	call :MountImageRegistry "%InstallMount%"
	echo.Importing Registry Settings to Image Registry...
	call :ImportRegistry2Image "%Win32Calc%\Win32Calc_%ImageArchitecture%.reg"
	echo.Un-Mounting Image Registry...
	call :UnMountImageRegistry
)
echo.
echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Microsoft Win32 Calculator############################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set Win32Calc=
set PackageIndex=
set PackageArchitecture=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Windows Data Deduplication
::-------------------------------------------------------------------------------------------
:IntDedup

setlocal

cls
echo.===============================================================================
echo.             MSMG ToolKit - Integrate Windows Data Deduplication
echo.===============================================================================
echo.

set "FSSMRESReg=%Dedup%\fssmres.dll.reg"

:: Setting Windows Data Deduplication Pack folder path accroding to selected Source OS
if "%SelectedSourceOS%"=="w81" set "Dedup=%Dedup%\%SelectedSourceOS%"
if "%SelectedSourceOS%"=="w10" set "Dedup=%Dedup%\%SelectedSourceOS%\10.0.%ImageBuild%"

:: Getting Install Image Index Architecture
if "%ImageIndexNo%" equ "*" call :GetImageArchitecture "%InstallWim%", 1 >nul
if "%ImageIndexNo%" neq "*" call :GetImageArchitecture "%InstallWim%", %ImageIndexNo% >nul

:: Setting Package Service Pack Build
if "%SelectedSourceOS%" equ "w10" (
	if "%ImageBuild%" equ "10586" set "PackageServicePackBuild=0"
	if "%ImageBuild%" equ "14393" set "PackageServicePackBuild=0"
	if "%ImageBuild%" equ "15063" set "PackageServicePackBuild=0"
	if "%ImageBuild%" equ "16299" set "PackageServicePackBuild=15"
	if "%ImageBuild%" equ "17134" set "PackageServicePackBuild=1"
	if "%ImageBuild%" equ "17763" set "PackageServicePackBuild=1"
	if "%ImageBuild%" equ "18362" set "PackageServicePackBuild=1"
	if "%ImageBuild%" equ "19041" set "PackageServicePackBuild=1"
)

:: Checking whether Windows Data Deduplication Pack file exist
if "%SelectedSourceOS%" equ "w81" if not exist "%Dedup%\Microsoft-Windows-FileServer-Package~31bf3856ad364e35~amd64~~6.3.9600.16384.cab" (
	echo.Windows Data Deduplication Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-FileServer-Package~31bf3856ad364e35~amd64~~6.3.9600.16384.cab"
	echo.
	echo.Please copy the above file to ^<Packs\Dedup\%SelectedSourceOS%^> folder...
	goto :Stop
)

:: Checking whether Windows Data Deduplication Pack file exist
if "%SelectedSourceOS%" equ "w81" if not exist "%Dedup%\Microsoft-Windows-FileServer-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~6.3.9600.16384.cab" (
	echo.Windows Data Deduplication Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-FileServer-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~6.3.9600.16384.cab"
	echo.
	echo.Please copy the above file to ^<Packs\Dedup\%SelectedSourceOS%^> folder...
	goto :Stop
)

:: Checking whether Windows Data Deduplication Pack file exist
if "%SelectedSourceOS%" equ "w81" if not exist "%Dedup%\Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~~6.3.9600.16384.cab" (
	echo.Windows Data Deduplication Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~~6.3.9600.16384.cab"
	echo.
	echo.Please copy the above file to ^<Packs\Dedup\%SelectedSourceOS%^> folder...
	goto :Stop
)

:: Checking whether Windows Data Deduplication Pack file exist
if "%SelectedSourceOS%" equ "w81" if not exist "%Dedup%\Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~6.3.9600.16384.cab" (
	echo.Windows Data Deduplication Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~6.3.9600.16384.cab"
	echo.
	echo.Please copy the above file to ^<Packs\Dedup\%SelectedSourceOS%^> folder...
	goto :Stop
)

:: Checking whether Windows Data Deduplication Pack file exist
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "10586" if not exist "%Dedup%\Microsoft-Windows-FileServer-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Data Deduplication Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-FileServer-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\Dedup\%SelectedSourceOS%\10.0.%ImageBuild%^> folder...
	goto :Stop
)

:: Checking whether Windows Data Deduplication Pack file exist
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "10586" if not exist "%Dedup%\Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Data Deduplication Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\Dedup\%SelectedSourceOS%\10.0.%ImageBuild%^> folder...
	goto :Stop
)

:: Checking whether Windows Data Deduplication Pack file exist
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "10586" if "%ImageDefaultLanguage%" neq "de-DE" if "%ImageDefaultLanguage%" neq "es-ES" if "%ImageDefaultLanguage%" neq "fr-FR" if "%ImageDefaultLanguage%" neq "it-IT" if "%ImageDefaultLanguage%" neq "ja-JP" if "%ImageDefaultLanguage%" neq "ko-KR" if "%ImageDefaultLanguage%" neq "pt-BR" if "%ImageDefaultLanguage%" neq "ru-RU" if "%ImageDefaultLanguage%" neq "tr-TR" if "%ImageDefaultLanguage%" neq "zh-CN" if "%ImageDefaultLanguage%" neq "zh-TW" (
	if not exist "%Dedup%\Microsoft-Windows-FileServer-Package~31bf3856ad364e35~amd64~en-US~%ImageVersion%.%PackageServicePackBuild%.cab" (
		echo.Windows Data Deduplication Pack folder is missing the below file...
		echo.
		echo."Microsoft-Windows-FileServer-Package~31bf3856ad364e35~amd64~en-US~%ImageVersion%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\Dedup\%SelectedSourceOS%\10.0.%ImageBuild%^> folder...
		goto :Stop
	)
	
	if not exist "%Dedup%\Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~en-US~%ImageVersion%.%PackageServicePackBuild%.cab" (
		echo.Windows Data Deduplication Pack folder is missing the below file...
		echo.
		echo."Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~en-US~%ImageVersion%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\Dedup\%SelectedSourceOS%\10.0.%ImageBuild%^> folder...
		goto :Stop
	)
)

:: Checking whether Windows Data Deduplication Pack file exist
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "10586" (
	for %%j in (de-DE, es-ES, fr-FR, it-IT, ja-JP, ko-KR, pt-BR, ru-RU, tr-TR, zh-CN, zh-TW) do (
		if "%ImageDefaultLanguage%" equ "%%j" (
			if not exist "%Dedup%\Microsoft-Windows-FileServer-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab" (
				echo.Windows Data Deduplication Pack folder is missing the below file...
				echo.
				echo."Microsoft-Windows-FileServer-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
				echo.
				echo.Please copy the above file to ^<Packs\Dedup\%SelectedSourceOS%\10.0.%ImageBuild%^> folder...
				goto :Stop
			)
			
			if not exist "%Dedup%\Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab" (
				echo.Windows Data Deduplication Pack folder is missing the below file...
				echo.
				echo."Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
				echo.
				echo.Please copy the above file to ^<Packs\Dedup\%SelectedSourceOS%\10.0.%ImageBuild%^> folder...
				goto :Stop
			)			
		)
	)
)

:: Checking whether Windows Data Deduplication Pack file exist
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "14393" if not exist "%Dedup%\Microsoft-Windows-FileServer-ServerCore-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Data Deduplication Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-FileServer-ServerCore-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\Dedup\%SelectedSourceOS%\10.0.%ImageBuild%^> folder...
	goto :Stop
)

:: Checking whether Windows Data Deduplication Pack file exist
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "14393" if not exist "%Dedup%\Microsoft-Windows-FileServer-ServerCore-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Data Deduplication Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-FileServer-ServerCore-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\Dedup\%SelectedSourceOS%\10.0.%ImageBuild%^> folder...
	goto :Stop
)

:: Checking whether Windows Data Deduplication Pack file exist
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "14393" if not exist "%Dedup%\Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Data Deduplication Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\Dedup\%SelectedSourceOS%\10.0.%ImageBuild%^> folder...
	goto :Stop
)

:: Checking whether Windows Data Deduplication Pack file exist
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "14393" if not exist "%Dedup%\Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Data Deduplication Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\Dedup\%SelectedSourceOS%\10.0.%ImageBuild%^> folder...
	goto :Stop
)

:: Checking whether Windows Data Deduplication Pack file exist
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "15063" if not exist "%Dedup%\Microsoft-Windows-FileServer-ServerCore-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Data Deduplication Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-FileServer-ServerCore-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\Dedup\%SelectedSourceOS%\10.0.%ImageBuild%^> folder...
	goto :Stop
)

:: Checking whether Windows Data Deduplication Pack file exist
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "15063" if not exist "%Dedup%\Microsoft-Windows-FileServer-ServerCore-Package~31bf3856ad364e35~amd64~en-US~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Data Deduplication Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-FileServer-ServerCore-Package~31bf3856ad364e35~amd64~en-US~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\Dedup\%SelectedSourceOS%\10.0.%ImageBuild%^> folder...
	goto :Stop
)

:: Checking whether Windows Data Deduplication Pack file exist
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "15063" if not exist "%Dedup%\Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Data Deduplication Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\Dedup\%SelectedSourceOS%\10.0.%ImageBuild%^> folder...
	goto :Stop
)

:: Checking whether Windows Data Deduplication Pack file exist
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "15063" if not exist "%Dedup%\Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~en-US~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Data Deduplication Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~en-US~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\Dedup\%SelectedSourceOS%\10.0.%ImageBuild%^> folder...
	goto :Stop
)

:: Checking whether Windows Data Deduplication Pack file exist
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "16299" if not exist "%Dedup%\Microsoft-Windows-FileServer-ServerCore-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Data Deduplication Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-FileServer-ServerCore-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\Dedup\%SelectedSourceOS%\10.0.%ImageBuild%^> folder...
	goto :Stop
)

:: Checking whether Windows Data Deduplication Pack file exist
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "16299" if not exist "%Dedup%\Microsoft-Windows-FileServer-ServerCore-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Data Deduplication Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-FileServer-ServerCore-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\Dedup\%SelectedSourceOS%\10.0.%ImageBuild%^> folder...
	goto :Stop
)

:: Checking whether Windows Data Deduplication Pack file exist
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "16299" if not exist "%Dedup%\Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Data Deduplication Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\Dedup\%SelectedSourceOS%\10.0.%ImageBuild%^> folder...
	goto :Stop
)

:: Checking whether Windows Data Deduplication Pack file exist
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "16299" if not exist "%Dedup%\Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Data Deduplication Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\Dedup\%SelectedSourceOS%\10.0.%ImageBuild%^> folder...
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Windows Data Deduplication############################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if "%ImageIndexNo%" equ "*" echo.    Image Indexes            : 1-%ImageCount%
if "%ImageIndexNo%" neq "*" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
if "%ImageIndexNo%" neq "*" echo.    Image Edition            : %ImageEdition%
echo.    Image Default Language   : %ImageDefaultLanguage%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Windows Data Deduplication#####################################
echo.-------------------------------------------------------------------------------
echo.
if "%ImageIndexNo%" equ "*" (
	for /L %%i in (1, 1, %ImageCount%) do (
		if not %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]#############################
		if %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]############################
		echo.
			
		:: Getting Image Index Information
		call :GetImageIndexInfo "%InstallWim%", %%i >nul

		if "%SelectedSourceOS%" equ "w81" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows File Server Base Package....
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Dedup%\Microsoft-Windows-FileServer-Package~31bf3856ad364e35~amd64~~6.3.9600.16384.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows File Server [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Dedup%\Microsoft-Windows-FileServer-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~6.3.9600.16384.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows Deduplication Base Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Dedup%\Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~~6.3.9600.16384.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows Deduplication [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Dedup%\Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~6.3.9600.16384.cab"
		)

		if "%SelectedSourceOS%" equ "w10" (
			if "%ImageBuild%" equ "10586" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows File Server Base Package....
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Dedup%\Microsoft-Windows-FileServer-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
				echo.-------------------------------------------------------------------------------
				if "%ImageDefaultLanguage%" neq "de-DE" if "%ImageDefaultLanguage%" neq "es-ES" if "%ImageDefaultLanguage%" neq "fr-FR" if "%ImageDefaultLanguage%" neq "it-IT" if "%ImageDefaultLanguage%" neq "ja-JP" if "%ImageDefaultLanguage%" neq "ko-KR" if "%ImageDefaultLanguage%" neq "pt-BR" if "%ImageDefaultLanguage%" neq "ru-RU" if "%ImageDefaultLanguage%" neq "tr-TR" if "%ImageDefaultLanguage%" neq "zh-CN" if "%ImageDefaultLanguage%" neq "zh-TW" (
					echo.Integrating Windows File Server [en-US] Language Package...
					echo.-------------------------------------------------------------------------------
					call :AddPackage "%InstallMount%\%%i", "%Dedup%\Microsoft-Windows-FileServer-Package~31bf3856ad364e35~amd64~en-US~%ImageVersion%.%PackageServicePackBuild%.cab"
				)
				for %%j in (de-DE, es-ES, fr-FR, it-IT, ja-JP, ko-KR, pt-BR, ru-RU, tr-TR, zh-CN, zh-TW) do (
					if "%ImageDefaultLanguage%" equ "%%j" (
						echo.Integrating Windows File Server [%ImageDefaultLanguage%] Language Package...
						echo.-------------------------------------------------------------------------------
						call :AddPackage "%InstallMount%\%%i", "%Dedup%\Microsoft-Windows-FileServer-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
					)
				)
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows Deduplication Base Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Dedup%\Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
				echo.-------------------------------------------------------------------------------
				if "%ImageDefaultLanguage%" neq "de-DE" if "%ImageDefaultLanguage%" neq "es-ES" if "%ImageDefaultLanguage%" neq "fr-FR" if "%ImageDefaultLanguage%" neq "it-IT" if "%ImageDefaultLanguage%" neq "ja-JP" if "%ImageDefaultLanguage%" neq "ko-KR" if "%ImageDefaultLanguage%" neq "pt-BR" if "%ImageDefaultLanguage%" neq "ru-RU" if "%ImageDefaultLanguage%" neq "tr-TR" if "%ImageDefaultLanguage%" neq "zh-CN" if "%ImageDefaultLanguage%" neq "zh-TW" (
					echo.Integrating Windows Deduplication [en-US] Language Package...
					echo.-------------------------------------------------------------------------------
					call :AddPackage "%InstallMount%\%%i", "%Dedup%\Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~en-US~%ImageVersion%.%PackageServicePackBuild%.cab"
				)
				for %%j in (de-DE, es-ES, fr-FR, it-IT, ja-JP, ko-KR, pt-BR, ru-RU, tr-TR, zh-CN, zh-TW) do (
					if "%ImageDefaultLanguage%" equ "%%j" (
						echo.Integrating Windows Deduplication [%ImageDefaultLanguage%] Language Package...
						echo.-------------------------------------------------------------------------------
						call :AddPackage "%InstallMount%\%%i", "%Dedup%\Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
					)
				)
			)
			
			if "%ImageBuild%" equ "14393" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows File Server Core Base Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Dedup%\Microsoft-Windows-FileServer-ServerCore-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows File Server Core [%ImageDefaultLanguage%] Language Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Dedup%\Microsoft-Windows-FileServer-ServerCore-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows Deduplication Base Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Dedup%\Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows Deduplication [%ImageDefaultLanguage%] Language Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Dedup%\Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
				if exist "%Dedup%\Updates\*.cab" (
					echo.-------------------------------------------------------------------------------
					echo.Integrating Windows Deduplication Update Package...
					echo.-------------------------------------------------------------------------------
					call :AddPackage "%InstallMount%\%%i", "%Dedup%\Updates"
				)
			)
			
			if "%ImageBuild%" equ "15063" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows File Server Core Base Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Dedup%\Microsoft-Windows-FileServer-ServerCore-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows File Server Core [en-US] Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Dedup%\Microsoft-Windows-FileServer-ServerCore-Package~31bf3856ad364e35~amd64~en-US~%ImageVersion%.%PackageServicePackBuild%.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows Deduplication Base Package...
				echo	.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Dedup%\Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows Deduplication [en-US] Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Dedup%\Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~en-US~%ImageVersion%.%PackageServicePackBuild%.cab"
			)

			if "%ImageBuild%" geq "16299" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows File Server Core Base Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Dedup%\Microsoft-Windows-FileServer-ServerCore-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows File Server Core [en-US] Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Dedup%\Microsoft-Windows-FileServer-ServerCore-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows Deduplication Base Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Dedup%\Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows Deduplication [en-US] Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Dedup%\Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
			)
		)
	)
) else (
	if "%SelectedSourceOS%" equ "w81" (
		echo.-------------------------------------------------------------------------------
		echo.Integrating Windows File Server Base Package....
		echo.-------------------------------------------------------------------------------
		call :AddPackage "%InstallMount%", "%Dedup%\Microsoft-Windows-FileServer-Package~31bf3856ad364e35~amd64~~6.3.9600.16384.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Windows File Server [%ImageDefaultLanguage%] Language Package...
		echo.-------------------------------------------------------------------------------
		call :AddPackage "%InstallMount%", "%Dedup%\Microsoft-Windows-FileServer-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~6.3.9600.16384.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Windows Deduplication Base Package...
		echo.-------------------------------------------------------------------------------
		call :AddPackage "%InstallMount%", "%Dedup%\Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~~6.3.9600.16384.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Windows Deduplication [%ImageDefaultLanguage%] Language Package...
		echo.-------------------------------------------------------------------------------
		call :AddPackage "%InstallMount%", "%Dedup%\Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~6.3.9600.16384.cab"
	)

	if "%SelectedSourceOS%" equ "w10" (
		if "%ImageBuild%" equ "10586" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows File Server Base Package....
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%", "%Dedup%\Microsoft-Windows-FileServer-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
			echo.-------------------------------------------------------------------------------
			if "%ImageDefaultLanguage%" neq "de-DE" if "%ImageDefaultLanguage%" neq "es-ES" if "%ImageDefaultLanguage%" neq "fr-FR" if "%ImageDefaultLanguage%" neq "it-IT" if "%ImageDefaultLanguage%" neq "ja-JP" if "%ImageDefaultLanguage%" neq "ko-KR" if "%ImageDefaultLanguage%" neq "pt-BR" if "%ImageDefaultLanguage%" neq "ru-RU" if "%ImageDefaultLanguage%" neq "tr-TR" if "%ImageDefaultLanguage%" neq "zh-CN" if "%ImageDefaultLanguage%" neq "zh-TW" (
				echo.Integrating Windows File Server [en-US] Language Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%", "%Dedup%\Microsoft-Windows-FileServer-Package~31bf3856ad364e35~amd64~en-US~%ImageVersion%.%PackageServicePackBuild%.cab"
			)
			for %%j in (de-DE, es-ES, fr-FR, it-IT, ja-JP, ko-KR, pt-BR, ru-RU, tr-TR, zh-CN, zh-TW) do (
				if "%ImageDefaultLanguage%" equ "%%j" (
					echo.Integrating Windows File Server [%ImageDefaultLanguage%] Language Package...
					echo.-------------------------------------------------------------------------------
					call :AddPackage "%InstallMount%", "%Dedup%\Microsoft-Windows-FileServer-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
				)
			)
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows Deduplication Base Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%", "%Dedup%\Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
			echo.-------------------------------------------------------------------------------
			if "%ImageDefaultLanguage%" neq "de-DE" if "%ImageDefaultLanguage%" neq "es-ES" if "%ImageDefaultLanguage%" neq "fr-FR" if "%ImageDefaultLanguage%" neq "it-IT" if "%ImageDefaultLanguage%" neq "ja-JP" if "%ImageDefaultLanguage%" neq "ko-KR" if "%ImageDefaultLanguage%" neq "pt-BR" if "%ImageDefaultLanguage%" neq "ru-RU" if "%ImageDefaultLanguage%" neq "tr-TR" if "%ImageDefaultLanguage%" neq "zh-CN" if "%ImageDefaultLanguage%" neq "zh-TW" (
				echo.Integrating Windows Deduplication [en-US] Language Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%", "%Dedup%\Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~en-US~%ImageVersion%.%PackageServicePackBuild%.cab"
			)
			for %%j in (de-DE, es-ES, fr-FR, it-IT, ja-JP, ko-KR, pt-BR, ru-RU, tr-TR, zh-CN, zh-TW) do (
				if "%ImageDefaultLanguage%" equ "%%j" (
					echo.Integrating Windows Deduplication [%ImageDefaultLanguage%] Language Package...
					echo.-------------------------------------------------------------------------------
					call :AddPackage "%InstallMount%", "%Dedup%\Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
				)
			)
		)
		
		if "%ImageBuild%" equ "14393" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows File Server Core Base Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%", "%Dedup%\Microsoft-Windows-FileServer-ServerCore-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows File Server Core [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%", "%Dedup%\Microsoft-Windows-FileServer-ServerCore-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows Deduplication Base Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%", "%Dedup%\Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows Deduplication [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%", "%Dedup%\Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
			if exist "%Dedup%\Updates\*.cab" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows Deduplication Update Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%", "%Dedup%\Updates"
			)
		)
		
		if "%ImageBuild%" equ "15063" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows File Server Core Base Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%", "%Dedup%\Microsoft-Windows-FileServer-ServerCore-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows File Server Core [en-US] Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%", "%Dedup%\Microsoft-Windows-FileServer-ServerCore-Package~31bf3856ad364e35~amd64~en-US~%ImageVersion%.%PackageServicePackBuild%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows Deduplication Base Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%", "%Dedup%\Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows Deduplication [en-US] Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%", "%Dedup%\Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~en-US~%ImageVersion%.%PackageServicePackBuild%.cab"
		)

		if "%ImageBuild%" geq "16299" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows File Server Core Base Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%", "%Dedup%\Microsoft-Windows-FileServer-ServerCore-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows File Server Core [en-US] Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%", "%Dedup%\Microsoft-Windows-FileServer-ServerCore-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows Deduplication Base Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%", "%Dedup%\Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows Deduplication [en-US] Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%", "%Dedup%\Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
		)
	)			
)
echo.-------------------------------------------------------------------------------
echo.####Enabling Windows Data Deduplication Features###############################
echo.-------------------------------------------------------------------------------
if "%ImageIndexNo%" equ "*" (
	echo.
	for /L %%i in (1, 1, %ImageCount%) do (
		if not %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]#############################
		if %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]############################

		if "%SelectedSourceOS%" equ "w81" (
			echo.
			echo.-------------------------------------------------------------------------------
			echo.Enabling Windows Data Deduplication Feature...
			echo.-------------------------------------------------------------------------------
			call :EnableFeature "%InstallMount%\%%i", "Dedup-Core /All"
			echo.-------------------------------------------------------------------------------
			echo.Enabling Windows File Services Search Service Feature...
			echo.-------------------------------------------------------------------------------
			call :EnableFeature "%InstallMount%\%%i", "File-Services-Search-Service /All"
		)

		if "%SelectedSourceOS%" equ "w10" call :EnableFeature "%InstallMount%\%%i", "Dedup-Core /All"
	)
) else (
	if "%SelectedSourceOS%" equ "w81" (
		echo.
		echo.-------------------------------------------------------------------------------
		echo.Enabling Windows Data Deduplication Feature...
		echo.-------------------------------------------------------------------------------
		call :EnableFeature "%InstallMount%", "Dedup-Core /All"
		echo.-------------------------------------------------------------------------------
		echo.Enabling Windows File Services Search Service Feature...
		echo.-------------------------------------------------------------------------------
		call :EnableFeature "%InstallMount%", "File-Services-Search-Service /All"
	)

	if "%SelectedSourceOS%" equ "w10" call :EnableFeature "%InstallMount%", "Dedup-Core /All"
)
echo.-------------------------------------------------------------------------------
echo.####Importing Windows File Server ^(fssmres.dll^) Fix Registry Settings##########
echo.-------------------------------------------------------------------------------
if "%ImageIndexNo%" equ "*" (
	for /L %%i in (1, 1, %ImageCount%) do (
		echo.
		if not %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]#############################
		if %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]############################
		echo.
		echo.Mounting Image Registry...
		call :MountImageRegistry "%InstallMount%\%%i"
		echo.Importing Registry Settings to Image Registry...
		call :ImportRegistry2Image "%FSSMRESReg%"
		echo.Un-Mounting Image Registry...
		call :UnMountImageRegistry
	)
) else (
	echo.
	echo.Mounting Image Registry...
	call :MountImageRegistry "%InstallMount%"
	echo.Importing Registry Settings to Image Registry...
	call :ImportRegistry2Image "%FSSMRESReg%"
	echo.Un-Mounting Image Registry...
	call :UnMountImageRegistry
)
echo.
echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Windows Data Deduplication############################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set Dedup=
set PackageServicePackBuild=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Windows To Go Workspace
::-------------------------------------------------------------------------------------------
:IntWinToGo

setlocal

cls
echo.===============================================================================
echo.              MSMG ToolKit - Integrate Windows To Go Workspace
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
if "%ImageIndexNo%" equ "*" call :GetImageArchitecture "%InstallWim%", 1 >nul
if "%ImageIndexNo%" neq "*" call :GetImageArchitecture "%InstallWim%", %ImageIndexNo% >nul

:: Setting Windows To Go Workspace Pack path
if "%SelectedSourceOS%" equ "w81" set "WinToGo=%WinToGo%\%SelectedSourceOS%"
if "%SelectedSourceOS%" equ "w10" set "WinToGo=%WinToGo%\%SelectedSourceOS%\10.0.%ImageBuild%"

:: Setting Package Service Pack Build
if "%SelectedSourceOS%" equ "w10" (
	if "%ImageBuild%" equ "10240" set "PackageServicePackBuild=16384"
	if "%ImageBuild%" equ "10586" set "PackageServicePackBuild=0"
	if "%ImageBuild%" equ "14393" set "PackageServicePackBuild=0"
	if "%ImageBuild%" equ "15063" set "PackageServicePackBuild=0"
	if "%ImageBuild%" equ "16299" set "PackageServicePackBuild=15"
	if "%ImageBuild%" equ "17134" set "PackageServicePackBuild=1"
	if "%ImageBuild%" equ "17763" set "PackageServicePackBuild=1"
	if "%ImageBuild%" equ "18362" set "PackageServicePackBuild=1"
)

:: Setting Package Index and Architecture
if "%ImageArchitecture%" equ "x86" (
	set "PackageIndex=1"
	set "PackageArchitecture=x86"
)

if "%ImageArchitecture%" equ "x64" (
	set "PackageIndex=2"
	set "PackageArchitecture=amd64"
)

:: Checking whether Windows To Go Workspace Pack file exist
if "%SelectedSourceOS%" equ "w81" if not exist "%WinToGo%\WTG.tpk" (
	echo.Windows To Go Workspace Pack file "WTG.tpk" not found...
	echo.
	echo.Please copy the above file to ^<Packs\WinToGo\%SelectedSourceOS%^> folder...
	goto :Stop
)

:: Checking whether Windows To Go Workspace Pack file exist
if "%SelectedSourceOS%" equ "w81" if not exist "%WinToGo%\WTG_%ImageDefaultLanguage%.tpk" (
	echo.Windows To Go Workspace Pack file "WTG_%ImageDefaultLanguage%.tpk" not found...
	echo.
	echo.Please copy the above file to ^<Packs\WinToGo\%SelectedSourceOS%^> folder...
	goto :Stop
)

:: Checking whether Windows To Go Workspace Pack file exist
if "%SelectedSourceOS%" equ "w81" if not exist "%WinToGo%\WTG_%ImageArchitecture%.reg" (
	echo.Windows To Go Workspace Pack file "WTG_%ImageArchitecture%.reg" not found...
	echo.
	echo.Please copy the above file to ^<Packs\WinToGo\%SelectedSourceOS%^> folder...
	goto :Stop
)

:: Checking whether Windows To Go Workspace Pack file exist
if "%SelectedSourceOS%" equ "w10" if not exist "%WinToGo%\Microsoft-Windows-PortableWorkspaces-Creator-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows To Go Workspace Pack folder is missing the below file...
	echo.
	echo.Microsoft-Windows-PortableWorkspaces-Creator-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\WinToGo\%SelectedSourceOS%\10.0.%ImageBuild%^> folder...
	goto :Stop
)

:: Checking whether Windows To Go Workspace Pack file exist
if "%SelectedSourceOS%" equ "w10" if not exist "%WinToGo%\Microsoft-Windows-PortableWorkspaces-Creator-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows To Go Workspace Pack folder is missing the below file...
	echo.
	echo.Microsoft-Windows-PortableWorkspaces-Creator-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\WinToGo\%SelectedSourceOS%\10.0.%ImageBuild%^> folder...
	goto :Stop
)
echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Windows To Go Workspace###############################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if "%ImageIndexNo%" equ "*" echo.    Image Indexes            : 1-%ImageCount%
if "%ImageIndexNo%" neq "*" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
if "%ImageIndexNo%" neq "*" echo.    Image Edition            : %ImageEdition%
echo.    Image Default Language   : %ImageDefaultLanguage%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Windows To Go Workspace########################################
echo.-------------------------------------------------------------------------------
echo.
if "%ImageIndexNo%" equ "*" (
	for /L %%i in (1, 1, %ImageCount%) do (
		if not %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]#############################
		if %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]############################

		:: Getting Image Index Information
		call :GetImageIndexInfo "%InstallWim%", %%i >nul
		echo.

		if "%SelectedSourceOS%" equ "w81" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows To Go Workspace Base Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%WinToGo%\WTG.tpk", %PackageIndex%, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows To Go Workspace [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%WinToGo%\WTG_%ImageDefaultLanguage%.tpk", %PackageIndex%, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.####Importing Windows To Go Workspace Registry Settings########################
			echo.-------------------------------------------------------------------------------
			echo.
			echo.Mounting Image Registry...
			call :MountImageRegistry "%InstallMount%\%%i"
			echo.Importing Registry Settings to Image Registry...
			call :ImportRegistry2Image "%WinToGo%\WTG_%ImageArchitecture%.reg"
			echo.Un-Mounting Image Registry...
			call :UnMountImageRegistry		  
		)

		if "%SelectedSourceOS%" equ "w10" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows To Go Workspace Base Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%\%%i", %WinToGo%\Microsoft-Windows-PortableWorkspaces-Creator-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows To Go Workspace [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%\%%i", %WinToGo%\Microsoft-Windows-PortableWorkspaces-Creator-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab
		)
	)
) else (
	if "%SelectedSourceOS%" equ "w81" (
		echo.-------------------------------------------------------------------------------
		echo.Integrating Windows To Go Workspace Base Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%WinToGo%\WTG.tpk", %PackageIndex%, "%InstallMount%"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Windows To Go Workspace [%ImageDefaultLanguage%] Language Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%WinToGo%\WTG_%ImageDefaultLanguage%.tpk", %PackageIndex%, "%InstallMount%"
		echo.-------------------------------------------------------------------------------
		echo.####Importing Windows To Go Workspace Registry Settings########################
		echo.-------------------------------------------------------------------------------
		echo.
		echo.Mounting Image Registry...
		call :MountImageRegistry "%InstallMount%"
		echo.Importing Registry Settings to Image Registry...
		call :ImportRegistry2Image "%WinToGo%\WTG_%ImageArchitecture%.reg"
		echo.Un-Mounting Image Registry...
		call :UnMountImageRegistry
		echo.			  
	)

	if "%SelectedSourceOS%" equ "w10" (
		echo.-------------------------------------------------------------------------------
		echo.Integrating Windows To Go Workspace Base Package...
		echo.-------------------------------------------------------------------------------
		call :AddPackage "%InstallMount%", %WinToGo%\Microsoft-Windows-PortableWorkspaces-Creator-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab
		echo.-------------------------------------------------------------------------------
		echo.Integrating Windows To Go Workspace [%ImageDefaultLanguage%] Language Package...
		echo.-------------------------------------------------------------------------------
		call :AddPackage "%InstallMount%", %WinToGo%\Microsoft-Windows-PortableWorkspaces-Creator-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab
	)
)
echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Windows To Go Workspace###############################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set WinToGo=
set PackageServicePackBuild=
set PackageIndex=
set PackageArchitecture=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Windows System Restore
::-------------------------------------------------------------------------------------------
:IntSystemRestore

setlocal

cls
echo.===============================================================================
echo.               MSMG ToolKit - Integrate Windows System Restore
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
if "%ImageIndexNo%" equ "*" call :GetImageArchitecture "%InstallWim%", 1 >nul
if "%ImageIndexNo%" neq "*" call :GetImageArchitecture "%InstallWim%", %ImageIndexNo% >nul

:: Setting Windows System Restore Pack Path
if "%SelectedSourceOS%" equ "w7" set "SystemRestore=%SystemRestore%\%SelectedSourceOS%"
if "%SelectedSourceOS%" equ "w10" set "SystemRestore=%SystemRestore%\%SelectedSourceOS%\10.0.%ImageBuild%"

:: Setting Package Service Pack Build
if "%SelectedSourceOS%" equ "w7"  set PackageServicePackBuild=17514

if "%SelectedSourceOS%" equ "w10" (
	if "%ImageBuild%" equ "14393" set "PackageServicePackBuild=0"
	if "%ImageBuild%" equ "15063" set "PackageServicePackBuild=0"
	if "%ImageBuild%" equ "16299" set "PackageServicePackBuild=15"
	if "%ImageBuild%" equ "17134" set "PackageServicePackBuild=1"
	if "%ImageBuild%" equ "17763" set "PackageServicePackBuild=1"
)

:: Checking whether Windows System Restore Pack file exist
if not exist "%SystemRestore%\Microsoft-Windows-SystemRestore-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows System Restore Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-SystemRestore-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	if "%SelectedSourceOS%" equ "w7" echo.Please copy the above file to ^<Packs\SystemRestore\%SelectedSourceOS%^> folder...
	if "%SelectedSourceOS%" equ "w10" echo.Please copy the above file to ^<Packs\SystemRestore\%SelectedSourceOS%\10.0.%ImageBuild%^> folder...
	goto :Stop
)

:: Checking whether Windows System Restore Pack file exist
if not exist "%SystemRestore%\Microsoft-Windows-SystemRestore-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows System Restore Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-SystemRestore-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	if "%SelectedSourceOS%" equ "w7" echo.Please copy the above file to ^<Packs\SystemRestore\%SelectedSourceOS%^> folder...
	if "%SelectedSourceOS%" equ "w10" echo.Please copy the above file to ^<Packs\SystemRestore\%SelectedSourceOS%\10.0.%ImageBuild%^> folder...
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Windows System Restore################################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if "%ImageIndexNo%" equ "*" echo.    Image Indexes            : 1-%ImageCount%
if "%ImageIndexNo%" neq "*" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
if "%ImageIndexNo%" neq "*" echo.    Image Edition            : %ImageEdition%
echo.    Image Default Language   : %ImageDefaultLanguage%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Windows System Restore#########################################
echo.-------------------------------------------------------------------------------
echo.
if "%ImageIndexNo%" equ "*" (
	for /L %%i in (1, 1, %ImageCount%) do (
		if not %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]#############################
		if %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]############################
		echo.
			
		:: Getting Image Index Information
		call :GetImageIndexInfo "%InstallWim%", %%i >nul

		echo.-------------------------------------------------------------------------------
		echo.Integrating Windows System Restore Base Package...
		echo.-------------------------------------------------------------------------------
		call :AddPackage "%InstallMount%\%%i", "%SystemRestore%\Microsoft-Windows-SystemRestore-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Windows System Restore [%ImageDefaultLanguage%] Language Package...
		echo.-------------------------------------------------------------------------------
		call :AddPackage "%InstallMount%\%%i", "%SystemRestore%\Microsoft-Windows-SystemRestore-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"	
	)
) else (
	echo.-------------------------------------------------------------------------------
	echo.Integrating Windows System Restore Base Package...
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%SystemRestore%\Microsoft-Windows-SystemRestore-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating Windows System Restore [%ImageDefaultLanguage%] Language Package...
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%SystemRestore%\Microsoft-Windows-SystemRestore-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
)
echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Windows System Restore################################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set SystemRestore=
set PackageServicePackBuild=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Microsoft Edge Classic Browser
::-------------------------------------------------------------------------------------------
:IntEdgeClassic

setlocal

cls
echo.===============================================================================
echo.            MSMG ToolKit - Integrate Microsoft Edge Classic Browser
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
if "%ImageIndexNo%" equ "*" call :GetImageArchitecture "%InstallWim%", 1 >nul
if "%ImageIndexNo%" neq "*" call :GetImageArchitecture "%InstallWim%", %ImageIndexNo% >nul

:: Setting Microsoft Edge Classic Browser Pack path
set "EdgeClassic=%EdgeClassic%\10.0.%ImageBuild%"

:: Setting Package Service Pack Build
if "%ImageBuild%" equ "10240" set "PackageServicePackBuild=16384"
if "%ImageBuild%" equ "14393" set "PackageServicePackBuild=0"
if "%ImageBuild%" equ "15063" set "PackageServicePackBuild=0"
if "%ImageBuild%" equ "16299" set "PackageServicePackBuild=15"
if "%ImageBuild%" equ "17134" set "PackageServicePackBuild=1"
if "%ImageBuild%" equ "17763" set "PackageServicePackBuild=1"
if "%ImageBuild%" equ "18362" set "PackageServicePackBuild=1"
if "%ImageBuild%" equ "19041" set "PackageServicePackBuild=1"

:: Setting Package Architecture
if "%ImageArchitecture%" equ "x86" set "PackageArchitecture=x86"
if "%ImageArchitecture%" equ "x64" set "PackageArchitecture=amd64"

:: Checking whether Microsoft Edge Classic Browser Pack file exist
if "%SelectedSourceOS%" equ "w10" if not exist "%EdgeClassic%\Microsoft-Windows-Internet-Browser-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Microsoft Edge Classic Browser Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-Internet-Browser-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\EdgeBrowser\10.0.%ImageBuild%^> folder...
	goto :Stop
)

:: Checking whether Microsoft Edge Classic Browser Pack file exist
if "%SelectedSourceOS%" equ "w10" if not exist "%EdgeClassic%\Microsoft-Windows-Internet-Browser-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Microsoft Edge Classic Browser Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-Internet-Browser-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\EdgeBrowser\10.0.%ImageBuild%^> folder...
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Microsoft Edge Classic Browser########################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if "%ImageIndexNo%" equ "*" echo.    Image Indexes            : 1-%ImageCount%
if "%ImageIndexNo%" neq "*" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
if "%ImageIndexNo%" neq "*" echo.    Image Edition            : %ImageEdition%
echo.    Image Default Language   : %ImageDefaultLanguage%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Microsoft Edge Classic Browser#################################
echo.-------------------------------------------------------------------------------
echo.
if "%ImageIndexNo%" equ "*" (
	for /L %%i in (1, 1, %ImageCount%) do (
		if not %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]#############################
		if %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]############################
		echo.
		
		:: Getting Image Index Information
		call :GetImageIndexInfo "%InstallWim%", %%i >nul

		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Edge Classic Browser Base Package...
		echo.-------------------------------------------------------------------------------
		call :AddPackage "%InstallMount%\%%i", "%EdgeClassic%\Microsoft-Windows-Internet-Browser-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Edge Classic Browser [%ImageDefaultLanguage%] Language Package...
		echo.-------------------------------------------------------------------------------
		call :AddPackage "%InstallMount%\%%i", "%EdgeClassic%\Microsoft-Windows-Internet-Browser-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"

		:: Importing Registry Fix to Enable Integrating Windows 10 Cumulative Update.
		if "%ImageBuild%" lss "17763" (
			for %%j in (EnterpriseS, ServerStandard, ServerDatacenter) do (
				if "%ImageEdition%" equ "%%j" if exist "%InstallMount%\%%i\Windows\servicing\packages\Microsoft-Windows-Internet-Browser-Package~31bf3856ad364e35~*.mum" (
					call :MountImageRegistry "%InstallMount%\%%i"
					reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%" /v "InstallClient" /t REG_SZ /d "DISM Package Manager Provider" /f >nul
					reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%" /v "InstallName" /t REG_SZ /d "Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.mum" /f >nul
					reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%" /v "InstallLocation" /t REG_SZ /d "\\?\d:\rs.bin.%PackageArchitecture%fre.dep\mergedcomponents\images\client\packages\\" /f >nul
					reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%" /v "CurrentState" /t REG_DWORD /d "112" /f >nul
					reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%" /v "SelfUpdate" /t REG_DWORD /d "0" /f >nul
					reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%" /v "Visibility" /t REG_DWORD /d "1" /f >nul
					reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%" /v "InstallTimeHigh" /t REG_DWORD /d "30531506" /f >nul
					reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%" /v "InstallTimeLow" /t REG_DWORD /d "76431985" /f >nul
					reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%" /v "InstallUser" /t REG_SZ /d "S-1-5-18" /f >nul
					call :UnMountImageRegistry
				)
			)
		
			if "%ImageEdition%" equ "EnterpriseSN" if exist "%InstallMount%\%%i\Windows\servicing\packages\Microsoft-Windows-Internet-Browser-Package~31bf3856ad364e35~*.mum" (
				call :MountImageRegistry "%InstallMount%\%%i"
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%" /v "InstallClient" /t REG_SZ /d "DISM Package Manager Provider" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%" /v "InstallName" /t REG_SZ /d "Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.mum" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%" /v "InstallLocation" /t REG_SZ /d "\\?\d:\rs.bin.%PackageArchitecture%fre.dep\mergedcomponents\images\client\packages\\" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%" /v "CurrentState" /t REG_DWORD /d "112" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%" /v "SelfUpdate" /t REG_DWORD /d "0" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%" /v "Visibility" /t REG_DWORD /d "1" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%" /v "InstallTimeHigh" /t REG_DWORD /d "30531506" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%" /v "InstallTimeLow" /t REG_DWORD /d "76431985" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%" /v "InstallUser" /t REG_SZ /d "S-1-5-18" /f >nul
				call :UnMountImageRegistry
			)
		)		
	)
) else (
	echo.-------------------------------------------------------------------------------
	echo.Integrating Microsoft Edge Classic Browser Base Package...
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%EdgeClassic%\Microsoft-Windows-Internet-Browser-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating Microsoft Edge Classic Browser [%ImageDefaultLanguage%] Language Package...
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%EdgeClassic%\Microsoft-Windows-Internet-Browser-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"

	:: Importing Registry Fix to Enable Integrating Windows 10 Cumulative Update. 
	if "%ImageBuild%" lss "17763" (
		for %%j in (EnterpriseS, ServerStandard, ServerDatacenter) do (
			if "%ImageEdition%" equ "%%j" if exist "%InstallMount%\Windows\servicing\packages\Microsoft-Windows-Internet-Browser-Package~31bf3856ad364e35~*.mum" (
				call :MountImageRegistry "%InstallMount%"
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%" /v "InstallClient" /t REG_SZ /d "DISM Package Manager Provider" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%" /v "InstallName" /t REG_SZ /d "Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.mum" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%" /v "InstallLocation" /t REG_SZ /d "\\?\d:\rs.bin.%PackageArchitecture%fre.dep\mergedcomponents\images\client\packages\\" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%" /v "CurrentState" /t REG_DWORD /d "112" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%" /v "SelfUpdate" /t REG_DWORD /d "0" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%" /v "Visibility" /t REG_DWORD /d "1" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%" /v "InstallTimeHigh" /t REG_DWORD /d "30531506" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%" /v "InstallTimeLow" /t REG_DWORD /d "76431985" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%" /v "InstallUser" /t REG_SZ /d "S-1-5-18" /f >nul
				call :UnMountImageRegistry
			)
		)

		if "%ImageEdition%" equ "EnterpriseSN" if exist "%InstallMount%\Windows\servicing\packages\Microsoft-Windows-Internet-Browser-Package~31bf3856ad364e35~*.mum" (
			call :MountImageRegistry "%InstallMount%"
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%" /v "InstallClient" /t REG_SZ /d "DISM Package Manager Provider" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%" /v "InstallName" /t REG_SZ /d "Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.mum" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%" /v "InstallLocation" /t REG_SZ /d "\\?\d:\rs.bin.%PackageArchitecture%fre.dep\mergedcomponents\images\client\packages\\" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%" /v "CurrentState" /t REG_DWORD /d "112" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%" /v "SelfUpdate" /t REG_DWORD /d "0" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%" /v "Visibility" /t REG_DWORD /d "1" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%" /v "InstallTimeHigh" /t REG_DWORD /d "30531506" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%" /v "InstallTimeLow" /t REG_DWORD /d "76431985" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%" /v "InstallUser" /t REG_SZ /d "S-1-5-18" /f >nul
			call :UnMountImageRegistry
		)
	)
)
echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Microsoft Edge Classic Browser########################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set EdgeClassic=
set PackageServicePackBuild=
set PackageArchitecture=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Microsoft Edge Chromium Browser
::-------------------------------------------------------------------------------------------
:IntEdgeChromium

setlocal

cls
echo.===============================================================================
echo.          MSMG ToolKit - Integrate Microsoft Edge Chromium Browser
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
if "%ImageIndexNo%" equ "*" call :GetImageArchitecture "%InstallWim%", 1 >nul
if "%ImageIndexNo%" neq "*" call :GetImageArchitecture "%InstallWim%", %ImageIndexNo% >nul

:: Checking whether Microsoft Edge Chromium Browser Pack file exist
if not exist "%EdgeChromium%\EdgeChromium_%SelectedSourceOS%_%ImageArchitecture%.tpk" (
	echo.Microsoft Edge Chromium Browser Pack folder is missing the EdgeChromium_%SelectedSourceOS%_%ImageArchitecture%.tpk file...
	echo.
	echo.Please copy the above file to ^<Packs\EdgeChromium^> folder...
	goto :Stop
)

:: Checking whether Microsoft Edge Chromium Browser Pack file exist
if not exist "%EdgeChromium%\EdgeChromium_%SelectedSourceOS%_%ImageArchitecture%.reg" (
	echo.Microsoft Edge Chromium Browser Pack folder is missing the EdgeChromium_%SelectedSourceOS%_%ImageArchitecture%.reg file...
	echo.
	echo.Please copy the above file to ^<Packs\EdgeChromium^> folder...
	goto :Stop
)
echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Microsoft Edge Chromium Browser#######################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if "%ImageIndexNo%" equ "*" echo.    Image Indexes            : 1-%ImageCount%
if "%ImageIndexNo%" neq "*" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
if "%ImageIndexNo%" neq "*" echo.    Image Edition            : %ImageEdition%
echo.    Image Default Language   : %ImageDefaultLanguage%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Microsoft Edge Chromium Browser################################
echo.-------------------------------------------------------------------------------
if "%ImageIndexNo%" equ "*" (
	for /L %%i in (1, 1, %ImageCount%) do (
		echo.
		if not %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]#############################
		if %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]############################
		echo.
		
		:: Getting Image Index Information
		call :GetImageIndexInfo "%InstallWim%", %%i >nul

		call :ApplyImage "%EdgeChromium%\EdgeChromium_%SelectedSourceOS%_%ImageArchitecture%.tpk", 1, "%InstallMount%\%%i"

		echo.-------------------------------------------------------------------------------
		echo.####Importing Microsoft Edge Chromium Browser Registry Settings################
		echo.-------------------------------------------------------------------------------
		echo.
		echo.Mounting Image Registry...
		call :MountImageRegistry "%InstallMount%\%%i"
		echo.Importing Registry Settings to Image Registry...
		call :ImportRegistry2Image "%EdgeChromium%\EdgeChromium_%SelectedSourceOS%_%ImageArchitecture%.reg"
		echo.Un-Mounting Image Registry...
		call :UnMountImageRegistry
		echo.
	)
) else (
	call :ApplyImage "%EdgeChromium%\EdgeChromium_%SelectedSourceOS%_%ImageArchitecture%.tpk", 1, "%InstallMount%"
	echo.-------------------------------------------------------------------------------
	echo.####Importing Microsoft Edge Chromium Browser Registry Settings################
	echo.-------------------------------------------------------------------------------
	echo.
	echo.Mounting Image Registry...
	call :MountImageRegistry "%InstallMount%"
	echo.Importing Registry Settings to Image Registry...
	call :ImportRegistry2Image "%EdgeChromium%\EdgeChromium_%SelectedSourceOS%_%ImageArchitecture%.reg"
	echo.Un-Mounting Image Registry...
	call :UnMountImageRegistry
	echo.
)
echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Microsoft Edge Chromium Browser#######################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set EdgeChromium=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Windows Accessibility Braille
::-------------------------------------------------------------------------------------------
:IntBraille

setlocal

cls
echo.===============================================================================
echo.           MSMG ToolKit - Integrate Windows Accessibility Braille
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
if "%ImageIndexNo%" equ "*" call :GetImageArchitecture "%InstallWim%", 1 >nul
if "%ImageIndexNo%" neq "*" call :GetImageArchitecture "%InstallWim%", %ImageIndexNo% >nul

:: Setting Braille Pack Path
set "Braille=%Braille%\10.0.%ImageBuild%"

:: Setting Package Service Pack Build
if "%ImageBuild%" equ "15063" set "PackageServicePackBuild=0"
if "%ImageBuild%" equ "16299" set "PackageServicePackBuild=15"
if "%ImageBuild%" equ "17134" set "PackageServicePackBuild=1"
if "%ImageBuild%" equ "17763" set "PackageServicePackBuild=1"
if "%ImageBuild%" equ "18362" set "PackageServicePackBuild=1"
if "%ImageBuild%" equ "19041" set "PackageServicePackBuild=1"

:: Setting Package Architecture
if "%ImageArchitecture%" equ "x86" set "PackageArchitecture=x86"
if "%ImageArchitecture%" equ "x64" set "PackageArchitecture=amd64"
if "%ImageArchitecture%" equ "arm64" set "PackageArchitecture=arm64"

:: Checking whether Windows Accessibility Braille Pack file exist
if not exist "%Braille%\Microsoft-Windows-Accessibility-Braille-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Accessibility Braille Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-Accessibility-Braille-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\Braille\10.0.%ImageBuild%^> folder...
	goto :Stop
)

call :RemoveFile "%Temp%\Microsoft-Windows-Accessibility-Braille-Package~31bf3856ad364e35~%PackageArchitecture%~~.cab"
if "%ImageBuild%" geq "17763" copy /y "%Braille%\Microsoft-Windows-Accessibility-Braille-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab" "%Temp%\Microsoft-Windows-Accessibility-Braille-Package~31bf3856ad364e35~%PackageArchitecture%~~.cab" >nul
echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Windows Accessibility Braille#########################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if "%ImageIndexNo%" equ "*" echo.    Image Indexes            : 1-%ImageCount%
if "%ImageIndexNo%" neq "*" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
if "%ImageIndexNo%" neq "*" echo.    Image Edition            : %ImageEdition%
echo.    Image Default Language   : %ImageDefaultLanguage%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Windows Accessibility Braille##################################
echo.-------------------------------------------------------------------------------
if "%ImageIndexNo%" equ "*" (
	echo.
	for /L %%i in (1, 1, %ImageCount%) do (
		if not %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]#############################
		if %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]############################
		
		:: Getting Image Index Information
		call :GetImageIndexInfo "%InstallWim%", %%i >nul

		if "%ImageBuild%" leq "17134" call :AddPackage "%InstallMount%\%%i", "%Braille%\Microsoft-Windows-Accessibility-Braille-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab"
		if "%ImageBuild%" geq "17763" call :AddPackage "%InstallMount%\%%i", "%Temp%\Microsoft-Windows-Accessibility-Braille-Package~31bf3856ad364e35~%PackageArchitecture%~~.cab"
	)
) else (
	if "%ImageBuild%" leq "17134" call :AddPackage "%InstallMount%", "%Braille%\Microsoft-Windows-Accessibility-Braille-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab"
	if "%ImageBuild%" geq "17763" call :AddPackage "%InstallMount%", "%Temp%\Microsoft-Windows-Accessibility-Braille-Package~31bf3856ad364e35~%PackageArchitecture%~~.cab"
)

call :RemoveFile "%Temp%\Microsoft-Windows-Accessibility-Braille-Package~31bf3856ad364e35~%PackageArchitecture%~~.cab"
echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Windows Accessibility Braille#########################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set Braille=
set PackageServicePackBuild=
set PackageArchitecture=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Windows Multimedia Restricted Codecs
::-------------------------------------------------------------------------------------------
:IntMMRC

setlocal

cls
echo.===============================================================================
echo.       MSMG ToolKit - Integrate Windows Multimedia Restricted Codecs
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
if "%ImageIndexNo%" equ "*" call :GetImageArchitecture "%InstallWim%", 1 >nul
if "%ImageIndexNo%" neq "*" call :GetImageArchitecture "%InstallWim%", %ImageIndexNo% >nul

:: Setting Multimedia Restricted Codecs Pack path
set "MMRC=%MMRC%\10.0.%ImageBuild%"

:: Setting Package Service Pack Build
if "%ImageBuild%" equ "14393" set "PackageServicePackBuild=0"
if "%ImageBuild%" equ "15063" set "PackageServicePackBuild=0"
if "%ImageBuild%" equ "16299" set "PackageServicePackBuild=15"
if "%ImageBuild%" equ "17134" set "PackageServicePackBuild=1"
if "%ImageBuild%" equ "17763" set "PackageServicePackBuild=1"
if "%ImageBuild%" equ "18362" set "PackageServicePackBuild=1"
if "%ImageBuild%" equ "19041" set "PackageServicePackBuild=1"

:: Checking whether Windows Multimedia Restricted Codecs Pack file exist
if not exist "%MMRC%\Multimedia-RestrictedCodecsExt-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Multimedia Restricted Codecs Pack folder is missing the below file...
	echo.
	echo."Multimedia-RestrictedCodecsExt-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\MultimediaRestrictedCodecs\10.0.%ImageBuild%^> folder...
	goto :Stop
)

:: Checking whether Windows Multimedia Restricted Codecs Pack file exist
if not exist "%MMRC%\Multimedia-RestrictedCodecsExt-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Multimedia Restricted Codecs Pack folder is missing the below file...
	echo.
	echo."Multimedia-RestrictedCodecsExt-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\MultimediaRestrictedCodecs\10.0.%ImageBuild%^> folder...
	goto :Stop
)

:: Checking whether Windows Multimedia Restricted Codecs Pack file exist
if "%ImageBuild%" leq "17763" if "%ImageArchitecture%" equ "x64" if not exist "%MMRC%\Multimedia-RestrictedCodecsExt-WOW64-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Multimedia Restricted Codecs Pack folder is missing the below file...
	echo.
	echo."Multimedia-RestrictedCodecsExt-WOW64-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\MultimediaRestrictedCodecs\10.0.%ImageBuild%^> folder...
	goto :Stop
)

:: Checking whether Windows Multimedia Restricted Codecs Pack file exist
if "%ImageBuild%" leq "17763" if "%ImageArchitecture%" equ "x64" if not exist "%MMRC%\Multimedia-RestrictedCodecsExt-WOW64-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Multimedia Restricted Codecs Pack folder is missing the below file...
	echo.
	echo."Multimedia-RestrictedCodecsExt-WOW64-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\MultimediaRestrictedCodecs\10.0.%ImageBuild%^> folder...
	goto :Stop
)

:: Checking whether Windows Multimedia Restricted Codecs Pack file exist
if "%ImageBuild%" geq "18362" if "%ImageArchitecture%" equ "x64" if not exist "%MMRC%\Multimedia-RestrictedCodecsExt-WOW64-Package~31bf3856ad364e35~wow64~~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Multimedia Restricted Codecs Pack folder is missing the below file...
	echo.
	echo."Multimedia-RestrictedCodecsExt-WOW64-Package~31bf3856ad364e35~wow64~~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\MultimediaRestrictedCodecs\10.0.%ImageBuild%^> folder...
	goto :Stop
)

:: Checking whether Windows Multimedia Restricted Codecs Pack file exist
if "%ImageBuild%" geq "18362" if "%ImageArchitecture%" equ "x64" if not exist "%MMRC%\Multimedia-RestrictedCodecsExt-WOW64-Package~31bf3856ad364e35~wow64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Multimedia Restricted Codecs Pack folder is missing the below file...
	echo.
	echo."Multimedia-RestrictedCodecsExt-WOW64-Package~31bf3856ad364e35~wow64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\MultimediaRestrictedCodecs\10.0.%ImageBuild%^> folder...
	goto :Stop
)
echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Windows Multimedia Restricted Codecs##################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if "%ImageIndexNo%" equ "*" echo.    Image Indexes            : 1-%ImageCount%
if "%ImageIndexNo%" neq "*" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
if "%ImageIndexNo%" neq "*" echo.    Image Edition            : %ImageEdition%
echo.    Image Default Language   : %ImageDefaultLanguage%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Windows Multimedia Restricted Codecs###########################
echo.-------------------------------------------------------------------------------
echo.
if "%ImageIndexNo%" equ "*" (
	for /L %%i in (1, 1, %ImageCount%) do (
		if not %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]#############################
		if %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]############################
		echo.
		
		:: Getting Image Index Information
		call :GetImageIndexInfo "%InstallWim%", %%i >nul
 
		echo.-------------------------------------------------------------------------------
		echo.Integrating Windows Multimedia Restricted Codecs Base Package...
		echo.-------------------------------------------------------------------------------
		call :AddPackage "%InstallMount%\%%i", "%MMRC%\Multimedia-RestrictedCodecsExt-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Windows Multimedia Restricted Codecs [%ImageDefaultLanguage%] Language Package...
		echo.-------------------------------------------------------------------------------
		call :AddPackage "%InstallMount%\%%i", "%MMRC%\Multimedia-RestrictedCodecsExt-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
		echo.-------------------------------------------------------------------------------

		if "%ImageArchitecture%" equ "x64" (
			echo.Integrating Windows Multimedia Restricted Codecs WOW64 Base Package...
			echo.-------------------------------------------------------------------------------
			if "%ImageBuild%" leq "17763" call :AddPackage "%InstallMount%\%%i", "%MMRC%\Multimedia-RestrictedCodecsExt-WOW64-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
			if "%ImageBuild%" geq "18362" call :AddPackage "%InstallMount%\%%i", "%MMRC%\Multimedia-RestrictedCodecsExt-WOW64-Package~31bf3856ad364e35~wow64~~%ImageVersion%.%PackageServicePackBuild%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows Multimedia Restricted Codecs WOW64 [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			if "%ImageBuild%" leq "17763" call :AddPackage "%InstallMount%\%%i", "%MMRC%\Multimedia-RestrictedCodecsExt-WOW64-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
			if "%ImageBuild%" geq "18362" call :AddPackage "%InstallMount%\%%i", "%MMRC%\Multimedia-RestrictedCodecsExt-WOW64-Package~31bf3856ad364e35~wow64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
		)
	)
) else (
	echo.-------------------------------------------------------------------------------
	echo.Integrating Windows Multimedia Restricted Codecs Base Package...
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%MMRC%\Multimedia-RestrictedCodecsExt-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating Windows Multimedia Restricted Codecs [%ImageDefaultLanguage%] Language Package...
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%MMRC%\Multimedia-RestrictedCodecsExt-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.-------------------------------------------------------------------------------

	if "%ImageArchitecture%" equ "x64" (
		echo.Integrating Windows Multimedia Restricted Codecs WOW64 Base Package...
		echo.-------------------------------------------------------------------------------
		if "%ImageBuild%" leq "17763" call :AddPackage "%InstallMount%", "%MMRC%\Multimedia-RestrictedCodecsExt-WOW64-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
		if "%ImageBuild%" geq "18362" call :AddPackage "%InstallMount%", "%MMRC%\Multimedia-RestrictedCodecsExt-WOW64-Package~31bf3856ad364e35~wow64~~%ImageVersion%.%PackageServicePackBuild%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Windows Multimedia Restricted Codecs WOW64 [%ImageDefaultLanguage%] Language Package...
		echo.-------------------------------------------------------------------------------
		if "%ImageBuild%" leq "17763" call :AddPackage "%InstallMount%", "%MMRC%\Multimedia-RestrictedCodecsExt-WOW64-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
		if "%ImageBuild%" geq "18362" call :AddPackage "%InstallMount%", "%MMRC%\Multimedia-RestrictedCodecsExt-WOW64-Package~31bf3856ad364e35~wow64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
	)
)
echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Windows Multimedia Restricted Codecs##################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set MMRC=
set PackageServicePackBuild=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Windows Subsystem for Linux ^(WSL^)
::-------------------------------------------------------------------------------------------
:IntWSL

setlocal

cls
echo.===============================================================================
echo.        MSMG ToolKit - Integrate Windows Subsystem for Linux ^(WSL^)
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
if "%ImageIndexNo%" equ "*" call :GetImageArchitecture "%InstallWim%", 1 >nul
if "%ImageIndexNo%" neq "*" call :GetImageArchitecture "%InstallWim%", %ImageIndexNo% >nul

:: Setting Windows Subsystem for Linux (WSL) Pack Path
set "WSL=%WSL%\10.0.%ImageBuild%"

:: Setting Package Service Pack Build
if "%ImageBuild%" equ "14393" set "PackageServicePackBuild=0"
if "%ImageBuild%" equ "15063" set "PackageServicePackBuild=0"
if "%ImageBuild%" equ "16299" set "PackageServicePackBuild=15"
if "%ImageBuild%" equ "17134" set "PackageServicePackBuild=1"
if "%ImageBuild%" equ "17763" set "PackageServicePackBuild=1"
if "%ImageBuild%" equ "18362" set "PackageServicePackBuild=1"
if "%ImageBuild%" equ "19041" set "PackageServicePackBuild=1"

:: Checking whether Windows Subsystem for Linux (WSL) Pack file exist
if not exist "%WSL%\Microsoft-Windows-Lxss-Optional-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Subsystem for Linux ^(WSL^) Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-Lxss-Optional-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\WSL\10.0.%ImageBuild%^> folder...
	goto :Stop
)

:: Checking whether Windows Subsystem for Linux (WSL) Pack file exist
if not exist "%WSL%\Microsoft-Windows-Lxss-Optional-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Subsystem for Linux ^(WSL^) Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-Lxss-Optional-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\WSL\10.0.%ImageBuild%^> folder...
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Windows Subsystem for Linux ^(WSL^)#####################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if "%ImageIndexNo%" equ "*" echo.    Image Indexes            : 1-%ImageCount%
if "%ImageIndexNo%" neq "*" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
if "%ImageIndexNo%" neq "*" echo.    Image Edition            : %ImageEdition%
echo.    Image Default Language   : %ImageDefaultLanguage%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Windows Subsystem for Linux ^(WSL^)##############################
echo.-------------------------------------------------------------------------------
echo.
if "%ImageIndexNo%" equ "*" (
	for /L %%i in (1, 1, %ImageCount%) do (
		if not %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]#############################
		if %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]############################
		echo.
		
		:: Getting Image Index Information
		call :GetImageIndexInfo "%InstallWim%", %%i >nul

		echo.-------------------------------------------------------------------------------
		echo.Integrating Windows Subsystem for Linux ^(WSL^) Base Package...
		echo.-------------------------------------------------------------------------------
		call :AddPackage "%InstallMount%\%%i", "%WSL%\Microsoft-Windows-Lxss-Optional-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Windows Subsystem for Linux ^(WSL^) [%ImageDefaultLanguage%] Language Package...
		echo.-------------------------------------------------------------------------------
		call :AddPackage "%InstallMount%\%%i", "%WSL%\Microsoft-Windows-Lxss-Optional-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
	)
) else (
	echo.-------------------------------------------------------------------------------
	echo.Integrating Windows Subsystem for Linux ^(WSL^) Base Package...
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%WSL%\Microsoft-Windows-Lxss-Optional-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating Windows Subsystem for Linux ^(WSL^) [%ImageDefaultLanguage%] Language Package...
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%WSL%\Microsoft-Windows-Lxss-Optional-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
)
echo.-------------------------------------------------------------------------------
echo.####Enabling Windows Subsystem for Linux ^(WSL^) Related Features################
echo.-------------------------------------------------------------------------------
echo.
if "%ImageIndexNo%" equ "*" (
	for /L %%i in (1, 1, %ImageCount%) do (
		if not %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]#############################
		if %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]############################
		echo.
		echo.-------------------------------------------------------------------------------
		echo.Enabling Windows Subsystem for Linux ^(WSL^) Feature in Image...
		echo.-------------------------------------------------------------------------------
		call :EnableFeature "%InstallMount%\%%i", "Microsoft-Windows-Subsystem-Linux /All"
	)
) else (
	echo.-------------------------------------------------------------------------------
	echo.Enabling Windows Subsystem for Linux ^(WSL^) Feature in Image...
	echo.-------------------------------------------------------------------------------
	call :EnableFeature "%InstallMount%", "Microsoft-Windows-Subsystem-Linux /All"
)
echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Windows Subsystem for Linux ^(WSL^)#####################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set PackageServicePackBuild=
set WSL=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Open Secure Shell (SSH) Client & Server
::-------------------------------------------------------------------------------------------
:IntOpenSSH

setlocal

cls
echo.===============================================================================
echo.      MSMG ToolKit - Integrate Open Secure Shell ^(SSH^) Client ^& Server
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
if "%ImageIndexNo%" equ "*" call :GetImageArchitecture "%InstallWim%", 1 >nul
if "%ImageIndexNo%" neq "*" call :GetImageArchitecture "%InstallWim%", %ImageIndexNo% >nul

:: Setting Open Secure Shell Pack Path
set "OpenSSH=%OpenSSH%\10.0.%ImageBuild%"

:: Setting Package Service Pack Build
if "%ImageBuild%" equ "16299" set "PackageServicePackBuild=15"
if "%ImageBuild%" equ "17134" set "PackageServicePackBuild=1"
if "%ImageBuild%" equ "17763" set "PackageServicePackBuild=1"
if "%ImageBuild%" equ "18362" set "PackageServicePackBuild=1"
if "%ImageBuild%" equ "19041" set "PackageServicePackBuild=1"

:: Setting Package Architecture
if "%ImageArchitecture%" equ "x86" set "PackageArchitecture=x86"
if "%ImageArchitecture%" equ "x64" set "PackageArchitecture=amd64"
if "%ImageArchitecture%" equ "arm64" set "PackageArchitecture=arm64"

:: Checking whether Open Secure Shell (SSH) Client Pack file exist
if not exist "%OpenSSH%\OpenSSH-Client-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.OpenSSH Client ^& Server Pack folder is missing the below file...
	echo.
	echo."OpenSSH-Client-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\OpenSSH\10.0.%ImageBuild%^> folder...
	goto :Stop
)

:: Checking whether Open Secure Shell (SSH) Server Pack file exist
if not exist "%OpenSSH%\OpenSSH-Server-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.OpenSSH Client ^& Server Pack folder is missing the below file...
	echo.
	echo."OpenSSH-Server-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\OpenSSH\10.0.%ImageBuild%^> folder...
	goto :Stop
)

call :RemoveFile "%Temp%\OpenSSH-Client-Package~31bf3856ad364e35~%PackageArchitecture%~~.cab"
call :RemoveFile "%Temp%\OpenSSH-Server-Package~31bf3856ad364e35~%PackageArchitecture%~~.cab"

if "%ImageBuild%" geq "17763" (
	copy /y "%OpenSSH%\OpenSSH-Client-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab" "%Temp%\OpenSSH-Client-Package~31bf3856ad364e35~%PackageArchitecture%~~.cab" >nul
	copy /y "%OpenSSH%\OpenSSH-Server-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab" "%Temp%\OpenSSH-Server-Package~31bf3856ad364e35~%PackageArchitecture%~~.cab" >nul
)
echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Open Secure Shell ^(SSH^) Client ^& Server##############
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if "%ImageIndexNo%" equ "*" echo.    Image Indexes            : 1-%ImageCount%
if "%ImageIndexNo%" neq "*" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
if "%ImageIndexNo%" neq "*" echo.    Image Edition            : %ImageEdition%
echo.    Image Default Language   : %ImageDefaultLanguage%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Open Secure Shell ^(SSH^) Client ^& Server#######################
echo.-------------------------------------------------------------------------------

if "%ImageIndexNo%" equ "*" (
	echo.
	for /L %%i in (1, 1, %ImageCount%) do (
		if not %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]#############################
		if %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]############################
		echo.
		echo.-------------------------------------------------------------------------------
		echo.Integrating OpenSSH Client Package...
		echo.-------------------------------------------------------------------------------
		if "%ImageBuild%" leq "17134" call :AddPackage "%InstallMount%\%%i", "%OpenSSH%\OpenSSH-Client-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab"
		if "%ImageBuild%" geq "17763" call :AddPackage "%InstallMount%\%%i", "%Temp%\OpenSSH-Client-Package~31bf3856ad364e35~%PackageArchitecture%~~.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating OpenSSH Server Package...
		echo.-------------------------------------------------------------------------------
		if "%ImageBuild%" leq "17134" call :AddPackage "%InstallMount%\%%i", "%OpenSSH%\OpenSSH-Server-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab"
		if "%ImageBuild%" geq "17763" call :AddPackage "%InstallMount%\%%i", "%Temp%\OpenSSH-Server-Package~31bf3856ad364e35~%PackageArchitecture%~~.cab"
	)
) else (
	echo.
	echo.-------------------------------------------------------------------------------
	echo.Integrating OpenSSH Client Package...
	echo.-------------------------------------------------------------------------------
	if "%ImageBuild%" leq "17134" call :AddPackage "%InstallMount%", "%OpenSSH%\OpenSSH-Client-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab"
	if "%ImageBuild%" geq "17763" call :AddPackage "%InstallMount%", "%Temp%\OpenSSH-Client-Package~31bf3856ad364e35~%PackageArchitecture%~~.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating OpenSSH Server Package...
	echo.-------------------------------------------------------------------------------
	if "%ImageBuild%" leq "17134" call :AddPackage "%InstallMount%", "%OpenSSH%\OpenSSH-Server-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab"
	if "%ImageBuild%" geq "17763" call :AddPackage "%InstallMount%", "%Temp%\OpenSSH-Server-Package~31bf3856ad364e35~%PackageArchitecture%~~.cab"
)
call :RemoveFile "%Temp%\OpenSSH-Server-Package~31bf3856ad364e35~%PackageArchitecture%~~.cab"
call :RemoveFile "%Temp%\OpenSSH-Server-Package~31bf3856ad364e35~%PackageArchitecture%~~.cab"
echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Open Secure Shell ^(SSH^) Client ^& Server##############
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set OpenSSH=
set PackageServicePackBuild=
set PackageArchitecture=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Windows Media Feature Pack
::-------------------------------------------------------------------------------------------
:IntMediaFeaturePack

setlocal

cls
echo.===============================================================================
echo.             MSMG ToolKit - Integrate Windows Media Feature Pack
echo.===============================================================================
echo.

:: Setting Windows Media Feature Pack folder path accroding to selected Source OS
if "%SelectedSourceOS%" neq "w10" set "MediaFeaturePack=%MediaFeaturePack%\%SelectedSourceOS%"
if "%SelectedSourceOS%" equ "w10" set "MediaFeaturePack=%MediaFeaturePack%\%SelectedSourceOS%\%ImageVersion%"

:: Getting Install Image Index Architecture
if "%ImageIndexNo%" equ "*" call :GetImageArchitecture "%InstallWim%", 1 >nul
if "%ImageIndexNo%" neq "*" call :GetImageArchitecture "%InstallWim%", %ImageIndexNo% >nul

:: Setting Package Service Pack Build
if "%SelectedSourceOS%" equ "w10" (
	if "%ImageBuild%" equ "10240" set "PackageServicePackBuild=16384"
	if "%ImageBuild%" equ "10586" set "PackageServicePackBuild=0"
	if "%ImageBuild%" equ "14393" set "PackageServicePackBuild=0"
	if "%ImageBuild%" equ "15063" set "PackageServicePackBuild=0"
	if "%ImageBuild%" equ "16299" set "PackageServicePackBuild=15"
	if "%ImageBuild%" equ "17134" set "PackageServicePackBuild=1"
	if "%ImageBuild%" equ "17763" set "PackageServicePackBuild=1"
	if "%ImageBuild%" equ "18362" set "PackageServicePackBuild=1"
	if "%ImageBuild%" equ "19041" set "PackageServicePackBuild=1"
)

:: Setting Package Architecture
if "%ImageArchitecture%" equ "x86" set "PackageArchitecture=x86"
if "%ImageArchitecture%" equ "x64" set "PackageArchitecture=amd64"
if "%ImageArchitecture%" equ "arm64" set "PackageArchitecture=arm64"

:: Checking whether Multi-Index servicing mode is selected
if "%ImageIndexNo%" equ "*" (
	echo.This feature is not available when Multi-Index servicing mode is enabled...
	echo.
	echo.Please Re-choose Source with a Single Index...
	goto :Stop
)

:: Checking whether the selected Source OS is a N, K, KN Editions 
if "%ImageIndexNo%" neq "*" if "%ImageEdition%" neq "StarterN" if "%ImageEdition%" neq "StarterKN" if "%ImageEdition%" neq "HomeBasicN" if "%ImageEdition%" neq "HomeBasicKN" if "%ImageEdition%" neq "CoreN" if "%ImageEdition%" neq "CloudN" if "%ImageEdition%" neq "ProfessionalN" if "%ImageEdition%" neq "ProfessionalKN" if "%ImageEdition%" neq "ProfessionalEducationN" if "%ImageEdition%" neq "ProfessionalEducationKN" if "%ImageEdition%" neq "EnterpriseN" if "%ImageEdition%" neq "EnterpriseKN" if "%ImageEdition%" neq "EnterpriseSN" if "%ImageEdition%" neq "EnterpriseSKN" if "%ImageEdition%" neq "EnterpriseGN" if "%ImageEdition%" neq "UltimateN" if "%ImageEdition%" neq "UltimateKN" if "%ImageEdition%" neq "EducationN" if "%ImageEdition%" neq "EducationKN" (
	if "%SelectedSourceOS%" equ "w7" echo.This feature requires Windows 7 N/K/KN Editions...
	if "%SelectedSourceOS%" equ "w81" echo.This feature requires Windows 8.1 N Editions...
	if "%SelectedSourceOS%" equ "w10" echo.This feature requires Windows 10 N Editions...
	goto :Stop
)

:: Checking whether Windows Media Feature Pack file exist
if "%SelectedSourceOS%" equ "w7" if not exist "%MediaFeaturePack%\Microsoft-Windows-MediaFeaturePack-OOB-Package~31bf3856ad364e35~%PackageArchitecture%~~6.1.7600.16385.cab" (
	echo.Windows Media Feature Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-MediaFeaturePack-OOB-Package~31bf3856ad364e35~%PackageArchitecture%~~6.1.7600.16385.cab"
	echo.
	echo.Please copy the above file to ^<Packs\MediaFeaturePack\%SelectedSourceOS%^> folder...
	goto :Stop
)

:: Checking whether Windows Media Feature Pack file exist
if "%SelectedSourceOS%" equ "w7" if not exist "%MediaFeaturePack%\Microsoft-Windows-Media-Format-OOB-Package~31bf3856ad364e35~%PackageArchitecture%~~6.1.7600.16385.cab" (
	echo.Windows Media Feature Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-Media-Format-OOB-Package~31bf3856ad364e35~%PackageArchitecture%~~6.1.7600.16385.cab"
	echo.
	echo.Please copy the above file to ^<Packs\MediaFeaturePack\%SelectedSourceOS%^> folder...
	goto :Stop
)

:: Checking whether Windows Media Feature Pack file exist
if "%SelectedSourceOS%" equ "w81" if not exist "%MediaFeaturePack%\Microsoft-Windows-MediaFeaturePack-OOB-Package~31bf3856ad364e35~%PackageArchitecture%~~6.3.9600.16384.cab" (
	echo.Windows Media Feature Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-MediaFeaturePack-OOB-Package~31bf3856ad364e35~%PackageArchitecture%~~6.3.9600.16384.cab"
	echo.
	echo.Please copy the above file to ^<Packs\MediaFeaturePack\%SelectedSourceOS%^> folder...
	goto :Stop
)

:: Checking whether Windows Media Feature Pack file exist
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" leq "17763" if not exist "%MediaFeaturePack%\Microsoft-Windows-MediaFeaturePack-OOB-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Media Feature Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-MediaFeaturePack-OOB-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\MediaFeaturePack\%SelectedSourceOS%\%ImageVersion%^> folder...
	goto :Stop
)

:: Checking whether Windows Media Feature Pack file exist
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" leq "17763" if not exist "%MediaFeaturePack%\Microsoft-Windows-MediaFeaturePack-OOB-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Media Feature Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-MediaFeaturePack-OOB-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\MediaFeaturePack\%SelectedSourceOS%\%ImageVersion%^> folder...
	goto :Stop
)

:: Checking whether Windows Media Feature Pack file exist
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "18362" if not exist "%MediaFeaturePack%\Microsoft-Windows-Media-Features-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Media Feature Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-Media-Features-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\MediaFeaturePack\%SelectedSourceOS%\%ImageVersion%^> folder...
	goto :Stop
)

:: Checking whether Windows Media Feature Pack file exist
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "18362" if not exist "%MediaFeaturePack%\Microsoft-Windows-Media-Features-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Media Feature Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-Media-Features-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\MediaFeaturePack\%SelectedSourceOS%\%ImageVersion%^> folder...
	goto :Stop
)

:: Checking whether Windows Media Feature Pack file exist
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "18362" if "%ImageArchitecture%" equ "x64" if not exist "%MediaFeaturePack%\Microsoft-Windows-Media-Features-Package~31bf3856ad364e35~wow64~~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Media Feature Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-Media-Features-Package~31bf3856ad364e35~wow64~~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\MediaFeaturePack\%SelectedSourceOS%\%ImageVersion%^> folder...
	goto :Stop
)

:: Checking whether Windows Media Feature Pack file exist
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "18362" if "%ImageArchitecture%" equ "x64" if not exist "%MediaFeaturePack%\Microsoft-Windows-Media-Features-Package~31bf3856ad364e35~wow64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Media Feature Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-Media-Features-Package~31bf3856ad364e35~wow64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\MediaFeaturePack\%SelectedSourceOS%\%ImageVersion%^> folder...
	goto :Stop
)
echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Windows Media Feature Pack############################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.    Image Edition            : %ImageEdition%
echo.    Image Default Language   : %ImageDefaultLanguage%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Windows Media Feature Pack#####################################
echo.-------------------------------------------------------------------------------
if "%SelectedSourceOS%" equ "w7" (
	echo.
	echo.-------------------------------------------------------------------------------
	echo.Integrating Microsoft Windows Media Feature Pack OOB Package
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%MediaFeaturePack%\Microsoft-Windows-MediaFeaturePack-OOB-Package~31bf3856ad364e35~%PackageArchitecture%~~6.1.7600.16385.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating Microsoft Windows Media Format OOB Package
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%MediaFeaturePack%\Microsoft-Windows-Media-Format-OOB-Package~31bf3856ad364e35~%PackageArchitecture%~~6.1.7600.16385.cab"
)

if "%SelectedSourceOS%" equ "w81" call :AddPackage "%InstallMount%", "%MediaFeaturePack%\Microsoft-Windows-MediaFeaturePack-OOB-Package~31bf3856ad364e35~%PackageArchitecture%~~6.3.9600.16384.cab"

if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" leq "17763" (
	echo.
	echo.-------------------------------------------------------------------------------
	echo.Integrating Microsoft Windows Media Feature Pack OOB Package
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%MediaFeaturePack%\Microsoft-Windows-MediaFeaturePack-OOB-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating Microsoft Windows Media Feature Pack OOB [%ImageDefaultLanguage%] Package
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%MediaFeaturePack%\Microsoft-Windows-MediaFeaturePack-OOB-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
)

if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "18362" (
	echo.
	call :RemoveFolder "%Temp%\Updates\MediaFeaturePack"
	call :CreateFolder "%Temp%\Updates\MediaFeaturePack"
	expand -R "%MediaFeaturePack%\Microsoft-Windows-Media-Features-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab" -F:* "%Temp%\Updates\MediaFeaturePack" >nul
	echo.-------------------------------------------------------------------------------
	echo.Integrating Microsoft Windows Media Features Package
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%Temp%\Updates\MediaFeaturePack"
	echo.-------------------------------------------------------------------------------
	echo.Integrating Microsoft Windows Media Features [%ImageDefaultLanguage%] Package
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%MediaFeaturePack%\Microsoft-Windows-Media-Features-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
	if "%ImageArchitecture%" equ "x64" (
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Windows Media Features WOW64 Package...
		echo.-------------------------------------------------------------------------------
		call :AddPackage "%InstallMount%", "%MediaFeaturePack%\Microsoft-Windows-Media-Features-Package~31bf3856ad364e35~wow64~~%ImageVersion%.%PackageServicePackBuild%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Windows Media Features [%ImageDefaultLanguage%] WOW64 Package...
		echo.-------------------------------------------------------------------------------
		call :AddPackage "%InstallMount%", "%MediaFeaturePack%\Microsoft-Windows-Media-Features-Package~31bf3856ad364e35~wow64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
	)
	call :RemoveFolder "%Temp%\Updates"
)
echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Windows Media Feature Pack############################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set MediaFeaturePack=
set PackageServicePackBuild=
set PackageArchitecture=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Windows Portable Devices
::-------------------------------------------------------------------------------------------
:IntPortableDevices

setlocal

cls
echo.===============================================================================
echo.             MSMG ToolKit - Integrate Windows Portable Devices
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
if "%ImageIndexNo%" equ "*" call :GetImageArchitecture "%InstallWim%", 1 >nul
if "%ImageIndexNo%" neq "*" call :GetImageArchitecture "%InstallWim%", %ImageIndexNo% >nul

:: Setting Windows Portable Devices Pack Path
set "PortableDevices=%PortableDevices%\10.0.%ImageBuild%"

:: Setting Package Service Pack Build
if "%ImageBuild%" equ "10240" set "PackageServicePackBuild=16384"
if "%ImageBuild%" equ "14393" set "PackageServicePackBuild=0"
if "%ImageBuild%" equ "15063" set "PackageServicePackBuild=0"
if "%ImageBuild%" equ "16299" set "PackageServicePackBuild=15"
if "%ImageBuild%" equ "17134" set "PackageServicePackBuild=1"
if "%ImageBuild%" equ "17763" set "PackageServicePackBuild=1"
if "%ImageBuild%" equ "18362" set "PackageServicePackBuild=1"
if "%ImageBuild%" equ "19041" set "PackageServicePackBuild=1"

:: Setting Package Architecture
if "%ImageArchitecture%" equ "x86" set "PackageArchitecture=x86"
if "%ImageArchitecture%" equ "x64" set "PackageArchitecture=amd64"

:: Checking whether Multi-Index servicing mode is selected
if "%ImageIndexNo%" equ "*" (
	echo.This feature is not available when Multi-Index servicing mode is enabled...
	echo.
	echo.Please Re-choose Source with a Single Index...
	goto :Stop
)

:: Checking whether the selected Source OS is a N, K, KN Editions 
if "%ImageIndexNo%" neq "*" if "%ImageEdition%" neq "StarterN" if "%ImageEdition%" neq "StarterKN" if "%ImageEdition%" neq "HomeBasicN" if "%ImageEdition%" neq "HomeBasicKN" if "%ImageEdition%" neq "CoreN" if "%ImageEdition%" neq "CloudN" if "%ImageEdition%" neq "ProfessionalN" if "%ImageEdition%" neq "ProfessionalKN" if "%ImageEdition%" neq "ProfessionalEducationN" if "%ImageEdition%" neq "ProfessionalEducationKN" if "%ImageEdition%" neq "EnterpriseN" if "%ImageEdition%" neq "EnterpriseKN" if "%ImageEdition%" neq "EnterpriseSN" if "%ImageEdition%" neq "EnterpriseSKN" if "%ImageEdition%" neq "EnterpriseGN" if "%ImageEdition%" neq "UltimateN" if "%ImageEdition%" neq "UltimateKN" if "%ImageEdition%" neq "EducationN" if "%ImageEdition%" neq "EducationKN" (
	if "%SelectedSourceOS%" equ "w7" echo.This feature requires Windows 7 N/K/KN Editions...
	if "%SelectedSourceOS%" equ "w81" echo.This feature requires Windows 8.1 N Editions...
	if "%SelectedSourceOS%" equ "w10" echo.This feature requires Windows 10 N Editions...
	goto :Stop
)

:: Checking whether Windows Portable Devices Pack file exist
if not exist "%PortableDevices%\Microsoft-Windows-Portable-Devices-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Portable Devices Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-Portable-Devices-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\PortableDevices\10.0.%ImageBuild%^> folder...
	goto :Stop
)

:: Checking whether Windows Portable Devices Pack file exist
if not exist "%PortableDevices%\Microsoft-Windows-Portable-Devices-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Portable Devices Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-Portable-Devices-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\PortableDevices\10.0.%ImageBuild%^> folder...
	goto :Stop
)

:: Checking whether Windows Portable Devices Pack file exist
if "%ImageBuild%" leq "17763" if "%ImageArchitecture%" equ "x64" if not exist "%PortableDevices%\Microsoft-Windows-Portable-Devices-WOW64-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Portable Devices Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-Portable-Devices-WOW64-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\PortableDevices\10.0.%ImageBuild%^> folder...
	goto :Stop
)

:: Checking whether Windows Portable Devices Pack file exist
if "%ImageBuild%" leq "17763" if "%ImageArchitecture%" equ "x64" if not exist "%PortableDevices%\Microsoft-Windows-Portable-Devices-WOW64-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Portable Devices Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-Portable-Devices-WOW64-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\PortableDevices\10.0.%ImageBuild%^> folder...
	goto :Stop
)

:: Checking whether Windows Portable Devices Pack file exist
if "%ImageBuild%" geq "18362" if "%ImageArchitecture%" equ "x64" if not exist "%PortableDevices%\Microsoft-Windows-Portable-Devices-WOW64-Package~31bf3856ad364e35~wow64~~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Portable Devices Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-Portable-Devices-WOW64-Package~31bf3856ad364e35~wow64~~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\PortableDevices\10.0.%ImageBuild%^> folder...
	goto :Stop
)

:: Checking whether Windows Portable Devices Pack file exist
if "%ImageBuild%" geq "18362" if "%ImageArchitecture%" equ "x64" if not exist "%PortableDevices%\Microsoft-Windows-Portable-Devices-WOW64-Package~31bf3856ad364e35~wow64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Portable Devices Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-Portable-Devices-WOW64-Package~31bf3856ad364e35~wow64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\PortableDevices\10.0.%ImageBuild%^> folder...
	goto :Stop
)
echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Windows Portable Devices##############################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if "%ImageIndexNo%" equ "*" echo.    Image Indexes            : 1-%ImageCount%
if "%ImageIndexNo%" neq "*" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
if "%ImageIndexNo%" neq "*" echo.    Image Edition            : %ImageEdition%
echo.    Image Default Language   : %ImageDefaultLanguage%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Windows Portable Devices#######################################
echo.-------------------------------------------------------------------------------
echo.
echo.-------------------------------------------------------------------------------
echo.Integrating Windows Portable Devices Package...
echo.-------------------------------------------------------------------------------
call :AddPackage "%InstallMount%", "%PortableDevices%\Microsoft-Windows-Portable-Devices-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab"
echo.-------------------------------------------------------------------------------
echo.Integrating Windows Portable Devices [%ImageDefaultLanguage%] Language Package...
echo.-------------------------------------------------------------------------------
call :AddPackage "%InstallMount%", "%PortableDevices%\Microsoft-Windows-Portable-Devices-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"

if "%ImageArchitecture%" equ "x64" (
	echo.-------------------------------------------------------------------------------
	echo.Integrating Windows Portable Devices WOW64 Package...
	echo.-------------------------------------------------------------------------------
	if "%ImageBuild%" leq "17763" call :AddPackage "%InstallMount%", "%PortableDevices%\Microsoft-Windows-Portable-Devices-WOW64-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
	if "%ImageBuild%" geq "18362" call :AddPackage "%InstallMount%", "%PortableDevices%\Microsoft-Windows-Portable-Devices-WOW64-Package~31bf3856ad364e35~wow64~~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating Windows Portable Devices [%ImageDefaultLanguage%] Language WOW64 Package...
	echo.-------------------------------------------------------------------------------
	if "%ImageBuild%" leq "17763" call :AddPackage "%InstallMount%", "%PortableDevices%\Microsoft-Windows-Portable-Devices-WOW64-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
	if "%ImageBuild%" geq "18362" call :AddPackage "%InstallMount%", "%PortableDevices%\Microsoft-Windows-Portable-Devices-WOW64-Package~31bf3856ad364e35~wow64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
)

echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Windows Portable Devices##############################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set PortableDevices=
set PackageServicePackBuild=
set PackageArchitecture=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Windows Remote Server Administration Tool (RSAT)
::-------------------------------------------------------------------------------------------
:IntRSAT

setlocal

set RSATType=

if "%SelectedSourceOS%" equ "w10" (
	cls
	echo.===============================================================================
	echo.   MSMG ToolKit - Integrate Windows Remote Server Administration Tool ^(RSAT^)
	echo.===============================================================================
	echo.
	echo.  [1]  RSAT for Managing targets older than Windows Server, version 1709
	echo.
	echo.  [2]  RSAT for Managing Windows Server, version 1709
	echo.
	echo.  [3]  RSAT for Managing Windows Server, version 1803
	echo.
	echo.  [X]  Go Back
	echo.
	echo.===============================================================================
	echo.
	choice /C:123X /N /M "Enter Your Choice : "
	if errorlevel 4 goto :IntegrateMenu
	if errorlevel 3 set RSATType=v1803
	if errorlevel 2 set RSATType=v1709
	if errorlevel 1 set RSATType=v1609
)

cls
echo.===============================================================================
echo.   MSMG ToolKit - Integrate Windows Remote Server Administration Tool ^(RSAT^)
echo.===============================================================================
echo.

:: Setting Windows Remote Server Administration Tool (RSAT) Pack folder path according to selected Source OS
set "RSAT=%RSAT%\%SelectedSourceOS%"

:: Getting Install Image Index Architecture
if "%ImageIndexNo%" equ "*" call :GetImageArchitecture "%InstallWim%", 1 >nul
if "%ImageIndexNo%" neq "*" call :GetImageArchitecture "%InstallWim%", %ImageIndexNo% >nul

:: Setting Package Architecture
if "%ImageArchitecture%" equ "x86" set "PackageArchitecture=x86"
if "%ImageArchitecture%" equ "x64" set "PackageArchitecture=amd64"

:: Checking whether Windows Remote Server Administration Tool (RSAT) Pack file exist
if "%SelectedSourceOS%" equ "w7" if not exist "%RSAT%\Microsoft-Windows-RemoteServerAdministrationTools-Client-Package-TopLevel~31bf3856ad364e35~%PackageArchitecture%.cab" (
	echo.Remote Server Administration Tool Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-RemoteServerAdministrationTools-Client-Package-TopLevel~31bf3856ad364e35~%PackageArchitecture%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\RSAT\%SelectedSourceOS%^> folder...
	goto :Stop
)

:: Checking whether Windows Remote Server Administration Tool (RSAT) for Streaming Media Services Pack file exist
if "%SelectedSourceOS%" equ "w7" if not exist "%RSAT%\Microsoft-Windows-MediaServer-Admin-Package-TopLevel~31bf3856ad364e35~%PackageArchitecture%.cab" (
	echo.Remote Server Administration Tool Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-MediaServer-Admin-Package-TopLevel~31bf3856ad364e35~%PackageArchitecture%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\RSAT\%SelectedSourceOS%^> folder...
	goto :Stop
)

:: Checking whether Windows Remote Server Administration Tool (RSAT) Pack file exist
if "%SelectedSourceOS%" equ "w81" if not exist "%RSAT%\Microsoft-Windows-RemoteServerAdministrationTools-Client-Package-TopLevel~31bf3856ad364e35~%PackageArchitecture%.cab" (
	echo.Remote Server Administration Tool Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-RemoteServerAdministrationTools-Client-Package-TopLevel~31bf3856ad364e35~%PackageArchitecture%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\RSAT\%SelectedSourceOS%^> folder...
	goto :Stop
)

:: Checking whether Windows Remote Server Administration Tool (RSAT) Pack file exist
if "%SelectedSourceOS%" equ "w10" if "%RSATType%" equ "v1609" if not exist "%RSAT%\10.0.14393\Microsoft-Windows-RemoteServerAdministrationTools-Client-Package-TopLevel~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0.cab" (
	echo.Remote Server Administration Tool Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-RemoteServerAdministrationTools-Client-Package-TopLevel~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0.cab"
	echo.
	echo.Please copy the above file to ^<Packs\RSAT\%SelectedSourceOS%\10.0.14393^> folder...
	goto :Stop
)

:: Checking whether Windows Remote Server Administration Tool (RSAT) Pack file exist
if "%SelectedSourceOS%" equ "w10" if "%RSATType%" equ "v1709" if not exist "%RSAT%\10.0.16299\Microsoft-Windows-RemoteServerAdministrationTools-Client-Package-TopLevel~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15.cab" (
	echo.Remote Server Administration Tool Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-RemoteServerAdministrationTools-Client-Package-TopLevel~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15.cab"
	echo.
	echo.Please copy the above file to ^<Packs\RSAT\%SelectedSourceOS%\10.0.16299^> folder...
	goto :Stop
)

:: Checking whether Windows Remote Server Administration Tool (RSAT) Pack file exist
if "%SelectedSourceOS%" equ "w10" if "%RSATType%" equ "v1803" if not exist "%RSAT%\10.0.17134\Microsoft-Windows-RemoteServerAdministrationTools-Client-Package-TopLevel~31bf3856ad364e35~%PackageArchitecture%~~10.0.17134.1.cab" (
	echo.Remote Server Administration Tool Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-RemoteServerAdministrationTools-Client-Package-TopLevel~31bf3856ad364e35~%PackageArchitecture%~~10.0.17134.1.cab"
	echo.
	echo.Please copy the above file to ^<Packs\RSAT\%SelectedSourceOS%\10.0.17134^> folder...
	goto :Stop
)
echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Windows Remote Server Administration Tool ^(RSAT^)######
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if "%ImageIndexNo%" equ "*" echo.    Image Indexes            : 1-%ImageCount%
if "%ImageIndexNo%" neq "*" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
if "%ImageIndexNo%" neq "*" echo.    Image Edition            : %ImageEdition%
echo.    Image Default Language   : %ImageDefaultLanguage%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Windows Remote Server Administration Tool ^(RSAT^)###############
echo.-------------------------------------------------------------------------------

if "%ImageIndexNo%" equ "*" (
	echo.
	for /L %%i in (1, 1, %ImageCount%) do (
		if not %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]#############################
		if %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]############################
		echo.
		
		:: Getting Image Index Information
		call :GetImageIndexInfo "%InstallWim%", %%i >nul

		:: Checking whether the selected Source OS is a valid editions
		if "%SelectedSourceOS%" equ "w7" if "!ImageEdition:~,12!" neq "Professional" if "!ImageEdition:~,8!" neq "Ultimate" (
			echo.
			echo.This feature eequires Windows 7 Professional or Ultimate Editions...
			echo.
			echo.-------------------------------------------------------------------------------
			echo.####Skipping Integrating Windows Remote Server Administration Tool ^(RSAT^)######
			echo.-------------------------------------------------------------------------------
			echo.
		)
		if "%SelectedSourceOS%" neq "w7" if "!ImageEdition:~,12!" neq "Professional" if "!ImageEdition:~,10!" neq "Enterprise" (
			echo.
			if "%SelectedSourceOS%" equ "w81" echo.This Feature Requires Windows 8.1 Professional or Enterprise Editions...
			if "%SelectedSourceOS%" equ "w10" echo.This Feature Requires Windows 10 Professional or Enterprise Editions...
			echo.
			echo.-------------------------------------------------------------------------------
			echo.####Skipping Integrating Windows Remote Server Administration Tool ^(RSAT^)######
			echo.-------------------------------------------------------------------------------
			echo.
		)

		if "%SelectedSourceOS%" equ "w7" if "!ImageEdition:~,7!" neq "Starter" if "!ImageEdition:~,9!" neq "HomeBasic" if "!ImageEdition:~,11!" neq "HomePremium" if "!ImageEdition:~,6!" neq "Server" (
			echo.
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows Remote Server Administration Tool ^(RSAT^) Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%\%%i", "%RSAT%\Microsoft-Windows-RemoteServerAdministrationTools-Client-Package-TopLevel~31bf3856ad364e35~%PackageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows RSAT for Streaming Media Services Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%\%%i", "%RSAT%\Microsoft-Windows-MediaServer-Admin-Package-TopLevel~31bf3856ad364e35~%PackageArchitecture%.cab"
		)

		if "%SelectedSourceOS%" equ "w81" if "!ImageEdition!" neq "Core" if "!ImageEdition!" neq "CoreN" if "!ImageEdition!" neq "CoreSingleLanguage" if "!ImageEdition:~,6!" neq "Server" (
			call :AddPackage "%InstallMount%\%%i", "%RSAT%\Microsoft-Windows-RemoteServerAdministrationTools-Client-Package-TopLevel~31bf3856ad364e35~%PackageArchitecture%.cab"
		)

		if "%SelectedSourceOS%" equ "w10" if "!ImageEdition!" neq "Core" if "!ImageEdition!" neq "CoreN" if "!ImageEdition!" neq "CoreSingleLanguage" if "!ImageEdition!" neq "Education" if "!ImageEdition!" neq "EducationN" if "!ImageEdition!" neq "ProfessionalEducation" if "!ImageEdition!" neq "ProfessionalEducationN" if "!ImageEdition!" neq "Cloud" if "!ImageEdition!" neq "CloudN" if "!ImageEdition:~,6!" neq "Server" (
			if "%RSATType%" equ "v1609" call :AddPackage "%InstallMount%\%%i", "%RSAT%\10.0.14393\Microsoft-Windows-RemoteServerAdministrationTools-Client-Package-TopLevel~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0.cab"
			if "%RSATType%" equ "v1709" call :AddPackage "%InstallMount%\%%i", "%RSAT%\10.0.16299\Microsoft-Windows-RemoteServerAdministrationTools-Client-Package-TopLevel~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15.cab"
			if "%RSATType%" equ "v1803" call :AddPackage "%InstallMount%\%%i", "%RSAT%\10.0.17134\Microsoft-Windows-RemoteServerAdministrationTools-Client-Package-TopLevel~31bf3856ad364e35~%PackageArchitecture%~~10.0.17134.1.cab"
		)
	)
) else (
	:: Checking whether the selected Source OS is a valid editions
	if "%SelectedSourceOS%" equ "w7" if "%ImageEdition:~,12%" neq "Professional" if "%ImageEdition:~,8%" neq "Ultimate" (
		echo.
		echo.This feature requires Windows 7 Professional or Ultimate Editions...
		echo.
		echo.-------------------------------------------------------------------------------
		echo.####Skipping Integrating Windows Remote Server Administration Tool ^(RSAT^)######
		echo.-------------------------------------------------------------------------------
		goto :Stop
	)

	if "%SelectedSourceOS%" neq "w7" if "!ImageEdition:~,12!" neq "Professional" if "!ImageEdition:~,10!" neq "Enterprise" (
		echo.
		if "%SelectedSourceOS%" equ "w81" echo.This feature requires Windows 8.1 Professional or Enterprise Editions...
		if "%SelectedSourceOS%" equ "w10" echo.This feature requires Windows 10 Professional or Enterprise Editions...
		echo.
		echo.-------------------------------------------------------------------------------
		echo.####Skipping Integrating Windows Remote Server Administration Tool ^(RSAT^)######
		echo.-------------------------------------------------------------------------------
		goto :Stop
	)

	if "%SelectedSourceOS%" equ "w7" if "!ImageEdition:~,7!" neq "Starter" if "!ImageEdition:~,9!" neq "HomeBasic" if "!ImageEdition:~,11!" neq "HomePremium" if "!ImageEdition:~,6!" neq "Server" (
		echo.
		echo.-------------------------------------------------------------------------------
		echo.Integrating Windows Remote Server Administration Tool ^(RSAT^) Package...
		echo.-------------------------------------------------------------------------------
		call :AddPackage "%InstallMount%", "%RSAT%\Microsoft-Windows-RemoteServerAdministrationTools-Client-Package-TopLevel~31bf3856ad364e35~%PackageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Windows RSAT for Streaming Media Services Package...
		echo.-------------------------------------------------------------------------------
		call :AddPackage "%InstallMount%", "%RSAT%\Microsoft-Windows-MediaServer-Admin-Package-TopLevel~31bf3856ad364e35~%PackageArchitecture%.cab"
	)
	
	if "%SelectedSourceOS%" equ "w81" if "!ImageEdition!" neq "Core" if "!ImageEdition!" neq "CoreN" if "!ImageEdition!" neq "CoreSingleLanguage" if "!ImageEdition:~,6!" neq "Server" (
		call :AddPackage "%InstallMount%", "%RSAT%\Microsoft-Windows-RemoteServerAdministrationTools-Client-Package-TopLevel~31bf3856ad364e35~%PackageArchitecture%.cab"
	)

	if "%SelectedSourceOS%" equ "w10" if "!ImageEdition!" neq "Core" if "!ImageEdition!" neq "CoreN" if "!ImageEdition!" neq "CoreSingleLanguage" if "!ImageEdition!" neq "Education" if "!ImageEdition!" neq "EducationN" if "!ImageEdition!" neq "ProfessionalEducation" if "!ImageEdition!" neq "ProfessionalEducationN" if "!ImageEdition!" neq "Cloud" if "!ImageEdition!" neq "CloudN" if "!ImageEdition:~,6!" neq "Server" (
		if "%RSATType%" equ "v1609" call :AddPackage "%InstallMount%", "%RSAT%\10.0.14393\Microsoft-Windows-RemoteServerAdministrationTools-Client-Package-TopLevel~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0.cab"
		if "%RSATType%" equ "v1709" call :AddPackage "%InstallMount%", "%RSAT%\10.0.16299\Microsoft-Windows-RemoteServerAdministrationTools-Client-Package-TopLevel~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15.cab"
		if "%RSATType%" equ "v1803" call :AddPackage "%InstallMount%", "%RSAT%\10.0.17134\Microsoft-Windows-RemoteServerAdministrationTools-Client-Package-TopLevel~31bf3856ad364e35~%PackageArchitecture%~~10.0.17134.1.cab"
	)
)
echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Windows Remote Server Administration Tool ^(RSAT^)######
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set RSAT=
set RSATType=
set PackageArchitecture=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: MSMG ToolKit - Integrate Microsoft Default Metro Apps
::-------------------------------------------------------------------------------------------
:IntMetroApps

setlocal

set MetroApp=

set Alarms_Appx=
set AppConnector_Appx=
set BingFinance_Appx=
set BingFoodDrink_Appx=
set BingHealthFitness_Appx=
set BingMaps_Appx=
set BingNews_Appx=
set BingSports_Appx=
set BingTravel_Appx=
set BingWeather_Appx=
set Calculator_Appx=
set Camera_Appx=
set CommunicationsApps_Appx=
set DesktopAppInstaller_Appx=
set FeedbackHub_Appx=
set GetHelp_Appx=
set Getstarted_Appx=
set HEIFImageExtension_arm_Appx=
set HEIFImageExtension_x86_Appx=
set HEIFImageExtension_x64_Appx=
set HEVCVideoExtension_arm_Appx=
set HEVCVideoExtension_x86_Appx=
set HEVCVideoExtension_x64_Appx=
set HelpAndTips_Appx=
set Maps_Appx=
set Messaging_Appx=
set MixedRealityPortal_Appx=
set MPEG2VideoExtension_arm_Appx=
set MPEG2VideoExtension_x86_Appx=
set MPEG2VideoExtension_x64_Appx=
set OfficeHub_Appx=
set OfficeOneNote_Appx=
set OfficeSway_Appx=
set OneConnect_Appx=
set Paint3D_Appx=
set People_Appx=
set Phone_Appx=
set PhoneCompanion_Appx=
set Photos_Appx=
set Print3D_Appx=
set Reader_Appx=
set ReadingList_Appx=
set Scan_Appx=
set ScreenSketch_Appx=
set Skype_Appx=
set SolitaireCollection_Appx=
set SoundRecorder_Appx=
set StickyNotes_Appx=
set Store_Appx=
set StorePurchase_Appx=
set ThreeDBuilder_Appx=
set ThreeDViewer_Appx=
set VP9VideoExtensions_arm_Appx=
set VP9VideoExtensions_x86_Appx=
set VP9VideoExtensions_x64_Appx=
set Wallet_Appx=
set WebMediaExtensions_Appx=
set WebpImageExtension_arm_Appx=
set WebpImageExtension_x86_Appx=
set WebpImageExtension_x64_Appx=
set WiFi_Appx=
set Xbox_Appx=
set XboxGameOverlay_Appx=
set XboxGamingOverlay_Appx=
set XboxIdentityProvider_Appx=
set XboxLiveGames_Appx=
set XboxSpeechToTextOverlay_Appx=
set XboxTCUI_Appx=
set YourPhone_Appx=
set ZuneMusic_Appx=
set ZuneVideo_Appx=

set Alarms_License=
set AppConnector_License=
set BingFinance_License=
set BingFoodDrink_License=
set BingHealthFitness_License=
set BingMaps_License=
set BingNews_License=
set BingSports_License=
set BingTravel_License=
set BingWeather_License=
set Calculator_License=
set Camera_License=
set CommunicationsApps_License=
set DesktopAppInstaller_License=
set FeedbackHub_License=
set GetHelp_License=
set Getstarted_License=
set HEIFImageExtension_arm_License=
set HEIFImageExtension_x86_License=
set HEIFImageExtension_x64_License=
set HEVCVideoExtension_arm_License=
set HEVCVideoExtension_x86_License=
set HEVCVideoExtension_x64_License=
set HelpAndTips_License=
set Maps_License=
set Messaging_License=
set MixedRealityPortal_License=
set MPEG2VideoExtension_arm_License=
set MPEG2VideoExtension_x86_License=
set MPEG2VideoExtension_x64_License=
set OfficeHub_License=
set OfficeOneNote_License=
set OfficeSway_License=
set OneConnect_License=
set Paint3D_License=
set People_License=
set Phone_License=
set PhoneCompanion_License=
set Photos_License=
set Print3D_License=
set Reader_License=
set ReadingList_License=
set Scan_License=
set ScreenSketch_License=
set Skype_License=
set SolitaireCollection_License=
set SoundRecorder_License=
set StickyNotes_License=
set Store_License=
set StorePurchase_License=
set ThreeDBuilder_License=
set ThreeDViewer_License=
set VP9VideoExtensions_arm_License=
set VP9VideoExtensions_x86_License=
set VP9VideoExtensions_x64_License=
set Wallet_License=
set WebMediaExtensions_License=
set WebpImageExtension_arm_License=
set WebpImageExtension_x86_License=
set WebpImageExtension_x64_License=
set WiFi_License=
set Xbox_License=
set XboxGameOverlay_License=
set XboxGamingOverlay_License=
set XboxIdentityProvider_License=
set XboxLiveGames_License=
set XboxSpeechToTextOverlay_License=
set XboxTCUI_License=
set YourPhone_License=
set ZuneMusic_License=
set ZuneVideo_License=

set DependencyPackagePath=

set AdvertisingXaml_arm_Appx=
set AdvertisingXaml_arm64_Appx=
set AdvertisingXaml_x86_Appx=
set AdvertisingXaml_x64_Appx=
set MediaPlayReadyClient22_arm_Appx=
set MediaPlayReadyClient22_x86_Appx=
set MediaPlayReadyClient22_x64_Appx=
set NETNativeFramework13_arm_Appx=
set NETNativeFramework13_x86_Appx=
set NETNativeFramework13_x64_Appx=
set NETNativeFramework16_arm_Appx=
set NETNativeFramework16_x86_Appx=
set NETNativeFramework16_x64_Appx=
set NETNativeFramework17_arm_Appx=
set NETNativeFramework17_x86_Appx=
set NETNativeFramework17_x64_Appx=
set NETNativeFramework21_arm_Appx=
set NETNativeFramework21_x86_Appx=
set NETNativeFramework21_x64_Appx=
set NETNativeFramework22_arm_Appx=
set NETNativeFramework22_arm64_Appx=
set NETNativeFramework22_x86_Appx=
set NETNativeFramework22_x64_Appx=
set NETNativeRuntime13_arm_Appx=
set NETNativeRuntime13_x86_Appx=
set NETNativeRuntime13_x64_Appx=
set NETNativeRuntime14_arm_Appx=
set NETNativeRuntime14_x86_Appx=
set NETNativeRuntime14_x64_Appx=
set NETNativeRuntime16_arm_Appx=
set NETNativeRuntime16_x86_Appx=
set NETNativeRuntime16_x64_Appx=
set NETNativeRuntime17_arm_Appx=
set NETNativeRuntime17_x86_Appx=
set NETNativeRuntime17_x64_Appx=
set NETNativeRuntime21_arm_Appx=
set NETNativeRuntime21_x86_Appx=
set NETNativeRuntime21_x64_Appx=
set NETNativeRuntime22_arm_Appx=
set NETNativeRuntime22_arm64_Appx=
set NETNativeRuntime22_x86_Appx=
set NETNativeRuntime22_x64_Appx=
set ServicesStoreEngagement_arm_Appx=
set ServicesStoreEngagement_arm64_Appx=
set ServicesStoreEngagement_x86_Appx=
set ServicesStoreEngagement_x64_Appx=
set UIXaml20_arm_Appx=
set UIXaml20_arm64_Appx=
set UIXaml20_x86_Appx=
set UIXaml20_x64_Appx=
set UIXaml21_arm_Appx=
set UIXaml21_arm64_Appx=
set UIXaml21_x86_Appx=
set UIXaml21_x64_Appx=
set VCLibs12_arm_Appx=
set VCLibs12_x86_Appx=
set VCLibs12_x64_Appx=
set VCLibs14_arm_Appx=
set VCLibs14_arm64_Appx=
set VCLibs14_x86_Appx=
set VCLibs14_x64_Appx=
set VCLibsUWPDesktop14_arm_Appx=
set VCLibsUWPDesktop14_arm64_Appx=
set VCLibsUWPDesktop14_x86_Appx=
set VCLibsUWPDesktop14_x64_Appx=
set WinJS20_Appx=

cls
echo.===============================================================================
echo.           MSMG ToolKit - Integrate Microsoft Default Metro Apps
echo.===============================================================================
echo.

:: Integrate Windows 8.1 Default Metro Apps Menu
if "%SelectedSourceOS%" equ "w81" (
	cls
	echo.===============================================================================
	echo.         MSMG ToolKit - Integrate Microsoft Default Metro Apps Menu
	echo.===============================================================================
	echo.                                  ^|
	echo.  [A]  Alarms                     ^| [R]  Sound Recorder
	echo.  [B]  Calculator                 ^| [S]  Xbox LIVE Games
	echo.  [C]  Calender, Mail ^& People    ^| [T]  Zune Music
	echo.  [D]  Bing Finance               ^| [U]  Zune Video
	echo.  [E]  Bing Food ^& Drink          ^|
	echo.  [F]  Bing Health ^& Fitness      ^|
	echo.  [G]  Bing Maps                  ^|
	echo.  [H]  Bing News                  ^|
	echo.  [I]  Bing Sports                ^|
	echo.  [J]  Bing Travel                ^|
	echo.  [K]  Bing Weather               ^|
	echo.  [L]  Help ^& Tips                ^|
	echo.  [M]  Office OneNote             ^|
	echo.  [N]  Reader                     ^|
	echo.  [O]  Reading List               ^|
	echo.  [P]  Scan                       ^| [1]  All Apps
	echo.  [Q]  Skype                      ^| [X]  Go Back
	echo.                                  ^|
	echo.===============================================================================
	echo.
	choice /C:ABCDEFGHIJKLMNOPQRSTU1X /N /M "Enter Your Choice : "
	if errorlevel 23 goto :IntFeatures
	if errorlevel 22 set "MetroApp=AllApps"
	if errorlevel 21 set "MetroApp=ZuneVideo"
	if errorlevel 20 set "MetroApp=ZuneMusic"
	if errorlevel 19 set "MetroApp=XboxLiveGames"
	if errorlevel 18 set "MetroApp=SoundRecorder"
	if errorlevel 17 set "MetroApp=SkypeApp"
	if errorlevel 16 set "MetroApp=Scan"
	if errorlevel 15 set "MetroApp=ReadingList"
	if errorlevel 14 set "MetroApp=Reader"
	if errorlevel 13 set "MetroApp=OfficeOneNote"
	if errorlevel 12 set "MetroApp=HelpAndTips"
	if errorlevel 11 set "MetroApp=BingWeather"
	if errorlevel 10 set "MetroApp=BingTravel"
	if errorlevel 9  set "MetroApp=BingSports"
	if errorlevel 8  set "MetroApp=BingNews"
	if errorlevel 7  set "MetroApp=BingMaps"
	if errorlevel 6  set "MetroApp=BingHealthFitness"
	if errorlevel 5  set "MetroApp=BingFoodDrink"
	if errorlevel 4  set "MetroApp=BingFinance"
	if errorlevel 3  set "MetroApp=CommunicationsApps"
	if errorlevel 2  set "MetroApp=Calculator"
	if errorlevel 1  set "MetroApp=Alarms"
)

:: Integrate Windows 10 v1507 Default Metro Apps Menu
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "10240" (
	cls
	echo.===============================================================================
	echo.         MSMG ToolKit - Integrate Microsoft Default Metro Apps Menu
	echo.===============================================================================
	echo.                                    ^|
	echo.  [A]  3D Builder                   ^|  [R]  People
	echo.  [B]  Alarms ^& Clock              ^|  [S]  Phone Companion
	echo.  [C]  App Connector                ^|  [T]  Photos
	echo.  [D]  Bing Finance                 ^|  [U]  Solitaire Collection
	echo.  [E]  Bing News                    ^|  [V]  Store
	echo.  [F]  Bing Sports                  ^|  [W]  Voice Recorder
	echo.  [G]  Bing Weather                 ^|  [X]  Xbox App
	echo.  [H]  Calculator                   ^|
	echo.  [I]  Calendar ^& Mail              ^|
	echo.  [J]  Camera                       ^|
	echo.  [K]  Get Office App               ^|
	echo.  [L]  Get Started                  ^|
	echo.  [M]  Get Skype App                ^|
	echo.  [N]  Groove Music                 ^|
	echo.  [O]  Maps                         ^|
	echo.  [P]  Movies ^& TV                  ^|  [1]  All Apps
	echo.  [Q]  Office OneNote               ^|  [2]  Go Back
	echo.                                    ^|
	echo.===============================================================================
	echo.
	choice /C:ABCDEFGHIJKLMNOPQRSTUVWX12 /N /M "Enter Your Choice : "
	if errorlevel 26 goto :IntFeatures
	if errorlevel 25 set "MetroApp=AllApps"
	if errorlevel 24 set "MetroApp=XboxApp"
	if errorlevel 23 set "MetroApp=SoundRecorder"
	if errorlevel 22 set "MetroApp=Store"
	if errorlevel 21 set "MetroApp=SolitaireCollection"
	if errorlevel 20 set "MetroApp=Photos"
	if errorlevel 19 set "MetroApp=PhoneCompanion"
	if errorlevel 18 set "MetroApp=People"
	if errorlevel 17 set "MetroApp=OfficeOneNote"
	if errorlevel 16 set "MetroApp=ZuneVideo"
	if errorlevel 15 set "MetroApp=Maps"
	if errorlevel 14 set "MetroApp=ZuneMusic"
	if errorlevel 13 set "MetroApp=SkypeApp"
	if errorlevel 12 set "MetroApp=Getstarted"
	if errorlevel 11 set "MetroApp=OfficeHub"
	if errorlevel 10 set "MetroApp=Camera"
	if errorlevel 9  set "MetroApp=CommunicationsApps"
	if errorlevel 8  set "MetroApp=Calculator"
	if errorlevel 7  set "MetroApp=BingWeather"	
	if errorlevel 6  set "MetroApp=BingSports"
	if errorlevel 5  set "MetroApp=BingNews"
	if errorlevel 4  set "MetroApp=BingFinance"
	if errorlevel 3  set "MetroApp=AppConnector"
	if errorlevel 2  set "MetroApp=Alarms"
	if errorlevel 1  set "MetroApp=ThreeDBuilder"
)

:: Integrate Windows 10 v1511 Default Metro Apps Menu
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "10586" (
	cls
	echo.===============================================================================
	echo.         MSMG ToolKit - Integrate Microsoft Default Metro Apps Menu
	echo.===============================================================================
	echo.                                    ^|
	echo.  [A]  3D Builder                   ^|  [R]  Office OneNote
	echo.  [B]  Alarms ^& Clock              ^|  [S]  Office Sway
	echo.  [C]  App Connector                ^|  [T]  People
	echo.  [D]  Bing Finance                 ^|  [U]  Phone
	echo.  [E]  Bing News                    ^|  [V]  Phone Companion
	echo.  [F]  Bing Sports                  ^|  [W]  Photos
	echo.  [G]  Bing Weather                 ^|  [X]  Solitaire Collection
	echo.  [H]  Calculator                   ^|  [Y]  Store
	echo.  [I]  Calendar ^& Mail              ^|  [Z]  Voice Recorder
	echo.  [J]  Camera                       ^|  [1]  Xbox App
	echo.  [K]  Get Office App               ^|  [2]  WiFi
	echo.  [L]  Get Started                  ^|
	echo.  [M]  Get Skype App                ^|
	echo.  [N]  Groove Music                 ^|
	echo.  [O]  Maps                         ^|
	echo.  [P]  Messaging                    ^|  [3]  All Apps
	echo.  [Q]  Movies ^& TV                  ^|  [4]  Go Back
	echo.                                    ^|
	echo.===============================================================================
	echo.
	choice /C:ABCDEFGHIJKLMNOPQRSTUVWXYZ1234 /N /M "Enter Your Choice : "
	if errorlevel 30 goto :IntFeatures
	if errorlevel 29 set "MetroApp=AllApps"
	if errorlevel 28 set "MetroApp=WiFi"
	if errorlevel 27 set "MetroApp=XboxApp"
	if errorlevel 26 set "MetroApp=SoundRecorder"
	if errorlevel 25 set "MetroApp=Store"
	if errorlevel 24 set "MetroApp=SolitaireCollection"
	if errorlevel 23 set "MetroApp=Photos"
	if errorlevel 22 set "MetroApp=PhoneCompanion"
	if errorlevel 21 set "MetroApp=Phone"
	if errorlevel 20 set "MetroApp=People"
	if errorlevel 19 set "MetroApp=OfficeSway"
	if errorlevel 18 set "MetroApp=OfficeOneNote"
	if errorlevel 17 set "MetroApp=ZuneVideo"
	if errorlevel 16 set "MetroApp=Messaging"
	if errorlevel 15 set "MetroApp=Maps"
	if errorlevel 14 set "MetroApp=ZuneMusic"
	if errorlevel 13 set "MetroApp=SkypeApp"
	if errorlevel 12 set "MetroApp=Getstarted"
	if errorlevel 11 set "MetroApp=OfficeHub"
	if errorlevel 10 set "MetroApp=Camera"
	if errorlevel 9  set "MetroApp=CommunicationsApps"
	if errorlevel 8  set "MetroApp=Calculator"
	if errorlevel 7  set "MetroApp=BingWeather"	
	if errorlevel 6  set "MetroApp=BingSports"
	if errorlevel 5  set "MetroApp=BingNews"
	if errorlevel 4  set "MetroApp=BingFinance"
	if errorlevel 3  set "MetroApp=AppConnector"
	if errorlevel 2  set "MetroApp=Alarms"
	if errorlevel 1  set "MetroApp=ThreeDBuilder"
)

:: Integrate Windows 10 v1607 Default Metro Apps Menu
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "14393" (
	cls
	echo.===============================================================================
	echo.         MSMG ToolKit - Integrate Microsoft Default Metro Apps Menu
	echo.===============================================================================
	echo.                                    ^|
	echo.  [A]  3D Builder                   ^|  [R]  Skype Preview App
	echo.  [B]  Alarms ^& Clock               ^|  [S]  Solitaire Collection
	echo.  [C]  Calculator                   ^|  [T]  Sticky Notes
	echo.  [D]  Calendar ^& Mail              ^|  [U]  Store
	echo.  [E]  Camera                       ^|  [V]  Store Purchase App
	echo.  [F]  Desktop App Installer        ^|  [W]  Voice Recorder
	echo.  [G]  Feedback Hub                 ^|  [X]  Weather
	echo.  [H]  Get Office App               ^|  [Y]  Xbox App
	echo.  [I]  Get Started                  ^|  [Z]  Xbox Identity Provider
	echo.  [J]  Groove Music                 ^|
	echo.  [K]  Maps                         ^|
	echo.  [L]  Messaging                    ^|
	echo.  [M]  Movies ^& TV                  ^|
	echo.  [N]  Office OneNote               ^|
	echo.  [O]  Paid WiFi ^& Mobile           ^|
	echo.  [P]  People                       ^|  [1]  All Apps
	echo.  [Q]  Photos                       ^|  [2]  Go Back
	echo.                                    ^|
	echo.===============================================================================
	echo.
	choice /C:ABCDEFGHIJKLMNOPQRSTUVWXYZ12 /N /M "Enter Your Choice : "
	if errorlevel 28 goto :IntFeatures
	if errorlevel 27 set "MetroApp=AllApps"  
	if errorlevel 26 set "MetroApp=XboxIdentityProvider"
	if errorlevel 25 set "MetroApp=XboxApp"
	if errorlevel 24 set "MetroApp=BingWeather"
	if errorlevel 23 set "MetroApp=SoundRecorder"
	if errorlevel 22 set "MetroApp=StorePurchaseApp"
	if errorlevel 21 set "MetroApp=Store"
	if errorlevel 20 set "MetroApp=StickyNotes"
	if errorlevel 19 set "MetroApp=SolitaireCollection"
	if errorlevel 18 set "MetroApp=SkypeApp"	
	if errorlevel 17 set "MetroApp=Photos"
	if errorlevel 16 set "MetroApp=People"
	if errorlevel 15 set "MetroApp=OneConnect"
	if errorlevel 14 set "MetroApp=OfficeOneNote"
	if errorlevel 13 set "MetroApp=ZuneVideo"
	if errorlevel 12 set "MetroApp=Messaging"
	if errorlevel 11 set "MetroApp=Maps"
	if errorlevel 10 set "MetroApp=ZuneMusic"
	if errorlevel 9  set "MetroApp=Getstarted"
	if errorlevel 8  set "MetroApp=OfficeHub"
	if errorlevel 7  set "MetroApp=FeedbackHub"
	if errorlevel 6  set "MetroApp=DesktopAppInstaller"	
	if errorlevel 5  set "MetroApp=Camera"
	if errorlevel 4  set "MetroApp=CommunicationsApps"
	if errorlevel 3  set "MetroApp=Calculator"
	if errorlevel 2  set "MetroApp=Alarms"
	if errorlevel 1  set "MetroApp=ThreeDBuilder"
)

:: Integrate Windows 10 v1703 Default Metro Apps Menu
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "15063" (
	cls
	echo.===============================================================================
	echo.         MSMG ToolKit - Integrate Microsoft Default Metro Apps Menu
	echo.===============================================================================
	echo.  [A]  3D Builder                   ^|  [S]  Solitaire Collection
	echo.  [B]  Alarms ^& Clock               ^|  [T]  Sticky Notes
	echo.  [C]  Calculator                   ^|  [U]  Store
	echo.  [D]  Calendar ^& Mail              ^|  [V]  Store Purchase App
	echo.  [E]  Camera                       ^|  [W]  Tips
	echo.  [F]  Desktop App Installer        ^|  [X]  View 3D Preview
	echo.  [G]  Feedback Hub                 ^|  [Y]  Voice Recorder
	echo.  [H]  Get Office App               ^|  [Z]  Wallet
	echo.  [I]  Groove Music                 ^|  [1]  Weather
	echo.  [J]  Maps                         ^|  [2]  Xbox App
	echo.  [K]  Messaging                    ^|  [3]  Xbox Game Overlay
	echo.  [L]  Movies ^& TV                  ^|  [4]  Xbox Identity Provider
	echo.  [M]  Office OneNote               ^|  [5]  Xbox SpeechToText Overlay
	echo.  [N]  Paid WiFi ^& Mobile           ^|
	echo.  [O]  Paint 3D                     ^|
	echo.  [P]  People                       ^|
	echo.  [Q]  Photos                       ^|  [6]  All Apps
	echo.  [R]  Skype Preview App            ^|  [7]  Go Back
	echo.===============================================================================
	echo.
	choice /C:ABCDEFGHIJKLMNOPQRSTUVWXYZ1234567 /N /M "Enter Your Choice : "
	if errorlevel 33 goto :IntFeatures
	if errorlevel 32 set "MetroApp=AllApps"
	if errorlevel 31 set "MetroApp=XboxSpeechToTextOverlay"
	if errorlevel 30 set "MetroApp=XboxIdentityProvider"
	if errorlevel 29 set "MetroApp=XboxGameOverlay"
	if errorlevel 28 set "MetroApp=XboxApp"
	if errorlevel 27 set "MetroApp=BingWeather"
	if errorlevel 26 set "MetroApp=Wallet"
	if errorlevel 25 set "MetroApp=SoundRecorder"
	if errorlevel 24 set "MetroApp=ThreeDViewer"
	if errorlevel 23 set "MetroApp=Getstarted"
	if errorlevel 22 set "MetroApp=StorePurchaseApp"
	if errorlevel 21 set "MetroApp=Store"
	if errorlevel 20 set "MetroApp=StickyNotes"
	if errorlevel 19 set "MetroApp=SolitaireCollection"
	if errorlevel 18 set "MetroApp=SkypeApp"
	if errorlevel 17 set "MetroApp=Photos"
	if errorlevel 16 set "MetroApp=People"
	if errorlevel 15 set "MetroApp=Paint3D"
	if errorlevel 14 set "MetroApp=OneConnect"
	if errorlevel 13 set "MetroApp=OfficeOneNote"
	if errorlevel 12 set "MetroApp=ZuneVideo"
	if errorlevel 11 set "MetroApp=Messaging"
	if errorlevel 10 set "MetroApp=Maps"
	if errorlevel 9  set "MetroApp=ZuneMusic"
	if errorlevel 8  set "MetroApp=OfficeHub"
	if errorlevel 7  set "MetroApp=FeedbackHub"
	if errorlevel 6  set "MetroApp=DesktopAppInstaller"	
	if errorlevel 5  set "MetroApp=Camera"
	if errorlevel 4  set "MetroApp=CommunicationsApps"
	if errorlevel 3  set "MetroApp=Calculator"
	if errorlevel 2  set "MetroApp=Alarms"
	if errorlevel 1  set "MetroApp=ThreeDBuilder"
)

:: Integrate Windows 10 v1709 Default Metro Apps Menu
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "16299" (
	cls
	echo.===============================================================================
	echo.         MSMG ToolKit - Integrate Microsoft Default Metro Apps Menu
	echo.===============================================================================
	echo.  [A]  3D Builder                   ^|  [S]  Solitaire Collection
	echo.  [B]  Alarms ^& Clock               ^|  [T]  Sticky Notes
	echo.  [C]  Calculator                   ^|  [U]  Store
	echo.  [D]  Calendar ^& Mail              ^|  [V]  Store Purchase App
	echo.  [E]  Camera                       ^|  [W]  Tips
	echo.  [F]  Desktop App Installer        ^|  [X]  View 3D Preview
	echo.  [G]  Feedback Hub                 ^|  [Y]  Voice Recorder
	echo.  [H]  Get Office App               ^|  [Z]  Wallet
	echo.  [I]  Groove Music                 ^|  [1]  Weather
	echo.  [J]  Maps                         ^|  [2]  Xbox App
	echo.  [K]  Messaging                    ^|  [3]  Xbox Game Overlay
	echo.  [L]  Movies ^& TV                  ^|  [4]  Xbox Identity Provider
	echo.  [M]  Office OneNote               ^|  [5]  Xbox SpeechToText Overlay
	echo.  [N]  Paid WiFi ^& Mobile          ^|
	echo.  [O]  Paint 3D                     ^|
	echo.  [P]  People                       ^|
	echo.  [Q]  Photos                       ^|  [6]  All Apps
	echo.  [R]  Skype Preview App            ^|  [7]  Go Back
	echo.===============================================================================
	echo.
	choice /C:ABCDEFGHIJKLMNOPQRSTUVWXYZ1234567 /N /M "Enter Your Choice : "
	if errorlevel 33 goto :IntFeatures
	if errorlevel 32 set "MetroApp=AllApps"
	if errorlevel 31 set "MetroApp=XboxSpeechToTextOverlay"
	if errorlevel 30 set "MetroApp=XboxIdentityProvider"
	if errorlevel 29 set "MetroApp=XboxGameOverlay"
	if errorlevel 28 set "MetroApp=XboxApp"
	if errorlevel 27 set "MetroApp=BingWeather"
	if errorlevel 26 set "MetroApp=Wallet"
	if errorlevel 25 set "MetroApp=SoundRecorder"
	if errorlevel 24 set "MetroApp=ThreeDViewer"
	if errorlevel 23 set "MetroApp=Getstarted"
	if errorlevel 22 set "MetroApp=StorePurchaseApp"
	if errorlevel 21 set "MetroApp=Store"
	if errorlevel 20 set "MetroApp=StickyNotes"
	if errorlevel 19 set "MetroApp=SolitaireCollection"
	if errorlevel 18 set "MetroApp=SkypeApp"
	if errorlevel 17 set "MetroApp=Photos"
	if errorlevel 16 set "MetroApp=People"
	if errorlevel 15 set "MetroApp=Paint3D"
	if errorlevel 14 set "MetroApp=OneConnect"
	if errorlevel 13 set "MetroApp=OfficeOneNote"
	if errorlevel 12 set "MetroApp=ZuneVideo"
	if errorlevel 11 set "MetroApp=Messaging"
	if errorlevel 10 set "MetroApp=Maps"
	if errorlevel 9  set "MetroApp=ZuneMusic"
	if errorlevel 8  set "MetroApp=OfficeHub"
	if errorlevel 7  set "MetroApp=FeedbackHub"
	if errorlevel 6  set "MetroApp=DesktopAppInstaller"	
	if errorlevel 5  set "MetroApp=Camera"
	if errorlevel 4  set "MetroApp=CommunicationsApps"
	if errorlevel 3  set "MetroApp=Calculator"
	if errorlevel 2  set "MetroApp=Alarms"
	if errorlevel 1  set "MetroApp=ThreeDBuilder"
)

:: Integrate Windows 10 v1809/V1903/v1909 Default Metro Apps Menu
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "17763" if "%ImageArchitecture%" equ "x86" (
	cls
	echo.===============================================================================
	echo.         MSMG ToolKit - Integrate Microsoft Default Metro Apps Menu
	echo.===============================================================================
	echo.
	echo.  [A]  3DViewer                 -  Mixed Reality Viewer App
	echo.  [B]  Alarms                   -  Alarms ^& Clock App
	echo.  [C]  BingWeather              -  Weather App
	echo.  [D]  Calculator               -  Calculator App
	echo.  [E]  Camera                   -  Camera App
	echo.  [F]  CommunicationsApps       -  Windows Calendar ^& Mail App
	echo.  [G]  DesktopAppInstaller      -  Desktop App Installer
	echo.  [H]  Extensions               -  HEIF, HEVC, MPEG2, VP9, Web, Webp Extensions
	echo.  [I]  FeedbackHub              -  Feedback Hub App
	echo.  [J]  GetHelp                  -  Get Help App
	echo.  [K]  Getstarted               -  Tips App
	echo.  [L]  Maps                     -  Maps App
	echo.  [M]  Messaging                -  Messaging App
	echo.  [N]  OfficeHub                -  My Office App
	echo.  [O]  OfficeOneNote            -  OneNote App
	echo.  [P]  OneConnect               -  Mobile Plans App
	echo.  [Q]  Paint3D                  -  Paint 3D App
	echo.  [R]  People                   -  People App
	echo.  [S]  Photos                   -  Photos App
	echo.  [T]  Print3D                  -  Print 3D App
	echo.  [U]  ScreenSketch             -  Screen Sketch App
	echo.  [V]  SkypeApp                 -  Skype App
	echo.  [W]  SolitaireCollection      -  Solitaire Collection App
	echo.  [X]  SoundRecorder            -  Voice Recorder App
	echo.  [Y]  StickyNotes              -  Sticky Notes App
	echo.  [Z]  Store                    -  Microsoft Store App
	echo.  [1]  WalletService            -  Wallet Service App
	echo.  [2]  XboxApp                  -  Microsoft Xbox App
	echo.  [3]  YourPhone                -  Your Phone App
	echo.  [4]  ZuneMusic                -  Groove Music App
	echo.  [5]  ZuneVideo                -  Films ^& TV App
	echo.
	echo.  [6]  All Windows Apps
	echo.  [7]  Go Back
	echo.
	echo.===============================================================================
	echo.
	choice /C:ABCDEFGHIJKLMNOPQRSTUVWXYZ1234567 /N /M "Enter Your Choice : "
	if errorlevel 33 goto :IntFeatures
	if errorlevel 32 set "MetroApp=AllApps"
	if errorlevel 31 set "MetroApp=ZuneVideo"
	if errorlevel 30 set "MetroApp=ZuneMusic"
	if errorlevel 29 set "MetroApp=YourPhone"
	if errorlevel 28 set "MetroApp=XboxApp"
	if errorlevel 27 set "MetroApp=WalletService"
	if errorlevel 26 set "MetroApp=Store"
	if errorlevel 25 set "MetroApp=StickyNotes"
	if errorlevel 24 set "MetroApp=SoundRecorder"
	if errorlevel 23 set "MetroApp=SolitaireCollection"
	if errorlevel 22 set "MetroApp=SkypeApp"
	if errorlevel 21 set "MetroApp=ScreenSketch"
	if errorlevel 20 set "MetroApp=Print3D"
	if errorlevel 19 set "MetroApp=Photos"
	if errorlevel 18 set "MetroApp=People"
	if errorlevel 17 set "MetroApp=Paint3D"
	if errorlevel 16 set "MetroApp=OneConnect"
	if errorlevel 15 set "MetroApp=OfficeOneNote"
	if errorlevel 14 set "MetroApp=OfficeHub"
	if errorlevel 13 set "MetroApp=Messaging"
	if errorlevel 12 set "MetroApp=Maps"
	if errorlevel 11 set "MetroApp=Getstarted"
	if errorlevel 10 set "MetroApp=GetHelp"
	if errorlevel 9  set "MetroApp=FeedbackHub"
	if errorlevel 8  set "MetroApp=Extensions"
	if errorlevel 7  set "MetroApp=DesktopAppInstaller"
	if errorlevel 6  set "MetroApp=CommunicationsApps"
	if errorlevel 5  set "MetroApp=Camera"
	if errorlevel 4  set "MetroApp=Calculator"
	if errorlevel 3  set "MetroApp=BingWeather"
	if errorlevel 2  set "MetroApp=Alarms"
	if errorlevel 1  set "MetroApp=ThreeDViewer"
)

:: Integrate Windows 10 v1809/V1903/v1909 Default Metro Apps Menu
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "17763" if "%ImageArchitecture%" equ "x64" (
	cls
	echo.===============================================================================
	echo.         MSMG ToolKit - Integrate Microsoft Default Metro Apps Menu
	echo.===============================================================================
	echo.
	echo.  [A]  3DViewer                 -  Mixed Reality Viewer App
	echo.  [B]  Alarms                   -  Alarms ^& Clock App
	echo.  [C]  BingWeather              -  Weather App
	echo.  [D]  Calculator               -  Calculator App
	echo.  [E]  Camera                   -  Camera App
	echo.  [F]  CommunicationsApps       -  Windows Calendar ^& Mail App
	echo.  [G]  DesktopAppInstaller      -  Desktop App Installer
	echo.  [H]  Extensions               -  HEIF, HEVC, MPEG2, VP9, Web, Webp Extensions
	echo.  [I]  FeedbackHub              -  Feedback Hub App
	echo.  [J]  GetHelp                  -  Get Help App
	echo.  [K]  Getstarted               -  Tips App
	echo.  [L]  Maps                     -  Maps App
	echo.  [M]  Messaging                -  Messaging App
	echo.  [N]  MixedRealityPortal       -  Mixed Reality Portal App
	echo.  [O]  OfficeHub                -  My Office App
	echo.  [P]  OfficeOneNote            -  OneNote App
	echo.  [Q]  OneConnect               -  Mobile Plans App
	echo.  [R]  Paint3D                  -  Paint 3D App
	echo.  [S]  People                   -  People App
	echo.  [T]  Photos                   -  Photos App
	echo.  [U]  Print3D                  -  Print 3D App
	echo.  [V]  ScreenSketch             -  Screen Sketch App
	echo.  [W]  SkypeApp                 -  Skype App
	echo.  [X]  SolitaireCollection      -  Solitaire Collection App
	echo.  [Y]  SoundRecorder            -  Voice Recorder App
	echo.  [Z]  StickyNotes              -  Sticky Notes App
	echo.  [1]  Store                    -  Microsoft Store App
	echo.  [2]  WalletService            -  Wallet Service App
	echo.  [3]  XboxApp                  -  Microsoft Xbox App
	echo.  [4]  YourPhone                -  Your Phone App
	echo.  [5]  ZuneMusic                -  Groove Music App
	echo.  [6]  ZuneVideo                -  Films ^& TV App
	echo.
	echo.  [7]  All Windows Apps
	echo.  [8]  Go Back
	echo.
	echo.===============================================================================
	echo.
	choice /C:ABCDEFGHIJKLMNOPQRSTUVWXYZ12345678 /N /M "Enter Your Choice : "
	if errorlevel 34 goto :IntFeatures
	if errorlevel 33 set "MetroApp=AllApps"
	if errorlevel 32 set "MetroApp=ZuneVideo"
	if errorlevel 31 set "MetroApp=ZuneMusic"
	if errorlevel 30 set "MetroApp=YourPhone"
	if errorlevel 29 set "MetroApp=XboxApp"
	if errorlevel 28 set "MetroApp=WalletService"
	if errorlevel 27 set "MetroApp=Store"
	if errorlevel 26 set "MetroApp=StickyNotes"
	if errorlevel 25 set "MetroApp=SoundRecorder"
	if errorlevel 24 set "MetroApp=SolitaireCollection"
	if errorlevel 23 set "MetroApp=SkypeApp"
	if errorlevel 22 set "MetroApp=ScreenSketch"
	if errorlevel 21 set "MetroApp=Print3D"
	if errorlevel 20 set "MetroApp=Photos"
	if errorlevel 19 set "MetroApp=People"
	if errorlevel 18 set "MetroApp=Paint3D"
	if errorlevel 17 set "MetroApp=OneConnect"
	if errorlevel 16 set "MetroApp=OfficeOneNote"
	if errorlevel 15 set "MetroApp=OfficeHub"
	if errorlevel 14 set "MetroApp=MixedRealityPortal"
	if errorlevel 13 set "MetroApp=Messaging"
	if errorlevel 12 set "MetroApp=Maps"
	if errorlevel 11 set "MetroApp=Getstarted"
	if errorlevel 10 set "MetroApp=GetHelp"
	if errorlevel 9  set "MetroApp=FeedbackHub"
	if errorlevel 8  set "MetroApp=Extensions"
	if errorlevel 7  set "MetroApp=DesktopAppInstaller"
	if errorlevel 6  set "MetroApp=CommunicationsApps"
	if errorlevel 5  set "MetroApp=Camera"
	if errorlevel 4  set "MetroApp=Calculator"
	if errorlevel 3  set "MetroApp=BingWeather"
	if errorlevel 2  set "MetroApp=Alarms"
	if errorlevel 1  set "MetroApp=ThreeDViewer"
)

:: Getting Install Image Index Architecture
if "%ImageIndexNo%" equ "*" call :GetImageArchitecture "%InstallWim%", 1 >nul
if "%ImageIndexNo%" neq "*" call :GetImageArchitecture "%InstallWim%", %ImageIndexNo% >nul

:: Setting Default Metro Apps Pack Path
if "%SelectedSourceOS%" equ "w81" set "Apps=%Apps%\%SelectedSourceOS%"
if "%SelectedSourceOS%" equ "w10" set "Apps=%Apps%\%SelectedSourceOS%\10.0.%ImageBuild%"

:: Checking whether Microsoft Default Metro Apps folder is empty
if not exist "%Apps%\*.appxbundle" (
	echo.Microsoft Default Metro Apps Appxbundle files are missing...
	echo.
	if "%SelectedSourceOS%" equ "w81" echo.Please copy the missing files to ^<Packs\Apps\%SelectedSourceOS%^> folder...
	if "%SelectedSourceOS%" equ "w10" echo.Please copy the missing files to ^<Packs\Apps\%SelectedSourceOS%\10.0.%ImageBuild%^> folder...
	echo.
	goto :Stop
)

if not exist "%Apps%\*.appx" (
	echo.Microsoft Default Metro Apps Appx files are missing...
	echo.
	if "%SelectedSourceOS%" equ "w81" echo.Please copy the missing files to ^<Packs\Apps\%SelectedSourceOS%^> folder...
	if "%SelectedSourceOS%" equ "w10" echo.Please copy the missing files to ^<Packs\Apps\%SelectedSourceOS%\10.0.%ImageBuild%^> folder...
	echo.
	goto :Stop
)

if not exist "%Apps%\*.xml" (
	echo.Microsoft Default Metro Apps License XML files are missing...
	echo.
	if "%SelectedSourceOS%" equ "w81" echo.Please copy the missing files to ^<Packs\Apps\%SelectedSourceOS%^> folder...
	if "%SelectedSourceOS%" equ "w10" echo.Please copy the missing files to ^<Packs\Apps\%SelectedSourceOS%\10.0.%ImageBuild%^> folder...
	echo.
	goto :Stop
)

:: Getting Microsoft Default Metro Apps files full pathnames
cd /d "%Apps%\"

for /f %%i IN ('"dir /b Microsoft.Advertising.Xaml*_arm__8wekyb3d8bbwe.Appx" 2^>nul') do set "AdvertisingXaml_arm_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.Advertising.Xaml*_arm64__8wekyb3d8bbwe.Appx" 2^>nul') do set "AdvertisingXaml_arm64_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.Advertising.Xaml*_x86__8wekyb3d8bbwe.Appx" 2^>nul') do set "AdvertisingXaml_x86_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.Advertising.Xaml*_x64__8wekyb3d8bbwe.Appx" 2^>nul') do set "AdvertisingXaml_x64_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b *PlayReadyClient*arm.appx" 2^>nul') do set "MediaPlayReadyClient22_arm_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b *PlayReadyClient*x86.appx" 2^>nul') do set "MediaPlayReadyClient22_x86_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b *PlayReadyClient*x64.appx" 2^>nul') do set "MediaPlayReadyClient22_x64_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.NET.Native.Framework.1.3*_arm__8wekyb3d8bbwe.Appx" 2^>nul') do set "NETNativeFramework13_arm_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.NET.Native.Framework.1.3*_x86__8wekyb3d8bbwe.Appx" 2^>nul') do set "NETNativeFramework13_x86_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.NET.Native.Framework.1.3*_x64__8wekyb3d8bbwe.Appx" 2^>nul') do set "NETNativeFramework13_x64_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.NET.Native.Framework.1.6*_arm__8wekyb3d8bbwe.Appx" 2^>nul') do set "NETNativeFramework16_arm_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.NET.Native.Framework.1.6*_x86__8wekyb3d8bbwe.Appx" 2^>nul') do set "NETNativeFramework16_x86_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.NET.Native.Framework.1.6*_x64__8wekyb3d8bbwe.Appx" 2^>nul') do set "NETNativeFramework16_x64_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.NET.Native.Framework.1.7*_arm__8wekyb3d8bbwe.Appx" 2^>nul') do set "NETNativeFramework17_arm_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.NET.Native.Framework.1.7*_x86__8wekyb3d8bbwe.Appx" 2^>nul') do set "NETNativeFramework17_x86_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.NET.Native.Framework.1.7*_x64__8wekyb3d8bbwe.Appx" 2^>nul') do set "NETNativeFramework17_x64_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.NET.Native.Framework.2.1*_arm__8wekyb3d8bbwe.Appx" 2^>nul') do set "NETNativeFramework21_arm64_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.NET.Native.Framework.2.1*_x86__8wekyb3d8bbwe.Appx" 2^>nul') do set "NETNativeFramework21_x86_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.NET.Native.Framework.2.1*_x64__8wekyb3d8bbwe.Appx" 2^>nul') do set "NETNativeFramework21_x64_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.NET.Native.Framework.2.2*_arm__8wekyb3d8bbwe.Appx" 2^>nul') do set "NETNativeFramework22_arm_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.NET.Native.Framework.2.2*_arm64__8wekyb3d8bbwe.Appx" 2^>nul') do set "NETNativeFramework22_arm64_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.NET.Native.Framework.2.2*_x86__8wekyb3d8bbwe.Appx" 2^>nul') do set "NETNativeFramework22_x86_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.NET.Native.Framework.2.2*_x64__8wekyb3d8bbwe.Appx" 2^>nul') do set "NETNativeFramework22_x64_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.NET.Native.Runtime.1.3*_arm__8wekyb3d8bbwe.Appx" 2^>nul') do set "NETNativeRuntime13_arm_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.NET.Native.Runtime.1.3*_x86__8wekyb3d8bbwe.Appx" 2^>nul') do set "NETNativeRuntime13_x86_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.NET.Native.Runtime.1.3*_x64__8wekyb3d8bbwe.Appx" 2^>nul') do set "NETNativeRuntime13_x64_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.NET.Native.Runtime.1.4*_arm__8wekyb3d8bbwe.Appx" 2^>nul') do set "NETNativeRuntime14_arm_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.NET.Native.Runtime.1.4*_x86__8wekyb3d8bbwe.Appx" 2^>nul') do set "NETNativeRuntime14_x86_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.NET.Native.Runtime.1.4*_x64__8wekyb3d8bbwe.Appx" 2^>nul') do set "NETNativeRuntime14_x64_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.NET.Native.Runtime.1.6*_arm__8wekyb3d8bbwe.Appx" 2^>nul') do set "NETNativeRuntime16_arm_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.NET.Native.Runtime.1.6*_x86__8wekyb3d8bbwe.Appx" 2^>nul') do set "NETNativeRuntime16_x86_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.NET.Native.Runtime.1.6*_x64__8wekyb3d8bbwe.Appx" 2^>nul') do set "NETNativeRuntime16_x64_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.NET.Native.Runtime.1.7*_arm__8wekyb3d8bbwe.Appx" 2^>nul') do set "NETNativeRuntime17_arm_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.NET.Native.Runtime.1.7*_x86__8wekyb3d8bbwe.Appx" 2^>nul') do set "NETNativeRuntime17_x86_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.NET.Native.Runtime.1.7*_x64__8wekyb3d8bbwe.Appx" 2^>nul') do set "NETNativeRuntime17_x64_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.NET.Native.Runtime.2.1*_arm__8wekyb3d8bbwe.Appx" 2^>nul') do set "NETNativeRuntime21_arm_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.NET.Native.Runtime.2.1*_arm64__8wekyb3d8bbwe.Appx" 2^>nul') do set "NETNativeRuntime21_arm64_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.NET.Native.Runtime.2.1*_x86__8wekyb3d8bbwe.Appx" 2^>nul') do set "NETNativeRuntime21_x86_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.NET.Native.Runtime.2.1*_x64__8wekyb3d8bbwe.Appx" 2^>nul') do set "NETNativeRuntime21_x64_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.NET.Native.Runtime.2.2*_arm__8wekyb3d8bbwe.Appx" 2^>nul') do set "NETNativeRuntime22_arm_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.NET.Native.Runtime.2.2*_arm64__8wekyb3d8bbwe.Appx" 2^>nul') do set "NETNativeRuntime22_arm64_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.NET.Native.Runtime.2.2*_x86__8wekyb3d8bbwe.Appx" 2^>nul') do set "NETNativeRuntime22_x86_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.NET.Native.Runtime.2.2*_x64__8wekyb3d8bbwe.Appx" 2^>nul') do set "NETNativeRuntime22_x64_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.Services.Store.Engagement*_arm__8wekyb3d8bbwe.Appx" 2^>nul') do set "ServicesStoreEngagement_arm_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.Services.Store.Engagement*_arm64__8wekyb3d8bbwe.Appx" 2^>nul') do set "ServicesStoreEngagement_arm64_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.Services.Store.Engagement*_x86__8wekyb3d8bbwe.Appx" 2^>nul') do set "ServicesStoreEngagement_x86_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.Services.Store.Engagement*_x64__8wekyb3d8bbwe.Appx" 2^>nul') do set "ServicesStoreEngagement_x64_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.UI.Xaml.2.0*_arm__8wekyb3d8bbwe.Appx" 2^>nul') do set "UIXaml20_arm_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.UI.Xaml.2.0*_arm64__8wekyb3d8bbwe.Appx" 2^>nul') do set "UIXaml20_arm64_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.UI.Xaml.2.0*_x86__8wekyb3d8bbwe.Appx" 2^>nul') do set "UIXaml20_x86_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.UI.Xaml.2.0*_x64__8wekyb3d8bbwe.Appx" 2^>nul') do set "UIXaml20_x64_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.UI.Xaml.2.1*_arm__8wekyb3d8bbwe.Appx" 2^>nul') do set "UIXaml21_arm_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.UI.Xaml.2.1*_arm64__8wekyb3d8bbwe.Appx" 2^>nul') do set "UIXaml21_arm64_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.UI.Xaml.2.1*_x86__8wekyb3d8bbwe.Appx" 2^>nul') do set "UIXaml21_x86_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.UI.Xaml.2.1*_x64__8wekyb3d8bbwe.Appx" 2^>nul') do set "UIXaml21_x64_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.VCLibs.120.00*_arm__8wekyb3d8bbwe.Appx" 2^>nul') do set "VCLibs12_arm_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.VCLibs.120.00*_x86__8wekyb3d8bbwe.Appx" 2^>nul') do set "VCLibs12_x86_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.VCLibs.120.00*_x64__8wekyb3d8bbwe.Appx" 2^>nul') do set "VCLibs12_x64_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.VCLibs.140.00*_arm__8wekyb3d8bbwe.Appx" 2^>nul') do set "VCLibs14_arm_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.VCLibs.140.00*_arm64__8wekyb3d8bbwe.Appx" 2^>nul') do set "VCLibs14_arm64_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.VCLibs.140.00*_x86__8wekyb3d8bbwe.Appx" 2^>nul') do set "VCLibs14_x86_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.VCLibs.140.00*_x64__8wekyb3d8bbwe.Appx" 2^>nul') do set "VCLibs14_x64_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.VCLibs.140.00.UWPDesktop*_arm__8wekyb3d8bbwe.Appx" 2^>nul') do set "VCLibsUWPDesktop14_arm_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.VCLibs.140.00.UWPDesktop*_arm64__8wekyb3d8bbwe.Appx" 2^>nul') do set "VCLibsUWPDesktop14_arm64_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.VCLibs.140.00.UWPDesktop*_x86__8wekyb3d8bbwe.Appx" 2^>nul') do set "VCLibsUWPDesktop14_x86_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.VCLibs.140.00.UWPDesktop*_x64__8wekyb3d8bbwe.Appx" 2^>nul') do set "VCLibsUWPDesktop14_x64_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.WinJS*.appx" 2^>nul') do set "WinJS20_Appx=/DependencyPackagePath:%Apps%\%%i"

set AdvertisingXaml=
set DependencyPackages=
set NETNativeFramework13=
set NETNativeFramework16=
set NETNativeFramework17=
set NETNativeFramework21=
set NETNativeFramework22=
set NETNativeRuntime13=
set NETNativeRuntime14=
set NETNativeRuntime16=
set NETNativeRuntime17=
set NETNativeRuntime21=
set NETNativeRuntime22=
set ServicesStoreEngagement=
set UIXaml20=
set UIXaml21=
set VCLibs14=
set VCLibsUWPDesktop14=

if "%ImageArchitecture%" equ "x86" (
	set "AdvertisingXaml=%AdvertisingXaml_x86_Appx%
	set "NETNativeFramework13=%NETNativeFramework13_x86_Appx%
	set "NETNativeFramework16=%NETNativeFramework16_x86_Appx%
	set "NETNativeFramework17=%NETNativeFramework17_x86_Appx%
	set "NETNativeFramework21=%NETNativeFramework21_x86_Appx%
	set "NETNativeFramework22=%NETNativeFramework22_x86_Appx%
	set "NETNativeRuntime13=%NETNativeRuntime13_x86_Appx%
	set "NETNativeRuntime14=%NETNativeRuntime14_x86_Appx%
	set "NETNativeRuntime16=%NETNativeRuntime16_x86_Appx%
	set "NETNativeRuntime17=%NETNativeRuntime17_x86_Appx%
	set "NETNativeRuntime21=%NETNativeRuntime21_x86_Appx%
	set "NETNativeRuntime22=%NETNativeRuntime22_x86_Appx%
	set "ServicesStoreEngagement=%ServicesStoreEngagement_x86_Appx%
	set "UIXaml20=%UIXaml20_x86_Appx%
	set "UIXaml21=%UIXaml21_x86_Appx%
	set "VCLibs14=%VCLibs14_x86_Appx%
	set "VCLibsUWPDesktop14=%VCLibsUWPDesktop14_x86_Appx%
)

if "%ImageArchitecture%" equ "x64" (
	set "AdvertisingXaml=%AdvertisingXaml_x86_Appx% %AdvertisingXaml_x64_Appx%
	set "NETNativeFramework13=%NETNativeFramework13_x86_Appx% %NETNativeFramework13_x64_Appx%
	set "NETNativeFramework16=%NETNativeFramework16_x86_Appx% %NETNativeFramework16_x64_Appx%
	set "NETNativeFramework17=%NETNativeFramework17_x86_Appx% %NETNativeFramework17_x64_Appx%
	set "NETNativeFramework21=%NETNativeFramework21_x86_Appx% %NETNativeFramework21_x64_Appx%
	set "NETNativeFramework22=%NETNativeFramework22_x86_Appx% %NETNativeFramework22_x64_Appx%
	set "NETNativeRuntime13=%NETNativeRuntime13_x86_Appx% %NETNativeRuntime13_x64_Appx%
	set "NETNativeRuntime14=%NETNativeRuntime14_x86_Appx% %NETNativeRuntime14_x64_Appx%
	set "NETNativeRuntime16=%NETNativeRuntime16_x86_Appx% %NETNativeRuntime16_x64_Appx%
	set "NETNativeRuntime17=%NETNativeRuntime17_x86_Appx% %NETNativeRuntime17_x64_Appx%
	set "NETNativeRuntime21=%NETNativeRuntime21_x86_Appx% %NETNativeRuntime21_x64_Appx%
	set "NETNativeRuntime22=%NETNativeRuntime22_x86_Appx% %NETNativeRuntime22_x64_Appx%
	set "ServicesStoreEngagement=%ServicesStoreEngagement_x86_Appx% %ServicesStoreEngagement_x64_Appx%
	set "UIXaml20=%UIXaml20_x86_Appx% %UIXaml20_x64_Appx%
	set "UIXaml21=%UIXaml21_x86_Appx% %UIXaml21_x64_Appx%
	set "VCLibs14=%VCLibs14_x86_Appx% %VCLibs14_x64_Appx%
	set "VCLibsUWPDesktop14=%VCLibsUWPDesktop14_x86_Appx% %VCLibsUWPDesktop14_x64_Appx%
)

if "%ImageArchitecture%" equ "arm64" (
	set "AdvertisingXaml=%AdvertisingXaml_arm_Appx% %AdvertisingXaml_arm64_Appx%
	set "NETNativeFramework13=%NETNativeFramework13_arm_Appx% %NETNativeFramework13_arm64_Appx%
	set "NETNativeFramework16=%NETNativeFramework16_arm_Appx% %NETNativeFramework16_arm64_Appx%
	set "NETNativeFramework17=%NETNativeFramework17_arm_Appx% %NETNativeFramework17_arm64_Appx%
	set "NETNativeFramework21=%NETNativeFramework21_arm_Appx% %NETNativeFramework21_arm64_Appx%
	set "NETNativeFramework22=%NETNativeFramework22_arm_Appx% %NETNativeFramework22_arm64_Appx%
	set "NETNativeRuntime13=%NETNativeRuntime13_arm_Appx% %NETNativeRuntime13_arm64_Appx%
	set "NETNativeRuntime14=%NETNativeRuntime14_arm_Appx% %NETNativeRuntime14_arm64_Appx%
	set "NETNativeRuntime16=%NETNativeRuntime16_arm_Appx% %NETNativeRuntime16_arm64_Appx%
	set "NETNativeRuntime17=%NETNativeRuntime17_arm_Appx% %NETNativeRuntime17_arm64_Appx%
	set "NETNativeRuntime21=%NETNativeRuntime21_arm_Appx% %NETNativeRuntime21_arm64_Appx%
	set "NETNativeRuntime22=%NETNativeRuntime22_arm_Appx% %NETNativeRuntime22_arm64_Appx%
	set "ServicesStoreEngagement=%ServicesStoreEngagement_arm_Appx% %ServicesStoreEngagement_arm64_Appx%
	set "UIXaml20=%UIXaml20_arm_Appx% %UIXaml20_arm64_Appx%
	set "UIXaml21=%UIXaml21_arm_Appx% %UIXaml21_arm64_Appx%
	set "VCLibs14=%VCLibs14_x86_Appx% %VCLibs14_arm_Appx% %VCLibs14_arm64_Appx%
	set "VCLibsUWPDesktop14=%VCLibsUWPDesktop14_x86_Appx% %VCLibsUWPDesktop14_arm_Appx% %VCLibsUWPDesktop14_arm64_Appx%
)

if "%SelectedSourceOS%" equ "w81" set "DependencyPackages=%VCLibs12_x86_Appx% %VCLibs12_x64_Appx% %VCLibs12_arm_Appx% %WinJS20Appx% %MediaPlayReadyClient22_x86_Appx% %MediaPlayReadyClient22_x64_Appx% %MediaPlayReadyClient22_arm_Appx%"

if "%SelectedSourceOS%" equ "w10" (
	if "%ImageBuild%" equ "16299" set "DependencyPackages=%AdvertisingXaml% %NETNativeFramework13% %NETNativeFramework16% %NETNativeFramework17% %NETNativeFramework21% %NETNativeFramework22% %NETNativeRuntime13% %NETNativeRuntime14% %NETNativeRuntime16% %NETNativeRuntime17% %NETNativeRuntime21% %NETNativeRuntime22% %ServicesStoreEngagement% %UIXaml20% %UIXaml21% %VCLibs14% %VCLibsUWPDesktop14%"
	if "%ImageBuild%" equ "17134" set "DependencyPackages=%AdvertisingXaml% %NETNativeFramework13% %NETNativeFramework16% %NETNativeFramework17% %NETNativeFramework21% %NETNativeFramework22% %NETNativeRuntime13% %NETNativeRuntime14% %NETNativeRuntime16% %NETNativeRuntime17% %NETNativeRuntime21% %NETNativeRuntime22% %ServicesStoreEngagement% %UIXaml20% %UIXaml21% %VCLibs14% %VCLibsUWPDesktop14%"
	if "%ImageBuild%" equ "17763" set "DependencyPackages=%AdvertisingXaml% %NETNativeFramework16% %NETNativeFramework17% %NETNativeFramework21% %NETNativeFramework22% %NETNativeRuntime16% %NETNativeRuntime17% %NETNativeRuntime21% %NETNativeRuntime22% %ServicesStoreEngagement% %UIXaml20% %UIXaml21% %VCLibs14% %VCLibsUWPDesktop14%"
	if "%ImageBuild%" equ "18362" set "DependencyPackages=%AdvertisingXaml% %NETNativeFramework17% %NETNativeFramework22% %NETNativeRuntime17% %NETNativeRuntime22% %ServicesStoreEngagement% %UIXaml21% %VCLibs14% %VCLibsUWPDesktop14%"
)

for /f %%i IN ('"dir /b *Alarms*.appxbundle" 2^>nul') do if exist %%i set "Alarms_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *AppConnector*.appxbundle" 2^>nul') do if exist %%i set "AppConnector_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *BingFinance*.appxbundle" 2^>nul') do if exist %%i set "BingFinance_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *BingFoodAndDrink*.appxbundle" 2^>nul') do if exist %%i set "BingFoodDrink_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *BingHealthAndFitness*.appxbundle" 2^>nul') do if exist %%i set "BingHealthFitness_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *BingMaps*.appxbundle" 2^>nul') do if exist %%i set "BingMaps_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *BingNews*.appxbundle" 2^>nul') do if exist %%i set "BingNews_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *BingSports*.appxbundle" 2^>nul') do if exist %%i set "BingSports_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *BingTravel*.appxbundle" 2^>nul') do if exist %%i set "BingTravel_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *BingWeather*.appxbundle" 2^>nul') do if exist %%i set "BingWeather_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *Calculator*.appxbundle" 2^>nul') do if exist %%i set "Calculator_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *Camera*.appxbundle" 2^>nul') do if exist %%i set "Camera_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *CommunicationsApps*.appxbundle" 2^>nul') do if exist %%i set "CommunicationsApps_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *DesktopAppInstaller*.appxbundle" 2^>nul') do if exist %%i set "DesktopAppInstaller_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *FeedbackHub*.appxbundle" 2^>nul') do if exist %%i set "FeedbackHub_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *GetHelp*.appxbundle" 2^>nul') do if exist %%i set "GetHelp_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *Getstarted*.appxbundle" 2^>nul') do if exist %%i set "Getstarted_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *HEIFImageExtension*arm*.appx" 2^>nul') do if exist %%i set "HEIFImageExtension_arm_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *HEIFImageExtension*x86*.appx" 2^>nul') do if exist %%i set "HEIFImageExtension_x86_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *HEIFImageExtension*x64*.appx" 2^>nul') do if exist %%i set "HEIFImageExtension_x64_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *HEVCVideoExtension*arm*.appx" 2^>nul') do if exist %%i set "HEVCVideoExtension_arm_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *HEVCVideoExtension*x86*.appx" 2^>nul') do if exist %%i set "HEVCVideoExtension_x86_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *HEVCVideoExtension*x64*.appx" 2^>nul') do if exist %%i set "HEVCVideoExtension_x64_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *HelpAndTips*.appxbundle" 2^>nul') do if exist %%i set "HelpAndTips_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *Maps*.appxbundle" 2^>nul') do if exist %%i set "Maps_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *Messaging*.appxbundle" 2^>nul') do if exist %%i set "Messaging_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *MixedReality.Portal*.appxbundle" 2^>nul') do if exist %%i set "MixedRealityPortal_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *MPEG2VideoExtension*arm*.appx" 2^>nul') do if exist %%i set "MPEG2VideoExtension_arm_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *MPEG2VideoExtension*x86*.appx" 2^>nul') do if exist %%i set "MPEG2VideoExtension_x86_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *MPEG2VideoExtension*x64*.appx" 2^>nul') do if exist %%i set "MPEG2VideoExtension_x64_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *OfficeHub*.appxbundle" 2^>nul') do if exist %%i set "OfficeHub_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *OneNote*.appxbundle" 2^>nul') do if exist %%i set "OfficeOneNote_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *Sway*.appxbundle" 2^>nul') do if exist %%i set "OfficeSway_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *OneConnect*.appxbundle" 2^>nul') do if exist %%i set "OneConnect_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *Paint*.appxbundle" 2^>nul') do if exist %%i set "Paint3D_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *People*.appxbundle" 2^>nul') do if exist %%i set "People_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *CommsPhone*.appxbundle" 2^>nul') do if exist %%i set "Phone_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *WindowsPhone*.appxbundle" 2^>nul') do if exist %%i set "PhoneCompanion_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *Photos*.appxbundle" 2^>nul') do if exist %%i set "Photos_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *Print3D*.appxbundle" 2^>nul') do if exist %%i set "Print3D_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *Reader*.appxbundle" 2^>nul') do if exist %%i set "Reader_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *ReadingList*.appxbundle" 2^>nul') do if exist %%i set "ReadingList_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *Scan*.appxbundle" 2^>nul') do if exist %%i set "Scan_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *ScreenSketch*.appxbundle" 2^>nul') do if exist %%i set "ScreenSketch_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *Skype*.appxbundle" 2^>nul') do if exist %%i set "SkypeApp_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *SolitaireCollection*.appxbundle" 2^>nul') do if exist %%i set "SolitaireCollection_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *SoundRecorder*.appxbundle" 2^>nul') do if exist %%i set "SoundRecorder_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *StickyNotes*.appxbundle" 2^>nul') do if exist %%i set "StickyNotes_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *Store*.appxbundle" 2^>nul') do if exist %%i set "Store_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *StorePurchaseApp*.appxbundle" 2^>nul') do if exist %%i set "StorePurchaseApp_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *3DBuilder*.appxbundle" 2^>nul') do if exist %%i set "ThreeDBuilder_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *3DView*.appxbundle" 2^>nul') do if exist %%i set "ThreeDViewer_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *VP9VideoExtensions*arm*.appx" 2^>nul') do if exist %%i set "VP9VideoExtensions_arm_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *VP9VideoExtensions*x86*.appx" 2^>nul') do if exist %%i set "VP9VideoExtensions_x86_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *VP9VideoExtensions*x64*.appx" 2^>nul') do if exist %%i set "VP9VideoExtensions_x64_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *Wallet*.appxbundle" 2^>nul') do if exist %%i set "Wallet_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *WebMediaExtensions*.appxbundle" 2^>nul') do if exist %%i set "WebMediaExtensions_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *WebpImageExtension*arm*.appx" 2^>nul') do if exist %%i set "WebpImageExtension_arm_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *WebpImageExtension*x86*.appx" 2^>nul') do if exist %%i set "WebpImageExtension_x86_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *WebpImageExtension*x64*.appx" 2^>nul') do if exist %%i set "WebpImageExtension_x64_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *ConnectivityStore*.appxbundle" 2^>nul') do if exist %%i set "WiFi_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *XboxApp*.appxbundle" 2^>nul') do if exist %%i set "XboxApp_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *XboxGameOverlay*.appxbundle" 2^>nul') do if exist %%i set "XboxGameOverlay_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *XboxGamingOverlay*.appxbundle" 2^>nul') do if exist %%i set "XboxGamingOverlay_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *XboxIdentityProvider*.appxbundle" 2^>nul') do if exist %%i set "XboxIdentityProvider_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *XboxLIVEGames*.appxbundle" 2^>nul') do if exist %%i set "XboxLiveGames_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *XboxSpeechToTextOverlay*.appxbundle" 2^>nul') do if exist %%i set "XboxSpeechToTextOverlay_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *Xbox.TCUI*.appxbundle" 2^>nul') do if exist %%i set "XboxTCUI_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *Microsoft.YourPhone*.appxbundle" 2^>nul') do if exist %%i set "YourPhone_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *ZuneMusic*.appxbundle" 2^>nul') do if exist %%i set "ZuneMusic_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *ZuneVideo*.appxbundle" 2^>nul') do if exist %%i set "ZuneVideo_Appx=%Apps%\%%i"

for /f %%i IN ('"dir /b *Alarms*.xml" 2^>nul') do if exist %%i set "Alarms_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *AppConnector*.xml" 2^>nul') do if exist %%i set "AppConnector_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *BingFinance*.xml" 2^>nul') do if exist %%i set "BingFinance_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *BingFoodAndDrink*.xml" 2^>nul') do if exist %%i set "BingFoodDrink_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *BingHealthAndFitness*.xml" 2^>nul') do if exist %%i set "BingHealthFitness_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *BingMaps*.xml" 2^>nul') do if exist %%i set "BingMaps_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *BingNews*.xml" 2^>nul') do if exist %%i set "BingNews_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *BingSports*.xml" 2^>nul') do if exist %%i set "BingSports_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *BingTravel*.xml" 2^>nul') do if exist %%i set "BingTravel_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *BingWeather*.xml" 2^>nul') do if exist %%i set "BingWeather_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *Calculator*.xml" 2^>nul') do if exist %%i set "Calculator_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *Camera*.xml" 2^>nul') do if exist %%i set "Camera_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *CommunicationsApps*.xml" 2^>nul') do if exist %%i set "CommunicationsApps_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *DesktopAppInstaller*.xml" 2^>nul') do if exist %%i set "DesktopAppInstaller_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *FeedbackHub*.xml" 2^>nul') do if exist %%i set "FeedbackHub_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *GetHelp*.xml" 2^>nul') do if exist %%i set "GetHelp_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *Getstarted*.xml" 2^>nul') do if exist %%i set "Getstarted_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *HEIFImageExtension*arm*.xml" 2^>nul') do if exist %%i set "HEIFImageExtension_arm_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *HEIFImageExtension*x86*.xml" 2^>nul') do if exist %%i set "HEIFImageExtension_x86_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *HEIFImageExtension*x64*.xml" 2^>nul') do if exist %%i set "HEIFImageExtension_x64_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *HEVCVideoExtension*arm*.xml" 2^>nul') do if exist %%i set "HEVCVideoExtension_arm_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *HEVCVideoExtension*x86*.xml" 2^>nul') do if exist %%i set "HEVCVideoExtension_x86_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *HEVCVideoExtension*x64*.xml" 2^>nul') do if exist %%i set "HEVCVideoExtension_x64_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *HelpAndTips*.xml" 2^>nul') do if exist %%i set "HelpAndTips_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *Maps*.xml" 2^>nul') do if exist %%i set "Maps_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *Messaging*.xml" 2^>nul') do if exist %%i set "Messaging_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *MixedReality.Portal*.xml" 2^>nul') do if exist %%i set "MixedRealityPortal_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *MPEG2VideoExtension*arm*.xml" 2^>nul') do if exist %%i set "MPEG2VideoExtension_arm_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *MPEG2VideoExtension*x86*.xml" 2^>nul') do if exist %%i set "MPEG2VideoExtension_x86_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *MPEG2VideoExtension*x64*.xml" 2^>nul') do if exist %%i set "MPEG2VideoExtension_x64_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *OfficeHub*.xml" 2^>nul') do if exist %%i set "OfficeHub_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *OneNote*.xml" 2^>nul') do if exist %%i set "OfficeOneNote_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *Sway*.xml" 2^>nul') do if exist %%i set "OfficeSway_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *OneConnect*.xml" 2^>nul') do if exist %%i set "OneConnect_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *Paint*.xml" 2^>nul') do if exist %%i set "Paint3D_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *People*.xml" 2^>nul') do if exist %%i set "People_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *CommsPhone*.xml" 2^>nul') do if exist %%i set "Phone_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *WindowsPhone*.xml" 2^>nul') do if exist %%i set "PhoneCompanion_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *Photos*.xml" 2^>nul') do if exist %%i set "Photos_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *Print3D*.xml" 2^>nul') do if exist %%i set "Print3D_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *Reader*.xml" 2^>nul') do if exist %%i set "Reader_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *ReadingList*.xml" 2^>nul') do if exist %%i set "ReadingList_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *Scan*.xml" 2^>nul') do if exist %%i set "Scan_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *ScreenSketch*.xml" 2^>nul') do if exist %%i set "ScreenSketch_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *Skype*.xml" 2^>nul') do if exist %%i set "SkypeApp_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *SolitaireCollection*.xml" 2^>nul') do if exist %%i set "SolitaireCollection_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *SoundRecorder*.xml" 2^>nul') do if exist %%i set "SoundRecorder_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *StickyNotes*.xml" 2^>nul') do if exist %%i set "StickyNotes_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *Store*.xml" 2^>nul') do if exist %%i set "Store_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *StorePurchaseApp*.xml" 2^>nul') do if exist %%i set "StorePurchaseApp_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *3DBuilder*.xml" 2^>nul') do if exist %%i set "ThreeDBuilder_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *3DView*.xml" 2^>nul') do if exist %%i set "ThreeDViewer_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *VP9VideoExtensions*arm*.xml" 2^>nul') do if exist %%i set "VP9VideoExtensions_arm_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *VP9VideoExtensions*x86*.xml" 2^>nul') do if exist %%i set "VP9VideoExtensions_x86_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *VP9VideoExtensions*x64*.xml" 2^>nul') do if exist %%i set "VP9VideoExtensions_x64_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *Wallet*.xml" 2^>nul') do if exist %%i set "Wallet_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *WebMediaExtensions*.xml" 2^>nul') do if exist %%i set "WebMediaExtensions_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *WebpImageExtension*arm*.xml" 2^>nul') do if exist %%i set "WebpImageExtension_arm_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *WebpImageExtension*x86*.xml" 2^>nul') do if exist %%i set "WebpImageExtension_x86_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *WebpImageExtension*x64*.xml" 2^>nul') do if exist %%i set "WebpImageExtension_x64_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *ConnectivityStore*.xml" 2^>nul') do if exist %%i set "WiFi_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *XboxApp*.xml" 2^>nul') do if exist %%i set "XboxApp_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *XboxGameOverlay*.xml" 2^>nul') do if exist %%i set "XboxGameOverlay_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *XboxGamingOverlay*.xml" 2^>nul') do if exist %%i set "XboxGamingOverlay_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *XboxIdentityProvider*.xml" 2^>nul') do if exist %%i set "XboxIdentityProvider_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *XboxLIVEGames*.xml" 2^>nul') do if exist %%i set "XboxLiveGames_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *XboxSpeechToTextOverlay*.xml" 2^>nul') do if exist %%i set "XboxSpeechToTextOverlay_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *Xbox.TCUI*.xml" 2^>nul') do if exist %%i set "XboxTCUI_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *Microsoft.YourPhone*.xml" 2^>nul') do if exist %%i set "YourPhone_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *ZuneMusic*.xml" 2^>nul') do if exist %%i set "ZuneMusic_License=%Apps%\%%i"
for /f %%i IN ('"dir /b *ZuneVideo*.xml" 2^>nul') do if exist %%i set "ZuneVideo_License=%Apps%\%%i"

cd /d "%ROOT%\"

cls
echo.===============================================================================
echo. 	      MSMG ToolKit - Integrate Microsoft Default Metro Apps
echo.===============================================================================
echo.
echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Microsoft Default Metro Apps##########################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if "%ImageIndexNo%" equ "*" echo.    Image Indexes            : 1-%ImageCount%
if "%ImageIndexNo%" neq "*" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
if "%ImageIndexNo%" neq "*" echo.    Image Edition            : %ImageEdition%
echo.    Image Default Language   : %ImageDefaultLanguage%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Microsoft Default Metro Apps###################################
echo.-------------------------------------------------------------------------------
echo.
if "%ImageIndexNo%" equ "*" (
	for /L %%i in (1, 1, %ImageCount%) do (
		if not %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]#############################
		if %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]############################
		echo.
	
		:: Integraing Windows 8.1 Default Metro Apps to Install Image File
		if "%SelectedSourceOS%" equ "w81" (	
			if "%MetroApp%" equ "Alarms" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Alarms", %Alarms_Appx%, %Alarms_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "Calculator" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Calculator", %Calculator_Appx%, %Calculator_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "CommunicationsApps" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Calender, Mail and People", %CommunicationsApps_Appx%, %CommunicationsApps_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "BingFinance" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Bing Finance", %BingFinance_Appx%, %BingFinance_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "BingFoodDrink" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Bing Food and Drink", %BingFoodDrink_Appx%, %BingFoodDrink_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "BingHealthFitness" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Bing Health and Fitness", %BingHealthFitness_Appx%, %BingHealthFitness_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "BingMaps" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Bing Maps", %BingMaps_Appx%, %BingMaps_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "BingNews" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Bing News", %BingNews_Appx%, %BingNews_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "BingSports" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Bing Sports", %BingSports_Appx%, %BingSports_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "BingTravel" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Bing Travel", %BingTravel_Appx%, %BingTravel_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "BingWeather" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Bing Weather", %BingWeather_Appx%, %BingWeather_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "HelpAndTips" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Help and Tips", %HelpAndTips_Appx%, %HelpAndTips_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "OfficeOneNote" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Office OneNote", %OfficeOneNote_Appx%, %OfficeOneNote_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "Reader" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Reader", %Reader_Appx%, %Reader_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "ReadingList" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Reading List", %ReadingList_Appx%, %ReadingList_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "Scan" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Scan", %Scan_Appx%, %Scan_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "SkypeApp" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Skype App", %SkypeApp_Appx%, %SkypeApp_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "SoundRecorder" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Sound Recorder", %SoundRecorder_Appx%, %SoundRecorder_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "XboxLiveGames" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Xbox Live Games", %XboxLiveGames_Appx%, %XboxLiveGames_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "ZuneMusic" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Zune Music", %ZuneMusic_Appx%, %ZuneMusic_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "ZuneVideo" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Zune Video", %ZuneVideo_Appx%, %ZuneVideo_License%, "%DependencyPackages%"
		)

		:: Integrating Windows 10 Default Metro Apps to Install Image
		if "%SelectedSourceOS%" equ "w10" (
			if "%MetroApp%" equ "Alarms" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Alarms and Clock", %Alarms_Appx%, %Alarms_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "AppConnector" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "App Connector", %AppConnector_Appx%, %AppConnector_License%, ""
			if "%MetroApp%" equ "BingFinance" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Bing Finance", %BingFinance_Appx%, %BingFinance_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "BingNews" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Bing News", %BingNews_Appx%, %BingNews_License%, %BingNews_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "BingSports" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Bing Sports", %BingSports_Appx%, %BingSports_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "BingWeather" if "%ImageBuild%" leq "10586" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Bing Weather", %BingWeather_Appx%, %BingWeather_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "BingWeather" if "%ImageBuild%" geq "14393" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Weather", %BingWeather_Appx%, %BingWeather_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "Calculator" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Calculator", %Calculator_Appx%, %Calculator_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "Camera" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Camera", %Camera_Appx%, %Camera_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "CommunicationsApps" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Calendar and Mail", %CommunicationsApps_Appx%, %CommunicationsApps_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "DesktopAppInstaller" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Desktop App Installer", %DesktopAppInstaller_Appx%, %DesktopAppInstaller_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "Extensions" (
				if "%ImageBuild%" geq "17763" if "%ImageArchitecture%" equ "x86" (
					call :AddProvisionedAppxPackage "%InstallMount%\%%i", "HEIF Image Extension", %HEIFImageExtension_x86_Appx%, %HEIFImageExtension_x86_License%, "%DependencyPackages%"
					call :AddProvisionedAppxPackage "%InstallMount%\%%i", "HEVC Video Extension", %HEVCVideoExtension_x86_Appx%, %HEVCVideoExtension_x86_License%, "%DependencyPackages%"
					call :AddProvisionedAppxPackage "%InstallMount%\%%i", "MPEG2 Video Extension", %MPEG2VideoExtension_x86_Appx%, %MPEG2VideoExtension_x86_License%, "%DependencyPackages%"
					call :AddProvisionedAppxPackage "%InstallMount%\%%i", "VP9 Video Extension", %VP9VideoExtensions_x86_Appx%, %VP9VideoExtensions_x86_License%, "%DependencyPackages%"
				)
				if "%ImageBuild%" geq "17763" if "%ImageArchitecture%" equ "x64" (
					call :AddProvisionedAppxPackage "%InstallMount%\%%i", "HEIF Image Extension x86", %HEIFImageExtension_x86_Appx%, %HEIFImageExtension_x86_License%, "%DependencyPackages%"
					call :AddProvisionedAppxPackage "%InstallMount%\%%i", "HEIF Image Extension x64", %HEIFImageExtension_x64_Appx%, %HEIFImageExtension_x64_License%, "%DependencyPackages%"
					call :AddProvisionedAppxPackage "%InstallMount%\%%i", "HEVC Video Extension x86", %HEVCVideoExtension_x86_Appx%, %HEVCVideoExtension_x86_License%, "%DependencyPackages%"
					call :AddProvisionedAppxPackage "%InstallMount%\%%i", "HEVC Video Extension x64", %HEVCVideoExtension_x64_Appx%, %HEVCVideoExtension_x64_License%, "%DependencyPackages%"
					call :AddProvisionedAppxPackage "%InstallMount%\%%i", "MPEG2 Video Extension x86", %MPEG2VideoExtension_x86_Appx%, %MPEG2VideoExtension_x86_License%, "%DependencyPackages%"
					call :AddProvisionedAppxPackage "%InstallMount%\%%i", "MPEG2 Video Extension x64", %MPEG2VideoExtension_x64_Appx%, %MPEG2VideoExtension_x64_License%, "%DependencyPackages%"
					call :AddProvisionedAppxPackage "%InstallMount%\%%i", "VP9 Video Extension x86", %VP9VideoExtensions_x86_Appx%, %VP9VideoExtensions_x86_License%, "%DependencyPackages%"
					call :AddProvisionedAppxPackage "%InstallMount%\%%i", "VP9 Video Extension x64", %VP9VideoExtensions_x64_Appx%, %VP9VideoExtensions_x64_License%, "%DependencyPackages%"
				)
				if "%ImageBuild%" geq "17763" if "%ImageArchitecture%" equ "arm64" (
					call :AddProvisionedAppxPackage "%InstallMount%\%%i", "HEIF Image Extension", %HEIFImageExtension_arm_Appx%, %HEIFImageExtension_arm_License%, "%DependencyPackages%"
					call :AddProvisionedAppxPackage "%InstallMount%\%%i", "HEVC Video Extension", %HEVCVideoExtension_arm_Appx%, %HEVCVideoExtension_arm_License%, "%DependencyPackages%"
					call :AddProvisionedAppxPackage "%InstallMount%\%%i", "MPEG2 Video Extension", %MPEG2VideoExtension_arm_Appx%, %MPEG2VideoExtension_arm_License%, "%DependencyPackages%"
					call :AddProvisionedAppxPackage "%InstallMount%\%%i", "VP9 Video Extension", %VP9VideoExtensions_arm_Appx%, %VP9VideoExtensions_arm_License%, "%DependencyPackages%"
				)
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Web Media Extension", %WebMediaExtensions_Appx%, %WebMediaExtensions_License%, "%DependencyPackages%"
				if "%ImageBuild%" geq "17763" if "%ImageArchitecture%" equ "x86" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Webp Image Extension", %WebpImageExtension_x86_Appx%, %WebpImageExtension_x86_License%, "%DependencyPackages%"
				if "%ImageBuild%" geq "17763" if "%ImageArchitecture%" equ "x64" (
					call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Webp Image Extension x86", %WebpImageExtension_x86_Appx%, %WebpImageExtension_x86_License%, "%DependencyPackages%"
					call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Webp Image Extension x64", %WebpImageExtension_x64_Appx%, %WebpImageExtension_x64_License%, "%DependencyPackages%"
				)
				if "%ImageBuild%" geq "17763" if "%ImageArchitecture%" equ "arm64" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Webp Image Extension", %WebpImageExtension_arm_Appx%, %WebpImageExtension_arm_License%, "%DependencyPackages%"
			)
			if "%MetroApp%" equ "FeedbackHub" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Feedback Hub", %FeedbackHub_Appx%, %FeedbackHub_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "GetHelp" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Get Help", %GetHelp_Appx%, %GetHelp_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "Getstarted" if "%ImageBuild%" leq "14393" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Get Started", %Getstarted_Appx%, %Getstarted_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "Getstarted" if "%ImageBuild%" geq "15063" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Tips", %Getstarted_Appx%, %Getstarted_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "Maps" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Maps", %Maps_Appx%, %Maps_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "Messaging" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Messaging", %Messaging_Appx%, %Messaging_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "MixedRealityPortal" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Mixed Reality Portal", %MixedRealityPortal_Appx%, %MixedRealityPortal_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "OfficeHub" if "%ImageBuild%" leq "16299" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Get Office", %OfficeHub_Appx%, %OfficeHub_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "OfficeHub" if "%ImageBuild%" geq "17134" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "My Office", %OfficeHub_Appx%, %OfficeHub_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "OfficeOneNote" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Office OneNote", %OfficeOneNote_Appx%, %OfficeOneNote_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "OfficeSway" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Office Sway", %OfficeSway_Appx%, %OfficeSway_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "OneConnect" if "%ImageBuild%" leq "16299" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Paid WiFi and Mobile", %OneConnect_Appx%, %OneConnect_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "OneConnect" if "%ImageBuild%" geq "17134" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Mobile Plans", %OneConnect_Appx%, %OneConnect_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "Paint3D" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Paint 3D", %Paint3D_Appx%, %Paint3D_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "People" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "People", %People_Appx%, %People_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "Phone" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Phone", %Phone_Appx%, %Phone_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "PhoneCompanion" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Phone Companion", %PhoneCompanion_Appx%, %PhoneCompanion_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "Photos" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Photos", %Photos_Appx%, %Photos_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "Print3D" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Print 3D", %Print3D_Appx%, %Print3D_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "ScreenSketch" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Snip and Sketch", %ScreenSketch_Appx%, %ScreenSketch_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "SkypeApp" if "%ImageBuild%" leq "10586" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Get Skype App", %SkypeApp_Appx%, %SkypeApp_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "SkypeApp" if "%ImageBuild%" geq "14393" if "%ImageBuild%" leq "16299" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Skype Preview App", %SkypeApp_Appx%, %SkypeApp_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "SkypeApp" if "%ImageBuild%" geq "17134" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Skype", %SkypeApp_Appx%, %SkypeApp_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "SolitaireCollection" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Solitaire Collection", %SolitaireCollection_Appx%, %SolitaireCollection_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "SoundRecorder" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Voice Recorder", %SoundRecorder_Appx%, %SoundRecorder_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "StickyNotes" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Sticky Notes", %StickyNotes_Appx%, %StickyNotes_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "Store" (
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Store", %Store_Appx%, %Store_License%, "%DependencyPackages%"
				if "%ImageBuild%" geq "14393" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Store Purchase App", %StorePurchaseApp_Appx%, %StorePurchaseApp_License%, "%DependencyPackages%"
				if "%ImageBuild%" geq "14393" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Xbox Identity Provider", %XboxIdentityProvider_Appx%, %XboxIdentityProvider_License%, "%DependencyPackages%"
				if "%ImageBuild%" geq "16299" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Xbox Live", %XboxTCUI_Appx%, %XboxTCUI_License%, "%DependencyPackages%"
			)
			if "%MetroApp%" equ "ThreeDBuilder" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "3D Builder", %ThreeDBuilder_Appx%, %ThreeDBuilder_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "ThreeDViewer" if "%ImageBuild%" equ "16299" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "View 3D Preview", %ThreeDViewer_Appx%, %ThreeDViewer_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "ThreeDViewer" if "%ImageBuild%" geq "17134" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Mixed Reality Viewer", %ThreeDViewer_Appx%, %ThreeDViewer_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "Wallet" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Wallet", %Wallet_Appx%, %Wallet_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "WiFi" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "WiFi", %WiFi_Appx%, %WiFi_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "XboxApp" (
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Xbox App", %XboxApp_Appx%, %XboxApp_License%, "%DependencyPackages%"
				if "%ImageBuild%" geq "15063" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Xbox Game Overlay", %XboxGameOverlay_Appx%, %XboxGameOverlay_License%, "%DependencyPackages%"
				if "%ImageBuild%" geq "17134" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Xbox Gaming Overlay", %XboxGamingOverlay_Appx%, %XboxGamingOverlay_License%, "%DependencyPackages%"
				if "%ImageBuild%" geq "14393" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Xbox Identity Provider", %XboxIdentityProvider_Appx%, %XboxIdentityProvider_License%, "%DependencyPackages%"
				if "%ImageBuild%" geq "15063" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Xbox Game Speech Window", %XboxSpeechToTextOverlay_Appx%, %XboxSpeechToTextOverlay_License%, "%DependencyPackages%"
				if "%ImageBuild%" geq "16299" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Xbox Live", %XboxTCUI_Appx%, %XboxTCUI_License%, "%DependencyPackages%"
			)
			if "%MetroApp%" equ "YourPhone" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Your Phone", %YourPhone_Appx%, %YourPhone_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "ZuneMusic" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Groove Music", %ZuneMusic_Appx%, %ZuneMusic_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "ZuneVideo" if "%ImageBuild%" leq "16299" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Movies and TV", %ZuneVideo_Appx%, %ZuneVideo_License%, "%DependencyPackages%"
			if "%MetroApp%" equ "ZuneVideo" if "%ImageBuild%" geq "17134" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Films and TV", %ZuneVideo_Appx%, %ZuneVideo_License%, "%DependencyPackages%"
		)

		:: Integrating All Microsoft Default Metro Apps to Install Image
		if "%MetroApp%" equ "AllApps" (
			if "%SelectedSourceOS%" equ "w81" (
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Alarms", %Alarms_Appx%, %Alarms_License%, "%DependencyPackages%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Calculator", %Calculator_Appx%, %Calculator_License%, "%DependencyPackages%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Calender, Mail and People", %CommunicationsApps_Appx%, %CommunicationsApps_License%, "%DependencyPackages%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Bing Finance", %BingFinance_Appx%, %BingFinance_License%, "%DependencyPackages%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Bing Food and Drink", %BingFoodDrink_Appx%, %BingFoodDrink_License%, "%DependencyPackages%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Bing Health and Fitness", %BingHealthFitness_Appx%, %BingHealthFitness_License%, "%DependencyPackages%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Bing Maps", %BingMaps_Appx%, %BingMaps_License%, "%DependencyPackages%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Bing News", %BingNews_Appx%, %BingNews_License%, "%DependencyPackages%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Bing Sports", %BingSports_Appx%, %BingSports_License%, "%DependencyPackages%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Bing Travel", %BingTravel_Appx%, %BingTravel_License%, "%DependencyPackages%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Bing Weather", %BingWeather_Appx%, %BingWeather_License%, "%DependencyPackages%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Help and Tips", %HelpAndTips_Appx%, %HelpAndTips_License%, "%DependencyPackages%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Office OneNote", %OfficeOneNote_Appx%, %OfficeOneNote_License%, "%DependencyPackages%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Reader", %Reader_Appx%, %Reader_License%, "%DependencyPackages%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Reading List", %ReadingList_Appx%, %ReadingList_License%, "%DependencyPackages%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Scan", %Scan_Appx%, %Scan_License%, "%DependencyPackages%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Skype App", %SkypeApp_Appx%, %SkypeApp_License%, "%DependencyPackages%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Sound Recorder", %SoundRecorder_Appx%, %SoundRecorder_License%, "%DependencyPackages%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Xbox Live Games", %XboxLiveGames_Appx%, %XboxLiveGames_License%, "%DependencyPackages%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Zune Music", %ZuneMusic_Appx%, %ZuneMusic_License%, "%DependencyPackages%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Zune Video", %ZuneVideo_Appx%, %ZuneVideo_License%, "%DependencyPackages%"
			)

			if "%SelectedSourceOS%" equ "w10" (
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Alarms and Clock", %Alarms_Appx%, %Alarms_License%, "%DependencyPackages%"
				if "%ImageBuild%" geq "10240" if "%ImageBuild%" leq "10586" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "App Connector", %AppConnector_Appx%, %AppConnector_License%, ""
				if "%ImageBuild%" leq "10586" (
						call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Bing Finance", %BingFinance_Appx%, %BingFinance_License%, "%DependencyPackages%"
						call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Bing News", %BingNews_Appx%, %BingNews_License%, "%DependencyPackages%"
						call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Bing Sports", %BingSports_Appx%, %BingSports_License%, "%DependencyPackages%"
						call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Bing Weather", %BingWeather_Appx%, %BingWeather_License%, "%DependencyPackages%"
				)
				if "%ImageBuild%" geq "14393" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Weather", %BingWeather_Appx%, %BingWeather_License%, "%DependencyPackages%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Calculator", %Calculator_Appx%, %Calculator_License%, "%DependencyPackages%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Camera", %Camera_Appx%, %Camera_License%, "%DependencyPackages%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Calendar and Mail", %CommunicationsApps_Appx%, %CommunicationsApps_License%, "%DependencyPackages%"
				if "%ImageBuild%" geq "14393" if "%ImageBuild%" lss "17763" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Desktop App Installer", %DesktopAppInstaller_Appx%, %DesktopAppInstaller_License%, "%DependencyPackages%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Desktop App Installer", %DesktopAppInstaller_Appx%, %DesktopAppInstaller_License%, "%DependencyPackages%"
				if "%ImageBuild%" geq "17763" (
					if "%ImageArchitecture%" equ "x86" (
						call :AddProvisionedAppxPackage "%InstallMount%\%%i", "HEIF Image Extension", %HEIFImageExtension_x86_Appx%, %HEIFImageExtension_x86_License%, "%DependencyPackages%"
						call :AddProvisionedAppxPackage "%InstallMount%\%%i", "HEVC Video Extension", %HEVCVideoExtension_x86_Appx%, %HEVCVideoExtension_x86_License%, "%DependencyPackages%"
						call :AddProvisionedAppxPackage "%InstallMount%\%%i", "MPEG2 Video Extension", %MPEG2VideoExtension_x86_Appx%, %MPEG2VideoExtension_x86_License%, "%DependencyPackages%"
						call :AddProvisionedAppxPackage "%InstallMount%\%%i", "VP9 Video Extension", %VP9VideoExtensions_x86_Appx%, %VP9VideoExtensions_x86_License%, "%DependencyPackages%"
					)
					if "%ImageArchitecture%" equ "x64" (
						call :AddProvisionedAppxPackage "%InstallMount%\%%i", "HEIF Image Extension x86", %HEIFImageExtension_x86_Appx%, %HEIFImageExtension_x86_License%, "%DependencyPackages%"
						call :AddProvisionedAppxPackage "%InstallMount%\%%i", "HEIF Image Extension x64", %HEIFImageExtension_x64_Appx%, %HEIFImageExtension_x64_License%, "%DependencyPackages%"
						call :AddProvisionedAppxPackage "%InstallMount%\%%i", "HEVC Video Extension x86", %HEVCVideoExtension_x86_Appx%, %HEVCVideoExtension_x86_License%, "%DependencyPackages%"
						call :AddProvisionedAppxPackage "%InstallMount%\%%i", "HEVC Video Extension x64", %HEVCVideoExtension_x64_Appx%, %HEVCVideoExtension_x64_License%, "%DependencyPackages%"
						call :AddProvisionedAppxPackage "%InstallMount%\%%i", "MPEG2 Video Extension x86", %MPEG2VideoExtension_x86_Appx%, %MPEG2VideoExtension_x86_License%, "%DependencyPackages%"
						call :AddProvisionedAppxPackage "%InstallMount%\%%i", "MPEG2 Video Extension x64", %MPEG2VideoExtension_x64_Appx%, %MPEG2VideoExtension_x64_License%, "%DependencyPackages%"
						call :AddProvisionedAppxPackage "%InstallMount%\%%i", "VP9 Video Extension x86", %VP9VideoExtensions_x86_Appx%, %VP9VideoExtensions_x86_License%, "%DependencyPackages%"
						call :AddProvisionedAppxPackage "%InstallMount%\%%i", "VP9 Video Extension x64", %VP9VideoExtensions_x64_Appx%, %VP9VideoExtensions_x64_License%, "%DependencyPackages%"
					)
					if "%ImageArchitecture%" equ "arm64" (
						call :AddProvisionedAppxPackage "%InstallMount%\%%i", "HEIF Image Extension", %HEIFImageExtension_arm_Appx%, %HEIFImageExtension_arm_License%, "%DependencyPackages%"
						call :AddProvisionedAppxPackage "%InstallMount%\%%i", "HEVC Video Extension", %HEVCVideoExtension_arm_Appx%, %HEVCVideoExtension_arm_License%, "%DependencyPackages%"
						call :AddProvisionedAppxPackage "%InstallMount%\%%i", "MPEG2 Video Extension", %MPEG2VideoExtension_arm_Appx%, %MPEG2VideoExtension_arm_License%, "%DependencyPackages%"
						call :AddProvisionedAppxPackage "%InstallMount%\%%i", "VP9 Video Extension", %VP9VideoExtensions_arm_Appx%, %VP9VideoExtensions_arm_License%, "%DependencyPackages%"
					)
				)
				if "%ImageBuild%" geq "17134" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Web Media Extension", %WebMediaExtensions_Appx%, %WebMediaExtensions_License%, "%DependencyPackages%"
				if "%ImageBuild%" geq "17763" (
					if "%ImageArchitecture%" equ "x86" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Webp Image Extension", %WebpImageExtension_x86_Appx%, %WebpImageExtension_x86_License%, "%DependencyPackages%"
					if "%ImageArchitecture%" equ "x64" (
						call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Webp Image Extension x86", %WebpImageExtension_x86_Appx%, %WebpImageExtension_x86_License%, "%DependencyPackages%"
						call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Webp Image Extension x64", %WebpImageExtension_x64_Appx%, %WebpImageExtension_x64_License%, "%DependencyPackages%"
					)
					if "%ImageBuild%" geq "17763" if "%ImageArchitecture%" equ "arm64" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Webp Image Extension", %WebpImageExtension_arm_Appx%, %WebpImageExtension_arm_License%, "%DependencyPackages%"
				)
				if "%ImageBuild%" geq "14393" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Feedback Hub", %FeedbackHub_Appx%, %FeedbackHub_License%, "%DependencyPackages%"
				if "%ImageBuild%" geq "16299" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Get Help", %GetHelp_Appx%, %GetHelp_License%, "%DependencyPackages%"
				if "%ImageBuild%" leq "14393" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Get Started", %Getstarted_Appx%, %Getstarted_License%, "%DependencyPackages%"
				if "%ImageBuild%" geq "15063" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Tips", %Getstarted_Appx%, %Getstarted_License%, "%DependencyPackages%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Maps", %Maps_Appx%, %Maps_License%, "%DependencyPackages%"
				if "%ImageBuild%" geq "10586" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Messaging", %Messaging_Appx%, %Messaging_License%, "%DependencyPackages%"
				if "%ImageBuild%" geq "17763" if "%ImageArchitecture%" equ "x64" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Mixed Reality Portal", %MixedRealityPortal_Appx%, %MixedRealityPortal_License%, "%DependencyPackages%"
				if "%ImageBuild%" leq "16299" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Get Office", %OfficeHub_Appx%, %OfficeHub_License%, "%DependencyPackages%"
				if "%ImageBuild%" geq "17134" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "My Office", %OfficeHub_Appx%, %OfficeHub_License%, "%DependencyPackages%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Office OneNote", %OfficeOneNote_Appx%, %OfficeOneNote_License%, "%DependencyPackages%"
				if "%ImageBuild%" equ "10586" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Office Sway", %OfficeSway_Appx%, %OfficeSway_License%, "%DependencyPackages%"
				if "%ImageBuild%" geq "14393" if "%ImageBuild%" leq "16299" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Paid WiFi and Mobile", %OneConnect_Appx%, %OneConnect_License%, "%DependencyPackages%"
				if "%ImageBuild%" geq "17134" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Mobile Plans", %OneConnect_Appx%, %OneConnect_License%, "%DependencyPackages%"
				if "%ImageBuild%" geq "15063" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Paint 3D", %Paint3D_Appx%, %Paint3D_License%, "%DependencyPackages%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "People", %People_Appx%, %People_License%, "%DependencyPackages%"
				if "%ImageBuild%" equ "10586" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Phone", %Phone_Appx%, %Phone_License%, "%DependencyPackages%"
				if "%ImageBuild%" geq "10240" if "%ImageBuild%" leq "10586" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Phone Companion", %PhoneCompanion_Appx%, %PhoneCompanion_License%, "%DependencyPackages%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Photos", %Photos_Appx%, %Photos_License%, "%DependencyPackages%"
				if "%ImageBuild%" geq "16299" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Print 3D", %Print3D_Appx%, %Print3D_License%, "%DependencyPackages%"
				if "%ImageBuild%" geq "17763" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Snip and Sketch", %ScreenSketch_Appx%, %ScreenSketch_License%, "%DependencyPackages%"
				if "%ImageBuild%" leq "10586" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Get Skype App", %SkypeApp_Appx%, %SkypeApp_License%, "%DependencyPackages%"
				if "%ImageBuild%" geq "14393" if "%ImageBuild%" leq "16299" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Skype Preview App", %SkypeApp_Appx%, %SkypeApp_License%, "%DependencyPackages%"
				if "%ImageBuild%" geq "17134" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Skype", %SkypeApp_Appx%, %SkypeApp_License%, "%DependencyPackages%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Solitaire Collection", %SolitaireCollection_Appx%, %SolitaireCollection_License%, "%DependencyPackages%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Voice Recorder", %SoundRecorder_Appx%, %SoundRecorder_License%, "%DependencyPackages%"
				if "%ImageBuild%" geq "14393" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Sticky Notes", %StickyNotes_Appx%, %StickyNotes_License%, "%DependencyPackages%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Store", %Store_Appx%, %Store_License%, "%DependencyPackages%"
				if "%ImageBuild%" geq "14393" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Store Purchase App", %StorePurchaseApp_Appx%, %StorePurchaseApp_License%, "%DependencyPackages%"
				if "%ImageBuild%" leq "15063" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "3D Builder", %ThreeDBuilder_Appx%, %ThreeDBuilder_License%, "%DependencyPackages%"
				if "%ImageBuild%" geq "17134" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Mixed Reality Viewer", %ThreeDViewer_Appx%, %ThreeDViewer_License%, "%DependencyPackages%"
				if "%ImageBuild%" geq "15063" if "%ImageBuild%" leq "16299" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "View 3D Preview", %ThreeDViewer_Appx%, %ThreeDViewer_License%, "%DependencyPackages%"
				if "%ImageBuild%" geq "15063" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Wallet", %Wallet_Appx%, %Wallet_License%, "%DependencyPackages%"
				if "%ImageBuild%" equ "10586" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "WiFi", %WiFi_Appx%, %WiFi_License%, "%DependencyPackages%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Xbox App", %XboxApp_Appx%, %XboxApp_License%, "%DependencyPackages%"
				if "%ImageBuild%" geq "15063" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Xbox Game Overlay", %XboxGameOverlay_Appx%, %XboxGameOverlay_License%, "%DependencyPackages%"
				if "%ImageBuild%" geq "17134" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Xbox Gaming Overlay", %XboxGamingOverlay_Appx%, %XboxGamingOverlay_License%, "%DependencyPackages%"
				if "%ImageBuild%" geq "14393" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Xbox Identity Provider", %XboxIdentityProvider_Appx%, %XboxIdentityProvider_License%, "%DependencyPackages%"
				if "%ImageBuild%" geq "15063" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Xbox Game Speech Window", %XboxSpeechToTextOverlay_Appx%, %XboxSpeechToTextOverlay_License%, "%DependencyPackages%"
				if "%ImageBuild%" geq "16299" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Xbox Live", %XboxTCUI_Appx%, %XboxTCUI_License%, "%DependencyPackages%"
				if "%ImageBuild%" geq "17763" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Your Phone", %YourPhone_Appx%, %YourPhone_License%, "%DependencyPackages%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Groove Music", %ZuneMusic_Appx%, %ZuneMusic_License%, "%DependencyPackages%"
				if "%ImageBuild%" geq "17134" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Films and TV", %ZuneVideo_Appx%, %ZuneVideo_License%, "%DependencyPackages%"
				if "%ImageBuild%" leq "16299" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Movies and TV", %ZuneVideo_Appx%, %ZuneVideo_License%, "%DependencyPackages%"
			)				
		)
	) 
) else (
	:: Integraing Windows 8.1 Default Metro Apps to Install Image File
	if "%SelectedSourceOS%" equ "w81" (	
		if "%MetroApp%" equ "Alarms" call :AddProvisionedAppxPackage "%InstallMount%", "Alarms", %Alarms_Appx%, %Alarms_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "Calculator" call :AddProvisionedAppxPackage "%InstallMount%", "Calculator", %Calculator_Appx%, %Calculator_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "CommunicationsApps" call :AddProvisionedAppxPackage "%InstallMount%", "Calender, Mail and People", %CommunicationsApps_Appx%, %CommunicationsApps_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "BingFinance" call :AddProvisionedAppxPackage "%InstallMount%", "Bing Finance", %BingFinance_Appx%, %BingFinance_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "BingFoodDrink" call :AddProvisionedAppxPackage "%InstallMount%", "Bing Food and Drink", %BingFoodDrink_Appx%, %BingFoodDrink_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "BingHealthFitness" call :AddProvisionedAppxPackage "%InstallMount%", "Bing Health and Fitness", %BingHealthFitness_Appx%, %BingHealthFitness_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "BingMaps" call :AddProvisionedAppxPackage "%InstallMount%", "Bing Maps", %BingMaps_Appx%, %BingMaps_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "BingNews" call :AddProvisionedAppxPackage "%InstallMount%", "Bing News", %BingNews_Appx%, %BingNews_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "BingSports" call :AddProvisionedAppxPackage "%InstallMount%", "Bing Sports", %BingSports_Appx%, %BingSports_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "BingTravel" call :AddProvisionedAppxPackage "%InstallMount%", "Bing Travel", %BingTravel_Appx%, %BingTravel_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "BingWeather" call :AddProvisionedAppxPackage "%InstallMount%", "Bing Weather", %BingWeather_Appx%, %BingWeather_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "HelpAndTips" call :AddProvisionedAppxPackage "%InstallMount%", "Help and Tips", %HelpAndTips_Appx%, %HelpAndTips_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "OfficeOneNote" call :AddProvisionedAppxPackage "%InstallMount%", "Office OneNote", %OfficeOneNote_Appx%, %OfficeOneNote_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "Reader" call :AddProvisionedAppxPackage "%InstallMount%", "Reader", %Reader_Appx%, %Reader_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "ReadingList" call :AddProvisionedAppxPackage "%InstallMount%", "Reading List", %ReadingList_Appx%, %ReadingList_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "Scan" call :AddProvisionedAppxPackage "%InstallMount%", "Scan", %Scan_Appx%, %Scan_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "SkypeApp" call :AddProvisionedAppxPackage "%InstallMount%", "Skype App", %SkypeApp_Appx%, %SkypeApp_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "SoundRecorder" call :AddProvisionedAppxPackage "%InstallMount%", "Sound Recorder", %SoundRecorder_Appx%, %SoundRecorder_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "XboxLiveGames" call :AddProvisionedAppxPackage "%InstallMount%", "Xbox Live Games", %XboxLiveGames_Appx%, %XboxLiveGames_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "ZuneMusic" call :AddProvisionedAppxPackage "%InstallMount%", "Zune Music", %ZuneMusic_Appx%, %ZuneMusic_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "ZuneVideo" call :AddProvisionedAppxPackage "%InstallMount%", "Zune Video", %ZuneVideo_Appx%, %ZuneVideo_License%, "%DependencyPackages%"
	)

	:: Integrating Windows 10 Default Metro Apps to Install Image
	if "%SelectedSourceOS%" equ "w10" (
		if "%MetroApp%" equ "Alarms" call :AddProvisionedAppxPackage "%InstallMount%", "Alarms and Clock", %Alarms_Appx%, %Alarms_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "AppConnector" call :AddProvisionedAppxPackage "%InstallMount%", "App Connector", %AppConnector_Appx%, %AppConnector_License%, ""
		if "%MetroApp%" equ "BingFinance" call :AddProvisionedAppxPackage "%InstallMount%", "Bing Finance", %BingFinance_Appx%, %BingFinance_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "BingNews" call :AddProvisionedAppxPackage "%InstallMount%", "Bing News", %BingNews_Appx%, %BingNews_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "BingSports" call :AddProvisionedAppxPackage "%InstallMount%", "Bing Sports", %BingSports_Appx%, %BingSports_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "BingWeather" if "%ImageBuild%" leq "10586" call :AddProvisionedAppxPackage "%InstallMount%", "Bing Weather", %BingWeather_Appx%, %BingWeather_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "BingWeather" if "%ImageBuild%" geq "14393" call :AddProvisionedAppxPackage "%InstallMount%", "Weather", %BingWeather_Appx%, %BingWeather_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "Calculator" call :AddProvisionedAppxPackage "%InstallMount%", "Calculator", %Calculator_Appx%, %Calculator_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "Camera" call :AddProvisionedAppxPackage "%InstallMount%", "Camera", %Camera_Appx%, %Camera_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "CommunicationsApps" call :AddProvisionedAppxPackage "%InstallMount%", "Calendar and Mail", %CommunicationsApps_Appx%, %CommunicationsApps_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "DesktopAppInstaller" call :AddProvisionedAppxPackage "%InstallMount%", "Desktop App Installer", %DesktopAppInstaller_Appx%, %DesktopAppInstaller_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "Extensions" (
			if "%ImageBuild%" geq "17763" if "%ImageArchitecture%" equ "x86" (
				call :AddProvisionedAppxPackage "%InstallMount%", "HEIF Image Extension", %HEIFImageExtension_x86_Appx%, %HEIFImageExtension_x86_License%, "%DependencyPackages%"
				call :AddProvisionedAppxPackage "%InstallMount%", "HEVC Video Extension", %HEVCVideoExtension_x86_Appx%, %HEVCVideoExtension_x86_License%, "%DependencyPackages%"
				call :AddProvisionedAppxPackage "%InstallMount%", "MPEG2 Video Extension", %MPEG2VideoExtension_x86_Appx%, %MPEG2VideoExtension_x86_License%, "%DependencyPackages%"
				call :AddProvisionedAppxPackage "%InstallMount%", "VP9 Video Extension", %VP9VideoExtensions_x86_Appx%, %VP9VideoExtensions_x86_License%, "%DependencyPackages%"
			)
			if "%ImageBuild%" geq "17763" if "%ImageArchitecture%" equ "x64" (
				call :AddProvisionedAppxPackage "%InstallMount%", "HEIF Image Extension x86", %HEIFImageExtension_x86_Appx%, %HEIFImageExtension_x86_License%, "%DependencyPackages%"
				call :AddProvisionedAppxPackage "%InstallMount%", "HEIF Image Extension x64", %HEIFImageExtension_x64_Appx%, %HEIFImageExtension_x64_License%, "%DependencyPackages%"
				call :AddProvisionedAppxPackage "%InstallMount%", "HEVC Video Extension x86", %HEVCVideoExtension_x86_Appx%, %HEVCVideoExtension_x86_License%, "%DependencyPackages%"
				call :AddProvisionedAppxPackage "%InstallMount%", "HEVC Video Extension x64", %HEVCVideoExtension_x64_Appx%, %HEVCVideoExtension_x64_License%, "%DependencyPackages%"
				call :AddProvisionedAppxPackage "%InstallMount%", "MPEG2 Video Extension x86", %MPEG2VideoExtension_x86_Appx%, %MPEG2VideoExtension_x86_License%, "%DependencyPackages%"
				call :AddProvisionedAppxPackage "%InstallMount%", "MPEG2 Video Extension x64", %MPEG2VideoExtension_x64_Appx%, %MPEG2VideoExtension_x64_License%, "%DependencyPackages%"
				call :AddProvisionedAppxPackage "%InstallMount%", "VP9 Video Extension x86", %VP9VideoExtensions_x86_Appx%, %VP9VideoExtensions_x86_License%, "%DependencyPackages%"
				call :AddProvisionedAppxPackage "%InstallMount%", "VP9 Video Extension x64", %VP9VideoExtensions_x64_Appx%, %VP9VideoExtensions_x64_License%, "%DependencyPackages%"
			)
			if "%ImageBuild%" geq "17763" if "%ImageArchitecture%" equ "arm64" (
				call :AddProvisionedAppxPackage "%InstallMount%", "HEIF Image Extension", %HEIFImageExtension_arm_Appx%, %HEIFImageExtension_arm_License%, "%DependencyPackages%"
				call :AddProvisionedAppxPackage "%InstallMount%", "HEVC Video Extension", %HEVCVideoExtension_arm_Appx%, %HEVCVideoExtension_arm_License%, "%DependencyPackages%"
				call :AddProvisionedAppxPackage "%InstallMount%", "MPEG2 Video Extension", %MPEG2VideoExtension_arm_Appx%, %MPEG2VideoExtension_arm_License%, "%DependencyPackages%"
				call :AddProvisionedAppxPackage "%InstallMount%", "VP9 Video Extension", %VP9VideoExtensions_arm_Appx%, %VP9VideoExtensions_arm_License%, "%DependencyPackages%"
			)
			call :AddProvisionedAppxPackage "%InstallMount%", "Web Media Extension", %WebMediaExtensions_Appx%, %WebMediaExtensions_License%, "%DependencyPackages%"
			if "%ImageBuild%" geq "17763" if "%ImageArchitecture%" equ "x86" call :AddProvisionedAppxPackage "%InstallMount%", "Webp Image Extension", %WebpImageExtension_x86_Appx%, %WebpImageExtension_x86_License%, "%DependencyPackages%"
			if "%ImageBuild%" geq "17763" if "%ImageArchitecture%" equ "x64" (
				call :AddProvisionedAppxPackage "%InstallMount%", "Webp Image Extension x86", %WebpImageExtension_x86_Appx%, %WebpImageExtension_x86_License%, "%DependencyPackages%"
				call :AddProvisionedAppxPackage "%InstallMount%", "Webp Image Extension x64", %WebpImageExtension_x64_Appx%, %WebpImageExtension_x64_License%, "%DependencyPackages%"
			)
			if "%ImageBuild%" geq "17763" if "%ImageArchitecture%" equ "arm64" call :AddProvisionedAppxPackage "%InstallMount%", "Webp Image Extension", %WebpImageExtension_arm_Appx%, %WebpImageExtension_arm_License%, "%DependencyPackages%"
		)
		if "%MetroApp%" equ "FeedbackHub" call :AddProvisionedAppxPackage "%InstallMount%", "Feedback Hub", %FeedbackHub_Appx%, %FeedbackHub_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "GetHelp" call :AddProvisionedAppxPackage "%InstallMount%", "Get Help", %GetHelp_Appx%, %GetHelp_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "Getstarted" if "%ImageBuild%" leq "14393" call :AddProvisionedAppxPackage "%InstallMount%", "Get Started", %Getstarted_Appx%, %Getstarted_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "Getstarted" if "%ImageBuild%" geq "15063" call :AddProvisionedAppxPackage "%InstallMount%", "Tips", %Getstarted_Appx%, %Getstarted_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "Maps" call :AddProvisionedAppxPackage "%InstallMount%", "Maps", %Maps_Appx%, %Maps_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "Messaging" call :AddProvisionedAppxPackage "%InstallMount%", "Messaging", %Messaging_Appx%, %Messaging_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "MixedRealityPortal" call :AddProvisionedAppxPackage "%InstallMount%", "Mixed Reality Portal", %MixedRealityPortal_Appx%, %MixedRealityPortal_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "OfficeHub" if "%ImageBuild%" leq "16299" call :AddProvisionedAppxPackage "%InstallMount%", "Get Office", %OfficeHub_Appx%, %OfficeHub_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "OfficeHub" if "%ImageBuild%" geq "17134" call :AddProvisionedAppxPackage "%InstallMount%", "My Office", %OfficeHub_Appx%, %OfficeHub_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "OfficeOneNote" call :AddProvisionedAppxPackage "%InstallMount%", "Office OneNote", %OfficeOneNote_Appx%, %OfficeOneNote_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "OfficeSway" call :AddProvisionedAppxPackage "%InstallMount%", "Office Sway", %OfficeSway_Appx%, %OfficeSway_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "OneConnect" if "%ImageBuild%" leq "16299" call :AddProvisionedAppxPackage "%InstallMount%", "Paid WiFi and Mobile", %OneConnect_Appx%, %OneConnect_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "OneConnect" if "%ImageBuild%" geq "17134" call :AddProvisionedAppxPackage "%InstallMount%", "Mobile Plans", %OneConnect_Appx%, %OneConnect_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "Paint3D" call :AddProvisionedAppxPackage "%InstallMount%", "Paint 3D", %Paint3D_Appx%, %Paint3D_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "People" call :AddProvisionedAppxPackage "%InstallMount%", "People", %People_Appx%, %People_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "Phone" call :AddProvisionedAppxPackage "%InstallMount%", "Phone", %Phone_Appx%, %Phone_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "PhoneCompanion" call :AddProvisionedAppxPackage "%InstallMount%", "Phone Companion", %PhoneCompanion_Appx%, %PhoneCompanion_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "Photos" call :AddProvisionedAppxPackage "%InstallMount%", "Photos", %Photos_Appx%, %Photos_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "Print3D" call :AddProvisionedAppxPackage "%InstallMount%", "Print 3D", %Print3D_Appx%, %Print3D_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "ScreenSketch" call :AddProvisionedAppxPackage "%InstallMount%", "Snip and Sketch", %ScreenSketch_Appx%, %ScreenSketch_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "SkypeApp" if "%ImageBuild%" leq "10586" call :AddProvisionedAppxPackage "%InstallMount%", "Get Skype App", %SkypeApp_Appx%, %SkypeApp_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "SkypeApp" if "%ImageBuild%" geq "14393" if "%ImageBuild%" leq "16299" call :AddProvisionedAppxPackage "%InstallMount%", "Skype Preview App", %SkypeApp_Appx%, %SkypeApp_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "SkypeApp" if "%ImageBuild%" geq "17134" call :AddProvisionedAppxPackage "%InstallMount%", "Skype", %SkypeApp_Appx%, %SkypeApp_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "SolitaireCollection" call :AddProvisionedAppxPackage "%InstallMount%", "Solitaire Collection", %SolitaireCollection_Appx%, %SolitaireCollection_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "SoundRecorder" call :AddProvisionedAppxPackage "%InstallMount%", "Voice Recorder", %SoundRecorder_Appx%, %SoundRecorder_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "StickyNotes" call :AddProvisionedAppxPackage "%InstallMount%", "Sticky Notes", %StickyNotes_Appx%, %StickyNotes_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "Store" (
			call :AddProvisionedAppxPackage "%InstallMount%", "Store", %Store_Appx%, %Store_License%, "%DependencyPackages%"
			if "%ImageBuild%" geq "14393" call :AddProvisionedAppxPackage "%InstallMount%", "Store Purchase App", %StorePurchaseApp_Appx%, %StorePurchaseApp_License%, "%DependencyPackages%"
			if "%ImageBuild%" geq "14393" call :AddProvisionedAppxPackage "%InstallMount%", "Xbox Identity Provider", %XboxIdentityProvider_Appx%, %XboxIdentityProvider_License%, "%DependencyPackages%"
			if "%ImageBuild%" geq "16299" call :AddProvisionedAppxPackage "%InstallMount%", "Xbox Live", %XboxTCUI_Appx%, %XboxTCUI_License%, "%DependencyPackages%"
		)
		if "%MetroApp%" equ "ThreeDBuilder" call :AddProvisionedAppxPackage "%InstallMount%", "3D Builder", %ThreeDBuilder_Appx%, %ThreeDBuilder_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "ThreeDViewer" if "%ImageBuild%" equ "16299" call :AddProvisionedAppxPackage "%InstallMount%", "View 3D Preview", %ThreeDViewer_Appx%, %ThreeDViewer_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "ThreeDViewer" if "%ImageBuild%" geq "17134" call :AddProvisionedAppxPackage "%InstallMount%", "Mixed Reality Viewer", %ThreeDViewer_Appx%, %ThreeDViewer_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "Wallet" call :AddProvisionedAppxPackage "%InstallMount%", "Wallet", %Wallet_Appx%, %Wallet_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "WiFi" call :AddProvisionedAppxPackage "%InstallMount%", "WiFi", %WiFi_Appx%, %WiFi_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "XboxApp" (
			call :AddProvisionedAppxPackage "%InstallMount%", "Xbox App", %XboxApp_Appx%, %XboxApp_License%, "%DependencyPackages%"
			if "%ImageBuild%" geq "15063" call :AddProvisionedAppxPackage "%InstallMount%", "Xbox Game Overlay", %XboxGameOverlay_Appx%, %XboxGameOverlay_License%, "%DependencyPackages%"
			if "%ImageBuild%" geq "17134" call :AddProvisionedAppxPackage "%InstallMount%", "Xbox Gaming Overlay", %XboxGamingOverlay_Appx%, %XboxGamingOverlay_License%, "%DependencyPackages%"
			if "%ImageBuild%" geq "14393" call :AddProvisionedAppxPackage "%InstallMount%", "Xbox Identity Provider", %XboxIdentityProvider_Appx%, %XboxIdentityProvider_License%, "%DependencyPackages%"
			if "%ImageBuild%" geq "15063" call :AddProvisionedAppxPackage "%InstallMount%", "Xbox Game Speech Window", %XboxSpeechToTextOverlay_Appx%, %XboxSpeechToTextOverlay_License%, "%DependencyPackages%"
			if "%ImageBuild%" geq "16299" call :AddProvisionedAppxPackage "%InstallMount%", "Xbox Live", %XboxTCUI_Appx%, %XboxTCUI_License%, "%DependencyPackages%"
		)
		if "%MetroApp%" equ "YourPhone" call :AddProvisionedAppxPackage "%InstallMount%", "Your Phone", %YourPhone_Appx%, %YourPhone_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "ZuneMusic" call :AddProvisionedAppxPackage "%InstallMount%", "Groove Music", %ZuneMusic_Appx%, %ZuneMusic_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "ZuneVideo" if "%ImageBuild%" leq "16299" call :AddProvisionedAppxPackage "%InstallMount%", "Movies and TV", %ZuneVideo_Appx%, %ZuneVideo_License%, "%DependencyPackages%"
		if "%MetroApp%" equ "ZuneVideo" if "%ImageBuild%" geq "17134" call :AddProvisionedAppxPackage "%InstallMount%", "Films and TV", %ZuneVideo_Appx%, %ZuneVideo_License%, "%DependencyPackages%"
	)

	:: Integrating All Microsoft Default Metro Apps to Install Image
	if "%MetroApp%" equ "AllApps" (
		if "%SelectedSourceOS%" equ "w81" (
			call :AddProvisionedAppxPackage "%InstallMount%", "Alarms", %Alarms_Appx%, %Alarms_License%, "%DependencyPackages%"
			call :AddProvisionedAppxPackage "%InstallMount%", "Calculator", %Calculator_Appx%, %Calculator_License%, "%DependencyPackages%"
			call :AddProvisionedAppxPackage "%InstallMount%", "Calender, Mail and People", %CommunicationsApps_Appx%, %CommunicationsApps_License%, "%DependencyPackages%"
			call :AddProvisionedAppxPackage "%InstallMount%", "Bing Finance", %BingFinance_Appx%, %BingFinance_License%, "%DependencyPackages%"
			call :AddProvisionedAppxPackage "%InstallMount%", "Bing Food and Drink", %BingFoodDrink_Appx%, %BingFoodDrink_License%, "%DependencyPackages%"
			call :AddProvisionedAppxPackage "%InstallMount%", "Bing Health and Fitness", %BingHealthFitness_Appx%, %BingHealthFitness_License%, "%DependencyPackages%"
			call :AddProvisionedAppxPackage "%InstallMount%", "Bing Maps", %BingMaps_Appx%, %BingMaps_License%, "%DependencyPackages%"
			call :AddProvisionedAppxPackage "%InstallMount%", "Bing News", %BingNews_Appx%, %BingNews_License%, "%DependencyPackages%"
			call :AddProvisionedAppxPackage "%InstallMount%", "Bing Sports", %BingSports_Appx%, %BingSports_License%, "%DependencyPackages%"
			call :AddProvisionedAppxPackage "%InstallMount%", "Bing Travel", %BingTravel_Appx%, %BingTravel_License%, "%DependencyPackages%"
			call :AddProvisionedAppxPackage "%InstallMount%", "Bing Weather", %BingWeather_Appx%, %BingWeather_License%, "%DependencyPackages%"
			call :AddProvisionedAppxPackage "%InstallMount%", "Help and Tips", %HelpAndTips_Appx%, %HelpAndTips_License%, "%DependencyPackages%"
			call :AddProvisionedAppxPackage "%InstallMount%", "Office OneNote", %OfficeOneNote_Appx%, %OfficeOneNote_License%, "%DependencyPackages%"
			call :AddProvisionedAppxPackage "%InstallMount%", "Reader", %Reader_Appx%, %Reader_License%, "%DependencyPackages%"
			call :AddProvisionedAppxPackage "%InstallMount%", "Reading List", %ReadingList_Appx%, %ReadingList_License%, "%DependencyPackages%"
			call :AddProvisionedAppxPackage "%InstallMount%", "Scan", %Scan_Appx%, %Scan_License%, "%DependencyPackages%"
			call :AddProvisionedAppxPackage "%InstallMount%", "Skype App", %SkypeApp_Appx%, %SkypeApp_License%, "%DependencyPackages%"
			call :AddProvisionedAppxPackage "%InstallMount%", "Sound Recorder", %SoundRecorder_Appx%, %SoundRecorder_License%, "%DependencyPackages%"
			call :AddProvisionedAppxPackage "%InstallMount%", "Xbox Live Games", %XboxLiveGames_Appx%, %XboxLiveGames_License%, "%DependencyPackages%"
			call :AddProvisionedAppxPackage "%InstallMount%", "Zune Music", %ZuneMusic_Appx%, %ZuneMusic_License%, "%DependencyPackages%"
			call :AddProvisionedAppxPackage "%InstallMount%", "Zune Video", %ZuneVideo_Appx%, %ZuneVideo_License%, "%DependencyPackages%"
		)

		if "%SelectedSourceOS%" equ "w10" (
			call :AddProvisionedAppxPackage "%InstallMount%", "Alarms and Clock", %Alarms_Appx%, %Alarms_License%, "%DependencyPackages%"
			if "%ImageBuild%" geq "10240" if "%ImageBuild%" leq "10586" call :AddProvisionedAppxPackage "%InstallMount%", "App Connector", %AppConnector_Appx%, %AppConnector_License%, ""
			if "%ImageBuild%" leq "10586" (
				call :AddProvisionedAppxPackage "%InstallMount%", "Bing Finance", %BingFinance_Appx%, %BingFinance_License%, "%DependencyPackages%"
				call :AddProvisionedAppxPackage "%InstallMount%", "Bing News", %BingNews_Appx%, %BingNews_License%, "%DependencyPackages%"
				call :AddProvisionedAppxPackage "%InstallMount%", "Bing Sports", %BingSports_Appx%, %BingSports_License%, "%DependencyPackages%"
				call :AddProvisionedAppxPackage "%InstallMount%", "Bing Weather", %BingWeather_Appx%, %BingWeather_License%, "%DependencyPackages%"
			)
			if "%ImageBuild%" geq "14393" call :AddProvisionedAppxPackage "%InstallMount%", "Weather", %BingWeather_Appx%, %BingWeather_License%, "%DependencyPackages%"
			call :AddProvisionedAppxPackage "%InstallMount%", "Calculator", %Calculator_Appx%, %Calculator_License%, "%DependencyPackages%"
			call :AddProvisionedAppxPackage "%InstallMount%", "Camera", %Camera_Appx%, %Camera_License%, "%DependencyPackages%"
			call :AddProvisionedAppxPackage "%InstallMount%", "Calendar and Mail", %CommunicationsApps_Appx%, %CommunicationsApps_License%, "%DependencyPackages%"
			if "%ImageBuild%" geq "14393" if "%ImageBuild%" lss "17763" call :AddProvisionedAppxPackage "%InstallMount%", "Desktop App Installer", %DesktopAppInstaller_Appx%, %DesktopAppInstaller_License%, "%DependencyPackages%"
			call :AddProvisionedAppxPackage "%InstallMount%", "Desktop App Installer", %DesktopAppInstaller_Appx%, %DesktopAppInstaller_License%, "%DependencyPackages%"
			if "%ImageBuild%" geq "17763" (
				if "%ImageArchitecture%" equ "x86" (
					call :AddProvisionedAppxPackage "%InstallMount%", "HEIF Image Extension", %HEIFImageExtension_x86_Appx%, %HEIFImageExtension_x86_License%, "%DependencyPackages%"
					call :AddProvisionedAppxPackage "%InstallMount%", "HEVC Video Extension", %HEVCVideoExtension_x86_Appx%, %HEVCVideoExtension_x86_License%, "%DependencyPackages%"
					call :AddProvisionedAppxPackage "%InstallMount%", "MPEG2 Video Extension", %MPEG2VideoExtension_x86_Appx%, %MPEG2VideoExtension_x86_License%, "%DependencyPackages%"
					call :AddProvisionedAppxPackage "%InstallMount%", "VP9 Video Extension", %VP9VideoExtensions_x86_Appx%, %VP9VideoExtensions_x86_License%, "%DependencyPackages%"
				)
				if "%ImageArchitecture%" equ "x64" (
					call :AddProvisionedAppxPackage "%InstallMount%", "HEIF Image Extension x86", %HEIFImageExtension_x86_Appx%, %HEIFImageExtension_x86_License%, "%DependencyPackages%"
					call :AddProvisionedAppxPackage "%InstallMount%", "HEIF Image Extension x64", %HEIFImageExtension_x64_Appx%, %HEIFImageExtension_x64_License%, "%DependencyPackages%"
					call :AddProvisionedAppxPackage "%InstallMount%", "HEVC Video Extension x86", %HEVCVideoExtension_x86_Appx%, %HEVCVideoExtension_x86_License%, "%DependencyPackages%"
					call :AddProvisionedAppxPackage "%InstallMount%", "HEVC Video Extension x64", %HEVCVideoExtension_x64_Appx%, %HEVCVideoExtension_x64_License%, "%DependencyPackages%"
					call :AddProvisionedAppxPackage "%InstallMount%", "MPEG2 Video Extension x86", %MPEG2VideoExtension_x86_Appx%, %MPEG2VideoExtension_x86_License%, "%DependencyPackages%"
					call :AddProvisionedAppxPackage "%InstallMount%", "MPEG2 Video Extension x64", %MPEG2VideoExtension_x64_Appx%, %MPEG2VideoExtension_x64_License%, "%DependencyPackages%"
					call :AddProvisionedAppxPackage "%InstallMount%", "VP9 Video Extension x86", %VP9VideoExtensions_x86_Appx%, %VP9VideoExtensions_x86_License%, "%DependencyPackages%"
					call :AddProvisionedAppxPackage "%InstallMount%", "VP9 Video Extension x64", %VP9VideoExtensions_x64_Appx%, %VP9VideoExtensions_x64_License%, "%DependencyPackages%"
				)
				if "%ImageArchitecture%" equ "arm64" (
					call :AddProvisionedAppxPackage "%InstallMount%", "HEIF Image Extension", %HEIFImageExtension_arm_Appx%, %HEIFImageExtension_arm_License%, "%DependencyPackages%"
					call :AddProvisionedAppxPackage "%InstallMount%", "HEVC Video Extension", %HEVCVideoExtension_arm_Appx%, %HEVCVideoExtension_arm_License%, "%DependencyPackages%"
					call :AddProvisionedAppxPackage "%InstallMount%", "MPEG2 Video Extension", %MPEG2VideoExtension_arm_Appx%, %MPEG2VideoExtension_arm_License%, "%DependencyPackages%"
					call :AddProvisionedAppxPackage "%InstallMount%", "VP9 Video Extension", %VP9VideoExtensions_arm_Appx%, %VP9VideoExtensions_arm_License%, "%DependencyPackages%"
				)
			)
			if "%ImageBuild%" geq "17134" call :AddProvisionedAppxPackage "%InstallMount%", "Web Media Extension", %WebMediaExtensions_Appx%, %WebMediaExtensions_License%, "%DependencyPackages%"
			if "%ImageBuild%" geq "17763" (
				if "%ImageArchitecture%" equ "x86" call :AddProvisionedAppxPackage "%InstallMount%", "Webp Image Extension", %WebpImageExtension_x86_Appx%, %WebpImageExtension_x86_License%, "%DependencyPackages%"
				if "%ImageArchitecture%" equ "x64" (
					call :AddProvisionedAppxPackage "%InstallMount%", "Webp Image Extension x86", %WebpImageExtension_x86_Appx%, %WebpImageExtension_x86_License%, "%DependencyPackages%"
					call :AddProvisionedAppxPackage "%InstallMount%", "Webp Image Extension x64", %WebpImageExtension_x64_Appx%, %WebpImageExtension_x64_License%, "%DependencyPackages%"
				)
				if "%ImageBuild%" geq "17763" if "%ImageArchitecture%" equ "arm64" call :AddProvisionedAppxPackage "%InstallMount%", "Webp Image Extension", %WebpImageExtension_arm_Appx%, %WebpImageExtension_arm_License%, "%DependencyPackages%"
			)
			if "%ImageBuild%" geq "14393" call :AddProvisionedAppxPackage "%InstallMount%", "Feedback Hub", %FeedbackHub_Appx%, %FeedbackHub_License%, "%DependencyPackages%"
			if "%ImageBuild%" geq "16299" call :AddProvisionedAppxPackage "%InstallMount%", "Get Help", %GetHelp_Appx%, %GetHelp_License%, "%DependencyPackages%"
			if "%ImageBuild%" leq "14393" call :AddProvisionedAppxPackage "%InstallMount%", "Get Started", %Getstarted_Appx%, %Getstarted_License%, "%DependencyPackages%"
			if "%ImageBuild%" geq "15063" call :AddProvisionedAppxPackage "%InstallMount%", "Tips", %Getstarted_Appx%, %Getstarted_License%, "%DependencyPackages%"
			call :AddProvisionedAppxPackage "%InstallMount%", "Maps", %Maps_Appx%, %Maps_License%, "%DependencyPackages%"
			if "%ImageBuild%" geq "10586" call :AddProvisionedAppxPackage "%InstallMount%", "Messaging", %Messaging_Appx%, %Messaging_License%, "%DependencyPackages%"
			if "%ImageBuild%" geq "17763" if "%ImageArchitecture%" equ "x64" call :AddProvisionedAppxPackage "%InstallMount%", "Mixed Reality Portal", %MixedRealityPortal_Appx%, %MixedRealityPortal_License%, "%DependencyPackages%"
			if "%ImageBuild%" leq "16299" call :AddProvisionedAppxPackage "%InstallMount%", "Get Office", %OfficeHub_Appx%, %OfficeHub_License%, "%DependencyPackages%"
			if "%ImageBuild%" geq "17134" call :AddProvisionedAppxPackage "%InstallMount%", "My Office", %OfficeHub_Appx%, %OfficeHub_License%, "%DependencyPackages%"
			call :AddProvisionedAppxPackage "%InstallMount%", "Office OneNote", %OfficeOneNote_Appx%, %OfficeOneNote_License%, "%DependencyPackages%"
			if "%ImageBuild%" equ "10586" call :AddProvisionedAppxPackage "%InstallMount%", "Office Sway", %OfficeSway_Appx%, %OfficeSway_License%, "%DependencyPackages%"
			if "%ImageBuild%" geq "14393" if "%ImageBuild%" leq "16299" call :AddProvisionedAppxPackage "%InstallMount%", "Paid WiFi and Mobile", %OneConnect_Appx%, %OneConnect_License%, "%DependencyPackages%"
			if "%ImageBuild%" geq "17134" call :AddProvisionedAppxPackage "%InstallMount%", "Mobile Plans", %OneConnect_Appx%, %OneConnect_License%, "%DependencyPackages%"
			if "%ImageBuild%" geq "15063" call :AddProvisionedAppxPackage "%InstallMount%", "Paint 3D", %Paint3D_Appx%, %Paint3D_License%, "%DependencyPackages%"
			call :AddProvisionedAppxPackage "%InstallMount%", "People", %People_Appx%, %People_License%, "%DependencyPackages%"
			if "%ImageBuild%" equ "10586" call :AddProvisionedAppxPackage "%InstallMount%", "Phone", %Phone_Appx%, %Phone_License%, "%DependencyPackages%"
			if "%ImageBuild%" geq "10240" if "%ImageBuild%" leq "10586" call :AddProvisionedAppxPackage "%InstallMount%", "Phone Companion", %PhoneCompanion_Appx%, %PhoneCompanion_License%, "%DependencyPackages%"
			call :AddProvisionedAppxPackage "%InstallMount%", "Photos", %Photos_Appx%, %Photos_License%, "%DependencyPackages%"
			if "%ImageBuild%" geq "16299" call :AddProvisionedAppxPackage "%InstallMount%", "Print 3D", %Print3D_Appx%, %Print3D_License%, "%DependencyPackages%"
			if "%ImageBuild%" geq "17763" call :AddProvisionedAppxPackage "%InstallMount%", "Snip and Sketch", %ScreenSketch_Appx%, %ScreenSketch_License%, "%DependencyPackages%"
			if "%ImageBuild%" leq "10586" call :AddProvisionedAppxPackage "%InstallMount%", "Get Skype App", %SkypeApp_Appx%, %SkypeApp_License%, "%DependencyPackages%"
			if "%ImageBuild%" geq "14393" if "%ImageBuild%" leq "16299" call :AddProvisionedAppxPackage "%InstallMount%", "Skype Preview App", %SkypeApp_Appx%, %SkypeApp_License%, "%DependencyPackages%"
			if "%ImageBuild%" geq "17134" call :AddProvisionedAppxPackage "%InstallMount%", "Skype", %SkypeApp_Appx%, %SkypeApp_License%, "%DependencyPackages%"
			call :AddProvisionedAppxPackage "%InstallMount%", "Solitaire Collection", %SolitaireCollection_Appx%, %SolitaireCollection_License%, "%DependencyPackages%"
			call :AddProvisionedAppxPackage "%InstallMount%", "Voice Recorder", %SoundRecorder_Appx%, %SoundRecorder_License%, "%DependencyPackages%"
			if "%ImageBuild%" geq "14393" call :AddProvisionedAppxPackage "%InstallMount%", "Sticky Notes", %StickyNotes_Appx%, %StickyNotes_License%, "%DependencyPackages%"
			call :AddProvisionedAppxPackage "%InstallMount%", "Store", %Store_Appx%, %Store_License%, "%DependencyPackages%"
			if "%ImageBuild%" geq "14393" call :AddProvisionedAppxPackage "%InstallMount%", "Store Purchase App", %StorePurchaseApp_Appx%, %StorePurchaseApp_License%, "%DependencyPackages%"
			if "%ImageBuild%" leq "15063" call :AddProvisionedAppxPackage "%InstallMount%", "3D Builder", %ThreeDBuilder_Appx%, %ThreeDBuilder_License%, "%DependencyPackages%"
			if "%ImageBuild%" geq "17134" call :AddProvisionedAppxPackage "%InstallMount%", "Mixed Reality Viewer", %ThreeDViewer_Appx%, %ThreeDViewer_License%, "%DependencyPackages%"
			if "%ImageBuild%" geq "15063" if "%ImageBuild%" leq "16299" call :AddProvisionedAppxPackage "%InstallMount%", "View 3D Preview", %ThreeDViewer_Appx%, %ThreeDViewer_License%, "%DependencyPackages%"
			if "%ImageBuild%" geq "15063" call :AddProvisionedAppxPackage "%InstallMount%", "Wallet", %Wallet_Appx%, %Wallet_License%, "%DependencyPackages%"
			if "%ImageBuild%" equ "10586" call :AddProvisionedAppxPackage "%InstallMount%", "WiFi", %WiFi_Appx%, %WiFi_License%, "%DependencyPackages%"
			call :AddProvisionedAppxPackage "%InstallMount%", "Xbox App", %XboxApp_Appx%, %XboxApp_License%, "%DependencyPackages%"
			if "%ImageBuild%" geq "15063" call :AddProvisionedAppxPackage "%InstallMount%", "Xbox Game Overlay", %XboxGameOverlay_Appx%, %XboxGameOverlay_License%, "%DependencyPackages%"
			if "%ImageBuild%" geq "17134" call :AddProvisionedAppxPackage "%InstallMount%", "Xbox Gaming Overlay", %XboxGamingOverlay_Appx%, %XboxGamingOverlay_License%, "%DependencyPackages%"
			if "%ImageBuild%" geq "14393" call :AddProvisionedAppxPackage "%InstallMount%", "Xbox Identity Provider", %XboxIdentityProvider_Appx%, %XboxIdentityProvider_License%, "%DependencyPackages%"
			if "%ImageBuild%" geq "15063" call :AddProvisionedAppxPackage "%InstallMount%", "Xbox Game Speech Window", %XboxSpeechToTextOverlay_Appx%, %XboxSpeechToTextOverlay_License%, "%DependencyPackages%"
			if "%ImageBuild%" geq "16299" call :AddProvisionedAppxPackage "%InstallMount%", "Xbox Live", %XboxTCUI_Appx%, %XboxTCUI_License%, "%DependencyPackages%"
			if "%ImageBuild%" geq "17763" call :AddProvisionedAppxPackage "%InstallMount%", "Your Phone", %YourPhone_Appx%, %YourPhone_License%, "%DependencyPackages%"
			call :AddProvisionedAppxPackage "%InstallMount%", "Groove Music", %ZuneMusic_Appx%, %ZuneMusic_License%, "%DependencyPackages%"
			if "%ImageBuild%" geq "17134" call :AddProvisionedAppxPackage "%InstallMount%", "Films and TV", %ZuneVideo_Appx%, %ZuneVideo_License%, "%DependencyPackages%"
			if "%ImageBuild%" leq "16299" call :AddProvisionedAppxPackage "%InstallMount%", "Movies and TV", %ZuneVideo_Appx%, %ZuneVideo_License%, "%DependencyPackages%"
		)			
	)
)
echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Microsoft Default Metro Apps##########################
echo.-------------------------------------------------------------------------------
echo.
:Stop
echo.===============================================================================
echo.
pause

set Apps=
set MetroApp=

set Alarms_Appx=
set AppConnector_Appx=
set BingFinance_Appx=
set BingFoodDrink_Appx=
set BingHealthFitness_Appx=
set BingMaps_Appx=
set BingNews_Appx=
set BingSports_Appx=
set BingTravel_Appx=
set BingWeather_Appx=
set Calculator_Appx=
set Camera_Appx=
set CommunicationsApps_Appx=
set DesktopAppInstaller_Appx=
set FeedbackHub_Appx=
set GetHelp_Appx=
set Getstarted_Appx=
set HEIFImageExtension_arm_Appx=
set HEIFImageExtension_x86_Appx=
set HEIFImageExtension_x64_Appx=
set HEVCVideoExtension_arm_Appx=
set HEVCVideoExtension_x86_Appx=
set HEVCVideoExtension_x64_Appx=
set HelpAndTips_Appx=
set Maps_Appx=
set Messaging_Appx=
set MixedRealityPortal_Appx=
set MPEG2VideoExtension_arm_Appx=
set MPEG2VideoExtension_x86_Appx=
set MPEG2VideoExtension_x64_Appx=
set OfficeHub_Appx=
set OfficeOneNote_Appx=
set OfficeSway_Appx=
set OneConnect_Appx=
set Paint3D_Appx=
set People_Appx=
set Phone_Appx=
set PhoneCompanion_Appx=
set Photos_Appx=
set Print3D_Appx=
set Reader_Appx=
set ReadingList_Appx=
set Scan_Appx=
set ScreenSketch_Appx=
set Skype_Appx=
set SolitaireCollection_Appx=
set SoundRecorder_Appx=
set StickyNotes_Appx=
set Store_Appx=
set StorePurchase_Appx=
set ThreeDBuilder_Appx=
set ThreeDViewer_Appx=
set VP9VideoExtensions_arm_Appx=
set VP9VideoExtensions_x86_Appx=
set VP9VideoExtensions_x64_Appx=
set Wallet_Appx=
set WebMediaExtensions_Appx=
set WebpImageExtension_arm_Appx=
set WebpImageExtension_x86_Appx=
set WebpImageExtension_x64_Appx=
set WiFi_Appx=
set Xbox_Appx=
set XboxGameOverlay_Appx=
set XboxGamingOverlay_Appx=
set XboxIdentityProvider_Appx=
set XboxLiveGames_Appx=
set XboxSpeechToTextOverlay_Appx=
set XboxTCUI_Appx=
set YourPhone_Appx=
set ZuneMusic_Appx=
set ZuneVideo_Appx=

set Alarms_License=
set AppConnector_License=
set BingFinance_License=
set BingFoodDrink_License=
set BingHealthFitness_License=
set BingMaps_License=
set BingNews_License=
set BingSports_License=
set BingTravel_License=
set BingWeather_License=
set Calculator_License=
set Camera_License=
set CommunicationsApps_License=
set DesktopAppInstaller_License=
set FeedbackHub_License=
set GetHelp_License=
set Getstarted_License=
set HEIFImageExtension_arm_License=
set HEIFImageExtension_x86_License=
set HEIFImageExtension_x64_License=
set HEVCVideoExtension_arm_License=
set HEVCVideoExtension_x86_License=
set HEVCVideoExtension_x64_License=
set HelpAndTips_License=
set Maps_License=
set Messaging_License=
set MixedRealityPortal_License=
set MPEG2VideoExtension_arm_License=
set MPEG2VideoExtension_x86_License=
set MPEG2VideoExtension_x64_License=
set OfficeHub_License=
set OfficeOneNote_License=
set OfficeSway_License=
set OneConnect_License=
set Paint3D_License=
set People_License=
set Phone_License=
set PhoneCompanion_License=
set Photos_License=
set Print3D_License=
set Reader_License=
set ReadingList_License=
set Scan_License=
set ScreenSketch_License=
set Skype_License=
set SolitaireCollection_License=
set SoundRecorder_License=
set StickyNotes_License=
set Store_License=
set StorePurchase_License=
set ThreeDBuilder_License=
set ThreeDViewer_License=
set VP9VideoExtensions_arm_License=
set VP9VideoExtensions_x86_License=
set VP9VideoExtensions_x64_License=
set Wallet_License=
set WebMediaExtensions_License=
set WebpImageExtension_arm_License=
set WebpImageExtension_x86_License=
set WebpImageExtension_x64_License=
set WiFi_License=
set Xbox_License=
set XboxGameOverlay_License=
set XboxGamingOverlay_License=
set XboxIdentityProvider_License=
set XboxLiveGames_License=
set XboxSpeechToTextOverlay_License=
set XboxTCUI_License=
set YourPhone_License=
set ZuneMusic_License=
set ZuneVideo_License=

set AdvertisingXaml_arm_Appx=
set AdvertisingXaml_arm64_Appx=
set AdvertisingXaml_x86_Appx=
set AdvertisingXaml_x64_Appx=
set MediaPlayReadyClient22_arm_Appx=
set MediaPlayReadyClient22_x86_Appx=
set MediaPlayReadyClient22_x64_Appx=
set NETNativeFramework13_arm_Appx=
set NETNativeFramework13_x86_Appx=
set NETNativeFramework13_x64_Appx=
set NETNativeFramework16_arm_Appx=
set NETNativeFramework16_x86_Appx=
set NETNativeFramework16_x64_Appx=
set NETNativeFramework17_arm_Appx=
set NETNativeFramework17_x86_Appx=
set NETNativeFramework17_x64_Appx=
set NETNativeFramework21_arm_Appx=
set NETNativeFramework21_x86_Appx=
set NETNativeFramework21_x64_Appx=
set NETNativeFramework22_arm_Appx=
set NETNativeFramework22_arm64_Appx=
set NETNativeFramework22_x86_Appx=
set NETNativeFramework22_x64_Appx=
set NETNativeRuntime13_arm_Appx=
set NETNativeRuntime13_x86_Appx=
set NETNativeRuntime13_x64_Appx=
set NETNativeRuntime14_arm_Appx=
set NETNativeRuntime14_x86_Appx=
set NETNativeRuntime14_x64_Appx=
set NETNativeRuntime16_arm_Appx=
set NETNativeRuntime16_x86_Appx=
set NETNativeRuntime16_x64_Appx=
set NETNativeRuntime17_arm_Appx=
set NETNativeRuntime17_x86_Appx=
set NETNativeRuntime17_x64_Appx=
set NETNativeRuntime21_arm_Appx=
set NETNativeRuntime21_x86_Appx=
set NETNativeRuntime21_x64_Appx=
set NETNativeRuntime22_arm_Appx=
set NETNativeRuntime22_arm64_Appx=
set NETNativeRuntime22_x86_Appx=
set NETNativeRuntime22_x64_Appx=
set ServicesStoreEngagement_arm_Appx=
set ServicesStoreEngagement_arm64_Appx=
set ServicesStoreEngagement_x86_Appx=
set ServicesStoreEngagement_x64_Appx=
set UIXaml20_arm_Appx=
set UIXaml20_arm64_Appx=
set UIXaml20_x86_Appx=
set UIXaml20_x64_Appx=
set UIXaml21_arm_Appx=
set UIXaml21_arm64_Appx=
set UIXaml21_x86_Appx=
set UIXaml21_x64_Appx=
set VCLibs12_arm_Appx=
set VCLibs12_x86_Appx=
set VCLibs12_x64_Appx=
set VCLibs14_arm_Appx=
set VCLibs14_arm64_Appx=
set VCLibs14_x86_Appx=
set VCLibs14_x64_Appx=
set VCLibsUWPDesktop14_arm_Appx=
set VCLibsUWPDesktop14_arm64_Appx=
set VCLibsUWPDesktop14_x86_Appx=
set VCLibsUWPDesktop14_x64_Appx=
set WinJS20_Appx=

set AdvertisingXaml=
set DependencyPackages=
set NETNativeFramework13=
set NETNativeFramework16=
set NETNativeFramework17=
set NETNativeFramework21=
set NETNativeFramework22=
set NETNativeRuntime13=
set NETNativeRuntime14=
set NETNativeRuntime16=
set NETNativeRuntime17=
set NETNativeRuntime21=
set NETNativeRuntime22=
set ServicesStoreEngagement=
set UIXaml20=
set UIXaml21=
set VCLibs14=
set VCLibsUWPDesktop14=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: MSMG ToolKit - Integrate Microsoft Office Desktop Universal Windows Platform (UWP) Apps
::-------------------------------------------------------------------------------------------
:IntOfficeUWPApps

setlocal

set OfficeUWPApp=
set OfficeDesktop_Appx=
set OfficeAccess_Appx=
set OfficeExcel_Appx=
set OfficeOutlook_Appx=
set OfficePowerPoint_Appx=
set OfficePublisher_Appx=
set OfficeWord_Appx=

set OfficeDesktop_License=
set OfficeAccess_License=
set OfficeExcel_License=
set OfficeOutlook_License=
set OfficePowerPoint_License=
set OfficePublisher_License=
set OfficeWord_License=

cls
echo.===============================================================================
echo.         MSMG ToolKit - Integrate Microsoft Office Desktop ^(UWP^) Apps
echo.===============================================================================
echo.
:: Checking whether Microsoft Office Desktop (UWP) Apps folder is empty
if not exist "%OfficeUWP%\*.appxbundle" (
	echo.Microsoft Office Desktop ^(UWP^) Apps Pack folder ^<Packs\%OfficeUWP%^> is empty...
	echo.
	echo.Please copy Microsoft Office Desktop ^(UWP^) Apps Pack files to respective folder...
	echo.
	goto :Stop
)

if not exist "%OfficeUWP%\*.xml" (
	echo.Microsoft Office Desktop ^(UWP^) Apps Pack folder ^<Packs\%OfficeUWP%^> is empty...
	echo.
	echo.Please copy Microsoft Office Desktop ^(UWP^) Apps Pack files to respective folder...
	echo.
	goto :Stop
)

cls
echo.===============================================================================
echo.      MSMG ToolKit - Integrate Microsoft Office Desktop ^(UWP^) Apps Menu
echo.===============================================================================
echo.
echo.  [1]  Microsoft Office Access 2016
echo.
echo.  [2]  Microsoft Office Excel 2016
echo.
echo.  [3]  Microsoft Office Outlook 2016
echo.
echo.  [4]  Microsoft Office PowerPoint 2016
echo.
echo.  [5]  Microsoft Office Publisher 2016
echo.
echo.  [6]  Microsoft Office Word 2016
echo.
echo.
echo.  [A]  All Apps
echo.
echo.  [X]  Go Back
echo.
echo.===============================================================================
echo.
choice /C:123456AX /N /M "Enter Your Choice : "

if errorlevel 8 goto :IntFeatures
if errorlevel 7 set "OfficeUWPApp=AllOfficeApps"
if errorlevel 6 set "OfficeUWPApp=OfficeWord"
if errorlevel 5 set "OfficeUWPApp=OfficePublisher"
if errorlevel 4 set "OfficeUWPApp=OfficePowerPoint"
if errorlevel 3 set "OfficeUWPApp=OfficeOutlook"
if errorlevel 2 set "OfficeUWPApp=OfficeExcel"
if errorlevel 1 set "OfficeUWPApp=OfficeAccess"

:: Getting Install Image Index Architecture
if "%ImageIndexNo%" equ "*" call :GetImageArchitecture "%InstallWim%", 1 >nul
if "%ImageIndexNo%" neq "*" call :GetImageArchitecture "%InstallWim%", %ImageIndexNo% >nul

:: Getting Microsoft Office Desktop (UWP) Apps files full pathnames
cd /d "%OfficeUWP%\"

for /f %%i IN ('"dir /b *Microsoft.Office.Desktop_*.appxbundle" 2^>nul') do if exist %%i set "OfficeDesktop_Appx=%OfficeUWP%\%%i"
for /f %%i IN ('"dir /b *Microsoft.Office.Desktop.Access_*.appxbundle" 2^>nul') do if exist %%i set "OfficeAccess_Appx=%OfficeUWP%\%%i"
for /f %%i IN ('"dir /b *Microsoft.Office.Desktop.Excel_*.appxbundle" 2^>nul') do if exist %%i set "OfficeExcel_Appx=%OfficeUWP%\%%i"
for /f %%i IN ('"dir /b *Microsoft.Office.Desktop.Outlook_*.appxbundle" 2^>nul') do if exist %%i set "OfficeOutlook_Appx=%OfficeUWP%\%%i"
for /f %%i IN ('"dir /b *Microsoft.Office.Desktop.PowerPoint*.appxbundle" 2^>nul') do if exist %%i set "OfficePowerPoint_Appx=%OfficeUWP%\%%i"
for /f %%i IN ('"dir /b *Microsoft.Office.Desktop.Publisher_*.appxbundle" 2^>nul') do if exist %%i set "OfficePublisher_Appx=%OfficeUWP%\%%i"
for /f %%i IN ('"dir /b *Microsoft.Office.Desktop.Word_*.appxbundle" 2^>nul') do if exist %%i set "OfficeWord_Appx=%OfficeUWP%\%%i"

for /f %%i IN ('"dir /b *Microsoft.Office.Desktop_*.xml" 2^>nul') do if exist %%i set "OfficeDesktop_License=%OfficeUWP%\%%i"
for /f %%i IN ('"dir /b *Microsoft.Office.Desktop.Access_*.xml" 2^>nul') do if exist %%i set "OfficeAccess_License=%OfficeUWP%\%%i"
for /f %%i IN ('"dir /b *Microsoft.Office.Desktop.Excel_*.xml" 2^>nul') do if exist %%i set "OfficeExcel_License=%OfficeUWP%\%%i"
for /f %%i IN ('"dir /b *Microsoft.Office.Desktop.Outlook_*.xml" 2^>nul') do if exist %%i set "OfficeOutlook_License=%OfficeUWP%\%%i"
for /f %%i IN ('"dir /b *Microsoft.Office.Desktop.PowerPoint_*.xml" 2^>nul') do if exist %%i set "OfficePowerPoint_License=%OfficeUWP%\%%i"
for /f %%i IN ('"dir /b *Microsoft.Office.Desktop.Publisher_*.xml" 2^>nul') do if exist %%i set "OfficePublisher_License=%OfficeUWP%\%%i"
for /f %%i IN ('"dir /b *Microsoft.Office.Desktop.Word_*.xml" 2^>nul') do if exist %%i set "OfficeWord_License=%OfficeUWP%\%%i"

cd /d "%ROOT%\"

cls
echo.===============================================================================
echo.         MSMG ToolKit - Integrate Microsoft Office Desktop ^(UWP^) Apps
echo.===============================================================================
echo.
echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Microsoft Office Desktop ^(UWP^) Apps###################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if "%ImageIndexNo%" equ "*" echo.    Image Indexes            : 1-%ImageCount%
if "%ImageIndexNo%" neq "*" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
if "%ImageIndexNo%" neq "*" echo.    Image Edition            : %ImageEdition%
echo.    Image Default Language   : %ImageDefaultLanguage%
echo.
echo.-------------------------------------------------------------------------------
if "%OfficeUWPApp%" equ "AllOfficeApps"	echo.####Integrating Microsoft Office Desktop ^(UWP^) Apps############################
if "%OfficeUWPApp%" equ "OfficeAccess" echo.####Integrating Microsoft Office Desktop - Access ^(UWP^) Apps###################
if "%OfficeUWPApp%" equ "OfficeExcel" echo.####Integrating Microsoft Office Desktop - Excel ^(UWP^) Apps####################
if "%OfficeUWPApp%" equ "OfficeOutlook" echo.####Integrating Microsoft Office Desktop - Outlook ^(UWP^) Apps##################
if "%OfficeUWPApp%" equ "OfficePowerPoint" echo.####Integrating Microsoft Office Desktop - PowerPoint ^(UWP^) Apps###############
if "%OfficeUWPApp%" equ "OfficePublisher" echo.####Integrating Microsoft Office Desktop - Publisher ^(UWP^) Apps################
if "%OfficeUWPApp%" equ "OfficeWord" echo.####Integrating Microsoft Office Desktop - Word ^(UWP^) Apps#####################
echo.-------------------------------------------------------------------------------
if "%ImageIndexNo%" equ "*" (
	for /L %%i in (1, 1, %ImageCount%) do (
		echo.
		if not %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]#############################
		if %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]############################
		
		if "%OfficeUWPApp%" equ "OfficeAccess" %DISM% /Image:"%InstallMount%\%%i" /Add-ProvisionedAppxPackage /PackagePath:%OfficeDesktop_Appx% /OptionalPackagePath=%OfficeAccess_Appx% /LicensePath:%OfficeDesktop_License% /LicensePath:%OfficeAccess_License%
		if "%OfficeUWPApp%" equ "OfficeExcel" %DISM% /Image:"%InstallMount%\%%i" /Add-ProvisionedAppxPackage /PackagePath:%OfficeDesktop_Appx% /OptionalPackagePath=%OfficeExcel_Appx% /LicensePath:%OfficeDesktop_License% /LicensePath:%OfficeExcel_License%
		if "%OfficeUWPApp%" equ "OfficeOutlook" %DISM% /Image:"%InstallMount%\%%i" /Add-ProvisionedAppxPackage /PackagePath:%OfficeDesktop_Appx% /OptionalPackagePath=%OfficeOutlook_Appx% /LicensePath:%OfficeDesktop_License% /LicensePath:%OfficeOutlook_License%
		if "%OfficeUWPApp%" equ "OfficePowerPoint" %DISM% /Image:"%InstallMount%\%%i" /Add-ProvisionedAppxPackage /PackagePath:%OfficeDesktop_Appx% /OptionalPackagePath=%OfficePowerPoint_Appx% /LicensePath:%OfficeDesktop_License% /LicensePath:%OfficePowerPoint_License%
		if "%OfficeUWPApp%" equ "OfficePublisher" %DISM% /Image:"%InstallMount%\%%i" /Add-ProvisionedAppxPackage /PackagePath:%OfficeDesktop_Appx% /OptionalPackagePath=%OfficePublisher_Appx% /LicensePath:%OfficeDesktop_License% /LicensePath:%OfficePublisher_License%
		if "%OfficeUWPApp%" equ "OfficeWord" %DISM% /Image:"%InstallMount%\%%i" /Add-ProvisionedAppxPackage /PackagePath:%OfficeDesktop_Appx% /OptionalPackagePath=%OfficeWord_Appx% /LicensePath:%OfficeDesktop_License% /LicensePath:%OfficeWord_License%
		if "%OfficeUWPApp%" equ "AllOfficeApps"	%DISM% /Image:"%InstallMount%\%%i" /Add-ProvisionedAppxPackage /PackagePath:%OfficeDesktop_Appx% /OptionalPackagePath=%OfficeAccess_Appx% /OptionalPackagePath=%OfficeExcel_Appx% /OptionalPackagePath=%OfficeOutlook_Appx% /OptionalPackagePath=%OfficePowerPoint_Appx% /OptionalPackagePath=%OfficePublisher_Appx% /OptionalPackagePath=%OfficeWord_Appx% /LicensePath:%OfficeDesktop_License% /LicensePath:%OfficeAccess_License% /LicensePath:%OfficeExcel_License% /LicensePath:%OfficeOutlook_License% /LicensePath:%OfficePowerPoint_License% /LicensePath:%OfficePublisher_License% /LicensePath:%OfficeWord_License%
	) 
) else (
	if "%OfficeUWPApp%" equ "OfficeAccess" %DISM% /Image:"%InstallMount%" /Add-ProvisionedAppxPackage /PackagePath:%OfficeDesktop_Appx% /OptionalPackagePath=%OfficeAccess_Appx% /LicensePath:%OfficeDesktop_License% /LicensePath:%OfficeAccess_License%
	if "%OfficeUWPApp%" equ "OfficeExcel" %DISM% /Image:"%InstallMount%" /Add-ProvisionedAppxPackage /PackagePath:%OfficeDesktop_Appx% /OptionalPackagePath=%OfficeExcel_Appx% /LicensePath:%OfficeDesktop_License% /LicensePath:%OfficeExcel_License%
	if "%OfficeUWPApp%" equ "OfficeOutlook" %DISM% /Image:"%InstallMount%" /Add-ProvisionedAppxPackage /PackagePath:%OfficeDesktop_Appx% /OptionalPackagePath=%OfficeOutlook_Appx% /LicensePath:%OfficeDesktop_License% /LicensePath:%OfficeOutlook_License%
	if "%OfficeUWPApp%" equ "OfficePowerPoint" %DISM% /Image:"%InstallMount%" /Add-ProvisionedAppxPackage /PackagePath:%OfficeDesktop_Appx% /OptionalPackagePath=%OfficePowerPoint_Appx% /LicensePath:%OfficeDesktop_License% /LicensePath:%OfficePowerPoint_License%
	if "%OfficeUWPApp%" equ "OfficePublisher" %DISM% /Image:"%InstallMount%" /Add-ProvisionedAppxPackage /PackagePath:%OfficeDesktop_Appx% /OptionalPackagePath=%OfficePublisher_Appx% /LicensePath:%OfficeDesktop_License% /LicensePath:%OfficePublisher_License%
	if "%OfficeUWPApp%" equ "OfficeWord" %DISM% /Image:"%InstallMount%" /Add-ProvisionedAppxPackage /PackagePath:%OfficeDesktop_Appx% /OptionalPackagePath=%OfficeWord_Appx% /LicensePath:%OfficeDesktop_License% /LicensePath:%OfficeWord_License%
	if "%OfficeUWPApp%" equ "AllOfficeApps"	%DISM% /Image:"%InstallMount%" /Add-ProvisionedAppxPackage /PackagePath:%OfficeDesktop_Appx% /OptionalPackagePath=%OfficeAccess_Appx% /OptionalPackagePath=%OfficeExcel_Appx% /OptionalPackagePath=%OfficeOutlook_Appx% /OptionalPackagePath=%OfficePowerPoint_Appx% /OptionalPackagePath=%OfficePublisher_Appx% /OptionalPackagePath=%OfficeWord_Appx% /LicensePath:%OfficeDesktop_License% /LicensePath:%OfficeAccess_License% /LicensePath:%OfficeExcel_License% /LicensePath:%OfficeOutlook_License% /LicensePath:%OfficePowerPoint_License% /LicensePath:%OfficePublisher_License% /LicensePath:%OfficeWord_License%
)
echo.
echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Microsoft Office Desktop ^(UWP^) Apps###################
echo.-------------------------------------------------------------------------------
echo.
:Stop
echo.===============================================================================
echo.
pause

set OfficeUWPApp=
set OfficeDesktop_Appx=
set OfficeAccess_Appx=
set OfficeExcel_Appx=
set OfficeOutlook_Appx=
set OfficePowerPoint_Appx=
set OfficePublisher_Appx=
set OfficeWord_Appx=

set OfficeDesktop_License=
set OfficeAccess_License=
set OfficeExcel_License=
set OfficeOutlook_License=
set OfficePowerPoint_License=
set OfficePublisher_License=
set OfficeWord_License=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Windows Thin PC Add-on Features
::-------------------------------------------------------------------------------------------
:IntThinPcPkgs

if "%IsDialogsEnabled%" equ "Yes" (
	cls
	echo.===============================================================================
	echo.            MSMG ToolKit - Integrate Windows Thin PC Add-on Features
	echo.===============================================================================
	echo.
	echo.
	echo.
	echo.                              W A R N I N G
	echo.                              =============
	echo.
	echo.  Do not integrate any updates before integrating a language pack or
	echo.  any windows features. If you integrate any updates ^(Hotfix, General 
	echo.  Distribution Release [GDR], Zero-Day Patch [ZDP] or Service Pack [SP]^)
	echo.  that contains language/feature-dependent resources before you integrate
	echo.  any updates, The language/feature-specific changes that are contained 
	echo.  in the updates are not applied and you will have to re-integrate the 
	echo.  udates. Always integrate language packs/qindows features before you 
	echo.  install updates. 
	echo.
	echo.
	echo.  To turn off Warning Dialogs, Choose Disable Dialogs in Tools-^>Options Menu
	echo.
	echo.===============================================================================
	echo.
	choice /C:YN /N /M "Do you want to Continue ? ['Y'es/'N'o] : "
	if errorlevel 2 goto :IntegrateMenu
)

setlocal

set Feature=

cls
echo.===============================================================================
echo.          MSMG ToolKit - Integrate Windows Thin PC Add-on Features
echo.===============================================================================

:: Checking whether Multi-Index servicing mode is selected
if "%ImageIndexNo%" equ "*" (
	echo.This feature is not available when Multi-Index servicing mode is enabled...
	echo.
	echo.Please Re-Choose source with a Single Index...
	goto :Stop
)

:: Checking whether the selected Source OS is a Windows Thin PC OS
if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType%" neq "Embedded" (
	echo.Selected Source OS is not a Windows Thin PC OS..
	echo.
	echo.Please use Windows Thin PC Source OS..
	goto :Stop
)

echo.  [A]  Microsoft .NET Framework 3.5 with Client Profile
echo.  [B]  Windows Backup ^& Restore
echo.  [C]  Windows Basic Help
echo.  [D]  Windows Defender
echo.  [E]  Windows DVD Maker
echo.  [F]  Windows Fax ^& Scan
echo.  [G]  Windows ISO Burner
echo.  [H]  Windows Media Center
echo.  [I]  Windows Media Player Premium Codecs
echo.  [J]  Windows Mobility Center
echo.  [K]  Windows Parental Control
echo.  [L]  Windows Photo Viewer
echo.  [M]  Windows Search
echo.  [N]  Windows Speech ^& Text with Speech US English Pack
echo.  [O]  Windows Tablet PC Support
echo.
echo.  [1]  All Features
echo.
echo.  [X]  Go Back
echo.===============================================================================
choice /C:ABCDEFGHIJKLMNo1X /N /M "Enter your choice : "
if errorlevel 17 goto :IntegrateMenu
if errorlevel 16 set "Feature=All"
if errorlevel 15 set "Feature=TabletPC"
if errorlevel 14 set "Feature=SpeechText"
if errorlevel 13 set "Feature=Search"
if errorlevel 12 set "Feature=PhotoViewer"
if errorlevel 11 set "Feature=ParentalControl"
if errorlevel 10 set "Feature=MobilityCenter"
if errorlevel 9  set "Feature=PremiumCodecs"
if errorlevel 8  set "Feature=MediaCenter"
if errorlevel 7  set "Feature=ISOBurner"
if errorlevel 6  set "Feature=FaxScan"
if errorlevel 5  set "Feature=DVDMaker"
if errorlevel 4  set "Feature=Defender"
if errorlevel 3  set "Feature=BasicHelp"
if errorlevel 2  set "Feature=BackupRestore"
if errorlevel 1  set "Feature=NetFx35"

cls
echo.===============================================================================
if "%Feature%" equ "NetFx35" echo.     MSMG ToolKit - Integrate Microsoft .NET Framework 3.5 Add-on Feature
if "%Feature%" equ "BackupRestore" echo.       MSMG ToolKit - Integrate Windows Backup ^& Restore Add-on Feature
if "%Feature%" equ "BasicHelp" echo.         MSMG ToolKit - Integrate Windows Basic Help Add-on Feature
if "%Feature%" equ "Defender" echo.          MSMG ToolKit - Integrate Windows Defender Add-on Feature
if "%Feature%" equ "DVDMaker" echo.          MSMG ToolKit - Integrate Windows DVD Maker Add-on Feature
if "%Feature%" equ "FaxScan" echo.           MSMG ToolKit - Integrate Windows Fax ^& Scan Add-on Feature
if "%Feature%" equ "ISOBurner" echo.          MSMG ToolKit - Integrate Windows ISO Burner Add-on Feature
if "%Feature%" equ "MediaCenter" echo.        MSMG ToolKit - Integrate Windows Media Center Add-on Feature
if "%Feature%" equ "PremiumCodecs" echo.     MSMG ToolKit - Integrate Windows Media Player Premium Codecs Features
if "%Feature%" equ "MobilityCenter" echo.        MSMG ToolKit - Integrate Windows Mobility Center Add-on Feature
if "%Feature%" equ "ParentalControl" echo.       MSMG ToolKit - Integrate Windows Parental Control Add-on Feature
if "%Feature%" equ "PhotoViewer" echo.          MSMG ToolKit - Integrate Windows Photo Viewer Add-on Feature
if "%Feature%" equ "Search" echo.             MSMG ToolKit - Integrate Windows Search Add-on Feature
if "%Feature%" equ "SpeechText" echo.        MSMG ToolKit - Integrate Windows Speech ^& Text Add-on Feature
if "%Feature%" equ "TabletPC" echo.          MSMG ToolKit - Integrate Windows Tablet PC Add-on Feature
if "%Feature%" equ "All" echo.            MSMG ToolKit - Integrate Windows Thin PC Add-on Features
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
call :GetImageArchitecture "%InstallWim%", %ImageIndexNo% >nul

:: Checking whether Windows Thin PC Add-on Features folder is empty
if not exist "%ThinPC%\*.*" (
	echo.Windows Thin PC Add-on Features folder ^<Packs\ThinPC^> is empty...
	echo.
	echo.Please copy Windows Thin PC Add-on Features files to respective folder...
	goto :Stop
)

echo.-------------------------------------------------------------------------------
if "%Feature%" equ "NetFx35" echo.####Starting Integrating Microsoft .NET Framework 3.5 Add-on Feature###########
if "%Feature%" equ "BackupRestore" echo.####Starting Integrating Windows Backup ^& Restore Add-on Feature################
if "%Feature%" equ "BasicHelp" echo.####Starting Integrating Windows Basic Help Add-on Feature#####################
if "%Feature%" equ "Defender" echo.####Starting Integrating Windows Defender Add-on Feature#######################
if "%Feature%" equ "DVDMaker" echo.####Starting Integrating Windows DVD Maker Add-on Feature######################
if "%Feature%" equ "FaxScan" echo.####Starting Integrating Windows Fax ^& Scan Add-on Feature#####################
if "%Feature%" equ "ISOBurner" echo.####Starting Integrating Windows ISO Burner Add-on Feature#####################
if "%Feature%" equ "MediaCenter" echo.####Starting Integrating Windows Media Center Add-on Feature###################
if "%Feature%" equ "PremiumCodecs" echo.####Starting Integrating Windows Media Player Premium Codecs Features##########
if "%Feature%" equ "MobilityCenter" echo.####Starting Integrating Windows Mobility Center Add-on Feature################
if "%Feature%" equ "ParentalControl" echo.####Starting Integrating Windows Parental Control Add-on Feature###############
if "%Feature%" equ "PhotoViewer" echo.####Starting Integrating Windows Photo Viewer Add-on Feature###################
if "%Feature%" equ "Search" echo.####Starting Integrating Windows Search Add-on Feature#########################
if "%Feature%" equ "SpeechText" echo.####Starting Integrating Windows Speech ^& Text Add-on Feature##################
if "%Feature%" equ "TabletPC" echo.####Starting Integrating Windows Tablet PC Add-on Feature######################
if "%Feature%" equ "All" echo.####Starting Integrating Windows Thin PC Add-on Features#######################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.    Image Edition            : %ImageEdition%
echo.    Image Default Language   : %ImageDefaultLanguage%
echo.
echo.-------------------------------------------------------------------------------
if "%Feature%" equ "NetFx35" echo.####Integrating Microsoft .NET Framework 3.5 Add-on Feature####################
if "%Feature%" equ "BackupRestore" echo.####Integrating Windows Backup ^& Restore Add-on Feature#######################
if "%Feature%" equ "BasicHelp" echo.####Integrating Windows Basic Help Add-on Feature##############################
if "%Feature%" equ "Defender" echo.####Integrating Windows Defender Add-on Feature################################
if "%Feature%" equ "DVDMaker" echo.####Integrating Windows DVD Maker Add-on Feature###############################
if "%Feature%" equ "FaxScan" echo.####Integrating Windows Fax ^& Scan Add-on Feature##############################
if "%Feature%" equ "ISOBurner" echo.####Integrating Windows ISO Burner Add-on Feature##############################
if "%Feature%" equ "MediaCenter" echo.####Integrating Windows Media Center Add-on Feature############################
if "%Feature%" equ "PremiumCodecs" echo.####Integrating Windows Media Player Premium Codecs Features###################
if "%Feature%" equ "MobilityCenter" echo.####Integrating Windows Mobility Center Add-on Feature#########################
if "%Feature%" equ "ParentalControl" echo.####Integrating Windows Parental Control Add-on Feature########################
if "%Feature%" equ "PhotoViewer" echo.####Integrating Windows Photo Viewer Add-on Feature############################
if "%Feature%" equ "Search" echo.####Integrating Windows Search Add-on Feature##################################
if "%Feature%" equ "SpeechText" echo.####Integrating Windows Speech ^& Text Add-on Feature###########################
if "%Feature%" equ "TabletPC" echo.####Integrating Windows Tablet PC Add-on Feature###############################
if "%Feature%" equ "All" echo.####Integrating Windows Thin PC Add-on Features################################
echo.-------------------------------------------------------------------------------
if "%Feature%" equ "NetFx35" (
	echo.
	echo.-------------------------------------------------------------------------------
	echo.Integrating Microsoft IIS Windows Process Activation Service Package...
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%ThinPC%\WinEmb-IIS-WAS~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating Microsoft .NET Framework 3.0 Package...
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%ThinPC%\WinEmb-NetFx30~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating Microsoft .NET Framework 3.0 Client Profile Package...
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%ThinPC%\WinEmb-NetFx30Client~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating Microsoft .NET Framework 3.5 Package...
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%ThinPC%\WinEmb-NetFx35~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating Microsoft .NET Framework 3.5 Client Profile Package...
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%ThinPC%\WinEmb-NetFx35Client~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
)
if "%Feature%" equ "BackupRestore" call :AddPackage "%InstallMount%", "%ThinPC%\WinEmb-BackupRestore~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
if "%Feature%" equ "BasicHelp" call :AddPackage "%InstallMount%", "%ThinPC%\WinEmb-HelpEngine~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
if "%Feature%" equ "Defender" call :AddPackage "%InstallMount%", "%ThinPC%\WinEmb-AntiMalware~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
if "%Feature%" equ "DVDMaker" (
	echo.
	echo.-------------------------------------------------------------------------------
	echo.Integrating Windows DVD Maker Package...
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%ThinPC%\WinEmb-DVDBurning~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating Windows ISO Burner Package...
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%ThinPC%\WinEmb-IMAPIv2~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
)
if "%Feature%" equ "FaxScan" call :AddPackage "%InstallMount%", "%ThinPC%\WinEmb-Fax-Scan~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
if "%Feature%" equ "ISOBurner" call :AddPackage "%InstallMount%", "%ThinPC%\WinEmb-IMAPIv2~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
if "%Feature%" equ "MediaCenter" call :AddPackage "%InstallMount%", "%ThinPC%\WinEmb-MediaCenter~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
if "%Feature%" equ "PremiumCodecs" (
	echo.
	echo.-------------------------------------------------------------------------------
	echo.Integrating Windows Media Player DOLBY AC3 Audio Encoder Premium Codec Package
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%ThinPC%\WinEmb-PremiumCodecs-DOLBY-AC3-AudioEncoder~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating Windows Media Player MPEG2 Decoder Premium Codec Package...
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%ThinPC%\WinEmb-PremiumCodecs-MPEG2-Decoder~31bf3856ad364e35~x86~~6.1.7600.16385.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating Windows Media Player MPEG2 Encoder Premium Codec Package...
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%ThinPC%\WinEmb-PremiumCodecs-MPEG2-Encoder~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating Windows Media Player MPEG2 ^& Dolby Decoder Premium Codec Package..
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%ThinPC%\WinEmb-PremiumCodecs-MPEG2andDolbyDecoder~31bf3856ad364e35~x86~~6.1.7600.16385.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating Windows Media Player MPEG3 Premium Codec Package...
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%ThinPC%\WinEmb-PremiumCodecs-MPEG3~31bf3856ad364e35~x86~~6.1.7600.16385.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating Windows Media Player MPEG4 Premium Codec Package...
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%ThinPC%\WinEmb-PremiumCodecs-MPEG4~31bf3856ad364e35~x86~~6.1.7600.16385.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating Windows Media Player WMV Premium Codec Package...
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%ThinPC%\WinEmb-PremiumCodecs-WMV~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
)
if "%Feature%" equ "MobilityCenter" call :AddPackage "%InstallMount%", "%ThinPC%\WinEmb-MobilePC~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
if "%Feature%" equ "ParentalControl" call :AddPackage "%InstallMount%", "%ThinPC%\WinEmb-ParentalControl~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
if "%Feature%" equ "PhotoViewer" call :AddPackage "%InstallMount%", "%ThinPC%\WinEmb-Photos-Viewer~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
if "%Feature%" equ "Search" (
	echo.
	echo.-------------------------------------------------------------------------------
	echo.Integrating Windows Natural Language Package...
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%ThinPC%\WinEmb-Natural-Language~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating Windows Search Package...
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%ThinPC%\WinEmb-Search~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
)
if "%Feature%" equ "SpeechText" (
	echo.
	echo.-------------------------------------------------------------------------------
	echo.Integrating Windows Speech ^& Text US English Language Pack Package...
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%ThinPC%\WinEmb-Speech-LP-ENG~31bf3856ad364e35~x86~~6.1.7600.16385.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating Windows Speech ^& Text Package...
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%ThinPC%\WinEmb-Speech~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
)
if "%Feature%" equ "TabletPC" call :AddPackage "%InstallMount%", "%ThinPC%\WinEmb-Tablet~31bf3856ad364e35~x86~~6.1.7601.17514.cab"

if "%Feature%" equ "All" (
	echo.
	echo.-------------------------------------------------------------------------------
	echo.Integrating Microsoft IIS Windows Process Activation Service Package...
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%ThinPC%\WinEmb-IIS-WAS~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating Microsoft .NET Framework 3.0 Package...
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%ThinPC%\WinEmb-NetFx30~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating Microsoft .NET Framework 3.0 Client Profile Package...
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%ThinPC%\WinEmb-NetFx30Client~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating Microsoft .NET Framework 3.5 Package...
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%ThinPC%\WinEmb-NetFx35~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating Microsoft .NET Framework 3.5 Client Profile Package...
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%ThinPC%\WinEmb-NetFx35Client~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating Windows Backup ^& Restore Package...
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%ThinPC%\WinEmb-BackupRestore~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating Windows Basic Help Package...
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%ThinPC%\WinEmb-HelpEngine~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating Windows Defender Package...
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%ThinPC%\WinEmb-AntiMalware~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating Windows DVD Maker Package...
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%ThinPC%\WinEmb-DVDBurning~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating Windows Fax ^& Scan Feature...
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%ThinPC%\WinEmb-Fax-Scan~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating Windows ISO Burner Package...
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%ThinPC%\WinEmb-IMAPIv2~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating Windows Media Center Feature...
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%ThinPC%\WinEmb-MediaCenter~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating Windows Media Player DOLBY AC3 Audio Encoder Premium Codec Package
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%ThinPC%\WinEmb-PremiumCodecs-DOLBY-AC3-AudioEncoder~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating Windows Media Player MPEG2 Decoder Premium Codec Package...
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%ThinPC%\WinEmb-PremiumCodecs-MPEG2-Decoder~31bf3856ad364e35~x86~~6.1.7600.16385.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating Windows Media Player MPEG2 Encoder Premium Codec Package...
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%ThinPC%\WinEmb-PremiumCodecs-MPEG2-Encoder~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating Windows Media Player MPEG2 ^& Dolby Decoder Premium Codec Package..
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%ThinPC%\WinEmb-PremiumCodecs-MPEG2andDolbyDecoder~31bf3856ad364e35~x86~~6.1.7600.16385.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating Windows Media Player MPEG3 Premium Codec Package...
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%ThinPC%\WinEmb-PremiumCodecs-MPEG3~31bf3856ad364e35~x86~~6.1.7600.16385.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating Windows Media Player MPEG4 Premium Codec Package...
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%ThinPC%\WinEmb-PremiumCodecs-MPEG4~31bf3856ad364e35~x86~~6.1.7600.16385.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating Windows Media Player WMV Premium Codec Package...
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%ThinPC%\WinEmb-PremiumCodecs-WMV~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating Windows Mobility Center Feature...
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%ThinPC%\WinEmb-MobilePC~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating Windows Parental Control Feature...
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%ThinPC%\WinEmb-ParentalControl~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating Windows Photo Viewer Feature...
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%ThinPC%\WinEmb-Photos-Viewer~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating Windows Natural Language Package...
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%ThinPC%\WinEmb-Natural-Language~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating Windows Search Package...
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%ThinPC%\WinEmb-Search~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating Windows Speech ^& Text US English Language Pack Package...
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%ThinPC%\WinEmb-Speech-LP-ENG~31bf3856ad364e35~x86~~6.1.7600.16385.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating Windows Speech ^& Text Package...
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%ThinPC%\WinEmb-Speech~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating Windows Tablet PC Support Feature...
	echo.-------------------------------------------------------------------------------
	call :AddPackage "%InstallMount%", "%ThinPC%\WinEmb-Tablet~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
)

if "%IsLogsEnabled%" equ "Yes" (
	echo.-------------------------------------------------------------------------------
	if "%Feature%" equ "NetFx35" echo.####Generating Microsoft .NET Framework 3.5 Add-on Feature Integration Log#####
	if "%Feature%" equ "BackupRestore" echo.####Generating Windows Backup ^& Restore Add-on Feature Integration Log#########
	if "%Feature%" equ "BasicHelp" echo.####Generating Windows Basic Help Add-on Feature Integration Log###############
	if "%Feature%" equ "Defender" echo.####Generating Windows Defender Add-on Feature Integration Log#################
	if "%Feature%" equ "DVDMaker" echo.####Generating Windows DVD Maker Add-on Feature Integration Log################
	if "%Feature%" equ "FaxScan" echo.####Generating Windows Fax ^& Scan Add-on Feature Integration Log###############
	if "%Feature%" equ "ISOBurner" echo.####Generating Windows ISO Burner Add-on Feature Integration Log###############
	if "%Feature%" equ "MediaCenter" echo.####Generating Windows Media Center Add-on Feature Integration Log#############
	if "%Feature%" equ "PremiumCodecs" echo.####Generating Windows Media Player Premium Codecs Features Integration Log####
	if "%Feature%" equ "MobilityCenter" echo.####Generating Windows Mobility Center Add-on Feature Integration Log##########
	if "%Feature%" equ "ParentalControl" echo.####Generating Windows Parental Control Add-on Feature Integration Log#########
	if "%Feature%" equ "PhotoViewer" echo.####Generating Windows Photo Viewer Add-on Feature Integration Log#############
	if "%Feature%" equ "Search" echo.####Generating Windows Search Add-on Feature Integration Log###################
	if "%Feature%" equ "SpeechText" echo.####Generating Windows Speech ^& Text Add-on Feature Integration Log############
	if "%Feature%" equ "TabletPC" echo.####Generating Windows Tablet PC Add-on Feature Integration Log################
	if "%Feature%" equ "All" echo.####Generating Thin PC Add-on Features Integration Log#########################
	echo.-------------------------------------------------------------------------------
	echo.
	echo.Writing Thin PC Add-on Features ^<Logs\ThinPC.txt^> Log file...
	call :GetPackages "%InstallMount%", "ThinPC.txt"
	echo.
)
echo.-------------------------------------------------------------------------------
if "%Feature%" equ "NetFx35" echo.####Finished Integrating Microsoft .NET Framework 3.5 Add-on Feature###########
if "%Feature%" equ "BackupRestore" echo.####Finished Integrating Windows Backup ^& Restore Add-on Feature###############
if "%Feature%" equ "BasicHelp" echo.####Finished Integrating Windows Basic Help Add-on Feature#####################
if "%Feature%" equ "Defender" echo.####Finished Integrating Windows Defender Add-on Feature#######################
if "%Feature%" equ "DVDMaker" echo.####Finished Integrating Windows DVD Maker Add-on Feature######################
if "%Feature%" equ "FaxScan" echo.####Finished Integrating Windows Fax ^& Scan Add-on Feature#####################
if "%Feature%" equ "ISOBurner" echo.####Finished Integrating Windows ISO Burner Add-on Feature#####################
if "%Feature%" equ "MediaCenter" echo.####Finished Integrating Windows Media Center Add-on Feature###################
if "%Feature%" equ "PremiumCodecs" echo.####Finished Integrating Windows Media Player Premium Codecs Features##########
if "%Feature%" equ "MobilityCenter" echo.####Finished Integrating Windows Mobility Center Add-on Feature################
if "%Feature%" equ "ParentalControl" echo.####Finished Integrating Windows Parental Control Add-on Feature###############
if "%Feature%" equ "PhotoViewer" echo.####Finished Integrating Windows Photo Viewer Add-on Feature###################
if "%Feature%" equ "Search" echo.####Finished Integrating Windows Search Add-on Feature#########################
if "%Feature%" equ "SpeechText" echo.####Finished Integrating Windows Speech ^& Text Add-on Feature##################
if "%Feature%" equ "TabletPC" echo.####Finished Integrating Windows Tablet PC Add-on Feature######################
if "%Feature%" equ "All" echo.####Finished Integrating Windows Thin PC Add-on Features#######################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set Feature=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Microsoft Diagnostics and Recovery Toolset ^(DaRT^) 7.0/8.1/10
::-------------------------------------------------------------------------------------------
:IntDaRT

if "%SelectedSourceOS%" neq "w7" (
	cls
	echo.===============================================================================
	if "%SelectedSourceOS%" equ "w81" echo.              MSMG ToolKit - Integrate Microsoft DaRT 8.1 Tools
	if "%SelectedSourceOS%" equ "w10" echo.               MSMG ToolKit - Integrate Microsoft DaRT 10 Tools
	echo.===============================================================================
	echo.
	echo.
	echo.
	echo.                              W A R N I N G
	echo.                              =============
	echo.
	echo. Microsoft DaRT 8.1/10 Tools includes functionality that lets an administrator
	echo. or a help desk worker run the DaRT tools remotely to resolve problems on an
	echo. end-user computer. In addition, you can save the International Organization
	echo. for Standardization ^(ISO^) image to a USB flash drive or put the ISO image on
	echo. a network to include its contents as a recovery partition on a computer's
	echo. hard disk. These capabilities provide flexibility, but also create potential
	echo. security risks that you should consider when configuring DaRT.
	echo.  	
	echo.
	echo.
	echo. To turn off Warning Dialogs, Choose Disable Dialogs in Tools-^>Options Menu
	echo.
	echo.===============================================================================
	echo.
	choice /C:YN /N /M "Do you want to Continue ? ['Y'es/'N'o] : "
	if errorlevel 2 goto :MainMenu
)

setlocal

set DartType=
set PackageLanguage=
set DebugTools=

cls
echo.===============================================================================
if "%SelectedSourceOS%" equ "w7" echo.              MSMG ToolKit - Integrate Microsoft DaRT 7.0 Tools
if "%SelectedSourceOS%" equ "w81" echo.              MSMG ToolKit - Integrate Microsoft DaRT 8.1 Tools
if "%SelectedSourceOS%" equ "w10" echo.               MSMG ToolKit - Integrate Microsoft DaRT 10 Tools
echo.===============================================================================
echo.
:: Checking whether the selected Source OS is a Windows 7 Thin PC
if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType%" equ "Embedded" (
	:: Checking whether the Source Boot Image is selected
	if "%IsBootImageSelected%" equ "No" (
		echo.Windows Setup Boot Image is not selected...
		echo.
		echo.Please choose Windows Setup Boot Image while selecting Source...
		goto :Stop	
	)
	
	:: Setting Package Language
	for /d %%i in (ar-SA,bg-BG,cs-CZ,da-DK,el-GR,en-GB,en-US,et-EE,fi-FI,he-IL,hr-HR,hu-HU,lt-LT,lv-LV,nb-NO,nl-NL,pl-PL,ro-RO,sk-SK,sl-SI,sr-Latn-CS,sr-Latn-RS,sv-SE,th-TH,tr-TR,uk-UA) do (
		if "%ImageDefaultLanguage%" equ "%%i" set "PackageLanguage=en-US"
	)

	if "%ImageDefaultLanguage%" equ "de-DE" set "PackageLanguage=de-DE"
	if "%ImageDefaultLanguage%" equ "es-ES" set "PackageLanguage=es-ES"
	if "%ImageDefaultLanguage%" equ "fr-FR" set "PackageLanguage=fr-FR"
	if "%ImageDefaultLanguage%" equ "it-IT" set "PackageLanguage=it-IT"
	if "%ImageDefaultLanguage%" equ "ja-JP" set "PackageLanguage=ja-JP"
	if "%ImageDefaultLanguage%" equ "ko-KR" set "PackageLanguage=ko-KR"
	if "%ImageDefaultLanguage%" equ "pt-BR" set "PackageLanguage=pt-BR"
	if "%ImageDefaultLanguage%" equ "ru-RU" set "PackageLanguage=ru-RU"
	if "%ImageDefaultLanguage%" equ "zh-CN" set "PackageLanguage=zh-CN"
	if "%ImageDefaultLanguage%" equ "zh-TW" set "PackageLanguage=zh-TW"
	if "%ImageDefaultLanguage%" equ "es-MX" set "PackageLanguage=es-ES"
	if "%ImageDefaultLanguage%" equ "fr-CA" set "PackageLanguage=fr-FR"
	if "%ImageDefaultLanguage%" equ "pt-PT" set "PackageLanguage=pt-BR"
	if "%ImageDefaultLanguage%" equ "zh-HK" set "PackageLanguage=zh-TW"	
	
	:: Setting Microsoft DaRT Tools Pack folder path
	set "DaRT=%DaRT%\%SelectedSourceOS%"
	
	:: Checking whether Microsoft DaRT 7 Tools Base Package file exist
	if not exist "%DaRT%\DaRT.tpk" (
		echo.Microsoft DaRT 7 Tools Pack file "DaRT.tpk" not found...
		echo.
		echo.Please copy the above file to ^<Packs\DaRT\%SelectedSourceOS%^> folder...
		goto :Stop
	)

	:: Checking whether Microsoft  DaRT 7 Tools Language Package file exist
	if not exist "%DaRT%\DaRT_%PackageLanguage%.tpk" (
		echo.Microsoft DaRT 7 Tools Pack file "DaRT_%PackageLanguage%.tpk" not found...
		echo.
		echo.Please copy the above file to ^<Packs\DaRT\%SelectedSourceOS%^> folder...
		goto :Stop
	)

	goto :IntDaRTBoot
)

cls
echo.===============================================================================
if "%SelectedSourceOS%" equ "w7" echo.              MSMG ToolKit - Integrate Microsoft DaRT 7.0 Tools
if "%SelectedSourceOS%" equ "w81" echo.              MSMG ToolKit - Integrate Microsoft DaRT 8.1 Tools
if "%SelectedSourceOS%" equ "w10" echo.               MSMG ToolKit - Integrate Microsoft DaRT 10 Tools
echo.===============================================================================
echo.
echo.  [1]  Integrate to Windows Setup Boot Image
echo.
echo.  [2]  Integrate to Windows Recovery Image
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.  [X]  Go Back
echo.
echo.===============================================================================
echo.
choice /C:12X /N /M "Enter Your Choice : "
if errorlevel 3 goto :IntegrateMenu
if errorlevel 2 set "DartType=Recovery"
if errorlevel 1 set "DartType=Boot"

cls
echo.===============================================================================
if "%SelectedSourceOS%" equ "w7" echo.              MSMG ToolKit - Integrate Microsoft DaRT 7.0 Tools
if "%SelectedSourceOS%" equ "w81" echo.              MSMG ToolKit - Integrate Microsoft DaRT 8.1 Tools
if "%SelectedSourceOS%" equ "w10" echo.               MSMG ToolKit - Integrate Microsoft DaRT 10 Tools
echo.===============================================================================
echo.

:: Checking whether the Source Boot Image is selected
if "%DartType%" equ "Boot" if "%IsBootImageSelected%" equ "No" (
	echo.Windows Setup Boot Image is not selected...
	echo.
	echo.Please choose Windows Setup Boot Image while selecting Source...
	goto :Stop	
)

:: Checking whether the Source Recovery Image is selected
if "%DartType%" equ "Recovery" if "%IsRecoveryImageSelected%" equ "No" (
	echo.Windows Recovery Image Is not selected...
	echo.
	echo.Please choose Windows Recovery Image while selecting Source...
	goto :Stop	
)

:: Setting Package Language
for /d %%i in (ar-SA,bg-BG,cs-CZ,da-DK,el-GR,en-GB,en-US,et-EE,fi-FI,he-IL,hr-HR,hu-HU,lt-LT,lv-LV,nb-NO,nl-NL,pl-PL,ro-RO,sk-SK,sl-SI,sr-Latn-CS,sr-Latn-RS,sv-SE,th-TH,tr-TR,uk-UA) do (
	if "%ImageDefaultLanguage%" equ "%%i" set "PackageLanguage=en-US"
)

if "%ImageDefaultLanguage%" equ "de-DE" set "PackageLanguage=de-DE"
if "%ImageDefaultLanguage%" equ "es-ES" set "PackageLanguage=es-ES"
if "%ImageDefaultLanguage%" equ "fr-FR" set "PackageLanguage=fr-FR"
if "%ImageDefaultLanguage%" equ "it-IT" set "PackageLanguage=it-IT"
if "%ImageDefaultLanguage%" equ "ja-JP" set "PackageLanguage=ja-JP"
if "%ImageDefaultLanguage%" equ "ko-KR" set "PackageLanguage=ko-KR"
if "%ImageDefaultLanguage%" equ "pt-BR" set "PackageLanguage=pt-BR"
if "%ImageDefaultLanguage%" equ "ru-RU" set "PackageLanguage=ru-RU"
if "%ImageDefaultLanguage%" equ "zh-CN" set "PackageLanguage=zh-CN"
if "%ImageDefaultLanguage%" equ "zh-TW" set "PackageLanguage=zh-TW"
if "%ImageDefaultLanguage%" equ "es-MX" set "PackageLanguage=es-ES"
if "%ImageDefaultLanguage%" equ "fr-CA" set "PackageLanguage=fr-FR"
if "%ImageDefaultLanguage%" equ "pt-PT" set "PackageLanguage=pt-BR"
if "%ImageDefaultLanguage%" equ "zh-HK" set "PackageLanguage=zh-TW"

:: Setting Microsoft DaRT Tools Pack folder path
set "DaRT=%DaRT%\%SelectedSourceOS%"

:: Setting Microsoft DaRT Tools Debug Tools Package filename
if "%SelectedSourceOS%" equ "w10" set "DebugTools=DebugTools_%ImageVersion%.tpk"

:: Checking whether Microsoft DaRT 7/8.1/10 Tools Base Package file exist
if not exist "%DaRT%\DaRT.tpk" (
	if "%SelectedSourceOS%" equ "w7" echo.Microsoft DaRT 7 Tools Pack file "DaRT.tpk" not found...
	if "%SelectedSourceOS%" equ "w81" echo.Microsoft DaRT 8.1 Tools Pack file "DaRT.tpk" not found...
	if "%SelectedSourceOS%" equ "w10" echo.Microsoft DaRT 10 Tools Pack file "DaRT.tpk" not found...
	echo.
	echo.Please copy the above file to ^<Packs\DaRT\%SelectedSourceOS%^> folder...
	goto :Stop
)

:: Checking whether Microsoft  DaRT 7/8.1/10 Tools Language Package file exist
if not exist "%DaRT%\DaRT_%PackageLanguage%.tpk" (
	if "%SelectedSourceOS%" equ "w7" echo.Microsoft DaRT 7 Tools Pack file "DaRT_%PackageLanguage%.tpk" not found...
	if "%SelectedSourceOS%" equ "w81" echo.Microsoft DaRT 8.1 Tools Pack file "DaRT_%PackageLanguage%.tpk" not found...
	if "%SelectedSourceOS%" equ "w10" echo.Microsoft DaRT 10 Tools Pack file "DaRT_%PackageLanguage%.tpk" not found...
	echo.
	echo.Please copy the above file to ^<Packs\DaRT\%SelectedSourceOS%^> folder...
	goto :Stop
)

:: Checking whether Microsoft DaRT 10 Debug Tools Package file exist
if "%SelectedSourceOS%" equ "w10" if not exist "%DaRT%\%DebugTools%" (
	echo.Microsoft DaRT 10 Tools Pack folder is missing the below file...
	echo.
	echo."%DebugTools%"
	echo.
	echo.Please copy the above file to ^<Packs\DaRT\%SelectedSourceOS%^> folder...
	goto :Stop
)

if "%DartType%" equ "Boot" (
	cls
	echo.===============================================================================
	if "%SelectedSourceOS%" equ "w7" echo.  MSMG ToolKit - Integrate Microsoft DaRT 7 Tools to Windows Setup Boot Image
	if "%SelectedSourceOS%" equ "w81" echo. MSMG ToolKit - Integrate Microsoft DaRT 8.1 Tools to Windows Setup Boot Image
	if "%SelectedSourceOS%" equ "w10" echo.  MSMG ToolKit - Integrate Microsoft DaRT 10 Tools to Windows Setup Boot Image
	echo.===============================================================================
	echo.
	:: Getting Boot Image Index Architecture
	call :GetImageArchitecture "%BootWim%", 2 >nul
	echo.-------------------------------------------------------------------------------
	if "%SelectedSourceOS%" equ "w7" echo.####Starting Integrating Microsoft DaRT 7 Tools to Windows Boot Image##########
	if "%SelectedSourceOS%" equ "w81" echo.####Starting Integrating Microsoft DaRT 8.1 Tools to Windows Boot Image########
	if "%SelectedSourceOS%" equ "w10" echo.####Starting Integrating Microsoft DaRT 10 Tools to Windows Boot Image#########
	echo.-------------------------------------------------------------------------------
	echo.
	echo.    Image                    : Boot.wim
	echo.    Image Index              : 2
	echo.    Image Architecture       : %ImageArchitecture%
	echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
	echo.    Image Default Language   : %ImageDefaultLanguage%
	echo.
	echo.-------------------------------------------------------------------------------
	if "%SelectedSourceOS%" equ "w7" echo.####Integrating Microsoft DaRT 7 Tools to Windows Boot Image###################
	if "%SelectedSourceOS%" equ "w81" echo.####Integrating Microsoft DaRT 8.1 Tools to Windows Boot Image#################
	if "%SelectedSourceOS%" equ "w10" echo.####Integrating Microsoft DaRT 10 Tools to Windows Boot Image##################
	echo.-------------------------------------------------------------------------------
	echo.
	echo.-------------------------------------------------------------------------------
	if "%SelectedSourceOS%" equ "w7" echo.Integrating Microsoft DaRT 7 Tools Base Package...
	if "%SelectedSourceOS%" equ "w81" echo.Integrating Microsoft DaRT 8.1 Tools Base Package...
	if "%SelectedSourceOS%" equ "w10" echo.Integrating Microsoft DaRT 10 Tools Base Package...
	echo.-------------------------------------------------------------------------------
	if "%ImageArchitecture%" equ "x86" call :ApplyImage "%DaRT%\DaRT.tpk", 1, "%BootMount%\2"
	if "%ImageArchitecture%" equ "x64" call :ApplyImage "%DaRT%\DaRT.tpk", 2, "%BootMount%\2"
	if "%SelectedSourceOS%" equ "w10" if not exist "%BootMount%\2\Windows\System32\fmapi.dll" (
		if "%ImageIndexNo%" equ "*" copy /y "%InstallMount%\1\Windows\System32\fmapi.dll" "%BootMount%\2\Windows\System32" >nul
		if "%ImageIndexNo%" neq "*" copy /y "%InstallMount%\Windows\System32\fmapi.dll" "%BootMount%\2\Windows\System32" >nul
	)
	call :RemoveFile "%BootMount%\2\Windows\System32\winpeshl.ini"
	echo.[LaunchApps]>>"%BootMount%\2\Windows\System32\winpeshl.ini"
	echo.%%windir%%\system32\wpeinit.exe>>"%BootMount%\2\Windows\System32\winpeshl.ini"
	echo.%%windir%%\system32\netstart.exe>>"%BootMount%\2\Windows\System32\winpeshl.ini"
	echo.%%systemdrive%%\setup.exe>>"%BootMount%\2\Windows\System32\winpeshl.ini"
	echo.-------------------------------------------------------------------------------
	if "%SelectedSourceOS%" equ "w7" echo.Integrating Microsoft DaRT 7 Tools [%PackageLanguage%] Language Package...
	if "%SelectedSourceOS%" equ "w81" echo.Integrating Microsoft DaRT 8.1 Tools [%PackageLanguage%] Language Package...
	if "%SelectedSourceOS%" equ "w10" echo.Integrating Microsoft DaRT 10 Tools [%PackageLanguage%] Language Package...
	echo.-------------------------------------------------------------------------------
	if "%ImageArchitecture%" equ "x86" call :ApplyImage "%DaRT%\DaRT_%PackageLanguage%.tpk", 1, "%BootMount%\2"
	if "%ImageArchitecture%" equ "x64" call :ApplyImage "%DaRT%\DaRT_%PackageLanguage%.tpk", 2, "%BootMount%\2"
	if "%SelectedSourceOS%" equ "w10" (
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft DaRT 10 Debug Tools Package...
		echo.-------------------------------------------------------------------------------
		if "%ImageArchitecture%" equ "x86" call :ApplyImage "%DaRT%\%DebugTools%", 1, "%BootMount%\2"
		if "%ImageArchitecture%" equ "x64" call :ApplyImage "%DaRT%\%DebugTools%", 2, "%BootMount%\2"
	)
	echo.-------------------------------------------------------------------------------
	if "%SelectedSourceOS%" equ "w7" echo.####Finished Integrating Microsoft DaRT 7 Tools to Windows Boot Image##########
	if "%SelectedSourceOS%" equ "w81" echo.####Finished Integrating Microsoft DaRT 8.1 Tools to Windows Boot Image########
	if "%SelectedSourceOS%" equ "w10" echo.####Finished Integrating Microsoft DaRT 10 Tools to Windows Boot Image#########
	echo.-------------------------------------------------------------------------------
)

if "%DartType%" equ "Recovery" (
	cls
	echo.===============================================================================
	if "%SelectedSourceOS%" equ "w7" echo.   MSMG ToolKit - Integrate Microsoft DaRT 7 Tools to Windows Recovery Image
	if "%SelectedSourceOS%" equ "w81" echo.  MSMG ToolKit - Integrate Microsoft DaRT 8.1 Tools to Windows Recovery Image
	if "%SelectedSourceOS%" equ "w10" echo.   MSMG ToolKit - Integrate Microsoft DaRT 10 Tools to Windows Recovery Image
	echo.===============================================================================
	echo.
	:: Getting Recovery Image Index Architecture
	if "%ImageIndexNo%" equ "*" call :GetImageArchitecture "%InstallMount%\1\%WinReWim%", 1 >nul
	if "%ImageIndexNo%" neq "*" call :GetImageArchitecture "%InstallMount%\%WinReWim%", 1 >nul	
	echo.-------------------------------------------------------------------------------
	if "%SelectedSourceOS%" equ "w7" echo.####Starting Integrating Microsoft DaRT 7 Tools to Windows Recovery Image######
	if "%SelectedSourceOS%" equ "w81" echo.####Starting Integrating Microsoft DaRT 8.1 Tools to Windows Recovery Image####
	if "%SelectedSourceOS%" equ "w10" echo.####Starting Integrating Microsoft DaRT 10 Tools to Windows Recovery Image#####
	echo.-------------------------------------------------------------------------------
	echo.
	echo.    Image                    : WinRE.wim
	echo.    Image Index              : 1
	echo.    Image Architecture       : %ImageArchitecture%
	echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
	echo.    Image Default Language   : %ImageDefaultLanguage%
	echo.
	echo.-------------------------------------------------------------------------------
	if "%SelectedSourceOS%" equ "w7" echo.####Integrating Microsoft DaRT 7 Tools to Windows Recovery Image###############
	if "%SelectedSourceOS%" equ "w81" echo.####Integrating Microsoft DaRT 8.1 Tools to Windows Recovery Image#############
	if "%SelectedSourceOS%" equ "w10" echo.####Integrating Microsoft DaRT 10 Tools to Windows Recovery Image##############
	echo.-------------------------------------------------------------------------------
	echo.
	echo.-------------------------------------------------------------------------------
	if "%SelectedSourceOS%" equ "w7" echo.Integrating Microsoft DaRT 7 Tools Base Package...
	if "%SelectedSourceOS%" equ "w81" echo.Integrating Microsoft DaRT 8.1 Tools Base Package...
	if "%SelectedSourceOS%" equ "w10" echo.Integrating Microsoft DaRT 10 Tools Base Package...
	echo.-------------------------------------------------------------------------------
	if "%ImageArchitecture%" equ "x86" call :ApplyImage "%DaRT%\DaRT.tpk", 1, "%WinReMount%"
	if "%ImageArchitecture%" equ "x64" call :ApplyImage "%DaRT%\DaRT.tpk", 2, "%WinReMount%"
	if "%SelectedSourceOS%" equ "w10" if not exist "%WinReMount%\Windows\System32\fmapi.dll" (
		if "%ImageIndexNo%" equ "*" copy /y "%InstallMount%\1\Windows\System32\fmapi.dll" "%WinReMount%\Windows\System32" >nul
		if "%ImageIndexNo%" neq "*" copy /y "%InstallMount%\Windows\System32\fmapi.dll" "%WinReMount%\Windows\System32" >nul
	)
	call :RemoveFile "%WinReMount%\Windows\System32\winpeshl.ini"
	echo.[LaunchApps]>>"%WinReMount%\Windows\System32\winpeshl.ini"
	echo.%%windir%%\system32\wpeinit.exe>>"%WinReMount%\Windows\System32\winpeshl.ini"
	echo.%%windir%%\system32\netstart.exe>>"%WinReMount%\Windows\System32\winpeshl.ini"
	echo.%%systemdrive%%\sources\recovery\recenv.exe>>"%WinReMount%\Windows\System32\winpeshl.ini"
	echo.-------------------------------------------------------------------------------
	if "%SelectedSourceOS%" equ "w7" echo.Integrating Microsoft DaRT 7 Tools [%PackageLanguage%] Language Package...
	if "%SelectedSourceOS%" equ "w81" echo.Integrating Microsoft DaRT 8.1 Tools [%PackageLanguage%] Language Package...
	if "%SelectedSourceOS%" equ "w10" echo.Integrating Microsoft DaRT 10 Tools [%PackageLanguage%] Language Package...
	echo.-------------------------------------------------------------------------------
	if "%ImageArchitecture%" equ "x86" call :ApplyImage "%DaRT%\DaRT_%PackageLanguage%.tpk", 1, "%WinReMount%"
	if "%ImageArchitecture%" equ "x64" call :ApplyImage "%DaRT%\DaRT_%PackageLanguage%.tpk", 2, "%WinReMount%"
	if "%SelectedSourceOS%" equ "w10" (
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft DaRT 10 Debug Tools Package...
		echo.-------------------------------------------------------------------------------
		if "%ImageArchitecture%" equ "x86" call :ApplyImage "%DaRT%\%DebugTools%", 1, "%WinReMount%"
		if "%ImageArchitecture%" equ "x64" call :ApplyImage "%DaRT%\%DebugTools%", 2, "%WinReMount%"
	)	
	echo.-------------------------------------------------------------------------------
	if "%SelectedSourceOS%" equ "w7" echo.####Finished Integrating Microsoft DaRT 7 Tools to Windows Recovery Image######
	if "%SelectedSourceOS%" equ "w81" echo.####Finished Integrating Microsoft DaRT 8.1 Tools to Windows Recovery Image####
	if "%SelectedSourceOS%" equ "w10" echo.####Finished Integrating Microsoft DaRT 10 Tools to Windows Recovery Image#####
	echo.-------------------------------------------------------------------------------
)

:Stop
echo.
echo.===============================================================================
echo.
pause

set DaRT=
set DartType=
set PackageLanguage=
set DebugTools=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Microsoft DirectX 9.0c
::-------------------------------------------------------------------------------------------
:IntDirectX9c

setlocal

cls
echo.===============================================================================
echo.               MSMG ToolKit - Integrate Microsoft DirectX 9.0c
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
if "%ImageIndexNo%" equ "*" call :GetImageArchitecture "%InstallWim%", 1 >nul
if "%ImageIndexNo%" neq "*" call :GetImageArchitecture "%InstallWim%", %ImageIndexNo% >nul

:: Checking whether Microsoft DirectX 9.0c Pack file exist
if not exist "%DirectX9c%\DirectX9c.tpk" (
	echo.Microsoft DirectX 9.0c Pack file "DirectX9c.tpk" not found...
	echo.
	echo.Please copy the above file to ^<Packs\DirectX9c^> folder...
	goto :Stop
)

:: Checking whether Microsoft DirectX 9.0c Pack file exist
if not exist "%DirectX9c%\DirectX9c_%ImageArchitecture%.reg" (
	echo.Microsoft DirectX 9.0c Pack file "DirectX9c_%ImageArchitecture%.reg" not found...
	echo.
	echo.Please copy the above file to ^<Packs\DirectX9c^> folder...
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Microsoft DirectX 9.0c################################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if "%ImageIndexNo%" equ "*" echo.    Image Indexes            : 1-%ImageCount%
if "%ImageIndexNo%" neq "*" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
if "%ImageIndexNo%" neq "*" echo.    Image Edition            : %ImageEdition%
echo.    Image Default Language   : %ImageDefaultLanguage%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Microsoft DirectX 9.0c#########################################
echo.-------------------------------------------------------------------------------
if "%ImageIndexNo%" equ "*" (
	for /L %%i in (1, 1, %ImageCount%) do (
		echo.
		if not %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]#############################
		if %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]############################

		:: Getting Image Index Information
		call :GetImageIndexInfo "%InstallWim%", %%i >nul

		if "%ImageArchitecture%" equ "x86" call :ApplyImage "%DirectX9c%\DirectX9c.tpk", 1, "%InstallMount%\%%i"
		if "%ImageArchitecture%" equ "x64" call :ApplyImage "%DirectX9c%\DirectX9c.tpk", 2, "%InstallMount%\%%i"
		echo.-------------------------------------------------------------------------------
		echo.####Importing Microsoft DirectX 9.0c Registry Settings#########################
		echo.-------------------------------------------------------------------------------
		echo.
		echo.Mounting Image Registry...
		call :MountImageRegistry "%InstallMount%\%%i"	
		echo.Importing Registry Settings to Image Registry...
		call :ImportRegistry2Image "%DirectX9c%\DirectX9c_%ImageArchitecture%.reg"		
		echo.Un-Mounting Image Registry...
		call :UnMountImageRegistry
	)
) else (
	if "%ImageArchitecture%" equ "x86" call :ApplyImage "%DirectX9c%\DirectX9c.tpk", 1, "%InstallMount%"
	if "%ImageArchitecture%" equ "x64" call :ApplyImage "%DirectX9c%\DirectX9c.tpk", 2, "%InstallMount%"
	echo.-------------------------------------------------------------------------------
	echo.####Importing Microsoft DirectX 9.0c Registry Settings#########################
	echo.-------------------------------------------------------------------------------
	echo.
	echo.Mounting Image Registry...
	call :MountImageRegistry "%InstallMount%"
	echo.Importing Registry Settings to Image Registry...
	call :ImportRegistry2Image "%DirectX9c%\DirectX9c_%ImageArchitecture%.reg"	
	echo.Un-Mounting Image Registry...
	call :UnMountImageRegistry
)
echo.
echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Microsoft DirectX 9.0c################################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Microsoft Games
::-------------------------------------------------------------------------------------------
:IntGames

setlocal

set Game=
set PackageLanguage=

cls
echo.===============================================================================
echo.                   MSMG ToolKit - Integrate Microsoft Games
echo.===============================================================================

:: Getting Install Image Index Architecture
if "%ImageIndexNo%" equ "*" call :GetImageArchitecture "%InstallWim%", 1 >nul
if "%ImageIndexNo%" neq "*" call :GetImageArchitecture "%InstallWim%", %ImageIndexNo% >nul

:: Checking whether the selected Source OS is a Windows 7 Client Edition
if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType%" equ "Client" if "%ImageEdition%" neq "HomePremium" if "%ImageEdition%" neq "HomePremiumN" if "%ImageEdition%" neq "Professional" if "%ImageEdition%" neq "ProfessionalN" if "%ImageEdition%" neq "Enterprise" if "%ImageEdition%" neq "EnterpriseN" if "%ImageEdition%" neq "Ultimate" if "%ImageEdition%" neq "UltimateN" (
	cls
	echo.===============================================================================
	echo.                MSMG ToolKit - Integrate Microsoft Games Menu
	echo.===============================================================================
	echo.
	echo.  [1]  Chess Titans
	echo.
	echo.  [2]  Mahjong Titans
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.  [A]  All Games
	echo.
	echo.  [X]  Go Back
	echo.
	echo.===============================================================================
	choice /C:12AX /N /M "Enter your choice : "
	if errorlevel 4 goto :IntFeatures
	if errorlevel 3 set "Game=W7Games"
	if errorlevel 2 set "Game=MahjongTitans"
	if errorlevel 1 set "Game=ChessTitans"
)

:: Checking whether the selected Source OS is not a Windows 7 Client Edition
if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType%" neq "Client" (
	cls
	echo.===============================================================================
	echo.                MSMG ToolKit - Integrate Microsoft Games Menu
	echo.===============================================================================
	echo.
	echo.  [1]  Chess Titans
	echo.  [2]  FreeCell
	echo.  [3]  Hearts
	echo.  [4]  Mahjong Titans
	echo.  [5]  Minesweeper
	echo.  [6]  Purble Place
	echo.  [7]  Solitaire
	echo.  [8]  Spider Solitaire
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.  [A]  All Games
	echo.
	echo.  [X]  Go Back
	echo.
	echo.===============================================================================
	choice /C:12345678AX /N /M "Enter your choice : "
	if errorlevel 10 goto :IntFeatures
	if errorlevel 9 set "Game=W7Games"
	if errorlevel 8 set "Game=SpiderSolitaire"
	if errorlevel 7 set "Game=Solitaire"
	if errorlevel 6 set "Game=PurblePlace"
	if errorlevel 5 set "Game=Minesweeper"
	if errorlevel 4 set "Game=MahjongTitans"
	if errorlevel 3 set "Game=Hearts"
	if errorlevel 2 set "Game=FreeCell"
	if errorlevel 1 set "Game=ChessTitans"
)

:: Checking whether the selected Source OS is not Windows 7
if "%SelectedSourceOS%" neq "w7" (
	cls
	echo.===============================================================================
	echo.                MSMG ToolKit - Integrate Microsoft Games Menu
	echo.===============================================================================
	echo.
	echo.  [1]  Chess Titans
	echo.  [2]  FreeCell
	echo.  [3]  Hearts
	echo.  [4]  Mahjong Titans
	echo.  [5]  Minesweeper
	echo.  [6]  Purble Place
	echo.  [7]  Solitaire
	echo.  [8]  Spider Solitaire
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.  [A]  All Games
	echo.
	echo.  [X]  Go Back
	echo.
	echo.===============================================================================
	echo.
	choice /C:12345678AX /N /M "Enter your choice : "
	if errorlevel 10 goto :IntFeatures
	if errorlevel 9 set "Game=W7Games"
	if errorlevel 8 set "Game=SpiderSolitaire"
	if errorlevel 7 set "Game=Solitaire"
	if errorlevel 6 set "Game=PurblePlace"
	if errorlevel 5 set "Game=Minesweeper"
	if errorlevel 4 set "Game=MahjongTitans"
	if errorlevel 3 set "Game=Hearts"
	if errorlevel 2 set "Game=FreeCell"
	if errorlevel 1 set "Game=ChessTitans"
)

cls
echo.===============================================================================
echo.                   MSMG ToolKit - Integrate Microsoft Games
echo.===============================================================================
echo.
:: Checking whether Microsoft Games Pack file exist
if not exist "%Games%\Games_%ImageArchitecture%.tpk" (
	echo.Microsoft Games Pack file "Games_%ImageArchitecture%.tpk" not found...
	echo.                      
	echo.Please copy the above file to ^<Packs\Games^> folder...
	goto :Stop
)

:: Checking whether Microsoft Games Pack file exist
if not exist "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk" (
	echo.Microsoft Games Pack file "Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk" not found...
	echo.                      
	echo.Please copy the above file to ^<Packs\Games^> folder...
	goto :Stop
)

:: Checking whether Microsoft Games Pack file exist
if "%Game%" equ "W7Games" if not exist "%Games%\W7Games.reg" (
	echo.Microsoft Games Pack file "W7Games.reg" not found...
	echo.                      
	echo.Please copy the above file to ^<Packs\Games^> folder...
	goto :Stop
)

:: Checking whether Microsoft Games Pack file exist
if "%Game%" equ "ChessTitans" if not exist "%Games%\ChessTitans.reg" (
	echo.Microsoft Games Pack file "ChessTitans.reg" not found...
	echo.                      
	echo.Please copy the above file to ^<Packs\Games^> folder...
	goto :Stop
)

:: Checking whether Microsoft Games Pack file exist
if "%Game%" equ "FreeCell" if not exist "%Games%\FreeCell.reg" (
	echo.Microsoft Games Pack file "FreeCell.reg" not found...
	echo.                      
	echo.Please copy the above file to ^<Packs\Games^> folder...
	goto :Stop
)

:: Checking whether Microsoft Games Pack file exist
if "%Game%" equ "Hearts" if not exist "%Games%\Hearts.reg" (
	echo.Microsoft Games Pack file "Hearts.reg" not found...
	echo.                      
	echo.Please copy the above file to ^<Packs\Games^> folder...
	goto :Stop
)

:: Checking whether Microsoft Games Pack file exist
if "%Game%" equ "MahjongTitans" if not exist "%Games%\MahjongTitans.reg" (
	echo.Microsoft Games Pack file "MahjongTitans.reg" not found...
	echo.                      
	echo.Please copy the above file to ^<Packs\Games^> folder...
	goto :Stop
)

:: Checking whether Microsoft Games Pack file exist
if "%Game%" equ "Minesweeper" if not exist "%Games%\Minesweeper.reg" (
	echo.Microsoft Games Pack file "Minesweeper.reg" not found...
	echo.                      
	echo.Please copy the above file to ^<Packs\Games^> folder...
	goto :Stop
)

:: Checking whether Microsoft Games Pack file exist
if "%Game%" equ "PurblePlace" if not exist "%Games%\PurblePlace.reg" (
	echo.Microsoft Games Pack file "PurblePlace.reg" not found...
	echo.                      
	echo.Please copy the above file to ^<Packs\Games^> folder...
	goto :Stop
)

:: Checking whether Microsoft Games Pack file exist
if "%Game%" equ "Solitaire" if not exist "%Games%\Solitaire.reg" (
	echo.Microsoft Games Pack file "Solitaire.reg" not found...
	echo.                      
	echo.Please copy the above file to ^<Packs\Games^> folder...
	goto :Stop
)

:: Checking whether Microsoft Games Pack file exist
if "%Game%" equ "SpiderSolitaire" if not exist "%Games%\SpiderSolitaire.reg" (
	echo.Microsoft Games Pack file "SpiderSolitaire.reg" not found...
	echo.                      
	echo.Please copy the above file to ^<Packs\Games^> folder...
	goto :Stop
)
echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Microsoft Games#######################################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if "%ImageIndexNo%" equ "*" echo.    Image Indexes            : 1-%ImageCount%
if "%ImageIndexNo%" neq "*" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
if "%ImageIndexNo%" neq "*" echo.    Image Edition            : %ImageEdition%
echo.    Image Default Language   : %ImageDefaultLanguage%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Microsoft Games################################################
echo.-------------------------------------------------------------------------------
echo.
if "%ImageIndexNo%" equ "*" (
	for /L %%i in (1, 1, %ImageCount%) do (
		if not %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]#############################
		if %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]############################
		echo.
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Games Base Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 1, "%InstallMount%\%%i"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Games [%ImageDefaultLanguage%] Language Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 1, "%InstallMount%\%%i"

		if "%Game%" equ "ChessTitans" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Chess Titans Game Base Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 2, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Chess Titans Game [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 2, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
		)
		
		if "%Game%" equ "FreeCell" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft FreeCell Game Base Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 3, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft FreeCell Game [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 3, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
		)
		
		if "%Game%" equ "Hearts" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Hearts Game Base Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 4, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Hearts Game [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 4, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
		)
		
		if "%Game%" equ "MahjongTitans" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Mahjong Titans Game Base Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 5, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Mahjong Titans Game [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 5, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
		)
		
		if "%Game%" equ "Minesweeper" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Minesweeper Game Base Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 6, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Minesweeper Game [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 6, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
		)
		
		if "%Game%" equ "PurblePlace" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Purble Place Game Base Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 7, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Purble Place Game [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 7, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
		)
		
		if "%Game%" equ "Solitaire" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Solitaire Game Base Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 8, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Solitaire Game [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 8, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
		)
		
		if "%Game%" equ "SpiderSolitaire" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Spider Solitaire Game Base Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 9, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Spider Solitaire Game [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 9, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
		)

		if "%Game%" equ "W7Games" if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType%" equ "Client" if "%ImageEdition%" neq "HomePremium" if "%ImageEdition%" neq "HomePremiumN" if "%ImageEdition%" neq "Professional" if "%ImageEdition%" neq "ProfessionalN" if "%ImageEdition%" neq "Enterprise" if "%ImageEdition%" neq "EnterpriseN" if "%ImageEdition%" neq "Ultimate" if "%ImageEdition%" neq "UltimateN" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Chess Titans Game Base Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 2, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Chess Titans Game [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 2, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Mahjong Titans Game Base Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 5, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Mahjong Titans Game [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 5, "%InstallMount%\%%i"
		)

		if "%Game%" equ "W7Games" if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType%" neq "Client" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Chess Titans Game Base Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 2, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Chess Titans Game [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 2, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft FreeCell Game Base Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 3, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft FreeCell Game [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 3, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Hearts Game Base Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 4, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Hearts Game [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 4, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Mahjong Titans Game Base Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 5, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Mahjong Titans Game [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 5, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Minesweeper Game Base Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 6, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Minesweeper Game [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 6, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Purble Place Game Base Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 7, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Purble Place Game [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 7, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Solitaire Game Base Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 8, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Solitaire Game [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 8, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Spider Solitaire Game Base Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 9, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Spider Solitaire Game [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 9, "%InstallMount%\%%i"
		)

		if "%Game%" equ "W7Games" if "%SelectedSourceOS%" neq "w7" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Chess Titans Game Base Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 2, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Chess Titans Game [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 2, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft FreeCell Game Base Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 3, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft FreeCell Game [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 3, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Hearts Game Base Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 4, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Hearts Game [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 4, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Mahjong Titans Game Base Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 5, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Mahjong Titans Game [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 5, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Minesweeper Game Base Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 6, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Minesweeper Game [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 6, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Purble Place Game Base Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 7, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Purble Place Game [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 7, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Solitaire Game Base Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 8, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Solitaire Game [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 8, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Spider Solitaire Game Base Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 9, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Spider Solitaire Game [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 9, "%InstallMount%\%%i"
		)
		
		echo.-------------------------------------------------------------------------------
		echo.####Importing Microsoft Games Registry Settings################################
		echo.-------------------------------------------------------------------------------
		echo.	
		echo.Mounting Image Registry...
		call :MountImageRegistry "%InstallMount%\%%i"	

		echo.Importing Registry Settings to Image Registry...
		if "%Game%" equ "ChessTitans" call :ImportRegistry2Image "%Games%\ChessTitans.reg"
		if "%Game%" equ "FreeCell" call :ImportRegistry2Image "%Games%\FreeCell.reg"
		if "%Game%" equ "Hearts" call :ImportRegistry2Image "%Games%\Hearts.reg"
		if "%Game%" equ "MahjongTitans" call :ImportRegistry2Image "%Games%\MahjongTitans.reg"
		if "%Game%" equ "Minesweeper" call :ImportRegistry2Image "%Games%\Minesweeper.reg"
		if "%Game%" equ "PurblePlace" call :ImportRegistry2Image "%Games%\PurblePlace.reg"
		if "%Game%" equ "Solitaire" call :ImportRegistry2Image "%Games%\Solitaire.reg"
		if "%Game%" equ "SpiderSolitaire" call :ImportRegistry2Image "%Games%\SpiderSolitaire.reg"
		if "%Game%" equ "W7Games" call :ImportRegistry2Image "%Games%\W7Games.reg"

		echo.Un-Mounting Image Registry...
		call :UnMountImageRegistry

		:: Deleting Non-Windows Media Center Related Games Shortcuts
		if /i not exist "%InstallMount%\%%i\Windows\ehome" (
			for %%z in (Chess, FreeCell, Hearts, Mahjong, Minesweeper, Purble Place, Solitaire, SpiderSolitaire) do (
				if /i exist "%InstallMount%\%%i\Program Files\Microsoft Games\%%z" (
					cd "%InstallMount%\%%i\Program Files\Microsoft Games\%%z" >nul
					if /i exist desktop.ini (
						attrib -h -s -a desktop.ini
						del /f /q desktop.ini >nul
					)
					cd "%ROOT%" >nul
					call :RemoveFile "%InstallMount%\%%i\Program Files\Microsoft Games\%%z\*MCE.*"
				)
			)
		)
	)
) else (
	echo.-------------------------------------------------------------------------------
	echo.Integrating Microsoft Games Base Package...
	echo.-------------------------------------------------------------------------------
	call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 1, "%InstallMount%"
	echo.-------------------------------------------------------------------------------
	echo.Integrating Microsoft Games [%ImageDefaultLanguage%] Language Package...
	echo.-------------------------------------------------------------------------------
	call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 1, "%InstallMount%"

	if "%Game%" equ "ChessTitans" (
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Chess Titans Game Base Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 2, "%InstallMount%"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Chess Titans Game [%ImageDefaultLanguage%] Language Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 2, "%InstallMount%"
	)
	
	if "%Game%" equ "FreeCell" (
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft FreeCell Game Base Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 3, "%InstallMount%"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft FreeCell Game [%ImageDefaultLanguage%] Language Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 3, "%InstallMount%"
	)
	
	if "%Game%" equ "Hearts" (
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Hearts Game Base Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 4, "%InstallMount%"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Hearts Game [%ImageDefaultLanguage%] Language Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 4, "%InstallMount%"
	)
	
	if "%Game%" equ "MahjongTitans" (
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Mahjong Titans Game Base Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 5, "%InstallMount%"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Mahjong Titans Game [%ImageDefaultLanguage%] Language Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 5, "%InstallMount%"
	)
	
	if "%Game%" equ "Minesweeper" (
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Minesweeper Game Base Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 6, "%InstallMount%"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Minesweeper Game [%ImageDefaultLanguage%] Language Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 6, "%InstallMount%"
	)
	
	if "%Game%" equ "PurblePlace" (
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Purble Place Game Base Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 7, "%InstallMount%"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Purble Place Game [%ImageDefaultLanguage%] Language Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 7, "%InstallMount%"
	)
	
	if "%Game%" equ "Solitaire" (
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Solitaire Game Base Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 8, "%InstallMount%"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Solitaire Game [%ImageDefaultLanguage%] Language Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 8, "%InstallMount%"
	)
	
	if "%Game%" equ "SpiderSolitaire" (
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Spider Solitaire Game Base Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 9, "%InstallMount%"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Spider Solitaire Game [%ImageDefaultLanguage%] Language Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 9, "%InstallMount%"
	)

	if "%Game%" equ "W7Games" if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType%" equ "Client" if "%ImageEdition%" neq "HomePremium" if "%ImageEdition%" neq "HomePremiumN" if "%ImageEdition%" neq "Professional" if "%ImageEdition%" neq "ProfessionalN" if "%ImageEdition%" neq "Enterprise" if "%ImageEdition%" neq "EnterpriseN" if "%ImageEdition%" neq "Ultimate" if "%ImageEdition%" neq "UltimateN" (
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Chess Titans Game Base Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 2, "%InstallMount%"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Chess Titans Game [%ImageDefaultLanguage%] Language Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 2, "%InstallMount%"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Mahjong Titans Game Base Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 5, "%InstallMount%"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Mahjong Titans Game [%ImageDefaultLanguage%] Language Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 5, "%InstallMount%"
	)

	if "%Game%" equ "W7Games" if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType%" neq "Client" (
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Chess Titans Game Base Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 2, "%InstallMount%"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Chess Titans Game [%ImageDefaultLanguage%] Language Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 2, "%InstallMount%"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft FreeCell Game Base Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 3, "%InstallMount%"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft FreeCell Game [%ImageDefaultLanguage%] Language Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 3, "%InstallMount%"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Hearts Game Base Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 4, "%InstallMount%"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Hearts Game [%ImageDefaultLanguage%] Language Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 4, "%InstallMount%"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Mahjong Titans Game Base Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 5, "%InstallMount%"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Mahjong Titans Game [%ImageDefaultLanguage%] Language Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 5, "%InstallMount%"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Minesweeper Game Base Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 6, "%InstallMount%"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Minesweeper Game [%ImageDefaultLanguage%] Language Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 6, "%InstallMount%"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Purble Place Game Base Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 7, "%InstallMount%"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Purble Place Game [%ImageDefaultLanguage%] Language Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 7, "%InstallMount%"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Solitaire Game Base Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 8, "%InstallMount%"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Solitaire Game [%ImageDefaultLanguage%] Language Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 8, "%InstallMount%"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Spider Solitaire Game Base Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 9, "%InstallMount%"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Spider Solitaire Game [%ImageDefaultLanguage%] Language Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 9, "%InstallMount%"
	)

	if "%Game%" equ "W7Games" if "%SelectedSourceOS%" neq "w7" (
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Chess Titans Game Base Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 2, "%InstallMount%"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Chess Titans Game [%ImageDefaultLanguage%] Language Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 2, "%InstallMount%"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft FreeCell Game Base Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 3, "%InstallMount%"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft FreeCell Game [%ImageDefaultLanguage%] Language Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 3, "%InstallMount%"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Hearts Game Base Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 4, "%InstallMount%"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Hearts Game [%ImageDefaultLanguage%] Language Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 4, "%InstallMount%"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Mahjong Titans Game Base Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 5, "%InstallMount%"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Mahjong Titans Game [%ImageDefaultLanguage%] Language Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 5, "%InstallMount%"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Minesweeper Game Base Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 6, "%InstallMount%"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Minesweeper Game [%ImageDefaultLanguage%] Language Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 6, "%InstallMount%"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Purble Place Game Base Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 7, "%InstallMount%"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Purble Place Game [%ImageDefaultLanguage%] Language Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 7, "%InstallMount%"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Solitaire Game Base Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 8, "%InstallMount%"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Solitaire Game [%ImageDefaultLanguage%] Language Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 8, "%InstallMount%"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Spider Solitaire Game Base Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 9, "%InstallMount%"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Spider Solitaire Game [%ImageDefaultLanguage%] Language Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 9, "%InstallMount%"
	)
	
	echo.-------------------------------------------------------------------------------
	echo.####Importing Microsoft Games Registry Settings################################
	echo.-------------------------------------------------------------------------------
	echo.	
	echo.Mounting Image Registry...
	call :MountImageRegistry "%InstallMount%"	

	echo.Importing Registry Settings to Image Registry...
	if "%Game%" equ "ChessTitans" call :ImportRegistry2Image "%Games%\ChessTitans.reg"
	if "%Game%" equ "FreeCell" call :ImportRegistry2Image "%Games%\FreeCell.reg"
	if "%Game%" equ "Hearts" call :ImportRegistry2Image "%Games%\Hearts.reg"
	if "%Game%" equ "MahjongTitans" call :ImportRegistry2Image "%Games%\MahjongTitans.reg"
	if "%Game%" equ "Minesweeper" call :ImportRegistry2Image "%Games%\Minesweeper.reg"
	if "%Game%" equ "PurblePlace" call :ImportRegistry2Image "%Games%\PurblePlace.reg"
	if "%Game%" equ "Solitaire" call :ImportRegistry2Image "%Games%\Solitaire.reg"
	if "%Game%" equ "SpiderSolitaire" call :ImportRegistry2Image "%Games%\SpiderSolitaire.reg"
	if "%Game%" equ "W7Games" call :ImportRegistry2Image "%Games%\W7Games.reg"

	echo.Un-Mounting Image Registry...
	call :UnMountImageRegistry

	:: Deleting Non-Windows Media Center Related Games Shortcuts
	if /i not exist "%InstallMount%\Windows\ehome" (
		for %%z in (Chess, FreeCell, Hearts, Mahjong, Minesweeper, Purble Place, Solitaire, SpiderSolitaire) do (
			if /i exist "%InstallMount%\Program Files\Microsoft Games\%%z" (
				cd "%InstallMount%\Program Files\Microsoft Games\%%z" >nul
				if /i exist desktop.ini (
					attrib -h -s -a desktop.ini
					del /f /q desktop.ini >nul
				)
				cd "%ROOT%" >nul
				call :RemoveFile "%InstallMount%\Program Files\Microsoft Games\%%z\*MCE.*"
			)
		)
	)
)
echo.
echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Microsoft Games#######################################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set Game=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Windows Sidebar
::-------------------------------------------------------------------------------------------
:IntSidebar

setlocal

set PackageIndex=

cls
echo.===============================================================================
echo.                   MSMG ToolKit - Integrate Windows Sidebar
echo.===============================================================================
echo.
:: Getting Install Image Index Architecture
if "%ImageIndexNo%" equ "*" call :GetImageArchitecture "%InstallWim%", 1 >nul
if "%ImageIndexNo%" neq "*" call :GetImageArchitecture "%InstallWim%", %ImageIndexNo% >nul

:: Setting Package Index
if "%ImageArchitecture%" equ "x86" set "PackageIndex=1"
if "%ImageArchitecture%" equ "x64" set "PackageIndex=2"

:: Checking whether Windows Sidebar Pack file exist
if not exist "%Sidebar%\Sidebar.tpk" (
	echo.Windows Sidebar Pack file "Sidebar.tpk" not found...
	echo.
	echo.Please copy the above file to ^<Packs\Sidebar^> folder...
	goto :Stop
)

:: Checking whether Windows Sidebar Pack file exist
if not exist "%Sidebar%\Sidebar_%ImageDefaultLanguage%.tpk" (
	echo.Windows Sidebar Pack file "Sidebar_%ImageDefaultLanguage%.tpk" not found...
	echo.
	echo.Please copy the above file to ^<Packs\Sidebar^> folder...
	goto :Stop
)

:: Checking whether Windows Sidebar Pack file exist
if not exist "%Sidebar%\Sidebar_%ImageArchitecture%.reg" (
	echo.Windows Sidebar Pack file "Sidebar_%ImageArchitecture%.reg" not found...
	echo.
	echo.Please copy the above file to ^<Packs\Sidebar^> folder...
	goto :Stop
)
echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Windows Sidebar#######################################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if "%ImageIndexNo%" equ "*" echo.    Image Indexes            : 1-%ImageCount%
if "%ImageIndexNo%" neq "*" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
if "%ImageIndexNo%" neq "*" echo.    Image Edition            : %ImageEdition%
echo.    Image Default Language   : %ImageDefaultLanguage%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Windows Sidebar################################################
echo.-------------------------------------------------------------------------------
echo.
if "%ImageIndexNo%" equ "*" (
	for /L %%i in (1, 1, %ImageCount%) do (
		if not %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]#############################
		if %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]############################
		echo.
		:: Getting Image Index Information
		call :GetImageIndexInfo "%InstallWim%", %%i >nul

		echo.-------------------------------------------------------------------------------
		echo.Integrating Windows Sidebar Base Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Sidebar%\Sidebar.tpk", %PackageIndex%, "%InstallMount%\%%i"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Windows Sidebar [%ImageDefaultLanguage%] Language Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Sidebar%\Sidebar_%ImageDefaultLanguage%.tpk", %PackageIndex%, "%InstallMount%\%%i"

		echo.-------------------------------------------------------------------------------
		echo.####Importing Windows Sidebar Registry Settings################################
		echo.-------------------------------------------------------------------------------
		echo.
		echo.Mounting Image Registry...
		call :MountImageRegistry "%InstallMount%\%%i"
		echo.Taking Image Registry Ownership...
		echo.Importing Registry Settings to Image Registry...
		call :ImportRegistry2Image "%Sidebar%\Sidebar_%ImageArchitecture%.reg"
		call :ImportRegistry2Image "%Sidebar%\3rdPartyGadgets_%ImageArchitecture%.reg"
		echo.Un-Mounting Image Registry...
		call :UnMountImageRegistry
		echo.

		:: Deleting Microsoft Sidebar Media Center files if the Source Edition is not MediaCenter
		if /i not exist "%InstallMount%\%%i\Windows\ehome" call :RemoveFolder "%InstallMount%\%%i\Program Files\Windows Sidebar\Gadgets\MediaCenter.Gadget"
	)
) else (
	echo.-------------------------------------------------------------------------------
	echo.Integrating Windows Sidebar Base Package...
	echo.-------------------------------------------------------------------------------
	call :ApplyImage "%Sidebar%\Sidebar.tpk", %PackageIndex%, "%InstallMount%"
	echo.-------------------------------------------------------------------------------
	echo.Integrating Windows Sidebar [%ImageDefaultLanguage%] Language Package...
	echo.-------------------------------------------------------------------------------
	call :ApplyImage "%Sidebar%\Sidebar_%ImageDefaultLanguage%.tpk", %PackageIndex%, "%InstallMount%"
	
	echo.-------------------------------------------------------------------------------
	echo.####Importing Windows Sidebar Registry Settings################################
	echo.-------------------------------------------------------------------------------
	echo.
	echo.Mounting Image Registry...
	call :MountImageRegistry "%InstallMount%"	
	echo.Importing Registry Settings to Image Registry...
	call :ImportRegistry2Image "%Sidebar%\Sidebar_%ImageArchitecture%.reg"
	call :ImportRegistry2Image "%Sidebar%\3rdPartyGadgets_%ImageArchitecture%.reg"
	echo.Un-Mounting Image Registry...
	call :UnMountImageRegistry

	:: Deleting Microsoft Sidebar Media Center files if the Source Edition is not MediaCenter
	call :RemoveFolder "%InstallMount%\Program Files\Windows Sidebar\Gadgets\MediaCenter.Gadget"
)
echo.
echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Windows Sidebar#######################################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set PackageIndex=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Microsoft Visual C++ Runtime
::-------------------------------------------------------------------------------------------
:IntVCRuntime

setlocal

set PackageIndex=

cls
echo.===============================================================================
echo.            MSMG ToolKit - Integrate Microsoft Visual C++ Runtime
echo.===============================================================================
echo.
:: Getting Install Image Index Architecture
if "%ImageIndexNo%" equ "*" call :GetImageArchitecture "%InstallWim%", 1 >nul
if "%ImageIndexNo%" neq "*" call :GetImageArchitecture "%InstallWim%", %ImageIndexNo% >nul

:: Setting Package Index
if "%ImageArchitecture%" equ "x86" set "PackageIndex=1"
if "%ImageArchitecture%" equ "x64" set "PackageIndex=2"

if not exist "%VCRuntime%\VCRedist_%SelectedSourceOS%.tpk" (
	echo.Microsoft Visual C++ Runtime Pack file "VCRedist_%SelectedSourceOS%.tpk" not found...
	echo.
	echo.Please copy the above file to ^<Packs\VCRuntime^> folder...
	goto :Stop
)

if not exist "%VCRuntime%\VCRedist_%SelectedSourceOS%_%ImageArchitecture%.reg" (
	echo.Microsoft Visual C++ Runtime Pack file "VCRedist_%SelectedSourceOS%_%ImageArchitecture%.reg" not found...
	echo.
	echo.Please copy the above file to ^<Packs\VCRuntime^> folder...
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Microsoft Visual C++ Runtime##########################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if "%ImageIndexNo%" equ "*" echo.    Image Indexes            : 1-%ImageCount%
if "%ImageIndexNo%" neq "*" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
if "%ImageIndexNo%" neq "*" echo.    Image Edition            : %ImageEdition%
echo.    Image Default Language   : %ImageDefaultLanguage%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Microsoft Visual C++ Runtime###################################
echo.-------------------------------------------------------------------------------
if "%ImageIndexNo%" equ "*" (
	for /L %%i in (1, 1, %ImageCount%) do (
		echo.
		if not %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]#############################
		if %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]############################
		echo.
		:: Getting Image Index Information
		call :GetImageIndexInfo "%InstallWim%", %%i >nul

		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Visual C++ Runtime Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%VCRuntime%\VCRedist_%SelectedSourceOS%.tpk", %PackageIndex%, "%InstallMount%\%%i"
		echo.-------------------------------------------------------------------------------
		echo.####Importing Microsoft Visual C++ Runtime Registry Settings###################
		echo.-------------------------------------------------------------------------------
		echo.
		echo.Mounting Image Registry...
		call :MountImageRegistry "%InstallMount%\%%i"
		echo.Importing Registry Settings to Image Registry...
		call :ImportRegistry2Image "%VCRuntime%\VCRedist_%SelectedSourceOS%_%ImageArchitecture%.reg"
		echo.Un-Mounting Image Registry...
		call :UnMountImageRegistry
	)
) else (
	echo.
	echo.-------------------------------------------------------------------------------
	echo.Integrating Microsoft Visual C++ Runtime Package...
	echo.-------------------------------------------------------------------------------
	call :ApplyImage "%VCRuntime%\VCRedist_%SelectedSourceOS%.tpk", %PackageIndex%, "%InstallMount%"
	echo.-------------------------------------------------------------------------------
	echo.####Importing Microsoft Visual C++ Runtime Registry Settings###################
	echo.-------------------------------------------------------------------------------
	echo.
	echo.Mounting Image Registry...
	call :MountImageRegistry "%InstallMount%"
	echo.Importing Registry Settings to Image Registry...
	call :ImportRegistry2Image "%VCRuntime%\VCRedist_%SelectedSourceOS%_%ImageArchitecture%.reg"
	echo.Un-Mounting Image Registry...
	call :UnMountImageRegistry
)
echo.
echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Microsoft Visual C++ Runtime##########################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set PackageIndex=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Windows Updates Menu
::-------------------------------------------------------------------------------------------
:IntUpdatesMenu

if "%IsDialogsEnabled%" equ "Yes" (
	cls
	echo.===============================================================================
	echo.                    MSMG ToolKit - Integrate Windows Updates
	echo.===============================================================================
	echo.
	echo.
	echo.
	echo.                              W A R N I N G
	echo.                              =============
	echo.
	echo.  Do not integrate any updates before integrating a language pack or
	echo.  any windows features. If you integrate any updates ^(Hotfix, General 
	echo.  Distribution Release [GDR], Zero-Day Patch [ZDP] or Service Pack [SP]^)
	echo.  that contains language/feature-dependent resources before you integrate
	echo.  any updates, The language/feature-specific changes that are contained 
	echo.  in the updates are not applied and you will have to re-integrate the 
	echo.  udates. Always integrate language packs/qindows features before you 
	echo.  install updates. 
	echo.
	echo.
	echo.  To turn off Warning Dialogs, Choose Disable Dialogs in Tools-^>Options Menu
	echo.
	echo.===============================================================================
	echo.
	choice /C:YN /N /M "Do you want to Continue ? ['Y'es/'N'o] : "
	if errorlevel 2 goto :IntegrateMenu
)

cls
echo.===============================================================================
echo.                MSMG ToolKit - Integrate Windows Updates Menu
echo.===============================================================================
echo.
echo.  [1]   Integrate Windows Updates
echo.
echo.  [2]   Integrate WHD Update Pack
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.  [X]   Go Back
echo.
echo.===============================================================================
echo.

choice /C:12X /N /M "Enter Your Choice : "
if errorlevel 3 goto :IntegrateMenu
if errorlevel 2 goto :IntWHDUpdatesMenu
if errorlevel 1 call :IntUpdates WUpdates

:IntWHDUpdatesMenu
cls
echo.===============================================================================
echo.               MSMG ToolKit - Integrate WHD Update Pack Menu
echo.===============================================================================
echo.
if "%SelectedSourceOS%" equ "w7" (
	echo.  [1]   Integrate WHD Update Pack with Service Pack 2
	echo.
	echo.  [2]   Integrate WHD Update Pack without Service Pack 2
	echo.
	echo.  [3]   Integrate Windows Setup Media Updates
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.  [X]   Go Back
	echo.
	echo.===============================================================================
	echo.
)

if "%SelectedSourceOS%" equ "w81" (
	echo.  [1]   Integrate WHD Baseline Updates
	echo.
	echo.  [2]   Integrate WHD General Updates
	echo.
	echo.  [3]   Integrate WHD Hotfix Updates
	echo.
	echo.  [4]   Integrate WHD Security Updates
	echo.
	echo.  [5]   Integrate WHD Additional Updates
	echo.
	echo.  [6]   Integrate Windows Setup Media Updates
	echo.
	echo.
	echo.
	echo.
	echo.  [X]   Go Back
	echo.
	echo.===============================================================================
	echo.
)

if "%SelectedSourceOS%" equ "w10" (
	echo.  [1]   Integrate WHD General Updates
	echo.
	echo.  [2]   Integrate Windows Setup Media Updates
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.  [X]   Go Back
	echo.
	echo.===============================================================================
	echo.
)

if "%SelectedSourceOS%" equ "w7" (
	choice /C:123X /N /M "Enter Your Choice : "
	if errorlevel 4 goto :IntegrateMenu
	if errorlevel 3 goto :IntWindowsSetupMediaUpdates
	if errorlevel 2 (
		set IsW7SP1CRUSelected=0
		goto :IntW7WHDUpdatesMenu
	)
	if errorlevel 1 (
		set IsW7SP1CRUSelected=1
		goto :IntW7WHDUpdatesMenu
	)
)

if "%SelectedSourceOS%" equ "w81" (
	choice /C:123456X /N /M "Enter Your Choice : "
	if errorlevel 7 goto :IntegrateMenu
	if errorlevel 6 goto :IntWindowsSetupMediaUpdates
	if errorlevel 5 goto :IntWHDAdditionalMenu
	if errorlevel 4 call :IntUpdates Security
	if errorlevel 3 call :IntUpdates Hotfix
	if errorlevel 2 call :IntUpdates General
	if errorlevel 1 goto :IntWHDBaselineMenu
)

if "%SelectedSourceOS%" equ "w10" (
	choice /C:12X /N /M "Enter Your Choice : "
	if errorlevel 3 goto :IntegrateMenu
	if errorlevel 2 goto :IntWindowsSetupMediaUpdates
	if errorlevel 1 goto :IntWHDBaselineMenu
)

:IntW7WHDUpdatesMenu
if "%IsDialogsEnabled%" equ "Yes" if "%IsW7SP1CRUSelected%" equ "1" (
	cls
	echo.===============================================================================
	echo.          MSMG ToolKit - Integrate WHD Updates with Service Pack 2
	echo.===============================================================================
	echo.## Convenience Rollup Update for Windows 7 SP1 aka Service Pack 2 ##
	echo.
	echo.KB3125574 is a comprehensive rollup update that contains almost all fixes
	echo.released after Windows 7 SP1's release, up through April 2016.
	echo.
	echo.If you intend to integrate any of the following feature packages, integrate
	echo.them *first* ^(before KB3125574^) so the rollup can integrate their updated
	echo.components afterwards:
	echo.
	echo.DCA2.0, AD LDS, VirtualPC, WorkFolders, Server Essentials Connector found
	echo.in WHD Additional and Extra Updates section.
	echo.
	echo.This update aims to simplify the updating process for Windows 7, but it's 
	echo.completely optional, and for due diligence purposes, be aware that it does
	echo.contain some telemetry updates components ^(3068708, 3075249^). 
	echo.So if you do not want this, you should choose Integrate WHD Updates without
	echo.Service Pack 2 option from Integrate WHD Updates Menu.
	echo.
	echo.You could also block these telemetry effects while having the rollup integrated
	echo.refer to this topic for details: http://forums.mydigitallife.info/threads/68131
	echo.===============================================================================
	pause
)
cls
echo.===============================================================================
echo.                   MSMG ToolKit - Integrate WHD Updates Menu
echo.===============================================================================
echo.
if "%SelectedSourceOS%" equ "w7" (
	echo.  [1]   Integrate WHD Additional Updates
	echo.
	echo.  [2]   Integrate WHD Extra Updates
	echo.
	echo.  [3]   Integrate WHD General Updates
	echo.
	echo.  [4]   Integrate WHD Hotfix Updates
	echo.
	echo.  [5]   Integrate WHD Security Updates
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.  [X]   Go Back
	echo.
	echo.===============================================================================
	echo.
)

if "%SelectedSourceOS%" equ "w7" (
	choice /C:12345X /N /M "Enter Your Choice : "
	if errorlevel 6 goto :IntegrateMenu
	if errorlevel 5 call :IntUpdates "Security"
	if errorlevel 4 call :IntUpdates "Hotfix"
	if errorlevel 3 call :IntUpdates "General"
	if errorlevel 2 goto :IntWHDExtraMenu
	if errorlevel 1 goto :IntWHDAdditionalMenu
)

:IntWHDBaselineMenu
cls

echo.===============================================================================
if "%SelectedSourceOS%" equ "w81" echo.               MSMG ToolKit - Integrate WHD Baseline Updates Menu
if "%SelectedSourceOS%" equ "w10" echo.              MSMG ToolKit - Integrate WHD General Updates Menu
echo.===============================================================================
echo.
echo.  [1]   Integrate to Windows Setup Boot Image
echo.
echo.  [2]   Integrate to Windows Setup Install Image
echo.
echo.  [3]   Integrate to Windows Setup Install ^& Recovery Image
echo.
echo.  [4]   Integrate to Windows Setup Boot, Install ^& Recovery Image
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.  [X]   Go Back
echo.
echo.===============================================================================
echo.
choice /C:1234X /N /M "Enter Your Choice : "
if errorlevel 5 goto :IntUpdatesMenu
if errorlevel 4 goto :IntWHDBaseBootInstallRecovery
if errorlevel 3 goto :IntWHDBaseInstallRecovery
if errorlevel 2 goto :IntWHDBaseInstall
if errorlevel 1 goto :IntWHDBaseBoot

:IntWHDAdditionalMenu
cls

echo.===============================================================================
echo.             MSMG ToolKit - Integrate WHD Additional Updates Menu
echo.===============================================================================
echo.
if "%SelectedSourceOS%" equ "w7" (
	echo.  [1]   Integrate Windows Activation Technologies ^(WAT^)
	echo.
	echo.  [2]   Integrate Windows 10 Upgrade Prerequisites
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
)

if "%SelectedSourceOS%" equ "w81" (
	echo.  [1]   Integrate Microsoft .NET Framework 3.5 Updates
	echo.
	echo.  [2]   Integrate Windows 10 Upgrade Prerequisites
	echo.
	echo.  [3]   Integrate Windows PE Updates
	echo.
	echo.  [4]   Integrate Windows Update Satisfy Updates
	echo.
	echo.
	echo.
	echo.
)

echo.
echo.	
echo.
echo.
echo.  [X]   Go Back
echo.
echo.===============================================================================
echo.
if "%SelectedSourceOS%" equ "w7" (
	choice /C:12X /N /M "Enter Your Choice : "
	if errorlevel 3 goto :IntW7WHDUpdatesMenu
	if errorlevel 2 call :IntUpdates "Windows10"
	if errorlevel 1 call :IntUpdates "WAT"
)

if "%SelectedSourceOS%" equ "w81" (
	choice /C:1234X /N /M "Enter Your Choice : "
	if errorlevel 5 goto :IntWHDUpdatesMenu
	if errorlevel 4 call :IntUpdates "WUSatisfy"
	if errorlevel 3 call :IntUpdates "WinPE"
	if errorlevel 2 call :IntUpdates "Windows10"
	if errorlevel 1 call :IntUpdates "NET35"
)

:IntWHDExtraMenu
cls

echo.===============================================================================
echo.                MSMG ToolKit - Integrate WHD Extra Updates Menu
echo.===============================================================================

if "%SelectedSourceOS%" equ "w7" if "%IsW7SP1CRUSelected%" equ "0" (
	echo.  [1]   Active Directory Lightweight Directory Services ^(ADLDS^)
	echo.
	echo.  [2]   File Management API	
	echo.
	echo.  [3]   Microsoft Virtual PC
	echo.
	echo.  [4]   Windows Features Updates
	echo.
	echo.  [5]   Sync Agent for Domain Environmernts ^(Work Folders^)
	echo.	
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.  
	echo.  [X]   Go Back
	echo.===============================================================================
	echo.
)

if "%SelectedSourceOS%" equ "w7" if "%IsW7SP1CRUSelected%" equ "1" (
	echo.
	echo.  [1]   Active Directory Lightweight Directory Services ^(ADLDS^)
	echo.
	echo.  [2]   File Management API	
	echo.
	echo.  [3]   Microsoft Virtual PC
	echo.	
	echo.  [4]   Sync Agent for Domain Environmernts ^(Work Folders^)
	echo.	
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.  [X]   Go Back
	echo.	
	echo.===============================================================================
	echo.
)

if "%SelectedSourceOS%" equ "w7" if "%IsW7SP1CRUSelected%" equ "0" (
	choice /C:12345X /N /M "Enter Your Choice : "
	if errorlevel 6 goto :IntW7WHDUpdatesMenu
	if errorlevel 5 call :IntUpdates "WorkFolders"
	if errorlevel 4 call :IntUpdates "Features"	
	if errorlevel 3 call :IntUpdates "VirtualPC"
	if errorlevel 2 call :IntUpdates "FMApi"
	if errorlevel 1 call :IntUpdates "ADLDS"
)

if "%SelectedSourceOS%" equ "w7" if "%IsW7SP1CRUSelected%" equ "1" (
	choice /C:1234X /N /M "Enter Your Choice : "
	if errorlevel 5 goto :IntW7WHDUpdatesMenu
	if errorlevel 4 call :IntUpdates "WorkFolders"
	if errorlevel 3 call :IntUpdates "VirtualPC"
	if errorlevel 2 call :IntUpdates "FMApi"
	if errorlevel 1 call :IntUpdates "ADLDS"
)

::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate WHD Baseline Updates to Windows Setup Boot Image
::-------------------------------------------------------------------------------------------
:IntWHDBaseBoot

setlocal

cls
echo.===============================================================================
if "%SelectedSourceOS%" equ "w81" echo.   MSMG ToolKit - Integrate WHD Baseline Updates to Windows Setup Boot Image
if "%SelectedSourceOS%" equ "w10" echo.    MSMG ToolKit - Integrate WHD General Updates to Windows Setup Boot Image
echo.===============================================================================
echo.
if "%IsBootImageSelected%" equ "No" (
	echo.Windows Setup Boot Image is not selected...
	echo.
	echo.Please choose Windows Setup Boot Image while selecting Source...
	goto :Stop	
)

:: Getting Boot Image Index Architecture
call :GetImageArchitecture "%BootWim%", 1 >nul

:: Settings WHD Baseline Updates folder path
if "%SelectedSourceOS%" equ "w81" set "Updates=%WHD%\%SelectedSourceOS%\%ImageArchitecture%\Baseline"
if "%SelectedSourceOS%" equ "w10" set "Updates=%WHD%\%SelectedSourceOS%\%ImageArchitecture%"

:: Checking whether WHD Baseline Updates folder is empty
:: Windows 8.1 RTM (Build : 6.3.9600.16384)
if "%SelectedSourceOS%" equ "w81" if %ImageServicePackBuild% equ 16384 (
	if not exist "%Updates%\RTM\*.msu" if not exist "%Updates%\RTM\*.cab" (
		echo.WHD Baseline Updates folder ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Baseline\RTM^> is empty...
	)
	if not exist "%Updates%\*.msu" if not exist "%Updates%\*.cab" (
		echo.
		echo.WHD Baseline Updates folder ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Baseline^> is empty...
	)
	echo.
	echo.Please copy WHD Baseline Updates to respective folder...
	goto :Stop
)

:: Windows 8.1 Post-RTM
if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" neq "16384" (
	if not exist "%Updates%\*.msu" if not exist "%Updates%\*.cab" (
		echo.WHD Baseline Updates folder ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Baseline^> is empty...
		echo.
		echo.Please copy WHD Baseline Updates to respective folder...
		goto :Stop
	)
)

:: Windows 10
if "%SelectedSourceOS%" equ "w10" if not exist "%Updates%\Cumulative\*.msu" if not exist "%Updates%\Cumulative\*.cab" (
	echo.WHD General Updates folder ^<WHD\w10\%ImageArchitecture%\Cumulative^> is empty...
	echo.
	echo.Please copy WHD General Updates to respective folder...
	goto :Stop
)
echo.-------------------------------------------------------------------------------
if "%SelectedSourceOS%" equ "w81" echo.####Starting Integrating WHD Baseline Updates to Windows Setup Boot Image######
if "%SelectedSourceOS%" equ "w10" echo.####Starting Integrating WHD General Updates to Windows Setup Boot Image#######
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Boot.wim
echo.    Image Index              : 1, 2
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.    Image Edition            : %ImageEdition%
echo.    Image Default Language   : %ImageDefaultLanguage%
echo.
echo.-------------------------------------------------------------------------------
if "%SelectedSourceOS%" equ "w81" echo.####Processing WHD Baseline Updates Packages###################################
if "%SelectedSourceOS%" equ "w10" echo.####Processing WHD General Updates Packages####################################
echo.-------------------------------------------------------------------------------
echo.
:: Creating WHD Baseline Updates Temporary folder
if "%SelectedSourceOS%" equ "w81" echo.Creating WHD Baseline Updates Temporary folder...
if "%SelectedSourceOS%" equ "w10" echo.Creating WHD General Updates Temporary folder...
call :RemoveFolder "%Temp%\Updates"
call :CreateFolder "%Temp%\Updates"
echo.

:: Extracting .CAB files From .MSU Package files to CAB Temporary folder
echo.Extracting .CAB Package files to Temporary folder...

:: Windows 8.1 RTM (Build : 6.3.9600.16384)
if "%SelectedSourceOS%" equ "w81" if %ImageServicePackBuild% equ 16384 (
	if exist "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\RTM\Windows8.1-KB2919355-%ImageArchitecture%*.msu" expand "%Updates%\RTM\Windows8.1-KB2919355-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\RTM\Windows8.1-KB2932046-%ImageArchitecture%*.msu" expand "%Updates%\RTM\Windows8.1-KB2932046-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB2934018-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB2934018-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\RTM\Windows8.1-KB2937592-%ImageArchitecture%*.msu" expand "%Updates%\RTM\Windows8.1-KB2937592-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\RTM\Windows8.1-KB2938439-%ImageArchitecture%*.msu" expand "%Updates%\RTM\Windows8.1-KB2938439-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\RTM\Windows8.1-KB2938772-%ImageArchitecture%*.msu" expand "%Updates%\RTM\Windows8.1-KB2938772-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul

	:: Copy .CAB files from .MSU package files to CAB Temporary folder
	if exist "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\RTM\Windows8.1-KB2919355-%ImageArchitecture%*.cab" %XCopy% "%Updates%\RTM\Windows8.1-KB2919355-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\RTM\Windows8.1-KB2932046-%ImageArchitecture%*.cab" %XCopy% "%Updates%\RTM\Windows8.1-KB2932046-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB2934018-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB2934018-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\RTM\Windows8.1-KB2937592-%ImageArchitecture%*.cab" %XCopy% "%Updates%\RTM\Windows8.1-KB2937592-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\RTM\Windows8.1-KB2938439-%ImageArchitecture%*.cab" %XCopy% "%Updates%\RTM\Windows8.1-KB2938439-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\RTM\Windows8.1-KB2938772-%ImageArchitecture%*.cab" %XCopy% "%Updates%\RTM\Windows8.1-KB2938772-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
)

:: Windows 8.1 with Update (IR3 Build : 6.3.9600.17031)
if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" equ "17031" (
	if exist "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB2934018-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB2934018-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul

	:: Copy .CAB files from .MSU package files to CAB Temporary folder
	if exist "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB2934018-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB2934018-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul	
	if exist "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
)

:: Windows 8.1 with Update Refresh (IR4 Build : 6.3.9600.17056)
if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" equ "17056" (
	if exist "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul

	:: Copy .CAB files from .MSU package files to CAB Temporary folder
	if exist "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
)

:: Windows 8.1 with Update Refresh (IR5 Build : 6.3.9600.17415)
if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" equ "17415" (
	if exist "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul

	:: Copy .CAB files from .MSU package files to CAB Temporary folder
	if exist "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
)

:: Windows 10
if "%SelectedSourceOS%" equ "w10" (
	for /d %%j in (ServicingStack, Cumulative) do (
		if exist "%Updates%\%%j\*%ImageArchitecture%*.msu" (
			call :CreateFolder "%Temp%\Updates\%%j"
			expand -R "%Updates%\%%j\*%ImageArchitecture%*.msu" -F:*.cab "%Temp%\Updates\%%j" >nul
			call :RemoveFile "%Temp%\Updates\%%j\wsusscan.cab"
			expand -R "%Temp%\Updates\%%j\*.cab" -F:* "%Temp%\Updates\%%j" >nul
			if "%%j" equ "Cumulative" if exist "%Temp%\Updates\%%j\Cab_*.cab" expand -R "%Temp%\Updates\%%j\Cab_*.cab" -F:* "%Temp%\Updates\%%j" >nul
			call :RemoveFile "%Temp%\Updates\%%j\*.cab"
		)
		if exist "%Updates%\%%j\*%ImageArchitecture%*.cab" (
			call :CreateFolder "%Temp%\Updates\%%j"
			expand -R "%Updates%\%%j\*%ImageArchitecture%*.cab" -F:* "%Temp%\Updates\%%j" >nul
			if "%%j" equ "Cumulative" if exist "%Temp%\Updates\%%j\Cab_*.cab" expand -R "%Temp%\Updates\%%j\Cab_*.cab" -F:* "%Temp%\Updates\%%j" >nul
			call :RemoveFile "%Temp%\Updates\%%j\*.cab"
		)
	)
	
	for /d %%j in (WinPE, SetupMedia) do (	
		if exist "%Updates%\%%j\*%ImageArchitecture%*.msu" (
			call :CreateFolder "%Temp%\Updates\%%j"
			expand -R "%Updates%\%%j\*%ImageArchitecture%*.msu" -F:*.cab "%Temp%\Updates\%%j" >nul
			call :RemoveFile "%Temp%\Updates\%%j\wsusscan.cab"		
		)
	
		if exist "%Updates%\%%j\*%ImageArchitecture%*.cab" (
			call :CreateFolder "%Temp%\Updates\%%j"
			%XCopy% "%Updates%\%%j\*%ImageArchitecture%*.cab" "%Temp%\Updates\%%j" >nul
		)
	)	
)
echo.
echo.Finished Extracting .CAB Package files to Temporary folder...
echo.
echo.-------------------------------------------------------------------------------
if "%SelectedSourceOS%" equ "w81" echo.####Integrating WHD Baseline Updates to Windows Setup Boot Image###############
if "%SelectedSourceOS%" equ "w10" echo.####Integrating WHD General Updates to Windows Setup Boot Image################
echo.-------------------------------------------------------------------------------
echo.
:: Windows 8.1 RTM (Build : 6.3.9600.16384)
if "%SelectedSourceOS%" equ "w81" if %ImageServicePackBuild% equ 16384 (
	for /l %%i in (1, 1, 2) do (
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Prerequisite Update ^(KB3021910^) to Boot Image
		echo.---------------------------------[Index : %%i]-----------------------------------
		call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Update ^(KB2919355^) to Boot Image
		echo.---------------------------------[Index : %%i]-----------------------------------
		call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB2919355-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB3000850^) to Boot Image
		echo.---------------------------------[Index : %%i]-----------------------------------
		call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB3000850-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB2932046^) to Boot Image
		echo.---------------------------------[Index : %%i]-----------------------------------
		call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB2932046-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB2934018^) to Boot Image
		echo.---------------------------------[Index : %%i]-----------------------------------
		call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB2934018-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB2937592^) to Boot Image
		echo.---------------------------------[Index : %%i]-----------------------------------
		call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB2937592-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB2938439^) to Boot Image
		echo.---------------------------------[Index : %%i]-----------------------------------
		call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB2938439-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB2938772^) to Boot Image
		echo.---------------------------------[Index : %%i]-----------------------------------
		call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB2938772-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB3003057^) to Boot Image
		echo.---------------------------------[Index : %%i]-----------------------------------
		call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB3003057-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB4540725^) to Boot Image
		echo.---------------------------------[Index : %%i]-----------------------------------
		call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB4540725-%ImageArchitecture%.cab"
	)
)

:: Windows 8.1 with Update (IR3 Build : 6.3.9600.17031)
if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" equ "17031" (
	for /l %%i in (1, 1, 2) do (
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB3021910^) to Boot Image
		echo.---------------------------------[Index : %%i]-----------------------------------
		call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB4540725^) to Boot Image
		echo.---------------------------------[Index : %%i]-----------------------------------
		call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB4540725-%ImageArchitecture%.cab"    
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB3000850^) to Boot Image
		echo.---------------------------------[Index : %%i]-----------------------------------
		call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB3000850-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB2934018^) to Boot Image
		echo.---------------------------------[Index : %%i]-----------------------------------
		call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB2934018-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB3003057^) to Boot Image
		echo.---------------------------------[Index : %%i]-----------------------------------
		call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB3003057-%ImageArchitecture%.cab"
	)
)

:: Windows 8.1 with Update (IR4 Build : 6.3.9600.17056)
if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" equ "17056" (
	for /l %%i in (1, 1, 2) do (
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB3021910^) to Boot Image
		echo.---------------------------------[Index : %%i]-----------------------------------
		call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB4540725^) to Boot Image
		echo.---------------------------------[Index : %%i]-----------------------------------
		call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB4540725-%ImageArchitecture%.cab"    
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB3000850^) to Boot Image
		echo.---------------------------------[Index : %%i]-----------------------------------
		call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB3000850-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB3003057^) to Boot Image
		echo.---------------------------------[Index : %%i]-----------------------------------
		call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB3003057-%ImageArchitecture%.cab"
	)
)

:: Windows 8.1 with Update Refresh (IR5 Build : 6.3.9600.17415)
if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" equ "17415" (
	for /l %%i in (1, 1, 2) do (
		if exist "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB3021910^) to Boot Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab"
		)
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB4540725^) to Boot Image
		echo.---------------------------------[Index : %%i]-----------------------------------
		call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB4540725-%ImageArchitecture%.cab"		
	)
)

:: Windows 10
if "%SelectedSourceOS%" equ "w10" (
	for /l %%i in (1, 1, 2) do (
		if exist "%Temp%\Updates\ServicingStack\Update.mum" (
			if "%ImageBuild%" equ "10240" if "%ImageServicePackBuild%" equ "16384" (
				echo.-------------------------------------------------------------------------------
				echo.Applying Windows 10 v1507 Cumulative Update Integration Fix
				echo.-------------------------------------------------------------------------------
				if "%ImageArchitecture%" equ "x86" call :ApplyImage "%W10CUFix%\TH1CUFix.tpk", 1, "%BootMount%\%%i"
				if "%ImageArchitecture%" equ "x64" call :ApplyImage "%W10CUFix%\TH1CUFix.tpk", 2, "%BootMount%\%%i"
				call :MountImageRegistry "%BootMount%\%%i"
				call :ImportRegistry2Image "%W10CUFix%\TH1CUFix_%ImageArchitecture%.reg" 2>nul
				call :UnMountImageRegistry
			)
			if "%ImageArchitecture%" equ "x86" if "%ImageBuild%" equ "14393" if "%ImageServicePackBuild%" equ "0" (
				echo.-------------------------------------------------------------------------------
				echo.Applying Windows 10 v1607 Cumulative Update Integration Fix
				echo.-------------------------------------------------------------------------------
				call :ApplyImage "%W10CUFix%\RS1CUFix.tpk", 1, "%BootMount%\%%i"
				call :MountImageRegistry "%BootMount%\%%i"
				call :ImportRegistry2Image "%W10CUFix%\RS1CUFix.reg" 2>nul
				call :UnMountImageRegistry
			)
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows 10 Servicing Stack Update to Boot Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\ServicingStack"
		)
		if exist "%Temp%\Updates\Cumulative\Update.mum" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows 10 Cumulative Update to Boot Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Cumulative"
		)
	)
	if exist "%Temp%\Updates\WinPE\*.cab" (
		echo.-------------------------------------------------------------------------------
		echo.Integrating Windows 10 WinPE Updates to Boot Image
		echo.---------------------------------[Index : 2]-----------------------------------
		call :AddPackage "%BootMount%\2", "%Temp%\Updates\WinPE"
	)
	if exist "%Temp%\Updates\SetupMedia\*.cab" (
		echo.-------------------------------------------------------------------------------
		echo.Integrating Windows 10 Setup Media Update
		echo.-------------------------------------------------------------------------------
		echo.
		echo.Extracting Windows 10 Setup Media Update to ^<DVD^> folder...
		expand -R "%Temp%\Updates\SetupMedia\*.cab" -F:* "%DVD%\sources" >nul
		cd /d "%DVD%\sources\" >nul
		for /d %%i in (ar-SA,bg-BG,cs-CZ,da-DK,de-DE,el-GR,en-GB,en-US,es-ES,es-MX,et-EE,fi-FI,fr-CA,fr-FR,he-IL,hr-HR,hu-HU,it-IT,ja-JP,ko-KR,lt-LT,lv-LV,nb-NO,nl-NL,pl-PL,pt-BR,pt-PT,ro-RO,ru-RU,sk-SK,sl-SI,sr-Latn-RS,sv-SE,th-TH,tr-TR,uk-UA,zh-CN,zh-HK,zh-TW) do (
			if "%ImageDefaultLanguage%" neq "%%i" rd /q /s "%DVD%\sources\%%i" >nul 2>&1
		)
		cd /d "%ROOT%\" >nul
		echo.
	)
)

if "%IsLogsEnabled%" equ "Yes" (
	echo.-------------------------------------------------------------------------------
	if "%SelectedSourceOS%" equ "w81" echo.####Generating WHD Baseline Updates Integration Log Files######################
	if "%SelectedSourceOS%" equ "w10" echo.####Generating WHD General Updates Integration Log Files#######################
	echo.-------------------------------------------------------------------------------
	echo.
	for /l %%k in (1, 1, 2) do (
		if "%SelectedSourceOS%" equ "w81" echo.Writing WHD Baseline Updates Integration [Boot.wim, Index : %%k] Log...
		if "%SelectedSourceOS%" equ "w10" echo.Writing WHD General Updates Integration [Boot.wim, Index : %%k] Log...
		call :GetPackages "%BootMount%\%%k", "Boot-%%k.txt"
		echo.
	)
)
echo.-------------------------------------------------------------------------------
echo.####Cleaning Up Temporary Files ^& Folders#####################################
echo.-------------------------------------------------------------------------------
echo.
if "%SelectedSourceOS%" equ "w81" echo.Cleaning Up WHD Baseline Updates Temporary folder...
if "%SelectedSourceOS%" equ "w10" echo.Cleaning Up WHD General Updates Temporary folder...
call :RemoveFolder "%Temp%\Updates"
echo.
echo.-------------------------------------------------------------------------------
if "%SelectedSourceOS%" equ "w81" echo.####Finished Integrating WHD Baseline Updates to Windows Setup Boot Image######
if "%SelectedSourceOS%" equ "w10" echo.####Finished Integrating WHD General Updates to Windows Setup Boot Image#######
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set Updates=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate WHD Baseline Updates to Windows Setup Install Image
::-------------------------------------------------------------------------------------------
:IntWHDBaseInstall

setlocal

cls
echo.===============================================================================
if "%SelectedSourceOS%" equ "w81" echo. MSMG ToolKit - Integrate WHD Baseline Updates to Windows Setup Install Image
if "%SelectedSourceOS%" equ "w10" echo.  MSMG ToolKit - Integrate WHD General Updates to Windows Setup Install Image
echo.===============================================================================
echo.
:: Getting Install Image Index Architecture
if "%ImageIndexNo%" equ "*" call :GetImageArchitecture "%InstallWim%", 1 >nul
if "%ImageIndexNo%" neq "*" call :GetImageArchitecture "%InstallWim%", %ImageIndexNo% >nul

:: Setting Package Architecture
if "%ImageArchitecture%" equ "x86" set "PackageArchitecture=x86"
if "%ImageArchitecture%" equ "x64" set "PackageArchitecture=amd64"
if "%ImageArchitecture%" equ "arm64" set "PackageArchitecture=arm64"

:: Settings WHD Baseline Updates folder path
if "%SelectedSourceOS%" equ "w81" set "Updates=%WHD%\%SelectedSourceOS%\%ImageArchitecture%\Baseline"
if "%SelectedSourceOS%" equ "w10" set "Updates=%WHD%\%SelectedSourceOS%\%ImageArchitecture%"

:: Checking whether WHD Baseline Updates folder is empty
:: Windows 8.1 RTM (Build : 6.3.9600.16384)
if "%SelectedSourceOS%" equ "w81" if %ImageServicePackBuild% equ 16384 (
	if not exist "%Updates%\RTM\*.msu" if not exist "%Updates%\RTM\*.cab" (
		echo.WHD Baseline Updates Folder ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Baseline\RTM^> is empty...
	)
	if not exist "%Updates%\*.msu" if not exist "%Updates%\*.cab" (
		echo.
		echo.WHD Baseline Updates Folder ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Baseline^> is empty...
	)
	echo.
	echo.Please copy WHD Baseline Updates to respective folder...
	goto :Stop
)

:: Windows 8.1 Post-RTM
if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" neq "16384" (
	if not exist "%Updates%\*.msu" if not exist "%Updates%\*.cab" (
		echo.WHD Baseline Updates Folder ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Baseline^> is empty...
		echo.
		echo.Please copy WHD Baseline Updates to respective folder...
		goto :Stop
	)
)

:: Windows 10
if "%SelectedSourceOS%" equ "w10" if not exist "%Updates%\Cumulative\*.msu" if not exist "%Updates%\Cumulative\*.cab" (
	echo.WHD General Updates folder ^<WHD\w10\%ImageArchitecture%\Cumulative^> is empty...
	echo.
	echo.Please copy WHD General Updates to respective folder...
	goto :Stop
)

echo.-------------------------------------------------------------------------------
if "%SelectedSourceOS%" equ "w81" echo.##################Starting Integrating WHD Baseline Updates to Install Image###
if "%SelectedSourceOS%" equ "w10" echo.##################Starting Integrating WHD General Updates to Install Image####
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if "%ImageIndexNo%" neq "*" if not "%ImageCount%" gtr "9" echo.    Image Indexes            : %ImageIndexNo%
if "%ImageIndexNo%" neq "*" if "%ImageCount%" gtr "9" echo.    Image Indexes            : %ImageIndexNo%
if "%ImageIndexNo%" equ "*" if not "%ImageCount%" gtr "9" echo.    Image Indexes            : 1-%ImageCount%
if "%ImageIndexNo%" equ "*" if "%ImageCount%" gtr "9" echo.    Image Indexes            : 1-%ImageCount%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
if "%ImageIndexNo%" neq "*" echo.    Image Edition            : %ImageEdition%
echo.    Image Default Language   : %ImageDefaultLanguage%
echo.
echo.-------------------------------------------------------------------------------
if "%SelectedSourceOS%" equ "w81" echo.####Processing WHD Baseline Updates Packages###################################
if "%SelectedSourceOS%" equ "w10" echo.####Processing WHD General Updates Packages####################################
echo.-------------------------------------------------------------------------------
echo.
:: Creating WHD Baseline Updates Temporary folder
if "%SelectedSourceOS%" equ "w81" echo.Creating WHD Baseline Updates Temporary folder...
if "%SelectedSourceOS%" equ "w10" echo.Creating WHD General Updates Temporary folder...
call :RemoveFolder "%Temp%\Updates"
call :CreateFolder "%Temp%\Updates"
echo.

:: Extracting .CAB files from .MSU Package files to CAB Temporary folder
echo.Extracting .CAB Package files to Temporary folder...

:: Windows 8.1 RTM (Build : 6.3.9600.16384)
if "%SelectedSourceOS%" equ "w81" if %ImageServicePackBuild% equ 16384 (
	if exist "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\RTM\Windows8.1-KB2919355-%ImageArchitecture%*.msu" expand "%Updates%\RTM\Windows8.1-KB2919355-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\RTM\Windows8.1-KB2932046-%ImageArchitecture%*.msu" expand "%Updates%\RTM\Windows8.1-KB2932046-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB2934018-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB2934018-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\RTM\Windows8.1-KB2937592-%ImageArchitecture%*.msu" expand "%Updates%\RTM\Windows8.1-KB2937592-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\RTM\Windows8.1-KB2938439-%ImageArchitecture%*.msu" expand "%Updates%\RTM\Windows8.1-KB2938439-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\RTM\Windows8.1-KB2938772-%ImageArchitecture%*.msu" expand "%Updates%\RTM\Windows8.1-KB2938772-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3014442-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB3014442-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul

	:: Copy .CAB files from .MSU package files to CAB Temporary folder
	if exist "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\RTM\Windows8.1-KB2919355-%ImageArchitecture%*.cab" %XCopy% "%Updates%\RTM\Windows8.1-KB2919355-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\RTM\Windows8.1-KB2932046-%ImageArchitecture%*.cab" %XCopy% "%Updates%\RTM\Windows8.1-KB2932046-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB2934018-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB2934018-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\RTM\Windows8.1-KB2937592-%ImageArchitecture%*.cab" %XCopy% "%Updates%\RTM\Windows8.1-KB2937592-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\RTM\Windows8.1-KB2938439-%ImageArchitecture%*.cab" %XCopy% "%Updates%\RTM\Windows8.1-KB2938439-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\RTM\Windows8.1-KB2938772-%ImageArchitecture%*.cab" %XCopy% "%Updates%\RTM\Windows8.1-KB2938772-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3014442-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB3014442-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
)

:: Windows 8.1 with Update (IR3 Build : 6.3.9600.17031)
if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" equ "17031" (
	if exist "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB2934018-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB2934018-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3014442-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB3014442-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul

	:: Copy .CAB files from .MSU package files to CAB Temporary folder
	if exist "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB2934018-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB2934018-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul	
	if exist "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3014442-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB3014442-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
)

:: Windows 8.1 with Update Refresh (IR4 Build : 6.3.9600.17056)
if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" equ "17056" (
	if exist "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3014442-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB3014442-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul

	:: Copy .CAB files from .MSU package files to CAB Temporary folder
	if exist "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3014442-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB3014442-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
)

:: Windows 8.1 with Update Refresh (IR5 Build : 6.3.9600.17415)
if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" equ "17415" (
	if exist "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul

	:: Copy .CAB files from .MSU package files to CAB Temporary folder
	if exist "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
)

:: Windows 10
if "%SelectedSourceOS%" equ "w10" (
	for /d %%j in (ServicingStack, Cumulative, Enablement, FlashPlayer) do (
		if exist "%Updates%\%%j\*%ImageArchitecture%*.msu" (
			call :CreateFolder "%Temp%\Updates\%%j"
			expand -R "%Updates%\%%j\*%ImageArchitecture%*.msu" -F:*.cab "%Temp%\Updates\%%j" >nul
			call :RemoveFile "%Temp%\Updates\%%j\wsusscan.cab"
			expand -R "%Temp%\Updates\%%j\*.cab" -F:* "%Temp%\Updates\%%j" >nul
			if "%%j" equ "Cumulative" if exist "%Temp%\Updates\%%j\Cab_*.cab" expand -R "%Temp%\Updates\%%j\Cab_*.cab" -F:* "%Temp%\Updates\%%j" >nul
			call :RemoveFile "%Temp%\Updates\%%j\*.cab"
		)
		if exist "%Updates%\%%j\*%ImageArchitecture%*.cab" (
			call :CreateFolder "%Temp%\Updates\%%j"
			expand -R "%Updates%\%%j\*%ImageArchitecture%*.cab" -F:* "%Temp%\Updates\%%j" >nul
			if "%%j" equ "Cumulative" if exist "%Temp%\Updates\%%j\Cab_*.cab" expand -R "%Temp%\Updates\%%j\Cab_*.cab" -F:* "%Temp%\Updates\%%j" >nul
			call :RemoveFile "%Temp%\Updates\%%j\*.cab"
		)
	)
	
	for /d %%j in (Dynamic, NetCumulative, WinPE) do (	
		if exist "%Updates%\%%j\*%ImageArchitecture%*.msu" (
			call :CreateFolder "%Temp%\Updates\%%j"
			expand -R "%Updates%\%%j\*%ImageArchitecture%*.msu" -F:*.cab "%Temp%\Updates\%%j" >nul
			call :RemoveFile "%Temp%\Updates\%%j\wsusscan.cab"		
		)
	
		if exist "%Updates%\%%j\*%ImageArchitecture%*.cab" (
			call :CreateFolder "%Temp%\Updates\%%j"
			%XCopy% "%Updates%\%%j\*%ImageArchitecture%*.cab" "%Temp%\Updates\%%j" >nul
		)
	)	
)
echo.
echo.Finished Extracting .CAB Package files to Temporary folder...
echo.
echo.-------------------------------------------------------------------------------
if "%SelectedSourceOS%" equ "w81" echo.####Integrating WHD Baseline Updates to Windows Setup Install Image############
if "%SelectedSourceOS%" equ "w10" echo.####Integrating WHD General Updates to Windows Setup Install Image#############
echo.-------------------------------------------------------------------------------
echo.
if "%ImageIndexNo%" equ "*" (
	for /L %%i in (1, 1, %ImageCount%) do (
		:: Windows 8.1 RTM (Build : 6.3.9600.16384)
		if "%SelectedSourceOS%" equ "w81" if %ImageServicePackBuild% equ 16384 (
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Prerequisite Update ^(KB3021910^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Update ^(KB2919355^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB2919355-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB3000850^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB3000850-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB2932046^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB2932046-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB2934018^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB2934018-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB2937592^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB2937592-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB2938439^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB2938439-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB2938772^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB2938772-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB3003057^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB3003057-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB3014442^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB3014442-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB4540725^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB4540725-%ImageArchitecture%.cab"
		)

		:: Windows 8.1 with Update (IR3 Build : 6.3.9600.17031)
		if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" equ "17031" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB3021910^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB4540725^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB4540725-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB3000850^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB3000850-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB2934018^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB2934018-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB3003057^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB3003057-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB3014442^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB3014442-%ImageArchitecture%.cab"
		)

		:: Windows 8.1 with Update (IR4 Build : 6.3.9600.17056)
		if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" equ "17056" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB3021910^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB4540725^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB4540725-%ImageArchitecture%.cab"			
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB3000850^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB3000850-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB3003057^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB3003057-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB3014442^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB3014442-%ImageArchitecture%.cab"
		)

		:: Windows 8.1 with Update Refresh (IR5 Build : 6.3.9600.17415)
		if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" equ "17415" (
			if exist "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating WHD Baseline Feature Pack Update ^(KB3021910^) to Install Image
				echo.---------------------------------[Index : %%i]-----------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab"
			)
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB4540725^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB4540725-%ImageArchitecture%.cab"
		)

		:: Windows 10
		if "%SelectedSourceOS%" equ "w10" (
			:: Importing Registry fix to Enable Integrating Windows 10 LTSB 2015 Updates to Windows 10 Non-LTSB Editions.
			if "%ImageBuild%" equ "10240" if "%ImageEdition%" neq "EnterpriseS" if "%ImageEdition%" neq "EnterpriseSN" (
				call :MountImageRegistry "%InstallMount%\%%i"
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "InstallClient" /t REG_SZ /d "DISM Package Manager Provider" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "InstallName" /t REG_SZ /d "Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384.mum" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "InstallLocation" /t REG_SZ /d "\\?\d:\th1.bin.%PackageArchitecture%fre\csi\pkgs\\" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "CurrentState" /t REG_DWORD /d "112" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "SelfUpdate" /t REG_DWORD /d "0" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "Visibility" /t REG_DWORD /d "1" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "InstallTimeHigh" /t REG_DWORD /d "30649479" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "InstallTimeLow" /t REG_DWORD /d "1431244152" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "InstallUser" /t REG_SZ /d "S-1-5-18" /f >nul
				call :UnMountImageRegistry
			)

			:: Importing Registry fix to Enable Integrating Windows 10 Education/Enterprise Updates to Windows 10 Non Education/Enterprise (N) Editions.
			if "%ImageBuild%" equ "10586" if "%ImageEdition%" neq "Education" if "%ImageEdition%" neq "EducationN" if "%ImageEdition%" neq "Enterprise" if "%ImageEdition%" neq "EnterpriseN" (
				call :MountImageRegistry "%InstallMount%\%%i"
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "InstallClient" /t REG_SZ /d "DISM Package Manager Provider" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "InstallName" /t REG_SZ /d "Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0.mum" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "InstallLocation" /t REG_SZ /d "\\?\d:\th2.bin.%PackageArchitecture%fre\csi\pkgs\\" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "CurrentState" /t REG_DWORD /d "112" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "SelfUpdate" /t REG_DWORD /d "0" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "Visibility" /t REG_DWORD /d "1" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "InstallTimeHigh" /t REG_DWORD /d "30649479" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "InstallTimeLow" /t REG_DWORD /d "1431244152" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "InstallUser" /t REG_SZ /d "S-1-5-18" /f >nul
				call :UnMountImageRegistry
			)

			:: Importing Registry fix to Enable Integrating Windows 10 Education/Enterprise/LTSB 2016 Updates to Windows 10 Non Education/Enterprise/LTSB 2016 Editions.
			if "%ImageBuild%" equ "14393" if "%ImageEdition%" neq "Education" if "%ImageEdition%" neq "EducationN" if "%ImageEdition%" neq "Enterprise" if "%ImageEdition%" neq "EnterpriseN" if "%ImageEdition%" neq "EnterpriseS" if "%ImageEdition%" neq "EnterpriseSN" (
				call :MountImageRegistry "%InstallMount%\%%i"
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "InstallClient" /t REG_SZ /d "DISM Package Manager Provider" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "InstallName" /t REG_SZ /d "Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0.mum" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "InstallLocation" /t REG_SZ /d "\\?\d:\rs1.bin.%PackageArchitecture%fre\csi\pkgs\\" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "CurrentState" /t REG_DWORD /d "112" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "SelfUpdate" /t REG_DWORD /d "0" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "Visibility" /t REG_DWORD /d "1" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "InstallTimeHigh" /t REG_DWORD /d "30649479" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "InstallTimeLow" /t REG_DWORD /d "1431244152" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "InstallUser" /t REG_SZ /d "S-1-5-18" /f >nul
				call :UnMountImageRegistry
			)

			:: Importing Registry fix to Enable Integrating Windows Updates to Windows 10 Pro for Workstation Edition.
			if "%ImageBuild%" equ "16299" if "%ImageEdition%" equ "ProfessionalWorkstation" (
				call :MountImageRegistry "%InstallMount%\%%i"
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallClient" /t REG_SZ /d "DISM Package Manager Provider" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallName" /t REG_SZ /d "Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15.mum" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallLocation" /t REG_SZ /d "\\?\d:\rs2.bin.%PackageArchitecture%fre\csi\pkgs\\" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "CurrentState" /t REG_DWORD /d "112" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "SelfUpdate" /t REG_DWORD /d "0" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "Visibility" /t REG_DWORD /d "1" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallTimeHigh" /t REG_DWORD /d "30649479" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallTimeLow" /t REG_DWORD /d "1431244152" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallUser" /t REG_SZ /d "S-1-5-18" /f >nul
				call :UnMountImageRegistry
			)
			
			:: Importing Registry fix to Enable Integrating Windows Updates to Windows 10 Pro for Workstation 'N' Edition.
			if "%ImageBuild%" equ "16299" if "%ImageEdition%" equ "ProfessionalWorkstationN" (
				call :MountImageRegistry "%InstallMount%\%%i"
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallClient" /t REG_SZ /d "DISM Package Manager Provider" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallName" /t REG_SZ /d "Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15.mum" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallLocation" /t REG_SZ /d "\\?\d:\rs2.bin.%PackageArchitecture%fre\csi\pkgs\\" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "CurrentState" /t REG_DWORD /d "112" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "SelfUpdate" /t REG_DWORD /d "0" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "Visibility" /t REG_DWORD /d "1" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallTimeHigh" /t REG_DWORD /d "30649479" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallTimeLow" /t REG_DWORD /d "1431244152" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallUser" /t REG_SZ /d "S-1-5-18" /f >nul
				call :UnMountImageRegistry
			)
		
			if exist "%Temp%\Updates\ServicingStack\Update.mum" (
				if "%ImageBuild%" equ "10240" if "%ImageServicePackBuild%" equ "16384" (
					echo.-------------------------------------------------------------------------------
					echo.Applying Windows 10 v1507 Cumulative Update Integration Fix
					echo.-------------------------------------------------------------------------------
					if "%ImageArchitecture%" equ "x86" call :ApplyImage "%W10CUFix%\TH1CUFix.tpk", 1, "%InstallMount%\%%i"
					if "%ImageArchitecture%" equ "x64" call :ApplyImage "%W10CUFix%\TH1CUFix.tpk", 2, "%InstallMount%\%%i"
					call :MountImageRegistry "%InstallMount%\%%i"
					call :ImportRegistry2Image "%W10CUFix%\TH1CUFix_%ImageArchitecture%.reg" 2>nul
					call :UnMountImageRegistry
				)
				if "%ImageArchitecture%" equ "x86" if "%ImageBuild%" equ "14393" if "%ImageServicePackBuild%" equ "0" (
					echo.-------------------------------------------------------------------------------
					echo.Applying Windows 10 v1607 Cumulative Update Integration Fix
					echo.-------------------------------------------------------------------------------
					call :ApplyImage "%W10CUFix%\RS1CUFix.tpk", 1, "%InstallMount%\%%i"
					call :MountImageRegistry "%InstallMount%\%%i"
					call :ImportRegistry2Image "%W10CUFix%\RS1CUFix.reg" 2>nul
					call :UnMountImageRegistry
				)
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows 10 Servicing Stack Update to Install Image
				echo.---------------------------------[Index : %%i]-----------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\ServicingStack"
			)
			if exist "%Temp%\Updates\Dynamic\*.cab" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows 10 Dynamic Updates to Install Image
				echo.---------------------------------[Index : %%i]-----------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Dynamic"
			)
			if exist "%Temp%\Updates\FlashPlayer\Update.mum" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Adobe Flash Player Security Update to Install Image
				echo.---------------------------------[Index : %%i]-----------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\FlashPlayer"
			)
			if exist "%Temp%\Updates\NetCumulative\*.cab" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows 10 .NET Cumulative Update to Install Image
				echo.---------------------------------[Index : %%i]-----------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\NetCumulative"
			)
			if exist "%Temp%\Updates\Cumulative\Update.mum" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows 10 Cumulative Update to Install Image
				echo.---------------------------------[Index : %%i]-----------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Cumulative"		
			)
			if exist "%Temp%\Updates\Enablement\Update.mum" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows 10 Enablement Update to Install Image
				echo.---------------------------------[Index : %%i]-----------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Enablement"		
			)
		)
	)
) else (
	:: Windows 8.1 RTM (Build : 6.3.9600.16384)
	if "%SelectedSourceOS%" equ "w81" if %ImageServicePackBuild% equ 16384 (
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Prerequisite Update ^(KB3021910^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Update ^(KB2919355^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB2919355-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB3000850^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB3000850-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB2932046^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB2932046-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB2934018^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB2934018-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB2937592^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB2937592-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB2938439^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB2938439-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB2938772^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB2938772-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB3003057^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB3003057-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB3014442^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB3014442-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB4540725^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB4540725-%ImageArchitecture%.cab"
	)

	:: Windows 8.1 with Update (IR3 Build : 6.3.9600.17031)
	if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" equ "17031" (
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB3021910^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB4540725^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB4540725-%ImageArchitecture%.cab"		
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB3000850^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB3000850-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB2934018^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB2934018-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB3003057^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB3003057-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB3014442^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB3014442-%ImageArchitecture%.cab"
	)

	:: Windows 8.1 with Update (IR4 Build : 6.3.9600.17056)
	if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" equ "17056" (
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB3021910^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB4540725^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB4540725-%ImageArchitecture%.cab"			
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB3000850^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB3000850-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB3003057^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB3003057-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB3014442^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB3014442-%ImageArchitecture%.cab"
	)

	:: Windows 8.1 with Update Refresh (IR5 Build : 6.3.9600.17415)
	if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" equ "17415" (
		if exist "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB3021910^) to Install Image
			echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
			call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab"
		)
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB4540725^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB4540725-%ImageArchitecture%.cab"
	)

	:: Windows 10
	if "%SelectedSourceOS%" equ "w10" (
		:: Importing Registry fix to Enable Integrating Windows 10 LTSB 2015 Updates to Windows 10 Non-LTSB Editions.
		if "%ImageBuild%" equ "10240" if "%ImageEdition%" neq "EnterpriseS" if "%ImageEdition%" neq "EnterpriseSN" (
			call :MountImageRegistry "%InstallMount%"
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "InstallClient" /t REG_SZ /d "DISM Package Manager Provider" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "InstallName" /t REG_SZ /d "Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384.mum" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "InstallLocation" /t REG_SZ /d "\\?\d:\th1.bin.%PackageArchitecture%fre\csi\pkgs\\" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "CurrentState" /t REG_DWORD /d "112" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "SelfUpdate" /t REG_DWORD /d "0" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "Visibility" /t REG_DWORD /d "1" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "InstallTimeHigh" /t REG_DWORD /d "30649479" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "InstallTimeLow" /t REG_DWORD /d "1431244152" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "InstallUser" /t REG_SZ /d "S-1-5-18" /f >nul
			call :UnMountImageRegistry
		)
			
		:: Importing Registry fix to Enable Integrating Windows 10 Education/Enterprise Updates to Windows 10 Non Education/Enterprise (N) Editions.
		if "%ImageBuild%" equ "10586" if "%ImageEdition%" neq "Education" if "%ImageEdition%" neq "EducationN" if "%ImageEdition%" neq "Enterprise" if "%ImageEdition%" neq "EnterpriseN" (
			call :MountImageRegistry "%InstallMount%"
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "InstallClient" /t REG_SZ /d "DISM Package Manager Provider" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "InstallName" /t REG_SZ /d "Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0.mum" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "InstallLocation" /t REG_SZ /d "\\?\d:\th2.bin.%PackageArchitecture%fre\csi\pkgs\\" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "CurrentState" /t REG_DWORD /d "112" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "SelfUpdate" /t REG_DWORD /d "0" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "Visibility" /t REG_DWORD /d "1" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "InstallTimeHigh" /t REG_DWORD /d "30649479" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "InstallTimeLow" /t REG_DWORD /d "1431244152" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "InstallUser" /t REG_SZ /d "S-1-5-18" /f >nul
			call :UnMountImageRegistry
		)

		:: Importing Registry fix to Enable Integrating Windows 10 Education/Enterprise/LTSB 2016 Updates to Windows 10 Non Education/Enterprise/LTSB 2016 Editions.
		if "%ImageBuild%" equ "14393" if "%ImageEdition%" neq "Education" if "%ImageEdition%" neq "EducationN" if "%ImageEdition%" neq "Enterprise" if "%ImageEdition%" neq "EnterpriseN" if "%ImageEdition%" neq "EnterpriseS" if "%ImageEdition%" neq "EnterpriseSN" (
			call :MountImageRegistry "%InstallMount%"
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "InstallClient" /t REG_SZ /d "DISM Package Manager Provider" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "InstallName" /t REG_SZ /d "Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0.mum" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "InstallLocation" /t REG_SZ /d "\\?\d:\rs1.bin.%PackageArchitecture%fre\csi\pkgs\\" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "CurrentState" /t REG_DWORD /d "112" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "SelfUpdate" /t REG_DWORD /d "0" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "Visibility" /t REG_DWORD /d "1" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "InstallTimeHigh" /t REG_DWORD /d "30649479" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "InstallTimeLow" /t REG_DWORD /d "1431244152" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "InstallUser" /t REG_SZ /d "S-1-5-18" /f >nul
			call :UnMountImageRegistry
		)

		:: Importing Registry fix to Enable Integrating Windows Updates to Windows 10 Pro for Workstation Edition.
		if "%ImageBuild%" equ "16299" if "%ImageEdition%" equ "ProfessionalWorkstation" (
			call :MountImageRegistry "%InstallMount%"
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallClient" /t REG_SZ /d "DISM Package Manager Provider" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallName" /t REG_SZ /d "Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15.mum" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallLocation" /t REG_SZ /d "\\?\d:\rs2.bin.%PackageArchitecture%fre\csi\pkgs\\" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "CurrentState" /t REG_DWORD /d "112" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "SelfUpdate" /t REG_DWORD /d "0" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "Visibility" /t REG_DWORD /d "1" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallTimeHigh" /t REG_DWORD /d "30649479" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallTimeLow" /t REG_DWORD /d "1431244152" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallUser" /t REG_SZ /d "S-1-5-18" /f >nul
			call :UnMountImageRegistry
		)		
		
		:: Importing Registry fix to Enable Integrating Windows Updates to Windows 10 Pro for Workstation 'N' Edition.
		if "%ImageBuild%" equ "16299" if "%ImageEdition%" equ "ProfessionalWorkstationN" (
			call :MountImageRegistry "%InstallMount%"
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallClient" /t REG_SZ /d "DISM Package Manager Provider" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallName" /t REG_SZ /d "Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15.mum" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallLocation" /t REG_SZ /d "\\?\d:\rs2.bin.%PackageArchitecture%fre\csi\pkgs\\" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "CurrentState" /t REG_DWORD /d "112" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "SelfUpdate" /t REG_DWORD /d "0" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "Visibility" /t REG_DWORD /d "1" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallTimeHigh" /t REG_DWORD /d "30649479" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallTimeLow" /t REG_DWORD /d "1431244152" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallUser" /t REG_SZ /d "S-1-5-18" /f >nul
			call :UnMountImageRegistry
		)
				
		if exist "%Temp%\Updates\ServicingStack\Update.mum" (
			if "%ImageBuild%" equ "10240" if "%ImageServicePackBuild%" equ "16384" (
				echo.-------------------------------------------------------------------------------
				echo.Applying Windows 10 v1507 Cumulative Update Integration Fix
				echo.-------------------------------------------------------------------------------
				if "%ImageArchitecture%" equ "x86" call :ApplyImage "%W10CUFix%\TH1CUFix.tpk", 1, "%InstallMount%"
				if "%ImageArchitecture%" equ "x64" call :ApplyImage "%W10CUFix%\TH1CUFix.tpk", 2, "%InstallMount%"
				call :MountImageRegistry "%InstallMount%"
				call :ImportRegistry2Image "%W10CUFix%\TH1CUFix_%ImageArchitecture%.reg" 2>nul
				call :UnMountImageRegistry
			)
			if "%ImageArchitecture%" equ "x86" if "%ImageBuild%" equ "14393" if "%ImageServicePackBuild%" equ "0" (
				echo.-------------------------------------------------------------------------------
				echo.Applying Windows 10 v1607 Cumulative Update Integration Fix
				echo.-------------------------------------------------------------------------------
				call :ApplyImage "%W10CUFix%\RS1CUFix.tpk", 1, "%InstallMount%"
				call :MountImageRegistry "%InstallMount%"
				call :ImportRegistry2Image "%W10CUFix%\RS1CUFix.reg" 2>nul
				call :UnMountImageRegistry
			)
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows 10 Servicing Stack Update to Install Image
			echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
			call :AddPackage "%InstallMount%", "%Temp%\Updates\ServicingStack"
		)
		if exist "%Temp%\Updates\Dynamic\*.cab" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows 10 Dynamic Updates to Install Image
				echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
				call :AddPackage "%InstallMount%", "%Temp%\Updates\Dynamic"
		)
		if exist "%Temp%\Updates\FlashPlayer\Update.mum" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Adobe Flash Player Security Update to Install Image
			echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
			call :AddPackage "%InstallMount%", "%Temp%\Updates\FlashPlayer"
		)
		if exist "%Temp%\Updates\NetCumulative\*.cab" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows 10 .NET Cumulative Update to Install Image
			echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
			call :AddPackage "%InstallMount%", "%Temp%\Updates\NetCumulative"
		)
		if exist "%Temp%\Updates\Cumulative\Update.mum" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows 10 Cumulative Update to Install Image
			echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
			call :AddPackage "%InstallMount%", "%Temp%\Updates\Cumulative"
		)
		if exist "%Temp%\Updates\Enablement\Update.mum" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows 10 Enablement Update to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%", "%Temp%\Updates\Enablement"		
		)
	)
)

if "%IsLogsEnabled%" equ "Yes" (
	echo.-------------------------------------------------------------------------------
	if "%SelectedSourceOS%" equ "w81" echo.####Generating WHD Baseline Updates Integration Log Files######################
	if "%SelectedSourceOS%" equ "w10" echo.####Generating WHD General Updates Integration Log Files#######################
	echo.-------------------------------------------------------------------------------
	echo.
	if "%ImageIndexNo%" equ "*" (
		if "%SelectedSourceOS%" equ "w81" echo.Writing WHD Baseline Updates Integration [Install.wim, Index : 1-%ImageCount%] Log...
		if "%SelectedSourceOS%" equ "w10" echo.Writing WHD General Updates Integration [Install.wim, Index : 1-%ImageCount%] Log...
		for /L %%k in (1, 1, %ImageCount%) do (
			call :GetPackages "%InstallMount%\%%k", "Install-%%k.txt"
		)
	) else (
		if "%SelectedSourceOS%" equ "w81" echo.Writing WHD Baseline Updates Integration [Install.wim, Index : %ImageIndexNo%] Log...
		if "%SelectedSourceOS%" equ "w10" echo.Writing WHD General Updates Integration [Install.wim, Index : %ImageIndexNo%] Log...
		call :GetPackages "%InstallMount%", "Install.txt"
	)
	echo.
)

echo.-------------------------------------------------------------------------------
echo.####Cleaning Up Temporary Files ^& Folders#####################################
echo.-------------------------------------------------------------------------------
echo.
if "%SelectedSourceOS%" equ "w81" echo.Cleaning Up WHD Baseline Updates Temporary folder...
if "%SelectedSourceOS%" equ "w10" echo.Cleaning Up WHD General Updates Temporary folder...
call :RemoveFolder "%Temp%\Updates"
echo.
echo.-------------------------------------------------------------------------------
if "%SelectedSourceOS%" equ "w81" echo.####################Finished Integrating WHD Baseline Updates to Install Image##
if "%SelectedSourceOS%" equ "w10" echo.##################Finished Integrating WHD General Updates to Install Image#####
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set PackageArchitecture=
set Updates=

endlocal

:: Reading Updated Image Information
if "%SelectedSourceOS%" equ "w10" (
	if "%ImageIndexNo%" equ "*" (
		call :GetImageIndexInfo "%InstallWim%", 1 >nul
		call :MountImageRegistry "%InstallMount%\1"
		for /f "tokens=3 delims= " %%z in ('reg query "HKLM\TK_SOFTWARE\Microsoft\Windows NT\CurrentVersion" /v "UBR" ^| find "REG_DWORD"') do (set /a ImageServicePackBuild=%%z)
		call :UnMountImageRegistry
	) else (
		call :GetImageIndexInfo "%InstallWim%", %ImageIndexNo% >nul
		call :MountImageRegistry "%InstallMount%"
		for /f "tokens=3 delims= " %%z in ('reg query "HKLM\TK_SOFTWARE\Microsoft\Windows NT\CurrentVersion" /v "UBR" ^| find "REG_DWORD"') do (set /a ImageServicePackBuild=%%z)
		call :UnMountImageRegistry
	)
)

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate WHD Baseline Updates to Windows Setup Install ^& Recovery Image
::-------------------------------------------------------------------------------------------
:IntWHDBaseInstallRecovery

setlocal

cls
echo.===============================================================================
if "%SelectedSourceOS%" equ "w81" echo.                  MSMG ToolKit - Integrate WHD Baseline Updates 
if "%SelectedSourceOS%" equ "w10" echo.                   MSMG ToolKit - Integrate WHD General Updates 
echo.                    to Windows Setup Install ^& Recovery Images
echo.===============================================================================
echo.
if "%IsRecoveryImageSelected%" equ "No" (
	echo.Windows Recovery Image is not selected...
	echo.
	echo.Please choose Windows Recovery Image while selecting Source...
	goto :Stop	
)

:: Getting Install Image Index Architecture
if "%ImageIndexNo%" equ "*" call :GetImageArchitecture "%InstallWim%", 1 >nul
if "%ImageIndexNo%" neq "*" call :GetImageArchitecture "%InstallWim%", %ImageIndexNo% >nul

:: Setting Package Architecture
if "%ImageArchitecture%" equ "x86" set "PackageArchitecture=x86"
if "%ImageArchitecture%" equ "x64" set "PackageArchitecture=amd64"
if "%ImageArchitecture%" equ "arm64" set "PackageArchitecture=arm64"

:: Settings WHD Baseline Updates folder path
if "%SelectedSourceOS%" equ "w81" set "Updates=%WHD%\%SelectedSourceOS%\%ImageArchitecture%\Baseline"
if "%SelectedSourceOS%" equ "w10" set "Updates=%WHD%\%SelectedSourceOS%\%ImageArchitecture%"

:: Checking whether WHD Baseline Updates folder is empty
:: Windows 8.1 RTM (Build : 6.3.9600.16384)
if "%SelectedSourceOS%" equ "w81" if %ImageServicePackBuild% equ 16384 (
	if not exist "%Updates%\RTM\*.msu" if not exist "%Updates%\RTM\*.cab" (
		echo.WHD Baseline Updates Folder ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Baseline\RTM^> is empty...
	)
	if not exist "%Updates%\*.msu" if not exist "%Updates%\*.cab" (
		echo.
		echo.WHD Baseline Updates Folder ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Baseline^> is empty...
	)
	echo.
	echo.Please copy WHD Baseline Updates to respective folder...
	goto :Stop
)

:: Windows 8.1 Post-RTM
if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" neq "16384" (
	if not exist "%Updates%\*.msu" if not exist "%Updates%\*.cab" (
		echo.WHD Baseline Updates Folder ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Baseline^> is empty...
		echo.
		echo.Please copy WHD Baseline Updates to respective folder...
		goto :Stop
	)
)

:: Windows 10
if "%SelectedSourceOS%" equ "w10" if not exist "%Updates%\Cumulative\*.msu" if not exist "%Updates%\Cumulative\*.cab" (
	echo.WHD General Updates folder ^<WHD\w10\%ImageArchitecture%\Cumulative^> is empty...
	echo.
	echo.Please copy WHD General Updates to respective folder...
	goto :Stop
)

echo.-------------------------------------------------------------------------------
if "%SelectedSourceOS%" equ "w81" echo.##################Starting Integrating WHD Baseline Updates to#################
if "%SelectedSourceOS%" equ "w10" echo.##################Starting Integrating WHD General Updates to##################
echo.###################Windows Setup Install ^& Recovery Images#####################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim        ^|  WinRE.wim
if "%ImageIndexNo%" neq "*" if not "%ImageCount%" gtr "9" echo.    Image Indexes            : %ImageIndexNo%                  ^|      1
if "%ImageIndexNo%" neq "*" if "%ImageCount%" gtr "9" echo.    Image Indexes            : %ImageIndexNo%                  ^|      1
if "%ImageIndexNo%" equ "*" if not "%ImageCount%" gtr "9" echo.    Image Indexes            : 1-%ImageCount%                ^|     1
if "%ImageIndexNo%" equ "*" if "%ImageCount%" gtr "9" echo.    Image Indexes            : 1-%ImageCount%             ^|      1
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
if "%ImageIndexNo%" neq "*" echo.    Image Edition            : %ImageEdition%
echo.    Image Default Language   : %ImageDefaultLanguage%
echo.
echo.-------------------------------------------------------------------------------
if "%SelectedSourceOS%" equ "w81" echo.####Processing WHD Baseline Updates Packages###################################
if "%SelectedSourceOS%" equ "w10" echo.####Processing WHD General Updates Packages####################################
echo.-------------------------------------------------------------------------------
echo.
:: Creating WHD Baseline Updates Temporary folder
if "%SelectedSourceOS%" equ "w81" echo.Creating WHD Baseline Updates Temporary folder...
if "%SelectedSourceOS%" equ "w10" echo.Creating WHD General Updates Temporary folder...
call :RemoveFolder "%Temp%\Updates"
call :CreateFolder "%Temp%\Updates"
echo.

:: Extracting .CAB files from .MSU Package files to CAB Temporary folder
echo.Extracting .CAB Package files to Temporary folder...

:: Windows 8.1 RTM (Build : 6.3.9600.16384)
if "%SelectedSourceOS%" equ "w81" if %ImageServicePackBuild% equ 16384 (
	if exist "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\RTM\Windows8.1-KB2919355-%ImageArchitecture%*.msu" expand "%Updates%\RTM\Windows8.1-KB2919355-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\RTM\Windows8.1-KB2932046-%ImageArchitecture%*.msu" expand "%Updates%\RTM\Windows8.1-KB2932046-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB2934018-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB2934018-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\RTM\Windows8.1-KB2937592-%ImageArchitecture%*.msu" expand "%Updates%\RTM\Windows8.1-KB2937592-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\RTM\Windows8.1-KB2938439-%ImageArchitecture%*.msu" expand "%Updates%\RTM\Windows8.1-KB2938439-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\RTM\Windows8.1-KB2938772-%ImageArchitecture%*.msu" expand "%Updates%\RTM\Windows8.1-KB2938772-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3014442-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB3014442-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul

	:: Copy .CAB files from .MSU package files to CAB Temporary folder
	if exist "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\RTM\Windows8.1-KB2919355-%ImageArchitecture%*.cab" %XCopy% "%Updates%\RTM\Windows8.1-KB2919355-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\RTM\Windows8.1-KB2932046-%ImageArchitecture%*.cab" %XCopy% "%Updates%\RTM\Windows8.1-KB2932046-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB2934018-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB2934018-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\RTM\Windows8.1-KB2937592-%ImageArchitecture%*.cab" %XCopy% "%Updates%\RTM\Windows8.1-KB2937592-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\RTM\Windows8.1-KB2938439-%ImageArchitecture%*.cab" %XCopy% "%Updates%\RTM\Windows8.1-KB2938439-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\RTM\Windows8.1-KB2938772-%ImageArchitecture%*.cab" %XCopy% "%Updates%\RTM\Windows8.1-KB2938772-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3014442-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB3014442-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
)

:: Windows 8.1 with Update (IR3 Build : 6.3.9600.17031)
if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" equ "17031" (
	if exist "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB2934018-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB2934018-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3014442-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB3014442-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul

	:: Copy .CAB files from .MSU package files to CAB Temporary folder
	if exist "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB2934018-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB2934018-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul	
	if exist "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3014442-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB3014442-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
)

:: Windows 8.1 with Update Refresh (IR4 Build : 6.3.9600.17056)
if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" equ "17056" (
	if exist "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3014442-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB3014442-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul

	:: Copy .CAB files from .MSU package files to CAB Temporary folder
	if exist "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3014442-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB3014442-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
)

:: Windows 8.1 with Update Refresh (IR5 Build : 6.3.9600.17415)
if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" equ "17415" (
	if exist "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul

	:: Copy .CAB files from .MSU package files to CAB Temporary folder
	if exist "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
)

:: Windows 10
if "%SelectedSourceOS%" equ "w10" (
	for /d %%j in (ServicingStack, Cumulative, Enablement, FlashPlayer) do (
		if exist "%Updates%\%%j\*%ImageArchitecture%*.msu" (
			call :CreateFolder "%Temp%\Updates\%%j"
			expand -R "%Updates%\%%j\*%ImageArchitecture%*.msu" -F:*.cab "%Temp%\Updates\%%j" >nul
			call :RemoveFile "%Temp%\Updates\%%j\wsusscan.cab"
			expand -R "%Temp%\Updates\%%j\*.cab" -F:* "%Temp%\Updates\%%j" >nul
			if "%%j" equ "Cumulative" if exist "%Temp%\Updates\%%j\Cab_*.cab" expand -R "%Temp%\Updates\%%j\Cab_*.cab" -F:* "%Temp%\Updates\%%j" >nul
			call :RemoveFile "%Temp%\Updates\%%j\*.cab"
		)
		if exist "%Updates%\%%j\*%ImageArchitecture%*.cab" (
			call :CreateFolder "%Temp%\Updates\%%j"
			expand -R "%Updates%\%%j\*%ImageArchitecture%*.cab" -F:* "%Temp%\Updates\%%j" >nul
			if "%%j" equ "Cumulative" if exist "%Temp%\Updates\%%j\Cab_*.cab" expand -R "%Temp%\Updates\%%j\Cab_*.cab" -F:* "%Temp%\Updates\%%j" >nul
			call :RemoveFile "%Temp%\Updates\%%j\*.cab"
		)
	)
	
	for /d %%j in (Dynamic, NetCumulative, WinPE) do (	
		if exist "%Updates%\%%j\*%ImageArchitecture%*.msu" (
			call :CreateFolder "%Temp%\Updates\%%j"
			expand -R "%Updates%\%%j\*%ImageArchitecture%*.msu" -F:*.cab "%Temp%\Updates\%%j" >nul
			call :RemoveFile "%Temp%\Updates\%%j\wsusscan.cab"		
		)
	
		if exist "%Updates%\%%j\*%ImageArchitecture%*.cab" (
			call :CreateFolder "%Temp%\Updates\%%j"
			%XCopy% "%Updates%\%%j\*%ImageArchitecture%*.cab" "%Temp%\Updates\%%j" >nul
		)
	)	
)
echo.
echo.Finished Extracting .CAB Package files to Temporary folder...
echo.
echo.-------------------------------------------------------------------------------
if "%SelectedSourceOS%" equ "w81" echo.####Integrating WHD Baseline Updates to Windows Setup Install Image############
if "%SelectedSourceOS%" equ "w10" echo.####Integrating WHD General Updates to Windows Setup Install Image#############
echo.-------------------------------------------------------------------------------
echo.
if "%ImageIndexNo%" equ "*" (
	for /L %%i in (1, 1, %ImageCount%) do (
		:: Windows 8.1 RTM (Build : 6.3.9600.16384)
		if "%SelectedSourceOS%" equ "w81" if %ImageServicePackBuild% equ 16384 (
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Prerequisite Update ^(KB3021910^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Update ^(KB2919355^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB2919355-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB3000850^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB3000850-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB2932046^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB2932046-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB2934018^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB2934018-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB2937592^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB2937592-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB2938439^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB2938439-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB2938772^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB2938772-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB3003057^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB3003057-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB3014442^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB3014442-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB4540725^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB4540725-%ImageArchitecture%.cab"
		)

		:: Windows 8.1 with Update (IR3 Build : 6.3.9600.17031)
		if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" equ "17031" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB3021910^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB4540725^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB4540725-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB3000850^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB3000850-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB2934018^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB2934018-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB3003057^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB3003057-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB3014442^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB3014442-%ImageArchitecture%.cab"
		)

		:: Windows 8.1 with Update (IR4 Build : 6.3.9600.17056)
		if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" equ "17056" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB3021910^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB4540725^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB4540725-%ImageArchitecture%.cab"			
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB3000850^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB3000850-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB3003057^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB3003057-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB3014442^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB3014442-%ImageArchitecture%.cab"
		)

		:: Windows 8.1 with Update Refresh (IR5 Build : 6.3.9600.17415)
		if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" equ "17415" (
			if exist "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating WHD Baseline Feature Pack Update ^(KB3021910^) to Install Image
				echo.---------------------------------[Index : %%i]-----------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab"
			)
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB4540725^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB4540725-%ImageArchitecture%.cab"
		)

		:: Windows 10
		if "%SelectedSourceOS%" equ "w10" (
			:: Importing Registry fix to Enable Integrating Windows 10 LTSB 2015 Updates to Windows 10 Non-LTSB Editions.
			if "%ImageBuild%" equ "10240" if "%ImageEdition%" neq "EnterpriseS" if "%ImageEdition%" neq "EnterpriseSN" (
				call :MountImageRegistry "%InstallMount%\%%i"
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "InstallClient" /t REG_SZ /d "DISM Package Manager Provider" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "InstallName" /t REG_SZ /d "Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384.mum" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "InstallLocation" /t REG_SZ /d "\\?\d:\th1.bin.%PackageArchitecture%fre\csi\pkgs\\" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "CurrentState" /t REG_DWORD /d "112" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "SelfUpdate" /t REG_DWORD /d "0" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "Visibility" /t REG_DWORD /d "1" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "InstallTimeHigh" /t REG_DWORD /d "30649479" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "InstallTimeLow" /t REG_DWORD /d "1431244152" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "InstallUser" /t REG_SZ /d "S-1-5-18" /f >nul
				call :UnMountImageRegistry
			)

			:: Importing Registry fix to Enable Integrating Windows 10 Education/Enterprise Updates to Windows 10 Non Education/Enterprise (N) Editions.
			if "%ImageBuild%" equ "10586" if "%ImageEdition%" neq "Education" if "%ImageEdition%" neq "EducationN" if "%ImageEdition%" neq "Enterprise" if "%ImageEdition%" neq "EnterpriseN" (
				call :MountImageRegistry "%InstallMount%\%%i"
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "InstallClient" /t REG_SZ /d "DISM Package Manager Provider" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "InstallName" /t REG_SZ /d "Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0.mum" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "InstallLocation" /t REG_SZ /d "\\?\d:\th2.bin.%PackageArchitecture%fre\csi\pkgs\\" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "CurrentState" /t REG_DWORD /d "112" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "SelfUpdate" /t REG_DWORD /d "0" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "Visibility" /t REG_DWORD /d "1" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "InstallTimeHigh" /t REG_DWORD /d "30649479" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "InstallTimeLow" /t REG_DWORD /d "1431244152" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "InstallUser" /t REG_SZ /d "S-1-5-18" /f >nul
				call :UnMountImageRegistry
			)

			:: Importing Registry fix to Enable Integrating Windows 10 Education/Enterprise/LTSB 2016 Updates to Windows 10 Non Education/Enterprise/LTSB 2016 Editions.
			if "%ImageBuild%" equ "14393" if "%ImageEdition%" neq "Education" if "%ImageEdition%" neq "EducationN" if "%ImageEdition%" neq "Enterprise" if "%ImageEdition%" neq "EnterpriseN" if "%ImageEdition%" neq "EnterpriseS" if "%ImageEdition%" neq "EnterpriseSN" (
				call :MountImageRegistry "%InstallMount%\%%i"
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "InstallClient" /t REG_SZ /d "DISM Package Manager Provider" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "InstallName" /t REG_SZ /d "Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0.mum" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "InstallLocation" /t REG_SZ /d "\\?\d:\rs1.bin.%PackageArchitecture%fre\csi\pkgs\\" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "CurrentState" /t REG_DWORD /d "112" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "SelfUpdate" /t REG_DWORD /d "0" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "Visibility" /t REG_DWORD /d "1" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "InstallTimeHigh" /t REG_DWORD /d "30649479" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "InstallTimeLow" /t REG_DWORD /d "1431244152" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "InstallUser" /t REG_SZ /d "S-1-5-18" /f >nul
				call :UnMountImageRegistry
			)

			:: Importing Registry fix to Enable Integrating Windows Updates to Windows 10 Pro for Workstation Edition.
			if "%ImageBuild%" equ "16299" if "%ImageEdition%" equ "ProfessionalWorkstation" (
				call :MountImageRegistry "%InstallMount%\%%i"
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallClient" /t REG_SZ /d "DISM Package Manager Provider" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallName" /t REG_SZ /d "Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15.mum" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallLocation" /t REG_SZ /d "\\?\d:\rs2.bin.%PackageArchitecture%fre\csi\pkgs\\" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "CurrentState" /t REG_DWORD /d "112" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "SelfUpdate" /t REG_DWORD /d "0" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "Visibility" /t REG_DWORD /d "1" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallTimeHigh" /t REG_DWORD /d "30649479" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallTimeLow" /t REG_DWORD /d "1431244152" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallUser" /t REG_SZ /d "S-1-5-18" /f >nul
				call :UnMountImageRegistry
			)
			
			:: Importing Registry fix to Enable Integrating Windows Updates to Windows 10 Pro for Workstation 'N' Edition.
			if "%ImageBuild%" equ "16299" if "%ImageEdition%" equ "ProfessionalWorkstationN" (
				call :MountImageRegistry "%InstallMount%\%%i"
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallClient" /t REG_SZ /d "DISM Package Manager Provider" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallName" /t REG_SZ /d "Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15.mum" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallLocation" /t REG_SZ /d "\\?\d:\rs2.bin.%PackageArchitecture%fre\csi\pkgs\\" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "CurrentState" /t REG_DWORD /d "112" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "SelfUpdate" /t REG_DWORD /d "0" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "Visibility" /t REG_DWORD /d "1" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallTimeHigh" /t REG_DWORD /d "30649479" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallTimeLow" /t REG_DWORD /d "1431244152" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallUser" /t REG_SZ /d "S-1-5-18" /f >nul
				call :UnMountImageRegistry
			)
		
			if exist "%Temp%\Updates\ServicingStack\Update.mum" (
				if "%ImageBuild%" equ "10240" if "%ImageServicePackBuild%" equ "16384" (
					echo.-------------------------------------------------------------------------------
					echo.Applying Windows 10 v1507 Cumulative Update Integration Fix
					echo.-------------------------------------------------------------------------------
					if "%ImageArchitecture%" equ "x86" call :ApplyImage "%W10CUFix%\TH1CUFix.tpk", 1, "%InstallMount%\%%i"
					if "%ImageArchitecture%" equ "x64" call :ApplyImage "%W10CUFix%\TH1CUFix.tpk", 2, "%InstallMount%\%%i"
					call :MountImageRegistry "%InstallMount%\%%i"
					call :ImportRegistry2Image "%W10CUFix%\TH1CUFix_%ImageArchitecture%.reg" 2>nul
					call :UnMountImageRegistry
				)
				if "%ImageArchitecture%" equ "x86" if "%ImageBuild%" equ "14393" if "%ImageServicePackBuild%" equ "0" (
					echo.-------------------------------------------------------------------------------
					echo.Applying Windows 10 v1607 Cumulative Update Integration Fix
					echo.-------------------------------------------------------------------------------
					call :ApplyImage "%W10CUFix%\RS1CUFix.tpk", 1, "%InstallMount%\%%i"
					call :MountImageRegistry "%InstallMount%\%%i"
					call :ImportRegistry2Image "%W10CUFix%\RS1CUFix.reg" 2>nul
					call :UnMountImageRegistry
				)
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows 10 Servicing Stack Update to Install Image
				echo.---------------------------------[Index : %%i]-----------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\ServicingStack"
			)
			if exist "%Temp%\Updates\Dynamic\*.cab" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows 10 Dynamic Updates to Install Image
				echo.---------------------------------[Index : %%i]-----------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Dynamic"
			)
			if exist "%Temp%\Updates\FlashPlayer\Update.mum" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Adobe Flash Player Security Update to Install Image
				echo.---------------------------------[Index : %%i]-----------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\FlashPlayer"
			)
			if exist "%Temp%\Updates\NetCumulative\*.cab" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows 10 .NET Cumulative Update to Install Image
				echo.---------------------------------[Index : %%i]-----------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\NetCumulative"
			)
			if exist "%Temp%\Updates\Cumulative\Update.mum" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows 10 Cumulative Update to Install Image
				echo.---------------------------------[Index : %%i]-----------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Cumulative"		
			)
			if exist "%Temp%\Updates\Enablement\Update.mum" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows 10 Enablement Update to Install Image
				echo.---------------------------------[Index : %%i]-----------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Enablement"		
			)
		)
	)
) else (
	:: Windows 8.1 RTM (Build : 6.3.9600.16384)
	if "%SelectedSourceOS%" equ "w81" if %ImageServicePackBuild% equ 16384 (
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Prerequisite Update ^(KB3021910^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Update ^(KB2919355^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB2919355-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB3000850^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB3000850-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB2932046^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB2932046-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB2934018^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB2934018-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB2937592^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB2937592-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB2938439^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB2938439-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB2938772^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB2938772-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB3003057^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB3003057-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB3014442^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB3014442-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB4540725^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB4540725-%ImageArchitecture%.cab"
	)

	:: Windows 8.1 with Update (IR3 Build : 6.3.9600.17031)
	if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" equ "17031" (
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB3021910^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB4540725^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB4540725-%ImageArchitecture%.cab"		
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB3000850^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB3000850-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB2934018^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB2934018-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB3003057^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB3003057-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB3014442^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB3014442-%ImageArchitecture%.cab"
	)

	:: Windows 8.1 with Update (IR4 Build : 6.3.9600.17056)
	if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" equ "17056" (
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB3021910^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB4540725^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB4540725-%ImageArchitecture%.cab"			
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB3000850^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB3000850-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB3003057^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB3003057-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB3014442^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB3014442-%ImageArchitecture%.cab"
	)

	:: Windows 8.1 with Update Refresh (IR5 Build : 6.3.9600.17415)
	if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" equ "17415" (
		if exist "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB3021910^) to Install Image
			echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
			call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab"
		)
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB4540725^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB4540725-%ImageArchitecture%.cab"
	)

	:: Windows 10
	if "%SelectedSourceOS%" equ "w10" (
		:: Importing Registry fix to Enable Integrating Windows 10 LTSB 2015 Updates to Windows 10 Non-LTSB Editions.
		if "%ImageBuild%" equ "10240" if "%ImageEdition%" neq "EnterpriseS" if "%ImageEdition%" neq "EnterpriseSN" (
			call :MountImageRegistry "%InstallMount%"
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "InstallClient" /t REG_SZ /d "DISM Package Manager Provider" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "InstallName" /t REG_SZ /d "Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384.mum" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "InstallLocation" /t REG_SZ /d "\\?\d:\th1.bin.%PackageArchitecture%fre\csi\pkgs\\" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "CurrentState" /t REG_DWORD /d "112" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "SelfUpdate" /t REG_DWORD /d "0" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "Visibility" /t REG_DWORD /d "1" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "InstallTimeHigh" /t REG_DWORD /d "30649479" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "InstallTimeLow" /t REG_DWORD /d "1431244152" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "InstallUser" /t REG_SZ /d "S-1-5-18" /f >nul
			call :UnMountImageRegistry
		)
			
		:: Importing Registry fix to Enable Integrating Windows 10 Education/Enterprise Updates to Windows 10 Non Education/Enterprise (N) Editions.
		if "%ImageBuild%" equ "10586" if "%ImageEdition%" neq "Education" if "%ImageEdition%" neq "EducationN" if "%ImageEdition%" neq "Enterprise" if "%ImageEdition%" neq "EnterpriseN" (
			call :MountImageRegistry "%InstallMount%"
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "InstallClient" /t REG_SZ /d "DISM Package Manager Provider" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "InstallName" /t REG_SZ /d "Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0.mum" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "InstallLocation" /t REG_SZ /d "\\?\d:\th2.bin.%PackageArchitecture%fre\csi\pkgs\\" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "CurrentState" /t REG_DWORD /d "112" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "SelfUpdate" /t REG_DWORD /d "0" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "Visibility" /t REG_DWORD /d "1" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "InstallTimeHigh" /t REG_DWORD /d "30649479" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "InstallTimeLow" /t REG_DWORD /d "1431244152" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "InstallUser" /t REG_SZ /d "S-1-5-18" /f >nul
			call :UnMountImageRegistry
		)

		:: Importing Registry fix to Enable Integrating Windows 10 Education/Enterprise/LTSB 2016 Updates to Windows 10 Non Education/Enterprise/LTSB 2016 Editions.
		if "%ImageBuild%" equ "14393" if "%ImageEdition%" neq "Education" if "%ImageEdition%" neq "EducationN" if "%ImageEdition%" neq "Enterprise" if "%ImageEdition%" neq "EnterpriseN" if "%ImageEdition%" neq "EnterpriseS" if "%ImageEdition%" neq "EnterpriseSN" (
			call :MountImageRegistry "%InstallMount%"
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "InstallClient" /t REG_SZ /d "DISM Package Manager Provider" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "InstallName" /t REG_SZ /d "Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0.mum" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "InstallLocation" /t REG_SZ /d "\\?\d:\rs1.bin.%PackageArchitecture%fre\csi\pkgs\\" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "CurrentState" /t REG_DWORD /d "112" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "SelfUpdate" /t REG_DWORD /d "0" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "Visibility" /t REG_DWORD /d "1" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "InstallTimeHigh" /t REG_DWORD /d "30649479" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "InstallTimeLow" /t REG_DWORD /d "1431244152" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "InstallUser" /t REG_SZ /d "S-1-5-18" /f >nul
			call :UnMountImageRegistry
		)

		:: Importing Registry fix to Enable Integrating Windows Updates to Windows 10 Pro for Workstation Edition.
		if "%ImageBuild%" equ "16299" if "%ImageEdition%" equ "ProfessionalWorkstation" (
			call :MountImageRegistry "%InstallMount%"
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallClient" /t REG_SZ /d "DISM Package Manager Provider" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallName" /t REG_SZ /d "Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15.mum" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallLocation" /t REG_SZ /d "\\?\d:\rs2.bin.%PackageArchitecture%fre\csi\pkgs\\" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "CurrentState" /t REG_DWORD /d "112" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "SelfUpdate" /t REG_DWORD /d "0" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "Visibility" /t REG_DWORD /d "1" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallTimeHigh" /t REG_DWORD /d "30649479" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallTimeLow" /t REG_DWORD /d "1431244152" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallUser" /t REG_SZ /d "S-1-5-18" /f >nul
			call :UnMountImageRegistry
		)		
		
		:: Importing Registry fix to Enable Integrating Windows Updates to Windows 10 Pro for Workstation 'N' Edition.
		if "%ImageBuild%" equ "16299" if "%ImageEdition%" equ "ProfessionalWorkstationN" (
			call :MountImageRegistry "%InstallMount%"
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallClient" /t REG_SZ /d "DISM Package Manager Provider" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallName" /t REG_SZ /d "Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15.mum" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallLocation" /t REG_SZ /d "\\?\d:\rs2.bin.%PackageArchitecture%fre\csi\pkgs\\" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "CurrentState" /t REG_DWORD /d "112" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "SelfUpdate" /t REG_DWORD /d "0" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "Visibility" /t REG_DWORD /d "1" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallTimeHigh" /t REG_DWORD /d "30649479" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallTimeLow" /t REG_DWORD /d "1431244152" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallUser" /t REG_SZ /d "S-1-5-18" /f >nul
			call :UnMountImageRegistry
		)
				
		if exist "%Temp%\Updates\ServicingStack\Update.mum" (
			if "%ImageBuild%" equ "10240" if "%ImageServicePackBuild%" equ "16384" (
				echo.-------------------------------------------------------------------------------
				echo.Applying Windows 10 v1507 Cumulative Update Integration Fix
				echo.-------------------------------------------------------------------------------
				if "%ImageArchitecture%" equ "x86" call :ApplyImage "%W10CUFix%\TH1CUFix.tpk", 1, "%InstallMount%"
				if "%ImageArchitecture%" equ "x64" call :ApplyImage "%W10CUFix%\TH1CUFix.tpk", 2, "%InstallMount%"
				call :MountImageRegistry "%InstallMount%"
				call :ImportRegistry2Image "%W10CUFix%\TH1CUFix_%ImageArchitecture%.reg" 2>nul
				call :UnMountImageRegistry
			)
			if "%ImageArchitecture%" equ "x86" if "%ImageBuild%" equ "14393" if "%ImageServicePackBuild%" equ "0" (
				echo.-------------------------------------------------------------------------------
				echo.Applying Windows 10 v1607 Cumulative Update Integration Fix
				echo.-------------------------------------------------------------------------------
				call :ApplyImage "%W10CUFix%\RS1CUFix.tpk", 1, "%InstallMount%"
				call :MountImageRegistry "%InstallMount%"
				call :ImportRegistry2Image "%W10CUFix%\RS1CUFix.reg" 2>nul
				call :UnMountImageRegistry
			)
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows 10 Servicing Stack Update to Install Image
			echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
			call :AddPackage "%InstallMount%", "%Temp%\Updates\ServicingStack"
		)
		if exist "%Temp%\Updates\Dynamic\*.cab" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows 10 Dynamic Updates to Install Image
				echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
				call :AddPackage "%InstallMount%", "%Temp%\Updates\Dynamic"
		)
		if exist "%Temp%\Updates\FlashPlayer\Update.mum" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Adobe Flash Player Security Update to Install Image
			echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
			call :AddPackage "%InstallMount%", "%Temp%\Updates\FlashPlayer"
		)
		if exist "%Temp%\Updates\NetCumulative\*.cab" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows 10 .NET Cumulative Update to Install Image
			echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
			call :AddPackage "%InstallMount%", "%Temp%\Updates\NetCumulative"
		)
		if exist "%Temp%\Updates\Cumulative\Update.mum" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows 10 Cumulative Update to Install Image
			echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
			call :AddPackage "%InstallMount%", "%Temp%\Updates\Cumulative"
		)
		if exist "%Temp%\Updates\Enablement\Update.mum" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows 10 Enablement Update to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%", "%Temp%\Updates\Enablement"		
		)
	)
)
echo.-------------------------------------------------------------------------------
if "%SelectedSourceOS%" equ "w81" echo.####Integrating WHD Baseline Updates to Windows Setup Recovery Image###########
if "%SelectedSourceOS%" equ "w10" echo.####Integrating WHD General Updates to Windows Setup Recovery Image############
echo.-------------------------------------------------------------------------------
echo.
:: Windows 8.1 RTM (Build : 6.3.9600.16384)
if "%SelectedSourceOS%" equ "w81" if %ImageServicePackBuild% equ 16384 (
	echo.-------------------------------------------------------------------------------
	echo.Integrating WHD Baseline Prerequisite Update ^(KB3021910^) to Recovery Image
	echo.---------------------------------[Index : 1]-----------------------------------
	call :AddPackage "%WinReMount%", "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating WHD Baseline Update ^(KB2919355^) to Recovery Image
	echo.---------------------------------[Index : 1]-----------------------------------
	call :AddPackage "%WinReMount%", "%Temp%\Updates\Windows8.1-KB2919355-%ImageArchitecture%.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating WHD Baseline Feature Pack Update ^(KB3000850^) to Recovery Image
	echo.---------------------------------[Index : 1]-----------------------------------
	call :AddPackage "%WinReMount%", "%Temp%\Updates\Windows8.1-KB3000850-%ImageArchitecture%.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating WHD Baseline Feature Pack Update ^(KB2932046^) to Recovery Image
	echo.---------------------------------[Index : 1]-----------------------------------
	call :AddPackage "%WinReMount%", "%Temp%\Updates\Windows8.1-KB2932046-%ImageArchitecture%.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating WHD Baseline Feature Pack Update ^(KB2934018^) to Recovery Image
	echo.---------------------------------[Index : 1]-----------------------------------
	call :AddPackage "%WinReMount%", "%Temp%\Updates\Windows8.1-KB2934018-%ImageArchitecture%.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating WHD Baseline Feature Pack Update ^(KB2937592^) to Recovery Image
	echo.---------------------------------[Index : 1]-----------------------------------
	call :AddPackage "%WinReMount%", "%Temp%\Updates\Windows8.1-KB2937592-%ImageArchitecture%.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating WHD Baseline Feature Pack Update ^(KB2938439^) to Recovery Image
	echo.---------------------------------[Index : 1]-----------------------------------
	call :AddPackage "%WinReMount%", "%Temp%\Updates\Windows8.1-KB2938439-%ImageArchitecture%.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating WHD Baseline Feature Pack Update ^(KB2938772^) to Recovery Image
	echo.---------------------------------[Index : 1]-----------------------------------
	call :AddPackage "%WinReMount%", "%Temp%\Updates\Windows8.1-KB2938772-%ImageArchitecture%.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating WHD Baseline Feature Pack Update ^(KB3003057^) to Recovery Image
	echo.---------------------------------[Index : 1]-----------------------------------
	call :AddPackage "%WinReMount%", "%Temp%\Updates\Windows8.1-KB3003057-%ImageArchitecture%.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating WHD Baseline Feature Pack Update ^(KB4540725^) to Recovery Image
	echo.---------------------------------[Index : 1]-----------------------------------
	call :AddPackage "%WinReMount%", "%Temp%\Updates\Windows8.1-KB4540725-%ImageArchitecture%.cab"
)

:: Windows 8.1 with Update (IR3 Build : 6.3.9600.17031)
if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" equ "17031" (
	echo.-------------------------------------------------------------------------------
	echo.Integrating WHD Baseline Feature Pack Update ^(KB3021910^) to Recovery Image
	echo.---------------------------------[Index : 1]-----------------------------------
	call :AddPackage "%WinReMount%", "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating WHD Baseline Feature Pack Update ^(KB4540725^) to Recovery Image
	echo.---------------------------------[Index : 1]-----------------------------------
	call :AddPackage "%WinReMount%", "%Temp%\Updates\Windows8.1-KB4540725-%ImageArchitecture%.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating WHD Baseline Feature Pack Update ^(KB3000850^) to Recovery Image
	echo.---------------------------------[Index : 1]-----------------------------------
	call :AddPackage "%WinReMount%", "%Temp%\Updates\Windows8.1-KB3000850-%ImageArchitecture%.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating WHD Baseline Feature Pack Update ^(KB2934018^) to Recovery Image
	echo.---------------------------------[Index : 1]-----------------------------------
	call :AddPackage "%WinReMount%", "%Temp%\Updates\Windows8.1-KB2934018-%ImageArchitecture%.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating WHD Baseline Feature Pack Update ^(KB3003057^) to Recovery Image
	echo.---------------------------------[Index : 1]-----------------------------------
	call :AddPackage "%WinReMount%", "%Temp%\Updates\Windows8.1-KB3003057-%ImageArchitecture%.cab"
)

:: Windows 8.1 with Update Refresh (IR4 Build : 6.3.9600.17056)
if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" equ "17056" (
	echo.-------------------------------------------------------------------------------
	echo.Integrating WHD Baseline Feature Pack Update ^(KB3021910^) to Recovery Image
	echo.---------------------------------[Index : 1]-----------------------------------
	call :AddPackage "%WinReMount%", "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating WHD Baseline Feature Pack Update ^(KB4540725^) to Recovery Image
	echo.---------------------------------[Index : 1]-----------------------------------
	call :AddPackage "%WinReMount%", "%Temp%\Updates\Windows8.1-KB4540725-%ImageArchitecture%.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating WHD Baseline Feature Pack Update ^(KB3000850^) to Recovery Image
	echo.---------------------------------[Index : 1]-----------------------------------
	call :AddPackage "%WinReMount%", "%Temp%\Updates\Windows8.1-KB3000850-%ImageArchitecture%.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating WHD Baseline Feature Pack Update ^(KB3003057^) to Recovery Image
	echo.---------------------------------[Index : 1]-----------------------------------
	call :AddPackage "%WinReMount%", "%Temp%\Updates\Windows8.1-KB3003057-%ImageArchitecture%.cab"
)

:: Windows 8.1 with Update Refresh (IR5 Build : 6.3.9600.17415)
if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" equ "17415" (
	if exist "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab" (
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB3021910^) to Recovery Image
		echo.---------------------------------[Index : 1]-----------------------------------
		call :AddPackage "%WinReMount%", "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab"
	)
	echo.-------------------------------------------------------------------------------
	echo.Integrating WHD Baseline Feature Pack Update ^(KB4540725^) to Recovery Image
	echo.---------------------------------[Index : 1]-----------------------------------
	call :AddPackage "%WinReMount%", "%Temp%\Updates\Windows8.1-KB4540725-%ImageArchitecture%.cab"
)	

:: Windows 10
if "%SelectedSourceOS%" equ "w10" (
	if exist "%Temp%\Updates\ServicingStack\Update.mum" (
		if "%ImageBuild%" equ "10240" if "%ImageServicePackBuild%" equ "16384" (
			echo.-------------------------------------------------------------------------------
			echo.Applying Windows 10 v1507 Cumulative Update Integration Fix
			echo.-------------------------------------------------------------------------------
			if "%ImageArchitecture%" equ "x86" call :ApplyImage "%W10CUFix%\TH1CUFix.tpk", 1, "%WinReMount%"
			if "%ImageArchitecture%" equ "x64" call :ApplyImage "%W10CUFix%\TH1CUFix.tpk", 2, "%WinReMount%"
			call :MountImageRegistry "%WinReMount%"
			call :ImportRegistry2Image "%W10CUFix%\TH1CUFix_%ImageArchitecture%.reg" 2>nul
			call :UnMountImageRegistry
		)
		if "%ImageArchitecture%" equ "x86" if "%ImageBuild%" equ "14393" if "%ImageServicePackBuild%" equ "0" (
			echo.-------------------------------------------------------------------------------
			echo.Applying Windows 10 v1607 Cumulative Update Integration Fix
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%W10CUFix%\RS1CUFix.tpk", 1, "%WinReMount%"
			call :MountImageRegistry "%WinReMount%"
			call :ImportRegistry2Image "%W10CUFix%\RS1CUFix.reg" 2>nul
			call :UnMountImageRegistry
		)
		echo.-------------------------------------------------------------------------------
		echo.Integrating Windows 10 Servicing Stack Update to Recovery Image
		echo.---------------------------------[Index : 1]-----------------------------------
		call :AddPackage "%WinReMount%", "%Temp%\Updates\ServicingStack"
	)
	if exist "%Temp%\Updates\Cumulative\Update.mum" (
		echo.-------------------------------------------------------------------------------
		echo.Integrating Windows 10 Cumulative Update to Recovery Image
		echo.---------------------------------[Index : 1]-----------------------------------
		call :AddPackage "%WinReMount%", "%Temp%\Updates\Cumulative"
	)
	if exist "%Temp%\Updates\WinPE\*.cab" (
	echo.-------------------------------------------------------------------------------
		echo.Integrating Windows 10 WinPE Updates to Recovery Image
		echo.---------------------------------[Index : 1]-----------------------------------
		call :AddPackage "%WinReMount%", "%Temp%\Updates\WinPE"
	)
)

if "%IsLogsEnabled%" equ "Yes" (
	echo.-------------------------------------------------------------------------------
	if "%SelectedSourceOS%" equ "w81" echo.####Generating WHD Baseline Updates Integration Log Files######################
	if "%SelectedSourceOS%" equ "w10" echo.####Generating WHD General Updates Integration Log Files#######################
	echo.-------------------------------------------------------------------------------
	echo.
	if "%ImageIndexNo%" equ "*" (
		if "%SelectedSourceOS%" equ "w81" echo.Writing WHD Baseline Updates Integration [Install.wim, Index : 1-%ImageCount%] Log...
		if "%SelectedSourceOS%" equ "w10" echo.Writing WHD General Updates Integration [Install.wim, Index : 1-%ImageCount%] Log...
		for /L %%k in (1, 1, %ImageCount%) do (
			call :GetPackages "%InstallMount%\%%k", "Install-%%k.txt"
		)
	) else (
		if "%SelectedSourceOS%" equ "w81" echo.Writing WHD Baseline Updates Integration [Install.wim, Index : %ImageIndexNo%] Log...
		if "%SelectedSourceOS%" equ "w10" echo.Writing WHD General Updates Integration [Install.wim, Index : %ImageIndexNo%] Log...
		call :GetPackages "%InstallMount%", "Install.txt"
	)
	echo.
	if "%SelectedSourceOS%" equ "w81" echo.Writing WHD Baseline Updates Integration [WinRE.wim, Index : 1] Log...
	if "%SelectedSourceOS%" equ "w10" echo.Writing WHD General Updates Integration [WinRE.wim, Index : 1] Log...
	call :GetPackages "%WinReMount%", "Install_WinRE.txt"
	echo.
)

echo.-------------------------------------------------------------------------------
echo.####Cleaning Up Temporary Files ^& Folders#####################################
echo.-------------------------------------------------------------------------------
echo.
if "%SelectedSourceOS%" equ "w81" echo.Cleaning Up WHD Baseline Updates Temporary folder...
if "%SelectedSourceOS%" equ "w10" echo.Cleaning Up WHD General Updates Temporary folder...
call :RemoveFolder "%Temp%\Updates"
echo.
echo.-------------------------------------------------------------------------------
if "%SelectedSourceOS%" equ "w81" echo.####################Finished Integrating WHD Baseline Updates##################
if "%SelectedSourceOS%" equ "w10" echo.####################Finished Integrating WHD General Updates###################
echo.###################to Windows Setup Install ^& Recovery Images##################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set PackageArchitecture=
set Updates=

endlocal

:: Reading Updated Image Information
if "%SelectedSourceOS%" equ "w10" (
	if "%ImageIndexNo%" equ "*" (
		call :GetImageIndexInfo "%InstallWim%", 1 >nul
		call :MountImageRegistry "%InstallMount%\1"
		for /f "tokens=3 delims= " %%z in ('reg query "HKLM\TK_SOFTWARE\Microsoft\Windows NT\CurrentVersion" /v "UBR" ^| find "REG_DWORD"') do (set /a ImageServicePackBuild=%%z)
		call :UnMountImageRegistry
	) else (
		call :GetImageIndexInfo "%InstallWim%", %ImageIndexNo% >nul
		call :MountImageRegistry "%InstallMount%"
		for /f "tokens=3 delims= " %%z in ('reg query "HKLM\TK_SOFTWARE\Microsoft\Windows NT\CurrentVersion" /v "UBR" ^| find "REG_DWORD"') do (set /a ImageServicePackBuild=%%z)
		call :UnMountImageRegistry
	)
)

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate WHD Baseline Updates to Windows Setup Boot, Install & Recovery Image
::-------------------------------------------------------------------------------------------
:IntWHDBaseBootInstallRecovery

setlocal

cls
echo.===============================================================================
if "%SelectedSourceOS%" equ "w81" echo.                MSMG ToolKit - Integrate WHD Baseline Updates 
if "%SelectedSourceOS%" equ "w10" echo.                MSMG ToolKit -  Integrate WHD General Updates 
echo.              to Windows Setup Boot, Install ^& Recovery Images
echo.===============================================================================
echo.
if "%IsBootImageSelected%" equ "No" (
	echo.Windows Setup Boot Image is not selected...
	echo.
	echo.Please choose Windows Setup Boot Image while selecting Source...
	goto :Stop	
)

if "%IsRecoveryImageSelected%" equ "No" (
	echo.Windows Recovery Image is not selected...
	echo.
	echo.Please choose Windows Recovery Image while selecting Source...
	goto :Stop	
)

:: Getting Install Image Index Architecture
if "%ImageIndexNo%" equ "*" call :GetImageArchitecture "%InstallWim%", 1 >nul
if "%ImageIndexNo%" neq "*" call :GetImageArchitecture "%InstallWim%", %ImageIndexNo% >nul

:: Setting Package Architecture
if "%ImageArchitecture%" equ "x86" set "PackageArchitecture=x86"
if "%ImageArchitecture%" equ "x64" set "PackageArchitecture=amd64"
if "%ImageArchitecture%" equ "arm64" set "PackageArchitecture=arm64"

:: Settings WHD Baseline Updates folder path
if "%SelectedSourceOS%" equ "w81" set "Updates=%WHD%\%SelectedSourceOS%\%ImageArchitecture%\Baseline"
if "%SelectedSourceOS%" equ "w10" set "Updates=%WHD%\%SelectedSourceOS%\%ImageArchitecture%"

:: Checking whether WHD Baseline Updates folder is empty
:: Windows 8.1 RTM (Build : 6.3.9600.16384)
if "%SelectedSourceOS%" equ "w81" if %ImageServicePackBuild% equ 16384 (
	if not exist "%Updates%\RTM\*.msu" if not exist "%Updates%\RTM\*.cab" (
		echo.WHD Baseline Updates folder ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Baseline\RTM^> is empty...
	)
	if not exist "%Updates%\*.msu" if not exist "%Updates%\*.cab" (
		echo.
		echo.WHD Baseline Updates folder ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Baseline^> is empty...
	)
	echo.
	echo.Please copy WHD Baseline Updates to respective folder...
	goto :Stop
)

:: Windows 8.1 Post-RTM
if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" neq "16384" (
	if not exist "%Updates%\*.msu" if not exist "%Updates%\*.cab" (
		echo.WHD Baseline Updates folder ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Baseline^> is empty...
		echo.
		echo.Please copy WHD Baseline Updates to respective folder...
		goto :Stop
	)
)

:: Windows 10
if "%SelectedSourceOS%" equ "w10" if not exist "%Updates%\Cumulative\*.msu" if not exist "%Updates%\Cumulative\*.cab" (
	echo.WHD General Updates folder ^<WHD\w10\%ImageArchitecture%\Cumulative^> is empty...
	echo.
	echo.Please copy WHD General Updates to respective folder...
	goto :Stop
)
echo.-------------------------------------------------------------------------------
if "%SelectedSourceOS%" equ "w81" echo.##################Starting Integrating WHD Baseline Updates####################
if "%SelectedSourceOS%" equ "w10" echo.##################Starting Integrating WHD General Updates#####################
echo.##############to Windows Setup Boot, Install ^& Recovery Images#################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Boot.wim         ^|  Install.wim   ^|  WinRE.wim
if "%ImageIndexNo%" neq "*" echo.    Image Indexes            : 1, 2             ^|      %ImageIndexNo%         ^|      1
if "%ImageIndexNo%" equ "*" if not "%ImageCount%" gtr "9" echo.    Image Indexes            : 1, 2             ^|      1-%ImageCount%       ^|      1
if "%ImageIndexNo%" equ "*" if "%ImageCount%" gtr "9" echo.    Image Indexes            : 1, 2             ^|      1-%ImageCount%     ^|      1
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
if "%ImageIndexNo%" neq "*" echo.    Image Edition            : %ImageEdition%
echo.    Image Default Language   : %ImageDefaultLanguage%
echo.
echo.-------------------------------------------------------------------------------
if "%SelectedSourceOS%" equ "w81" echo.####Processing WHD Baseline Updates Packages###################################
if "%SelectedSourceOS%" equ "w10" echo.####Processing WHD General Updates Packages####################################
echo.-------------------------------------------------------------------------------
echo.
:: Creating WHD Baseline Updates Temporary folder
if "%SelectedSourceOS%" equ "w81" echo.Creating WHD Baseline Updates Temporary folder...
if "%SelectedSourceOS%" equ "w10" echo.Creating WHD General Updates Temporary folder...
call :RemoveFolder "%Temp%\Updates"
call :CreateFolder "%Temp%\Updates"
echo.

:: Extracting .CAB files From .MSU Package files to CAB Temporary folder
echo.Extracting .CAB Package files to Temporary folder...

:: Windows 8.1 RTM (Build : 6.3.9600.16384)
if "%SelectedSourceOS%" equ "w81" if %ImageServicePackBuild% equ 16384 (
	if exist "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\RTM\Windows8.1-KB2919355-%ImageArchitecture%*.msu" expand "%Updates%\RTM\Windows8.1-KB2919355-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\RTM\Windows8.1-KB2932046-%ImageArchitecture%*.msu" expand "%Updates%\RTM\Windows8.1-KB2932046-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB2934018-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB2934018-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\RTM\Windows8.1-KB2937592-%ImageArchitecture%*.msu" expand "%Updates%\RTM\Windows8.1-KB2937592-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\RTM\Windows8.1-KB2938439-%ImageArchitecture%*.msu" expand "%Updates%\RTM\Windows8.1-KB2938439-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\RTM\Windows8.1-KB2938772-%ImageArchitecture%*.msu" expand "%Updates%\RTM\Windows8.1-KB2938772-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul

	:: Copy .CAB files from .MSU package files to CAB Temporary folder
	if exist "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\RTM\Windows8.1-KB2919355-%ImageArchitecture%*.cab" %XCopy% "%Updates%\RTM\Windows8.1-KB2919355-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\RTM\Windows8.1-KB2932046-%ImageArchitecture%*.cab" %XCopy% "%Updates%\RTM\Windows8.1-KB2932046-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB2934018-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB2934018-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\RTM\Windows8.1-KB2937592-%ImageArchitecture%*.cab" %XCopy% "%Updates%\RTM\Windows8.1-KB2937592-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\RTM\Windows8.1-KB2938439-%ImageArchitecture%*.cab" %XCopy% "%Updates%\RTM\Windows8.1-KB2938439-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\RTM\Windows8.1-KB2938772-%ImageArchitecture%*.cab" %XCopy% "%Updates%\RTM\Windows8.1-KB2938772-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
)

:: Windows 8.1 with Update (IR3 Build : 6.3.9600.17031)
if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" equ "17031" (
	if exist "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB2934018-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB2934018-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul

	:: Copy .CAB files from .MSU package files to CAB Temporary folder
	if exist "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB2934018-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB2934018-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul	
	if exist "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
)

:: Windows 8.1 with Update Refresh (IR4 Build : 6.3.9600.17056)
if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" equ "17056" (
	if exist "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul

	:: Copy .CAB files from .MSU package files to CAB Temporary folder
	if exist "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
)

:: Windows 8.1 with Update Refresh (IR5 Build : 6.3.9600.17415)
if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" equ "17415" (
	if exist "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul

	:: Copy .CAB files from .MSU package files to CAB Temporary folder
	if exist "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB4540725-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
)

:: Windows 10
if "%SelectedSourceOS%" equ "w10" (
	for /d %%j in (ServicingStack, Cumulative, Enablement, FlashPlayer) do (
		if exist "%Updates%\%%j\*%ImageArchitecture%*.msu" (
			call :CreateFolder "%Temp%\Updates\%%j"
			expand -R "%Updates%\%%j\*%ImageArchitecture%*.msu" -F:*.cab "%Temp%\Updates\%%j" >nul
			call :RemoveFile "%Temp%\Updates\%%j\wsusscan.cab"
			expand -R "%Temp%\Updates\%%j\*.cab" -F:* "%Temp%\Updates\%%j" >nul
			if "%%j" equ "Cumulative" if exist "%Temp%\Updates\%%j\Cab_*.cab" expand -R "%Temp%\Updates\%%j\Cab_*.cab" -F:* "%Temp%\Updates\%%j" >nul
			call :RemoveFile "%Temp%\Updates\%%j\*.cab"
		)
		if exist "%Updates%\%%j\*%ImageArchitecture%*.cab" (
			call :CreateFolder "%Temp%\Updates\%%j"
			expand -R "%Updates%\%%j\*%ImageArchitecture%*.cab" -F:* "%Temp%\Updates\%%j" >nul
			if "%%j" equ "Cumulative" if exist "%Temp%\Updates\%%j\Cab_*.cab" expand -R "%Temp%\Updates\%%j\Cab_*.cab" -F:* "%Temp%\Updates\%%j" >nul
			call :RemoveFile "%Temp%\Updates\%%j\*.cab"
		)
	)
	
	for /d %%j in (Dynamic, NetCumulative, SetupMedia, WinPE) do (	
		if exist "%Updates%\%%j\*%ImageArchitecture%*.msu" (
			call :CreateFolder "%Temp%\Updates\%%j"
			expand -R "%Updates%\%%j\*%ImageArchitecture%*.msu" -F:*.cab "%Temp%\Updates\%%j" >nul
			call :RemoveFile "%Temp%\Updates\%%j\wsusscan.cab"		
		)
	
		if exist "%Updates%\%%j\*%ImageArchitecture%*.cab" (
			call :CreateFolder "%Temp%\Updates\%%j"
			%XCopy% "%Updates%\%%j\*%ImageArchitecture%*.cab" "%Temp%\Updates\%%j" >nul
		)
	)	
)
echo.
echo.Finished Extracting .CAB Package files to Temporary folder...
echo.
echo.-------------------------------------------------------------------------------
if "%SelectedSourceOS%" equ "w81" echo.####Integrating WHD Baseline Updates to Windows Setup Boot Image###############
if "%SelectedSourceOS%" equ "w10" echo.####Integrating WHD General Updates to Windows Setup Boot Image################
echo.-------------------------------------------------------------------------------
echo.
:: Windows 8.1 RTM (Build : 6.3.9600.16384)
if "%SelectedSourceOS%" equ "w81" if %ImageServicePackBuild% equ 16384 (
	for /l %%i in (1, 1, 2) do (
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Prerequisite Update ^(KB3021910^) to Boot Image
		echo.---------------------------------[Index : %%i]-----------------------------------
		call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Update ^(KB2919355^) to Boot Image
		echo.---------------------------------[Index : %%i]-----------------------------------
		call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB2919355-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB3000850^) to Boot Image
		echo.---------------------------------[Index : %%i]-----------------------------------
		call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB3000850-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB2932046^) to Boot Image
		echo.---------------------------------[Index : %%i]-----------------------------------
		call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB2932046-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB2934018^) to Boot Image
		echo.---------------------------------[Index : %%i]-----------------------------------
		call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB2934018-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB2937592^) to Boot Image
		echo.---------------------------------[Index : %%i]-----------------------------------
		call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB2937592-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB2938439^) to Boot Image
		echo.---------------------------------[Index : %%i]-----------------------------------
		call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB2938439-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB2938772^) to Boot Image
		echo.---------------------------------[Index : %%i]-----------------------------------
		call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB2938772-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB3003057^) to Boot Image
		echo.---------------------------------[Index : %%i]-----------------------------------
		call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB3003057-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB4540725^) to Boot Image
		echo.---------------------------------[Index : %%i]-----------------------------------
		call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB4540725-%ImageArchitecture%.cab"
	)
)

:: Windows 8.1 with Update (IR3 Build : 6.3.9600.17031)
if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" equ "17031" (
	for /l %%i in (1, 1, 2) do (
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB3021910^) to Boot Image
		echo.---------------------------------[Index : %%i]-----------------------------------
		call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB4540725^) to Boot Image
		echo.---------------------------------[Index : %%i]-----------------------------------
		call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB4540725-%ImageArchitecture%.cab"    
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB3000850^) to Boot Image
		echo.---------------------------------[Index : %%i]-----------------------------------
		call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB3000850-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB2934018^) to Boot Image
		echo.---------------------------------[Index : %%i]-----------------------------------
		call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB2934018-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB3003057^) to Boot Image
		echo.---------------------------------[Index : %%i]-----------------------------------
		call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB3003057-%ImageArchitecture%.cab"
	)
)

:: Windows 8.1 with Update (IR4 Build : 6.3.9600.17056)
if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" equ "17056" (
	for /l %%i in (1, 1, 2) do (
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB3021910^) to Boot Image
		echo.---------------------------------[Index : %%i]-----------------------------------
		call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB4540725^) to Boot Image
		echo.---------------------------------[Index : %%i]-----------------------------------
		call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB4540725-%ImageArchitecture%.cab"    
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB3000850^) to Boot Image
		echo.---------------------------------[Index : %%i]-----------------------------------
		call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB3000850-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB3003057^) to Boot Image
		echo.---------------------------------[Index : %%i]-----------------------------------
		call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB3003057-%ImageArchitecture%.cab"
	)
)

:: Windows 8.1 with Update Refresh (IR5 Build : 6.3.9600.17415)
if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" equ "17415" (
	for /l %%i in (1, 1, 2) do (
		if exist "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB3021910^) to Boot Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab"
		)
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB4540725^) to Boot Image
		echo.---------------------------------[Index : %%i]-----------------------------------
		call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB4540725-%ImageArchitecture%.cab"		
	)
)

:: Windows 10
if "%SelectedSourceOS%" equ "w10" (
	for /l %%i in (1, 1, 2) do (
		if exist "%Temp%\Updates\ServicingStack\Update.mum" (
			if "%ImageBuild%" equ "10240" if "%ImageServicePackBuild%" equ "16384" (
				echo.-------------------------------------------------------------------------------
				echo.Applying Windows 10 v1507 Cumulative Update Integration Fix
				echo.-------------------------------------------------------------------------------
				if "%ImageArchitecture%" equ "x86" call :ApplyImage "%W10CUFix%\TH1CUFix.tpk", 1, "%BootMount%\%%i"
				if "%ImageArchitecture%" equ "x64" call :ApplyImage "%W10CUFix%\TH1CUFix.tpk", 2, "%BootMount%\%%i"
				call :MountImageRegistry "%BootMount%\%%i"
				call :ImportRegistry2Image "%W10CUFix%\TH1CUFix_%ImageArchitecture%.reg" 2>nul
				call :UnMountImageRegistry
			)
			if "%ImageArchitecture%" equ "x86" if "%ImageBuild%" equ "14393" if "%ImageServicePackBuild%" equ "0" (
				echo.-------------------------------------------------------------------------------
				echo.Applying Windows 10 v1607 Cumulative Update Integration Fix
				echo.-------------------------------------------------------------------------------
				call :ApplyImage "%W10CUFix%\RS1CUFix.tpk", 1, "%BootMount%\%%i"
				call :MountImageRegistry "%BootMount%\%%i"
				call :ImportRegistry2Image "%W10CUFix%\RS1CUFix.reg" 2>nul
				call :UnMountImageRegistry
			)
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows 10 Servicing Stack Update to Boot Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\ServicingStack"
		)
		if exist "%Temp%\Updates\Cumulative\Update.mum" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows 10 Cumulative Update to Boot Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Cumulative"
		)
	)
	if exist "%Temp%\Updates\WinPE\*.cab" (
		echo.-------------------------------------------------------------------------------
		echo.Integrating Windows 10 WinPE Updates to Boot Image
		echo.---------------------------------[Index : 2]-----------------------------------
		call :AddPackage "%BootMount%\2", "%Temp%\Updates\WinPE"
	)
	if exist "%Temp%\Updates\SetupMedia\*.cab" (
		echo.-------------------------------------------------------------------------------
		echo.Integrating Windows 10 Setup Media Update
		echo.-------------------------------------------------------------------------------
		echo.
		echo.Extracting Windows 10 Setup Media Update to ^<DVD^> folder...
		expand -R "%Temp%\Updates\SetupMedia\*.cab" -F:* "%DVD%\sources" >nul
		cd /d "%DVD%\sources\" >nul
		for /d %%i in (ar-SA,bg-BG,cs-CZ,da-DK,de-DE,el-GR,en-GB,en-US,es-ES,es-MX,et-EE,fi-FI,fr-CA,fr-FR,he-IL,hr-HR,hu-HU,it-IT,ja-JP,ko-KR,lt-LT,lv-LV,nb-NO,nl-NL,pl-PL,pt-BR,pt-PT,ro-RO,ru-RU,sk-SK,sl-SI,sr-Latn-RS,sv-SE,th-TH,tr-TR,uk-UA,zh-CN,zh-HK,zh-TW) do (
			if "%ImageDefaultLanguage%" neq "%%i" rd /q /s "%DVD%\sources\%%i" >nul 2>&1
		)
		cd /d "%ROOT%\" >nul
		echo.
	)
)
echo.-------------------------------------------------------------------------------
if "%SelectedSourceOS%" equ "w81" echo.####Integrating WHD Baseline Updates to Windows Setup Install Image############
if "%SelectedSourceOS%" equ "w10" echo.####Integrating WHD General Updates to Windows Setup Install Image#############
echo.-------------------------------------------------------------------------------
echo.
if "%ImageIndexNo%" equ "*" (
	for /L %%i in (1, 1, %ImageCount%) do (
		:: Windows 8.1 RTM (Build : 6.3.9600.16384)
		if "%SelectedSourceOS%" equ "w81" if %ImageServicePackBuild% equ 16384 (
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Prerequisite Update ^(KB3021910^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Update ^(KB2919355^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB2919355-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB3000850^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB3000850-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB2932046^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB2932046-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB2934018^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB2934018-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB2937592^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB2937592-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB2938439^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB2938439-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB2938772^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB2938772-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB3003057^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB3003057-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB3014442^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB3014442-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB4540725^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB4540725-%ImageArchitecture%.cab"
		)

		:: Windows 8.1 with Update (IR3 Build : 6.3.9600.17031)
		if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" equ "17031" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB3021910^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB4540725^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB4540725-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB3000850^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB3000850-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB2934018^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB2934018-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB3003057^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB3003057-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB3014442^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB3014442-%ImageArchitecture%.cab"
		)

		:: Windows 8.1 with Update (IR4 Build : 6.3.9600.17056)
		if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" equ "17056" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB3021910^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB4540725^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB4540725-%ImageArchitecture%.cab"			
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB3000850^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB3000850-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB3003057^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB3003057-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB3014442^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB3014442-%ImageArchitecture%.cab"
		)

		:: Windows 8.1 with Update Refresh (IR5 Build : 6.3.9600.17415)
		if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" equ "17415" (
			if exist "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating WHD Baseline Feature Pack Update ^(KB3021910^) to Install Image
				echo.---------------------------------[Index : %%i]-----------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab"
			)
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB4540725^) to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB4540725-%ImageArchitecture%.cab"
		)

		:: Windows 10
		if "%SelectedSourceOS%" equ "w10" (
			:: Importing Registry fix to Enable Integrating Windows 10 LTSB 2015 Updates to Windows 10 Non-LTSB Editions.
			if "%ImageBuild%" equ "10240" if "%ImageEdition%" neq "EnterpriseS" if "%ImageEdition%" neq "EnterpriseSN" (
				call :MountImageRegistry "%InstallMount%\%%i"
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "InstallClient" /t REG_SZ /d "DISM Package Manager Provider" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "InstallName" /t REG_SZ /d "Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384.mum" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "InstallLocation" /t REG_SZ /d "\\?\d:\th1.bin.%PackageArchitecture%fre\csi\pkgs\\" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "CurrentState" /t REG_DWORD /d "112" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "SelfUpdate" /t REG_DWORD /d "0" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "Visibility" /t REG_DWORD /d "1" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "InstallTimeHigh" /t REG_DWORD /d "30649479" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "InstallTimeLow" /t REG_DWORD /d "1431244152" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "InstallUser" /t REG_SZ /d "S-1-5-18" /f >nul
				call :UnMountImageRegistry
			)

			:: Importing Registry fix to Enable Integrating Windows 10 Education/Enterprise Updates to Windows 10 Non Education/Enterprise (N) Editions.
			if "%ImageBuild%" equ "10586" if "%ImageEdition%" neq "Education" if "%ImageEdition%" neq "EducationN" if "%ImageEdition%" neq "Enterprise" if "%ImageEdition%" neq "EnterpriseN" (
				call :MountImageRegistry "%InstallMount%\%%i"
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "InstallClient" /t REG_SZ /d "DISM Package Manager Provider" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "InstallName" /t REG_SZ /d "Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0.mum" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "InstallLocation" /t REG_SZ /d "\\?\d:\th2.bin.%PackageArchitecture%fre\csi\pkgs\\" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "CurrentState" /t REG_DWORD /d "112" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "SelfUpdate" /t REG_DWORD /d "0" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "Visibility" /t REG_DWORD /d "1" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "InstallTimeHigh" /t REG_DWORD /d "30649479" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "InstallTimeLow" /t REG_DWORD /d "1431244152" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "InstallUser" /t REG_SZ /d "S-1-5-18" /f >nul
				call :UnMountImageRegistry
			)

			:: Importing Registry fix to Enable Integrating Windows 10 Education/Enterprise/LTSB 2016 Updates to Windows 10 Non Education/Enterprise/LTSB 2016 Editions.
			if "%ImageBuild%" equ "14393" if "%ImageEdition%" neq "Education" if "%ImageEdition%" neq "EducationN" if "%ImageEdition%" neq "Enterprise" if "%ImageEdition%" neq "EnterpriseN" if "%ImageEdition%" neq "EnterpriseS" if "%ImageEdition%" neq "EnterpriseSN" (
				call :MountImageRegistry "%InstallMount%\%%i"
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "InstallClient" /t REG_SZ /d "DISM Package Manager Provider" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "InstallName" /t REG_SZ /d "Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0.mum" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "InstallLocation" /t REG_SZ /d "\\?\d:\rs1.bin.%PackageArchitecture%fre\csi\pkgs\\" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "CurrentState" /t REG_DWORD /d "112" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "SelfUpdate" /t REG_DWORD /d "0" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "Visibility" /t REG_DWORD /d "1" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "InstallTimeHigh" /t REG_DWORD /d "30649479" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "InstallTimeLow" /t REG_DWORD /d "1431244152" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "InstallUser" /t REG_SZ /d "S-1-5-18" /f >nul
				call :UnMountImageRegistry
			)

			:: Importing Registry fix to Enable Integrating Windows Updates to Windows 10 Pro for Workstation Edition.
			if "%ImageBuild%" equ "16299" if "%ImageEdition%" equ "ProfessionalWorkstation" (
				call :MountImageRegistry "%InstallMount%\%%i"
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallClient" /t REG_SZ /d "DISM Package Manager Provider" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallName" /t REG_SZ /d "Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15.mum" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallLocation" /t REG_SZ /d "\\?\d:\rs2.bin.%PackageArchitecture%fre\csi\pkgs\\" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "CurrentState" /t REG_DWORD /d "112" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "SelfUpdate" /t REG_DWORD /d "0" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "Visibility" /t REG_DWORD /d "1" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallTimeHigh" /t REG_DWORD /d "30649479" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallTimeLow" /t REG_DWORD /d "1431244152" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallUser" /t REG_SZ /d "S-1-5-18" /f >nul
				call :UnMountImageRegistry
			)
			
			:: Importing Registry fix to Enable Integrating Windows Updates to Windows 10 Pro for Workstation 'N' Edition.
			if "%ImageBuild%" equ "16299" if "%ImageEdition%" equ "ProfessionalWorkstationN" (
				call :MountImageRegistry "%InstallMount%\%%i"
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallClient" /t REG_SZ /d "DISM Package Manager Provider" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallName" /t REG_SZ /d "Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15.mum" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallLocation" /t REG_SZ /d "\\?\d:\rs2.bin.%PackageArchitecture%fre\csi\pkgs\\" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "CurrentState" /t REG_DWORD /d "112" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "SelfUpdate" /t REG_DWORD /d "0" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "Visibility" /t REG_DWORD /d "1" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallTimeHigh" /t REG_DWORD /d "30649479" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallTimeLow" /t REG_DWORD /d "1431244152" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallUser" /t REG_SZ /d "S-1-5-18" /f >nul
				call :UnMountImageRegistry
			)
					
			if exist "%Temp%\Updates\ServicingStack\Update.mum" (
				if "%ImageBuild%" equ "10240" if "%ImageServicePackBuild%" equ "16384" (
					echo.-------------------------------------------------------------------------------
					echo.Applying Windows 10 v1507 Cumulative Update Integration Fix
					echo.-------------------------------------------------------------------------------
					if "%ImageArchitecture%" equ "x86" call :ApplyImage "%W10CUFix%\TH1CUFix.tpk", 1, "%InstallMount%\%%i"
					if "%ImageArchitecture%" equ "x64" call :ApplyImage "%W10CUFix%\TH1CUFix.tpk", 2, "%InstallMount%\%%i"
					call :MountImageRegistry "%InstallMount%\%%i"
					call :ImportRegistry2Image "%W10CUFix%\TH1CUFix_%ImageArchitecture%.reg" 2>nul
					call :UnMountImageRegistry
				)
				if "%ImageArchitecture%" equ "x86" if "%ImageBuild%" equ "14393" if "%ImageServicePackBuild%" equ "0" (
					echo.-------------------------------------------------------------------------------
					echo.Applying Windows 10 v1607 Cumulative Update Integration Fix
					echo.-------------------------------------------------------------------------------
					call :ApplyImage "%W10CUFix%\RS1CUFix.tpk", 1, "%InstallMount%\%%i"
					call :MountImageRegistry "%InstallMount%\%%i"
					call :ImportRegistry2Image "%W10CUFix%\RS1CUFix.reg" 2>nul
					call :UnMountImageRegistry
				)
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows 10 Servicing Stack Update to Install Image
				echo.---------------------------------[Index : %%i]-----------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\ServicingStack"
			)
			if exist "%Temp%\Updates\Dynamic\*.cab" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows 10 Dynamic Updates to Install Image
				echo.---------------------------------[Index : %%i]-----------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Dynamic"
			)
			if exist "%Temp%\Updates\FlashPlayer\Update.mum" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Adobe Flash Player Security Update to Install Image
				echo.---------------------------------[Index : %%i]-----------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\FlashPlayer"
			)
			if exist "%Temp%\Updates\NetCumulative\*.cab" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows 10 .NET Cumulative Update to Install Image
				echo.---------------------------------[Index : %%i]-----------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\NetCumulative"
			)
			if exist "%Temp%\Updates\Cumulative\Update.mum" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows 10 Cumulative Update to Install Image
				echo.---------------------------------[Index : %%i]-----------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Cumulative"		
			)
			if exist "%Temp%\Updates\Enablement\Update.mum" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows 10 Enablement Update to Install Image
				echo.---------------------------------[Index : %%i]-----------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Enablement"		
			)
		)
	)
) else (
	:: Windows 8.1 RTM (Build : 6.3.9600.16384)
	if "%SelectedSourceOS%" equ "w81" if %ImageServicePackBuild% equ 16384 (
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Prerequisite Update ^(KB3021910^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Update ^(KB2919355^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB2919355-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB3000850^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB3000850-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB2932046^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB2932046-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB2934018^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB2934018-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB2937592^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB2937592-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB2938439^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB2938439-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB2938772^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB2938772-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB3003057^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB3003057-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB3014442^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB3014442-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB4540725^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB4540725-%ImageArchitecture%.cab"
	)

	:: Windows 8.1 with Update (IR3 Build : 6.3.9600.17031)
	if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" equ "17031" (
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB3021910^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB4540725^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB4540725-%ImageArchitecture%.cab"		
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB3000850^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB3000850-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB2934018^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB2934018-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB3003057^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB3003057-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB3014442^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB3014442-%ImageArchitecture%.cab"
	)

	:: Windows 8.1 with Update (IR4 Build : 6.3.9600.17056)
	if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" equ "17056" (
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB3021910^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB4540725^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB4540725-%ImageArchitecture%.cab"			
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB3000850^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB3000850-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB3003057^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB3003057-%ImageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB3014442^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB3014442-%ImageArchitecture%.cab"
	)

	:: Windows 8.1 with Update Refresh (IR5 Build : 6.3.9600.17415)
	if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" equ "17415" (
		if exist "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB3021910^) to Install Image
			echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
			call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab"
		)
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB4540725^) to Install Image
		echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\Windows8.1-KB4540725-%ImageArchitecture%.cab"
	)

	:: Windows 10
	if "%SelectedSourceOS%" equ "w10" (
		:: Importing Registry fix to Enable Integrating Windows 10 LTSB 2015 Updates to Windows 10 Non-LTSB Editions.
		if "%ImageBuild%" equ "10240" if "%ImageEdition%" neq "EnterpriseS" if "%ImageEdition%" neq "EnterpriseSN" (
			call :MountImageRegistry "%InstallMount%"
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "InstallClient" /t REG_SZ /d "DISM Package Manager Provider" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "InstallName" /t REG_SZ /d "Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384.mum" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "InstallLocation" /t REG_SZ /d "\\?\d:\th1.bin.%PackageArchitecture%fre\csi\pkgs\\" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "CurrentState" /t REG_DWORD /d "112" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "SelfUpdate" /t REG_DWORD /d "0" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "Visibility" /t REG_DWORD /d "1" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "InstallTimeHigh" /t REG_DWORD /d "30649479" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "InstallTimeLow" /t REG_DWORD /d "1431244152" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "InstallUser" /t REG_SZ /d "S-1-5-18" /f >nul
			call :UnMountImageRegistry
		)

		:: Importing Registry fix to Enable Integrating Windows 10 Education/Enterprise Updates to Windows 10 Non Education/Enterprise (N) Editions.
		if "%ImageBuild%" equ "10586" if "%ImageEdition%" neq "Education" if "%ImageEdition%" neq "EducationN" if "%ImageEdition%" neq "Enterprise" if "%ImageEdition%" neq "EnterpriseN" (
			call :MountImageRegistry "%InstallMount%"
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "InstallClient" /t REG_SZ /d "DISM Package Manager Provider" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "InstallName" /t REG_SZ /d "Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0.mum" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "InstallLocation" /t REG_SZ /d "\\?\d:\th2.bin.%PackageArchitecture%fre\csi\pkgs\\" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "CurrentState" /t REG_DWORD /d "112" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "SelfUpdate" /t REG_DWORD /d "0" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "Visibility" /t REG_DWORD /d "1" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "InstallTimeHigh" /t REG_DWORD /d "30649479" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "InstallTimeLow" /t REG_DWORD /d "1431244152" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "InstallUser" /t REG_SZ /d "S-1-5-18" /f >nul
			call :UnMountImageRegistry
		)

		:: Importing Registry fix to Enable Integrating Windows 10 Education/Enterprise/LTSB 2016 Updates to Windows 10 Non Education/Enterprise/LTSB 2016 Editions.
		if "%ImageBuild%" equ "14393" if "%ImageEdition%" neq "Education" if "%ImageEdition%" neq "EducationN" if "%ImageEdition%" neq "Enterprise" if "%ImageEdition%" neq "EnterpriseN" if "%ImageEdition%" neq "EnterpriseS" if "%ImageEdition%" neq "EnterpriseSN" (
			call :MountImageRegistry "%InstallMount%"
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "InstallClient" /t REG_SZ /d "DISM Package Manager Provider" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "InstallName" /t REG_SZ /d "Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0.mum" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "InstallLocation" /t REG_SZ /d "\\?\d:\rs1.bin.%PackageArchitecture%fre\csi\pkgs\\" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "CurrentState" /t REG_DWORD /d "112" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "SelfUpdate" /t REG_DWORD /d "0" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "Visibility" /t REG_DWORD /d "1" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "InstallTimeHigh" /t REG_DWORD /d "30649479" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "InstallTimeLow" /t REG_DWORD /d "1431244152" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "InstallUser" /t REG_SZ /d "S-1-5-18" /f >nul
			call :UnMountImageRegistry
		)

		:: Importing Registry Fix to Enable Integrating Windows Updates to Windows 10 Pro for Workstation Edition.
		if "%ImageBuild%" equ "16299" if "%ImageEdition%" equ "ProfessionalWorkstation" (
			call :MountImageRegistry "%InstallMount%"
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallClient" /t REG_SZ /d "DISM Package Manager Provider" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallName" /t REG_SZ /d "Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15.mum" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallLocation" /t REG_SZ /d "\\?\d:\rs2.bin.%PackageArchitecture%fre\csi\pkgs\\" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "CurrentState" /t REG_DWORD /d "112" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "SelfUpdate" /t REG_DWORD /d "0" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "Visibility" /t REG_DWORD /d "1" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallTimeHigh" /t REG_DWORD /d "30649479" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallTimeLow" /t REG_DWORD /d "1431244152" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallUser" /t REG_SZ /d "S-1-5-18" /f >nul
			call :UnMountImageRegistry
		)		
		
		:: Importing Registry Fix to Enable Integrating Windows Updates to Windows 10 Pro for Workstation 'N' Edition.
		if "%ImageBuild%" equ "16299" if "%ImageEdition%" equ "ProfessionalWorkstationN" (
			call :MountImageRegistry "%InstallMount%"
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallClient" /t REG_SZ /d "DISM Package Manager Provider" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallName" /t REG_SZ /d "Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15.mum" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallLocation" /t REG_SZ /d "\\?\d:\rs2.bin.%PackageArchitecture%fre\csi\pkgs\\" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "CurrentState" /t REG_DWORD /d "112" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "SelfUpdate" /t REG_DWORD /d "0" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "Visibility" /t REG_DWORD /d "1" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallTimeHigh" /t REG_DWORD /d "30649479" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallTimeLow" /t REG_DWORD /d "1431244152" /f >nul
			reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-ProfessionalNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallUser" /t REG_SZ /d "S-1-5-18" /f >nul
			call :UnMountImageRegistry
		)	
		
		if exist "%Temp%\Updates\ServicingStack\Update.mum" (
			if "%ImageBuild%" equ "10240" if "%ImageServicePackBuild%" equ "16384" (
				echo.-------------------------------------------------------------------------------
				echo.Applying Windows 10 v1507 Cumulative Update Integration Fix
				echo.-------------------------------------------------------------------------------
				if "%ImageArchitecture%" equ "x86" call :ApplyImage "%W10CUFix%\TH1CUFix.tpk", 1, "%InstallMount%"
				if "%ImageArchitecture%" equ "x64" call :ApplyImage "%W10CUFix%\TH1CUFix.tpk", 2, "%InstallMount%"
				call :MountImageRegistry "%InstallMount%"
				call :ImportRegistry2Image "%W10CUFix%\TH1CUFix_%ImageArchitecture%.reg" 2>nul
				call :UnMountImageRegistry
			)
			if "%ImageArchitecture%" equ "x86" if "%ImageBuild%" equ "14393" if "%ImageServicePackBuild%" equ "0" (
				echo.-------------------------------------------------------------------------------
				echo.Applying Windows 10 v1607 Cumulative Update Integration Fix
				echo.-------------------------------------------------------------------------------
				call :ApplyImage "%W10CUFix%\RS1CUFix.tpk", 1, "%InstallMount%"
				call :MountImageRegistry "%InstallMount%"
				call :ImportRegistry2Image "%W10CUFix%\RS1CUFix.reg" 2>nul
				call :UnMountImageRegistry
			)
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows 10 Servicing Stack Update to Install Image
			echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
			call :AddPackage "%InstallMount%", "%Temp%\Updates\ServicingStack"
		)
		if exist "%Temp%\Updates\Dynamic\*.cab" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows 10 Dynamic Updates to Install Image
			echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
			call :AddPackage "%InstallMount%", "%Temp%\Updates\Dynamic"
		)
		if exist "%Temp%\Updates\FlashPlayer\Update.mum" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Adobe Flash Player Security Update to Install Image
			echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
			call :AddPackage "%InstallMount%", "%Temp%\Updates\FlashPlayer"
		)
		if exist "%Temp%\Updates\NetCumulative\*.cab" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows 10 .NET Cumulative Update to Install Image
			echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
			call :AddPackage "%InstallMount%", "%Temp%\Updates\NetCumulative"
		)
		if exist "%Temp%\Updates\Cumulative\Update.mum" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows 10 Cumulative Update to Install Image
			echo.---------------------------------[Index : %ImageIndexNo%]-----------------------------------
			call :AddPackage "%InstallMount%", "%Temp%\Updates\Cumulative"
		)
		if exist "%Temp%\Updates\Enablement\Update.mum" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows 10 Enablement Update to Install Image
			echo.---------------------------------[Index : %%i]-----------------------------------
			call :AddPackage "%InstallMount%", "%Temp%\Updates\Enablement"		
		)
	)
)
echo.-------------------------------------------------------------------------------
if "%SelectedSourceOS%" equ "w81" echo.####Integrating WHD Baseline Updates to Windows Setup Recovery Image###########
if "%SelectedSourceOS%" equ "w10" echo.####Integrating WHD General Updates to Windows Setup Recovery Image############
echo.-------------------------------------------------------------------------------
echo.
:: Windows 8.1 RTM (Build : 6.3.9600.16384)
if "%SelectedSourceOS%" equ "w81" if %ImageServicePackBuild% equ 16384 (
	echo.-------------------------------------------------------------------------------
	echo.Integrating WHD Baseline Prerequisite Update ^(KB3021910^) to Recovery Image
	echo.---------------------------------[Index : 1]-----------------------------------
	call :AddPackage "%WinReMount%", "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating WHD Baseline Update ^(KB2919355^) to Recovery Image
	echo.---------------------------------[Index : 1]-----------------------------------
	call :AddPackage "%WinReMount%", "%Temp%\Updates\Windows8.1-KB2919355-%ImageArchitecture%.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating WHD Baseline Feature Pack Update ^(KB3000850^) to Recovery Image
	echo.---------------------------------[Index : 1]-----------------------------------
	call :AddPackage "%WinReMount%", "%Temp%\Updates\Windows8.1-KB3000850-%ImageArchitecture%.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating WHD Baseline Feature Pack Update ^(KB2932046^) to Recovery Image
	echo.---------------------------------[Index : 1]-----------------------------------
	call :AddPackage "%WinReMount%", "%Temp%\Updates\Windows8.1-KB2932046-%ImageArchitecture%.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating WHD Baseline Feature Pack Update ^(KB2934018^) to Recovery Image
	echo.---------------------------------[Index : 1]-----------------------------------
	call :AddPackage "%WinReMount%", "%Temp%\Updates\Windows8.1-KB2934018-%ImageArchitecture%.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating WHD Baseline Feature Pack Update ^(KB2937592^) to Recovery Image
	echo.---------------------------------[Index : 1]-----------------------------------
	call :AddPackage "%WinReMount%", "%Temp%\Updates\Windows8.1-KB2937592-%ImageArchitecture%.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating WHD Baseline Feature Pack Update ^(KB2938439^) to Recovery Image
	echo.---------------------------------[Index : 1]-----------------------------------
	call :AddPackage "%WinReMount%", "%Temp%\Updates\Windows8.1-KB2938439-%ImageArchitecture%.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating WHD Baseline Feature Pack Update ^(KB2938772^) to Recovery Image
	echo.---------------------------------[Index : 1]-----------------------------------
	call :AddPackage "%WinReMount%", "%Temp%\Updates\Windows8.1-KB2938772-%ImageArchitecture%.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating WHD Baseline Feature Pack Update ^(KB3003057^) to Recovery Image
	echo.---------------------------------[Index : 1]-----------------------------------
	call :AddPackage "%WinReMount%", "%Temp%\Updates\Windows8.1-KB3003057-%ImageArchitecture%.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating WHD Baseline Feature Pack Update ^(KB4540725^) to Recovery Image
	echo.---------------------------------[Index : 1]-----------------------------------
	call :AddPackage "%WinReMount%", "%Temp%\Updates\Windows8.1-KB4540725-%ImageArchitecture%.cab"
)

:: Windows 8.1 with Update (IR3 Build : 6.3.9600.17031)
if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" equ "17031" (
	echo.-------------------------------------------------------------------------------
	echo.Integrating WHD Baseline Feature Pack Update ^(KB3021910^) to Recovery Image
	echo.---------------------------------[Index : 1]-----------------------------------
	call :AddPackage "%WinReMount%", "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating WHD Baseline Feature Pack Update ^(KB4540725^) to Recovery Image
	echo.---------------------------------[Index : 1]-----------------------------------
	call :AddPackage "%WinReMount%", "%Temp%\Updates\Windows8.1-KB4540725-%ImageArchitecture%.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating WHD Baseline Feature Pack Update ^(KB3000850^) to Recovery Image
	echo.---------------------------------[Index : 1]-----------------------------------
	call :AddPackage "%WinReMount%", "%Temp%\Updates\Windows8.1-KB3000850-%ImageArchitecture%.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating WHD Baseline Feature Pack Update ^(KB2934018^) to Recovery Image
	echo.---------------------------------[Index : 1]-----------------------------------
	call :AddPackage "%WinReMount%", "%Temp%\Updates\Windows8.1-KB2934018-%ImageArchitecture%.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating WHD Baseline Feature Pack Update ^(KB3003057^) to Recovery Image
	echo.---------------------------------[Index : 1]-----------------------------------
	call :AddPackage "%WinReMount%", "%Temp%\Updates\Windows8.1-KB3003057-%ImageArchitecture%.cab"
)

:: Windows 8.1 with Update Refresh (IR4 Build : 6.3.9600.17056)
if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" equ "17056" (
	echo.-------------------------------------------------------------------------------
	echo.Integrating WHD Baseline Feature Pack Update ^(KB3021910^) to Recovery Image
	echo.---------------------------------[Index : 1]-----------------------------------
	call :AddPackage "%WinReMount%", "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating WHD Baseline Feature Pack Update ^(KB4540725^) to Recovery Image
	echo.---------------------------------[Index : 1]-----------------------------------
	call :AddPackage "%WinReMount%", "%Temp%\Updates\Windows8.1-KB4540725-%ImageArchitecture%.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating WHD Baseline Feature Pack Update ^(KB3000850^) to Recovery Image
	echo.---------------------------------[Index : 1]-----------------------------------
	call :AddPackage "%WinReMount%", "%Temp%\Updates\Windows8.1-KB3000850-%ImageArchitecture%.cab"
	echo.-------------------------------------------------------------------------------
	echo.Integrating WHD Baseline Feature Pack Update ^(KB3003057^) to Recovery Image
	echo.---------------------------------[Index : 1]-----------------------------------
	call :AddPackage "%WinReMount%", "%Temp%\Updates\Windows8.1-KB3003057-%ImageArchitecture%.cab"
)

:: Windows 8.1 with Update Refresh (IR5 Build : 6.3.9600.17415)
if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" equ "17415" (
	if exist "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab" (
		echo.-------------------------------------------------------------------------------
		echo.Integrating WHD Baseline Feature Pack Update ^(KB3021910^) to Recovery Image
		echo.---------------------------------[Index : 1]-----------------------------------
		call :AddPackage "%WinReMount%", "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab"
	)
	echo.-------------------------------------------------------------------------------
	echo.Integrating WHD Baseline Feature Pack Update ^(KB4540725^) to Recovery Image
	echo.---------------------------------[Index : 1]-----------------------------------
	call :AddPackage "%WinReMount%", "%Temp%\Updates\Windows8.1-KB4540725-%ImageArchitecture%.cab"
)	

:: Windows 10
if "%SelectedSourceOS%" equ "w10" (
	if exist "%Temp%\Updates\ServicingStack\Update.mum" (
		if "%ImageBuild%" equ "10240" if "%ImageServicePackBuild%" equ "16384" (
			echo.-------------------------------------------------------------------------------
			echo.Applying Windows 10 v1507 Cumulative Update Integration Fix
			echo.-------------------------------------------------------------------------------
			if "%ImageArchitecture%" equ "x86" call :ApplyImage "%W10CUFix%\TH1CUFix.tpk", 1, "%WinReMount%"
			if "%ImageArchitecture%" equ "x64" call :ApplyImage "%W10CUFix%\TH1CUFix.tpk", 2, "%WinReMount%"
			call :MountImageRegistry "%WinReMount%"
			call :ImportRegistry2Image "%W10CUFix%\TH1CUFix_%ImageArchitecture%.reg" 2>nul
			call :UnMountImageRegistry
		)
		if "%ImageArchitecture%" equ "x86" if "%ImageBuild%" equ "14393" if "%ImageServicePackBuild%" equ "0" (
			echo.-------------------------------------------------------------------------------
			echo.Applying Windows 10 v1607 Cumulative Update Integration Fix
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%W10CUFix%\RS1CUFix.tpk", 1, "%WinReMount%"
			call :MountImageRegistry "%WinReMount%"
			call :ImportRegistry2Image "%W10CUFix%\RS1CUFix.reg" 2>nul
			call :UnMountImageRegistry
		)
		echo.-------------------------------------------------------------------------------
		echo.Integrating Windows 10 Servicing Stack Update to Recovery Image
		echo.---------------------------------[Index : 1]-----------------------------------
		call :AddPackage "%WinReMount%", "%Temp%\Updates\ServicingStack"
	)
	if exist "%Temp%\Updates\Cumulative\Update.mum" (
		echo.-------------------------------------------------------------------------------
		echo.Integrating Windows 10 Cumulative Update to Recovery Image
		echo.---------------------------------[Index : 1]-----------------------------------
			call :AddPackage "%WinReMount%", "%Temp%\Updates\Cumulative"
	)
	if exist "%Temp%\Updates\WinPE\*.cab" (
		echo.-------------------------------------------------------------------------------
		echo.Integrating Windows 10 WinPE Updates to Recovery Image
		echo.---------------------------------[Index : 1]-----------------------------------
		call :AddPackage "%WinReMount%", "%Temp%\Updates\WinPE"
	)
)

if "%IsLogsEnabled%" equ "Yes" (
	echo.-------------------------------------------------------------------------------
	if "%SelectedSourceOS%" equ "w81" echo.####Generating WHD Baseline Updates Integration Log Files######################
	if "%SelectedSourceOS%" equ "w10" echo.####Generating WHD General Updates Integration Log Files#######################
	echo.-------------------------------------------------------------------------------
	echo.
	for /l %%k in (1, 1, 2) do (
		if "%SelectedSourceOS%" equ "w81" echo.Writing WHD Baseline Updates Integration [Boot.wim, Index : %%k] Log...
		if "%SelectedSourceOS%" equ "w10" echo.Writing WHD General Updates Integration [Boot.wim, Index : %%k] Log...
		call :GetPackages "%BootMount%\%%k", "Boot-%%k.txt"
		echo.
	)
	if "%ImageIndexNo%" equ "*" (
		if "%SelectedSourceOS%" equ "w81" echo.Writing WHD Baseline Updates Integration [Install.wim, Index : 1-%ImageCount%] Log...
		if "%SelectedSourceOS%" equ "w10" echo.Writing WHD General Updates Integration [Install.wim, Index : 1-%ImageCount%] Log...
		for /L %%k in (1, 1, %ImageCount%) do (
			call :GetPackages "%InstallMount%\%%k", "Install-%%k.txt"
		)
	) else (
		if "%SelectedSourceOS%" equ "w81" echo.Writing WHD Baseline Updates Integration [Install.wim, Index : %ImageIndexNo%] Log...
		if "%SelectedSourceOS%" equ "w10" echo.Writing WHD General Updates Integration [Install.wim, Index : %ImageIndexNo%] Log...
		call :GetPackages "%InstallMount%", "Install.txt"
	)
	echo.
	if "%SelectedSourceOS%" equ "w81" echo.Writing WHD Baseline Updates Integration [WinRE.wim, Index : 1] Log...
	if "%SelectedSourceOS%" equ "w10" echo.Writing WHD General Updates Integration [WinRE.wim, Index : 1] Log...
	call :GetPackages "%WinReMount%", "Install_WinRE.txt"
	echo.
)

echo.-------------------------------------------------------------------------------
echo.####Cleaning Up Temporary files ^& Folders#####################################
echo.-------------------------------------------------------------------------------
echo.
if "%SelectedSourceOS%" equ "w81" echo.Cleaning Up WHD Baseline Updates Temporary folder...
if "%SelectedSourceOS%" equ "w10" echo.Cleaning Up WHD General Updates Temporary folder...
call :RemoveFolder "%Temp%\Updates"
echo.
echo.-------------------------------------------------------------------------------
if "%SelectedSourceOS%" equ "w81" echo.##################Finished Integrating WHD Baseline Updates####################
if "%SelectedSourceOS%" equ "w10" echo.##################Finished Integrating WHD General Updates#####################
echo.##############to Windows Setup Boot, Install ^& Recovery Images#################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set PackageArchitecture=
set Updates=

endlocal

:: Reading Updated Image Information
if "%SelectedSourceOS%" equ "w10" (
	if "%ImageIndexNo%" equ "*" (
		call :GetImageIndexInfo "%InstallWim%", 1 >nul
		call :MountImageRegistry "%InstallMount%\1"
		for /f "tokens=3 delims= " %%z in ('reg query "HKLM\TK_SOFTWARE\Microsoft\Windows NT\CurrentVersion" /v "UBR" ^| find "REG_DWORD"') do (set /a ImageServicePackBuild=%%z)
		call :UnMountImageRegistry
	) else (
		call :GetImageIndexInfo "%InstallWim%", %ImageIndexNo% >nul
		call :MountImageRegistry "%InstallMount%"
		for /f "tokens=3 delims= " %%z in ('reg query "HKLM\TK_SOFTWARE\Microsoft\Windows NT\CurrentVersion" /v "UBR" ^| find "REG_DWORD"') do (set /a ImageServicePackBuild=%%z)
		call :UnMountImageRegistry
	)
)

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Updates
:: Input Parameters [%~1 : UpdateType ]
::-------------------------------------------------------------------------------------------
:IntUpdates

setlocal

:: Setting WHD Updates Type
set "UpdateType=%~1"

cls
echo.===============================================================================
if "%UpdateType%" equ "WUpdates" echo.                   MSMG ToolKit - Integrate Windows Updates
if "%UpdateType%" equ "General" echo.                 MSMG ToolKit - Integrate WHD General Updates
if "%UpdateType%" equ "Hotfix" echo.                 MSMG ToolKit - Integrate WHD Hotfix Updates
if "%UpdateType%" equ "Security" echo.               MSMG ToolKit - Integrate WHD Security Updates
if "%UpdateType%" equ "NET35" echo.        MSMG ToolKit - Integrate Microsoft .NET Framework 3.5 Updates
if "%UpdateType%" equ "WAT" echo.        MSMG ToolKit - Integrate Windows Activation Technologies ^(WAT^)
if "%UpdateType%" equ "Windows10" echo.        MSMG ToolKit - Integrate Windows 10 Upgrade Preparation Updates
if "%UpdateType%" equ "WinPE" echo.                MSMG ToolKit - Integrate Windows PE Updates
if "%UpdateType%" equ "WUSatisfy" echo.           MSMG ToolKit - Integrate Windows Update Satisfy Updates
if "%UpdateType%" equ "ADLDS" echo.   MSMG ToolKit - Integrate Active Directory Lightweight Directory Services
if "%UpdateType%" equ "FMApi" echo.                    MSMG ToolKit - Integrate File Management API
if "%UpdateType%" equ "Features" echo.                   MSMG ToolKit - Integrate Windows Features
if "%UpdateType%" equ "VirtualPC" echo.             MSMG ToolKit - Integrate Microsoft Virtual PC Feature
if "%UpdateType%" equ "WorkFolders" echo.  MSMG ToolKit - Integrate Sync Agent for Domain Environmernts ^(Work Folders^)
echo.===============================================================================
echo.
:: Getting Install Image Index Architecture
if "%ImageIndexNo%" equ "*" call :GetImageArchitecture "%InstallWim%", 1 >nul
if "%ImageIndexNo%" neq "*" call :GetImageArchitecture "%InstallWim%", %ImageIndexNo% >nul

:: Settings Windows/WHD Updates Menu folder path
if "%UpdateType%" equ "WUpdates" set "Updates=%Updates%\%SelectedSourceOS%\%ImageArchitecture%"
if "%UpdateType%" neq "WUpdates" set "Updates=%WHD%\%SelectedSourceOS%\%ImageArchitecture%"

:: Checking Windows/WHD Updates folder is empty
if "%UpdateType%" equ "WUpdates" if not exist "%Updates%\*.msu" if not exist "%Updates%\*.cab" (
	echo.Windows Updates folder ^<Updates\%SelectedSourceOS%\%ImageArchitecture%^> is empty...
	echo.
	echo.Please copy Windows Updates files to respective folder...
	goto :Stop
)

if "%UpdateType%" equ "General" (
	if "%SelectedSourceOS%" equ "w7" if "%IsW7SP1CRUSelected%" equ "0" if not exist "%Updates%\Extra\WithoutKB3125574\#General\*.msu" if not exist "%Updates%\Extra\WithoutKB3125574\#General\*.cab" (
		echo.WHD General Updates Folder ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Extra\WithoutKB3125574\#General^> is empty...
		echo.
		echo.Please copy WHD General Updates files to respective folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w7" if "%IsW7SP1CRUSelected%" equ "1" if not exist "%Updates%\General\*.msu" if not exist "%Updates%\General\*.cab" (
		echo.WHD General Updates Folder ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\General^> is empty...
		echo.
		echo.Please copy WHD General Updates files to respective folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w81" if not exist "%Updates%\General\*.msu" if not exist "%Updates%\General\*.cab" (
		echo.WHD General Updates Folder ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\General^> is empty...
		echo.
		echo.Please copy WHD General Updates files to respective folder...
		goto :Stop
	)
)

if "%UpdateType%" equ "Hotfix" (
	if "%SelectedSourceOS%" equ "w7" if "%IsW7SP1CRUSelected%" equ "0" if not exist "%Updates%\Extra\WithoutKB3125574\#Hotfix\*.msu" if not exist "%Updates%\Extra\WithoutKB3125574\#Hotfix\*.cab" (
		echo.WHD Hotfix Updates Folder ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Extra\WithoutKB3125574\#Hotfix^> is empty...
		echo.
		echo.Please copy WHD Hotfix Updates files to respective folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w7" if "%IsW7SP1CRUSelected%" equ "1" if not exist "%Updates%\Hotfix\*.msu" if not exist "%Updates%\Hotfix\*.cab" (
		echo.WHD Hotfix Updates Folder ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Hotfix^> is empty...
		echo.
		echo.Please copy WHD Hotfix Updates files to respective folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w81" if not exist "%Updates%\Hotfix\*.msu" if not exist "%Updates%\Hotfix\*.cab" (
		echo.WHD Hotfix Updates Folder ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Hotfix^> is empty...
		echo.
		echo.Please copy WHD Hotfix Updates files to respective folder...
		goto :Stop
	)	
)

if "%UpdateType%" equ "Security" (
	if "%SelectedSourceOS%" equ "w7" if "%IsW7SP1CRUSelected%" equ "0" if not exist "%Updates%\Extra\WithoutKB3125574\#Security\*.msu" if not exist "%Updates%\Extra\WithoutKB3125574\#Security\*.cab" (
		echo.WHD Security Updates Folder ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Extra\WithoutKB3125574\#Security^> is empty...
		echo.
		echo.Please copy WHD Security Updates files to respective folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w7" if "%IsW7SP1CRUSelected%" equ "1" if not exist "%Updates%\Security\WithoutESU\*.msu" if not exist "%Updates%\Security\WithoutESU\*.cab" (
		echo.WHD Security Updates Folder ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Security\WithoutESU^> is empty...
		echo.
		echo.Please copy WHD Security Updates files to respective folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w7" if "%IsW7SP1CRUSelected%" equ "1" if not exist "%Updates%\Security\*.msu" if not exist "%Updates%\Security\*.cab" (
		echo.WHD Security Updates Folder ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Security^> is empty...
		echo.
		echo.Please copy WHD Security Updates files to respective folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w81" if not exist "%Updates%\Security\*.msu" if not exist "%Updates%\Security\*.cab" (
		echo.WHD Security Updates Folder ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Security^> is empty...
		echo.
		echo.Please copy WHD Security Updates files to respective folder...
		goto :Stop
	)	
)

if "%UpdateType%" equ "NET35" if not exist "%Updates%\Additional\NET35\*.msu" if not exist "%Updates%\Additional\NET35\*.cab" (
	echo.	         Microsoft .NET Framework 3.5 Updates Folder
	echo.	       ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Additional\NET35^> is empty...
	echo.
	echo. Please Copy Microsoft .NET Framework 3.5 Updates files to respective folder...
	goto :Stop
)

if "%UpdateType%" equ "WAT" (
	if not exist "%Updates%\Additional\WAT\*.msu" if not exist "%Updates%\Additional\WAT\*.cab" (
		echo.                    Windows Activation Technologies Folder
		echo.                 ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Additional\WAT^> is empty...
		echo.
		echo.    Please Copy Windows Activation Technologies files to respective folder...
		goto :Stop
	)

	if "%ImageEdition%" equ "Embedded" (
		echo.Windows Activation Technologies Requires Client/Server Editions...
		goto :Stop
	)
)

if "%UpdateType%" equ "Windows10" (
	if not exist "%Updates%\Additional\Windows10\*.msu" if not exist "%Updates%\Additional\Windows10\*.cab" (
		echo.                  Windows 10 Upgrade Preparation Updates Folder
		echo.               ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Additional\Windows10^> is empty...
		echo.
		echo.Please copy Windows 10 Upgrade Preparation Updates files to Respective Folder..
		goto :Stop
	)
	
	if "%IsW7SP1CRUSelected%" equ "0" if not exist "%Updates%\Extra\WithoutKB3125574\_Windows10\*.msu" if not exist "%Updates%\Extra\WithoutKB3125574\_Windows10\*.cab" (
		echo.               Windows 10 Upgrade Preparation Updates Folder
		echo.       ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Extra\WithoutKB3125574\_Windows10^> is empty...
		echo.
		echo.Please copy Windows 10 Upgrade Preparation Updates files to Respective Folder..
		goto :Stop
	)	

	if "%ImageEdition%" equ "Embedded" (
		echo.Windows 10 Upgrade Preparation Updates Requires Client Editions...
		goto :Stop
	)
)

if "%UpdateType%" equ "WinPE" if not exist "%Updates%\Additional\WinPE\*.msu" if not exist "%Updates%\Additional\WinPE\*.cab" (
	echo.Windows PE Updates Folder ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Additional\WinPE^> is empty...
	echo.
	echo.Please copy Windows PE Updates files to respective folder...
	goto :Stop
)

if "%UpdateType%" equ "WUSatisfy" if not exist "%Updates%\Additional\WU.Satisfy\*.msu" if not exist "%Updates%\Additional\WU.Satisfy\*.cab" (
	echo.                    Windows Update Satisfy Updates Folder 
	echo.              ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Additional\WU.Satisfy^> is empty...
	echo.
	echo.    Please Copy Windows Update Satisfy Updates files to respective folder...
	goto :Stop
)

if "%UpdateType%" equ "ADLDS" (
	if not exist "%Updates%\Extra\AD_LDS\*.msu" if not exist "%Updates%\Extra\AD_LDS\*.cab" (
		echo.        Active Directory Lightweight Directory Services Feature Folder
		echo.                 ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Extra\AD_LDS^> is empty...
		echo.
		echo.           Please Copy ADLDS Feature files to respective folder...
		goto :Stop
	)
	if not exist "%Updates%\Extra\AD_LDS\Updates\*.msu" if not exist "%Updates%\Extra\AD_LDS\Updates\*.cab" (
		echo.     Active Directory Lightweight Directory Services Feature Updates Folder
		echo.           ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Extra\AD_LDS\Updates^> is empty...
		echo.
		echo.        Please Copy ADLDS Feature Updates files to respective folder...
		goto :Stop
	)	
	if "%IsW7SP1CRUSelected%" equ "0" if not exist "%Updates%\Extra\WithoutKB3125574\AD_LDS\*.msu" if not exist "%Updates%\Extra\WithoutKB3125574\AD_LDS\*.cab" (
		echo.     Active Directory Lightweight Directory Services Feature Updates Folder
		echo.         ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Extra\WithoutKB3125574\AD_LDS^> is empty...
		echo.
		echo.        Please Copy ADLDS Feature Updates files to respective folder...
		goto :Stop
	)

	if "%ImageEdition%" neq "Professional" if "%ImageEdition%" neq "Enterprise" if "%ImageEdition%" neq "Ultimate" (
		echo.           Active Directory Lightweight Directory Services Feature 
		echo.             Requires Professional/Enterprise/Ultimate Editions...
		goto :Stop
	) else (
		goto :Continue
	)	
)

if "%UpdateType%" equ "FMApi" if not exist "%Updates%\Extra\Addons\FM.Api\*.msu" if not exist "%Updates%\Extra\Addons\FM.Api\*.cab" (
	echo.                        File Management API Folder 
	echo.        ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Extra\Addons\FM.Api^> is empty...
	echo.
	echo.           Please Copy File Management API files to respective folder...
	goto :Stop
)

if "%UpdateType%" equ "Features" if not exist "%Updates%\Extra\WithoutKB3125574\_Features\*.msu" if not exist "%Updates%\Extra\WithoutKB3125574\_Features\*.cab" (
	echo.                           Windows Features Folder 
	echo.        ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Extra\WithoutKB3125574\_Features^> is empty...
	echo.
	echo.           Please Copy Windows Features files to respective folder...
	goto :Stop
)

if "%UpdateType%" equ "VirtualPC" (
	if not exist "%Updates%\Extra\VirtualPC\*.msu" if not exist "%Updates%\Extra\VirtualPC\*.cab" (
		echo.                     Microsoft Virtual PC Feature Folder
		echo.                ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Extra\VirtualPC^> is empty...
		echo.
		echo.    Please Copy Microsoft Virtual PC Feature files to respective folder...
		goto :Stop
	)
	if "%IsW7SP1CRUSelected%" equ "0" if not exist "%Updates%\Extra\WithoutKB3125574\VirtualPC\*.msu" if not exist "%Updates%\Extra\WithoutKB3125574\VirtualPC\*.cab" (
		echo.                Microsoft Virtual PC Feature Updates Folder
		echo.       ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Extra\WithoutKB3125574\VirtualPC^> is empty...
		echo.
		echo.Please copy Microsoft Virtual PC Feature Updates files to respective folder...
		goto :Stop
	)	
)

if "%UpdateType%" equ "WorkFolders" (
	if not exist "%Updates%\Extra\Addons\WorkFolders\*.msu" if not exist "%Updates%\Extra\Addons\WorkFolders\*.cab" (
		echo.       Sync Agent for Domain Environmernts ^(Work Folders^) Feature Folder
		echo.           ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Extra\Addons\WorkFolders^> is empty...
		echo.
		echo.         Please Copy Sync Agent for Domain Environmernts ^(Work Folders^)
		echo.                   Feature files to respective folder...
		goto :Stop
	)
	if "%IsW7SP1CRUSelected%" equ "0" if not exist "%Updates%\Extra\WithoutKB3125574\WorkFolders\*.msu" if not exist "%Updates%\Extra\WithoutKB3125574\WorkFolders\*.cab" (
		echo.   Sync Agent for Domain Environmernts ^(Work Folders^) Feature Updates Folder
		echo.      ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Extra\WithoutKB3125574\WorkFolders^> is empty...
		echo.
		echo.        Please Copy Sync Agent for Domain Environmernts ^(Work Folders^)
		echo.                Feature Updates files to respective folder...
		goto :Stop
	)

	if "%ImageEdition%" neq "Professional" if "%ImageEdition%" neq "Enterprise" if "%ImageEdition%" neq "Ultimate" (
		echo.           Sync Agent for Domain Environmernts ^(Work Folders^) Feature 
		echo.             Requires Professional/Enterprise/Ultimate Editions...
		goto :Stop
	) else (
		goto :Continue
	)
)

:Continue
echo.-------------------------------------------------------------------------------
if "%UpdateType%" equ "WUpdates" echo.####Starting Integrating Windows Updates#######################################
if "%UpdateType%" equ "General" echo.####Starting Integrating WHD General Updates###################################
if "%UpdateType%" equ "Hotfix" echo.####Starting Integrating WHD Hotfix Updates####################################
if "%UpdateType%" equ "Security" echo.####Starting Integrating WHD Security Updates##################################
if "%UpdateType%" equ "NET35" echo.####Starting Integrating Microsoft .NET Framework 3.5 Updates##################
if "%UpdateType%" equ "WAT" echo.####Starting Integrating Windows Activation Technologies ^(WAT^)#################
if "%UpdateType%" equ "Windows10" echo.####Starting Integrating Windows 10 Upgrade Preparation Updates################
if "%UpdateType%" equ "WinPE" echo.####Starting Integrating Windows PE Updates####################################
if "%UpdateType%" equ "WUSatisfy" echo.####Starting Integrating Windows Update Satisfy Updates########################
if "%UpdateType%" equ "ADLDS" echo.####Starting Integrating Active Directory Lightweight Directory Services#######
if "%UpdateType%" equ "FMApi" echo.####Starting Integrating File Management API###################################
if "%UpdateType%" equ "Features" echo.####Starting Integrating Windows Features######################################
if "%UpdateType%" equ "VirtualPC" echo.####Starting Integrating Microsoft Virtual PC Feature##########################
if "%UpdateType%" equ "WorkFolders" echo.####Starting Integrating Sync Agent for Domain Environmernts ^(Work Folders^)####
echo.-------------------------------------------------------------------------------
echo.
if "%UpdateType%" neq "WinPE" (
	echo.    Image                    : Install.wim
	if "%ImageIndexNo%" equ "*" echo.    Image Indexes            : 1-%ImageCount%
	if "%ImageIndexNo%" neq "*" echo.    Image Index              : %ImageIndexNo%
) else (
	echo.    Image                    : Boot.wim         ^|  WinRE.wim
	if "%ImageIndexNo%" neq "*" echo.    Image Indexes            :    2             ^|    1
	if "%ImageIndexNo%" equ "*" echo.    Image Indexes            :    2             ^|    1
)
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
if "%ImageIndexNo%" neq "*" echo.    Image Edition            : %ImageEdition%
echo.    Image Default Language   : %ImageDefaultLanguage%
echo.
echo.-------------------------------------------------------------------------------
if "%UpdateType%" equ "WUpdates" echo.####Processing Windows Updates Packages########################################
if "%UpdateType%" equ "General" echo.####Processing WHD General Updates Packages####################################
if "%UpdateType%" equ "Hotfix" echo.####Processing WHD Hotfix Updates Packages#####################################
if "%UpdateType%" equ "Security" echo.####Processing WHD Security Updates Packages###################################
if "%UpdateType%" equ "NET35" echo.####Processing Microsoft .NET Framework 3.5 Updates Packages###################
if "%UpdateType%" equ "WAT" echo.####Processing Windows Activation Technologies ^(WAT^) Packages##################
if "%UpdateType%" equ "Windows10" echo.####Processing Windows 10 Upgrade Preparation Updates Packages#################
if "%UpdateType%" equ "WinPE" echo.####Processing Windows PE Updates Packages#####################################
if "%UpdateType%" equ "WUSatisfy" echo.####Processing Windows Update Satisfy Updates Packages#########################
if "%UpdateType%" equ "ADLDS" echo.####Processing Active Directory Lightweight Directory Services Packages########
if "%UpdateType%" equ "FMApi" echo.####Processing File Management API Packages####################################
if "%UpdateType%" equ "Features" echo.####Processing Windows Features Packages#######################################
if "%UpdateType%" equ "VirtualPC" echo.####Processing Microsoft Virtual PC Feature Packages###########################
if "%UpdateType%" equ "WorkFolders" echo.####Processing Sync Agent for Domain Environmernts ^(Work Folders^) Packages#####
echo.-------------------------------------------------------------------------------
echo.
:: Creating Windows/WHD Updates Temporary Folder
if "%UpdateType%" equ "WUpdates" echo.Creating Windows Updates Packages Temporary folder...
if "%UpdateType%" equ "General" echo.Creating WHD General Updates Packages Temporary folder...
if "%UpdateType%" equ "Hotfix" echo.Creating WHD Hotfix Updates Packages Temporary folder...
if "%UpdateType%" equ "Security" echo.Creating WHD Security Updates Packages Temporary folder...
if "%UpdateType%" equ "NET35" echo.Creating Microsoft .NET Framework 3.5 Updates Packages Temporary folder...
if "%UpdateType%" equ "WAT" echo.Creating Windows Activation Technologies Packages Temporary folder...
if "%UpdateType%" equ "Windows10" echo.Creating Windows 10 Upgrade Preparation Updates Packages Temporary folder...
if "%UpdateType%" equ "WinPE" echo.Creating Windows PE Updates Packages Temporary folder...
if "%UpdateType%" equ "WUSatisfy" echo.Creating Windows Update Satisfy Updates Packages Temporary folder...
if "%UpdateType%" equ "ADLDS" echo.Creating ADLDS Packages Temporary folder...
if "%UpdateType%" equ "FMApi" echo.Creating File Management API Packages Temporary folder...
if "%UpdateType%" equ "Features" echo.Creating Windows Features Packages Temporary folder...
if "%UpdateType%" equ "VirtualPC" echo.Creating Microsoft Virtual PC Feature Packages Temporary folder...
if "%UpdateType%" equ "WorkFolders" echo.Creating Sync Agent for Domain Environmernts Packages Temporary folder...
echo.

call :RemoveFolder "%Temp%\Updates"
call :CreateFolder "%Temp%\Updates"

if "%UpdateType%" equ "General" call :CreateFolder "%Temp%\Updates\%UpdateType%"
if "%UpdateType%" equ "Hotfix" call :CreateFolder "%Temp%\Updates\%UpdateType%"
if "%UpdateType%" equ "Security" (
	call :CreateFolder "%Temp%\Updates\%UpdateType%" >nul
	if "%SelectedSourceOS%" equ "w81" call :CreateFolder "%Temp%\Updates\%UpdateType%\ProWMC"
)
if "%UpdateType%" equ "NET35" call :CreateFolder "%Temp%\Updates\%UpdateType%"
if "%UpdateType%" equ "WAT" call :CreateFolder "%Temp%\Updates\%UpdateType%"
if "%UpdateType%" equ "Windows10" call :CreateFolder "%Temp%\Updates\%UpdateType%"
if "%UpdateType%" equ "WinPE" call :CreateFolder "%Temp%\Updates\%UpdateType%"
if "%UpdateType%" equ "WUSatisfy" call :CreateFolder "%Temp%\Updates\%UpdateType%\ProfessionalWMC"
if "%UpdateType%" equ "ADLDS" call :CreateFolder "%Temp%\Updates\%UpdateType%\Updates"
if "%UpdateType%" equ "FMApi" call :CreateFolder "%Temp%\Updates\%UpdateType%\Updates"
if "%UpdateType%" equ "Features" call :CreateFolder "%Temp%\Updates\%UpdateType%"
if "%UpdateType%" equ "VirtualPC" (
	if "%IsW7SP1CRUSelected%" equ "1" call :CreateFolder "%Temp%\Updates\%UpdateType%"
	if "%IsW7SP1CRUSelected%" equ "0" call :CreateFolder "%Temp%\Updates\%UpdateType%\Updates"
)
if "%UpdateType%" equ "WorkFolders" (
	if "%IsW7SP1CRUSelected%" equ "1" call :CreateFolder "%Temp%\Updates\%UpdateType%"
	if "%IsW7SP1CRUSelected%" equ "0" call :CreateFolder "%Temp%\Updates\%UpdateType%\Updates"
)

echo.Extracting .CAB Package files to Temporary folder...
echo.

:: Extracting/Copying Windows/WHD Updates .CAB files to Temporary Folder
if "%UpdateType%" equ "WUpdates" (
	if exist "%Updates%\*%ImageArchitecture%*.msu" expand "%Updates%\*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\*%ImageArchitecture%*.cab" %XCopy% "%Updates%\*.cab" "%Temp%\Updates" >nul
)
if "%UpdateType%" equ "General" (
	if "%SelectedSourceOS%" equ "w7" if "%IsW7SP1CRUSelected%" equ "0" (
		if exist "%Updates%\Extra\WithoutKB3125574\#General\*%ImageArchitecture%*.msu" expand "%Updates%\Extra\WithoutKB3125574\#General\*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%" >nul
		if exist "%Updates%\Extra\WithoutKB3125574\#General\*%ImageArchitecture%*.cab" %XCopy% "%Updates%\Extra\WithoutKB3125574\#General\*.cab" "%Temp%\Updates\%UpdateType%" >nul
		if exist "%Temp%\Updates\%UpdateType%\WUClient*.cab" (
			call :CreateFolder "%Temp%\Updates\%UpdateType%\WUClient"
			move /y "%Temp%\Updates\%UpdateType%\WUClient*.cab" "%Temp%\Updates\%UpdateType%\WUClient" >nul
		)
	)
	if "%SelectedSourceOS%" equ "w7" if "%IsW7SP1CRUSelected%" equ "1" (
		if exist "%Updates%\%UpdateType%\*%ImageArchitecture%*.msu" expand "%Updates%\%UpdateType%\*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%" >nul
		if exist "%Updates%\%UpdateType%\*%ImageArchitecture%*.cab" %XCopy% "%Updates%\%UpdateType%\*.cab" "%Temp%\Updates\%UpdateType%" >nul

		call :CreateFolder "%Temp%\Updates\%UpdateType%\SP2"
		move /y "%Temp%\Updates\%UpdateType%\Windows6.1-KB4490628-%ImageArchitecture%.cab" "%Temp%\Updates\%UpdateType%\SP2" >nul
		move /y "%Temp%\Updates\%UpdateType%\Windows6.1-KB2670838-%ImageArchitecture%.cab" "%Temp%\Updates\%UpdateType%\SP2" >nul
		move /y "%Temp%\Updates\%UpdateType%\Windows6.1-KB3125574-v4-%ImageArchitecture%.cab" "%Temp%\Updates\%UpdateType%\SP2" >nul
		move /y "%Temp%\Updates\%UpdateType%\Windows6.1-KB3172605-%ImageArchitecture%.cab" "%Temp%\Updates\%UpdateType%\SP2" >nul
	
		call :CreateFolder "%Temp%\Updates\%UpdateType%\Client"
		if exist "%Temp%\Updates\%UpdateType%\Windows6.1-KB917607-%ImageArchitecture%.cab" del /f /q "%Temp%\Updates\%UpdateType%\Windows6.1-KB917607-%ImageArchitecture%.cab" >nul
	)
	if "%SelectedSourceOS%" equ "w81" (
		if exist "%Updates%\%UpdateType%\*%ImageArchitecture%*.msu" expand "%Updates%\%UpdateType%\*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%" >nul
		if exist "%Updates%\%UpdateType%\*%ImageArchitecture%*.cab" %XCopy% "%Updates%\%UpdateType%\*.cab" "%Temp%\Updates\%UpdateType%" >nul

		if exist "%Temp%\Updates\%UpdateType%\Windows8.1-KB3140185-%ImageArchitecture%.cab" (
			call :CreateFolder "%Temp%\Updates\%UpdateType%\Upgrade"
			move /y "%Temp%\Updates\%UpdateType%\Windows8.1-KB3140185-%ImageArchitecture%.cab" "%Temp%\Updates\%UpdateType%\Upgrade" >nul
		)
	
		if exist "%Temp%\Updates\%UpdateType%\Windows8.1-KB917607-%ImageArchitecture%.cab" del /f /q "%Temp%\Updates\%UpdateType%\Windows8.1-KB917607-%ImageArchitecture%.cab" >nul
		if exist "%Temp%\Updates\%UpdateType%\Windows8.1-KB4486105-%ImageArchitecture%.cab" del /f /q "%Temp%\Updates\%UpdateType%\Windows8.1-KB4486105-%ImageArchitecture%.cab" >nul
	)
)
if "%UpdateType%" equ "Hotfix" (
	if "%SelectedSourceOS%" equ "w7" if "%IsW7SP1CRUSelected%" equ "0" (
		if exist "%Updates%\Extra\WithoutKB3125574\#Hotfix\*%ImageArchitecture%*.msu" expand "%Updates%\Extra\WithoutKB3125574\#Hotfix\*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%" >nul
		if exist "%Updates%\Extra\WithoutKB3125574\#Hotfix\*%ImageArchitecture%*.cab" %XCopy% "%Updates%\Extra\WithoutKB3125574\#Hotfix\*.cab" "%Temp%\Updates\%UpdateType%" >nul
		if exist "%Temp%\Updates\%UpdateType%\Windows6.1-KB2780124-%ImageArchitecture%*.cab" (
			call :CreateFolder "%Temp%\Updates\%UpdateType%\Ent_Ultimate"
			move /y "%Temp%\Updates\%UpdateType%\Windows6.1-KB2780124-%ImageArchitecture%*.cab" "%Temp%\Updates\%UpdateType%\Ent_Ultimate" >nul
		)		
	)
	if "%SelectedSourceOS%" equ "w7" if "%IsW7SP1CRUSelected%" equ "1" (
		if exist "%Updates%\%UpdateType%\*%ImageArchitecture%*.msu" expand "%Updates%\%UpdateType%\*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%" >nul
		if exist "%Updates%\%UpdateType%\*%ImageArchitecture%*.cab" %XCopy% "%Updates%\%UpdateType%\*.cab" "%Temp%\Updates\%UpdateType%" >nul

		call :CreateFolder "%Temp%\Updates\%UpdateType%\Client"
		if exist "%Temp%\Updates\%UpdateType%\Windows6.1-KB2727994-v3-%ImageArchitecture%.cab" move /y "%Temp%\Updates\%UpdateType%\Windows6.1-KB2727994-v3-%ImageArchitecture%.cab" "%Temp%\Updates\%UpdateType%\Client" >nul
	)
	if "%SelectedSourceOS%" equ "w81" (
		if exist "%Updates%\%UpdateType%\*%ImageArchitecture%*.msu" expand "%Updates%\%UpdateType%\*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%" >nul
		if exist "%Updates%\%UpdateType%\*%ImageArchitecture%*.cab" %XCopy% "%Updates%\%UpdateType%\*.cab" "%Temp%\Updates\%UpdateType%" >nul
	)
)
if "%UpdateType%" equ "Security" (
	if "%SelectedSourceOS%" equ "w7" if "%IsW7SP1CRUSelected%" equ "0" (
		if exist "%Updates%\Extra\WithoutKB3125574\#Security\*%ImageArchitecture%*.msu" expand "%Updates%\Extra\WithoutKB3125574\#Security\*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%" >nul
		if exist "%Updates%\Extra\WithoutKB3125574\#Security\*%ImageArchitecture%*.cab" %XCopy% "%Updates%\Extra\WithoutKB3125574\#Security\*.cab" "%Temp%\Updates\%UpdateType%" >nul

		if exist "%Updates%\%UpdateType%\Windows6.1-KB4490628-%ImageArchitecture%*.msu" expand "%Updates%\%UpdateType%\Windows6.1-KB4490628-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%" >nul
		if exist "%Updates%\%UpdateType%\Windows6.1-KB4490628-%ImageArchitecture%*.cab" %XCopy% "%Updates%\%UpdateType%\Windows6.1-KB4490628-%ImageArchitecture%*.cab" "%Temp%\Updates\%UpdateType%" >nul
	)
	if "%SelectedSourceOS%" equ "w7" if "%IsW7SP1CRUSelected%" equ "1" (
		if exist "%Updates%\%UpdateType%\WithoutESU\*%ImageArchitecture%*.msu" expand "%Updates%\%UpdateType%\WithoutESU\*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%" >nul
		if exist "%Updates%\%UpdateType%\WithoutESU\*%ImageArchitecture%*.cab" %XCopy% "%Updates%\%UpdateType%\WithoutESU\*.cab" "%Temp%\Updates\%UpdateType%" >nul
		if exist "%Updates%\%UpdateType%\*%ImageArchitecture%*.msu" expand "%Updates%\%UpdateType%\*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%" >nul
		if exist "%Updates%\%UpdateType%\*%ImageArchitecture%*.cab" %XCopy% "%Updates%\%UpdateType%\*.cab" "%Temp%\Updates\%UpdateType%" >nul
	)
	if "%SelectedSourceOS%" equ "w81" (
		if exist "%Updates%\%UpdateType%\*%ImageArchitecture%*.msu" expand "%Updates%\%UpdateType%\*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%" >nul
		if exist "%Updates%\%UpdateType%\*%ImageArchitecture%*.cab" %XCopy% "%Updates%\%UpdateType%\*.cab" "%Temp%\Updates\%UpdateType%" >nul
		if exist "%Updates%\%UpdateType%\NET452\*%ImageArchitecture%*.msu" expand "%Updates%\%UpdateType%\NET452\*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%" >nul
		if exist "%Updates%\%UpdateType%\NET452\*%ImageArchitecture%*.cab" %XCopy% "%Updates%\%UpdateType%\NET452\*.cab" "%Temp%\Updates\%UpdateType%" >nul
	)
)

if "%UpdateType%" equ "NET35" (
	if exist "%Updates%\Additional\NET35\*%ImageArchitecture%*.msu" expand "%Updates%\Additional\NET35\*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%" >nul
	if exist "%Updates%\Additional\NET35\*%ImageArchitecture%*.cab" %XCopy% "%Updates%\Additional\NET35\*.cab" "%Temp%\Updates\%UpdateType%" >nul
)

if "%UpdateType%" equ "WAT" (
	if exist "%Updates%\Additional\WAT\*%ImageArchitecture%*.msu" expand "%Updates%\Additional\WAT\*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%" >nul
	if exist "%Updates%\Additional\WAT\*%ImageArchitecture%*.cab" %XCopy% "%Updates%\Additional\WAT\*.cab" "%Temp%\Updates\%UpdateType%" >nul
)

if "%UpdateType%" equ "Windows10" (
	if exist "%Updates%\Additional\Windows10\*%ImageArchitecture%*.msu" expand "%Updates%\Additional\Windows10\*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%" >nul
	if exist "%Updates%\Additional\Windows10\*%ImageArchitecture%*.cab" %XCopy% "%Updates%\Additional\Windows10\*.cab" "%Temp%\Updates\%UpdateType%" >nul
	if "%IsW7SP1CRUSelected%" equ "0" (
		if exist "%Updates%\Extra\WithoutKB3125574\_Windows10\*%ImageArchitecture%*.msu" expand "%Updates%\Extra\WithoutKB3125574\_Windows10\*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%" >nul
		if exist "%Updates%\Extra\WithoutKB3125574\_Windows10\*%ImageArchitecture%*.cab" %XCopy% "%Updates%\Extra\WithoutKB3125574\_Windows10\*.cab" "%Temp%\Updates\%UpdateType%" >nul
	)
)

if "%UpdateType%" equ "WinPE" (
	if exist "%Updates%\Additional\WinPE\*%ImageArchitecture%*.msu" expand "%Updates%\Additional\WinPE\*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%" >nul
	if exist "%Updates%\Additional\WinPE\*%ImageArchitecture%*.cab" %XCopy% "%Updates%\Additional\WinPE\*.cab" "%Temp%\Updates\%UpdateType%" >nul

	if exist "%Updates%\General\Windows8.1-KB3084905*%ImageArchitecture%*.msu" expand "%Updates%\General\Windows8.1-KB3084905*%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%" >nul
	if exist "%Updates%\General\Windows8.1-KB3084905*%ImageArchitecture%*.cab" %XCopy% "%Updates%\General\Windows8.1-KB3084905*%ImageArchitecture%*.cab" "%Temp%\Updates\%UpdateType%" >nul
	if exist "%Updates%\General\Windows8.1-KB3115224*%ImageArchitecture%*.msu" expand "%Updates%\General\Windows8.1-KB3115224*%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%" >nul
	if exist "%Updates%\General\Windows8.1-KB3115224*%ImageArchitecture%*.cab" %XCopy% "%Updates%\General\Windows8.1-KB3115224*%ImageArchitecture%*.cab" "%Temp%\Updates\%UpdateType%" >nul
)

if "%UpdateType%" equ "WUSatisfy" (
	if exist "%Updates%\Additional\WU.Satisfy\*%ImageArchitecture%*.msu" expand "%Updates%\Additional\WU.Satisfy\*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%" >nul
	if exist "%Updates%\Additional\WU.Satisfy\*%ImageArchitecture%*.cab" %XCopy% "%Updates%\Additional\WU.Satisfy\*.cab" "%Temp%\Updates\%UpdateType%" >nul
	if exist "%Updates%\Additional\WU.Satisfy\ProfessionalWMC\*%ImageArchitecture%*.msu" expand "%Updates%\Additional\WU.Satisfy\ProfessionalWMC\*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%\ProfessionalWMC" >nul
	if exist "%Updates%\Additional\WU.Satisfy\ProfessionalWMC\*%ImageArchitecture%*.cab" %XCopy% "%Updates%\Additional\WU.Satisfy\ProfessionalWMC\*.cab" "%Temp%\Updates\%UpdateType%\ProfessionalWMC" >nul
)

if "%UpdateType%" equ "ADLDS" (
	if exist "%Updates%\Extra\AD_LDS\*%ImageArchitecture%*.msu" expand "%Updates%\Extra\AD_LDS\*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%" >nul
	if exist "%Updates%\Extra\AD_LDS\*%ImageArchitecture%*.cab" %XCopy% "%Updates%\Extra\AD_LDS\*.cab" "%Temp%\Updates\%UpdateType%" >nul

	if exist "%Updates%\Extra\AD_LDS\Updates\*%ImageArchitecture%*.msu" expand "%Updates%\Extra\AD_LDS\Updates\*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%\Updates" >nul
	if exist "%Updates%\Extra\AD_LDS\Updates\*%ImageArchitecture%*.cab" %XCopy% "%Updates%\Extra\AD_LDS\Updates\*.cab" "%Temp%\Updates\%UpdateType%\Updates" >nul

	if "%IsW7SP1CRUSelected%" equ "0" (	
		if exist "%Updates%\Extra\WithoutKB3125574\AD_LDS\*%ImageArchitecture%*.msu" expand "%Updates%\Extra\WithoutKB3125574\AD_LDS\*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%\Updates" >nul
		if exist "%Updates%\Extra\WithoutKB3125574\AD_LDS\*%ImageArchitecture%*.cab" %XCopy% "%Updates%\Extra\WithoutKB3125574\AD_LDS\*.cab" "%Temp%\Updates\%UpdateType%\Updates" >nul
	)
)

if "%UpdateType%" equ "FMApi" (
	if exist "%Updates%\Extra\Addons\FM.Api\*%ImageArchitecture%*.msu" expand "%Updates%\Extra\Addons\FM.Api\*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%" >nul
	if exist "%Updates%\Extra\Addons\FM.Api\*%ImageArchitecture%*.cab" %XCopy% "%Updates%\Extra\Addons\FM.Api\*.cab" "%Temp%\Updates\%UpdateType%" >nul
)

if "%UpdateType%" equ "Features" (
	if exist "%Updates%\Extra\WithoutKB3125574\_Features\*%ImageArchitecture%*.msu" expand "%Updates%\Extra\WithoutKB3125574\_Features\*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%" >nul
	if exist "%Updates%\Extra\WithoutKB3125574\_Features\*%ImageArchitecture%*.cab" %XCopy% "%Updates%\Extra\WithoutKB3125574\_Features\*.cab" "%Temp%\Updates\%UpdateType%" >nul
)

if "%UpdateType%" equ "VirtualPC" (
	if exist "%Updates%\Extra\VirtualPC\*%ImageArchitecture%*.msu" expand "%Updates%\Extra\VirtualPC\*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%" >nul
	if exist "%Updates%\Extra\VirtualPC\*%ImageArchitecture%*.cab" %XCopy% "%Updates%\Extra\VirtualPC\*.cab" "%Temp%\Updates\%UpdateType%" >nul
	if "%IsW7SP1CRUSelected%" equ "0" (
		if exist "%Updates%\Extra\WithoutKB3125574\VirtualPC\*%ImageArchitecture%*.msu" expand "%Updates%\Extra\WithoutKB3125574\VirtualPC\*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%\Updates" >nul
		if exist "%Updates%\Extra\WithoutKB3125574\VirtualPC\*%ImageArchitecture%*.cab" %XCopy% "%Updates%\Extra\WithoutKB3125574\VirtualPC\*.cab" "%Temp%\Updates\%UpdateType%\Updates" >nul
	)
)

if "%UpdateType%" equ "WorkFolders" (
	if exist "%Updates%\Extra\Addons\WorkFolders\*%ImageArchitecture%*.msu" expand "%Updates%\Extra\Addons\WorkFolders\*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%" >nul
	if exist "%Updates%\Extra\Addons\WorkFolders\*%ImageArchitecture%*.cab" %XCopy% "%Updates%\Extra\Addons\WorkFolders\*.cab" "%Temp%\Updates\%UpdateType%" >nul
	if "%IsW7SP1CRUSelected%" equ "0" (
		if exist "%Updates%\Extra\WithoutKB3125574\WorkFolders\*%ImageArchitecture%*.msu" expand "%Updates%\Extra\WithoutKB3125574\WorkFolders\*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%\Updates" >nul
		if exist "%Updates%\Extra\WithoutKB3125574\WorkFolders\*%ImageArchitecture%*.cab" %XCopy% "%Updates%\Extra\WithoutKB3125574\WorkFolders\*.cab" "%Temp%\Updates\%UpdateType%\Updates" >nul
	)
)

echo.Finished Extracting .CAB Package files to Temporary folder...
echo.
echo.-------------------------------------------------------------------------------
:: Integrating Windows/WHD Updates Packages to WIM Image
if "%UpdateType%" equ "WUpdates" echo.####Integrating Windows Updates################################################
if "%UpdateType%" equ "General" echo.####Integrating WHD General Updates############################################
if "%UpdateType%" equ "Hotfix" echo.####Integrating WHD Hotfix Updates#############################################
if "%UpdateType%" equ "Security" echo.####Integrating WHD Security Updates###########################################
if "%UpdateType%" equ "NET35" echo.####Integrating Microsoft .NET Framework 3.5 Updates###########################
if "%UpdateType%" equ "WAT" echo.####Integrating Windows Activation Technologies ^(WAT^) #########################
if "%UpdateType%" equ "Windows10" echo.####Integrating Windows 10 Upgrade Preparation Updates#########################
if "%UpdateType%" equ "WinPE" echo.####Integrating Windows PE Updates#############################################
if "%UpdateType%" equ "WUSatisfy" echo.####Integrating Windows Update Satisfy Updates#################################
if "%UpdateType%" equ "ADLDS" echo.####Integrating Active Directory Lightweight Directory Services Feature########
if "%UpdateType%" equ "FMApi" echo.####Integrating File Management API Feature####################################
if "%UpdateType%" equ "Features" echo.####Integrating Windows Features Updates#######################################
if "%UpdateType%" equ "VirtualPC" echo.####Integrating Microsoft Virtual PC Feature###################################
if "%UpdateType%" equ "WorkFolders" echo.####Integrating Sync Agent for Domain Environmernts ^(Work Folders^)#############
echo.-------------------------------------------------------------------------------

if "%UpdateType%" equ "WUpdates" (
	if "%ImageIndexNo%" equ "*" (
		echo.
		for /L %%i in (1, 1, %ImageCount%) do (
			if not %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]#############################
			if %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]############################
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates"
		)
	) else (
		call :AddPackage "%InstallMount%", "%Temp%\Updates"
	)
)

if "%UpdateType%" equ "General" (
	if "%ImageIndexNo%" equ "*" (
		echo.
		for /L %%i in (1, 1, %ImageCount%) do (
			if not %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]#############################
			if %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]############################

			call :GetImageEdition "%InstallWim%", %%i
			
			if "%SelectedSourceOS%" equ "w7" if "%IsW7SP1CRUSelected%" equ "0" (
				call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%"

				if exist "%Temp%\Updates\%UpdateType%\WUClient\WUClient*.cab" (
					echo.-------------------------------------------------------------------------------
					echo.Integrating Windows 7 - Windows Update Client Updates Packages...
					echo.-------------------------------------------------------------------------------
					call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%\WUClient\WUClient-SelfUpdate-Core-%ImageArchitecture%-7.6.7600.320.cab"
					echo.-------------------------------------------------------------------------------
					call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%\WUClient\WUClient-SelfUpdate-Aux-%ImageArchitecture%-7.6.7600.320.cab"
					echo.-------------------------------------------------------------------------------
					call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%\WUClient\WUClient-SelfUpdate-ActiveX-%ImageArchitecture%-7.6.7600.320.cab"
				)
			)
			
			if "%SelectedSourceOS%" equ "w7" if "%IsW7SP1CRUSelected%" equ "1" (
				echo.
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows 7 SP1 Convenience Rollup Prerequisite Update Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%\SP2\Windows6.1-KB4490628-%ImageArchitecture%.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows 7 SP1 Convenience Rollup Platform Update Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%\SP2\Windows6.1-KB2670838-%ImageArchitecture%.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows 7 SP1 Convenience Rollup Update Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%\SP2\Windows6.1-KB3125574-v4-%ImageArchitecture%.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows 7 SP1 July 2016 Rollup Update Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%\SP2\Windows6.1-KB3172605-%ImageArchitecture%.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating WHD General Updates Packages...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%"
				
				if "%ImageInstallationType%" neq "Embedded" if exist "%Temp%\Updates\%UpdateType%\Client\*.cab" (
					echo.-------------------------------------------------------------------------------
					echo.Integrating Windows 7 Client Updates Packages...
					echo.-------------------------------------------------------------------------------
					call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%\Client"
				)
			)

			if "%SelectedSourceOS%" equ "w81" (
				call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%"
			
				if exist "%Temp%\Updates\%UpdateType%\Upgrade\*.cab" (
					if "%ImageEdition%" equ "Core" (
						echo.-------------------------------------------------------------------------------
						echo.Integrating Windows 8.1 Upgradeable Editions Updates Packages...
						echo.-------------------------------------------------------------------------------
						call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%\Upgrade"
					)
					if "%ImageEdition%" equ "CoreSingleLanguage" (
						echo.-------------------------------------------------------------------------------
						echo.Integrating Windows 8.1 Upgradeable Editions Updates Packages...
						echo.-------------------------------------------------------------------------------
						call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%\Upgrade"
					)
					if "%ImageEdition%" equ "CoreCountrySpecific" (
						echo.-------------------------------------------------------------------------------
						echo.Integrating Windows 8.1 Upgradeable Editions Updates Packages...
						echo.-------------------------------------------------------------------------------
						call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%\Upgrade"
					)
					if "%ImageEdition%" equ "Professional" if not exist "%InstallMount%\%%i\Windows\Servicing\Packages\Microsoft-Windows-Security-SPP-Component-SKU-Professional-GVLK-Package*.mum" (
						echo.-------------------------------------------------------------------------------
						echo.Integrating Windows 8.1 Upgradeable Editions Updates Packages...
						echo.-------------------------------------------------------------------------------
						call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%\Upgrade"
					)
				)
			)
		)
	) else (
		if "%SelectedSourceOS%" equ "w7" if "%IsW7SP1CRUSelected%" equ "0" (
			call :AddPackage "%InstallMount%", "%Temp%\Updates\%UpdateType%"

			if exist "%Temp%\Updates\%UpdateType%\WUClient\WUClient*.cab" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows 7 - Windows Update Client Updates Packages...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%", "%Temp%\Updates\%UpdateType%\WUClient\WUClient-SelfUpdate-Core-%ImageArchitecture%-7.6.7600.320.cab"
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%", "%Temp%\Updates\%UpdateType%\WUClient\WUClient-SelfUpdate-Aux-%ImageArchitecture%-7.6.7600.320.cab"
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%", "%Temp%\Updates\%UpdateType%\WUClient\WUClient-SelfUpdate-ActiveX-%ImageArchitecture%-7.6.7600.320.cab"
			)
		)
	
		if "%SelectedSourceOS%" equ "w7" if "%IsW7SP1CRUSelected%" equ "1" (
			echo.
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows 7 SP1 Convenience Rollup Prerequisite Update Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%", "%Temp%\Updates\%UpdateType%\SP2\Windows6.1-KB4490628-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows 7 SP1 Convenience Rollup Platform Update Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%", "%Temp%\Updates\%UpdateType%\SP2\Windows6.1-KB2670838-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows 7 SP1 Convenience Rollup Update Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%", "%Temp%\Updates\%UpdateType%\SP2\Windows6.1-KB3125574-v4-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows 7 SP1 July 2016 Rollup Update Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%", "%Temp%\Updates\%UpdateType%\SP2\Windows6.1-KB3172605-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD General Updates Packages...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%", "%Temp%\Updates\%UpdateType%"
			
			if "%ImageInstallationType%" neq "Embedded" if exist "%Temp%\Updates\%UpdateType%\Client\*.cab" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows 7 Client Updates Packages...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%", "%Temp%\Updates\%UpdateType%\Client"
			)			
		)

		if "%SelectedSourceOS%" equ "w81" (
			call :AddPackage "%InstallMount%", "%Temp%\Updates\%UpdateType%"
				
			if exist "%Temp%\Updates\%UpdateType%\Upgrade\*.cab" (
				if "%ImageEdition%" equ "Core" (
					echo.-------------------------------------------------------------------------------
					echo.Integrating Windows 8.1 Upgradeable Editions Updates Packages...
					echo.-------------------------------------------------------------------------------
					call :AddPackage "%InstallMount%", "%Temp%\Updates\%UpdateType%\Upgrade"
				)
				if "%ImageEdition%" equ "CoreSingleLanguage" (
					echo.-------------------------------------------------------------------------------
					echo.Integrating Windows 8.1 Upgradeable Editions Updates Packages...
					echo.-------------------------------------------------------------------------------
					call :AddPackage "%InstallMount%", "%Temp%\Updates\%UpdateType%\Upgrade"
				)
				if "%ImageEdition%" equ "CoreCountrySpecific" (
					echo.-------------------------------------------------------------------------------
					echo.Integrating Windows 8.1 Upgradeable Editions Updates Packages...
					echo.-------------------------------------------------------------------------------
					call :AddPackage "%InstallMount%", "%Temp%\Updates\%UpdateType%\Upgrade"
				)
				if "%ImageEdition%" equ "Professional" if not exist "%InstallMount%\Windows\Servicing\Packages\Microsoft-Windows-Security-SPP-Component-SKU-Professional-GVLK-Package*.mum" (
					echo.-------------------------------------------------------------------------------
					echo.Integrating Windows 8.1 Upgradeable Editions Updates Packages...
					echo.-------------------------------------------------------------------------------
					call :AddPackage "%InstallMount%", "%Temp%\Updates\%UpdateType%\Upgrade"
				)
			)
		)
	)
)

if "%UpdateType%" equ "Hotfix" (
	if "%ImageIndexNo%" equ "*" (
		echo.
		for /L %%i in (1, 1, %ImageCount%) do (
			if not %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]#############################
			if %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]############################

			call :GetImageEdition "%InstallWim%", %%i
						
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%"
			
			if "%SelectedSourceOS%" equ "w7" if "%IsW7SP1CRUSelected%" equ "0" if exist "%Temp%\Updates\%UpdateType%\Ent_Ultimate\*.cab" (
				if "%ImageEdition%" equ "Enterprise" (
					echo.-------------------------------------------------------------------------------
					echo.Integrating Windows 7 Enterprise Edition Updates Packages...
					echo.-------------------------------------------------------------------------------
					call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%\Ent_Ultimate"
				)
				
				if "%ImageEdition%" equ "Ultimate"  (
					echo.-------------------------------------------------------------------------------
					echo.Integrating Windows 7 Ultimate Edition Updates Packages...
					echo.-------------------------------------------------------------------------------
					call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%\Ent_Ultimate"
				)
			)
			
			if "%SelectedSourceOS%" equ "w7" if "%IsW7SP1CRUSelected%" equ "1" if "%ImageInstallationType%" neq "Embedded" if exist "%Temp%\Updates\%UpdateType%\Client\*.cab" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows 7 Client Updates Packages...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%\Client"
			)
		)
	) else (
		call :AddPackage "%InstallMount%", "%Temp%\Updates\%UpdateType%"

		if "%SelectedSourceOS%" equ "w7" if "%IsW7SP1CRUSelected%" equ "0" if exist "%Temp%\Updates\%UpdateType%\Ent_Ultimate\*.cab" (
			if "%ImageEdition%" equ "Enterprise" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows 7 Enterprise Edition Updates Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%", "%Temp%\Updates\%UpdateType%\Ent_Ultimate"
			)
				
			if "%ImageEdition%" equ "Ultimate"  (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows 7 Ultimate Edition Updates Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%", "%Temp%\Updates\%UpdateType%\Ent_Ultimate"
			)
		)

		if "%SelectedSourceOS%" equ "w7" if "%IsW7SP1CRUSelected%" equ "1" if "%ImageInstallationType%" neq "Embedded" if exist "%Temp%\Updates\%UpdateType%\Client\*.cab" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows 7 Client Updates Packages...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%", "%Temp%\Updates\%UpdateType%\Client"
		)    
	)
)

if "%UpdateType%" equ "Security" (
	if "%ImageIndexNo%" equ "*" (
		echo.
		for /L %%i in (1, 1, %ImageCount%) do (
			if not %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]#############################
			if %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]############################

			call :GetImageEdition "%InstallWim%", %%i >nul
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%"

			:: Applying Anti Microsoft Telemetry Client Patches
			call :MountImageRegistry "%InstallMount%\%%i"
			Reg add "HKLM\TK_SYSTEM\ControlSet001\Services\DiagTrack" /v "Start" /t REG_DWORD /d "4" /f >nul
			Reg delete "HKLM\TK_SYSTEM\ControlSet001\Control\WMI\AutoLogger\AutoLogger-Diagtrack-Listener" /f >nul 2>&1
			Reg delete "HKLM\TK_SYSTEM\ControlSet001\Control\WMI\AutoLogger\SQMLogger" /f >nul 2>&1
			Reg delete "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Diagnostics\DiagTrack" /f >nul 2>&1
			call :UnMountImageRegistry
		)
	) else (
		call :AddPackage "%InstallMount%", "%Temp%\Updates\%UpdateType%"

		:: Applying Anti Microsoft Telemetry Client Patches
		call :MountImageRegistry "%InstallMount%"
		Reg add "HKLM\TK_SYSTEM\ControlSet001\Services\DiagTrack" /v "Start" /t REG_DWORD /d "4" /f >nul
		Reg delete "HKLM\TK_SYSTEM\ControlSet001\Control\WMI\AutoLogger\AutoLogger-Diagtrack-Listener" /f >nul 2>&1
		Reg delete "HKLM\TK_SYSTEM\ControlSet001\Control\WMI\AutoLogger\SQMLogger" /f >nul 2>&1
		Reg delete "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Diagnostics\DiagTrack" /f >nul 2>&1
		call :UnMountImageRegistry
	)
)

if "%UpdateType%" equ "NET35" (
	if "%ImageIndexNo%" equ "*" (
		echo.
		for /L %%i in (1, 1, %ImageCount%) do (
			if not %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]#############################
			if %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]############################
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%"
		)
	) else (
		call :AddPackage "%InstallMount%", "%Temp%\Updates\%UpdateType%"
	)
)

if "%UpdateType%" equ "WAT" (
	if "%ImageIndexNo%" equ "*" (
		echo.
		for /L %%i in (1, 1, %ImageCount%) do (
			if not %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]#############################
			if %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]############################
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%"
		)
	) else (
		call :AddPackage "%InstallMount%", "%Temp%\Updates\%UpdateType%"
	)
)

if "%UpdateType%" equ "Windows10" (
	if "%ImageIndexNo%" equ "*" (
		echo.
		for /L %%i in (1, 1, %ImageCount%) do (
			if not %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]#############################
			if %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]############################
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%"
		)
	) else (
		call :AddPackage "%InstallMount%", "%Temp%\Updates\%UpdateType%"
	)
)

if "%UpdateType%" equ "WinPE" (
	echo.
	if "%IsBootImageSelected%" equ "Yes" (
		echo.-------------------------------------------------------------------------------
		echo.             Integrating Windows PE Updates to Boot.wim Image
		echo.---------------------------------[Index : 2]-----------------------------------
		call :AddPackage "%BootMount%\2", "%Temp%\Updates\%UpdateType%"
	)

	if "%IsBootImageSelected%" equ "Yes" (
		echo.-------------------------------------------------------------------------------
		echo.             Integrating Windows PE Updates to WinRE.wim Image
		echo.---------------------------------[Index : 1]-----------------------------------
		call :AddPackage "%WinReMount%", "%Temp%\Updates\%UpdateType%"	
	)
)

if "%UpdateType%" equ "WUSatisfy" (
	if "%ImageIndexNo%" equ "*" (
		echo.
		for /L %%i in (1, 1, %ImageCount%) do (
			if not %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]#############################
			if %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]############################
			
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%"
			
			if exist "%Temp%\Updates\%UpdateType%\ProfessionalWMC\*.cab" (
				call :GetImageEdition "%InstallWim%", %%i >nul
				
				if "%ImageEdition%" equ "ProfessionalWMC" (
					echo.-------------------------------------------------------------------------------
					echo.Integrating Windows 8.1 Pro WMC Edition - Windows Update Satisfy Updates...
					echo.-------------------------------------------------------------------------------
					call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%\ProfessionalWMC"
				)
			)
		)
	) else (
		call :AddPackage "%InstallMount%", "%Temp%\Updates\%UpdateType%"
		
		if "%ImageEdition%" equ "ProfessionalWMC" if exist "%Temp%\Updates\%UpdateType%\ProfessionalWMC\*.cab" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows 8.1 Pro WMC Edition - Windows Update Satisfy Updates...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%", "%Temp%\Updates\%UpdateType%\ProfessionalWMC"
		)
	)
)

if "%UpdateType%" equ "ADLDS" (
	if "%ImageIndexNo%" equ "*" (
		echo.
		for /L %%i in (1, 1, %ImageCount%) do (
			if not %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]#############################
			if %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]############################

			call :GetImageEdition "%InstallWim%", %%i

			for /d %%j in (Professional, Enterprise, Ultimate) do (
				if "%ImageEdition%" equ "%%j" (
					call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%"
					
					echo.-------------------------------------------------------------------------------
					echo.Integrating Active Directory Lightweight Directory Services Updates Packages...
					echo.-------------------------------------------------------------------------------
					call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%\Updates"
				)
			)
		)
	) else (
		call :AddPackage "%InstallMount%", "%Temp%\Updates\%UpdateType%"
			
		echo.-------------------------------------------------------------------------------
		echo.Integrating Active Directory Lightweight Directory Services Updates Packages...
		echo.-------------------------------------------------------------------------------
		call :AddPackage "%InstallMount%", "%Temp%\Updates\%UpdateType%\Updates"
	)
)

if "%UpdateType%" equ "FMApi" (
	if "%ImageIndexNo%" equ "*" (
		echo.
		for /L %%i in (1, 1, %ImageCount%) do (
			if not %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]#############################
			if %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]############################
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%"
		)
	) else (
		call :AddPackage "%InstallMount%", "%Temp%\Updates\%UpdateType%"
	)
)

if "%UpdateType%" equ "Features" (
	if "%ImageIndexNo%" equ "*" (
		echo.
		for /L %%i in (1, 1, %ImageCount%) do (
			if not %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]#############################
			if %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]############################
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%"
		)
	) else (
		call :AddPackage "%InstallMount%", "%Temp%\Updates\%UpdateType%"
	)
)

if "%UpdateType%" equ "VirtualPC" (
	if "%ImageIndexNo%" equ "*" (
		echo.
		for /L %%i in (1, 1, %ImageCount%) do (
			if not %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]#############################
			if %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]############################
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%"
			
			if "%IsW7SP1CRUSelected%" equ "0"  if exist "%Temp%\Updates\%UpdateType%\Updates\*.cab" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Microsoft Virtual PC Feature Updates...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%\Updates"
			)
		)
	) else (
		call :AddPackage "%InstallMount%", "%Temp%\Updates\%UpdateType%"

		if "%IsW7SP1CRUSelected%" equ "0"  if exist "%Temp%\Updates\%UpdateType%\Updates\*.cab" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Virtual PC Feature Updates...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%", "%Temp%\Updates\%UpdateType%\Updates"
		)		
	)
)

if "%UpdateType%" equ "WorkFolders" (
	if "%ImageIndexNo%" equ "*" (
		echo.
		for /L %%i in (1, 1, %ImageCount%) do (
			if not %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]#############################
			if %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]############################

			call :GetImageEdition "%InstallWim%", %%i

			for /d %%j in (Professional, Enterprise, Ultimate) do (
				if "%ImageEdition%" equ "%%j" (
					call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%"
			
					if "%IsW7SP1CRUSelected%" equ "0" if exist "%Temp%\Updates\%UpdateType%\Updates\*.cab" (
						echo.-------------------------------------------------------------------------------
						echo.Integrating Microsoft Work Folders Feature Updates...
						echo.-------------------------------------------------------------------------------
						call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%\Updates"
					)
				)
			)
		)
	) else (
		call :AddPackage "%InstallMount%", "%Temp%\Updates\%UpdateType%"

		if "%IsW7SP1CRUSelected%" equ "0" if exist "%Temp%\Updates\%UpdateType%\Updates\*.cab" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Work Folders Feature Updates...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%", "%Temp%\Updates\%UpdateType%\Updates"
		)		
	)
)

if "%IsLogsEnabled%" equ "Yes" (
	echo.-------------------------------------------------------------------------------
	if "%UpdateType%" equ "WUpdates" echo.####Generating Windows Updates Integration LOG Files###########################
	if "%UpdateType%" equ "General" echo.####Generating WHD General Updates Integration LOG Files#######################
	if "%UpdateType%" equ "Hotfix" echo.####Generating WHD Hotfix Updates Integration LOG Files########################
	if "%UpdateType%" equ "Security" echo.####Generating WHD Security Updates Integration LOG Files######################
	if "%UpdateType%" equ "NET35" echo.####Generating Microsoft .NET Framework 3.5 Updates Integration LOG Files######
	if "%UpdateType%" equ "WAT" echo.####Generating Windows Activation Technologies Integration ^(WAT^) LOG###########
	if "%UpdateType%" equ "Windows10" echo.####Generating Windows 10 Upgrade Preparation Updates Integration LOG##########
	if "%UpdateType%" equ "WinPE" echo.####Generating Windows PE Updates Integration LOG##############################
	if "%UpdateType%" equ "WUSatisfy" echo.####Generating Windows Update Satisfy Updates Integration LOG Files############
	if "%UpdateType%" equ "ADLDS" echo.####Generating Active Directory Lightweight Directory Services Integration LOG#
	if "%UpdateType%" equ "FMApi" echo.####Generating File Management API Integration LOG#############################
	if "%UpdateType%" equ "Features" echo.####Generating Windows Features Packages Integration LOG Files#################
	if "%UpdateType%" equ "VirtualPC" echo.####Generating Microsoft Virtual PC Feature Integration LOG Files##############
	if "%UpdateType%" equ "WorkFolders" echo.####Generating Work Folders Integration LOG Files##############################
	echo.-------------------------------------------------------------------------------
	echo.
	:: Writing Windows/WHD Updates Integration Log file 
	if "%UpdateType%" equ "WUpdates" echo.Writing Windows Updates Integration Log file...
	if "%UpdateType%" equ "General" echo.Writing WHD General Updates Integration Log file...
	if "%UpdateType%" equ "Hotfix" echo.Writing WHD Hotfix Updates Integration Log file...
	if "%UpdateType%" equ "Security" echo.Writing WHD Security Updates Integration Log file...
	if "%UpdateType%" equ "NET35" echo.Writing Microsoft .NET Framework 3.5 Updates Integration Log file...
	if "%UpdateType%" equ "WAT" echo.Writing Windows Activation Technologies Integration Log file...
	if "%UpdateType%" equ "Windows10" echo.Writing Windows 10 Upgrade Preparation Updates Integration Log file...
	if "%UpdateType%" equ "WinPE" echo.Writing Windows PE Updates Integration Log file...
	if "%UpdateType%" equ "WUSatisfy" echo.Writing Windows Update Satisfy Updates Integration Log file...
	if "%UpdateType%" equ "ADLDS" echo.Writing Active Directory Lightweight Directory Services Integration Log file...
	if "%UpdateType%" equ "FMApi" echo.Writing File Management API Integration Log file...
	if "%UpdateType%" equ "Features" echo.Writing Windows Features Packages Integration Log file...
	if "%UpdateType%" equ "VirtualPC" echo.Writing Microsoft Virtual PC Feature Integration Log files...
	if "%UpdateType%" equ "WorkFolders" echo.Writing Work Folders Integration Log files...
	
	if "%ImageIndexNo%" equ "*" (
		for /L %%i in (1, 1, %ImageCount%) do (
			call :GetPackages "%InstallMount%\%%i", "Updates-%%i.txt"
		)
	) else (
		call :GetPackages "%InstallMount%", "Updates.txt"
	)
	echo.
)

echo.-------------------------------------------------------------------------------
echo.####Cleaning Up Temporary Files ^& Folders######################################
echo.-------------------------------------------------------------------------------
echo.
:: Cleaning Up Windows/WHD Updates Temporary folder...
if "%UpdateType%" equ "WUpdates" echo.Cleaning Up Windows Updates Temporary folder...
if "%UpdateType%" equ "General" echo.Cleaning Up WHD General Updates Temporary folder...
if "%UpdateType%" equ "Hotfix" echo.Cleaning Up WHD Hotfix Updates Temporary folder...
if "%UpdateType%" equ "Security" echo.Cleaning Up WHD Security Updates Temporary folder...
if "%UpdateType%" equ "NET35" echo.Cleaning Up Microsoft .NET Framework 3.5 Updates Temporary folder...
if "%UpdateType%" equ "WAT" echo.Cleaning Up Windows Activation Technologies Temporary folder...
if "%UpdateType%" equ "Windows10" echo.Cleaning Up Windows 10 Upgrade Preparation Updates Temporary folder...
if "%UpdateType%" equ "WinPE" echo.Cleaning Up Windows PE Updates Temporary folder...
if "%UpdateType%" equ "WUSatisfy" echo.Cleaning Up Windows Update Satisfy Updates Temporary folder...
if "%UpdateType%" equ "ADLDS" echo.Cleaning Up Active Directory Lightweight Directory Services Temporary folder...
if "%UpdateType%" equ "FMApi" echo.Cleaning Up File Management API Temporary folder...
if "%UpdateType%" equ "Features" echo.Cleaning Up Windows Features Updates Temporary folder...
if "%UpdateType%" equ "VirtualPC" echo.Cleaning Up Microsoft Virtual PC Feature Temporary folder...
if "%UpdateType%" equ "WorkFolders" echo.Cleaning Up Sync Agent for Domain Environmernts Temporary folder...

call :RemoveFolder "%Temp%\Updates"
echo.
echo.-------------------------------------------------------------------------------
if "%UpdateType%" equ "WUpdates" echo.####Finished Integrating Windows Updates#######################################
if "%UpdateType%" equ "General" echo.####Finished Integrating WHD General Updates###################################
if "%UpdateType%" equ "Hotfix" echo.####Finished Integrating WHD Hotfix Updates####################################
if "%UpdateType%" equ "Security" echo.####Finished Integrating WHD Security Updates##################################
if "%UpdateType%" equ "NET35" echo.####Finished Integrating Microsoft .NET Framework 3.5 Updates##################
if "%UpdateType%" equ "WAT" echo.####Finished Integrating Windows Activation Technologies ^(WAT^) ################
if "%UpdateType%" equ "Windows10" echo.####Finished Windows 10 Upgrade Preparation Updates############################
if "%UpdateType%" equ "WinPE" echo.####Finished Integrating Windows PE Updates####################################
if "%UpdateType%" equ "WUSatisfy" echo.####Finished Integrating Windows Update Satisfy Updates########################
if "%UpdateType%" equ "ADLDS" echo.####Finished Integrating Active Directory Lightweight Directory Service Feature
if "%UpdateType%" equ "FMApi" echo.####Finished Integrating File Management API Feature###########################
if "%UpdateType%" equ "Features" echo.####Finished Integrating Windows Features Updates##############################
if "%UpdateType%" equ "VirtualPC" echo.####Finished Integrating Microsoft Virtual PC Feature##########################
if "%UpdateType%" equ "WorkFolders" echo.####Finished Integrating Sync Agent for Domain Environmernts ^(Work Folders^)####
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set Updates=
set UpdateType=
set IsW7SP1CRUSelected=

endlocal

:: Reading Updated Image Information
if "%SelectedSourceOS%" equ "w10" (
	if "%ImageIndexNo%" equ "*" (
		call :GetImageIndexInfo "%InstallWim%", 1 >nul
		call :MountImageRegistry "%InstallMount%\1"
		for /f "tokens=3 delims= " %%z in ('reg query "HKLM\TK_SOFTWARE\Microsoft\Windows NT\CurrentVersion" /v "UBR" ^| find "REG_DWORD"') do (set /a ImageServicePackBuild=%%z)
		call :UnMountImageRegistry
	) else (
		call :GetImageIndexInfo "%InstallWim%", %ImageIndexNo% >nul
		call :MountImageRegistry "%InstallMount%"
		for /f "tokens=3 delims= " %%z in ('reg query "HKLM\TK_SOFTWARE\Microsoft\Windows NT\CurrentVersion" /v "UBR" ^| find "REG_DWORD"') do (set /a ImageServicePackBuild=%%z)
		call :UnMountImageRegistry
	)
)

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Windows Setup Media Updates
::-------------------------------------------------------------------------------------------
:IntWindowsSetupMediaUpdates

cls
echo.===============================================================================
echo.                  MSMG ToolKit - Update Windows Setup Media
echo.===============================================================================
echo.
:: Getting Boot Image Index Architecture
call :GetImageArchitecture "%BootWim%", 1 >nul

:: Setting the Install Mount folder path
if "%ImageIndexNo%" equ "*" (
	set "InstallMount1=%InstallMount%"
	set "InstallMount=%InstallMount%\1"
)

echo.-------------------------------------------------------------------------------
echo.####Starting Updating Windows Setup Media######################################
echo.-------------------------------------------------------------------------------
echo.
echo.Getting Windows Setup Media Language Settings...
echo.
for /f "tokens=* delims=" %%a in ('%DISM% /Get-WimInfo /WimFile:%BootWim% /Index:1 ^| findstr /i Default') do ( set ImageDefaultLanguage=%%a )
set ImageDefaultLanguage=%ImageDefaultLanguage:~1,-11%
echo.Found Windows Setup Media Language : [%ImageDefaultLanguage%]
echo.
echo.Copying Windows Setup Media Update files to ^<DVD^> folder...

:: Creating Directory Structures
call :CreateFolder "%DVD%"
call :CreateFolder "%DVD%\boot"
call :CreateFolder "%DVD%\efi"
call :CreateFolder "%DVD%\sources"
call :CreateFolder "%DVD%\boot\%ImageDefaultLanguage%"
call :CreateFolder "%DVD%\boot\fonts"
call :CreateFolder "%DVD%\boot\resources"
call :CreateFolder "%DVD%\efi\boot"
call :CreateFolder "%DVD%\efi\microsoft"
call :CreateFolder "%DVD%\efi\microsoft\boot"
call :CreateFolder "%DVD%\efi\microsoft\boot\fonts"
call :CreateFolder "%DVD%\efi\microsoft\boot\resources"
call :CreateFolder "%DVD%\sources\%ImageDefaultLanguage%"
call :CreateFolder "%DVD%\sources\inf"

Copy /Y "%BootMount%\2\Windows\Boot\PCAT\bootmgr" "%DVD%\bootmgr" >nul
Copy /Y "%BootMount%\2\Windows\Boot\EFI\bootmgr.efi" "%DVD%\bootmgr.efi" >nul
Copy /Y "%BootMount%\2\setup.exe" "%DVD%\setup.exe" >nul
Copy /Y "%BootMount%\2\Windows\Boot\DVD\PCAT\bcd" "%DVD%\boot\bcd" >nul
Copy /Y "%BootMount%\2\Windows\Boot\DVD\PCAT\boot.sdi" "%DVD%\boot\boot.sdi" >nul
Copy /Y "%BootMount%\2\Windows\Boot\DVD\PCAT\%ImageDefaultLanguage%\bootfix.bin" "%DVD%\boot\bootfix.bin" >nul
Copy /Y "%BootMount%\2\Windows\System32\bootsect.exe" "%DVD%\boot\bootsect.exe" >nul
Copy /Y "%BootMount%\2\Windows\Boot\DVD\PCAT\etfsboot.com" "%DVD%\boot\etfsboot.com" >nul
Copy /Y "%BootMount%\2\Windows\Boot\PCAT\memtest.exe" "%DVD%\boot\memtest.exe" >nul
Copy /Y "%BootMount%\2\Windows\System32\%ImageDefaultLanguage%\bootsect.exe.mui" "%DVD%\boot\%ImageDefaultLanguage%\bootsect.exe.mui" >nul
Copy /Y "%InstallMount%\Windows\Boot\Fonts\chs_boot.ttf" "%DVD%\boot\fonts\chs_boot.ttf" >nul
Copy /Y "%InstallMount%\Windows\Boot\Fonts\cht_boot.ttf" "%DVD%\boot\fonts\cht_boot.ttf" >nul
Copy /Y "%InstallMount%\Windows\Boot\Fonts\jpn_boot.ttf" "%DVD%\boot\fonts\jpn_boot.ttf" >nul
Copy /Y "%InstallMount%\Windows\Boot\Fonts\kor_boot.ttf" "%DVD%\boot\fonts\kor_boot.ttf" >nul
Copy /Y "%InstallMount%\Windows\Boot\Fonts\malgunn_boot.ttf" "%DVD%\boot\fonts\malgunn_boot.ttf" >nul
Copy /Y "%InstallMount%\Windows\Boot\Fonts\malgun_boot.ttf" "%DVD%\boot\fonts\malgun_boot.ttf" >nul
Copy /Y "%InstallMount%\Windows\Boot\Fonts\meiryon_boot.ttf" "%DVD%\boot\fonts\meiryon_boot.ttf" >nul
Copy /Y "%InstallMount%\Windows\Boot\Fonts\meiryo_boot.ttf" "%DVD%\boot\fonts\meiryo_boot.ttf" >nul
Copy /Y "%InstallMount%\Windows\Boot\Fonts\msjhn_boot.ttf" "%DVD%\boot\fonts\msjhn_boot.ttf" >nul
Copy /Y "%InstallMount%\Windows\Boot\Fonts\msjh_boot.ttf" "%DVD%\boot\fonts\msjh_boot.ttf" >nul
Copy /Y "%InstallMount%\Windows\Boot\Fonts\msyhn_boot.ttf" "%DVD%\boot\fonts\msyhn_boot.ttf" >nul
Copy /Y "%InstallMount%\Windows\Boot\Fonts\msyh_boot.ttf" "%DVD%\boot\fonts\msyh_boot.ttf" >nul
Copy /Y "%InstallMount%\Windows\Boot\Fonts\segmono_boot.ttf" "%DVD%\boot\fonts\segmono_boot.ttf" >nul
Copy /Y "%InstallMount%\Windows\Boot\Fonts\segoen_slboot.ttf" "%DVD%\boot\fonts\segoen_slboot.ttf" >nul
Copy /Y "%InstallMount%\Windows\Boot\Fonts\segoe_slboot.ttf" "%DVD%\boot\fonts\segoe_slboot.ttf" >nul
Copy /Y "%InstallMount%\Windows\Boot\Fonts\wgl4_boot.ttf" "%DVD%\boot\fonts\wgl4_boot.ttf" >nul
Copy /Y "%BootMount%\2\Windows\Boot\Resources\bootres.dll" "%DVD%\boot\resources\bootres.dll" >nul
rem "%DVD%\efi\boot\bootia32.efi" >nul
rem "%DVD%\efi\microsoft\boot\cdboot.efi" >nul
rem "%DVD%\efi\microsoft\boot\cdboot_noprompt.efi" >nul
Copy /Y "%BootMount%\2\Windows\Boot\DVD\EFI\%ImageDefaultLanguage%\efisys.bin" "%DVD%\efi\microsoft\boot\efisys.bin" >nul
Copy /Y "%BootMount%\2\Windows\Boot\DVD\EFI\%ImageDefaultLanguage%\efisys_noprompt.bin" "%DVD%\efi\microsoft\boot\efisys_noprompt.bin" >nul
Copy /Y "%BootMount%\2\Windows\Boot\EFI\memtest.efi" "%DVD%\efi\microsoft\boot\memtest.efi" >nul
Copy /Y "%InstallMount%\Windows\Boot\Fonts\chs_boot.ttf" "%DVD%\efi\microsoft\boot\fonts\chs_boot.ttf" >nul
Copy /Y "%InstallMount%\Windows\Boot\Fonts\cht_boot.ttf" "%DVD%\efi\microsoft\boot\fonts\cht_boot.ttf" >nul
Copy /Y "%InstallMount%\Windows\Boot\Fonts\jpn_boot.ttf" "%DVD%\efi\microsoft\boot\fonts\jpn_boot.ttf" >nul
Copy /Y "%InstallMount%\Windows\Boot\Fonts\kor_boot.ttf" "%DVD%\efi\microsoft\boot\fonts\kor_boot.ttf" >nul
Copy /Y "%InstallMount%\Windows\Boot\Fonts\malgunn_boot.ttf" "%DVD%\efi\microsoft\boot\fonts\malgunn_boot.ttf" >nul
Copy /Y "%InstallMount%\Windows\Boot\Fonts\malgun_boot.ttf" "%DVD%\efi\microsoft\boot\fonts\malgun_boot.ttf" >nul
Copy /Y "%InstallMount%\Windows\Boot\Fonts\meiryon_boot.ttf" "%DVD%\efi\microsoft\boot\fonts\meiryon_boot.ttf" >nul
Copy /Y "%InstallMount%\Windows\Boot\Fonts\meiryo_boot.ttf" "%DVD%\efi\microsoft\boot\fonts\meiryo_boot.ttf" >nul
Copy /Y "%InstallMount%\Windows\Boot\Fonts\msjhn_boot.ttf" "%DVD%\efi\microsoft\boot\fonts\msjhn_boot.ttf" >nul
Copy /Y "%InstallMount%\Windows\Boot\Fonts\msjh_boot.ttf" "%DVD%\efi\microsoft\boot\fonts\msjh_boot.ttf" >nul
Copy /Y "%InstallMount%\Windows\Boot\Fonts\msyhn_boot.ttf" "%DVD%\efi\microsoft\boot\fonts\msyhn_boot.ttf" >nul
Copy /Y "%InstallMount%\Windows\Boot\Fonts\msyh_boot.ttf" "%DVD%\efi\microsoft\boot\fonts\msyh_boot.ttf" >nul
Copy /Y "%InstallMount%\Windows\Boot\Fonts\segmono_boot.ttf" "%DVD%\efi\microsoft\boot\fonts\segmono_boot.ttf" >nul
Copy /Y "%InstallMount%\Windows\Boot\Fonts\segoen_slboot.ttf" "%DVD%\efi\microsoft\boot\fonts\segoen_slboot.ttf" >nul
Copy /Y "%InstallMount%\Windows\Boot\Fonts\segoe_slboot.ttf" "%DVD%\efi\microsoft\boot\fonts\segoe_slboot.ttf" >nul
Copy /Y "%InstallMount%\Windows\Boot\Fonts\wgl4_boot.ttf" "%DVD%\efi\microsoft\boot\fonts\wgl4_boot.ttf" >nul
rem "%DVD%\efi\microsoft\boot\resources\bootres.dll" >nul
Copy /Y "%InstallMount%\Windows\apppatch\acres.dll" "%DVD%\sources\acres.dll" >nul
Copy /Y "%InstallMount%\Windows\System32\actionqueue.dll" "%DVD%\sources\actionqueue.dll" >nul
rem "%DVD%\sources\adfscomp.dll" >nul
rem "%DVD%\sources\admtv3check.dll" >nul
Copy /Y "%InstallMount%\Windows\System32\aeinv.dll" "%DVD%\sources\aeinv.dll" >nul
rem "%DVD%\sources\alert.gif" >nul
Copy /Y "%BootMount%\2\sources\api-ms-win-downlevel-advapi32-l1-1-0.dll" "%DVD%\sources\api-ms-win-downlevel-advapi32-l1-1-0.dll" >nul
Copy /Y "%BootMount%\2\sources\api-ms-win-downlevel-advapi32-l1-1-1.dll" "%DVD%\sources\api-ms-win-downlevel-advapi32-l1-1-1.dll" >nul
Copy /Y "%BootMount%\2\sources\api-ms-win-downlevel-advapi32-l2-1-0.dll" "%DVD%\sources\api-ms-win-downlevel-advapi32-l2-1-0.dll" >nul
Copy /Y "%BootMount%\2\sources\api-ms-win-downlevel-advapi32-l2-1-1.dll" "%DVD%\sources\api-ms-win-downlevel-advapi32-l2-1-1.dll" >nul
Copy /Y "%BootMount%\2\sources\api-ms-win-downlevel-advapi32-l3-1-0.dll" "%DVD%\sources\api-ms-win-downlevel-advapi32-l3-1-0.dll" >nul
Copy /Y "%BootMount%\2\sources\api-ms-win-downlevel-advapi32-l4-1-0.dll" "%DVD%\sources\api-ms-win-downlevel-advapi32-l4-1-0.dll" >nul
Copy /Y "%BootMount%\2\sources\api-ms-win-downlevel-kernel32-l1-1-0.dll" "%DVD%\sources\api-ms-win-downlevel-kernel32-l1-1-0.dll" >nul
Copy /Y "%BootMount%\2\sources\api-ms-win-downlevel-kernel32-l2-1-0.dll" "%DVD%\sources\api-ms-win-downlevel-kernel32-l2-1-0.dll" >nul
Copy /Y "%BootMount%\2\sources\api-ms-win-downlevel-ole32-l1-1-0.dll" "%DVD%\sources\api-ms-win-downlevel-ole32-l1-1-0.dll" >nul
Copy /Y "%BootMount%\2\sources\api-ms-win-downlevel-ole32-l1-1-1.dll" "%DVD%\sources\api-ms-win-downlevel-ole32-l1-1-1.dll" >nul
Copy /Y "%BootMount%\2\sources\api-ms-win-downlevel-shlwapi-l1-1-0.dll" "%DVD%\sources\api-ms-win-downlevel-shlwapi-l1-1-0.dll" >nul
Copy /Y "%BootMount%\2\sources\api-ms-win-downlevel-shlwapi-l1-1-1.dll" "%DVD%\sources\api-ms-win-downlevel-shlwapi-l1-1-1.dll" >nul
Copy /Y "%BootMount%\2\sources\api-ms-win-downlevel-user32-l1-1-0.dll" "%DVD%\sources\api-ms-win-downlevel-user32-l1-1-0.dll" >nul
Copy /Y "%BootMount%\2\sources\api-ms-win-downlevel-user32-l1-1-1.dll" "%DVD%\sources\api-ms-win-downlevel-user32-l1-1-1.dll" >nul
Copy /Y "%BootMount%\2\sources\api-ms-win-downlevel-version-l1-1-0.dll" "%DVD%\sources\api-ms-win-downlevel-version-l1-1-0.dll" >nul
Copy /Y "%BootMount%\2\sources\appcompat.xsl" "%DVD%\sources\appcompat.xsl" >nul
Copy /Y "%BootMount%\2\sources\appcompat_bidi.xsl" "%DVD%\sources\appcompat_bidi.xsl" >nul
rem "%DVD%\sources\appcompat_detailed.xsl" >nul
rem "%DVD%\sources\appcompat_detailed_bidi.xsl" >nul
Copy /Y "%BootMount%\2\sources\appcompat_detailed_bidi_txt.xsl" "%DVD%\sources\appcompat_detailed_bidi_txt.xsl" >nul
Copy /Y "%BootMount%\2\sources\appcompat_detailed_txt.xsl" "%DVD%\sources\appcompat_detailed_txt.xsl" >nul
Copy /Y "%BootMount%\2\sources\arunimg.dll" "%DVD%\sources\arunimg.dll" >nul
Copy /Y "%BootMount%\2\sources\arunres.dll" "%DVD%\sources\arunres.dll" >nul
Copy /Y "%BootMount%\2\sources\autorun.dll" "%DVD%\sources\autorun.dll" >nul
rem "%DVD%\sources\background_cli.bmp" >nul
rem "%DVD%\sources\cdplib.mof" >nul
rem "%DVD%\sources\cdplibuninstall.mof" >nul
rem "%DVD%\sources\clustercompliance.dll" >nul
Copy /Y "%InstallMount%\Windows\System32\migwiz\cmi2migxml.dll" "%DVD%\sources\cmi2migxml.dll" >nul
Copy /Y "%InstallMount%\Windows\System32\cmifw.dll" "%DVD%\sources\cmifw.dll" >nul
Copy /Y "%BootMount%\2\sources\cmisetup.dll" "%DVD%\sources\cmisetup.dll" >nul
Copy /Y "%InstallMount%\Windows\System32\CompatTel\compatctrl.dll" "%DVD%\sources\compatctrl.dll" >nul
Copy /Y "%BootMount%\2\sources\compatprovider.dll" "%DVD%\sources\compatprovider.dll" >nul
Copy /Y "%InstallMount%\Windows\System32\CompatTel\compatresources.dll" "%DVD%\sources\compatresources.dll" >nul
Copy /Y "%BootMount%\2\sources\compliance.ini" "%DVD%\sources\compliance.ini" >nul
rem "%DVD%\sources\compres.dll" >nul
Copy /Y "%BootMount%\2\sources\cryptosetup.dll" "%DVD%\sources\cryptosetup.dll" >nul
Copy /Y "%InstallMount%\Windows\System32\migwiz\csiagent.dll" "%DVD%\sources\csiagent.dll" >nul
rem "%DVD%\sources\cversion.ini" >nul
rem "%DVD%\sources\db_msftproductionwindowssigningca.cer" >nul
Copy /Y "%InstallMount%\Windows\System32\devinv.dll" "%DVD%\sources\devinv.dll" >nul
Copy /Y "%BootMount%\2\sources\diager.dll" "%DVD%\sources\diager.dll" >nul
Copy /Y "%BootMount%\2\sources\diagnostic.dll" "%DVD%\sources\diagnostic.dll" >nul
Copy /Y "%BootMount%\2\sources\dism.exe" "%DVD%\sources\dism.exe" >nul
Copy /Y "%BootMount%\2\Windows\System32\dismapi.dll" "%DVD%\sources\dismapi.dll" >nul
Copy /Y "%BootMount%\2\sources\dismcore.dll" "%DVD%\sources\dismcore.dll" >nul
Copy /Y "%BootMount%\2\sources\dismcoreps.dll" "%DVD%\sources\dismcoreps.dll" >nul
Copy /Y "%BootMount%\2\sources\dismprov.dll" "%DVD%\sources\dismprov.dll" >nul
Copy /Y "%InstallMount%\Windows\apppatch\drvmain.sdb" "%DVD%\sources\drvmain.sdb" >nul
Copy /Y "%InstallMount%\Windows\System32\CompatTel\drvmain32.sdb" "%DVD%\sources\drvmain32.sdb" >nul
Copy /Y "%InstallMount%\Windows\System32\CompatTel\drvmain64.sdb" "%DVD%\sources\drvmain64.sdb" >nul
rem "%DVD%\sources\drvmainarm.sdb" >nul
Copy /Y "%BootMount%\2\sources\drvmgrtn.dll" "%DVD%\sources\drvmgrtn.dll" >nul
Copy /Y "%BootMount%\2\sources\du.dll" "%DVD%\sources\du.dll" >nul
Copy /Y "%InstallMount%\Windows\WinSxS\x86_microsoft-windows-servicingstack-net_31bf3856ad364e35_6.3.9600.17031_none_d358249e46914d92\firewallofflineapi.dll" "%DVD%\sources\firewallofflineapi.dll" >nul
Copy /Y "%BootMount%\2\sources\folderprovider.dll" "%DVD%\sources\folderprovider.dll" >nul
rem "%DVD%\sources\fveupg.dll" >nul
Copy /Y "%BootMount%\2\sources\hwcompat.dll" "%DVD%\sources\hwcompat.dll" >nul
Copy /Y "%BootMount%\2\sources\hwcompat.txt" "%DVD%\sources\hwcompat.txt" >nul
rem "%DVD%\sources\hwcompatPE.txt" >nul
Copy /Y "%BootMount%\2\sources\hwexclude.txt" "%DVD%\sources\hwexclude.txt" >nul
rem "%DVD%\sources\hwexcludePE.txt" >nul
rem "%DVD%\sources\hypervcomplcheck.dll" >nul
Copy /Y "%BootMount%\2\sources\idwbinfo.txt" "%DVD%\sources\idwbinfo.txt" >nul
rem "%DVD%\sources\iiscomp.dll" >nul
Copy /Y "%BootMount%\2\sources\imagingprovider.dll" "%DVD%\sources\imagingprovider.dll" >nul
Copy /Y "%BootMount%\2\sources\input.dll" "%DVD%\sources\input.dll" >nul
rem "%DVD%\sources\install.exe" >nul
Copy /Y "%InstallMount%\Windows\System32\oobe\installeventres.dll" "%DVD%\sources\installeventres.dll" >nul
rem "%DVD%\sources\installprep.exe" >nul
rem "%DVD%\sources\itgtupg.dll" >nul
Copy /Y "%BootMount%\2\sources\lang.ini" "%DVD%\sources\lang.ini" >nul
Copy /Y "%BootMount%\2\sources\locale.nls" "%DVD%\sources\locale.nls" >nul
Copy /Y "%BootMount%\2\sources\logprovider.dll" "%DVD%\sources\logprovider.dll" >nul
Copy /Y "%InstallMount%\Windows\System32\luainstall.dll" "%DVD%\sources\luainstall.dll" >nul
Copy /Y "%InstallMount%\Windows\System32\migwiz\migapp.xml" "%DVD%\sources\migapp.xml" >nul
Copy /Y "%InstallMount%\Windows\System32\migwiz\migcore.dll" "%DVD%\sources\migcore.dll" >nul
Copy /Y "%InstallMount%\Windows\System32\migwiz\mighost.exe" "%DVD%\sources\mighost.exe" >nul
Copy /Y "%InstallMount%\Windows\System32\migisol.dll" "%DVD%\sources\migisol.dll" >nul
Copy /Y "%InstallMount%\Windows\System32\migwiz\migres.dll" "%DVD%\sources\migres.dll" >nul
Copy /Y "%InstallMount%\Windows\System32\migwiz\migstore.dll" "%DVD%\sources\migstore.dll" >nul
Copy /Y "%InstallMount%\Windows\System32\migwiz\migsys.dll" "%DVD%\sources\migsys.dll" >nul
rem "%DVD%\sources\migtestplugin.dll" >nul
Copy /Y "%BootMount%\2\sources\msxml6.dll" "%DVD%\sources\msxml6.dll" >nul
Copy /Y "%BootMount%\2\sources\msxml6r.dll" "%DVD%\sources\msxml6r.dll" >nul
Copy /Y "%InstallMount%\Windows\System32\migwiz\mxeagent.dll" "%DVD%\sources\mxeagent.dll" >nul
Copy /Y "%BootMount%\2\sources\ndiscompl.dll" "%DVD%\sources\ndiscompl.dll" >nul
Copy /Y "%BootMount%\2\sources\nlsbres.dll" "%DVD%\sources\nlsbres.dll" >nul
Copy /Y "%BootMount%\2\sources\ntdsupg.dll" "%DVD%\sources\ntdsupg.dll" >nul
rem "%DVD%\sources\ntfrsupg.dll" >nul
rem "%DVD%\sources\nxquery.cat" >nul
rem "%DVD%\sources\nxquery.inf" >nul
rem "%DVD%\sources\nxquery.sys" >nul
Copy /Y "%BootMount%\2\sources\offline.xml" "%DVD%\sources\offline.xml" >nul
rem "%DVD%\sources\oscomps.woa.xml" >nul
rem "%DVD%\sources\oscomps.xml" >nul
rem "%DVD%\sources\osfilter.inf" >nul
rem "%DVD%\sources\outofbox_windows_db.bin" >nul
Copy /Y "%BootMount%\2\sources\pnpibs.dll" "%DVD%\sources\pnpibs.dll" >nul
rem "%DVD%\sources\postrollback.exe" >nul
Copy /Y "%InstallMount%\Windows\System32\CompatTel\queryappblock.exe" "%DVD%\sources\queryappblock.exe" >nul
rem "%DVD%\sources\quirks.ait" >nul
rem "%DVD%\sources\rdsupgcheck.dll" >nul
Copy /Y "%InstallMount%\Windows\PolicyDefinitions\reagent.admx" "%DVD%\sources\reagent.admx" >nul
Copy /Y "%BootMount%\2\sources\reagent.dll" "%DVD%\sources\reagent.dll" >nul
Copy /Y "%InstallMount%\Windows\System32\Recovery\reagent.xml" "%DVD%\sources\reagent.xml" >nul
rem "%DVD%\sources\reportgen.dll" >nul
rem "%DVD%\sources\rmsupg.dll" >nul
Copy /Y "%BootMount%\2\sources\rollback.exe" "%DVD%\sources\rollback.exe" >nul
Copy /Y "%BootMount%\2\sources\schema.dat" "%DVD%\sources\schema.dat" >nul
Copy /Y "%BootMount%\2\sources\sdbapiu.dll" "%DVD%\sources\sdbapiu.dll" >nul
Copy /Y "%BootMount%\2\sources\segoeui.ttf" "%DVD%\sources\segoeui.ttf" >nul
Copy /Y "%BootMount%\2\sources\setup.exe" "%DVD%\sources\setup.exe" >nul
Copy /Y "%InstallMount%\Windows\System32\CompatTel\setupcompat.dll" "%DVD%\sources\setupcompat.dll" >nul
rem "%DVD%\sources\setuperror.exe" >nul
Copy /Y "%BootMount%\2\sources\setupplatform.cfg" "%DVD%\sources\setupplatform.cfg" >nul
Copy /Y "%BootMount%\2\sources\setupplatform.dll" "%DVD%\sources\setupplatform.dll" >nul
Copy /Y "%BootMount%\2\sources\setupplatform.exe" "%DVD%\sources\setupplatform.exe" >nul
rem "%DVD%\sources\setupresume.exe" >nul
Copy /Y "%InstallMount%\Windows\System32\migwiz\sfcn.dat" "%DVD%\sources\sfcn.dat" >nul
Copy /Y "%InstallMount%\Windows\System32\migwiz\sflcid.dat" "%DVD%\sources\sflcid.dat" >nul
Copy /Y "%InstallMount%\Windows\System32\migwiz\sflistw7.dat" "%DVD%\sources\sflistw7.dat" >nul
Copy /Y "%InstallMount%\Windows\System32\migwiz\sflistw8.dat" "%DVD%\sources\sflistw8.dat" >nul
Copy /Y "%InstallMount%\Windows\System32\migwiz\sflistw8.woa.dat" "%DVD%\sources\sflistw8.woa.dat" >nul
Copy /Y "%InstallMount%\Windows\System32\migwiz\sflistwb.dat" "%DVD%\sources\sflistwb.dat" >nul
Copy /Y "%InstallMount%\Windows\System32\migwiz\sflistwb.woa.dat" "%DVD%\sources\sflistwb.woa.dat" >nul
Copy /Y "%InstallMount%\Windows\System32\migwiz\sfpat.inf" "%DVD%\sources\sfpat.inf" >nul
rem "%DVD%\sources\sfpatpg.inf" >nul
Copy /Y "%InstallMount%\Windows\System32\migwiz\sfpatw7.inf" "%DVD%\sources\sfpatw7.inf" >nul
Copy /Y "%InstallMount%\Windows\System32\migwiz\sfpatw8.inf" "%DVD%\sources\sfpatw8.inf" >nul
Copy /Y "%InstallMount%\Windows\System32\migwiz\sfpatwb.inf" "%DVD%\sources\sfpatwb.inf" >nul
Copy /Y "%BootMount%\2\sources\smiengine.dll" "%DVD%\sources\smiengine.dll" >nul
Copy /Y "%BootMount%\2\sources\spflvrnt.dll" "%DVD%\sources\spflvrnt.dll" >nul
Copy /Y "%BootMount%\2\sources\spprgrss.dll" "%DVD%\sources\spprgrss.dll" >nul
Copy /Y "%BootMount%\2\sources\spwizeng.dll" "%DVD%\sources\spwizeng.dll" >nul
Copy /Y "%BootMount%\2\sources\spwizimg.dll" "%DVD%\sources\spwizimg.dll" >nul
Copy /Y "%BootMount%\2\sources\spwizres.dll" "%DVD%\sources\spwizres.dll" >nul
Copy /Y "%BootMount%\2\sources\sqmapi.dll" "%DVD%\sources\sqmapi.dll" >nul
Copy /Y "%BootMount%\2\sources\ssshim.dll" "%DVD%\sources\ssshim.dll" >nul
Copy /Y "%InstallMount%\Windows\apppatch\sysmain.sdb" "%DVD%\sources\sysmain.sdb" >nul
Copy /Y "%InstallMount%\Windows\System32\CompatTel\sysmain32.sdb" "%DVD%\sources\sysmain32.sdb" >nul
Copy /Y "%InstallMount%\Windows\System32\CompatTel\sysmain64.sdb" "%DVD%\sources\sysmain64.sdb" >nul
rem "%DVD%\sources\telemetry.xsd" >nul
rem "%DVD%\sources\uddicomp.dll" >nul
Copy /Y "%BootMount%\2\sources\unattend.dll" "%DVD%\sources\unattend.dll" >nul
Copy /Y "%BootMount%\2\sources\unbcl.dll" "%DVD%\sources\unbcl.dll" >nul
rem "%DVD%\sources\upgcompat.inf" >nul" >nul
rem "%DVD%\sources\upgdriver.dll" >nul" >nul
Copy /Y "%BootMount%\2\sources\upgloader.dll" "%DVD%\sources\upgloader.dll" >nul
rem "%DVD%\sources\upgradeagent.dll" >nul
rem "%DVD%\sources\upgradeagent.xml" >nul
rem "%DVD%\sources\upgrade_bulk.xml" >nul
rem "%DVD%\sources\upgrade_data.xml" >nul
Copy /Y "%BootMount%\2\sources\upgrade_frmwrk.xml" "%DVD%\sources\upgrade_frmwrk.xml" >nul
Copy /Y "%BootMount%\2\sources\upgreport.dll" "%DVD%\sources\upgreport.dll" >nul
rem "%DVD%\sources\upgwow_bulk.xml" >nul
Copy /Y "%BootMount%\2\sources\uxlib.dll" "%DVD%\sources\uxlib.dll" >nul
Copy /Y "%BootMount%\2\sources\uxlibres.dll" "%DVD%\sources\uxlibres.dll" >nul
Copy /Y "%BootMount%\2\sources\vhdprovider.dll" "%DVD%\sources\vhdprovider.dll" >nul
Copy /Y "%BootMount%\2\sources\w32uiimg.dll" "%DVD%\sources\w32uiimg.dll" >nul
Copy /Y "%BootMount%\2\sources\w32uires.dll" "%DVD%\sources\w32uires.dll" >nul
Copy /Y "%BootMount%\2\sources\warning.gif" "%DVD%\sources\warning.gif" >nul
Copy /Y "%BootMount%\2\sources\wdsclient.dll" "%DVD%\sources\wdsclient.dll" >nul
Copy /Y "%BootMount%\2\sources\wdsclientapi.dll" "%DVD%\sources\wdsclientapi.dll" >nul
Copy /Y "%BootMount%\2\sources\wdscore.dll" "%DVD%\sources\wdscore.dll" >nul
Copy /Y "%BootMount%\2\sources\wdscsl.dll" "%DVD%\sources\wdscsl.dll" >nul
Copy /Y "%BootMount%\2\sources\wdsimage.dll" "%DVD%\sources\wdsimage.dll" >nul
Copy /Y "%BootMount%\2\sources\wdstptc.dll" "%DVD%\sources\wdstptc.dll" >nul
rem "%DVD%\sources\wdsupgcompl.dll" >nul
Copy /Y "%BootMount%\2\sources\wdsutil.dll" "%DVD%\sources\wdsutil.dll" >nul
Copy /Y "%InstallMount%\Windows\System32\CompatTel\wica.dll" "%DVD%\sources\wica.dll" >nul
Copy /Y "%InstallMount%\Windows\System32\CompatTel\wica.ini" "%DVD%\sources\wica.ini" >nul
rem "%DVD%\sources\wicadevicefilters.xml" >nul
Copy /Y "%InstallMount%\Windows\System32\CompatTel\wicainventory.exe" "%DVD%\sources\wicainventory.exe" >nul
rem "%DVD%\sources\wicatel.dll" >nul
Copy /Y "%BootMount%\2\sources\wimprovider.dll" "%DVD%\sources\wimprovider.dll" >nul
Copy /Y "%BootMount%\2\sources\win32ui.dll" "%DVD%\sources\win32ui.dll" >nul
Copy /Y "%BootMount%\2\sources\winsetup.dll" "%DVD%\sources\winsetup.dll" >nul
Copy /Y "%InstallMount%\Windows\apppatch\%ImageDefaultLanguage%\acres.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\acres.dll.mui" >nul
Copy /Y "%InstallMount%\Windows\System32\%ImageDefaultLanguage%\actionqueue.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\actionqueue.dll.mui" >nul
Copy /Y "%BootMount%\2\sources\%ImageDefaultLanguage%\arunres.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\arunres.dll.mui" >nul
Copy /Y "%BootMount%\2\sources\%ImageDefaultLanguage%\cmisetup.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\cmisetup.dll.mui" >nul
rem "%DVD%\sources\%ImageDefaultLanguage%\compatctrl.dll.mui" >nul
Copy /Y "%BootMount%\2\sources\%ImageDefaultLanguage%\compatprovider.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\compatprovider.dll.mui" >nul
rem "%DVD%\sources\%ImageDefaultLanguage%\compatresources.dll.mui" >nul
rem "%DVD%\sources\%ImageDefaultLanguage%\compres.dll.mui" >nul
Copy /Y "%InstallMount%\Windows\Help\%ImageDefaultLanguage%\credits.rtf" "%DVD%\sources\%ImageDefaultLanguage%\credits.rtf" >nul
Copy /Y "%BootMount%\2\sources\%ImageDefaultLanguage%\dism.exe.mui" "%DVD%\sources\%ImageDefaultLanguage%\dism.exe.mui" >nul
Copy /Y "%InstallMount%\Windows\System32\%ImageDefaultLanguage%\dismapi.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\dismapi.dll.mui" >nul
Copy /Y "%BootMount%\2\sources\%ImageDefaultLanguage%\dismcore.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\dismcore.dll.mui" >nul
Copy /Y "%BootMount%\2\sources\%ImageDefaultLanguage%\dismprov.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\dismprov.dll.mui" >nul
Copy /Y "%InstallMount%\Windows\System32\%ImageDefaultLanguage%\erofflps.txt" "%DVD%\sources\%ImageDefaultLanguage%\erofflps.txt" >nul
Copy /Y "%BootMount%\2\sources\%ImageDefaultLanguage%\folderprovider.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\folderprovider.dll.mui" >nul
Copy /Y "%BootMount%\2\sources\%ImageDefaultLanguage%\imagingprovider.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\imagingprovider.dll.mui" >nul
Copy /Y "%BootMount%\2\sources\%ImageDefaultLanguage%\input.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\input.dll.mui" >nul
rem "%DVD%\sources\%ImageDefaultLanguage%\install.exe.mui" >nul
Copy /Y "%InstallMount%\Windows\System32\oobe\%ImageDefaultLanguage%\installeventres.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\installeventres.dll.mui" >nul
rem "%DVD%\sources\%ImageDefaultLanguage%\installprep.exe.mui" >nul
Copy /Y "%BootMount%\2\sources\%ImageDefaultLanguage%\logprovider.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\logprovider.dll.mui" >nul
Copy /Y "%InstallMount%\Windows\System32\migwiz\%ImageDefaultLanguage%\migcore.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\migcore.dll.mui" >nul
Copy /Y "%InstallMount%\Windows\System32\migwiz\%ImageDefaultLanguage%\migres.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\migres.dll.mui" >nul
Copy /Y "%BootMount%\2\sources\%ImageDefaultLanguage%\msxml6r.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\msxml6r.dll.mui" >nul
Copy /Y "%BootMount%\2\sources\%ImageDefaultLanguage%\nlsbres.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\nlsbres.dll.mui" >nul
Copy /Y "%InstallMount%\Windows\System32\oobe\%ImageDefaultLanguage%\oobe_help_opt_in_details.rtf" "%DVD%\sources\%ImageDefaultLanguage%\oobe_help_opt_in_details.rtf" >nul
Copy /Y "%BootMount%\2\sources\%ImageDefaultLanguage%\pnpibs.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\pnpibs.dll.mui" >nul
rem "%DVD%\sources\%ImageDefaultLanguage%\postrollback.exe.mui" >nul
Copy /Y "%InstallMount%\Windows\System32\oobe\%ImageDefaultLanguage%\privacy.rtf" "%DVD%\sources\%ImageDefaultLanguage%\privacy.rtf" >nul
Copy /Y "%InstallMount%\Windows\PolicyDefinitions\%ImageDefaultLanguage%\reagent.adml" "%DVD%\sources\%ImageDefaultLanguage%\reagent.adml" >nul
Copy /Y "%InstallMount%\Windows\System32\%ImageDefaultLanguage%\reagent.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\reagent.dll.mui" >nul
Copy /Y "%BootMount%\2\sources\%ImageDefaultLanguage%\rollback.exe.mui" "%DVD%\sources\%ImageDefaultLanguage%\rollback.exe.mui" >nul
Copy /Y "%BootMount%\2\sources\%ImageDefaultLanguage%\setup.exe.mui" "%DVD%\sources\%ImageDefaultLanguage%\setup.exe.mui" >nul
rem "%DVD%\sources\%ImageDefaultLanguage%\setupcompat.dll.mui" >nul
rem "%DVD%\sources\%ImageDefaultLanguage%\setuperror.exe.mui" >nul
rem "%DVD%\sources\%ImageDefaultLanguage%\setupplatform.exe.mui" >nul
rem "%DVD%\sources\%ImageDefaultLanguage%\setupresume.exe.mui" >nul
Copy /Y "%BootMount%\2\sources\%ImageDefaultLanguage%\setup_help_upgrade_or_custom.rtf" "%DVD%\sources\%ImageDefaultLanguage%\setup_help_upgrade_or_custom.rtf" >nul
rem "%DVD%\sources\%ImageDefaultLanguage%\setup_help_whattokeep.rtf" >nul
Copy /Y "%BootMount%\2\sources\%ImageDefaultLanguage%\smiengine.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\smiengine.dll.mui" >nul
Copy /Y "%BootMount%\2\sources\%ImageDefaultLanguage%\spwizres.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\spwizres.dll.mui" >nul
rem "%DVD%\sources\%ImageDefaultLanguage%\upgdriver.dll.mui" >nul
Copy /Y "%BootMount%\2\sources\%ImageDefaultLanguage%\upgloader.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\upgloader.dll.mui" >nul
rem "%DVD%\sources\%ImageDefaultLanguage%\upgreport.dll.mui" >nul
Copy /Y "%BootMount%\2\sources\%ImageDefaultLanguage%\uxlibres.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\uxlibres.dll.mui" >nul
Copy /Y "%BootMount%\2\sources\%ImageDefaultLanguage%\vhdprovider.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\vhdprovider.dll.mui" >nul
Copy /Y "%BootMount%\2\sources\%ImageDefaultLanguage%\vofflps.rtf" "%DVD%\sources\%ImageDefaultLanguage%\vofflps.rtf" >nul
Copy /Y "%BootMount%\2\sources\%ImageDefaultLanguage%\w32uires.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\w32uires.dll.mui" >nul
Copy /Y "%BootMount%\2\sources\%ImageDefaultLanguage%\wdsclient.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\wdsclient.dll.mui" >nul
Copy /Y "%BootMount%\2\sources\%ImageDefaultLanguage%\wdsimage.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\wdsimage.dll.mui" >nul
Copy /Y "%BootMount%\2\sources\%ImageDefaultLanguage%\wimprovider.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\wimprovider.dll.mui" >nul
Copy /Y "%BootMount%\2\sources\%ImageDefaultLanguage%\winsetup.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\winsetup.dll.mui" >nul
Copy /Y "%BootMount%\2\sources\inf\setup.cfg" "%DVD%\sources\inf\setup.cfg" >nul
echo.
echo.-------------------------------------------------------------------------------
echo.####Finished Updating Windows Setup Media######################################
echo.-------------------------------------------------------------------------------
echo.
echo.===============================================================================
echo.
pause

if "%ImageIndexNo%" equ "*" (
	set "InstallMount=%InstallMount1%"
	set InstallMount1=
)

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Windows 8.1 Media Center Generic Activation Tokens to Install Image
::-------------------------------------------------------------------------------------------
:IntWMCGActTokens

if "%IsDialogsEnabled%" equ "Yes" (
	cls
	echo.===============================================================================
	echo. MSMG ToolKit - Integrate Windows 8.1 Media Center Generic Activation Tokens
	echo.===============================================================================
	echo.
	echo.
	echo.                            I N F O R M A T I O N
	echo.                            =====================
	echo.
	echo.  Windows 8.1 Media Center Generic Activation Tokens are Generic Tokens data
	echo.  files that have been extracted from an Un-Activated Windows 8.0 Pro WMC
	echo.  OS upgraded to Windows 8.1 Pro WMC OS through Windows Store upgrade method.
	echo.
	echo.  Since Windows 8.1 Pro OS doesn't accepts Windows 8.0 Pro WMC or WMC Add-on
	echo.  Keys to install the OS, These Generic Tokens helps to make Windows Setup to 
	echo.  accept and install Windows 8.0 Pro WMC or WMC Add-on Keys for installation. 
	echo.
	echo.  Later the installed OS can be directly activated through Online or Phone
	echo.  activation method.
	echo.
	echo.
	echo.  To turn off Warning Dialogs, Choose Disable Dialogs in Tools-^>Options Menu
	echo.
	echo.===============================================================================
	echo.
	choice /C:YN /N /M "Do you want to continue ? ['Y'es/'N'o] : "
	if errorlevel 2 goto :IntegrateMenu
)

setlocal

cls
echo.===============================================================================
echo.  MSMG ToolKit - Integrate Windows 8.1 Media Center Generic Activation Tokens
echo.===============================================================================
echo.

:: Checking whether Multi-Index Servicing Mode is selected
if "%ImageIndexNo%" equ "*" (
	echo.This feature is not available when Multi-Index servicing mode is enabled...
	echo.
	echo.Please Re-Choose Source with a Single Index...
	goto :Stop
)

:: Getting Install Image Index Architecture
call :GetImageArchitecture "%InstallWim%", %ImageIndexNo% >nul

:: Checking whether the Selected Source OS is a Windows 8.1 Pro WMC Edition
%Imagex% /Info "%InstallWim%" %ImageIndexNo% | findstr /c:"<EDITIONID>ProfessionalWMC</EDITIONID>" >nul
if errorlevel 1 (
	echo.Selected Source is not a Windows 8.1 Pro WMC Edition...
	echo.
	echo.Please Use Windows 8.1 Pro WMC Edition Operating System as Source...
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Windows 8.1 Media Center Generic Activation Tokens####
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.    Image Edition            : %ImageEdition%
echo.    Image Default Language   : %ImageDefaultLanguage%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Windows 8.1 Media Center Generic Activation Tokens#############
echo.-------------------------------------------------------------------------------
call :ApplyImage "%WMCGActTokens%", 1, "%InstallMount%"
echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Windows 8.1 Media Center Generic Activation Tokens####
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Windows Pre-Activation Data
::-------------------------------------------------------------------------------------------
:IntPreActTokens

if "%IsDialogsEnabled%" equ "Yes" (
	cls
	echo.===============================================================================
	echo.          MSMG ToolKit - Integrate Windows 8.1 Pre-Activation Data
	echo.===============================================================================
	echo.
	echo. MSMG ToolKit will allow you to integrate your system activation details to
	echo. Windows Installation Disc Image to perform auto activation of system without 
	echo. any need to activate online or through phone activation.
	echo.
	echo. Note: When you make any changes to your System Hardware, then the activation
	echo. status will be Lost.
	echo. 
	echo. Requirements:
	echo. -------------
	echo. 1^) Windows Product Key
	echo.
	echo. 2^) Latest Pre-Activated Tokens files from Windows Activated System Drive
	echo.
	echo.    - "data.dat" from "<%SytemDrive%\Windows\System32\spp\store>" folder
	echo.    - "tokens.dat" from "<%SytemDrive%\Windows\System32\spp\store>" folder
	echo.    - "cache.dat" from "<%SytemDrive%\Windows\System32\spp\store>" folder
	echo.
	echo.===============================================================================
	echo.
	choice /C:YN /N /M "Do you want to Continue ? ['Y'es/'N'o] : "
	if errorlevel 2 goto :IntegrateMenu
)

setlocal

cls
echo.===============================================================================
echo.           MSMG ToolKit - Integrate Windows 8.1 Pre-Activation Data
echo.===============================================================================
echo.
:: Checking whether Multi-Index servicing mode is selected
if "%ImageIndexNo%" equ "*" (
	echo.This feature is not available when Multi-Index servicing mode is enabled...
	echo.
	echo.Please Re-Choose Source with a Single Index...
	goto :Stop
)

:: Settings Windows Pre-Activation Details folder path
set "PreActTokens=%PreActTokens%\%SelectedSourceOS%\%ImageArchitecture%"

:: Getting Install Image Index Architecture
call :GetImageArchitecture "%InstallWim%", %ImageIndexNo% >nul

:: Checking whether Windows Pre-Activation Token data files exist
if not exist "%PreActTokens%\data.dat" if not exist "%PreActTokens%\cache.dat" if not exist "%PreActTokens%\tokens.dat" (
	echo.Windows Pre-Activation Token files folder ^<Packs\PreActTokens\%SelectedSourceOS%\%ImageArchitecture%^> is empty
	echo.
	choice /C:YN /N /M "Do you want to copy Activation files from System Folder? ['Y'es/'N'o] : "
	if errorlevel 2 (
		echo.
		echo.Please copy Pre-Activation Token files to respective folder...
		goto :Stop
	)
	if errorlevel 1 (
		echo.
		echo.Copying Pre-Activation Token files from ^<System32\Spp\store\2.0^>
		Xcopy /O /H /R /K /Y "%SystemRoot%\System32\spp\store\2.0\data.dat" %PreActTokens% >nul
		Xcopy /O /H /R /K /Y "%SystemRoot%\System32\spp\store\2.0\tokens.dat" %PreActTokens% >nul		
		Xcopy /O /H /R /K /Y "%SystemRoot%\System32\spp\store\2.0\cache\cache.dat" %PreActTokens% >nul
	)
)

cls
echo.===============================================================================
echo.           MSMG ToolKit - Integrate Windows 8.1 Pre-Activation Data
echo.===============================================================================
echo.
echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Windows 8.1 Pre-Activation Data#######################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.    Image Edition            : %ImageEdition%
echo.    Image Default Language   : %ImageDefaultLanguage% 
echo.
echo.-------------------------------------------------------------------------------
echo.####Getting Windows 8.1 Activation Product Key Details#########################
echo.-------------------------------------------------------------------------------
echo.
set /p ProductKey=Enter the Product Key with the '-'s : 
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Windows 8.1 Pre-Activation Data################################
echo.-------------------------------------------------------------------------------
echo.
echo.-------------------------------------------------------------------------------
echo.Integrating Windows 8.1 Product Key [%ProductKey%]...
echo.-------------------------------------------------------------------------------
%DISM% /Image:"%InstallMount%" /Set-ProductKey:%ProductKey%
echo.
echo.-------------------------------------------------------------------------------
echo.Integrating Windows 8.1 Pre-Activated Token files...
echo.-------------------------------------------------------------------------------
echo.
echo.Copying Windows 8.1 Pre-Activated Token files...
Xcopy /O /H /R /K /Y %PreActTokens%\tokens.dat "%InstallMount%\Windows\System32\spp\store\2.0"
Xcopy /O /H /R /K /Y %PreActTokens%\data.dat "%InstallMount%\Windows\System32\spp\store\2.0"
Xcopy /O /H /R /K /Y %PreActTokens%\cache.dat "%InstallMount%\Windows\System32\spp\store\2.0\cache"
echo.
echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Windows 8.1 Pre-Activation Data#######################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set PreActTokens=
set ProductKey=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Terminal Server Patch
::-------------------------------------------------------------------------------------------
:IntCustomTerminalServer

setlocal

cls
echo.===============================================================================
echo.          MSMG ToolKit - Integrate Microsoft Terminal Server Patch
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
if "%ImageIndexNo%" equ "*" call :GetImageArchitecture "%InstallWim%", 1 >nul
if "%ImageIndexNo%" neq "*" call :GetImageArchitecture "%InstallWim%", %ImageIndexNo% >nul

:: Setting Terminal Server path according to selected Source OS
set "CustomTerminalServer=%CustomTerminalServer%\%SelectedSourceOS%\%ImageArchitecture%"

:: Checking whether Microsoft Terminal Server Patch Pack file exist
if not exist "%CustomTerminalServer%\termsrv.dll" (
	echo.Microsoft Terminal Server Patch file "termsrv.dll" not found...
	echo.
	echo.Please copy the above file to ^<Custom\TerminalServer\%SelectedSourceOS%\%ImageArchitecture%^> folder...
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Microsoft Terminal Server Patch#######################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if "%ImageIndexNo%" equ "*" echo.    Image Indexes            : 1-%ImageCount%
if "%ImageIndexNo%" neq "*" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
if "%ImageIndexNo%" neq "*" echo.    Image Edition            : %ImageEdition%
echo.    Image Default Language   : %ImageDefaultLanguage%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Microsoft Terminal Server Patch################################
echo.-------------------------------------------------------------------------------
if "%ImageIndexNo%" equ "*" (
	for /L %%i in (1, 1, %ImageCount%) do (
		echo.
		if not %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]#############################
		if %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]############################
		echo.
		
		echo.Copying Patched Microsoft Terminal Server [termsrv.dll] file...
		echo.
		%XCopy% %CustomTerminalServer%\*.* "%InstallMount%\%%i\Windows\System32"
		echo.
		echo.-------------------------------------------------------------------------------
		echo.####Importing Microsoft Terminal Server Patch Registry Settings################
		echo.-------------------------------------------------------------------------------
		echo.
		echo.Mounting Image Registry...
		call :MountImageRegistry "%InstallMount%\%%i"

		echo.Importing Registry Settings to Image Registry...	
		Reg add "HKLM\TK_SYSTEM\ControlSet001\Control\Terminal Server" /v "fDenyTSConnections" /t REG_DWORD /d "0" /f >nul
		Reg add "HKLM\TK_SYSTEM\ControlSet001\Control\Terminal Server" /v "fSingleSessionPerUser" /t REG_DWORD /d "0" /f >nul
		
		echo.Un-Mounting Image Registry...		
		call :UnMountImageRegistry
		echo.
	)
) else (
	echo.
	echo.Copying Patched Microsoft Terminal Server [termsrv.dll] file...
	echo.
	%XCopy% %CustomTerminalServer%\*.* "%InstallMount%\Windows\System32"
	echo.
	echo.-------------------------------------------------------------------------------
	echo.####Importing Microsoft Terminal Server Patch Registry Settings################
	echo.-------------------------------------------------------------------------------
	echo.
	echo.Mounting Image Registry...
	call :MountImageRegistry "%InstallMount%"

	echo.Importing Registry Settings to Image Registry...	
	Reg add "HKLM\TK_SYSTEM\ControlSet001\Control\Terminal Server" /v "fDenyTSConnections" /t REG_DWORD /d "0" /f >nul
	Reg add "HKLM\TK_SYSTEM\ControlSet001\Control\Terminal Server" /v "fSingleSessionPerUser" /t REG_DWORD /d "0" /f >nul

	echo.Un-Mounting Image Registry...	
	call :UnMountImageRegistry
	echo.
)
echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Microsoft Terminal Server Patch#######################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set CustomTerminalServer=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Custom UxTheme Patch
::-------------------------------------------------------------------------------------------
:IntCustomUxTheme

setlocal

cls
echo.===============================================================================
echo.                MSMG ToolKit - Integrate Custom UxTheme Patch
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
if "%ImageIndexNo%" equ "*" call :GetImageArchitecture "%InstallWim%", 1 >nul
if "%ImageIndexNo%" neq "*" call :GetImageArchitecture "%InstallWim%", %ImageIndexNo% >nul

:: Setting Custom UxTheme Patch Pack files path according to selected Source OS
set "CustomUxTheme=%CustomUxTheme%\%SelectedSourceOS%\%ImageArchitecture%"

:: Checking whether Custom UxTheme Patch Pack file exist
if "%SelectedSourceOS%" equ "w7" (
	for %%i in (themeservice.dll, themeui.dll, uxtheme.dll) do (
		if not exist "%CustomUxTheme%\%%i" (
			echo.Custom UxTheme Patch file "%%i" not found...
			echo.
			echo.Please copy the above file to ^<Custom\UxTheme\%SelectedSourceOS%\%ImageArchitecture%^> folder...
			goto :Stop
		)
	)
)

:: Checking whether Custom UxTheme Patch Pack file exist
if "%SelectedSourceOS%" neq "w7" (
	for %%i in (themeui.dll, UXInit.dll, uxtheme.dll) do (
		if not exist "%CustomUxTheme%\%%i" (
			echo.Custom UxTheme Patch file "%%i" not found...
			echo.
			echo.Please copy the above file to ^<Custom\UxTheme\%SelectedSourceOS%\%ImageArchitecture%^> folder...
			goto :Stop
		)
	)
)
echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Custom UxTheme Patch##################################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if "%ImageIndexNo%" equ "*" echo.    Image Indexes            : 1-%ImageCount%
if "%ImageIndexNo%" neq "*" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
if "%ImageIndexNo%" neq "*" echo.    Image Edition            : %ImageEdition%
echo.    Image Default Language   : %ImageDefaultLanguage%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Custom UxTheme Patch###########################################
echo.-------------------------------------------------------------------------------
if "%ImageIndexNo%" equ "*" (
	for /L %%i in (1, 1, %ImageCount%) do (
		echo.
		if not %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]#############################
		if %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]############################
		echo.
		echo.Copying Custom UxTheme Patch files...
		echo.
		%XCopy% %CustomUxTheme%\*.* "%InstallMount%\%%i\Windows\System32"
	)
) else (
	echo.
	echo.Copying Custom UxTheme Patch files...
	echo.
	%XCopy% %CustomUxTheme%\*.* "%InstallMount%\Windows\System32"
)
echo.
echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Custom UxTheme Patch##################################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set CustomUxTheme=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Custom Windows Recovery Image
::-------------------------------------------------------------------------------------------
:IntCustomRecoveryImage

setlocal

cls
echo.===============================================================================
echo.          MSMG ToolKit - Integrate Custom Windows Recovery Image
echo.===============================================================================
echo.
:: Checking whether Multi-Index Servicing Mode is selected
if "%ImageIndexNo%" equ "*" (
	echo.This feature is not available when Multi-Index servicing mode is enabled...
	echo.
	echo.Please Re-Choose Source with a Single Index...
	goto :Stop
)

:: Checking whether Source Windows Recovery Image is selected
if "%IsRecoveryImageSelected%" equ "No" (
	echo.Windows Recovery Image is not selected...
	echo.
	echo.Please choose Windows Recovery Image while selecting Source...
	goto :Stop	
)

:: Checking whether the selected Source OS is a Windows Thin PC OS
if "%SelectedSourceOS%" equ "w7" if "%ImageEdition%" equ "Embedded" (
	echo.Windows Thin PC OS is not Supported...
	echo.
	echo.Please use Windows 7.x/8.1/10 Client/Server Edition OS as Source...
	goto :Stop
)

:: Getting Recovery Image Index Architecture
call :GetImageArchitecture "%InstallMount%\%WinReWim%", 1 >nul

:: Setting Custom Windows Recovery Image file path according to selected Source OS
set "RecoveryImage=%RecoveryImage%\%SelectedSourceOS%\%ImageArchitecture%"

:: Checking whether Custom Windows Recovery Image file exist
if not exist "%RecoveryImage%\winre.wim" (
	echo.Custom Windows Recovery Image file "winre.wim" not found...
	echo.
	echo.Please copy the above file to ^<Custom\RecoveryImage\%SelectedSourceOS%\%ImageArchitecture%^> folder...
	goto :Stop
)
echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Custom Windows Recovery Image#########################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : WinRE.wim
echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.    Image Edition            : %ImageEdition%
echo.    Image Default Language   : %ImageDefaultLanguage%
echo.
echo.-------------------------------------------------------------------------------
echo.####Un-Mounting, Mounted Windows Recovery Image################################
echo.-------------------------------------------------------------------------------
call :UnMountImage "%WinReMount%", "Discard"
echo.-------------------------------------------------------------------------------
echo.####Integrating Custom Windows Recovery Image##################################
echo.-------------------------------------------------------------------------------
echo.
echo.Copying Custom Windows Recovery Environment (WinRE) Image...
%XCopy% %RecoveryImage%\*.* "%InstallMount%\Windows\System32\Recovery" >nul
echo.
echo.-------------------------------------------------------------------------------
echo.####Re-Mounting Windows Recovery Image#########################################
echo.-------------------------------------------------------------------------------
call :MountImage "%InstallMount%\%WinReWim%", 1, "%WinReMount%"
echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Custom Windows Recovery Image#########################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set RecoveryImage=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Custom Default User Account Pictures
::-------------------------------------------------------------------------------------------
:IntUAP

setlocal

cls
echo.===============================================================================
echo.        MSMG ToolKit - Integrate Custom Default User Account Pictures
echo.===============================================================================
echo.

:: Setting Custom User Account Pictures path according to selected Source OS
set "UAP=%UAP%\%SelectedSourceOS%"

:: Checking whether Custom Default User Account Pictures Pack file exist
if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType%" neq "Server" (
	if not exist "%UAP%\user.bmp" (
		echo.Custom Default User Account Pictures Pack file "user.bmp" not found...
		echo.
		echo.Please copy the above file to ^<Packs\UAP\%SelectedSourceOS%^> folder...
		goto :Stop
	)
)

:: Checking whether Custom Default User Account Pictures Pack file exist
if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType%" equ "Server" (
	if not exist "%UAP%\user.bmp" (
		echo.Custom Default User Account Pictures Pack file "user.bmp" not found...
		echo.
		echo.Please copy the above file to ^<Packs\UAP\%SelectedSourceOS%^> folder...
		goto :Stop
	)
)

:: Checking whether Custom Default User Account Pictures Pack file exist
if "%SelectedSourceOS%" equ "w81" (
	for %%i in (guest.bmp, guest.png, user.bmp, user.png, user-40.png, user-200.png) do (
		if not exist "%UAP%\%%i" (
			echo.Custom Default User Account Pictures Pack file "%%i" not found...
			echo.
			echo.Please copy the above file to ^<Packs\UAP\%SelectedSourceOS%^> folder...
			goto :Stop
		)
	)
)

:: Checking whether Custom Default User Account Pictures Pack file exist
if "%SelectedSourceOS%" equ "w10" (
	for %%i in (guest.bmp, guest.png, user.bmp, user.png, user-32.png, user-40.png, user-48.png, user-192.png, user-200.png) do (
		if not exist "%UAP%\%%i" (
			echo.Custom Default User Account Pictures Pack file "%%i" not found...
			echo.
			echo.Please copy the above file to ^<Packs\UAP\%SelectedSourceOS%^> folder...
			goto :Stop
		)
	)
)

echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Custom Default User Account Pictures##################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if "%ImageIndexNo%" equ "*" echo.    Image Indexes            : 1-%ImageCount%
if "%ImageIndexNo%" neq "*" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
if "%ImageIndexNo%" neq "*" echo.    Image Edition            : %ImageEdition%
echo.    Image Default Language   : %ImageDefaultLanguage%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Custom Default User Account Pictures###########################
echo.-------------------------------------------------------------------------------
if "%ImageIndexNo%" equ "*" (
	for /L %%i in (1, 1, %ImageCount%) do (
		echo.
		if not %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]#############################
		if %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]############################
		echo.
		:: Checking whether the Selected Source OS is a Windows Server 2008 R2 Core Edition
		if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType%" equ "Server Core" (
			echo.This Feature is not available in Windows Server 2008 R2 Core Editions OS...
			echo.
		)

		if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType%" neq "Server Core" (
			echo.Copying Custom Default User Account Pictures files...
			echo.
			if "%ImageInstallationType%" neq "Server" %XCopy% %UAP%\*.* "%InstallMount%\%%i\ProgramData\Microsoft\User Account Pictures"
			if "%ImageInstallationType%" equ "Server" %XCopy% %UAP%\user.bmp "%InstallMount%\%%i\ProgramData\Microsoft\User Account Pictures"
		) 
		if "%SelectedSourceOS%" neq "w7" (
			echo.Copying Custom Default User Account Pictures files...
			echo.
			%XCopy% %UAP%\*.* "%InstallMount%\%%i\ProgramData\Microsoft\User Account Pictures"
		)
	)
) else (
	echo.
	:: Checking whether the Selected Source OS is a Windows Server 2008 R2 Core Edition
	if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType%" equ "Server Core" (
		echo.This Feature is not available in Windows Server 2008 R2 Core Editions OS...
		echo.
		echo.Please Choose Windows Server 2008 R2 Non Core Source OS..
		goto :Stop
	)

	if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType%" neq "Server Core" (
		echo.Copying Custom Default User Account Pictures files...
		echo.
		if "%ImageInstallationType%" neq "Server" %XCopy% %UAP%\*.* "%InstallMount%\ProgramData\Microsoft\User Account Pictures"
		if "%ImageInstallationType%" equ "Server" %XCopy% %UAP%\user.bmp "%InstallMount%\ProgramData\Microsoft\User Account Pictures"
	) 
	if "%SelectedSourceOS%" neq "w7" (
		echo.Copying Custom Default User Account Pictures files...
		echo.
		%XCopy% %UAP%\*.* "%InstallMount%\ProgramData\Microsoft\User Account Pictures"
	)
)
echo.
echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Custom Default User Account Pictures##################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set UAP=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Custom System Files
::-------------------------------------------------------------------------------------------
:IntCustomFiles

setlocal

cls
echo.===============================================================================
echo.                MSMG ToolKit - Integrate Custom System Files
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
if "%ImageIndexNo%" equ "*" call :GetImageArchitecture "%InstallWim%", 1 >nul
if "%ImageIndexNo%" neq "*" call :GetImageArchitecture "%InstallWim%", %ImageIndexNo% >nul

:: Setting Custom System files path according to selected Source OS
set "CustomFiles=%CustomFiles%\%SelectedSourceOS%\%ImageArchitecture%"

:: Checking whether Custom System files Pack file exist
for /f %%i in ('dir /b /s /a:-d "%CustomFiles%\*.*" 2^>nul ^| find /v /c ""') do (
	if "%%i" equ "0" (
		echo.Custom System files Pack folder is empty...
		echo.
		echo.Please copy the above file to ^<Custom\Files\%SelectedSourceOS%\%ImageArchitecture%^> folder...
		goto :Stop
	)
)

echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Custom System Files###################################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if "%ImageIndexNo%" equ "*" echo.    Image Indexes            : 1-%ImageCount%
if "%ImageIndexNo%" neq "*" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
if "%ImageIndexNo%" neq "*" echo.    Image Edition            : %ImageEdition%
echo.    Image Default Language   : %ImageDefaultLanguage%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Custom System Files############################################
echo.-------------------------------------------------------------------------------
if "%ImageIndexNo%" equ "*" (
	for /L %%i in (1, 1, %ImageCount%) do (
		echo.
		if not %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]#############################
		if %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]############################
		echo.
		echo.Copying Custom System files...
		echo.
		%XCopy% %CustomFiles%\*.* "%InstallMount%\%%i"
	)
) else (
	echo.
	echo.Copying Custom System files...
	echo.
	%XCopy% %CustomFiles%\*.* "%InstallMount%"
)
echo.
echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Custom System Files###################################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set CustomFiles=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Microsoft Win32Calc Metro Skin
::-------------------------------------------------------------------------------------------
:IntWin32CalcMetroSkin

setlocal

cls
echo.===============================================================================
echo.          MSMG ToolKit - Integrate Microsoft Win32Calc Metro Skin
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
if "%ImageIndexNo%" equ "*" call :GetImageArchitecture "%InstallWim%", 1 >nul
if "%ImageIndexNo%" neq "*" call :GetImageArchitecture "%InstallWim%", %ImageIndexNo% >nul

set "Skins=%Skins%\Win32Calc"

:: Checking whether Microsoft Win32Calc Metro Skin Pack file exist
if not exist "%Skins%\Win32Calc.exe.res" (
	echo.Microsoft Win32Calc Metro Skin Pack file "Win32Calc.exe.res" not found...
	echo.
	echo.Please copy the above file to ^<Packs\Skins\Win32Calc^> folder...
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Microsoft Win32Calc Metro Skin########################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if "%ImageIndexNo%" equ "*" echo.    Image Indexes            : 1-%ImageCount%
if "%ImageIndexNo%" neq "*" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
if "%ImageIndexNo%" neq "*" echo.    Image Edition            : %ImageEdition%
echo.    Image Default Language   : %ImageDefaultLanguage%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Microsoft Win32Calc Metro Skin#################################
echo.-------------------------------------------------------------------------------

copy /y %ResourceHacker% %Temp% >nul

if "%ImageIndexNo%" equ "*" (
	for /L %%i in (1, 1, %ImageCount%) do (
		echo.
		if not %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]#############################
		if %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]############################
		echo.
		echo.Copying Microsoft Win32Calc files to Temporary Folder...
		if "%ImageArchitecture%" equ "x86" copy "%InstallMount%\%%i\Windows\System32\Win32Calc.exe" "%Temp%\Win32Calc_x.exe" >nul
		if "%ImageArchitecture%" equ "x64" (
			copy "%InstallMount%\%%i\Windows\System32\Win32Calc.exe" "%Temp%\Win32Calc64_x.exe" >nul
			copy "%InstallMount%\%%i\Windows\SysWOW64\Win32Calc.exe" "%Temp%\Win32Calc32_x.exe" >nul
		)

		echo.
		echo.Applying Microsoft Win32Calc Metro Skin to [Win32Calc.exe] file...
		if "%ImageArchitecture%" equ "x86" (		
			"%Temp%\ResourceHacker.exe" -addoverwrite "%Temp%\Win32Calc_x.exe", "%Temp%\Win32Calc.exe", "%Skins%\Win32Calc.exe.res" ,,,
			call :RemoveFile "%Temp%\Win32Calc_x.exe"
		)

		if "%ImageArchitecture%" equ "x64" (
			"%Temp%\ResourceHacker.exe" -addoverwrite "%Temp%\Win32Calc32_x.exe", "%Temp%\Win32Calc32.exe", "%Skins%\Win32Calc.exe.res" ,,,
			call :RemoveFile "%Temp%\Win32Calc32_x.exe"
			"%Temp%\ResourceHacker.exe" -addoverwrite "%Temp%\Win32Calc64_x.exe", "%Temp%\Win32Calc64.exe", "%Skins%\Win32Calc.exe.res" ,,,
			call :RemoveFile "%Temp%\Win32Calc64_x.exe"
		)

		echo.
		echo.Copying Patched Microsoft Win32Calc files...
		if "%ImageArchitecture%" equ "x86" move /y "%Temp%\Win32Calc.exe" "%InstallMount%\%%i\Windows\System32\Win32Calc.exe" >nul
		if "%ImageArchitecture%" equ "x64" (
			move /y "%Temp%\Win32Calc64.exe" "%InstallMount%\%%i\Windows\System32\Win32Calc.exe" >nul
			move /y "%Temp%\Win32Calc32.exe" "%InstallMount%\%%i\Windows\SysWOW64\Win32Calc.exe" >nul	
		)
	)
) else (
	echo.
	echo.Copying Microsoft Win32Calc files to Temporary Folder...
	if "%ImageArchitecture%" equ "x86" copy "%InstallMount%\Windows\System32\Win32Calc.exe" "%Temp%\Win32Calc_x.exe" >nul
	if "%ImageArchitecture%" equ "x64" (
		copy "%InstallMount%\Windows\System32\Win32Calc.exe" "%Temp%\Win32Calc64_x.exe" >nul
		copy "%InstallMount%\Windows\SysWOW64\Win32Calc.exe" "%Temp%\Win32Calc32_x.exe" >nul
	)

	echo.
	echo.Applying Microsoft Win32Calc Metro Skin to [Win32Calc.exe] file...
	if "%ImageArchitecture%" equ "x86" (		
		"%Temp%\ResourceHacker.exe" -addoverwrite "%Temp%\Win32Calc_x.exe", "%Temp%\Win32Calc.exe", "%Skins%\Win32Calc.exe.res" ,,,
		call :RemoveFile "%Temp%\Win32Calc_x.exe"
	)

	if "%ImageArchitecture%" equ "x64" (
		"%Temp%\ResourceHacker.exe" -addoverwrite "%Temp%\Win32Calc32_x.exe", "%Temp%\Win32Calc32.exe", "%Skins%\Win32Calc.exe.res" ,,,
		call :RemoveFile "%Temp%\Win32Calc32_x.exe"
		"%Temp%\ResourceHacker.exe" -addoverwrite "%Temp%\Win32Calc64_x.exe", "%Temp%\Win32Calc64.exe", "%Skins%\Win32Calc.exe.res" ,,,
		call :RemoveFile "%Temp%\Win32Calc64_x.exe"
	)

	echo.
	echo.Copying Patched Microsoft Win32Calc files...
	if "%ImageArchitecture%" equ "x86" move /y "%Temp%\Win32Calc.exe" "%InstallMount%\Windows\System32\Win32Calc.exe" >nul
	if "%ImageArchitecture%" equ "x64" (
		move /y "%Temp%\Win32Calc64.exe" "%InstallMount%\Windows\System32\Win32Calc.exe" >nul
		move /y "%Temp%\Win32Calc32.exe" "%InstallMount%\Windows\SysWOW64\Win32Calc.exe" >nul	
	)
)

call :RemoveFile "%Temp%\ResourceHacker.exe"
call :RemoveFile "%Temp%\ResourceHacker.ini"
call :RemoveFile "%Temp%\ResourceHacker.log"
echo.
echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Microsoft Win32Calc Metro Skin########################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set Skins=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Windows Photo Viewer Metro Skin
::-------------------------------------------------------------------------------------------
:IntWPVMetroSkin

setlocal

cls
echo.===============================================================================
echo.          MSMG ToolKit - Integrate Windows Photo Viewer Metro Skin
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
if "%ImageIndexNo%" equ "*" call :GetImageArchitecture "%InstallWim%", 1 >nul
if "%ImageIndexNo%" neq "*" call :GetImageArchitecture "%InstallWim%", %ImageIndexNo% >nul

set "Skins=%Skins%\PhotoViewer"

:: Checking whether Windows Photo Viewer Metro Skin Pack file exist
for %%i in (PhotoViewer.dll.res, photowiz.dll.res) do (
	if not exist "%Skins%\%%i" (
		echo.Windows Photo Viewer Metro Skin Pack file "%%i" not found...
		echo.
		echo.Please copy the above file to ^<Packs\Skins\PhotoViewer^> folder...
		goto :Stop
	)
)

echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Windows Photo Viewer Metro Skin#######################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if "%ImageIndexNo%" equ "*" echo.    Image Indexes            : 1-%ImageCount%
if "%ImageIndexNo%" neq "*" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
if "%ImageIndexNo%" neq "*" echo.    Image Edition            : %ImageEdition%
echo.    Image Default Language   : %ImageDefaultLanguage%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Windows Photo Viewer Metro Skin################################
echo.-------------------------------------------------------------------------------

copy /y %ResourceHacker% %Temp% >nul

if "%ImageIndexNo%" equ "*" (
	for /L %%i in (1, 1, %ImageCount%) do (
		echo.
		if not %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]#############################
		if %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]############################
		echo.
		echo.Copying Windows Photo Viewer files to Temporary Folder...
		if "%ImageArchitecture%" equ "x86" (
			copy "%InstallMount%\%%i\Program Files\Windows Photo Viewer\PhotoViewer.dll" "%Temp%\PhotoViewer_x.dll" >nul
			copy "%InstallMount%\%%i\Windows\System32\photowiz.dll" "%Temp%\photowiz_x.dll" >nul
		)
		if "%ImageArchitecture%" equ "x64" (
			copy "%InstallMount%\%%i\Program Files\Windows Photo Viewer\PhotoViewer.dll" "%Temp%\PhotoViewer64_x.dll" >nul
			copy "%InstallMount%\%%i\Program Files (x86)\Windows Photo Viewer\PhotoViewer.dll" "%Temp%\PhotoViewer32_x.dll" >nul
			copy "%InstallMount%\%%i\Windows\System32\photowiz.dll" "%Temp%\photowiz64_x.dll" >nul
			copy "%InstallMount%\%%i\Windows\SysWOW64\photowiz.dll" "%Temp%\photowiz32_x.dll" >nul
		)

		echo.
		if "%ImageArchitecture%" equ "x86" (		
			echo.Applying Windows Photo Viewer Metro Skin to [PhotoViewer.dll] file...
			"%Temp%\ResourceHacker.exe" -addoverwrite "%Temp%\PhotoViewer_x.dll", "%Temp%\PhotoViewer.dll", "%Skins%\PhotoViewer.dll.res" ,,,
			call :RemoveFile "%Temp%\PhotoViewer_x.dll"
			echo.
			echo.Applying Windows Photo Viewer Metro Skin to [photowiz.dll] file...
			"%Temp%\ResourceHacker.exe" -addoverwrite "%Temp%\photowiz_x.dll", "%Temp%\photowiz.dll", "%Skins%\photowiz.dll.res" ,,,
			call :RemoveFile "%Temp%\photowiz_x.dll"
		)

		if "%ImageArchitecture%" equ "x64" (
			echo.Applying Windows Photo Viewer Metro Skin to [PhotoViewer.dll] file...
			"%Temp%\ResourceHacker.exe" -addoverwrite "%Temp%\PhotoViewer32_x.dll", "%Temp%\PhotoViewer32.dll", "%Skins%\PhotoViewer.dll.res" ,,,
			call :RemoveFile "%Temp%\PhotoViewer32_x.dll"
			"%Temp%\ResourceHacker.exe" -addoverwrite "%Temp%\PhotoViewer64_x.dll", "%Temp%\PhotoViewer64.dll", "%Skins%\PhotoViewer.dll.res" ,,,
			call :RemoveFile "%Temp%\PhotoViewer64_x.dll"
			echo.
			echo.Applying Windows Photo Viewer Metro Skin to [photowiz.dll] file...
			"%Temp%\ResourceHacker.exe" -addoverwrite "%Temp%\photowiz32_x.dll", "%Temp%\photowiz32.dll", "%Skins%\photowiz.dll.res" ,,,
			call :RemoveFile "%Temp%\photowiz32_x.dll"
			"%Temp%\ResourceHacker.exe" -addoverwrite "%Temp%\photowiz64_x.dll", "%Temp%\photowiz64.dll", "%Skins%\photowiz.dll.res" ,,,
			call :RemoveFile "%Temp%\photowiz64_x.dll"
		)

		echo.
		echo.Copying Patched Windows Photo Viewer files...
		if "%ImageArchitecture%" equ "x86" (
			move /y "%Temp%\PhotoViewer.dll" "%InstallMount%\%%i\Program Files\Windows Photo Viewer\PhotoViewer.dll" >nul
			move /y "%Temp%\photowiz.dll" "%InstallMount%\%%i\Windows\System32\photowiz.dll" >nul
		)
		if "%ImageArchitecture%" equ "x64" (
			move /y "%Temp%\PhotoViewer64.dll" "%InstallMount%\%%i\Program Files\Windows Photo Viewer\PhotoViewer.dll" >nul
			move /y "%Temp%\PhotoViewer32.dll" "%InstallMount%\%%i\Program Files (x86)\Windows Photo Viewer\PhotoViewer.dll" >nul
			move /y "%Temp%\photowiz64.dll" "%InstallMount%\%%i\Windows\System32\photowiz.dll" >nul
			move /y "%Temp%\photowiz32.dll" "%InstallMount%\%%i\Windows\SysWOW64\photowiz.dll" >nul	
		)
	)
) else (
	echo.
	echo.Copying Windows Photo Viewer files to Temporary Folder...
	if "%ImageArchitecture%" equ "x86" (
		copy "%InstallMount%\Program Files\Windows Photo Viewer\PhotoViewer.dll" "%Temp%\PhotoViewer_x.dll" >nul
		copy "%InstallMount%\Windows\System32\photowiz.dll" "%Temp%\photowiz_x.dll" >nul
	)
	if "%ImageArchitecture%" equ "x64" (
		copy "%InstallMount%\Program Files\Windows Photo Viewer\PhotoViewer.dll" "%Temp%\PhotoViewer64_x.dll" >nul
		copy "%InstallMount%\Program Files (x86)\Windows Photo Viewer\PhotoViewer.dll" "%Temp%\PhotoViewer32_x.dll" >nul
		copy "%InstallMount%\Windows\System32\photowiz.dll" "%Temp%\photowiz64_x.dll" >nul
		copy "%InstallMount%\Windows\SysWOW64\photowiz.dll" "%Temp%\photowiz32_x.dll" >nul
	)

	echo.
	if "%ImageArchitecture%" equ "x86" (		
		echo.Applying Windows Photo Viewer Metro Skin to [PhotoViewer.dll] file...
		"%Temp%\ResourceHacker.exe" -addoverwrite "%Temp%\PhotoViewer_x.dll", "%Temp%\PhotoViewer.dll", "%Skins%\PhotoViewer.dll.res" ,,,
		call :RemoveFile "%Temp%\PhotoViewer_x.dll"
		echo.
		echo.Applying Windows Photo Viewer Metro Skin to [photowiz.dll] file...
		"%Temp%\ResourceHacker.exe" -addoverwrite "%Temp%\photowiz_x.dll", "%Temp%\photowiz.dll", "%Skins%\photowiz.dll.res" ,,,
		call :RemoveFile "%Temp%\photowiz_x.dll"
	)

	if "%ImageArchitecture%" equ "x64" (
		echo.Applying Windows Photo Viewer Metro Skin to [PhotoViewer.dll] file...
		"%Temp%\ResourceHacker.exe" -addoverwrite "%Temp%\PhotoViewer32_x.dll", "%Temp%\PhotoViewer32.dll", "%Skins%\PhotoViewer.dll.res" ,,,
		call :RemoveFile "%Temp%\PhotoViewer32_x.dll"
		"%Temp%\ResourceHacker.exe" -addoverwrite "%Temp%\PhotoViewer64_x.dll", "%Temp%\PhotoViewer64.dll", "%Skins%\PhotoViewer.dll.res" ,,,
		call :RemoveFile "%Temp%\PhotoViewer64_x.dll"
		echo.
		echo.Applying Windows Photo Viewer Metro Skin to [photowiz.dll] file...
		"%Temp%\ResourceHacker.exe" -addoverwrite "%Temp%\photowiz32_x.dll", "%Temp%\photowiz32.dll", "%Skins%\photowiz.dll.res" ,,,
		call :RemoveFile "%Temp%\photowiz32_x.dll"
		"%Temp%\ResourceHacker.exe" -addoverwrite "%Temp%\photowiz64_x.dll", "%Temp%\photowiz64.dll", "%Skins%\photowiz.dll.res" ,,,
		call :RemoveFile "%Temp%\photowiz64_x.dll"
	)

	echo.
	echo.Copying Patched Windows Photo Viewer files...
	if "%ImageArchitecture%" equ "x86" (
		move /y "%Temp%\PhotoViewer.dll" "%InstallMount%\Program Files\Windows Photo Viewer\PhotoViewer.dll" >nul
		move /y "%Temp%\photowiz.dll" "%InstallMount%\Windows\System32\photowiz.dll" >nul
	)
	if "%ImageArchitecture%" equ "x64" (
		move /y "%Temp%\PhotoViewer64.dll" "%InstallMount%\Program Files\Windows Photo Viewer\PhotoViewer.dll" >nul
		move /y "%Temp%\PhotoViewer32.dll" "%InstallMount%\Program Files (x86)\Windows Photo Viewer\PhotoViewer.dll" >nul
		move /y "%Temp%\photowiz64.dll" "%InstallMount%\Windows\System32\photowiz.dll" >nul
		move /y "%Temp%\photowiz32.dll" "%InstallMount%\Windows\SysWOW64\photowiz.dll" >nul	
	)
)

call :RemoveFile "%Temp%\ResourceHacker.exe"
call :RemoveFile "%Temp%\ResourceHacker.ini"
call :RemoveFile "%Temp%\ResourceHacker.log"

echo.
echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Windows Photo Viewer Metro Skin#######################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set Skins=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Windows Media Player Metro Skin
::-------------------------------------------------------------------------------------------
:IntWMPMetroSkin

setlocal

cls
echo.===============================================================================
echo.          MSMG ToolKit - Integrate Windows Media Player Metro Skin
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
if "%ImageIndexNo%" equ "*" call :GetImageArchitecture "%InstallWim%", 1 >nul
if "%ImageIndexNo%" neq "*" call :GetImageArchitecture "%InstallWim%", %ImageIndexNo% >nul

set "Skins=%Skins%\MediaPlayer"

:: Checking whether Windows Media Player Metro Skin Pack file exist
for %%i in (setup_wm.exe.res, wmpconfig.exe.res, wmplayer.exe.res, wmploc.dll.res, wmpshare.exe.res, WMPSideShowGadget.exe.res) do (
	if not exist "%Skins%\%%i" (
		echo.Windows Media Player Metro Skin Pack file "%%i" not found...
		echo.
		echo.Please copy the above file to ^<Packs\Skins\MediaPlayer^> folder...
		goto :Stop
	)
)

echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Windows Media Player Metro Skin#######################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if "%ImageIndexNo%" equ "*" echo.    Image Indexes            : 1-%ImageCount%
if "%ImageIndexNo%" neq "*" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
if "%ImageIndexNo%" neq "*" echo.    Image Edition            : %ImageEdition%
echo.    Image Default Language   : %ImageDefaultLanguage%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Windows Media Player Metro Skin################################
echo.-------------------------------------------------------------------------------

copy /y %ResourceHacker% %Temp% >nul

if "%ImageIndexNo%" equ "*" (
	for /L %%i in (1, 1, %ImageCount%) do (
		echo.
		if not %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]#############################
		if %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]############################
		echo.
		echo.Copying Windows Media Player files to Temporary Folder...
		if "%ImageArchitecture%" equ "x86" (
			copy "%InstallMount%\%%i\Program Files\Windows Media Player\setup_wm.exe" "%Temp%\setup_wm_x.exe" >nul
			copy "%InstallMount%\%%i\Program Files\Windows Media Player\wmpconfig.exe" "%Temp%\wmpconfig_x.exe" >nul
			copy "%InstallMount%\%%i\Program Files\Windows Media Player\wmplayer.exe" "%Temp%\wmplayer_x.exe" >nul
			copy "%InstallMount%\%%i\Program Files\Windows Media Player\wmpshare.exe" "%Temp%\wmpshare_x.exe" >nul
			if exist "%InstallMount%\%%i\Program Files\Windows Media Player\WMPSideShowGadget.exe" copy "%InstallMount%\%%i\Program Files\Windows Media Player\WMPSideShowGadget.exe" "%Temp%\WMPSideShowGadget_x.exe" >nul
			copy "%InstallMount%\%%i\Windows\System32\wmploc.dll" "%Temp%\wmploc_x.dll" >nul
		)
		if "%ImageArchitecture%" equ "x64" (
			copy "%InstallMount%\%%i\Program Files\Windows Media Player\setup_wm.exe" "%Temp%\setup_wm_x.exe" >nul
			copy "%InstallMount%\%%i\Program Files\Windows Media Player\wmpconfig.exe" "%Temp%\wmpconfig_x.exe" >nul
			copy "%InstallMount%\%%i\Program Files\Windows Media Player\wmplayer.exe" "%Temp%\wmplayer_x.exe" >nul
			copy "%InstallMount%\%%i\Program Files\Windows Media Player\wmpshare.exe" "%Temp%\wmpshare_x.exe" >nul
			if exist "%InstallMount%\%%i\Program Files\Windows Media Player\WMPSideShowGadget.exe" copy "%InstallMount%\%%i\Program Files\Windows Media Player\WMPSideShowGadget.exe" "%Temp%\WMPSideShowGadget_x.exe" >nul
			copy "%InstallMount%\%%i\Windows\System32\wmploc.dll" "%Temp%\wmploc64_x.dll" >nul
			copy "%InstallMount%\%%i\Windows\SysWOW64\wmploc.dll" "%Temp%\wmploc32_x.dll" >nul		
		)

		echo.		
		echo.Applying Windows Media Player Metro Skin to [setup_wm.exe] file...
		"%Temp%\ResourceHacker.exe" -addoverwrite "%Temp%\setup_wm_x.exe", "%Temp%\setup_wm.exe", "%Skins%\setup_wm.exe.res" ,,,
		call :RemoveFile "%Temp%\setup_wm_x.exe"		
		echo.Applying Windows Media Player Metro Skin to [wmpconfig.exe] file...
		"%Temp%\ResourceHacker.exe" -addoverwrite "%Temp%\wmpconfig_x.exe", "%Temp%\wmpconfig.exe", "%Skins%\wmpconfig.exe.res" ,,,
		call :RemoveFile "%Temp%\wmpconfig_x.exe"
		echo.Applying Windows Media Player Metro Skin to [wmplayer.exe] file...
		"%Temp%\ResourceHacker.exe" -addoverwrite "%Temp%\wmplayer_x.exe", "%Temp%\wmplayer.exe", "%Skins%\wmplayer.exe.res" ,,,
		call :RemoveFile "%Temp%\wmplayer_x.exe"		
		echo.Applying Windows Media Player Metro Skin to [wmpshare.exe] file...
		"%Temp%\ResourceHacker.exe" -addoverwrite "%Temp%\wmpshare_x.exe", "%Temp%\wmpshare.exe", "%Skins%\wmpshare.exe.res" ,,,
		call :RemoveFile "%Temp%\wmpshare_x.exe"
		
		if exist "%Temp%\WMPSideShowGadget_x.exe" (
			echo.Applying Windows Media Player Metro Skin to [WMPSideShowGadget.exe] file...
			"%Temp%\ResourceHacker.exe" -addoverwrite "%Temp%\WMPSideShowGadget_x.exe", "%Temp%\WMPSideShowGadget.exe", "%Skins%\WMPSideShowGadget.exe.res" ,,,
			call :RemoveFile "%Temp%\WMPSideShowGadget_x.exe"
		)
		
		if "%ImageArchitecture%" equ "x86" (
			echo.Applying Windows Media Player Metro Skin to [wmploc.dll] file...
			"%Temp%\ResourceHacker.exe" -addoverwrite "%Temp%\wmploc_x.dll", "%Temp%\wmploc.dll", "%Skins%\wmploc.dll.res" ,,,
			call :RemoveFile "%Temp%\wmploc_x.dll"
		)

		if "%ImageArchitecture%" equ "x64" (
			echo.Applying Windows Media Player Metro Skin to [wmploc.dll] file...
			"%Temp%\ResourceHacker.exe" -addoverwrite "%Temp%\wmploc32_x.dll", "%Temp%\wmploc32.dll", "%Skins%\wmploc.dll.res" ,,,
			call :RemoveFile "%Temp%\wmploc32_x.dll"
			"%Temp%\ResourceHacker.exe" -addoverwrite "%Temp%\wmploc64_x.dll", "%Temp%\wmploc64.dll", "%Skins%\wmploc.dll.res" ,,,
			call :RemoveFile "%Temp%\wmploc64_x.dll"
		)

		echo.
		echo.Copying Patched Windows Media Player files...
		move /y "%Temp%\setup_wm.exe" "%InstallMount%\%%i\Program Files\Windows Media Player\setup_wm.exe" >nul
		move /y "%Temp%\wmpconfig.exe" "%InstallMount%\%%i\Program Files\Windows Media Player\wmpconfig.exe" >nul
		move /y "%Temp%\wmplayer.exe" "%InstallMount%\%%i\Program Files\Windows Media Player\wmplayer.exe" >nul
		move /y "%Temp%\wmpshare.exe" "%InstallMount%\%%i\Program Files\Windows Media Player\wmpshare.exe" >nul
		if exist "%Temp%\WMPSideShowGadget.exe" move /y "%Temp%\WMPSideShowGadget.exe" "%InstallMount%\%%i\Program Files\Windows Media Player\WMPSideShowGadget.exe" >nul
		if "%ImageArchitecture%" equ "x86" move /y "%Temp%\wmploc.dll" "%InstallMount%\%%i\Windows\System32\wmploc.dll" >nul
		if "%ImageArchitecture%" equ "x64" move /y "%Temp%\wmploc64.dll" "%InstallMount%\%%i\Windows\System32\wmploc.dll" >nul
		if "%ImageArchitecture%" equ "x64" move /y "%Temp%\wmploc32.dll" "%InstallMount%\%%i\Windows\SysWOW64\wmploc.dll" >nul
	)
) else (
	echo.
	echo.Copying Windows Media Player files to Temporary Folder...
	if "%ImageArchitecture%" equ "x86" (
		copy "%InstallMount%\Program Files\Windows Media Player\setup_wm.exe" "%Temp%\setup_wm_x.exe" >nul
		copy "%InstallMount%\Program Files\Windows Media Player\wmpconfig.exe" "%Temp%\wmpconfig_x.exe" >nul
		copy "%InstallMount%\Program Files\Windows Media Player\wmplayer.exe" "%Temp%\wmplayer_x.exe" >nul
		copy "%InstallMount%\Program Files\Windows Media Player\wmpshare.exe" "%Temp%\wmpshare_x.exe" >nul
		if exist "%InstallMount%\Program Files\Windows Media Player\WMPSideShowGadget.exe" copy "%InstallMount%\Program Files\Windows Media Player\WMPSideShowGadget.exe" "%Temp%\WMPSideShowGadget_x.exe" >nul
		copy "%InstallMount%\Windows\System32\wmploc.dll" "%Temp%\wmploc_x.dll" >nul
	)
	if "%ImageArchitecture%" equ "x64" (
		copy "%InstallMount%\Program Files\Windows Media Player\setup_wm.exe" "%Temp%\setup_wm_x.exe" >nul
		copy "%InstallMount%\Program Files\Windows Media Player\wmpconfig.exe" "%Temp%\wmpconfig_x.exe" >nul
		copy "%InstallMount%\Program Files\Windows Media Player\wmplayer.exe" "%Temp%\wmplayer_x.exe" >nul
		copy "%InstallMount%\Program Files\Windows Media Player\wmpshare.exe" "%Temp%\wmpshare_x.exe" >nul
		if exist "%InstallMount%\Program Files\Windows Media Player\WMPSideShowGadget.exe" copy "%InstallMount%\Program Files\Windows Media Player\WMPSideShowGadget.exe" "%Temp%\WMPSideShowGadget_x.exe" >nul
		copy "%InstallMount%\Windows\System32\wmploc.dll" "%Temp%\wmploc64_x.dll" >nul
		copy "%InstallMount%\Windows\SysWOW64\wmploc.dll" "%Temp%\wmploc32_x.dll" >nul		
	)

	echo.		
	echo.Applying Windows Media Player Metro Skin to [setup_wm.exe] file...
	"%Temp%\ResourceHacker.exe" -addoverwrite "%Temp%\setup_wm_x.exe", "%Temp%\setup_wm.exe", "%Skins%\setup_wm.exe.res" ,,,
	call :RemoveFile "%Temp%\setup_wm_x.exe"		
	echo.Applying Windows Media Player Metro Skin to [wmpconfig.exe] file...
	"%Temp%\ResourceHacker.exe" -addoverwrite "%Temp%\wmpconfig_x.exe", "%Temp%\wmpconfig.exe", "%Skins%\wmpconfig.exe.res" ,,,
	call :RemoveFile "%Temp%\wmpconfig_x.exe"
	echo.Applying Windows Media Player Metro Skin to [wmplayer.exe] file...
	"%Temp%\ResourceHacker.exe" -addoverwrite "%Temp%\wmplayer_x.exe", "%Temp%\wmplayer.exe", "%Skins%\wmplayer.exe.res" ,,,
	call :RemoveFile "%Temp%\wmplayer_x.exe"		
	echo.Applying Windows Media Player Metro Skin to [wmpshare.exe] file...
	"%Temp%\ResourceHacker.exe" -addoverwrite "%Temp%\wmpshare_x.exe", "%Temp%\wmpshare.exe", "%Skins%\wmpshare.exe.res" ,,,
	call :RemoveFile "%Temp%\wmpshare_x.exe"
	
	if exist "%Temp%\WMPSideShowGadget_x.exe" (
		echo.Applying Windows Media Player Metro Skin to [WMPSideShowGadget.exe] file...
		"%Temp%\ResourceHacker.exe" -addoverwrite "%Temp%\WMPSideShowGadget_x.exe", "%Temp%\WMPSideShowGadget.exe", "%Skins%\WMPSideShowGadget.exe.res" ,,,
		call :RemoveFile "%Temp%\WMPSideShowGadget_x.exe"
	)
	
	if "%ImageArchitecture%" equ "x86" (
		echo.Applying Windows Media Player Metro Skin to [wmploc.dll] file...
		"%Temp%\ResourceHacker.exe" -addoverwrite "%Temp%\wmploc_x.dll", "%Temp%\wmploc.dll", "%Skins%\wmploc.dll.res" ,,,
		call :RemoveFile "%Temp%\wmploc_x.dll"
	)

	if "%ImageArchitecture%" equ "x64" (
		echo.Applying Windows Media Player Metro Skin to [wmploc.dll] file...
		"%Temp%\ResourceHacker.exe" -addoverwrite "%Temp%\wmploc32_x.dll", "%Temp%\wmploc32.dll", "%Skins%\wmploc.dll.res" ,,,
		call :RemoveFile "%Temp%\wmploc32_x.dll"
		"%Temp%\ResourceHacker.exe" -addoverwrite "%Temp%\wmploc64_x.dll", "%Temp%\wmploc64.dll", "%Skins%\wmploc.dll.res" ,,,
		call :RemoveFile "%Temp%\wmploc64_x.dll"
	)

	echo.
	echo.Copying Patched Windows Media Player files...
	move /y "%Temp%\setup_wm.exe" "%InstallMount%\Program Files\Windows Media Player\setup_wm.exe" >nul
	move /y "%Temp%\wmpconfig.exe" "%InstallMount%\Program Files\Windows Media Player\wmpconfig.exe" >nul
	move /y "%Temp%\wmplayer.exe" "%InstallMount%\Program Files\Windows Media Player\wmplayer.exe" >nul
	move /y "%Temp%\wmpshare.exe" "%InstallMount%\Program Files\Windows Media Player\wmpshare.exe" >nul
	if exist "%Temp%\WMPSideShowGadget.exe" move /y "%Temp%\WMPSideShowGadget.exe" "%InstallMount%\Program Files\Windows Media Player\WMPSideShowGadget.exe" >nul
	if "%ImageArchitecture%" equ "x86" move /y "%Temp%\wmploc.dll" "%InstallMount%\Windows\System32\wmploc.dll" >nul
	if "%ImageArchitecture%" equ "x64" move /y "%Temp%\wmploc64.dll" "%InstallMount%\Windows\System32\wmploc.dll" >nul
	if "%ImageArchitecture%" equ "x64" move /y "%Temp%\wmploc32.dll" "%InstallMount%\Windows\SysWOW64\wmploc.dll" >nul
)

call :RemoveFile "%Temp%\ResourceHacker.exe"
call :RemoveFile "%Temp%\ResourceHacker.ini"
call :RemoveFile "%Temp%\ResourceHacker.log"

echo.
echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Windows Media Player Metro Skin#######################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set Skins=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Remove Windows Components
::-------------------------------------------------------------------------------------------
:RemoveWindowsComponentsMenu

setlocal
set Component=

cls
echo.===============================================================================
echo.                  MSMG ToolKit - Remove Windows Components
echo.===============================================================================
echo.

:: Checking whether the selected Source OS is a Windows 10 v1809 Client Non-refreshed Image
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "17763" if "%ImageServicePackBuild%" neq "1" (
	echo.ToolKit component removal only work with the below Source OS Images...
	echo.
	echo.Windows 10 v1809 ^(10.0.17763.1^) Source OS.
	goto :Stop	
)

:: Checking whether the selected Source OS is a Windows 10 v1903/v1909 Client Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "18362" if "%ImageBuild%" leq "18363" if "%ImageServicePackBuild%" lss "418" (
	echo.ToolKit component removal only work with the below Source OS Images...
	echo.
	echo.Windows 10 v1909 ^(10.0.18363.418^) Source OS.
	goto :Stop	
)

:: Checking whether the selected Source OS is a Windows 10 v2004 Client Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "19041" if "%ImageServicePackBuild%" lss "208" (
	echo.ToolKit component removal only work with the below Source OS Images...
	echo.
	echo.Windows 10 v2004 ^(10.0.19041.208^) Source OS.
	goto :Stop	
)

:: Remove Windows 10 v1809/v1903/v1909/v2004 Client Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "17763" if "%ImageBuild%" leq "19041" (
	cls
	echo.===============================================================================
	echo.                 MSMG ToolKit - Remove Windows Components Menu
	echo.===============================================================================
	echo.
	echo.  [1]  Internet
	echo.
	echo.  [2]  Multimedia
	echo.
	echo.  [3]  Privacy
	echo.
	echo.  [4]  Remoting
	echo.
	echo.  [5]  System
	echo.
	echo.  [6]  System Apps
	echo.
	echo.  [7]  Windows Apps
	echo.
	echo.
	echo.  [X]   Go Back
	echo.
	echo.===============================================================================
	echo.
	choice /C:1234567X /N /M "Enter Your Choice : "
	if errorlevel 8 goto :RemoveMenu
	if errorlevel 7 goto :RemoveWindowsAppsMenu
	if errorlevel 6 goto :RemoveSystemAppsMenu
	if errorlevel 5 goto :RemoveSystemMenu
	if errorlevel 4 goto :RemoveRemotingMenu
	if errorlevel 3 goto :RemovePrivacyMenu
	if errorlevel 2 goto :RemoveMultimediaMenu
	if errorlevel 1 goto :RemoveInternetMenu
)

:RemoveInternetMenu
:: Remove Windows 10 v1809/v1903/v1909/v2004 Client Internet Menu
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "17763" if "%ImageBuild%" leq "19041" (
	cls
	echo.===============================================================================
	echo.                 MSMG ToolKit - Remove Internet Components Menu
	echo.===============================================================================
	echo.
	echo.  [1]  Adobe Flash For Windows
	echo.
	echo.  [2]  Internet Explorer
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.  [A]  All Internet Components
	echo.
	echo.  [X]  Go Back
	echo.
	echo.===============================================================================
	echo.
	choice /C:12AX /N /M "Enter Your Choice : "
	if errorlevel 4 goto :RemoveWindowsComponentsMenu
	if errorlevel 3 set "Component=InternetComponents"
	if errorlevel 2 set "Component=InternetExplorer"
	if errorlevel 1 set "Component=AdobeFlashForWindows"

	goto :RemoveWindowsComponents
)

:RemoveMultimediaMenu
:: Remove Windows 10 v1809/v1903/v1909/v2004 Client Multimedia Menu
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "17763" if "%ImageBuild%" leq "19041" (
	cls
	echo.===============================================================================
	echo.                 MSMG ToolKit - Remove Multimedia Components Menu
	echo.===============================================================================
	echo.
	echo.  [1]  First Logon Animation
	echo.  [2]  Game Explorer ^| Needed for Microsoft Games
	echo.  [3]  Snipping Tool
	echo.  [4]  Speech Recognition ^| Needed for Cortana
	echo.  [5]  Windows Media Player
	echo.  [6]  Windows Photo Viewer
	echo.  [7]  Windows System Assessment Tool ^| Needed for Microsoft Games
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.  [A]  All Multimedia Components
	echo.
	echo.  [X]  Go Back
	echo.
	echo.===============================================================================
	echo.
	choice /C:1234567AX /N /M "Enter Your Choice : "
	if errorlevel 9 goto :RemoveWindowsComponentsMenu
	if errorlevel 8 set "Component=MultimediaComponents"
	if errorlevel 7 set "Component=WinSAT"
	if errorlevel 6 set "Component=WindowsPhotoViewer"
	if errorlevel 5 set "Component=WindowsMediaPlayer"
	if errorlevel 4 set "Component=SpeechRecognition"
	if errorlevel 3 set "Component=SnippingTool"
	if errorlevel 2 set "Component=GameExplorer"
	if errorlevel 1 set "Component=FirstLogonAnimation"

	goto :RemoveWindowsComponents
)

:RemovePrivacyMenu
:: Remove Windows 10 v1809/v1903/v1909/v2004 Client Privacy Menu
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "17763" if "%ImageBuild%" leq "19041" (
	cls
	echo.===============================================================================
	echo.                  MSMG ToolKit - Remove Privacy Components Menu
	echo.===============================================================================
	echo.
	echo.  [A]  Assigned Access
	echo.  [B]  Customer Experience Improvement Program ^(CEIP^)
	echo.  [C]  Face Recognition
	echo.  [D]  Kernel Debugging ^| Depends on: Windows Error Reporting
	echo.  [E]  Location Service
	echo.  [F]  Picture Password
	echo.  [G]  Pin SignIn Support
	echo.  [H]  Unified Telemetry Client ^(Asimov^) ^| Depends on: Windows Error Reporting
	echo.  [I]  WiFi Network Manager ^(WiFi Sense^)
	if "%ImageBuild%" equ "17763" echo.  [J]  Windows Error Reporting
	if "%ImageBuild%" geq "18362" if "%ImageBuild%" leq "18363" echo.  [J]  Windows Error Reporting ^| Needed for Out of Box Experience
	if "%ImageBuild%" equ "19041" echo.  [J]  Windows Error Reporting
	echo.  [K]  Windows Insider Hub
	echo.
	echo.
	echo.  [1]  All Privacy Components
	echo.
	echo.  [X]  Go Back
	echo.
	echo.===============================================================================
	echo.
	choice /C:ABCDEFGHIJK1X /N /M "Enter Your Choice : "
	if errorlevel 13 goto :RemoveWindowsComponentsMenu
	if errorlevel 12 set "Component=PrivacyComponents"
	if errorlevel 11 set "Component=WindowsInsiderHub"
	if errorlevel 10 set "Component=WindowsErrorReporting"
	if errorlevel 9  set "Component=WiFiNetworkManager"
	if errorlevel 8  set "Component=UnifiedTelemetryClient"
	if errorlevel 7  set "Component=PinEnrollment"
	if errorlevel 6  set "Component=PicturePassword"
	if errorlevel 5  set "Component=LocationService"
	if errorlevel 4  set "Component=KernelDebugging"
	if errorlevel 3  set "Component=FaceRecognition"
	if errorlevel 2  set "Component=CEIP_SQM"
	if errorlevel 1  set "Component=AssignedAccess"

	goto :RemoveWindowsComponents
)

:RemoveRemotingMenu
:: Remove Windows 10 v1809/v1903/v1909/v2004 Client Remoting Menu
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "17763" if "%ImageBuild%" leq "19041" (
	cls
	echo.===============================================================================
	echo.                  MSMG ToolKit - Remove Remoting Components Menu
	echo.===============================================================================
	echo.
	echo.  [1]  Home Group
	echo.
	echo.  [2]  MultiPoint Connector
	echo.
	echo.  [3]  Remote Assistance
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.  [A]  All Remoting Components
	echo.
	echo.  [X]  Go Back
	echo.
	echo.===============================================================================
	echo.
	choice /C:123AX /N /M "Enter Your Choice : "
	if errorlevel 5 goto :RemoveWindowsComponentsMenu
	if errorlevel 4 set "Component=RemotingComponents"
	if errorlevel 3 set "Component=RemoteAssistance"
	if errorlevel 2 set "Component=MultiPointConnector"
	if errorlevel 1 set "Component=HomeGroup"

	goto :RemoveWindowsComponents
)

:RemoveSystemMenu
:: Remove Windows 10 v1809/v1903/v1909/v2004 Client System Menu
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "17763" if "%ImageBuild%" leq "19041" (
	cls
	echo.===============================================================================
	echo.                  MSMG ToolKit - Remove System Components Menu
	echo.===============================================================================
	echo.  [A]  Device Lockdown ^(Embedded Experience^)
	echo.  [B]  Ease of Access Themes
	echo.  [C]  Easy Transfer
	echo.  [D]  File History
	echo.  [E]  Manual Setup ^(InPlace Upgrade^)
	echo.  [F]  Paint
	echo.  [G]  Security Center ^| Depends on: Windows Defender
	echo.  [H]  Steps Recorder
	echo.  [I]  System Restore
	echo.  [J]  Windows Backup
	echo.  [K]  Windows Subsystem For Linux
	echo.  [L]  Windows To Go
	echo.  [M]  Wordpad
	echo.
	echo.
	echo.  [1]  All Advanced Components
	echo.
	echo.  [X]  Go Back
	echo.===============================================================================
	echo.
	choice /C:ABCDEFGHIJKLM1X /N /M "Enter Your Choice : "
	if errorlevel 15 goto :RemoveWindowsComponentsMenu
	if errorlevel 14 set "Component=SystemComponents"
	if errorlevel 13 set "Component=Wordpad"
	if errorlevel 12 set "Component=WindowsToGo"
	if errorlevel 11 set "Component=WindowsSubsystemForLinux"
	if errorlevel 10 set "Component=WindowsBackup"
	if errorlevel 9  set "Component=SystemRestore"
	if errorlevel 8  set "Component=StepsRecorder"
	if errorlevel 7  set "Component=SecurityCenter"
	if errorlevel 6  set "Component=Paint"
	if errorlevel 5  set "Component=ManualSetup"
	if errorlevel 4  set "Component=FileHistory"
	if errorlevel 3  set "Component=EasyTransfer"
	if errorlevel 2  set "Component=EaseOfAccessThemes"
	if errorlevel 1  set "Component=DeviceLockdown"

	goto :RemoveWindowsComponents
)

:RemoveSystemAppsMenu
:: Remove Windows 10 v1809 Client Enterprise LTSC 2019 Client System Apps Menu
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "17763" if "%ImageFlag%" equ "EnterpriseS" (
	cls
	echo.===============================================================================
	echo.                  MSMG ToolKit - Remove System Apps Menu
	echo.===============================================================================
	echo.  [A]  Assigned Access Lock App ^| Depends on: Assigned Access
	echo.  [B]  Azure Active Directory AppX Broker Plugin
	echo.  [C]  Bio Enrollment App
	echo.  [D]  Camera Barcode Scanner
	echo.  [E]  Content Delivery Manager ^| Needed for Out of Box Experience
	echo.  [F]  Cortana, StartMenu ^& Settings Search App ^| Depends on: Speech Recognition
	echo.  [G]  Edge Developer Tools Client
	echo.  [H]  Eye Control App
	echo.  [I]  File Explorer App
	echo.  [J]  Lockscreen App
	echo.  [K]  Map Control
	echo.  [L]  Narrator QuickStart
	echo.  [M]  Parental Controls
	echo.  [N]  People Bar
	echo.  [O]  Quick Assist App
	echo.  [P]  Retail Demo Content
	echo.  [Q]  Setting Sync
	echo.  [R]  Skype ORTC
	echo.  [S]  Smart Screen ^| Depends on: Windows Defender
	echo.  [T]  Win32 Web View Host
	echo.  [U]  Windows Defender App
	echo.  [V]  Windows Mixed Reality
	echo.  [W]  Windows Reader ^(PDF^)
	echo.  [X]  Xbox Game Callable UI
	echo.
	echo.  [1]  All System Apps
	echo.  [2]  Go Back
	echo.===============================================================================
	choice /C:ABCDEFGHIJKLMNOPQRSTUVWX12 /N /M "Enter Your Choice : "
	if errorlevel 26 goto :RemoveWindowsComponentsMenu
	if errorlevel 25 set "Component=SystemApps"
	if errorlevel 24 set "Component=XboxGameCallableUI"
	if errorlevel 23 set "Component=WindowsReaderPDF"
	if errorlevel 22 set "Component=WindowsMixedReality"
	if errorlevel 21 set "Component=WindowsDefender"
	if errorlevel 20 set "Component=Win32WebViewHost"
	if errorlevel 19 set "Component=SmartScreen"
	if errorlevel 18 set "Component=SkypeORTC"
	if errorlevel 17 set "Component=SettingSync"
	if errorlevel 16 set "Component=RetailDemoContent"
	if errorlevel 15 set "Component=QuickAssist"
	if errorlevel 14 set "Component=PeopleExperienceHost"
	if errorlevel 13 set "Component=ParentalControls"
	if errorlevel 12 set "Component=NarratorQuickStart"
	if errorlevel 11 set "Component=MapControl"
	if errorlevel 10 set "Component=LockApp"
	if errorlevel 9  set "Component=FileExplorer"
	if errorlevel 8  set "Component=ECApp"
	if errorlevel 7  set "Component=EdgeDevToolsClient"
	if errorlevel 6  set "Component=Cortana"
	if errorlevel 5  set "Component=ContentDeliveryManager"
	if errorlevel 4  set "Component=CBSPreview"
	if errorlevel 3  set "Component=BioEnrollment"
	if errorlevel 2  set "Component=AADBrokerPlugin"
	if errorlevel 1  set "Component=AssignedAccessLockApp"

	goto :RemoveWindowsComponents
)

:: Remove Windows 10 v1809 Client Enterprise N LTSC 2019 Client System Apps Menu
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "17763" if "%ImageFlag%" equ "EnterpriseSN" (
	cls
	echo.===============================================================================
	echo.                  MSMG ToolKit - Remove System Apps Menu
	echo.===============================================================================
	echo.  [A]  Assigned Access Lock App ^| Depends on: Assigned Access
	echo.  [B]  Azure Active Directory AppX Broker Plugin
	echo.  [C]  Bio Enrollment App
	echo.  [D]  Camera Barcode Scanner
	echo.  [E]  Content Delivery Manager ^| Needed for Out of Box Experience
	echo.  [F]  Cortana, StartMenu ^& Settings Search App ^| Depends on: Speech Recognition
	echo.  [G]  Edge Developer Tools Client
	echo.  [H]  Eye Control App
	echo.  [I]  File Explorer App
	echo.  [J]  Lockscreen App
	echo.  [K]  Map Control
	echo.  [L]  Narrator QuickStart
	echo.  [M]  Parental Controls
	echo.  [N]  People Bar
	echo.  [O]  Quick Assist App
	echo.  [P]  Retail Demo Content
	echo.  [Q]  Setting Sync
	echo.  [R]  Skype ORTC
	echo.  [S]  Smart Screen ^| Depends on: Windows Defender
	echo.  [T]  Win32 Web View Host
	echo.  [U]  Windows Defender App
	echo.  [V]  Windows Mixed Reality
	echo.  [W]  Windows Reader ^(PDF^)
	echo.  [X]  Xbox Game Callable UI
	echo.
	echo.  [1]  All System Apps
	echo.  [2]  Go Back
	echo.===============================================================================
	choice /C:ABCDEFGHIJKLMNOPQRSTUVWX12 /N /M "Enter Your Choice : "
	if errorlevel 26 goto :RemoveWindowsComponentsMenu
	if errorlevel 25 set "Component=SystemApps"
	if errorlevel 24 set "Component=XboxGameCallableUI"
	if errorlevel 23 set "Component=WindowsReaderPDF"
	if errorlevel 22 set "Component=WindowsMixedReality"
	if errorlevel 21 set "Component=WindowsDefender"
	if errorlevel 20 set "Component=Win32WebViewHost"
	if errorlevel 19 set "Component=SmartScreen"
	if errorlevel 18 set "Component=SkypeORTC"
	if errorlevel 17 set "Component=SettingSync"
	if errorlevel 16 set "Component=RetailDemoContent"
	if errorlevel 15 set "Component=QuickAssist"
	if errorlevel 14 set "Component=PeopleExperienceHost"
	if errorlevel 13 set "Component=ParentalControls"
	if errorlevel 12 set "Component=NarratorQuickStart"
	if errorlevel 11 set "Component=MapControl"
	if errorlevel 10 set "Component=LockApp"
	if errorlevel 9  set "Component=FileExplorer"
	if errorlevel 8  set "Component=ECApp"
	if errorlevel 7  set "Component=EdgeDevToolsClient"
	if errorlevel 6  set "Component=Cortana"
	if errorlevel 5  set "Component=ContentDeliveryManager"
	if errorlevel 4  set "Component=CBSPreview"
	if errorlevel 3  set "Component=BioEnrollment"
	if errorlevel 2  set "Component=AADBrokerPlugin"
	if errorlevel 1  set "Component=AssignedAccessLockApp"

	goto :RemoveWindowsComponents
)

:: Remove Windows 10 v1809/v1903/v1909 Client Edition System Apps Menu
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "17763" if "%ImageBuild%" leq "18363" if "%ImageFlag%" neq "EnterpriseS" if "%ImageFlag%" neq "EnterpriseSN" (
	cls
	echo.===============================================================================
	echo.                  MSMG ToolKit - Remove System Apps Menu
	echo.===============================================================================
	echo.  [A]  Assigned Access Lock App ^| Depends on: Assigned Access
	echo.  [B]  Azure Active Directory AppX Broker Plugin
	echo.  [C]  Bio Enrollment App
	echo.  [D]  Camera Barcode Scanner
	echo.  [E]  Connect App
	echo.  [F]  Content Delivery Manager ^| Needed for Out of Box Experience
	echo.  [G]  Cortana, StartMenu ^& Settings Search App ^| Depends on: Speech Recognition
	echo.  [H]  Edge
	echo.  [I]  Eye Control App
	echo.  [J]  File Explorer App
	echo.  [K]  Lockscreen App
	echo.  [L]  Map Control
	echo.  [M]  Narrator QuickStart
	echo.  [N]  OneDrive Desktop Client
	echo.  [O]  Parental Controls
	echo.  [P]  People Bar
	echo.  [Q]  Quick Assist App
	echo.  [R]  Retail Demo Content
	echo.  [S]  Setting Sync
	echo.  [T]  Skype ORTC
	echo.  [U]  Smart Screen ^| Depends on: Windows Defender
	echo.  [V]  Take Test App
	echo.  [W]  Win32 Web View Host
	echo.  [X]  Windows Defender App
	echo.  [Y]  Windows Mixed Reality
	echo.  [Z]  Xbox Game Callable UI
	echo.
	echo.  [1]  All System Apps
	echo.  [2]  Go Back
	echo.===============================================================================
	choice /C:ABCDEFGHIJKLMNOPQRSTUVWXYZ12 /N /M "Enter Your Choice : "
	if errorlevel 28 goto :RemoveWindowsComponentsMenu
	if errorlevel 27 set "Component=SystemApps"
	if errorlevel 26 set "Component=XboxGameCallableUI"
	if errorlevel 25 set "Component=WindowsMixedReality"
	if errorlevel 24 set "Component=WindowsDefender"
	if errorlevel 23 set "Component=Win32WebViewHost"
	if errorlevel 22 set "Component=SecureAssessmentBrowser"
	if errorlevel 21 set "Component=SmartScreen"
	if errorlevel 20 set "Component=SkypeORTC"
	if errorlevel 19 set "Component=SettingSync"
	if errorlevel 18 set "Component=RetailDemoContent"
	if errorlevel 17 set "Component=QuickAssist"
	if errorlevel 16 set "Component=PeopleExperienceHost"
	if errorlevel 15 set "Component=ParentalControls"
	if errorlevel 14 set "Component=OneDrive"
	if errorlevel 13 set "Component=NarratorQuickStart"
	if errorlevel 12 set "Component=MapControl"
	if errorlevel 11 set "Component=LockApp"
	if errorlevel 10 set "Component=FileExplorer"
	if errorlevel 9  set "Component=ECApp"
	if errorlevel 8  set "Component=Edge"
	if errorlevel 7  set "Component=Cortana"
	if errorlevel 6  set "Component=ContentDeliveryManager"
	if errorlevel 5  set "Component=PPIProjection"
	if errorlevel 4  set "Component=CBSPreview"
	if errorlevel 3  set "Component=BioEnrollment"
	if errorlevel 2  set "Component=AADBrokerPlugin"
	if errorlevel 1  set "Component=AssignedAccessLockApp"

	goto :RemoveWindowsComponents
)

:: Remove Windows 10 v2004 Client Edition System Apps Menu
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "19041" (
	cls
	echo.===============================================================================
	echo.                  MSMG ToolKit - Remove System Apps Menu
	echo.===============================================================================
	echo.  [A]  Assigned Access Lock App ^| Depends on: Assigned Access
	echo.  [B]  Azure Active Directory AppX Broker Plugin
	echo.  [C]  Bio Enrollment App
	echo.  [D]  Camera Barcode Scanner
	echo.  [E]  Content Delivery Manager ^| Needed for Out of Box Experience
	echo.  [F]  Edge
	echo.  [G]  Eye Control App
	echo.  [H]  File Explorer App
	echo.  [I]  Lockscreen App
	echo.  [J]  Map Control
	echo.  [K]  Narrator QuickStart
	echo.  [L]  OneDrive Desktop Client
	echo.  [M]  Parental Controls
	echo.  [N]  People Bar
	echo.  [O]  Quick Assist App
	echo.  [P]  Retail Demo Content
	echo.  [Q]  Setting Sync
	echo.  [R]  Skype ORTC
	echo.  [S]  Smart Screen ^| Depends on: Windows Defender
	echo.  [T]  Take Test App
	echo.  [U]  Win32 Web View Host
	echo.  [V]  Windows Defender App
	echo.  [W]  Windows Mixed Reality
	echo.  [X]  Xbox Game Callable UI
	echo.
	echo.  [1]  All System Apps
	echo.  [2]  Go Back
	echo.===============================================================================
	choice /C:ABCDEFGHIJKLMNOPQRSTUVWX12 /N /M "Enter Your Choice : "
	if errorlevel 26 goto :RemoveWindowsComponentsMenu
	if errorlevel 25 set "Component=SystemApps"
	if errorlevel 24 set "Component=XboxGameCallableUI"
	if errorlevel 23 set "Component=WindowsMixedReality"
	if errorlevel 22 set "Component=WindowsDefender"
	if errorlevel 21 set "Component=Win32WebViewHost"
	if errorlevel 20 set "Component=SecureAssessmentBrowser"
	if errorlevel 19 set "Component=SmartScreen"
	if errorlevel 18 set "Component=SkypeORTC"
	if errorlevel 17 set "Component=SettingSync"
	if errorlevel 16 set "Component=RetailDemoContent"
	if errorlevel 15 set "Component=QuickAssist"
	if errorlevel 14 set "Component=PeopleExperienceHost"
	if errorlevel 13 set "Component=ParentalControls"
	if errorlevel 12 set "Component=OneDrive"
	if errorlevel 11 set "Component=NarratorQuickStart"
	if errorlevel 10 set "Component=MapControl"
	if errorlevel 9  set "Component=LockApp"
	if errorlevel 8  set "Component=FileExplorer"
	if errorlevel 7  set "Component=ECApp"
	if errorlevel 6  set "Component=Edge"
	if errorlevel 5  set "Component=ContentDeliveryManager"
	if errorlevel 4  set "Component=CBSPreview"
	if errorlevel 3  set "Component=BioEnrollment"
	if errorlevel 2  set "Component=AADBrokerPlugin"
	if errorlevel 1  set "Component=AssignedAccessLockApp"

	goto :RemoveWindowsComponents
)

:RemoveWindowsAppsMenu
:: Remove Windows 10 v1809 Client Enterprise LTSC 2019 Client System Apps Menu
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "17763" if "%ImageFlag%" equ "EnterpriseS" (
	cls
	echo.===============================================================================
	echo.                  MSMG ToolKit - Remove System Apps Menu
	echo.===============================================================================
	echo.
	echo.  [1]  Windows Store Back-end ^| Depends on: Smart Screen
	echo.
	echo.  [2]  Xbox App Back-end
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.  [X]  Go Back
	echo.
	echo.===============================================================================
	echo.
	choice /C:12X /N /M "Enter Your Choice : "
	if errorlevel 3 goto :RemoveWindowsComponentsMenu
	if errorlevel 2 set "Component=XboxApp"
	if errorlevel 1 set "Component=WindowsStore"

	goto :RemoveWindowsComponents
)

:: Remove Windows 10 v1809 Client Enterprise N LTSC 2019 Client System Apps Menu
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "17763" if "%ImageFlag%" equ "EnterpriseSN" (
	cls
	echo.===============================================================================
	echo.                  MSMG ToolKit - Remove System Apps Menu
	echo.===============================================================================
	echo.
	echo.  [1]  Windows Store Back-end ^| Depends on: Smart Screen
	echo.
	echo.  [2]  Xbox App Back-end
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.  [X]  Go Back
	echo.
	echo.===============================================================================
	echo.
	choice /C:12X /N /M "Enter Your Choice : "
	if errorlevel 3 goto :RemoveWindowsComponentsMenu
	if errorlevel 2 set "Component=XboxApp"
	if errorlevel 1 set "Component=WindowsStore"

	goto :RemoveWindowsComponents
)

:: Remove Windows 10 v1809/v1903/v1909 Client 32-Bit Client Windows Apps Menu
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "17763" if "%ImageBuild%" leq "18363" if "%ImageArchitecture%" equ "x86" if "%ImageFlag%" neq "EnterpriseS" if "%ImageFlag%" neq "EnterpriseSN" (
	cls
	echo.===============================================================================
	echo.                  MSMG ToolKit - Remove Windows Apps Menu
	echo.===============================================================================
	echo.  [01]  Advertising Xaml
	echo.  [02]  Alarms ^& Clock App
	echo.  [03]  Calculator App
	echo.  [04]  Camera App
	echo.  [05]  Desktop App Installer
	echo.  [06]  Feedback Hub App
	echo.  [07]  Films ^& TV App
	echo.  [08]  Get Help App
	echo.  [09]  Google's VP9 WebM Video Codec Plugin
	echo.  [10]  Groove Music App
	echo.  [11]  High Efficiency Image File ^(HEIF^) Codec Plugin
	echo.  [12]  Maps App ^| Depends on: Map Control
	echo.  [13]  Messaging App
	echo.  [14]  Microsoft Pay App
	echo.  [15]  Mixed Reality Viewer App ^| Depends on: Windows Mixed Reality
	echo.  [16]  Mobile Plans App
	echo.  [17]  My Office App
	echo.  [18]  OneNote App
	echo.  [19]  Paint 3D App
	echo.  [20]  People App ^| Depends on: People Bar
	echo.  [21]  Photos App
	echo.  [22]  Print 3D App
	echo.  [23]  Screen Sketch App
	echo.  [24]  Skype App
	echo.  [25]  Solitaire Collection App ^| Depends on: Xbox Game Callable UI
	if "%ImageBuild%" equ "17763" echo.  [26]  Sticky Notes App
	if "%ImageBuild%" neq "17763" echo.  [26]  Sticky Notes App ^| Depends on: Windows Store
	echo.  [27]  Tips App
	echo.  [28]  Voice Recorder App
	echo.  [29]  Weather App ^| Depends on: Advertising Xaml
	echo.  [30]  Web Media Codec Plugin
	echo.  [31]  WebP Image Codec Plugin
	echo.  [32]  Windows Mail App ^| Depends on: Advertising Xaml
	echo.  [33]  Windows Store ^| Depends on: Smart Screen
	echo.  [34]  Xbox App
	echo.  [35]  Xbox Identity Provider
	echo.  [36]  Your Phone App
	echo.
	echo.  [A]   All Windows Apps
	echo.  [X]   Go Back
	echo.===============================================================================
	set /p MenuChoice=Enter Your Choice :  

	if /i "!MenuChoice!" equ "X" goto :RemoveWindowsComponentsMenu
	if /i "!MenuChoice!" equ "A" set "Component=WindowsApps"
	if "!MenuChoice!" equ "36" set "Component=YourPhone"
	if "!MenuChoice!" equ "35" set "Component=XboxIdentityProvider"
	if "!MenuChoice!" equ "34" set "Component=XboxApp"
	if "!MenuChoice!" equ "33" set "Component=WindowsStore"
	if "!MenuChoice!" equ "32" set "Component=CommunicationsApps"
	if "!MenuChoice!" equ "31" set "Component=WebpImageExtensions"
	if "!MenuChoice!" equ "30" set "Component=WebMediaExtensions"
	if "!MenuChoice!" equ "29" set "Component=BingWeather"
	if "!MenuChoice!" equ "28" set "Component=SoundRecorder"
	if "!MenuChoice!" equ "27" set "Component=Getstarted"
	if "!MenuChoice!" equ "26" set "Component=StickyNotes"
	if "!MenuChoice!" equ "25" set "Component=SolitaireCollection"
	if "!MenuChoice!" equ "24" set "Component=SkypeApp"
	if "!MenuChoice!" equ "23" set "Component=ScreenSketch"
	if "!MenuChoice!" equ "22" set "Component=Print3D"
	if "!MenuChoice!" equ "21" set "Component=Photos"
	if "!MenuChoice!" equ "20" set "Component=People"
	if "!MenuChoice!" equ "19" set "Component=Paint3D"
	if "!MenuChoice!" equ "18" set "Component=OfficeOneNote"
	if "!MenuChoice!" equ "17" set "Component=OfficeHub"
	if "!MenuChoice!" equ "16" set "Component=OneConnect"
	if "!MenuChoice!" equ "15" set "Component=3DViewer"
	if "!MenuChoice!" equ "14" set "Component=WalletService"
	if "!MenuChoice!" equ "13" set "Component=Messaging"
	if "!MenuChoice!" equ "12" set "Component=Maps"
	if "!MenuChoice!" equ "11" set "Component=HEIFImageExtension"
	if "!MenuChoice!" equ "10" set "Component=ZuneMusic"
	if "!MenuChoice!" equ "09" set "Component=VP9VideoExtensions"
	if "!MenuChoice!" equ "08" set "Component=GetHelp"
	if "!MenuChoice!" equ "07" set "Component=ZuneVideo"
	if "!MenuChoice!" equ "06" set "Component=FeedbackHub"
	if "!MenuChoice!" equ "05" set "Component=DesktopAppInstaller"
	if "!MenuChoice!" equ "04" set "Component=Camera"
	if "!MenuChoice!" equ "03" set "Component=Calculator"	
	if "!MenuChoice!" equ "02" set "Component=Alarms"
	if "!MenuChoice!" equ "01" set "Component=AdvertisingXaml"

	goto :RemoveWindowsComponents
)

:: Remove Windows 10 v1809/v1903/v1909 Client Non Enterprise (N) LTSC 2019 64-Bit Client Windows Apps Menu
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "17763" if "%ImageBuild%" leq "18363" if "%ImageArchitecture%" equ "x64" if "%ImageFlag%" neq "EnterpriseS" if "%ImageFlag%" neq "EnterpriseSN" (
	cls
	echo.===============================================================================
	echo.                  MSMG ToolKit - Remove Windows Apps Menu
	echo.===============================================================================
	echo.  [01]  Advertising Xaml
	echo.  [02]  Alarms ^& Clock App
	echo.  [03]  Calculator App
	echo.  [04]  Camera App
	echo.  [05]  Desktop App Installer
	echo.  [06]  Feedback Hub App
	echo.  [07]  Films ^& TV App
	echo.  [08]  Get Help App
	echo.  [09]  Google's VP9 WebM Video Codec Plugin
	echo.  [10]  Groove Music App
	echo.  [11]  High Efficiency Image File ^(HEIF^) Codec Plugin
	echo.  [12]  Maps App ^| Depends on: Map Control
	echo.  [13]  Messaging App
	echo.  [14]  Microsoft Pay App
	echo.  [15]  Mixed Reality Portal App ^| Depends on: Windows Mixed Reality
	echo.  [16]  Mixed Reality Viewer App ^| Depends on: Windows Mixed Reality
	echo.  [17]  Mobile Plans App
	echo.  [18]  My Office App
	echo.  [19]  OneNote App
	echo.  [20]  Paint 3D App
	echo.  [21]  People App ^| Depends on: People Bar
	echo.  [22]  Photos App
	echo.  [23]  Print 3D App
	echo.  [24]  Screen Sketch App
	echo.  [25]  Skype App
	echo.  [26]  Solitaire Collection App ^| Depends on: Xbox Game Callable UI
	if "%ImageBuild%" equ "17763" echo.  [27]  Sticky Notes App
	if "%ImageBuild%" neq "17763" echo.  [27]  Sticky Notes App ^| Depends on: Windows Store
	echo.  [28]  Tips App
	echo.  [29]  Voice Recorder App
	echo.  [30]  Weather App ^| Depends on: Advertising Xaml
	echo.  [31]  Web Media Codec Plugin
	echo.  [32]  WebP Image Codec Plugin
	echo.  [33]  Windows Mail App ^| Depends on: Advertising Xaml
	echo.  [34]  Windows Store ^| Depends on: Smart Screen
	echo.  [35]  Xbox App
	echo.  [36]  Xbox Identity Provider
	echo.  [37]  Your Phone App
	echo.
	echo.  [A]   All Windows Apps
	echo.  [X]   Go Back
	echo.===============================================================================
	set /p MenuChoice=Enter Your Choice :  

	if /i "!MenuChoice!" equ "X" goto :RemoveWindowsComponentsMenu
	if /i "!MenuChoice!" equ "A" set "Component=WindowsApps"
	if "!MenuChoice!" equ "37" set "Component=YourPhone"
	if "!MenuChoice!" equ "36" set "Component=XboxIdentityProvider"
	if "!MenuChoice!" equ "35" set "Component=XboxApp"
	if "!MenuChoice!" equ "34" set "Component=WindowsStore"
	if "!MenuChoice!" equ "33" set "Component=CommunicationsApps"
	if "!MenuChoice!" equ "32" set "Component=WebpImageExtensions"
	if "!MenuChoice!" equ "31" set "Component=WebMediaExtensions"
	if "!MenuChoice!" equ "30" set "Component=BingWeather"
	if "!MenuChoice!" equ "29" set "Component=SoundRecorder"
	if "!MenuChoice!" equ "28" set "Component=Getstarted"
	if "!MenuChoice!" equ "27" set "Component=StickyNotes"
	if "!MenuChoice!" equ "26" set "Component=SolitaireCollection"
	if "!MenuChoice!" equ "25" set "Component=SkypeApp"
	if "!MenuChoice!" equ "24" set "Component=ScreenSketch"
	if "!MenuChoice!" equ "23" set "Component=Print3D"
	if "!MenuChoice!" equ "22" set "Component=Photos"
	if "!MenuChoice!" equ "21" set "Component=People"
	if "!MenuChoice!" equ "20" set "Component=Paint3D"
	if "!MenuChoice!" equ "19" set "Component=OfficeOneNote"
	if "!MenuChoice!" equ "18" set "Component=OfficeHub"
	if "!MenuChoice!" equ "17" set "Component=OneConnect"
	if "!MenuChoice!" equ "16" set "Component=3DViewer"
	if "!MenuChoice!" equ "15" set "Component=MixedRealityPortal"
	if "!MenuChoice!" equ "14" set "Component=WalletService"
	if "!MenuChoice!" equ "13" set "Component=Messaging"
	if "!MenuChoice!" equ "12" set "Component=Maps"
	if "!MenuChoice!" equ "11" set "Component=HEIFImageExtension"
	if "!MenuChoice!" equ "10" set "Component=ZuneMusic"
	if "!MenuChoice!" equ "09" set "Component=VP9VideoExtensions"
	if "!MenuChoice!" equ "08" set "Component=GetHelp"
	if "!MenuChoice!" equ "07" set "Component=ZuneVideo"
	if "!MenuChoice!" equ "06" set "Component=FeedbackHub"
	if "!MenuChoice!" equ "05" set "Component=DesktopAppInstaller"
	if "!MenuChoice!" equ "04" set "Component=Camera"
	if "!MenuChoice!" equ "03" set "Component=Calculator"	
	if "!MenuChoice!" equ "02" set "Component=Alarms"
	if "!MenuChoice!" equ "01" set "Component=AdvertisingXaml"

	goto :RemoveWindowsComponents
)

:: Remove Windows 10 v2004 32-Bit Client Windows Apps Menu
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "19041" if "%ImageArchitecture%" equ "x86" (
	cls
	echo.===============================================================================
	echo.                  MSMG ToolKit - Remove Windows Apps Menu
	echo.===============================================================================
	echo.  [01]  Advertising Xaml
	echo.  [02]  Alarms ^& Clock App
	echo.  [03]  Calculator App
	echo.  [04]  Camera App
	echo.  [05]  Cortana App
	echo.  [06]  Desktop App Installer
	echo.  [07]  Feedback Hub App
	echo.  [08]  Get Help App
	echo.  [09]  Google's VP9 WebM Video Codec Plugin
	echo.  [10]  Groove Music App
	echo.  [11]  High Efficiency Image File ^(HEIF^) Codec Plugin
	echo.  [12]  Maps App ^| Depends on: Map Control
	echo.  [13]  Microsoft Pay App
	echo.  [14]  Mixed Reality Viewer App ^| Depends on: Windows Mixed Reality
	echo.  [15]  Movies ^& TV App
	echo.  [16]  My Office App
	echo.  [17]  OneNote App
	echo.  [18]  Paint 3D App
	echo.  [19]  People App ^| Depends on: People Bar
	echo.  [20]  Photos App
	echo.  [21]  Screen Sketch App
	echo.  [22]  Skype App
	echo.  [23]  Solitaire Collection App ^| Depends on: Xbox Game Callable UI
	echo.  [24]  Sticky Notes App ^| Depends on: Windows Store
	echo.  [25]  Tips App
	echo.  [26]  Voice Recorder App
	echo.  [27]  Weather App ^| Depends on: Advertising Xaml
	echo.  [28]  Web Media Codec Plugin
	echo.  [29]  WebP Image Codec Plugin
	echo.  [30]  Windows Mail App ^| Depends on: Advertising Xaml
	echo.  [31]  Windows Store ^| Depends on: Smart Screen
	echo.  [32]  Xbox App
	echo.  [33]  Xbox Identity Provider
	echo.  [34]  Your Phone App
	echo.
	echo.  [A]   All Windows Apps
	echo.  [X]   Go Back
	echo.===============================================================================
	set /p MenuChoice=Enter Your Choice :  

	if /i "!MenuChoice!" equ "X" goto :RemoveWindowsComponentsMenu
	if /i "!MenuChoice!" equ "A" set "Component=WindowsApps"
	if "!MenuChoice!" equ "34" set "Component=YourPhone"
	if "!MenuChoice!" equ "33" set "Component=XboxIdentityProvider"
	if "!MenuChoice!" equ "32" set "Component=XboxApp"
	if "!MenuChoice!" equ "31" set "Component=WindowsStore"
	if "!MenuChoice!" equ "30" set "Component=CommunicationsApps"
	if "!MenuChoice!" equ "29" set "Component=WebpImageExtensions"
	if "!MenuChoice!" equ "28" set "Component=WebMediaExtensions"
	if "!MenuChoice!" equ "27" set "Component=BingWeather"
	if "!MenuChoice!" equ "26" set "Component=SoundRecorder"
	if "!MenuChoice!" equ "25" set "Component=Getstarted"
	if "!MenuChoice!" equ "24" set "Component=StickyNotes"
	if "!MenuChoice!" equ "23" set "Component=SolitaireCollection"
	if "!MenuChoice!" equ "22" set "Component=SkypeApp"
	if "!MenuChoice!" equ "21" set "Component=ScreenSketch"
	if "!MenuChoice!" equ "20" set "Component=Photos"
	if "!MenuChoice!" equ "19" set "Component=People"
	if "!MenuChoice!" equ "18" set "Component=Paint3D"
	if "!MenuChoice!" equ "17" set "Component=OfficeOneNote"
	if "!MenuChoice!" equ "16" set "Component=OfficeHub"
	if "!MenuChoice!" equ "15" set "Component=ZuneVideo"
	if "!MenuChoice!" equ "14" set "Component=3DViewer"
	if "!MenuChoice!" equ "13" set "Component=WalletService"
	if "!MenuChoice!" equ "12" set "Component=Maps"
	if "!MenuChoice!" equ "11" set "Component=HEIFImageExtension"
	if "!MenuChoice!" equ "10" set "Component=ZuneMusic"
	if "!MenuChoice!" equ "09" set "Component=VP9VideoExtensions"
	if "!MenuChoice!" equ "08" set "Component=GetHelp"
	if "!MenuChoice!" equ "07" set "Component=FeedbackHub"
	if "!MenuChoice!" equ "06" set "Component=DesktopAppInstaller"
	if "!MenuChoice!" equ "05" set "Component=Cortana"
	if "!MenuChoice!" equ "04" set "Component=Camera"
	if "!MenuChoice!" equ "03" set "Component=Calculator"	
	if "!MenuChoice!" equ "02" set "Component=Alarms"
	if "!MenuChoice!" equ "01" set "Component=AdvertisingXaml"

	goto :RemoveWindowsComponents
)

:: Remove Windows 10 v2004 64-Bit Client Windows Apps Menu
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "19041" if "%ImageArchitecture%" equ "x64" (
	cls
	echo.===============================================================================
	echo.                  MSMG ToolKit - Remove Windows Apps Menu
	echo.===============================================================================
	echo.  [01]  Advertising Xaml
	echo.  [02]  Alarms ^& Clock App
	echo.  [03]  Calculator App
	echo.  [04]  Camera App
	echo.  [05]  Cortana App
	echo.  [06]  Desktop App Installer
	echo.  [07]  Feedback Hub App
	echo.  [08]  Get Help App
	echo.  [09]  Google's VP9 WebM Video Codec Plugin
	echo.  [10]  Groove Music App
	echo.  [11]  High Efficiency Image File ^(HEIF^) Codec Plugin
	echo.  [12]  Maps App ^| Depends on: Map Control
	echo.  [13]  Microsoft Pay App
	echo.  [14]  Mixed Reality Portal App ^| Depends on: Windows Mixed Reality
	echo.  [15]  Mixed Reality Viewer App ^| Depends on: Windows Mixed Reality
	echo.  [16]  Movies ^& TV App
	echo.  [17]  My Office App
	echo.  [18]  OneNote App
	echo.  [19]  Paint 3D App
	echo.  [20]  People App ^| Depends on: People Bar
	echo.  [21]  Photos App
	echo.  [22]  Screen Sketch App
	echo.  [23]  Skype App
	echo.  [24]  Solitaire Collection App ^| Depends on: Xbox Game Callable UI
	echo.  [25]  Sticky Notes App ^| Depends on: Windows Store
	echo.  [26]  Tips App
	echo.  [27]  Voice Recorder App
	echo.  [28]  Weather App ^| Depends on: Advertising Xaml
	echo.  [29]  Web Media Codec Plugin
	echo.  [30]  WebP Image Codec Plugin
	echo.  [31]  Windows Mail App ^| Depends on: Advertising Xaml
	echo.  [32]  Windows Store ^| Depends on: Smart Screen
	echo.  [33]  Xbox App
	echo.  [34]  Xbox Identity Provider
	echo.  [35]  Your Phone App
	echo.
	echo.  [A]   All Windows Apps
	echo.  [X]   Go Back
	echo.===============================================================================
	set /p MenuChoice=Enter Your Choice :  

	if /i "!MenuChoice!" equ "X" goto :RemoveWindowsComponentsMenu
	if /i "!MenuChoice!" equ "A" set "Component=WindowsApps"
	if "!MenuChoice!" equ "35" set "Component=YourPhone"
	if "!MenuChoice!" equ "34" set "Component=XboxIdentityProvider"
	if "!MenuChoice!" equ "33" set "Component=XboxApp"
	if "!MenuChoice!" equ "32" set "Component=WindowsStore"
	if "!MenuChoice!" equ "31" set "Component=CommunicationsApps"
	if "!MenuChoice!" equ "30" set "Component=WebpImageExtensions"
	if "!MenuChoice!" equ "29" set "Component=WebMediaExtensions"
	if "!MenuChoice!" equ "28" set "Component=BingWeather"
	if "!MenuChoice!" equ "27" set "Component=SoundRecorder"
	if "!MenuChoice!" equ "26" set "Component=Getstarted"
	if "!MenuChoice!" equ "25" set "Component=StickyNotes"
	if "!MenuChoice!" equ "24" set "Component=SolitaireCollection"
	if "!MenuChoice!" equ "23" set "Component=SkypeApp"
	if "!MenuChoice!" equ "22" set "Component=ScreenSketch"
	if "!MenuChoice!" equ "21" set "Component=Photos"
	if "!MenuChoice!" equ "20" set "Component=People"
	if "!MenuChoice!" equ "19" set "Component=Paint3D"
	if "!MenuChoice!" equ "18" set "Component=OfficeOneNote"
	if "!MenuChoice!" equ "17" set "Component=OfficeHub"
	if "!MenuChoice!" equ "16" set "Component=ZuneVideo"
	if "!MenuChoice!" equ "15" set "Component=3DViewer"
	if "!MenuChoice!" equ "14" set "Component=MixedRealityPortal"
	if "!MenuChoice!" equ "13" set "Component=WalletService"
	if "!MenuChoice!" equ "12" set "Component=Maps"
	if "!MenuChoice!" equ "11" set "Component=HEIFImageExtension"
	if "!MenuChoice!" equ "10" set "Component=ZuneMusic"
	if "!MenuChoice!" equ "09" set "Component=VP9VideoExtensions"
	if "!MenuChoice!" equ "08" set "Component=GetHelp"
	if "!MenuChoice!" equ "07" set "Component=FeedbackHub"
	if "!MenuChoice!" equ "06" set "Component=DesktopAppInstaller"
	if "!MenuChoice!" equ "05" set "Component=Cortana"
	if "!MenuChoice!" equ "04" set "Component=Camera"
	if "!MenuChoice!" equ "03" set "Component=Calculator"	
	if "!MenuChoice!" equ "02" set "Component=Alarms"
	if "!MenuChoice!" equ "01" set "Component=AdvertisingXaml"

	goto :RemoveWindowsComponents
)

:: Remove Windows Components
:RemoveWindowsComponents

cls
echo.===============================================================================
echo.                  MSMG ToolKit - Removing Windows Components
echo.===============================================================================
echo.

if "%Component%" equ "InternetComponents" (
	choice /C YN /N /M "Removing All Internet Components Continue... ['Y'es/'N'o] : "
	if errorlevel 2 goto :Stop
)

if "%Component%" equ "MultimediaComponents" (
	choice /C YN /N /M "Removing All Multimedia Components Continue... ['Y'es/'N'o] : "
	if errorlevel 2 goto :Stop
)

if "%Component%" equ "PrivacyComponents" (
	choice /C YN /N /M "Removing All Privacy Components Continue... ['Y'es/'N'o] : "
	if errorlevel 2 goto :Stop
)

if "%Component%" equ "RemotingComponents" (
	choice /C YN /N /M "Removing All Remoting Components Continue... ['Y'es/'N'o] : "
	if errorlevel 2 goto :Stop
)

if "%Component%" equ "SystemComponents" (
	choice /C YN /N /M "Removing All System Components Continue... ['Y'es/'N'o] : "
	if errorlevel 2 goto :Stop
)

if "%Component%" equ "SystemApps" (
	choice /C YN /N /M "Removing All System Apps Continue... ['Y'es/'N'o] : "
	if errorlevel 2 goto :Stop
)

if "%Component%" equ "WindowsApps" (
	choice /C YN /N /M "Removing All Windows Apps Continue... ['Y'es/'N'o] : "
	if errorlevel 2 goto :Stop
)

cls
echo.===============================================================================
echo.                  MSMG ToolKit - Removing Windows Components
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
if "%ImageIndexNo%" equ "*" call :GetImageArchitecture "%InstallWim%", 1 >nul
if "%ImageIndexNo%" neq "*" call :GetImageArchitecture "%InstallWim%", %ImageIndexNo% >nul

:: Set Package Architecture
if "%ImageArchitecture%" equ "x86" set "PackageArchitecture=x86"
if "%ImageArchitecture%" equ "x64" set "PackageArchitecture=amd64"
if "%ImageArchitecture%" equ "arm64" set "PackageArchitecture=arm64"

echo.-------------------------------------------------------------------------------
echo.####Starting Removing Windows Components#######################################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if "%ImageIndexNo%" equ "*" echo.    Image Indexes            : 1-%ImageCount%
if "%ImageIndexNo%" neq "*" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
if "%ImageIndexNo%" neq "*" echo.    Image Edition            : %ImageEdition%
echo.    Image Default Language   : %ImageDefaultLanguage%
echo.
echo.-------------------------------------------------------------------------------
echo.####Removing Windows Components################################################
echo.-------------------------------------------------------------------------------
echo.

if "%ImageIndexNo%" equ "*" (
	for /L %%i in (1, 1, %ImageCount%) do (
		if not "%ImageIndexNo%" gtr 9 echo.##########################[Install.wim, Index : %%i]#############################
		if "%ImageIndexNo%" gtr 9 echo.##########################[Install.wim, Index : %%i]############################
		echo.

		:: Getting Install Image Index Architecture
		call :GetImageIndexInfo "%InstallWim%", %%i >nul

		:: Internet Components
		if "%Component%" equ "AdobeFlashForWindows" call :RemoveWindowsComponent "%InstallMount%\%%i", "Adobe Flash For Windows", "AdobeFlashForWindows"
		if "%Component%" equ "InternetExplorer" call :RemoveWindowsComponent "%InstallMount%\%%i", "Internet Explorer", "InternetExplorer"

		:: Multimedia Components
		if "%Component%" equ "FirstLogonAnimation" call :RemoveWindowsComponent "%InstallMount%\%%i", "First Logon Animation", "FirstLogonAnimation"
		if "%Component%" equ "GameExplorer" call :RemoveWindowsComponent "%InstallMount%\%%i", "Game Explorer", "GameExplorer"
		if "%Component%" equ "SnippingTool" call :RemoveWindowsComponent "%InstallMount%\%%i", "Snipping Tool", "SnippingTool"
		if "%Component%" equ "SpeechRecognition" call :RemoveWindowsComponent "%InstallMount%\%%i", "Speech Recognition", "SpeechRecognition"
		if "%Component%" equ "WindowsMediaPlayer" call :RemoveWindowsComponent "%InstallMount%\%%i", "Windows Media Player", "WindowsMediaPlayer"
		if "%Component%" equ "WindowsPhotoViewer" call :RemoveWindowsComponent "%InstallMount%\%%i", "Windows Photo Viewer", "WindowsPhotoViewer"
		if "%Component%" equ "WinSAT" call :RemoveWindowsComponent "%InstallMount%\%%i", "Windows System Assessment Tool", "WinSAT"

		:: Privacy Components
		if "%Component%" equ "AssignedAccess" call :RemoveWindowsComponent "%InstallMount%\%%i", "Assigned Access", "AssignedAccess"
		if "%Component%" equ "CEIP_SQM" call :RemoveWindowsComponent "%InstallMount%\%%i", "Customer Experience Improvement Program [CEIP]", "CEIP_SQM"
		if "%Component%" equ "FaceRecognition" call :RemoveWindowsComponent "%InstallMount%\%%i", "Face Recognition", "FaceRecognition"
		if "%Component%" equ "KernelDebugging" call :RemoveWindowsComponent "%InstallMount%\%%i", "Kernel Debugging", "KernelDebugging"
		if "%Component%" equ "LocationService" call :RemoveWindowsComponent "%InstallMount%\%%i", "Location Service", "LocationService"
		if "%Component%" equ "PicturePassword" call :RemoveWindowsComponent "%InstallMount%\%%i", "Picture Password", "PicturePassword"
		if "%Component%" equ "PinEnrollment" call :RemoveWindowsComponent "%InstallMount%\%%i", "Pin Enrollment", "PinEnrollment"
		if "%Component%" equ "UnifiedTelemetryClient" call :RemoveWindowsComponent "%InstallMount%\%%i", "Unified Telemetry Client [Asimov]", "UnifiedTelemetryClient"
		if "%Component%" equ "WiFiNetworkManager" call :RemoveWindowsComponent "%InstallMount%\%%i", "WiFi Network Manager", "WiFiNetworkManager"
		if "%Component%" equ "WindowsErrorReporting" call :RemoveWindowsComponent "%InstallMount%\%%i", "Windows Error Reporting", "WindowsErrorReporting"
		if "%Component%" equ "WindowsInsiderHub" call :RemoveWindowsComponent "%InstallMount%\%%i", "Windows Insider Hub", "WindowsInsiderHub"

		:: Remoting Components
		if "%Component%" equ "HomeGroup" call :RemoveWindowsComponent "%InstallMount%\%%i", "HomeGroup", "HomeGroup"
		if "%Component%" equ "MultiPointConnector" call :RemoveWindowsComponent "%InstallMount%\%%i", "MultiPoint Connector", "MultiPointConnector"
		if "%Component%" equ "RemoteAssistance" call :RemoveWindowsComponent "%InstallMount%\%%i", "Remote Assistance", "RemoteAssistance"

		:: System Components
		if "%Component%" equ "DeviceLockdown" call :RemoveWindowsComponent "%InstallMount%\%%i", "Device Lockdown [Embedded Experience]", "DeviceLockdown"
		if "%Component%" equ "EaseOfAccessThemes" call :RemoveWindowsComponent "%InstallMount%\%%i", "Ease Of Access Themes", "EaseOfAccessThemes"
		if "%Component%" equ "EasyTransfer" call :RemoveWindowsComponent "%InstallMount%\%%i", "Easy Transfer", "EasyTransfer"
		if "%Component%" equ "FileHistory" call :RemoveWindowsComponent "%InstallMount%\%%i", "File History", "FileHistory"
		if "%Component%" equ "ManualSetup" call :RemoveWindowsManualSetup
		if "%Component%" equ "Paint" call :RemoveWindowsComponent "%InstallMount%\%%i", "Microsoft Paint", "Paint"
		if "%Component%" equ "SecurityCenter" call :RemoveWindowsComponent "%InstallMount%\%%i", "Security Center", "SecurityCenter"
		if "%Component%" equ "StepsRecorder" call :RemoveWindowsComponent "%InstallMount%\%%i", "Steps Recorder", "StepsRecorder"
		if "%Component%" equ "SystemRestore" call :RemoveWindowsComponent "%InstallMount%\%%i", "System Restore", "SystemRestore"
		if "%Component%" equ "WindowsBackup" call :RemoveWindowsComponent "%InstallMount%\%%i", "Windows Backup", "WindowsBackup"
		if "%Component%" equ "WindowsSubsystemForLinux" call :RemoveWindowsComponent "%InstallMount%\%%i", "Windows Subsystem For Linux", "WindowsSubsystemForLinux"
		if "%Component%" equ "WindowsToGo" call :RemoveWindowsComponent "%InstallMount%\%%i", "Windows To Go", "WindowsToGo"
		if "%Component%" equ "Wordpad" call :RemoveWindowsComponent "%InstallMount%\%%i", "Wordpad", "Wordpad"

		:: System Apps
		if "%Component%" equ "AADBrokerPlugin" call :RemoveWindowsComponent "%InstallMount%\%%i", "Azure Active Directory AppX Broker Plugin", "AADBrokerPlugin"
		if "%Component%" equ "AssignedAccessLockApp" call :RemoveWindowsComponent "%InstallMount%\%%i", "Assigned Access Lock App", "AssignedAccessLockApp"
		if "%Component%" equ "BioEnrollment" call :RemoveWindowsComponent "%InstallMount%\%%i", "Bio Enrollment App", "BioEnrollment"
		if "%Component%" equ "CBSPreview" call :RemoveWindowsComponent "%InstallMount%\%%i", "Camera Barcode Scanner", "CBSPreview"
		if "%Component%" equ "ContentDeliveryManager" call :RemoveWindowsComponent "%InstallMount%\%%i", "Content Delivery Manager", "ContentDeliveryManager"
		if "%ImageBuild%" geq "17763" if "%ImageBuild%" leq "18363" if "%Component%" equ "Cortana" call :RemoveWindowsComponent "%InstallMount%\%%i", "Cortana, StartMenu and Settings Search App", "Cortana"
		if "%Component%" equ "ECApp" call :RemoveWindowsComponent "%InstallMount%\%%i", "Eye Control App", "ECApp"
		if "%Component%" equ "Edge" (
			call :RemoveWindowsComponent "%InstallMount%\%%i", "Edge Developer Tools Client", "EdgeDevToolsClient"
			call :RemoveWindowsComponent "%InstallMount%\%%i", "Edge Browser App", "Edge"
			call :RemoveWindowsComponent "%InstallMount%\%%i", "Windows Reader [PDF]", "WindowsReaderPDF"
		)
		if "%Component%" equ "EdgeDevToolsClient" call :RemoveWindowsComponent "%InstallMount%\%%i", "Edge Developer Tools Client", "EdgeDevToolsClient"
		if "%Component%" equ "FileExplorer" call :RemoveWindowsComponent "%InstallMount%\%%i", "File Explorer App", "FileExplorer"
		if "%Component%" equ "LockApp" call :RemoveWindowsComponent "%InstallMount%\%%i", "Lockscreen App", "LockApp"
		if "%Component%" equ "MapControl" call :RemoveWindowsComponent "%InstallMount%\%%i", "Map Control", "MapControl"
		if "%Component%" equ "NarratorQuickStart" call :RemoveWindowsComponent "%InstallMount%\%%i", "Narrator QuickStart", "NarratorQuickStart"
		if "%Component%" equ "OneDrive" call :RemoveWindowsComponent "%InstallMount%\%%i", "OneDrive Desktop Client", "OneDrive"
		if "%Component%" equ "ParentalControls" call :RemoveWindowsComponent "%InstallMount%\%%i", "Parental Controls App", "ParentalControls"
		if "%Component%" equ "PeopleExperienceHost" call :RemoveWindowsComponent "%InstallMount%\%%i", "People Experience Host", "PeopleExperienceHost"
		if "%ImageBuild%" geq "17763" if "%ImageBuild%" leq "18363" if "%Component%" equ "PPIProjection" call :RemoveWindowsComponent "%InstallMount%\%%i", "Connect App", "PPIProjection"
		if "%Component%" equ "QuickAssist" call :RemoveWindowsComponent "%InstallMount%\%%i", "Quick Assist App", "QuickAssist"
		if "%Component%" equ "RetailDemoContent" call :RemoveWindowsComponent "%InstallMount%\%%i", "Retail Demo Content", "RetailDemoContent"
		if "%Component%" equ "SecureAssessmentBrowser" call :RemoveWindowsComponent "%InstallMount%\%%i", "Take Test App", "SecureAssessmentBrowser"
		if "%Component%" equ "SettingSync" call :RemoveWindowsComponent "%InstallMount%\%%i", "Setting Sync", "SettingSync"
		if "%Component%" equ "SkypeORTC" call :RemoveWindowsComponent "%InstallMount%\%%i", "Skype ORTC", "SkypeORTC"
		if "%Component%" equ "SmartScreen" call :RemoveWindowsComponent "%InstallMount%\%%i", "SmartScreen App", "SmartScreen"
		if "%Component%" equ "Win32WebViewHost" call :RemoveWindowsComponent "%InstallMount%\%%i", "Win32 WebView Host", "Win32WebViewHost"
		if "%Component%" equ "WindowsDefender" call :RemoveWindowsComponent "%InstallMount%\%%i", "Windows Defender App", "WindowsDefender"
		if "%Component%" equ "WindowsMixedReality" call :RemoveWindowsComponent "%InstallMount%\%%i", "Windows Mixed Reality", "WindowsMixedReality"
		if "%Component%" equ "WindowsReaderPDF" call :RemoveWindowsComponent "%InstallMount%\%%i", "Windows Reader [PDF]", "WindowsReaderPDF"
		if "%Component%" equ "XboxGameCallableUI" call :RemoveWindowsComponent "%InstallMount%\%%i", "Xbox Game Callable UI", "XboxGameCallableUI"

		:: Windows Apps
		if "%Component%" equ "3DViewer" call :RemoveWindowsComponent "%InstallMount%\%%i", "Mixed Reality Viewer App", "3DViewer"
		if "%Component%" equ "AdvertisingXaml" call :RemoveWindowsComponent "%InstallMount%\%%i", "Advertising Xaml", "AdvertisingXaml"
		if "%Component%" equ "Alarms" call :RemoveWindowsComponent "%InstallMount%\%%i", "Alarms and Clock App", "Alarms"
		if "%Component%" equ "BingWeather" call :RemoveWindowsComponent "%InstallMount%\%%i", "Weather App", "BingWeather"
		if "%Component%" equ "Calculator" call :RemoveWindowsComponent "%InstallMount%\%%i", "Calculator App", "Calculator"
		if "%Component%" equ "Camera" call :RemoveWindowsComponent "%InstallMount%\%%i", "Camera App", "Camera"
		if "%Component%" equ "CommunicationsApps" call :RemoveWindowsComponent "%InstallMount%\%%i", "Windows Mail App", "CommunicationsApps"
		if "%ImageBuild%" equ "19041" if "%Component%" equ "Cortana" call :RemoveWindowsComponent "%InstallMount%\%%i", "Cortana App", "Cortana"
		if "%Component%" equ "DesktopAppInstaller" call :RemoveWindowsComponent "%InstallMount%\%%i", "Desktop App Installer", "DesktopAppInstaller"
		if "%Component%" equ "FeedbackHub" call :RemoveWindowsComponent "%InstallMount%\%%i", "Feedback Hub App", "FeedbackHub"
		if "%Component%" equ "GetHelp" call :RemoveWindowsComponent "%InstallMount%\%%i", "Get Help App", "GetHelp"
		if "%Component%" equ "Getstarted" call :RemoveWindowsComponent "%InstallMount%\%%i", "Tips App", "Getstarted"
		if "%Component%" equ "HEIFImageExtension" call :RemoveWindowsComponent "%InstallMount%\%%i", "High Efficiency Image File Codec Plugin", "HEIFImageExtension"
		if "%Component%" equ "Maps" call :RemoveWindowsComponent "%InstallMount%\%%i", "Maps App", "Maps"
		if "%Component%" equ "Messaging" call :RemoveWindowsComponent "%InstallMount%\%%i", "Messaging App", "Messaging"
		if "%Component%" equ "MixedRealityPortal" call :RemoveWindowsComponent "%InstallMount%\%%i", "Mixed Reality Portal App", "MixedRealityPortal"
		if "%Component%" equ "OfficeHub" call :RemoveWindowsComponent "%InstallMount%\%%i", "My Office App", "OfficeHub"
		if "%Component%" equ "OfficeOneNote" call :RemoveWindowsComponent "%InstallMount%\%%i", "OneNote App", "OfficeOneNote"
		if "%Component%" equ "OneConnect" call :RemoveWindowsComponent "%InstallMount%\%%i", "Mobile Plans App", "OneConnect"
		if "%Component%" equ "Paint3D" call :RemoveWindowsComponent "%InstallMount%\%%i", "Paint 3D App", "Paint3D"
		if "%Component%" equ "People" call :RemoveWindowsComponent "%InstallMount%\%%i", "People App", "People"
		if "%Component%" equ "Photos" call :RemoveWindowsComponent "%InstallMount%\%%i", "Photos App", "Photos"
		if "%Component%" equ "Print3D" call :RemoveWindowsComponent "%InstallMount%\%%i", "Print 3D App", "Print3D"
		if "%Component%" equ "ScreenSketch" call :RemoveWindowsComponent "%InstallMount%\%%i", "Screen Sketch App", "ScreenSketch"
		if "%Component%" equ "SkypeApp" call :RemoveWindowsComponent "%InstallMount%\%%i", "Skype App", "SkypeApp"
		if "%Component%" equ "SolitaireCollection" call :RemoveWindowsComponent "%InstallMount%\%%i", "Solitaire Collection App", "SolitaireCollection"
		if "%Component%" equ "SoundRecorder" call :RemoveWindowsComponent "%InstallMount%\%%i", "Voice Recorder App", "SoundRecorder"
		if "%Component%" equ "StickyNotes" call :RemoveWindowsComponent "%InstallMount%\%%i", "Sticky Notes App", "StickyNotes"
		if "%Component%" equ "VP9VideoExtensions" call :RemoveWindowsComponent "%InstallMount%\%%i", "Google's VP9 WebM Video Codec Plugin", "VP9VideoExtensions"
		if "%Component%" equ "WalletService" call :RemoveWindowsComponent "%InstallMount%\%%i", "Microsoft Pay App", "WalletService"
		if "%Component%" equ "WebMediaExtensions" call :RemoveWindowsComponent "%InstallMount%\%%i", "Web Media Extension Plugin", "WebMediaExtensions"
		if "%Component%" equ "WebpImageExtensions" call :RemoveWindowsComponent "%InstallMount%\%%i", "Webp Image Extension Plugin", "WebpImageExtensions"
		if "%Component%" equ "WindowsStore" call :RemoveWindowsComponent "%InstallMount%\%%i", "Windows Store App", "WindowsStore"
		if "%Component%" equ "XboxApp" call :RemoveWindowsComponent "%InstallMount%\%%i", "Xbox App", "XboxApp"
		if "%Component%" equ "XboxIdentityProvider" call :RemoveWindowsComponent "%InstallMount%\%%i", "Xbox Identity Provider", "XboxIdentityProvider"
		if "%Component%" equ "YourPhone" call :RemoveWindowsComponent "%InstallMount%\%%i", "Your Phone App", "YourPhone"
		if "%Component%" equ "ZuneMusic" call :RemoveWindowsComponent "%InstallMount%\%%i", "Groove Music App", "ZuneMusic"
		if "%Component%" equ "ZuneVideo" if "%ImageBuild%" leq "18363" call :RemoveWindowsComponent "%InstallMount%\%%i", "Films and TV App", "ZuneVideo"
		if "%Component%" equ "ZuneVideo" if "%ImageBuild%" equ "19041" call :RemoveWindowsComponent "%InstallMount%\%%i", "Movies and TV App", "ZuneVideo"

		if "%Component%" equ "InternetComponents" call :RemoveWindowsComponent "%InstallMount%\%%i", "Internet Components", "Internet"
		if "%Component%" equ "MultimediaComponents" call :RemoveWindowsComponent "%InstallMount%\%%i", "Multimedia Components", "Multimedia"
		if "%Component%" equ "PrivacyComponents" call :RemoveWindowsComponent "%InstallMount%\%%i", "Privacy Components", "Privacy"
		if "%Component%" equ "RemotingComponents" call :RemoveWindowsComponent "%InstallMount%\%%i", "Remoting Components", "Remoting"
		if "%Component%" equ "SystemComponents" call :RemoveWindowsComponent "%InstallMount%\%%i", "System Components", "System"

		if "%Component%" equ "SystemApps" (
			if "%ImageFlag%" neq "Core" if "%ImageFlag%" neq "CoreN" if "%ImageFlag%" neq "CoreSingleEdition" call :RemoveWindowsComponent "%InstallMount%\%%i", "Assigned Access Lock App", "AssignedAccessLockApp"
			call :RemoveWindowsComponent "%InstallMount%\%%i", "Azure Active Directory AppX Broker Plugin", "AADBrokerPlugin"
			call :RemoveWindowsComponent "%InstallMount%\%%i", "Bio Enrollment App", "BioEnrollment"
			call :RemoveWindowsComponent "%InstallMount%\%%i", "Camera Barcode Scanner", "CBSPreview"
			if "%ImageBuild%" geq "17763" if "%ImageBuild%" leq "18363" if "%ImageFlag%" neq "Core" if "%ImageFlag%" neq "CoreN" if "%ImageFlag%" neq "CoreSingleEdition" if "%ImageFlag%" neq "EnterpriseS" if "%ImageFlag%" neq "EnterpriseSN" call :RemoveWindowsComponent "%InstallMount%\%%i", "Connect App", "PPIProjection"
			call :RemoveWindowsComponent "%InstallMount%\%%i", "Content Delivery Manager", "ContentDeliveryManager"
			if "%ImageBuild%" geq "17763" if "%ImageBuild%" leq "18363" call :RemoveWindowsComponent "%InstallMount%\%%i", "Cortana, StartMenu and Settings Search App", "Cortana"
			if "%ImageFlag%" neq "EnterpriseS" if "%ImageFlag%" neq "EnterpriseSN" call :RemoveWindowsComponent "%InstallMount%\%%i", "Edge Browser App", "Edge"
			call :RemoveWindowsComponent "%InstallMount%\%%i", "Edge Developer Tools Client", "EdgeDevToolsClient"
			call :RemoveWindowsComponent "%InstallMount%\%%i", "Eye Control App", "ECApp"
			call :RemoveWindowsComponent "%InstallMount%\%%i", "File Explorer App", "FileExplorer"
			call :RemoveWindowsComponent "%InstallMount%\%%i", "Lockscreen App", "LockApp"
			call :RemoveWindowsComponent "%InstallMount%\%%i", "Map Control", "MapControl"
			call :RemoveWindowsComponent "%InstallMount%\%%i", "Narrator QuickStart", "NarratorQuickStart"
			if "%ImageFlag%" neq "EnterpriseS" if "%ImageFlag%" neq "EnterpriseSN" call :RemoveWindowsComponent "%InstallMount%\%%i", "OneDrive Desktop Client", "OneDrive"
			call :RemoveWindowsComponent "%InstallMount%\%%i", "Parental Controls App", "ParentalControls"
			call :RemoveWindowsComponent "%InstallMount%\%%i", "People Experience Host", "PeopleExperienceHost"
			call :RemoveWindowsComponent "%InstallMount%\%%i", "Quick Assist App", "QuickAssist"
			call :RemoveWindowsComponent "%InstallMount%\%%i", "Retail Demo Content", "RetailDemoContent"
			call :RemoveWindowsComponent "%InstallMount%\%%i", "Setting Sync", "SettingSync"
			call :RemoveWindowsComponent "%InstallMount%\%%i", "Skype ORTC", "SkypeORTC"
			call :RemoveWindowsComponent "%InstallMount%\%%i", "SmartScreen App", "SmartScreen"
			if "%ImageFlag%" neq "Core" if "%ImageFlag%" neq "CoreN" if "%ImageFlag%" neq "CoreSingleEdition" if "%ImageFlag%" neq "EnterpriseS" if "%ImageFlag%" neq "EnterpriseSN" call :RemoveWindowsComponent "%InstallMount%\%%i", "Take Test App", "SecureAssessmentBrowser"
			call :RemoveWindowsComponent "%InstallMount%\%%i", "Win32 WebView Host", "Win32WebViewHost"
			call :RemoveWindowsComponent "%InstallMount%\%%i", "Windows Defender App", "WindowsDefender"
			call :RemoveWindowsComponent "%InstallMount%\%%i", "Windows Mixed Reality", "WindowsMixedReality"
			call :RemoveWindowsComponent "%InstallMount%\%%i", "Windows Reader [PDF]", "WindowsReaderPDF"
			call :RemoveWindowsComponent "%InstallMount%\%%i", "Xbox Game Callable UI", "XboxGameCallableUI"
		)

		if "%Component%" equ "WindowsApps" (
			call :RemoveWindowsComponent "%InstallMount%\%%i", "Advertising Xaml", "AdvertisingXaml"
			call :RemoveWindowsComponent "%InstallMount%\%%i", "Alarms and Clock App", "Alarms"
			call :RemoveWindowsComponent "%InstallMount%\%%i", "Calculator App", "Calculator"
			call :RemoveWindowsComponent "%InstallMount%\%%i", "Camera App", "Camera"
			if "%ImageBuild%" equ "19041" call :RemoveWindowsComponent "%InstallMount%\%%i", "Cortana App", "Cortana"
			call :RemoveWindowsComponent "%InstallMount%\%%i", "Desktop App Installer", "DesktopAppInstaller"
			call :RemoveWindowsComponent "%InstallMount%\%%i", "Feedback Hub App", "FeedbackHub"
			if "%ImageBuild%" leq "18363" call :RemoveWindowsComponent "%InstallMount%\%%i", "Films and TV App", "ZuneVideo"
			call :RemoveWindowsComponent "%InstallMount%\%%i", "Get Help App", "GetHelp"
			call :RemoveWindowsComponent "%InstallMount%\%%i", "Google's VP9 WebM Video Codec Plugin", "VP9VideoExtensions"
			call :RemoveWindowsComponent "%InstallMount%\%%i", "Groove Music App", "ZuneMusic"
			call :RemoveWindowsComponent "%InstallMount%\%%i", "High Efficiency Image File Codec Plugin", "HEIFImageExtension"
			call :RemoveWindowsComponent "%InstallMount%\%%i", "Maps App", "Maps"
			if "%ImageBuild%" leq "18363" call :RemoveWindowsComponent "%InstallMount%\%%i", "Messaging App", "Messaging"
			call :RemoveWindowsComponent "%InstallMount%\%%i", "Microsoft Pay App", "WalletService"
			call :RemoveWindowsComponent "%InstallMount%\%%i", "Mixed Reality Viewer App", "3DViewer"
			if "%ImageArchitecture%" equ "x64" call :RemoveWindowsComponent "%InstallMount%\%%i", "Mixed Reality Portal App", "MixedRealityPortal"
			if "%ImageBuild%" equ "19041" call :RemoveWindowsComponent "%InstallMount%\%%i", "Films and TV App", "ZuneVideo"
			if "%ImageBuild%" leq "18363" call :RemoveWindowsComponent "%InstallMount%\%%i", "Mobile Plans App", "OneConnect"		
			call :RemoveWindowsComponent "%InstallMount%\%%i", "My Office App", "OfficeHub"
			call :RemoveWindowsComponent "%InstallMount%\%%i", "OneNote App", "OfficeOneNote"
			call :RemoveWindowsComponent "%InstallMount%\%%i", "Paint 3D App", "Paint3D"
			call :RemoveWindowsComponent "%InstallMount%\%%i", "People App", "People"
			call :RemoveWindowsComponent "%InstallMount%\%%i", "Photos App", "Photos"
			if "%ImageBuild%" leq "18363" call :RemoveWindowsComponent "%InstallMount%\%%i", "Print 3D App", "Print3D"
			call :RemoveWindowsComponent "%InstallMount%\%%i", "Screen Sketch App", "ScreenSketch"
			call :RemoveWindowsComponent "%InstallMount%\%%i", "Skype App", "SkypeApp"
			call :RemoveWindowsComponent "%InstallMount%\%%i", "Solitaire Collection App", "SolitaireCollection"
			call :RemoveWindowsComponent "%InstallMount%\%%i", "Sticky Notes App", "StickyNotes"
			call :RemoveWindowsComponent "%InstallMount%\%%i", "Tips App", "Getstarted"
			call :RemoveWindowsComponent "%InstallMount%\%%i", "Voice Recorder App", "SoundRecorder"
			call :RemoveWindowsComponent "%InstallMount%\%%i", "Weather App", "BingWeather"
			call :RemoveWindowsComponent "%InstallMount%\%%i", "Web Media Extension Plugin", "WebMediaExtensions"
			call :RemoveWindowsComponent "%InstallMount%\%%i", "Webp Image Extension Plugin", "WebpImageExtensions"
			call :RemoveWindowsComponent "%InstallMount%\%%i", "Windows Mail App", "CommunicationsApps"
			call :RemoveWindowsComponent "%InstallMount%\%%i", "Windows Store App", "WindowsStore"
			call :RemoveWindowsComponent "%InstallMount%\%%i", "Xbox App", "XboxApp"
			call :RemoveWindowsComponent "%InstallMount%\%%i", "Xbox Identity Provider", "XboxIdentityProvider"
			call :RemoveWindowsComponent "%InstallMount%\%%i", "Your Phone App", "YourPhone"
		)
	)
) else (
	:: Internet Components
	if "%Component%" equ "AdobeFlashForWindows" call :RemoveWindowsComponent "%InstallMount%", "Adobe Flash For Windows", "AdobeFlashForWindows"
	if "%Component%" equ "InternetExplorer" call :RemoveWindowsComponent "%InstallMount%", "Internet Explorer", "InternetExplorer"

	:: Multimedia Components
	if "%Component%" equ "FirstLogonAnimation" call :RemoveWindowsComponent "%InstallMount%", "First Logon Animation", "FirstLogonAnimation"
	if "%Component%" equ "GameExplorer" call :RemoveWindowsComponent "%InstallMount%", "Game Explorer", "GameExplorer"
	if "%Component%" equ "SnippingTool" call :RemoveWindowsComponent "%InstallMount%", "Snipping Tool", "SnippingTool"
	if "%Component%" equ "SpeechRecognition" call :RemoveWindowsComponent "%InstallMount%", "Speech Recognition", "SpeechRecognition"
	if "%Component%" equ "WindowsMediaPlayer" call :RemoveWindowsComponent "%InstallMount%", "Windows Media Player", "WindowsMediaPlayer"
	if "%Component%" equ "WindowsPhotoViewer" call :RemoveWindowsComponent "%InstallMount%", "Windows Photo Viewer", "WindowsPhotoViewer"
	if "%Component%" equ "WinSAT" call :RemoveWindowsComponent "%InstallMount%", "Windows System Assessment Tool", "WinSAT"

	:: Privacy Components
	if "%Component%" equ "AssignedAccess" call :RemoveWindowsComponent "%InstallMount%", "Assigned Access", "AssignedAccess"
	if "%Component%" equ "CEIP_SQM" call :RemoveWindowsComponent "%InstallMount%", "Customer Experience Improvement Program [CEIP]", "CEIP_SQM"
	if "%Component%" equ "FaceRecognition" call :RemoveWindowsComponent "%InstallMount%", "Face Recognition", "FaceRecognition"
	if "%Component%" equ "KernelDebugging" call :RemoveWindowsComponent "%InstallMount%", "Kernel Debugging", "KernelDebugging"
	if "%Component%" equ "LocationService" call :RemoveWindowsComponent "%InstallMount%", "Location Service", "LocationService"
	if "%Component%" equ "PicturePassword" call :RemoveWindowsComponent "%InstallMount%", "Picture Password", "PicturePassword"
	if "%Component%" equ "PinEnrollment" call :RemoveWindowsComponent "%InstallMount%", "Pin Enrollment", "PinEnrollment"
	if "%Component%" equ "UnifiedTelemetryClient" call :RemoveWindowsComponent "%InstallMount%", "Unified Telemetry Client [Asimov]", "UnifiedTelemetryClient"
	if "%Component%" equ "WiFiNetworkManager" call :RemoveWindowsComponent "%InstallMount%", "WiFi Network Manager", "WiFiNetworkManager"
	if "%Component%" equ "WindowsErrorReporting" call :RemoveWindowsComponent "%InstallMount%", "Windows Error Reporting", "WindowsErrorReporting"
	if "%Component%" equ "WindowsInsiderHub" call :RemoveWindowsComponent "%InstallMount%", "Windows Insider Hub", "WindowsInsiderHub"

	:: Remoting Components
	if "%Component%" equ "HomeGroup" call :RemoveWindowsComponent "%InstallMount%", "HomeGroup", "HomeGroup"
	if "%Component%" equ "MultiPointConnector" call :RemoveWindowsComponent "%InstallMount%", "MultiPoint Connector", "MultiPointConnector"
	if "%Component%" equ "RemoteAssistance" call :RemoveWindowsComponent "%InstallMount%", "Remote Assistance", "RemoteAssistance"

	:: System Components
	if "%Component%" equ "DeviceLockdown" call :RemoveWindowsComponent "%InstallMount%", "Device Lockdown [Embedded Experience]", "DeviceLockdown"
	if "%Component%" equ "EaseOfAccessThemes" call :RemoveWindowsComponent "%InstallMount%", "Ease Of Access Themes", "EaseOfAccessThemes"
	if "%Component%" equ "EasyTransfer" call :RemoveWindowsComponent "%InstallMount%", "Easy Transfer", "EasyTransfer"
	if "%Component%" equ "FileHistory" call :RemoveWindowsComponent "%InstallMount%", "File History", "FileHistory"
	if "%Component%" equ "ManualSetup" call :RemoveWindowsManualSetup
	if "%Component%" equ "Paint" call :RemoveWindowsComponent "%InstallMount%", "Microsoft Paint", "Paint"
	if "%Component%" equ "SecurityCenter" call :RemoveWindowsComponent "%InstallMount%", "Security Center", "SecurityCenter"
	if "%Component%" equ "StepsRecorder" call :RemoveWindowsComponent "%InstallMount%", "Steps Recorder", "StepsRecorder"
	if "%Component%" equ "SystemRestore" call :RemoveWindowsComponent "%InstallMount%", "System Restore", "SystemRestore"
	if "%Component%" equ "WindowsBackup" call :RemoveWindowsComponent "%InstallMount%", "Windows Backup", "WindowsBackup"
	if "%Component%" equ "WindowsSubsystemForLinux" call :RemoveWindowsComponent "%InstallMount%", "Windows Subsystem For Linux", "WindowsSubsystemForLinux"
	if "%Component%" equ "WindowsToGo" call :RemoveWindowsComponent "%InstallMount%", "Windows To Go", "WindowsToGo"
	if "%Component%" equ "Wordpad" call :RemoveWindowsComponent "%InstallMount%", "Wordpad", "Wordpad"

	:: System Apps
	if "%Component%" equ "AADBrokerPlugin" call :RemoveWindowsComponent "%InstallMount%", "Azure Active Directory AppX Broker Plugin", "AADBrokerPlugin"
	if "%Component%" equ "AssignedAccessLockApp" call :RemoveWindowsComponent "%InstallMount%", "Assigned Access Lock App", "AssignedAccessLockApp"
	if "%Component%" equ "BioEnrollment" call :RemoveWindowsComponent "%InstallMount%", "Bio Enrollment App", "BioEnrollment"
	if "%Component%" equ "CBSPreview" call :RemoveWindowsComponent "%InstallMount%", "Camera Barcode Scanner", "CBSPreview"
	if "%Component%" equ "ContentDeliveryManager" call :RemoveWindowsComponent "%InstallMount%", "Content Delivery Manager", "ContentDeliveryManager"
	if "%ImageBuild%" geq "17763" if "%ImageBuild%" leq "18363" if "%Component%" equ "Cortana" call :RemoveWindowsComponent "%InstallMount%", "Cortana, StartMenu and Settings Search App", "Cortana"
	if "%Component%" equ "ECApp" call :RemoveWindowsComponent "%InstallMount%", "Eye Control App", "ECApp"
	if "%Component%" equ "Edge" (
		call :RemoveWindowsComponent "%InstallMount%", "Edge Developer Tools Client", "EdgeDevToolsClient"
		call :RemoveWindowsComponent "%InstallMount%", "Edge Browser App", "Edge"
		call :RemoveWindowsComponent "%InstallMount%", "Windows Reader [PDF]", "WindowsReaderPDF"
	)
	if "%Component%" equ "EdgeDevToolsClient" call :RemoveWindowsComponent "%InstallMount%", "Edge Developer Tools Client", "EdgeDevToolsClient"
	if "%Component%" equ "FileExplorer" call :RemoveWindowsComponent "%InstallMount%", "File Explorer App", "FileExplorer"
	if "%Component%" equ "LockApp" call :RemoveWindowsComponent "%InstallMount%", "Lockscreen App", "LockApp"
	if "%Component%" equ "MapControl" call :RemoveWindowsComponent "%InstallMount%", "Map Control", "MapControl"
	if "%Component%" equ "NarratorQuickStart" call :RemoveWindowsComponent "%InstallMount%", "Narrator QuickStart", "NarratorQuickStart"
	if "%Component%" equ "OneDrive" call :RemoveWindowsComponent "%InstallMount%", "OneDrive Desktop Client", "OneDrive"
	if "%Component%" equ "ParentalControls" call :RemoveWindowsComponent "%InstallMount%", "Parental Controls App", "ParentalControls"
	if "%Component%" equ "PeopleExperienceHost" call :RemoveWindowsComponent "%InstallMount%", "People Experience Host", "PeopleExperienceHost"
	if "%ImageBuild%" geq "17763" if "%ImageBuild%" leq "18363" if "%Component%" equ "PPIProjection" call :RemoveWindowsComponent "%InstallMount%", "Connect App", "PPIProjection"
	if "%Component%" equ "QuickAssist" call :RemoveWindowsComponent "%InstallMount%", "Quick Assist App", "QuickAssist"
	if "%Component%" equ "RetailDemoContent" call :RemoveWindowsComponent "%InstallMount%", "Retail Demo Content", "RetailDemoContent"
	if "%Component%" equ "SecureAssessmentBrowser" call :RemoveWindowsComponent "%InstallMount%", "Take Test App", "SecureAssessmentBrowser"
	if "%Component%" equ "SettingSync" call :RemoveWindowsComponent "%InstallMount%", "Setting Sync", "SettingSync"
	if "%Component%" equ "SkypeORTC" call :RemoveWindowsComponent "%InstallMount%", "Skype ORTC", "SkypeORTC"
	if "%Component%" equ "SmartScreen" call :RemoveWindowsComponent "%InstallMount%", "SmartScreen App", "SmartScreen"
	if "%Component%" equ "Win32WebViewHost" call :RemoveWindowsComponent "%InstallMount%", "Win32 WebView Host", "Win32WebViewHost"
	if "%Component%" equ "WindowsDefender" call :RemoveWindowsComponent "%InstallMount%", "Windows Defender App", "WindowsDefender"
	if "%Component%" equ "WindowsMixedReality" call :RemoveWindowsComponent "%InstallMount%", "Windows Mixed Reality", "WindowsMixedReality"
	if "%Component%" equ "WindowsReaderPDF" call :RemoveWindowsComponent "%InstallMount%", "Windows Reader [PDF]", "WindowsReaderPDF"
	if "%Component%" equ "XboxGameCallableUI" call :RemoveWindowsComponent "%InstallMount%", "Xbox Game Callable UI", "XboxGameCallableUI"

	:: Windows Apps
	if "%Component%" equ "3DViewer" call :RemoveWindowsComponent "%InstallMount%", "Mixed Reality Viewer App", "3DViewer"
	if "%Component%" equ "AdvertisingXaml" call :RemoveWindowsComponent "%InstallMount%", "Advertising Xaml", "AdvertisingXaml"
	if "%Component%" equ "Alarms" call :RemoveWindowsComponent "%InstallMount%", "Alarms and Clock App", "Alarms"
	if "%Component%" equ "BingWeather" call :RemoveWindowsComponent "%InstallMount%", "Weather App", "BingWeather"
	if "%Component%" equ "Calculator" call :RemoveWindowsComponent "%InstallMount%", "Calculator App", "Calculator"
	if "%Component%" equ "Camera" call :RemoveWindowsComponent "%InstallMount%", "Camera App", "Camera"
	if "%ImageBuild%" equ "19041" if "%Component%" equ "Cortana" call :RemoveWindowsComponent "%InstallMount%", "Cortana App", "Cortana"
	if "%Component%" equ "CommunicationsApps" call :RemoveWindowsComponent "%InstallMount%", "Windows Mail App", "CommunicationsApps"
	if "%Component%" equ "DesktopAppInstaller" call :RemoveWindowsComponent "%InstallMount%", "Desktop App Installer", "DesktopAppInstaller"
	if "%Component%" equ "FeedbackHub" call :RemoveWindowsComponent "%InstallMount%", "Feedback Hub App", "FeedbackHub"
	if "%Component%" equ "GetHelp" call :RemoveWindowsComponent "%InstallMount%", "Get Help App", "GetHelp"
	if "%Component%" equ "Getstarted" call :RemoveWindowsComponent "%InstallMount%", "Tips App", "Getstarted"
	if "%Component%" equ "HEIFImageExtension" call :RemoveWindowsComponent "%InstallMount%", "High Efficiency Image File Codec Plugin", "HEIFImageExtension"
	if "%Component%" equ "Maps" call :RemoveWindowsComponent "%InstallMount%", "Maps App", "Maps"
	if "%Component%" equ "Messaging" call :RemoveWindowsComponent "%InstallMount%", "Messaging App", "Messaging"
	if "%Component%" equ "MixedRealityPortal" call :RemoveWindowsComponent "%InstallMount%", "Mixed Reality Portal App", "MixedRealityPortal"
	if "%Component%" equ "OfficeHub" call :RemoveWindowsComponent "%InstallMount%", "My Office App", "OfficeHub"
	if "%Component%" equ "OfficeOneNote" call :RemoveWindowsComponent "%InstallMount%", "OneNote App", "OfficeOneNote"
	if "%Component%" equ "OneConnect" call :RemoveWindowsComponent "%InstallMount%", "Mobile Plans App", "OneConnect"
	if "%Component%" equ "Paint3D" call :RemoveWindowsComponent "%InstallMount%", "Paint 3D App", "Paint3D"
	if "%Component%" equ "People" call :RemoveWindowsComponent "%InstallMount%", "People App", "People"
	if "%Component%" equ "Photos" call :RemoveWindowsComponent "%InstallMount%", "Photos App", "Photos"
	if "%Component%" equ "Print3D" call :RemoveWindowsComponent "%InstallMount%", "Print 3D App", "Print3D"
	if "%Component%" equ "ScreenSketch" call :RemoveWindowsComponent "%InstallMount%", "Screen Sketch App", "ScreenSketch"
	if "%Component%" equ "SkypeApp" call :RemoveWindowsComponent "%InstallMount%", "Skype App", "SkypeApp"
	if "%Component%" equ "SolitaireCollection" call :RemoveWindowsComponent "%InstallMount%", "Solitaire Collection App", "SolitaireCollection"
	if "%Component%" equ "SoundRecorder" call :RemoveWindowsComponent "%InstallMount%", "Voice Recorder App", "SoundRecorder"
	if "%Component%" equ "StickyNotes" call :RemoveWindowsComponent "%InstallMount%", "Sticky Notes App", "StickyNotes"
	if "%Component%" equ "VP9VideoExtensions" call :RemoveWindowsComponent "%InstallMount%", "Google's VP9 WebM Video Codec Plugin", "VP9VideoExtensions"
	if "%Component%" equ "WalletService" call :RemoveWindowsComponent "%InstallMount%", "Microsoft Pay App", "WalletService"
	if "%Component%" equ "WebMediaExtensions" call :RemoveWindowsComponent "%InstallMount%", "Web Media Extension Plugin", "WebMediaExtensions"
	if "%Component%" equ "WebpImageExtensions" call :RemoveWindowsComponent "%InstallMount%", "Webp Image Extension Plugin", "WebpImageExtensions"
	if "%Component%" equ "WindowsStore" call :RemoveWindowsComponent "%InstallMount%", "Windows Store App", "WindowsStore"
	if "%Component%" equ "XboxApp" call :RemoveWindowsComponent "%InstallMount%", "Xbox App", "XboxApp"
	if "%Component%" equ "XboxIdentityProvider" call :RemoveWindowsComponent "%InstallMount%", "Xbox Identity Provider", "XboxIdentityProvider"
	if "%Component%" equ "YourPhone" call :RemoveWindowsComponent "%InstallMount%", "Your Phone App", "YourPhone"
	if "%Component%" equ "ZuneMusic" call :RemoveWindowsComponent "%InstallMount%", "Groove Music App", "ZuneMusic"
	if "%Component%" equ "ZuneVideo" if "%ImageBuild%" leq "18363" call :RemoveWindowsComponent "%InstallMount%", "Films and TV App", "ZuneVideo"
	if "%Component%" equ "ZuneVideo" if "%ImageBuild%" equ "19041" call :RemoveWindowsComponent "%InstallMount%", "Movies and TV App", "ZuneVideo"

	if "%Component%" equ "InternetComponents" call :RemoveWindowsComponent "%InstallMount%", "Internet Components", "Internet"
	if "%Component%" equ "MultimediaComponents" call :RemoveWindowsComponent "%InstallMount%", "Multimedia Components", "Multimedia"
	if "%Component%" equ "PrivacyComponents" call :RemoveWindowsComponent "%InstallMount%", "Privacy Components", "Privacy"
	if "%Component%" equ "RemotingComponents" call :RemoveWindowsComponent "%InstallMount%", "Remoting Components", "Remoting"
	if "%Component%" equ "SystemComponents" call :RemoveWindowsComponent "%InstallMount%", "System Components", "System"

	if "%Component%" equ "SystemApps" (
		if "%ImageFlag%" neq "Core" if "%ImageFlag%" neq "CoreN" if "%ImageFlag%" neq "CoreSingleEdition" call :RemoveWindowsComponent "%InstallMount%", "Assigned Access Lock App", "AssignedAccessLockApp"
		call :RemoveWindowsComponent "%InstallMount%", "Azure Active Directory AppX Broker Plugin", "AADBrokerPlugin"
		call :RemoveWindowsComponent "%InstallMount%", "Bio Enrollment App", "BioEnrollment"
		call :RemoveWindowsComponent "%InstallMount%", "Camera Barcode Scanner", "CBSPreview"
		if "%ImageBuild%" geq "17763" if "%ImageBuild%" leq "18363" if "%ImageFlag%" neq "Core" if "%ImageFlag%" neq "CoreN" if "%ImageFlag%" neq "CoreSingleEdition" if "%ImageFlag%" neq "EnterpriseS" if "%ImageFlag%" neq "EnterpriseSN" call :RemoveWindowsComponent "%InstallMount%", "Connect App", "PPIProjection"
		call :RemoveWindowsComponent "%InstallMount%", "Content Delivery Manager", "ContentDeliveryManager"
		if "%ImageBuild%" geq "17763" if "%ImageBuild%" leq "18363" call :RemoveWindowsComponent "%InstallMount%", "Cortana, StartMenu and Settings Search App", "Cortana"
		if "%ImageFlag%" neq "EnterpriseS" if "%ImageFlag%" neq "EnterpriseSN" call :RemoveWindowsComponent "%InstallMount%", "Edge Browser App", "Edge"
		call :RemoveWindowsComponent "%InstallMount%", "Edge Developer Tools Client", "EdgeDevToolsClient"
		call :RemoveWindowsComponent "%InstallMount%", "Eye Control App", "ECApp"
		call :RemoveWindowsComponent "%InstallMount%", "File Explorer App", "FileExplorer"
		call :RemoveWindowsComponent "%InstallMount%", "Lockscreen App", "LockApp"
		call :RemoveWindowsComponent "%InstallMount%", "Map Control", "MapControl"
		call :RemoveWindowsComponent "%InstallMount%", "Narrator QuickStart", "NarratorQuickStart"
		if "%ImageFlag%" neq "EnterpriseS" if "%ImageFlag%" neq "EnterpriseSN" call :RemoveWindowsComponent "%InstallMount%", "OneDrive Desktop Client", "OneDrive"
		call :RemoveWindowsComponent "%InstallMount%", "Parental Controls App", "ParentalControls"
		call :RemoveWindowsComponent "%InstallMount%", "People Experience Host", "PeopleExperienceHost"
		call :RemoveWindowsComponent "%InstallMount%", "Quick Assist App", "QuickAssist"
		call :RemoveWindowsComponent "%InstallMount%", "Retail Demo Content", "RetailDemoContent"
		call :RemoveWindowsComponent "%InstallMount%", "Setting Sync", "SettingSync"
		call :RemoveWindowsComponent "%InstallMount%", "Skype ORTC", "SkypeORTC"
		call :RemoveWindowsComponent "%InstallMount%", "SmartScreen App", "SmartScreen"
		if "%ImageFlag%" neq "Core" if "%ImageFlag%" neq "CoreN" if "%ImageFlag%" neq "CoreSingleEdition" if "%ImageFlag%" neq "EnterpriseS" if "%ImageFlag%" neq "EnterpriseSN" call :RemoveWindowsComponent "%InstallMount%", "Take Test App", "SecureAssessmentBrowser"
		call :RemoveWindowsComponent "%InstallMount%", "Win32 WebView Host", "Win32WebViewHost"
		call :RemoveWindowsComponent "%InstallMount%", "Windows Defender App", "WindowsDefender"
		call :RemoveWindowsComponent "%InstallMount%", "Windows Mixed Reality", "WindowsMixedReality"
		call :RemoveWindowsComponent "%InstallMount%", "Windows Reader [PDF]", "WindowsReaderPDF"
		call :RemoveWindowsComponent "%InstallMount%", "Xbox Game Callable UI", "XboxGameCallableUI"
	)

	if "%Component%" equ "WindowsApps" (
		call :RemoveWindowsComponent "%InstallMount%", "Advertising Xaml", "AdvertisingXaml"
		call :RemoveWindowsComponent "%InstallMount%", "Alarms and Clock App", "Alarms"
		call :RemoveWindowsComponent "%InstallMount%", "Calculator App", "Calculator"
		call :RemoveWindowsComponent "%InstallMount%", "Camera App", "Camera"
		if "%ImageBuild%" equ "19041" call :RemoveWindowsComponent "%InstallMount%", "Cortana App", "Cortana"
		call :RemoveWindowsComponent "%InstallMount%", "Desktop App Installer", "DesktopAppInstaller"
		call :RemoveWindowsComponent "%InstallMount%", "Feedback Hub App", "FeedbackHub"
		if "%ImageBuild%" leq "18363" call :RemoveWindowsComponent "%InstallMount%", "Films and TV App", "ZuneVideo"
		call :RemoveWindowsComponent "%InstallMount%", "Get Help App", "GetHelp"
		call :RemoveWindowsComponent "%InstallMount%", "Google's VP9 WebM Video Codec Plugin", "VP9VideoExtensions"
		call :RemoveWindowsComponent "%InstallMount%", "Groove Music App", "ZuneMusic"
		call :RemoveWindowsComponent "%InstallMount%", "High Efficiency Image File Codec Plugin", "HEIFImageExtension"
		call :RemoveWindowsComponent "%InstallMount%", "Maps App", "Maps"
		if "%ImageBuild%" leq "18363" call :RemoveWindowsComponent "%InstallMount%", "Messaging App", "Messaging"
		call :RemoveWindowsComponent "%InstallMount%", "Microsoft Pay App", "WalletService"
		call :RemoveWindowsComponent "%InstallMount%", "Mixed Reality Viewer App", "3DViewer"
		if "%ImageArchitecture%" equ "x64" call :RemoveWindowsComponent "%InstallMount%", "Mixed Reality Portal App", "MixedRealityPortal"
		if "%ImageBuild%" equ "19041" call :RemoveWindowsComponent "%InstallMount%", "Movies and TV App", "ZuneVideo"
		if "%ImageBuild%" leq "18363" call :RemoveWindowsComponent "%InstallMount%", "Mobile Plans App", "OneConnect"
		call :RemoveWindowsComponent "%InstallMount%", "My Office App", "OfficeHub"
		call :RemoveWindowsComponent "%InstallMount%", "OneNote App", "OfficeOneNote"
		call :RemoveWindowsComponent "%InstallMount%", "Paint 3D App", "Paint3D"
		call :RemoveWindowsComponent "%InstallMount%", "People App", "People"
		call :RemoveWindowsComponent "%InstallMount%", "Photos App", "Photos"
		if "%ImageBuild%" leq "18363" call :RemoveWindowsComponent "%InstallMount%", "Print 3D App", "Print3D"
		call :RemoveWindowsComponent "%InstallMount%", "Screen Sketch App", "ScreenSketch"
		call :RemoveWindowsComponent "%InstallMount%", "Skype App", "SkypeApp"
		call :RemoveWindowsComponent "%InstallMount%", "Solitaire Collection App", "SolitaireCollection"
		call :RemoveWindowsComponent "%InstallMount%", "Sticky Notes App", "StickyNotes"
		call :RemoveWindowsComponent "%InstallMount%", "Tips App", "Getstarted"
		call :RemoveWindowsComponent "%InstallMount%", "Voice Recorder App", "SoundRecorder"
		call :RemoveWindowsComponent "%InstallMount%", "Weather App", "BingWeather"
		call :RemoveWindowsComponent "%InstallMount%", "Web Media Extension Plugin", "WebMediaExtensions"
		call :RemoveWindowsComponent "%InstallMount%", "Webp Image Extension Plugin", "WebpImageExtensions"
		call :RemoveWindowsComponent "%InstallMount%", "Windows Mail App", "CommunicationsApps"
		call :RemoveWindowsComponent "%InstallMount%", "Windows Store App", "WindowsStore"
		call :RemoveWindowsComponent "%InstallMount%", "Xbox App", "XboxApp"
		call :RemoveWindowsComponent "%InstallMount%", "Xbox Identity Provider", "XboxIdentityProvider"
		call :RemoveWindowsComponent "%InstallMount%", "Your Phone App", "YourPhone"
	)
)
echo.-------------------------------------------------------------------------------
echo.####Finished Removing Windows Components#######################################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set Component=
endlocal

:: Returning to Main Menu.
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Remove Windows Manual Setup Feature
::-------------------------------------------------------------------------------------------
:RemoveWindowsManualSetup

echo.-------------------------------------------------------------------------------
echo.Removing Windows Manual Setup Feature...
echo.-------------------------------------------------------------------------------
echo.
		
:: Removing Windows Manual Setup Feature files and folders
echo.Please Wait, Deleting Windows Manual Setup files ^& folders...

call :RemoveFile "%DVD%\autorun.inf"
call :RemoveFile "%DVD%\setup.exe"
call :RemoveFile "%DVD%\*.dll"
call :RemoveFolder "%DVD%\ca"
call :RemoveFolder "%DVD%\NanoServer"
call :RemoveFolder "%DVD%\support"
call :RemoveFolder "%DVD%\upgrade"
call :RemoveFolder "%DVD%\sources\dlmanifests"
call :RemoveFolder "%DVD%\sources\etwproviders"
call :RemoveFolder "%DVD%\sources\inf"
call :RemoveFolder "%DVD%\sources\hwcompat"
call :RemoveFolder "%DVD%\sources\migration"
call :RemoveFolder "%DVD%\sources\replacementmanifests"
call :RemoveFolder "%DVD%\sources\servicing"
call :RemoveFolder "%DVD%\sources\servicingstackmisc"
call :RemoveFolder "%DVD%\sources\sxs"
call :RemoveFolder "%DVD%\sources\vista"
call :RemoveFolder "%DVD%\sources\xp"

if exist "%DVD%\sources\%ImageDefaultLanguage%\setup.exe.mui" move /y "%DVD%\sources\%ImageDefaultLanguage%\setup.exe.mui" "%DVD%" >nul
if exist "%DVD%\sources\EI.CFG" move /y "%DVD%\sources\EI.CFG" "%DVD%" >nul
if exist "%DVD%\sources\*.clg" move /y "%DVD%\sources\*.clg" "%DVD%" >nul
if exist "%DVD%\sources\gatherosstate.exe" move /y "%DVD%\sources\gatherosstate.exe" "%DVD%" >nul
if exist "%DVD%\sources\setup.exe" move /y "%DVD%\sources\setup.exe" "%DVD%" >nul
if exist "%DVD%\sources\lang.ini" move /y "%DVD%\sources\lang.ini" "%DVD%" >nul
if exist "%DVD%\sources\pid.txt" move /y "%DVD%\sources\pid.txt" "%DVD%" >nul

call :RemoveFile "%DVD%\sources\%ImageDefaultLanguage%\*.adml"
call :RemoveFile "%DVD%\sources\%ImageDefaultLanguage%\*.mui"
call :RemoveFile "%DVD%\sources\%ImageDefaultLanguage%\*.rtf"
call :RemoveFile "%DVD%\sources\%ImageDefaultLanguage%\*.txt"
call :RemoveFile "%DVD%\sources\*.dll"
call :RemoveFile "%DVD%\sources\*.gif"
call :RemoveFile "%DVD%\sources\*.xsl"
call :RemoveFile "%DVD%\sources\*.bmp"
call :RemoveFile "%DVD%\sources\*.mof"
call :RemoveFile "%DVD%\sources\*.ini"
call :RemoveFile "%DVD%\sources\*.cer"
call :RemoveFile "%DVD%\sources\*.exe"
call :RemoveFile "%DVD%\sources\*.sdb"
call :RemoveFile "%DVD%\sources\*.txt"
call :RemoveFile "%DVD%\sources\*.nls"
call :RemoveFile "%DVD%\sources\*.xml"
call :RemoveFile "%DVD%\sources\*.cat"
call :RemoveFile "%DVD%\sources\*.inf"
call :RemoveFile "%DVD%\sources\*.sys"
call :RemoveFile "%DVD%\sources\*.bin"
call :RemoveFile "%DVD%\sources\*.ait"
call :RemoveFile "%DVD%\sources\*.admx"
call :RemoveFile "%DVD%\sources\*.dat"
call :RemoveFile "%DVD%\sources\*.ttf"
call :RemoveFile "%DVD%\sources\*.cfg"
call :RemoveFile "%DVD%\sources\*.xsd"
call :RemoveFile "%DVD%\sources\*.rtf"
call :RemoveFile "%DVD%\sources\*.xrm-ms"

if exist "%DVD%\setup.exe.mui" move /y "%DVD%\setup.exe.mui" "%DVD%\sources\%ImageDefaultLanguage%" >nul
if exist "%DVD%\EI.CFG" move /y "%DVD%\EI.CFG" "%DVD%\sources" >nul
if exist "%DVD%\*.clg" move /y "%DVD%\*.clg" "%DVD%\sources" >nul
if exist "%DVD%\gatherosstate.exe" move /y "%DVD%\gatherosstate.exe" "%DVD%\sources" >nul
if exist "%DVD%\setup.exe" move /y "%DVD%\setup.exe" "%DVD%\sources" >nul
if exist "%DVD%\lang.ini" move /y "%DVD%\lang.ini" "%DVD%\sources" >nul
if exist "%DVD%\pid.txt" move /y "%DVD%\pid.txt" "%DVD%\sources" >nul
echo.
echo.Finished Deleting, Windows Manual Setup files ^& folders...
echo.

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Remove Windows Apps Using Apps List
::-------------------------------------------------------------------------------------------
:RemoveWindowsAppsList

setlocal

set "RemoveAppsList=%Lists%\RemoveAppsList.txt"

cls
echo.===============================================================================
echo.          MSMG ToolKit - Remove Windows Apps Using Apps List
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
if "%ImageIndexNo%" equ "*" call :GetImageArchitecture "%InstallWim%", 1 >nul
if "%ImageIndexNo%" neq "*" call :GetImageArchitecture "%InstallWim%", %ImageIndexNo% >nul

echo.-------------------------------------------------------------------------------
echo.####Starting Remove Windows Apps Using Apps List###############################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if "%ImageIndexNo%" equ "*" echo.    Image Indexes            : 1-%ImageCount%
if "%ImageIndexNo%" neq "*" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
if "%ImageIndexNo%" neq "*" echo.    Image Edition            : %ImageEdition%
echo.    Image Default Language   : %ImageDefaultLanguage%
echo.
echo.-------------------------------------------------------------------------------
echo.####Removing Windows Apps Using Apps List######################################
echo.-------------------------------------------------------------------------------
echo.
if "%ImageIndexNo%" equ "*" (
	echo.
	for /L %%i in (1, 1, %ImageCount%) do (
		if not "%ImageIndexNo%" gtr "9" echo.##########################[Install.wim, Index : %%i]#############################
		if "%ImageIndexNo%" gtr "9" echo.##########################[Install.wim, Index : %%i]############################
		echo.	

		for /f %%z IN ('"type %RemoveAppsList%" 2^>nul') do (
			call :RemoveProvisionedAppxPackage "%InstallMount%\%%i", %%z, %%z
			
			if "%%z" equ "Microsoft.3DBuilder" (
				:: Mounting Image Registry
				call :MountImageRegistry "%InstallMount%\%%i"
	
				:: Removing 3D Print with 3D Builder option from right click context menu
				Reg delete "HKLM\TK_SOFTWARE\Classes\SystemFileAssociations\.bmp\Shell\T3D Print" /f >nul 2>&1
				Reg delete "HKLM\TK_SOFTWARE\Classes\SystemFileAssociations\.jpg\Shell\T3D Print" /f >nul 2>&1
				Reg delete "HKLM\TK_SOFTWARE\Classes\SystemFileAssociations\.png\Shell\T3D Print" /f >nul 2>&1
				
				:: Un-Mounting Image Registry
				call :UnMountImageRegistry
			)
			
			if "%%z" equ "Microsoft.MSPaint" (
				:: Mounting Image Registry
				call :MountImageRegistry "%InstallMount%\%%i"
	
				:: Removing Edit with Paint 3D Option from right click context menu
				Reg delete "HKLM\TK_SOFTWARE\Classes\SystemFileAssociations\.3mf\Shell\3D Edit" /f >nul 2>&1
				Reg delete "HKLM\TK_SOFTWARE\Classes\SystemFileAssociations\.bmp\Shell\3D Edit" /f >nul 2>&1
				Reg delete "HKLM\TK_SOFTWARE\Classes\SystemFileAssociations\.fbx\Shell\3D Edit" /f >nul 2>&1
				Reg delete "HKLM\TK_SOFTWARE\Classes\SystemFileAssociations\.gif\Shell\3D Edit" /f >nul 2>&1
				Reg delete "HKLM\TK_SOFTWARE\Classes\SystemFileAssociations\.jfif\Shell\3D Edit" /f >nul 2>&1
				Reg delete "HKLM\TK_SOFTWARE\Classes\SystemFileAssociations\.jpe\Shell\3D Edit" /f >nul 2>&1
				Reg delete "HKLM\TK_SOFTWARE\Classes\SystemFileAssociations\.jpeg\Shell\3D Edit" /f >nul 2>&1
				Reg delete "HKLM\TK_SOFTWARE\Classes\SystemFileAssociations\.jpg\Shell\3D Edit" /f >nul 2>&1
				Reg delete "HKLM\TK_SOFTWARE\Classes\SystemFileAssociations\.png\Shell\3D Edit" /f >nul 2>&1
				Reg delete "HKLM\TK_SOFTWARE\Classes\SystemFileAssociations\.tif\Shell\3D Edit" /f >nul 2>&1
				Reg delete "HKLM\TK_SOFTWARE\Classes\SystemFileAssociations\.tiff\Shell\3D Edit" /f >nul 2>&1

				:: Un-Mounting Image Registry
				call :UnMountImageRegistry
			)
						
			if "%%z" equ "Microsoft.Print3D" if "%ImageBuild%" geq "16299"  (
				:: Mounting Image Registry
				call :MountImageRegistry "%InstallMount%\%%i"
				
				:: Removing 3D Objects Section from Windows Explorer Navigation Pane
				Reg delete "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\MyComputer\NameSpace\{0DB7E03F-FC29-4DC6-9020-FF41B59E513A}" /f >nul 2>&1
				if "%ImageArchitecture%" equ "x64" Reg delete "HKLM\TK_SOFTWARE\Wow6432Node\Microsoft\Windows\CurrentVersion\Explorer\MyComputer\NameSpace\{0DB7E03F-FC29-4DC6-9020-FF41B59E513A}" /f >nul 2>&1
					
				:: Un-Mounting Image Registry
				call :UnMountImageRegistry
			)

			if "%%z" equ "Microsoft.Microsoft3DViewer" if "%ImageBuild%" geq "16299"  (
				:: Mounting Image Registry
				call :MountImageRegistry "%InstallMount%\%%i"
				
				:: Removing 3D Objects Section from Windows Explorer Navigation Pane
				Reg delete "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\MyComputer\NameSpace\{0DB7E03F-FC29-4DC6-9020-FF41B59E513A}" /f >nul 2>&1
				if "%ImageArchitecture%" equ "x64" Reg delete "HKLM\TK_SOFTWARE\Wow6432Node\Microsoft\Windows\CurrentVersion\Explorer\MyComputer\NameSpace\{0DB7E03F-FC29-4DC6-9020-FF41B59E513A}" /f >nul 2>&1
					
				:: Un-Mounting Image Registry
				call :UnMountImageRegistry
			)
		)
	)
) else (
	for /f %%z IN ('"type %RemoveAppsList%" 2^>nul') do (
		call :RemoveProvisionedAppxPackage "%InstallMount%", %%z, %%z
		
		if "%%z" equ "Microsoft.3DBuilder" (
			:: Mounting Image Registry
			call :MountImageRegistry "%InstallMount%"
	
			:: Removing 3D Print with 3D Builder option from right click context menu
			Reg delete "HKLM\TK_SOFTWARE\Classes\SystemFileAssociations\.bmp\Shell\T3D Print" /f >nul 2>&1
			Reg delete "HKLM\TK_SOFTWARE\Classes\SystemFileAssociations\.jpg\Shell\T3D Print" /f >nul 2>&1
			Reg delete "HKLM\TK_SOFTWARE\Classes\SystemFileAssociations\.png\Shell\T3D Print" /f >nul 2>&1
				
			:: Un-Mounting Image Registry
			call :UnMountImageRegistry
		)
			
		if "%%z" equ "Microsoft.MSPaint" (
			:: Mounting Image Registry
			call :MountImageRegistry "%InstallMount%"
	
			:: Removing Edit with Paint 3D option from right click context menu
			Reg delete "HKLM\TK_SOFTWARE\Classes\SystemFileAssociations\.3mf\Shell\3D Edit" /f >nul 2>&1
			Reg delete "HKLM\TK_SOFTWARE\Classes\SystemFileAssociations\.bmp\Shell\3D Edit" /f >nul 2>&1
			Reg delete "HKLM\TK_SOFTWARE\Classes\SystemFileAssociations\.fbx\Shell\3D Edit" /f >nul 2>&1
			Reg delete "HKLM\TK_SOFTWARE\Classes\SystemFileAssociations\.gif\Shell\3D Edit" /f >nul 2>&1
			Reg delete "HKLM\TK_SOFTWARE\Classes\SystemFileAssociations\.jfif\Shell\3D Edit" /f >nul 2>&1
			Reg delete "HKLM\TK_SOFTWARE\Classes\SystemFileAssociations\.jpe\Shell\3D Edit" /f >nul 2>&1
			Reg delete "HKLM\TK_SOFTWARE\Classes\SystemFileAssociations\.jpeg\Shell\3D Edit" /f >nul 2>&1
			Reg delete "HKLM\TK_SOFTWARE\Classes\SystemFileAssociations\.jpg\Shell\3D Edit" /f >nul 2>&1
			Reg delete "HKLM\TK_SOFTWARE\Classes\SystemFileAssociations\.png\Shell\3D Edit" /f >nul 2>&1
			Reg delete "HKLM\TK_SOFTWARE\Classes\SystemFileAssociations\.tif\Shell\3D Edit" /f >nul 2>&1
			Reg delete "HKLM\TK_SOFTWARE\Classes\SystemFileAssociations\.tiff\Shell\3D Edit" /f >nul 2>&1

			:: Un-Mounting Image Registry
			call :UnMountImageRegistry
		)

		if "%%z" equ "Microsoft.Print3D" if "%ImageBuild%" geq "16299"  (
			:: Mounting Image Registry
			call :MountImageRegistry "%InstallMount%"
				
			:: Removing 3D Objects Section from Windows Explorer Navigation Pane
			Reg delete "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\MyComputer\NameSpace\{0DB7E03F-FC29-4DC6-9020-FF41B59E513A}" /f >nul 2>&1
			if "%ImageArchitecture%" equ "x64" Reg delete "HKLM\TK_SOFTWARE\Wow6432Node\Microsoft\Windows\CurrentVersion\Explorer\MyComputer\NameSpace\{0DB7E03F-FC29-4DC6-9020-FF41B59E513A}" /f >nul 2>&1
				
			:: Un-Mounting Image Registry
			call :UnMountImageRegistry
		)

		if "%%z" equ "Microsoft.Microsoft3DViewer" if "%ImageBuild%" geq "16299"  (
			:: Mounting Image Registry
			call :MountImageRegistry "%InstallMount%"
			
			:: Removing 3D Objects Section from Windows Explorer Navigation Pane
			Reg delete "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\MyComputer\NameSpace\{0DB7E03F-FC29-4DC6-9020-FF41B59E513A}" /f >nul 2>&1
			if "%ImageArchitecture%" equ "x64" Reg delete "HKLM\TK_SOFTWARE\Wow6432Node\Microsoft\Windows\CurrentVersion\Explorer\MyComputer\NameSpace\{0DB7E03F-FC29-4DC6-9020-FF41B59E513A}" /f >nul 2>&1
				
			:: Un-Mounting Image Registry
			call :UnMountImageRegistry
		)
	)
)
echo.-------------------------------------------------------------------------------
echo.####Finished Removing Windows Apps Using Apps List#############################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set RemoveAppsList=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Remove Windows Components Using Package List
::-------------------------------------------------------------------------------------------
:RemoveWindowsComponentsList

if "%IsDialogsEnabled%" equ "Yes" (
	cls
	echo.===============================================================================
	echo.          MSMG ToolKit - Remove Windows Components Using Package List
	echo.===============================================================================
	echo.
	echo.
	echo.
	echo.                                W A R N I N G
	echo.                                =============
	echo.
	echo.   Removing the packages without proper testing can break the OS and or it's
	echo.   functionalities.
	echo.
	echo.   When adding packages to the RemovePkgsList.txt, only add the parent package
	echo.   names excluding it's language packages or sub-packages.
	echo.   
	echo.
	echo.   E.g: ToolKitHelper_WindowsDefender ^(ToolKitHelper.exe Method^)
	echo.   E.g: Microsoft-Windows-Internet-Browser-Package ^(DISM Method^)
	echo.
	echo.   To turn off Warning Dialogs, Choose Disable Dialogs in Tools-^>Options Menu
	echo.
	echo.===============================================================================
	echo.
	choice /C:YN /N /M "Do you want to Continue ? ['Y'es/'N'o] : "
	if errorlevel 2 goto :MainMenu
)

setlocal

set "RemovePkgsList=%Lists%\RemovePkgsList.txt"

cls
echo.===============================================================================
echo.        MSMG ToolKit - Remove Windows Components Using Package List
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
if "%ImageIndexNo%" equ "*" call :GetImageArchitecture "%InstallWim%", 1 >nul
if "%ImageIndexNo%" neq "*" call :GetImageArchitecture "%InstallWim%", %ImageIndexNo% >nul

echo.-------------------------------------------------------------------------------
echo.####Starting Removing Windows Components Using Package List####################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if "%ImageIndexNo%" equ "*" echo.    Image Indexes            : 1-%ImageCount%
if "%ImageIndexNo%" neq "*" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
if "%ImageIndexNo%" neq "*" echo.    Image Edition            : %ImageEdition%
echo.    Image Default Language   : %ImageDefaultLanguage%
echo.
echo.-------------------------------------------------------------------------------
echo.####Removing Windows Components Using Package List#############################
echo.-------------------------------------------------------------------------------
echo.
if "%ImageIndexNo%" equ "*" (
	echo.
	for /L %%i in (1, 1, %ImageCount%) do (
		if not %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]#############################
		if %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]############################
		echo.	

		for /f %%z IN ('"type %RemovePkgsList%" 2^>nul') do (
			echo %%z | findstr /C:"ToolKitHelper:" 1>nul
			if errorlevel 1 (
				call :RemoveLockedPackage "%InstallMount%\%%i", %%z, %%z
			) else (
				for /f "tokens=2 delims=:" %%a in ("%%z") do (
					call :RemoveWindowsComponent "%InstallMount%\%%i", "%%a", "%%a"
				)
			)
		)
	)
) else (
	for /f %%z IN ('"type %RemovePkgsList%" 2^>nul') do (
		echo %%z | findstr /C:"ToolKitHelper:" 1>nul
		if errorlevel 1 (
			call :RemoveLockedPackage "%InstallMount%", %%z, %%z
		) else (
			for /f "tokens=2 delims=:" %%a in ("%%z") do (
				call :RemoveWindowsComponent "%InstallMount%", "%%a", "%%a"
			)
		)
	)
)
echo.-------------------------------------------------------------------------------
echo.####Finished Removing Windows Components Using Package List####################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set RemovePkgsList=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Enable Windows Features Using Features List
::-------------------------------------------------------------------------------------------
:EnableFeatures

setlocal

set "FeaturesList=%Lists%\EnableFeaturesList.txt"

cls
echo.===============================================================================
echo.        MSMG ToolKit - Enable Windows Features Using Features List
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
if "%ImageIndexNo%" equ "*" call :GetImageArchitecture "%InstallWim%", 1 >nul
if "%ImageIndexNo%" neq "*" call :GetImageArchitecture "%InstallWim%", %ImageIndexNo% >nul

echo.-------------------------------------------------------------------------------
echo.####Starting Enabling Windows Features Using Features List#####################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if "%ImageIndexNo%" equ "*" echo.    Image Indexes            : 1-%ImageCount%
if "%ImageIndexNo%" neq "*" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
if "%ImageIndexNo%" neq "*" echo.    Image Edition            : %ImageEdition%
echo.    Image Default Language   : %ImageDefaultLanguage%
echo.
echo.-------------------------------------------------------------------------------
echo.####Enabling Windows Features Using Features List##############################
echo.-------------------------------------------------------------------------------
echo.
if "%ImageIndexNo%" equ "*" (
	for /L %%i in (1, 1, %ImageCount%) do (
		if not %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]#############################
		if %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]############################
		echo.

		for /f %%z IN ('"type %FeaturesList%" 2^>nul') do (
			echo.-------------------------------------------------------------------------------
			echo.Enabling Windows Feature - [%%z]
			echo.-------------------------------------------------------------------------------
			call :EnableFeature "%InstallMount%\%%i" %%z
		)
	)
) else (
	for /f %%z IN ('"type %FeaturesList%" 2^>nul') do (
		echo.-------------------------------------------------------------------------------
		echo.Enabling Windows Feature - [%%z]
		echo.-------------------------------------------------------------------------------
		call :EnableFeature "%InstallMount%" %%z
	)
)
echo.-------------------------------------------------------------------------------
echo.####Finished Enabling Windows Features Using Features List#####################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set FeaturesList=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
::-------------------------------------------------------------------------------------------
:: Function to Disable Windows Features Using Features List
::-------------------------------------------------------------------------------------------
:DisableFeatures

setlocal

set "FeaturesList=%Lists%\DisableFeaturesList.txt"

cls
echo.===============================================================================
echo.        MSMG ToolKit - Disable Windows Features Using Features List
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
if "%ImageIndexNo%" equ "*" call :GetImageArchitecture "%InstallWim%", 1 >nul
if "%ImageIndexNo%" neq "*" call :GetImageArchitecture "%InstallWim%", %ImageIndexNo% >nul

echo.-------------------------------------------------------------------------------
echo.####Starting Disabling Windows Features Using Features List####################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if "%ImageIndexNo%" equ "*" echo.    Image Indexes            : 1-%ImageCount%
if "%ImageIndexNo%" neq "*" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
if "%ImageIndexNo%" neq "*" echo.    Image Edition            : %ImageEdition%
echo.    Image Default Language   : %ImageDefaultLanguage%
echo.
echo.-------------------------------------------------------------------------------
echo.####Disabling Windows Features Using Features List#############################
echo.-------------------------------------------------------------------------------
echo.
if "%ImageIndexNo%" equ "*" (
	for /L %%i in (1, 1, %ImageCount%) do (
		if not %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]#############################
		if %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]############################
		echo.

		for /f %%z IN ('"type %FeaturesList%" 2^>nul') do (
			echo.-------------------------------------------------------------------------------
			echo.Disabling Windows Feature - [%%z]
			echo.-------------------------------------------------------------------------------
			call :DisableFeature "%InstallMount%\%%i" %%z
		)
	)
) else (
	for /f %%z IN ('"type %FeaturesList%" 2^>nul') do (
		echo.-------------------------------------------------------------------------------
		echo.Disabling Windows Feature - [%%z]
		echo.-------------------------------------------------------------------------------
		call :DisableFeature "%InstallMount%" %%z
	)
)
echo.-------------------------------------------------------------------------------
echo.####Finished Disabling Windows Features Using Features List####################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set FeaturesList=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Import Custom Default Metro Apps Associations from XML File
::-------------------------------------------------------------------------------------------
:ImportMetroAppsAssociation

setlocal

set "CustomAppsAssociationXML=%XMLs%\%SelectedSourceOS%_CustomAppsAssociation.xml"

cls
echo.===============================================================================
echo.  MSMG ToolKit - Import Custom Default Metro Apps Associations from XML File
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
if "%ImageIndexNo%" equ "*" call :GetImageArchitecture "%InstallWim%", 1 >nul
if "%ImageIndexNo%" neq "*" call :GetImageArchitecture "%InstallWim%", %ImageIndexNo% >nul

echo.-------------------------------------------------------------------------------
echo.####Starting Importing Custom Default Metro Apps Associations from XML File####
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if "%ImageIndexNo%" equ "*" echo.    Image Indexes            : 1-%ImageCount%
if "%ImageIndexNo%" neq "*" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
if "%ImageIndexNo%" neq "*" echo.    Image Edition            : %ImageEdition%
echo.    Image Default Language   : %ImageDefaultLanguage%
echo.
echo.-------------------------------------------------------------------------------
echo.####Importing Custom Default Metro Apps Associations from XML File#############
echo.-------------------------------------------------------------------------------
if "%ImageIndexNo%" equ "*" (
	for /L %%i in (1, 1, %ImageCount%) do (
		echo.
		if not %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]#############################
		if %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]############################

		call :ImportDefaultAppAssociations "%InstallMount%\%%i", "%CustomAppsAssociationXML%"
	)
) else (
	call :ImportDefaultAppAssociations "%InstallMount%", "%CustomAppsAssociationXML%"
)
echo.
echo.-------------------------------------------------------------------------------
echo.####Finished Importing Custom Default Metro Apps Associations from XML File####
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set CustomAppsAssociationXML=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Export Default Metro Apps Associations to XML File
::-------------------------------------------------------------------------------------------
:ExportMetroAppsAssociation

setlocal

set "DefaultMetroAppsAssociationXML=%XMLs%\%SelectedSourceOS%_DefaultAppsAssociation.xml"

cls
echo.===============================================================================
echo.      MSMG ToolKit - Export Default Metro Apps Associations to XML File
echo.===============================================================================
echo.

:: Checking whether Multi-Index Servicing Mode is selected
if "%ImageIndexNo%" equ "*" (
	echo.This feature is not available when Multi-Index servicing mode is enabled...
	echo.
	echo.Please Re-Choose Source with a Single Index...
	goto :Stop
)

:: Getting Install Image Index Architecture
if "%ImageIndexNo%" equ "*" call :GetImageArchitecture "%InstallWim%", 1 >nul
if "%ImageIndexNo%" neq "*" call :GetImageArchitecture "%InstallWim%", %ImageIndexNo% >nul

echo.-------------------------------------------------------------------------------
echo.####Starting Exporting Default Metro Apps Associations to XML File#############
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.    Image Edition            : %ImageEdition%
echo.    Image Default Language   : %ImageDefaultLanguage%
echo.
echo.-------------------------------------------------------------------------------
echo.####Checking for Default Metro Apps Association################################
echo.-------------------------------------------------------------------------------
echo.
%DISM% /Image:"%InstallMount%" /Get-DefaultAppAssociations | findstr /c:"file could not be" >nul
if errorlevel 1 (
	echo.Found Default Metro Apps Association XML File...
	echo.
	echo.-------------------------------------------------------------------------------
	echo.####Exporting Default Metro Apps Associations to XML File######################
	echo.-------------------------------------------------------------------------------
	echo.
	call :RemoveFile "%DefaultMetroAppsAssociationXML%"
	echo.Exporting Default Metro Apps Associations to XML File...
	%DISM% /Image:"%InstallMount%" /Get-DefaultAppAssociations | findstr "<" >> "%DefaultMetroAppsAssociationXML%"
	echo.
	echo.-------------------------------------------------------------------------------
	echo.####Finished Exporting Default Metro Apps Associations to XML File#############
	echo.-------------------------------------------------------------------------------
	goto :Stop
)
if not errorlevel 1 (
	echo.Default Metro Apps Association is empty...
	echo.
	echo.-------------------------------------------------------------------------------
	echo.####Stopped Exporting Default Metro Apps Associations to XML File##############
	echo.-------------------------------------------------------------------------------
	goto :Stop
)

:Stop
echo.
echo.===============================================================================
echo.
pause

set DefaultMetroAppsAssociationXML=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Remove Default Metro Apps Association
::-------------------------------------------------------------------------------------------
:RemoveMetroAppsAssociation

setlocal

cls
echo.===============================================================================
echo.            MSMG ToolKit - Remove Default Metro Apps Association
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture.
if "%ImageIndexNo%" equ "*" call :GetImageArchitecture "%InstallWim%", 1 >nul
if "%ImageIndexNo%" neq "*" call :GetImageArchitecture "%InstallWim%", %ImageIndexNo% >nul

echo.-------------------------------------------------------------------------------
echo.####Starting Removing Default Metro Apps Association###########################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if "%ImageIndexNo%" equ "*" echo.    Image Indexes            : 1-%ImageCount%
if "%ImageIndexNo%" neq "*" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
if "%ImageIndexNo%" neq "*" echo.    Image Edition            : %ImageEdition%
echo.    Image Default Language   : %ImageDefaultLanguage%
echo.
echo.-------------------------------------------------------------------------------
if "%ImageIndexNo%" equ "*" (
	echo.
	for /L %%i in (1, 1, %ImageCount%) do (
		if not %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]#############################
		if %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]############################
		echo.
		echo.-------------------------------------------------------------------------------
		echo.####Checking for Default Metro Apps Association################################
		echo.-------------------------------------------------------------------------------
		echo.
		%DISM% /Image:"%InstallMount%\%%i" /Get-DefaultAppAssociations | findstr /c:"file could not be" >nul
		if errorlevel 1 (
			echo.Found Default Metro Apps Association XML File...
			echo.
			echo.-------------------------------------------------------------------------------
			echo.Removing Default Metro Apps Association...
			echo.-------------------------------------------------------------------------------
			call :RemoveDefaultAppAssociations "%InstallMount%\%%i"
			echo.
			if "%%i" equ "%ImageCount%" (
				echo.-------------------------------------------------------------------------------
				echo.####Finished Removing Default Metro Apps Association###########################
				echo.-------------------------------------------------------------------------------
				echo.
			)
		) else (
			echo.Default Metro Apps Association has already been removed...
			echo.
			echo.Skipping Removing Default Metro Apps Association...
			echo.
			if "%%i" equ "%ImageCount%" (
				echo.-------------------------------------------------------------------------------
				echo.####Stopped Removing Default Metro Apps Association############################
				echo.-------------------------------------------------------------------------------
				echo.
			)
		)
	)
) else (
	echo.####Checking for Default Metro Apps Association################################
	echo.-------------------------------------------------------------------------------
	echo.
	%DISM% /Image:"%InstallMount%" /Get-DefaultAppAssociations | findstr /c:"file could not be" >nul
	if errorlevel 1 (
		echo.Found Default Metro Apps Association XML File...
		echo.
		echo.-------------------------------------------------------------------------------
		echo.Removing Default Metro Apps Association...
		echo.-------------------------------------------------------------------------------
		call :RemoveDefaultAppAssociations "%InstallMount%"
		echo.
		echo.-------------------------------------------------------------------------------
		echo.####Finished Removing Default Metro Apps Association###########################
		echo.-------------------------------------------------------------------------------
		echo.
		goto :Stop
	) else (
		echo.Default Metro Apps Association has already been removed...
		echo.
		echo.-------------------------------------------------------------------------------
		echo.####Stopped Removing Default Metro Apps Association############################
		echo.-------------------------------------------------------------------------------
		echo.
		goto :Stop
	)
)
:Stop
echo.===============================================================================
echo.
pause

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Import Custom StartMenu Layout from XML File
::-------------------------------------------------------------------------------------------
:ImportStartMenuLayout

setlocal

set "CustomStartMenuLayoutXML=%XMLs%\%SelectedSourceOS%_CustomStartMenuLayout.xml"

cls
echo.===============================================================================
echo.        MSMG ToolKit - Import Custom StartMenu Layout from XML File
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
if "%ImageIndexNo%" equ "*" call :GetImageArchitecture "%InstallWim%", 1 >nul
if "%ImageIndexNo%" neq "*" call :GetImageArchitecture "%InstallWim%", %ImageIndexNo% >nul

echo.-------------------------------------------------------------------------------
echo.####Starting Importing Custom StartMenu Layout from XML File###################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if "%ImageIndexNo%" equ "*" echo.    Image Indexes            : 1-%ImageCount%
if "%ImageIndexNo%" neq "*" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
if "%ImageIndexNo%" neq "*" echo.    Image Edition            : %ImageEdition%
echo.    Image Default Language   : %ImageDefaultLanguage%
echo.
echo.-------------------------------------------------------------------------------
echo.####Importing Custom StartMenu Layout from XML File############################
echo.-------------------------------------------------------------------------------
if "%ImageIndexNo%" equ "*" (
	for /L %%i in (1, 1, %ImageCount%) do (
		echo.
		if not %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]#############################
		if %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]############################
		echo.
		echo.Copying the Custom StartMenu Layout...
		copy %CustomStartMenuLayoutXML% "%InstallMount%\%%i\Users\Default\AppData\Local\Microsoft\Windows\Shell\LayoutModification.xml" >nul
		call :RemoveFolder "%InstallMount%\%%i\Users\Default\AppData\Local\TileDataLayer"
	)
) else (
	echo.
	echo.Copying the Custom StartMenu Layout...
	copy %CustomStartMenuLayoutXML% "%InstallMount%\Users\Default\AppData\Local\Microsoft\Windows\Shell\LayoutModification.xml" >nul
	call :RemoveFolder "%InstallMount%\Users\Default\AppData\Local\TileDataLayer"
)
echo.
echo.-------------------------------------------------------------------------------
echo.####Finished Importing Custom StartMenu Layout from XML File###################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set CustomStartMenuLayoutXML=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Import Custom Registry Settings from Registry File
::-------------------------------------------------------------------------------------------
:ImportCustomRegistry

setlocal

cls
echo.===============================================================================
echo.     MSMG ToolKit - Import Custom Registry Settings from Registry File
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
if "%ImageIndexNo%" equ "*" call :GetImageArchitecture "%InstallWim%", 1 >nul
if "%ImageIndexNo%" neq "*" call :GetImageArchitecture "%InstallWim%", %ImageIndexNo% >nul

set "CustomRegistry=%CustomRegistry%\%SelectedSourceOS%\%ImageArchitecture%"

:: Checking whether Custom Registry Settings Pack folder is empty
for /f %%i in ('dir /b /a:-d "%CustomRegistry%\*.reg" 2^>nul ^| find /v /c ""') do (
	if "%%i" equ "0" (
		echo.Custom Registry Settings folder is empty...
		echo.
		echo.Please copy the registry files to ^<Custom\Registry\%SelectedSourceOS%\%ImageArchitecture%^> folder...
		goto :Stop
	)
)

echo.-------------------------------------------------------------------------------
echo.####Starting Importing Custom Registry Settings from Registry File#############
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if "%ImageIndexNo%" equ "*" echo.    Image Indexes            : 1-%ImageCount%
if "%ImageIndexNo%" neq "*" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
if "%ImageIndexNo%" neq "*" echo.    Image Edition            : %ImageEdition%
echo.    Image Default Language   : %ImageDefaultLanguage%
echo.
echo.-------------------------------------------------------------------------------
echo.####Processing Custom Registry Settings Files##################################
echo.-------------------------------------------------------------------------------
echo.
echo.Making Custom Registry compatible with ToolKit's Image Registry...
call :RemoveFolder "%Temp%\CustomRegistry"
call :CreateFolder "%Temp%\CustomRegistry"
PowerShell -Executionpolicy Bypass -File "%Bin%\ConvertReg.ps1" "%CustomRegistry%" "%Temp%\CustomRegistry"
echo.
echo.-------------------------------------------------------------------------------
echo.####Importing Custom Registry Settings from Registry File######################
echo.-------------------------------------------------------------------------------
echo.
if "%ImageIndexNo%" equ "*" (
	for /L %%i in (1, 1, %ImageCount%) do (
		if not %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]#############################
		if %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]############################
		echo.		
		echo.Mounting Image Registry...
		call :MountImageRegistry "%InstallMount%\%%i"
		echo.

		for /f "tokens=*" %%z in ('"dir /b "%Temp%\CustomRegistry\*.reg"" 2^>nul') do (
			echo.Importing [%%z] to Image Registry...
			call :ImportRegistry2Image "%Temp%\CustomRegistry\%%z"
		)

		echo.
		echo.Un-Mounting Image Registry...
		call :UnMountImageRegistry
	)
) else (
	echo.Mounting Image Registry...
	call :MountImageRegistry "%InstallMount%"
	echo.

	for /f "tokens=*" %%z in ('"dir /b "%Temp%\CustomRegistry\*.reg"" 2^>nul') do (
		echo.Importing [%%z] to Image Registry...
		call :ImportRegistry2Image "%Temp%\CustomRegistry\%%z"
	)

	echo.
	echo.Un-Mounting Image Registry...
	call :UnMountImageRegistry
)

call :RemoveFolder "%Temp%\CustomRegistry"
echo.
echo.-------------------------------------------------------------------------------
echo.####Finished Importing Custom Registry Settings from Registry File#############
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set CustomRegistry=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Apply Tweaks
::-------------------------------------------------------------------------------------------
:ApplyTweaks

setlocal

set Tweak=

cls
echo.===============================================================================
echo.                      MSMG ToolKit - Apply Tweaks Menu
echo.===============================================================================
echo.

if "%SelectedSourceOS%" equ "w81" (
	echo.  [A]   Disable Automatic Driver Updates through Windows Update
	echo.  [B]   Disable Automatic Downloading and Installing 3rd Party Apps
	echo.  [C]   Disable Windows Defender
	echo.  [D]   Disable Automatic Windows Upgrade
	echo.  [E]   Disable Windows Update
	echo.  [F]   Force .NET Programs to Use Newest .NET Framework
	echo.  [G]   Enable Windows Photo Viewer
	echo.  [H]   Enable Fraunhofer MP3 Professional Codec
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.  [X]   Go Back
	echo.
	echo.===============================================================================
	echo.
	choice /C:ABCDEFGHX /N /M "Enter Your Choice : "
	if errorlevel 9 goto :CustomizeMenu
	if errorlevel 8 set "Tweak=EnableFMP3ProCodec"
	if errorlevel 7 set "Tweak=EnablePhotoViewer"
	if errorlevel 6 set "Tweak=ForceLatestNetFramework"
	if errorlevel 5 set "Tweak=DisableWindowsUpdate"
	if errorlevel 4 set "Tweak=DisableWindowsUpgrade"
	if errorlevel 3 set "Tweak=DisableWindowsDefender"
	if errorlevel 2 set "Tweak=Disable3RDPartyApps"
	if errorlevel 1 set "Tweak=DisableDriversUpdates"
)

if "%SelectedSourceOS%" equ "w10" (
	echo.  [A]   Disable Cortana App
	echo.  [B]   Hide Taskbar TaskView Icon
	echo.  [C]   Disable Automatic Driver Updates through Windows Update
	echo.  [D]   Disable Automatic Downloading and Installing 3rd Party Apps
	echo.  [E]   Disable Windows Defender
	echo.  [F]   Disable Automatic Windows Upgrade
	echo.  [G]   Disable Windows Update
	echo.  [H]   Disable Microsoft Reserved Storage Space for Windows Updates
	echo.  [I]   Force .NET Programs to Use Newest .NET Framework
	echo.  [J]   Enable Windows Photo Viewer
	echo.  [K]   Enable Fraunhofer MP3 Professional Codec
	echo.  [L]   Enable DISM Image Cleanup with Full ResetBase
	echo.
	echo.
	echo.
	echo.  [X]   Go Back
	echo.
	echo.===============================================================================
	echo.
	choice /C:ABCDEFGHIJKLX /N /M "Enter Your Choice : "
	if errorlevel 13 goto :CustomizeMenu
	if errorlevel 12 set "Tweak=EnableFullResetBase"
	if errorlevel 11 set "Tweak=EnableFMP3ProCodec"
	if errorlevel 10 set "Tweak=EnablePhotoViewer"
	if errorlevel 9  set "Tweak=ForceLatestNetFramework"
	if errorlevel 8  set "Tweak=DisableReservedStorage"
	if errorlevel 7  set "Tweak=DisableWindowsUpdate"
	if errorlevel 6  set "Tweak=DisableWindowsUpgrade"
	if errorlevel 5  set "Tweak=DisableWindowsDefender"
	if errorlevel 4  set "Tweak=Disable3RDPartyApps"
	if errorlevel 3  set "Tweak=DisableDriversUpdates"
	if errorlevel 2  set "Tweak=HideTaskViewIcon"
	if errorlevel 1  set "Tweak=DisableCortanaApp"
)

cls
echo.===============================================================================
echo.                       MSMG ToolKit - Apply Tweaks
echo.===============================================================================
echo.
:: Getting Install Image Index Architecture
if "%ImageIndexNo%" equ "*" call :GetImageArchitecture "%InstallWim%", 1 >nul
if "%ImageIndexNo%" neq "*" call :GetImageArchitecture "%InstallWim%", %ImageIndexNo% >nul

echo.-------------------------------------------------------------------------------
echo.####Starting Applying Tweaks###################################################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if "%ImageIndexNo%" equ "*" echo.    Image Indexes            : 1-%ImageCount%
if "%ImageIndexNo%" neq "*" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
if "%ImageIndexNo%" neq "*" echo.    Image Edition            : %ImageEdition%
echo.    Image Default Language   : %ImageDefaultLanguage%
echo.
echo.-------------------------------------------------------------------------------
if "%Tweak%" equ "Disable3RDPartyApps" echo.####Applying Disable Downloading and Installing 3rd Party Apps Tweak###########
if "%Tweak%" equ "DisableCortanaApp" echo.####Applying Disable Cortana App Tweak#########################################
if "%Tweak%" equ "DisableDriversUpdates" echo.####Applying Disable Automatic Driver Updates through Windows Update Tweak#####
if "%Tweak%" equ "DisableReservedStorage" echo.####Applying Disable Microsoft Reserved Storage Space for Windows Updates######
if "%Tweak%" equ "DisableWindowsDefender" echo.####Applying Disable Windows Defender Tweak####################################
if "%Tweak%" equ "DisableWindowsUpdate" echo.####Applying Disable Windows Update Tweak######################################
if "%Tweak%" equ "DisableWindowsUpgrade" echo.####Applying Disable Automatic Windows OS Upgrade Tweak########################
if "%Tweak%" equ "EnableFMP3ProCodec" echo.####Applying Enable Fraunhofer MP3 Professional Codec Tweak####################
if "%Tweak%" equ "EnableFullResetBase" echo.####Applying Enable DISM Image Cleanup with Full ResetBase Tweak###############
if "%Tweak%" equ "EnablePhotoViewer" echo.####Applying Enable Windows Photo Viewer Tweak#################################
if "%Tweak%" equ "ForceLatestNetFramework" echo.####Applying Force .NET Programs to Use Newest .NET Framework Tweak############
if "%Tweak%" equ "HideTaskViewIcon" echo.####Applying Hide Taskbar TaskView Icon Tweak##################################
echo.-------------------------------------------------------------------------------
echo.
if "%ImageIndexNo%" equ "*" (
	for /L %%i in (1, 1, %ImageCount%) do (
		echo.
		if not %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]#############################
		if %ImageIndexNo% gtr 9 echo.##########################[Install.wim, Index : %%i]############################
		echo.		
		echo.Mounting Image Registry...
		call :MountImageRegistry "%InstallMount%\%%i"
		echo.Importing Registry Settings to Image Registry...
		
		if "%Tweak%" equ "DisableCortanaApp" (
			Reg add "HKLM\TK_DEFAULT\SOFTWARE\Microsoft\InputPersonalization\TrainedDataStore" /v "HarvestContacts" /t REG_DWORD /d "0" /f >nul 2>&1
			Reg add "HKLM\TK_DEFAULT\SOFTWARE\Microsoft\Windows\CurrentVersion\Search" /v "DeviceHistoryEnabled" /t REG_DWORD /d "0" /f >nul 2>&1
			Reg add "HKLM\TK_DEFAULT\SOFTWARE\Microsoft\Windows\CurrentVersion\Search" /v "HistoryViewEnabled" /t REG_DWORD /d "0" /f >nul 2>&1
			Reg add "HKLM\TK_DEFAULT\SOFTWARE\Microsoft\Windows\CurrentVersion\Windows Search" /v "CortanaConsent" /t REG_DWORD /d "0" /f >nul 2>&1
			Reg add "HKLM\TK_DEFAULT\SOFTWARE\Microsoft\Windows\CurrentVersion\Windows Search" /v "CortanaIsReplaceable" /t REG_DWORD /d "1" /f >nul 2>&1
			Reg add "HKLM\TK_DEFAULT\SOFTWARE\Microsoft\Windows\CurrentVersion\Windows Search" /v "CortanaIsReplaced" /t REG_DWORD /d "1" /f >nul 2>&1
			Reg add "HKLM\TK_DEFAULT\SOFTWARE\Microsoft\Windows\CurrentVersion\Windows Search" /v "SearchboxTaskbarMode" /t REG_DWORD /d "0" /f >nul 2>&1
			Reg add "HKLM\TK_DEFAULT\SOFTWARE\Policies\Microsoft\InputPersonalization" /v "RestrictImplicitInkCollection" /t REG_DWORD /d "1" /f >nul 2>&1
			Reg add "HKLM\TK_DEFAULT\SOFTWARE\Policies\Microsoft\InputPersonalization" /v "RestrictImplicitTextCollection" /t REG_DWORD /d "1" /f >nul 2>&1
			Reg add "HKLM\TK_NTUSER\SOFTWARE\Classes\Local Settings\Software\Microsoft\Windows\CurrentVersion\AppContainer\Storage\microsoft.microsoftedge_8wekyb3d8bbwe\MicrosoftEdge\ServiceUI" /v "EnableCortana" /t REG_DWORD /d "0" /f >nul 2>&1
			Reg add "HKLM\TK_NTUSER\SOFTWARE\Microsoft\InputPersonalization" /v "RestrictImplicitInkCollection" /t REG_DWORD /d "1" /f >nul 2>&1
			Reg add "HKLM\TK_NTUSER\SOFTWARE\Microsoft\InputPersonalization" /v "RestrictImplicitTextCollection" /t REG_DWORD /d "1" /f >nul 2>&1
			Reg add "HKLM\TK_NTUSER\SOFTWARE\Microsoft\InputPersonalization\TrainedDataStore" /v "HarvestContacts" /t REG_DWORD /d "0" /f >nul 2>&1
			Reg add "HKLM\TK_NTUSER\SOFTWARE\Microsoft\Personalization\Settings" /v "AcceptedPrivacyPolicy" /t REG_DWORD /d "0" /f >nul 2>&1
			Reg add "HKLM\TK_NTUSER\SOFTWARE\Microsoft\Windows\CurrentVersion\Search" /v "DeviceHistoryEnabled" /t REG_DWORD /d "0" /f >nul 2>&1
			Reg add "HKLM\TK_NTUSER\SOFTWARE\Microsoft\Windows\CurrentVersion\Search" /v "HistoryViewEnabled" /t REG_DWORD /d "0" /f >nul 2>&1
			Reg add "HKLM\TK_NTUSER\SOFTWARE\Microsoft\Windows\CurrentVersion\Windows Search" /v "CortanaConsent" /t REG_DWORD /d "0" /f >nul 2>&1
			Reg add "HKLM\TK_NTUSER\SOFTWARE\Microsoft\Windows\CurrentVersion\Windows Search" /v "CortanaIsReplaceable" /t REG_DWORD /d "1" /f >nul 2>&1
			Reg add "HKLM\TK_NTUSER\SOFTWARE\Microsoft\Windows\CurrentVersion\Windows Search" /v "CortanaIsReplaced" /t REG_DWORD /d "1" /f >nul 2>&1
			Reg add "HKLM\TK_NTUSER\SOFTWARE\Microsoft\Windows\CurrentVersion\Windows Search" /v "SearchboxTaskbarMode" /t REG_DWORD /d "0" /f >nul 2>&1
			Reg add "HKLM\TK_SOFTWARE\Microsoft\PolicyManager\current\device\AboveLock" /v "AllowCortanaAboveLock" /t REG_DWORD /d "0" /f >nul 2>&1
			Reg add "HKLM\TK_SOFTWARE\Microsoft\PolicyManager\current\device\Experience" /v "AllowCortana" /t REG_DWORD /d "0" /f >nul 2>&1
			Reg add "HKLM\TK_SOFTWARE\Microsoft\Speech_OneCore\Preferences" /v "ModelDownloadAllowed" /t REG_DWORD /d "0" /f >nul 2>&1
			Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Search" /v "SearchboxTaskbarMode" /t REG_DWORD /d "1" /f >nul 2>&1
			Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\Windows Search" /v "AllowCloudSearch" /t REG_DWORD /d "0" /f >nul 2>&1
			Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\Windows Search" /v "AllowCortana" /t REG_DWORD /d "0" /f >nul 2>&1
			Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\Windows Search" /v "AllowCortanaAboveLock" /t REG_DWORD /d "0" /f >nul 2>&1
			Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\Windows Search" /v "AllowSearchToUseLocation" /t REG_DWORD /d "0" /f >nul 2>&1
			Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\Windows Search" /v "ConnectedSearchPrivacy" /t REG_DWORD /d "3" /f >nul 2>&1
			Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\Windows Search" /v "ConnectedSearchSafeSearch" /t REG_DWORD /d "3" /f >nul 2>&1
			Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\Windows Search" /v "ConnectedSearchUseWeb" /t REG_DWORD /d "0" /f >nul 2>&1
			Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\Windows Search" /v "ConnectedSearchUseWebOverMeteredConnections" /t REG_DWORD /d "0" /f >nul 2>&1
			Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\Windows Search" /v "DisableWebSearch" /t REG_DWORD /d "1" /f >nul 2>&1
			Reg add "HKLM\TK_SOFTWARE\Policies\Wow6432Node\Microsoft\Windows\Windows Search" /v "AllowCortana" /t REG_DWORD /d "0" /f >nul 2>&1
			Reg add "HKLM\TK_SOFTWARE\Policies\Wow6432Node\Microsoft\Windows\Windows Search" /v "AllowCortanaAboveLock" /t REG_DWORD /d "0" /f >nul 2>&1
			Reg add "HKLM\TK_SYSTEM\ControlSet001\Services\SharedAccess\Parameters\FirewallPolicy\FirewallRules" /v "Block Cortana ActionUriServer.exe" /t REG_SZ /d "v2.26|Action=Block|Active=TRUE|Dir=Out|RA42=IntErnet|RA62=IntErnet|App=C:\Windows\SystemApps\Microsoft.Windows.Cortana_cw5n1h2txyewy\ActionUriServer.exe|Name=Block Cortana ActionUriServer.exe|Desc=Block Cortana Outbound UDP/TCP Traffic|" /f >nul 2>&1
			Reg add "HKLM\TK_SYSTEM\ControlSet001\Services\SharedAccess\Parameters\FirewallPolicy\FirewallRules" /v "Block Cortana Package" /t REG_SZ /d "v2.26|Action=Block|Active=TRUE|Dir=Out|RA42=IntErnet|RA62=IntErnet|Name=Block Cortana Package|Desc=Block Cortana Outbound UDP/TCP Traffic|AppPkgId=S-1-15-2-1861897761-1695161497-2927542615-642690995-327840285-2659745135-2630312742|Platform=2:6:2|Platform2=GTEQ|" /f >nul 2>&1
			Reg add "HKLM\TK_SYSTEM\ControlSet001\Services\SharedAccess\Parameters\FirewallPolicy\FirewallRules" /v "Block Cortana PlacesServer.exe" /t REG_SZ /d "v2.26|Action=Block|Active=TRUE|Dir=Out|RA42=IntErnet|RA62=IntErnet|App=C:\Windows\SystemApps\Microsoft.Windows.Cortana_cw5n1h2txyewy\PlacesServer.exe|Name=Block Cortana PlacesServer.exe|Desc=Block Cortana Outbound UDP/TCP Traffic|" /f >nul 2>&1
			Reg add "HKLM\TK_SYSTEM\ControlSet001\Services\SharedAccess\Parameters\FirewallPolicy\FirewallRules" /v "Block Cortana RemindersServer.exe" /t REG_SZ /d "v2.26|Action=Block|Active=TRUE|Dir=Out|RA42=IntErnet|RA62=IntErnet|App=C:\Windows\SystemApps\Microsoft.Windows.Cortana_cw5n1h2txyewy\RemindersServer.exe|Name=Block Cortana RemindersServer.exe|Desc=Block Cortana Outbound UDP/TCP Traffic|" /f >nul 2>&1
			Reg add "HKLM\TK_SYSTEM\ControlSet001\Services\SharedAccess\Parameters\FirewallPolicy\FirewallRules" /v "Block Cortana RemindersShareTargetApp.exe" /t REG_SZ /d "v2.26|Action=Block|Active=TRUE|Dir=Out|RA42=IntErnet|RA62=IntErnet|App=C:\Windows\SystemApps\Microsoft.Windows.Cortana_cw5n1h2txyewy\RemindersShareTargetApp.exe|Name=Block Cortana RemindersShareTargetApp.exe|Desc=Block Cortana Outbound UDP/TCP Traffic|" /f >nul 2>&1
			Reg add "HKLM\TK_SYSTEM\ControlSet001\Services\SharedAccess\Parameters\FirewallPolicy\FirewallRules" /v "Block Cortana SearchUI.exe" /t REG_SZ /d "v2.26|Action=Block|Active=TRUE|Dir=Out|RA42=IntErnet|RA62=IntErnet|App=C:\Windows\SystemApps\Microsoft.Windows.Cortana_cw5n1h2txyewy\SearchUI.exe|Name=Block Cortana SearchUI.exe|Desc=Block Cortana Outbound UDP/TCP Traffic|" /f >nul 2>&1
		)
		
		if "%Tweak%" equ "HideTaskViewIcon" Reg add "HKLM\TK_NTUSER\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\Advanced" /v "ShowTaskViewButton" /t REG_DWORD /d "0" /f >nul

		if "%Tweak%" equ "DisableDriversUpdates" (
			Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\Device Metadata" /v "PreventDeviceMetadataFromNetwork" /t REG_DWORD /d "1" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\DriverSearching" /v "DontPromptForWindowsUpdate" /t REG_DWORD /d "1" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\DriverSearching" /v "DontSearchWindowsUpdate" /t REG_DWORD /d "1" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\DriverSearching" /v "DriverUpdateWizardWuSearchEnabled" /t REG_DWORD /d "0" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\DriverSearching" /v "SearchOrderConfig" /t REG_DWORD /d "1" /f >nul		
			Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\WindowsUpdate" /v "ExcludeWUDriversInQualityUpdate" /t REG_DWORD /d "1" /f >nul
		)

		if "%Tweak%" equ "Disable3RDPartyApps" (
			Reg add "HKLM\TK_NTUSER\SOFTWARE\Microsoft\Windows\CurrentVersion\ContentDeliveryManager" /v "OemPreInstalledAppsEnabled" /t REG_DWORD /d "0" /f >nul
			Reg add "HKLM\TK_NTUSER\SOFTWARE\Microsoft\Windows\CurrentVersion\ContentDeliveryManager" /v "PreInstalledAppsEnabled" /t REG_DWORD /d "0" /f >nul
			Reg add "HKLM\TK_NTUSER\SOFTWARE\Microsoft\Windows\CurrentVersion\ContentDeliveryManager" /v "SilentInstalledAppsEnabled" /t REG_DWORD /d "0" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\CloudContent" /v "DisableWindowsConsumerFeatures" /t REG_DWORD /d "1" /f >nul
		)

		if "%Tweak%" equ "DisableWindowsDefender" (
			Reg add "HKLM\TK_DEFAULT\SOFTWARE\Microsoft\Windows Security Health\State" /v "AccountProtection_MicrosoftAccount_Disconnected" /t REG_DWORD /d "0" /f >nul 2>&1
			Reg add "HKLM\TK_NTUSER\SOFTWARE\Microsoft\Windows Security Health\State" /v "AccountProtection_MicrosoftAccount_Disconnected" /t REG_DWORD /d "0" /f >nul 2>&1
			Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows Defender\Features" /v "TamperProtection" /t REG_DWORD /d "0" /f >nul 2>&1
			Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\MRT" /v "DontOfferThroughWUAU" /t REG_DWORD /d "1" /f >nul 2>&1
			Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\MRT" /v "DontReportInfectionInformation" /t REG_DWORD /d "1" /f >nul 2>&1
			Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows Defender" /v "DisableAntiSpyware" /t REG_DWORD /d "1" /f >nul 2>&1
			Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows Defender\Spynet" /v "SpyNetReporting" /t REG_DWORD /d "0" /f >nul 2>&1
			Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows Defender\Spynet" /v "SubmitSamplesConsent" /t REG_DWORD /d "2" /f >nul 2>&1
		)
	
		if "%Tweak%" equ "DisableWindowsUpgrade" (
			if "%SelectedSourceOS%" neq "w10" (
				Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\Gwx" /v "DisableGwx" /t REG_DWORD /d "1" /f >nul
				Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\WindowsUpdate" /v "DisableOSUpgrade" /t REG_DWORD /d "1" /f >nul
			)
			
			if "%SelectedSourceOS%" equ "w10" (
				Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\WindowsUpdate" /v "DeferUpdatePeriod" /t REG_DWORD /d "0" /f >nul 2>&1
				Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\WindowsUpdate" /v "DeferUpgrade" /t REG_DWORD /d "1" /f >nul 2>&1
				Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\WindowsUpdate" /v "DeferUpgradePeriod" /t REG_DWORD /d "1" /f >nul 2>&1
				Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\WindowsUpdate\AU" /v "AUOptions" /t REG_DWORD /d "2" /f >nul
			)
		)

		if "%Tweak%" equ "DisableWindowsUpdate" (
			Reg add "HKLM\TK_DEFAULT\SOFTWARE\Microsoft\Windows\CurrentVersion\ContentDeliveryManager" /v "SubscribedContent-310093Enabled" /t REG_DWORD /d "0" /f >nul 2>&1
			Reg add "HKLM\TK_NTUSER\SOFTWARE\Microsoft\Windows\CurrentVersion\ContentDeliveryManager" /v "SubscribedContent-310093Enabled" /t REG_DWORD /d "0" /f >nul 2>&1
			Reg add "HKLM\TK_NTUSER\SOFTWARE\Microsoft\Windows\CurrentVersion\DeliveryOptimization" /v "SystemSettingsDownloadMode" /t REG_DWORD /d "0" /f >nul 2>&1
			Reg add "HKLM\TK_SOFTWARE\Microsoft\Speech_OneCore\Preferences" /v "ModelDownloadAllowed" /t REG_DWORD /d "0" /f >nul 2>&1
			Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\DeliveryOptimization" /v "OptInOOBE" /t REG_DWORD /d "0" /f >nul 2>&1
			Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\DeliveryOptimization\Config" /v "DODownloadMode" /t REG_DWORD /d "0" /f >nul 2>&1
			Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\WindowsStore\WindowsUpdate" /v "AutoDownload" /t REG_DWORD /d "2" /f >nul 2>&1
			Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\WindowsUpdate\Services\7971f918-a847-4430-9279-4a52d1efe18d" /v "registeredWithAU" /t REG_DWORD /d "0" /f >nul 2>&1
			Reg add "HKLM\TK_SOFTWARE\Microsoft\WindowsUpdate\UX\Settings" /v "HideMCTLink" /t REG_DWORD /d "1" /f >nul 2>&1
			Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Speech" /v "AllowSpeechModelUpdate" /t REG_DWORD /d "0" /f >nul 2>&1
			Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\DeliveryOptimization" /v "DODownloadMode" /t REG_DWORD /d "0" /f >nul 2>&1
			Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\DeliveryOptimization" /v "DODownloadMode" /t REG_DWORD /d "63" /f >nul 2>&1
			Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\WindowsUpdate\AU" /v "AUOptions" /t REG_DWORD /d "2" /f >nul 2>&1
			Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\WindowsUpdate\AU" /v "NoAutoUpdate" /t REG_DWORD /d "1" /f >nul 2>&1
			Reg add "HKLM\TK_SYSTEM\ControlSet001\Services\wuauserv" /v "Start" /t REG_DWORD /d "4" /f >nul 2>&1
		)
		
		if "%Tweak%" equ "DisableReservedStorage" Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\ReserveManager" /v "ShippedWithReserves" /t REG_DWORD /d "0" /f >nul
		if "%Tweak%" equ "ForceLatestNetFramework" Reg add "HKLM\TK_SOFTWARE\Microsoft\.NETFramework" /v "OnlyUseLatestCLR" /t REG_DWORD /d "1" /f >nul

		if "%Tweak%" equ "EnablePhotoViewer" (
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\ApplicationAssociationToasts" /v "emffile_.emf" /t REG_DWORD /d "0" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\ApplicationAssociationToasts" /v "rlefile_.rle" /t REG_DWORD /d "0" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\ApplicationAssociationToasts" /v "wmffile_.wmf" /t REG_DWORD /d "0" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer" /v "GlobalAssocChangedCounter" /t REG_DWORD /d "13" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.bmp\OpenWithList" /v "a" /t REG_SZ /d "PhotoViewer.dll" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.bmp\OpenWithList" /v "MRUList" /t REG_SZ /d "a" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.bmp\UserChoice" /v "Hash" /t REG_SZ /d "TDU75KWAGi4=" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.bmp\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.Bitmap" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.dib\OpenWithList" /v "a" /t REG_SZ /d "PhotoViewer.dll" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.dib\OpenWithList" /v "MRUList" /t REG_SZ /d "a" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.dib\UserChoice" /v "Hash" /t REG_SZ /d "hAQpLYJfRYE=" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.dib\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.Bitmap" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.gif\OpenWithList" /v "a" /t REG_SZ /d "PhotoViewer.dll" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.gif\OpenWithList" /v "MRUList" /t REG_SZ /d "a" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.gif\UserChoice" /v "Hash" /t REG_SZ /d "1in4hcmDrB4=" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.gif\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.Gif" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jfif\OpenWithList" /v "a" /t REG_SZ /d "PhotoViewer.dll" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jfif\OpenWithList" /v "MRUList" /t REG_SZ /d "a" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jfif\UserChoice" /v "Hash" /t REG_SZ /d "Y5upkzp3g5E=" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jfif\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.JFIF" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jpe\OpenWithList" /v "a" /t REG_SZ /d "PhotoViewer.dll" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jpe\OpenWithList" /v "MRUList" /t REG_SZ /d "a" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jpe\UserChoice" /v "Hash" /t REG_SZ /d "ZIeqfdrNtFk=" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jpe\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.Jpeg" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jpeg\OpenWithList" /v "a" /t REG_SZ /d "PhotoViewer.dll" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jpeg\OpenWithList" /v "MRUList" /t REG_SZ /d "a" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jpeg\UserChoice" /v "Hash" /t REG_SZ /d "iVWM3EAePKw=" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jpeg\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.Jpeg" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jpg\OpenWithList" /v "a" /t REG_SZ /d "PhotoViewer.dll" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jpg\OpenWithList" /v "MRUList" /t REG_SZ /d "a" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jpg\UserChoice" /v "Hash" /t REG_SZ /d "Xq9gH4jXoFM=" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jpg\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.Jpeg" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jxr\OpenWithList" /v "a" /t REG_SZ /d "PhotoViewer.dll" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jxr\OpenWithList" /v "MRUList" /t REG_SZ /d "a" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jxr\UserChoice" /v "Hash" /t REG_SZ /d "ahz7f/Yl09M=" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jxr\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.Wdp" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.png\OpenWithList" /v "a" /t REG_SZ /d "PhotoViewer.dll" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.png\OpenWithList" /v "MRUList" /t REG_SZ /d "a" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.png\UserChoice" /v "Hash" /t REG_SZ /d "Evm7jp++AWA=" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.png\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.Png" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.tif\OpenWithList" /v "a" /t REG_SZ /d "PhotoViewer.dll" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.tif\OpenWithList" /v "MRUList" /t REG_SZ /d "a" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.tif\UserChoice" /v "Hash" /t REG_SZ /d "wEj9gLqtYH4=" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.tif\UserChoice" /v "ProgId" /t REG_SZ /d "TIFImage.Document" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.tiff\OpenWithList" /v "a" /t REG_SZ /d "PhotoViewer.dll" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.tiff\OpenWithList" /v "MRUList" /t REG_SZ /d "a" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.tiff\UserChoice" /v "Hash" /t REG_SZ /d "/r2V12Yryig=" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.tiff\UserChoice" /v "ProgId" /t REG_SZ /d "TIFImage.Document" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.wdp\OpenWithList" /v "a" /t REG_SZ /d "PhotoViewer.dll" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.wdp\OpenWithList" /v "MRUList" /t REG_SZ /d "a" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.wdp\UserChoice" /v "Hash" /t REG_SZ /d "/qcrPB0bhuI=" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.wdp\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.Wdp" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.bmp\UserChoice" /v "Hash" /t REG_SZ /d "rEigxhAPyos=" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.bmp\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.Bitmap" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.dib\UserChoice" /v "Hash" /t REG_SZ /d "R60f5QZs3Hg=" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.dib\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.Bitmap" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.gif\UserChoice" /v "Hash" /t REG_SZ /d "YcQO9pssSPU=" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.gif\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.Gif" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.jfif\UserChoice" /v "Hash" /t REG_SZ /d "5yjvWKb+Jns=" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.jfif\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.JFIF" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.jpe\UserChoice" /v "Hash" /t REG_SZ /d "TujD2rCi+po=" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.jpe\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.Jpeg" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.jpeg\UserChoice" /v "Hash" /t REG_SZ /d "wdZ9wQI4vW8=" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.jpeg\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.Jpeg" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.jpg\UserChoice" /v "Hash" /t REG_SZ /d "3xY0V0JOiFc=" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.jpg\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.Jpeg" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.jxr\UserChoice" /v "Hash" /t REG_SZ /d "ENXEd5Uzg84=" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.jxr\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.Wdp" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.png\UserChoice" /v "Hash" /t REG_SZ /d "SPesrUKrIFE=" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.png\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.Png" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.tif\UserChoice" /v "Hash" /t REG_SZ /d "bCXQRSAHD/I=" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.tif\UserChoice" /v "ProgId" /t REG_SZ /d "TIFImage.Document" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.tiff\UserChoice" /v "Hash" /t REG_SZ /d "7F/LfjhVnes=" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.tiff\UserChoice" /v "ProgId" /t REG_SZ /d "TIFImage.Document" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.wdp\UserChoice" /v "Hash" /t REG_SZ /d "tu0JqOen+Es=" /f >nul
			Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.wdp\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.Wdp" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Classes\Applications\photoviewer.dll\shell\open" /v "MuiVerb" /t REG_SZ /d "@photoviewer.dll,-3043" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Classes\Applications\photoviewer.dll\shell\open\command" /ve /t REG_EXPAND_SZ /d "%%SystemRoot%%\System32\rundll32.exe \"%%ProgramFiles%%\Windows Photo Viewer\PhotoViewer.dll\", ImageView_Fullscreen %%1" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Classes\Applications\photoviewer.dll\shell\open\DropTarget" /v "Clsid" /t REG_SZ /d "{FFE2A43C-56B9-4bf5-9A79-CC6D4285608A}" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Classes\Applications\photoviewer.dll\shell\print\command" /ve /t REG_EXPAND_SZ /d "%%SystemRoot%%\System32\rundll32.exe \"%%ProgramFiles%%\Windows Photo Viewer\PhotoViewer.dll\", ImageView_Fullscreen %%1" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Classes\Applications\photoviewer.dll\shell\print\DropTarget" /v "Clsid" /t REG_SZ /d "{60fd46de-f830-4894-a628-6fa81bc0190d}" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Bitmap" /v "FriendlyTypeName" /t REG_EXPAND_SZ /d "@%%ProgramFiles%%\Windows Photo Viewer\PhotoViewer.dll,-3056" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Bitmap" /v "ImageOptionFlags" /t REG_DWORD /d "1" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Bitmap\DefaultIcon" /ve /t REG_SZ /d "%%SystemRoot%%\System32\imageres.dll,-70" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Bitmap\shell\open\command" /ve /t REG_EXPAND_SZ /d "%%SystemRoot%%\System32\rundll32.exe \"%%ProgramFiles%%\Windows Photo Viewer\PhotoViewer.dll\", ImageView_Fullscreen %%1" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Bitmap\shell\open\DropTarget" /v "Clsid" /t REG_SZ /d "{FFE2A43C-56B9-4bf5-9A79-CC6D4285608A}" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Gif" /v "FriendlyTypeName" /t REG_EXPAND_SZ /d "@%%ProgramFiles%%\Windows Photo Viewer\PhotoViewer.dll,-3057" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Gif" /v "ImageOptionFlags" /t REG_DWORD /d "1" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Gif\DefaultIcon" /ve /t REG_SZ /d "%%SystemRoot%%\System32\imageres.dll,-83" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Gif\shell\open\command" /ve /t REG_EXPAND_SZ /d "%%SystemRoot%%\System32\rundll32.exe \"%%ProgramFiles%%\Windows Photo Viewer\PhotoViewer.dll\", ImageView_Fullscreen %%1" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Gif\shell\open\DropTarget" /v "Clsid" /t REG_SZ /d "{FFE2A43C-56B9-4bf5-9A79-CC6D4285608A}" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.JFIF" /v "EditFlags" /t REG_DWORD /d "65536" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.JFIF" /v "FriendlyTypeName" /t REG_EXPAND_SZ /d "@%%ProgramFiles%%\Windows Photo Viewer\PhotoViewer.dll,-3055" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.JFIF" /v "ImageOptionFlags" /t REG_DWORD /d "1" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.JFIF\DefaultIcon" /ve /t REG_SZ /d "%%SystemRoot%%\System32\imageres.dll,-72" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.JFIF\shell\open" /v "MuiVerb" /t REG_EXPAND_SZ /d "@%%ProgramFiles%%\Windows Photo Viewer\photoviewer.dll,-3043" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.JFIF\shell\open\command" /ve /t REG_EXPAND_SZ /d "%%SystemRoot%%\System32\rundll32.exe \"%%ProgramFiles%%\Windows Photo Viewer\PhotoViewer.dll\", ImageView_Fullscreen %%1" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.JFIF\shell\open\DropTarget" /v "Clsid" /t REG_SZ /d "{FFE2A43C-56B9-4bf5-9A79-CC6D4285608A}" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Jpeg" /v "EditFlags" /t REG_DWORD /d "65536" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Jpeg" /v "FriendlyTypeName" /t REG_EXPAND_SZ /d "@%%ProgramFiles%%\Windows Photo Viewer\PhotoViewer.dll,-3055" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Jpeg" /v "ImageOptionFlags" /t REG_DWORD /d "1" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Jpeg\DefaultIcon" /ve /t REG_SZ /d "%%SystemRoot%%\System32\imageres.dll,-72" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Jpeg\shell\open" /v "MuiVerb" /t REG_EXPAND_SZ /d "@%%ProgramFiles%%\Windows Photo Viewer\photoviewer.dll,-3043" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Jpeg\shell\open\command" /ve /t REG_EXPAND_SZ /d "%%SystemRoot%%\System32\rundll32.exe \"%%ProgramFiles%%\Windows Photo Viewer\PhotoViewer.dll\", ImageView_Fullscreen %%1" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Jpeg\shell\open\DropTarget" /v "Clsid" /t REG_SZ /d "{FFE2A43C-56B9-4bf5-9A79-CC6D4285608A}" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Png" /v "FriendlyTypeName" /t REG_EXPAND_SZ /d "@%%ProgramFiles%%\Windows Photo Viewer\PhotoViewer.dll,-3057" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Png" /v "ImageOptionFlags" /t REG_DWORD /d "1" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Png\DefaultIcon" /ve /t REG_SZ /d "%%SystemRoot%%\System32\imageres.dll,-71" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Png\shell\open\command" /ve /t REG_EXPAND_SZ /d "%%SystemRoot%%\System32\rundll32.exe \"%%ProgramFiles%%\Windows Photo Viewer\PhotoViewer.dll\", ImageView_Fullscreen %%1" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Png\shell\open\DropTarget" /v "Clsid" /t REG_SZ /d "{FFE2A43C-56B9-4bf5-9A79-CC6D4285608A}" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Tiff" /v "FriendlyTypeName" /t REG_EXPAND_SZ /d "@%%ProgramFiles%%\Windows Photo Viewer\PhotoViewer.dll,-3058" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Tiff" /v "ImageOptionFlags" /t REG_DWORD /d "1" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Tiff\DefaultIcon" /ve /t REG_SZ /d "%%SystemRoot%%\System32\imageres.dll,-122" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Tiff\shell\open" /v "MuiVerb" /t REG_EXPAND_SZ /d "@%%ProgramFiles%%\Windows Photo Viewer\photoviewer.dll,-3043" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Tiff\shell\open\command" /ve /t REG_EXPAND_SZ /d "%%SystemRoot%%\System32\rundll32.exe \"%%ProgramFiles%%\Windows Photo Viewer\PhotoViewer.dll\", ImageView_Fullscreen %%1" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Tiff\shell\open\DropTarget" /v "Clsid" /t REG_SZ /d "{FFE2A43C-56B9-4bf5-9A79-CC6D4285608A}" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Wdp" /v "EditFlags" /t REG_DWORD /d "65536" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Wdp" /v "ImageOptionFlags" /t REG_DWORD /d "1" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Wdp\DefaultIcon" /ve /t REG_SZ /d "%%SystemRoot%%\System32\wmphoto.dll,-400" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Wdp\shell\open" /v "MuiVerb" /t REG_EXPAND_SZ /d "@%%ProgramFiles%%\Windows Photo Viewer\photoviewer.dll,-3043" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Wdp\shell\open\command" /ve /t REG_EXPAND_SZ /d "%%SystemRoot%%\System32\rundll32.exe \"%%ProgramFiles%%\Windows Photo Viewer\PhotoViewer.dll\", ImageView_Fullscreen %%1" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Wdp\shell\open\DropTarget" /v "Clsid" /t REG_SZ /d "{FFE2A43C-56B9-4bf5-9A79-CC6D4285608A}" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows Photo Viewer\Capabilities" /v "ApplicationDescription" /t REG_SZ /d "@%%ProgramFiles%%\Windows Photo Viewer\photoviewer.dll,-3069" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows Photo Viewer\Capabilities" /v "ApplicationName" /t REG_SZ /d "@%%ProgramFiles%%\Windows Photo Viewer\photoviewer.dll,-3009" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows Photo Viewer\Capabilities\FileAssociations" /v ".bmp" /t REG_SZ /d "PhotoViewer.FileAssoc.Bitmap" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows Photo Viewer\Capabilities\FileAssociations" /v ".dib" /t REG_SZ /d "PhotoViewer.FileAssoc.Bitmap" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows Photo Viewer\Capabilities\FileAssociations" /v ".gif" /t REG_SZ /d "PhotoViewer.FileAssoc.Gif" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows Photo Viewer\Capabilities\FileAssociations" /v ".jfif" /t REG_SZ /d "PhotoViewer.FileAssoc.JFIF" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows Photo Viewer\Capabilities\FileAssociations" /v ".jpe" /t REG_SZ /d "PhotoViewer.FileAssoc.Jpeg" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows Photo Viewer\Capabilities\FileAssociations" /v ".jpeg" /t REG_SZ /d "PhotoViewer.FileAssoc.Jpeg" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows Photo Viewer\Capabilities\FileAssociations" /v ".jpg" /t REG_SZ /d "PhotoViewer.FileAssoc.Jpeg" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows Photo Viewer\Capabilities\FileAssociations" /v ".jxr" /t REG_SZ /d "PhotoViewer.FileAssoc.Wdp" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows Photo Viewer\Capabilities\FileAssociations" /v ".png" /t REG_SZ /d "PhotoViewer.FileAssoc.Png" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows Photo Viewer\Capabilities\FileAssociations" /v ".tif" /t REG_SZ /d "PhotoViewer.FileAssoc.Tiff" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows Photo Viewer\Capabilities\FileAssociations" /v ".tiff" /t REG_SZ /d "PhotoViewer.FileAssoc.Tiff" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows Photo Viewer\Capabilities\FileAssociations" /v ".wdp" /t REG_SZ /d "PhotoViewer.FileAssoc.Wdp" /f >nul
		)

		if "%Tweak%" equ "EnableFMP3ProCodec" (
			if "%ImageArchitecture%" equ "x86" (
				Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows NT\CurrentVersion\drivers.desc" /v "%%SystemRoot%%\System32\l3codecp.acm" /t REG_SZ /d "Fraunhofer IIS MPEG Layer-3 Codec (Professional)" /f >nul
				Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows NT\CurrentVersion\Drivers32" /v "msacm.l3acm" /t REG_EXPAND_SZ /d "%%SystemRoot%%\System32\l3codecp.acm" /f >nul
				Reg delete "HKLM\TK_SOFTWARE\Microsoft\Windows NT\CurrentVersion\drivers.desc" /f >nul 2>&1
			)

			if "%ImageArchitecture%" equ "x64" (
				Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows NT\CurrentVersion\drivers.desc" /v "%%SystemRoot%%\System32\l3codecp.acm" /t REG_SZ /d "Fraunhofer IIS MPEG Layer-3 Codec (Professional)" /f >nul
				Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows NT\CurrentVersion\Drivers32" /v "msacm.l3acm" /t REG_EXPAND_SZ /d "%%SystemRoot%%\System32\l3codecp.acm" /f >nul
				Reg add "HKLM\TK_SOFTWARE\Wow6432Node\Microsoft\Windows NT\CurrentVersion\drivers.desc" /v "%%SystemRoot%%\SysWOW64\l3codecp.acm" /t REG_SZ /d "Fraunhofer IIS MPEG Layer-3 Codec (Professional)" /f >nul
				Reg add "HKLM\TK_SOFTWARE\Wow6432Node\Microsoft\Windows NT\CurrentVersion\Drivers32" /v "msacm.l3acm" /t REG_EXPAND_SZ /d "%%SystemRoot%%\SysWOW64\l3codecp.acm" /f >nul
				Reg delete "HKLM\TK_SOFTWARE\Microsoft\Windows NT\CurrentVersion\drivers.desc" /f >nul 2>&1
				Reg delete "HKLM\TK_SOFTWARE\Wow6432Node\Microsoft\Windows NT\CurrentVersion\drivers.desc" /f >nul 2>&1
			)
		)

		if "%Tweak%" equ "EnableFullResetBase" Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\SideBySide\Configuration" /v "DisableResetbase" /t REG_DWORD /d "0" /f >nul

		echo.Un-Mounting Image Registry...
		call :UnMountImageRegistry
	)
) else (
	echo.Mounting Image Registry...
	call :MountImageRegistry "%InstallMount%"
	echo.Importing Registry Settings to Image Registry...

	if "%Tweak%" equ "DisableCortanaApp" (
		Reg add "HKLM\TK_DEFAULT\SOFTWARE\Microsoft\InputPersonalization\TrainedDataStore" /v "HarvestContacts" /t REG_DWORD /d "0" /f >nul 2>&1
		Reg add "HKLM\TK_DEFAULT\SOFTWARE\Microsoft\Windows\CurrentVersion\Search" /v "DeviceHistoryEnabled" /t REG_DWORD /d "0" /f >nul 2>&1
		Reg add "HKLM\TK_DEFAULT\SOFTWARE\Microsoft\Windows\CurrentVersion\Search" /v "HistoryViewEnabled" /t REG_DWORD /d "0" /f >nul 2>&1
		Reg add "HKLM\TK_DEFAULT\SOFTWARE\Microsoft\Windows\CurrentVersion\Windows Search" /v "CortanaConsent" /t REG_DWORD /d "0" /f >nul 2>&1
		Reg add "HKLM\TK_DEFAULT\SOFTWARE\Microsoft\Windows\CurrentVersion\Windows Search" /v "CortanaIsReplaceable" /t REG_DWORD /d "1" /f >nul 2>&1
		Reg add "HKLM\TK_DEFAULT\SOFTWARE\Microsoft\Windows\CurrentVersion\Windows Search" /v "CortanaIsReplaced" /t REG_DWORD /d "1" /f >nul 2>&1
		Reg add "HKLM\TK_DEFAULT\SOFTWARE\Microsoft\Windows\CurrentVersion\Windows Search" /v "SearchboxTaskbarMode" /t REG_DWORD /d "0" /f >nul 2>&1
		Reg add "HKLM\TK_DEFAULT\SOFTWARE\Policies\Microsoft\InputPersonalization" /v "RestrictImplicitInkCollection" /t REG_DWORD /d "1" /f >nul 2>&1
		Reg add "HKLM\TK_DEFAULT\SOFTWARE\Policies\Microsoft\InputPersonalization" /v "RestrictImplicitTextCollection" /t REG_DWORD /d "1" /f >nul 2>&1
		Reg add "HKLM\TK_NTUSER\SOFTWARE\Classes\Local Settings\Software\Microsoft\Windows\CurrentVersion\AppContainer\Storage\microsoft.microsoftedge_8wekyb3d8bbwe\MicrosoftEdge\ServiceUI" /v "EnableCortana" /t REG_DWORD /d "0" /f >nul 2>&1
		Reg add "HKLM\TK_NTUSER\SOFTWARE\Microsoft\InputPersonalization" /v "RestrictImplicitInkCollection" /t REG_DWORD /d "1" /f >nul 2>&1
		Reg add "HKLM\TK_NTUSER\SOFTWARE\Microsoft\InputPersonalization" /v "RestrictImplicitTextCollection" /t REG_DWORD /d "1" /f >nul 2>&1
		Reg add "HKLM\TK_NTUSER\SOFTWARE\Microsoft\InputPersonalization\TrainedDataStore" /v "HarvestContacts" /t REG_DWORD /d "0" /f >nul 2>&1
		Reg add "HKLM\TK_NTUSER\SOFTWARE\Microsoft\Personalization\Settings" /v "AcceptedPrivacyPolicy" /t REG_DWORD /d "0" /f >nul 2>&1
		Reg add "HKLM\TK_NTUSER\SOFTWARE\Microsoft\Windows\CurrentVersion\Search" /v "DeviceHistoryEnabled" /t REG_DWORD /d "0" /f >nul 2>&1
		Reg add "HKLM\TK_NTUSER\SOFTWARE\Microsoft\Windows\CurrentVersion\Search" /v "HistoryViewEnabled" /t REG_DWORD /d "0" /f >nul 2>&1
		Reg add "HKLM\TK_NTUSER\SOFTWARE\Microsoft\Windows\CurrentVersion\Windows Search" /v "CortanaConsent" /t REG_DWORD /d "0" /f >nul 2>&1
		Reg add "HKLM\TK_NTUSER\SOFTWARE\Microsoft\Windows\CurrentVersion\Windows Search" /v "CortanaIsReplaceable" /t REG_DWORD /d "1" /f >nul 2>&1
		Reg add "HKLM\TK_NTUSER\SOFTWARE\Microsoft\Windows\CurrentVersion\Windows Search" /v "CortanaIsReplaced" /t REG_DWORD /d "1" /f >nul 2>&1
		Reg add "HKLM\TK_NTUSER\SOFTWARE\Microsoft\Windows\CurrentVersion\Windows Search" /v "SearchboxTaskbarMode" /t REG_DWORD /d "0" /f >nul 2>&1
		Reg add "HKLM\TK_SOFTWARE\Microsoft\PolicyManager\current\device\AboveLock" /v "AllowCortanaAboveLock" /t REG_DWORD /d "0" /f >nul 2>&1
		Reg add "HKLM\TK_SOFTWARE\Microsoft\PolicyManager\current\device\Experience" /v "AllowCortana" /t REG_DWORD /d "0" /f >nul 2>&1
		Reg add "HKLM\TK_SOFTWARE\Microsoft\Speech_OneCore\Preferences" /v "ModelDownloadAllowed" /t REG_DWORD /d "0" /f >nul 2>&1
		Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Search" /v "SearchboxTaskbarMode" /t REG_DWORD /d "1" /f >nul 2>&1
		Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\Windows Search" /v "AllowCloudSearch" /t REG_DWORD /d "0" /f >nul 2>&1
		Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\Windows Search" /v "AllowCortana" /t REG_DWORD /d "0" /f >nul 2>&1
		Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\Windows Search" /v "AllowCortanaAboveLock" /t REG_DWORD /d "0" /f >nul 2>&1
		Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\Windows Search" /v "AllowSearchToUseLocation" /t REG_DWORD /d "0" /f >nul 2>&1
		Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\Windows Search" /v "ConnectedSearchPrivacy" /t REG_DWORD /d "3" /f >nul 2>&1
		Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\Windows Search" /v "ConnectedSearchSafeSearch" /t REG_DWORD /d "3" /f >nul 2>&1
		Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\Windows Search" /v "ConnectedSearchUseWeb" /t REG_DWORD /d "0" /f >nul 2>&1
		Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\Windows Search" /v "ConnectedSearchUseWebOverMeteredConnections" /t REG_DWORD /d "0" /f >nul 2>&1
		Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\Windows Search" /v "DisableWebSearch" /t REG_DWORD /d "1" /f >nul 2>&1
		Reg add "HKLM\TK_SOFTWARE\Policies\Wow6432Node\Microsoft\Windows\Windows Search" /v "AllowCortana" /t REG_DWORD /d "0" /f >nul 2>&1
		Reg add "HKLM\TK_SOFTWARE\Policies\Wow6432Node\Microsoft\Windows\Windows Search" /v "AllowCortanaAboveLock" /t REG_DWORD /d "0" /f >nul 2>&1
		Reg add "HKLM\TK_SYSTEM\ControlSet001\Services\SharedAccess\Parameters\FirewallPolicy\FirewallRules" /v "Block Cortana ActionUriServer.exe" /t REG_SZ /d "v2.26|Action=Block|Active=TRUE|Dir=Out|RA42=IntErnet|RA62=IntErnet|App=C:\Windows\SystemApps\Microsoft.Windows.Cortana_cw5n1h2txyewy\ActionUriServer.exe|Name=Block Cortana ActionUriServer.exe|Desc=Block Cortana Outbound UDP/TCP Traffic|" /f >nul 2>&1
		Reg add "HKLM\TK_SYSTEM\ControlSet001\Services\SharedAccess\Parameters\FirewallPolicy\FirewallRules" /v "Block Cortana Package" /t REG_SZ /d "v2.26|Action=Block|Active=TRUE|Dir=Out|RA42=IntErnet|RA62=IntErnet|Name=Block Cortana Package|Desc=Block Cortana Outbound UDP/TCP Traffic|AppPkgId=S-1-15-2-1861897761-1695161497-2927542615-642690995-327840285-2659745135-2630312742|Platform=2:6:2|Platform2=GTEQ|" /f >nul 2>&1
		Reg add "HKLM\TK_SYSTEM\ControlSet001\Services\SharedAccess\Parameters\FirewallPolicy\FirewallRules" /v "Block Cortana PlacesServer.exe" /t REG_SZ /d "v2.26|Action=Block|Active=TRUE|Dir=Out|RA42=IntErnet|RA62=IntErnet|App=C:\Windows\SystemApps\Microsoft.Windows.Cortana_cw5n1h2txyewy\PlacesServer.exe|Name=Block Cortana PlacesServer.exe|Desc=Block Cortana Outbound UDP/TCP Traffic|" /f >nul 2>&1
		Reg add "HKLM\TK_SYSTEM\ControlSet001\Services\SharedAccess\Parameters\FirewallPolicy\FirewallRules" /v "Block Cortana RemindersServer.exe" /t REG_SZ /d "v2.26|Action=Block|Active=TRUE|Dir=Out|RA42=IntErnet|RA62=IntErnet|App=C:\Windows\SystemApps\Microsoft.Windows.Cortana_cw5n1h2txyewy\RemindersServer.exe|Name=Block Cortana RemindersServer.exe|Desc=Block Cortana Outbound UDP/TCP Traffic|" /f >nul 2>&1
		Reg add "HKLM\TK_SYSTEM\ControlSet001\Services\SharedAccess\Parameters\FirewallPolicy\FirewallRules" /v "Block Cortana RemindersShareTargetApp.exe" /t REG_SZ /d "v2.26|Action=Block|Active=TRUE|Dir=Out|RA42=IntErnet|RA62=IntErnet|App=C:\Windows\SystemApps\Microsoft.Windows.Cortana_cw5n1h2txyewy\RemindersShareTargetApp.exe|Name=Block Cortana RemindersShareTargetApp.exe|Desc=Block Cortana Outbound UDP/TCP Traffic|" /f >nul 2>&1
		Reg add "HKLM\TK_SYSTEM\ControlSet001\Services\SharedAccess\Parameters\FirewallPolicy\FirewallRules" /v "Block Cortana SearchUI.exe" /t REG_SZ /d "v2.26|Action=Block|Active=TRUE|Dir=Out|RA42=IntErnet|RA62=IntErnet|App=C:\Windows\SystemApps\Microsoft.Windows.Cortana_cw5n1h2txyewy\SearchUI.exe|Name=Block Cortana SearchUI.exe|Desc=Block Cortana Outbound UDP/TCP Traffic|" /f >nul 2>&1
	)
		
	if "%Tweak%" equ "HideTaskViewIcon" Reg add "HKLM\TK_NTUSER\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\Advanced" /v "ShowTaskViewButton" /t REG_DWORD /d "0" /f >nul

	if "%Tweak%" equ "DisableDriversUpdates" (
		Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\Device Metadata" /v "PreventDeviceMetadataFromNetwork" /t REG_DWORD /d "1" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\DriverSearching" /v "DontPromptForWindowsUpdate" /t REG_DWORD /d "1" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\DriverSearching" /v "DontSearchWindowsUpdate" /t REG_DWORD /d "1" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\DriverSearching" /v "DriverUpdateWizardWuSearchEnabled" /t REG_DWORD /d "0" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\DriverSearching" /v "SearchOrderConfig" /t REG_DWORD /d "1" /f >nul		
		Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\WindowsUpdate" /v "ExcludeWUDriversInQualityUpdate" /t REG_DWORD /d "1" /f >nul
	)

	if "%Tweak%" equ "Disable3RDPartyApps" (
		Reg add "HKLM\TK_NTUSER\SOFTWARE\Microsoft\Windows\CurrentVersion\ContentDeliveryManager" /v "OemPreInstalledAppsEnabled" /t REG_DWORD /d "0" /f >nul
		Reg add "HKLM\TK_NTUSER\SOFTWARE\Microsoft\Windows\CurrentVersion\ContentDeliveryManager" /v "PreInstalledAppsEnabled" /t REG_DWORD /d "0" /f >nul
		Reg add "HKLM\TK_NTUSER\SOFTWARE\Microsoft\Windows\CurrentVersion\ContentDeliveryManager" /v "SilentInstalledAppsEnabled" /t REG_DWORD /d "0" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\CloudContent" /v "DisableWindowsConsumerFeatures" /t REG_DWORD /d "1" /f >nul
	)

	if "%Tweak%" equ "DisableWindowsDefender" (
		Reg add "HKLM\TK_DEFAULT\SOFTWARE\Microsoft\Windows Security Health\State" /v "AccountProtection_MicrosoftAccount_Disconnected" /t REG_DWORD /d "0" /f >nul 2>&1
		Reg add "HKLM\TK_NTUSER\SOFTWARE\Microsoft\Windows Security Health\State" /v "AccountProtection_MicrosoftAccount_Disconnected" /t REG_DWORD /d "0" /f >nul 2>&1
		Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows Defender\Features" /v "TamperProtection" /t REG_DWORD /d "0" /f >nul 2>&1
		Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\MRT" /v "DontOfferThroughWUAU" /t REG_DWORD /d "1" /f >nul 2>&1
		Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\MRT" /v "DontReportInfectionInformation" /t REG_DWORD /d "1" /f >nul 2>&1
		Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows Defender" /v "DisableAntiSpyware" /t REG_DWORD /d "1" /f >nul 2>&1
		Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows Defender\Spynet" /v "SpyNetReporting" /t REG_DWORD /d "0" /f >nul 2>&1
		Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows Defender\Spynet" /v "SubmitSamplesConsent" /t REG_DWORD /d "2" /f >nul 2>&1
	)
	
	if "%Tweak%" equ "DisableWindowsUpgrade" (
		if "%SelectedSourceOS%" neq "w10" (
			Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\Gwx" /v "DisableGwx" /t REG_DWORD /d "1" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\WindowsUpdate" /v "DisableOSUpgrade" /t REG_DWORD /d "1" /f >nul
		)
			
		if "%SelectedSourceOS%" equ "w10" (
			Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\WindowsUpdate" /v "DeferUpdatePeriod" /t REG_DWORD /d "0" /f >nul 2>&1
			Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\WindowsUpdate" /v "DeferUpgrade" /t REG_DWORD /d "1" /f >nul 2>&1
			Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\WindowsUpdate" /v "DeferUpgradePeriod" /t REG_DWORD /d "1" /f >nul 2>&1
			Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\WindowsUpdate\AU" /v "AUOptions" /t REG_DWORD /d "2" /f >nul
		)
	)

	if "%Tweak%" equ "DisableWindowsUpdate" (
		Reg add "HKLM\TK_DEFAULT\SOFTWARE\Microsoft\Windows\CurrentVersion\ContentDeliveryManager" /v "SubscribedContent-310093Enabled" /t REG_DWORD /d "0" /f >nul 2>&1
		Reg add "HKLM\TK_NTUSER\SOFTWARE\Microsoft\Windows\CurrentVersion\ContentDeliveryManager" /v "SubscribedContent-310093Enabled" /t REG_DWORD /d "0" /f >nul 2>&1
		Reg add "HKLM\TK_NTUSER\SOFTWARE\Microsoft\Windows\CurrentVersion\DeliveryOptimization" /v "SystemSettingsDownloadMode" /t REG_DWORD /d "0" /f >nul 2>&1
		Reg add "HKLM\TK_SOFTWARE\Microsoft\Speech_OneCore\Preferences" /v "ModelDownloadAllowed" /t REG_DWORD /d "0" /f >nul 2>&1
		Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\DeliveryOptimization" /v "OptInOOBE" /t REG_DWORD /d "0" /f >nul 2>&1
		Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\DeliveryOptimization\Config" /v "DODownloadMode" /t REG_DWORD /d "0" /f >nul 2>&1
		Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\WindowsStore\WindowsUpdate" /v "AutoDownload" /t REG_DWORD /d "2" /f >nul 2>&1
		Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\WindowsUpdate\Services\7971f918-a847-4430-9279-4a52d1efe18d" /v "registeredWithAU" /t REG_DWORD /d "0" /f >nul 2>&1
		Reg add "HKLM\TK_SOFTWARE\Microsoft\WindowsUpdate\UX\Settings" /v "HideMCTLink" /t REG_DWORD /d "1" /f >nul 2>&1
		Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Speech" /v "AllowSpeechModelUpdate" /t REG_DWORD /d "0" /f >nul 2>&1
		Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\DeliveryOptimization" /v "DODownloadMode" /t REG_DWORD /d "0" /f >nul 2>&1
		Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\DeliveryOptimization" /v "DODownloadMode" /t REG_DWORD /d "63" /f >nul 2>&1
		Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\WindowsUpdate\AU" /v "AUOptions" /t REG_DWORD /d "2" /f >nul 2>&1
		Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\WindowsUpdate\AU" /v "NoAutoUpdate" /t REG_DWORD /d "1" /f >nul 2>&1
		Reg add "HKLM\TK_SYSTEM\ControlSet001\Services\wuauserv" /v "Start" /t REG_DWORD /d "4" /f >nul 2>&1
	)
		
	if "%Tweak%" equ "DisableReservedStorage" Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\ReserveManager" /v "ShippedWithReserves" /t REG_DWORD /d "0" /f >nul
	if "%Tweak%" equ "ForceLatestNetFramework" Reg add "HKLM\TK_SOFTWARE\Microsoft\.NETFramework" /v "OnlyUseLatestCLR" /t REG_DWORD /d "1" /f >nul

	if "%Tweak%" equ "EnablePhotoViewer" (
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\ApplicationAssociationToasts" /v "emffile_.emf" /t REG_DWORD /d "0" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\ApplicationAssociationToasts" /v "rlefile_.rle" /t REG_DWORD /d "0" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\ApplicationAssociationToasts" /v "wmffile_.wmf" /t REG_DWORD /d "0" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer" /v "GlobalAssocChangedCounter" /t REG_DWORD /d "13" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.bmp\OpenWithList" /v "a" /t REG_SZ /d "PhotoViewer.dll" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.bmp\OpenWithList" /v "MRUList" /t REG_SZ /d "a" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.bmp\UserChoice" /v "Hash" /t REG_SZ /d "TDU75KWAGi4=" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.bmp\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.Bitmap" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.dib\OpenWithList" /v "a" /t REG_SZ /d "PhotoViewer.dll" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.dib\OpenWithList" /v "MRUList" /t REG_SZ /d "a" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.dib\UserChoice" /v "Hash" /t REG_SZ /d "hAQpLYJfRYE=" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.dib\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.Bitmap" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.gif\OpenWithList" /v "a" /t REG_SZ /d "PhotoViewer.dll" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.gif\OpenWithList" /v "MRUList" /t REG_SZ /d "a" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.gif\UserChoice" /v "Hash" /t REG_SZ /d "1in4hcmDrB4=" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.gif\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.Gif" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jfif\OpenWithList" /v "a" /t REG_SZ /d "PhotoViewer.dll" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jfif\OpenWithList" /v "MRUList" /t REG_SZ /d "a" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jfif\UserChoice" /v "Hash" /t REG_SZ /d "Y5upkzp3g5E=" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jfif\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.JFIF" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jpe\OpenWithList" /v "a" /t REG_SZ /d "PhotoViewer.dll" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jpe\OpenWithList" /v "MRUList" /t REG_SZ /d "a" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jpe\UserChoice" /v "Hash" /t REG_SZ /d "ZIeqfdrNtFk=" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jpe\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.Jpeg" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jpeg\OpenWithList" /v "a" /t REG_SZ /d "PhotoViewer.dll" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jpeg\OpenWithList" /v "MRUList" /t REG_SZ /d "a" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jpeg\UserChoice" /v "Hash" /t REG_SZ /d "iVWM3EAePKw=" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jpeg\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.Jpeg" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jpg\OpenWithList" /v "a" /t REG_SZ /d "PhotoViewer.dll" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jpg\OpenWithList" /v "MRUList" /t REG_SZ /d "a" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jpg\UserChoice" /v "Hash" /t REG_SZ /d "Xq9gH4jXoFM=" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jpg\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.Jpeg" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jxr\OpenWithList" /v "a" /t REG_SZ /d "PhotoViewer.dll" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jxr\OpenWithList" /v "MRUList" /t REG_SZ /d "a" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jxr\UserChoice" /v "Hash" /t REG_SZ /d "ahz7f/Yl09M=" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jxr\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.Wdp" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.png\OpenWithList" /v "a" /t REG_SZ /d "PhotoViewer.dll" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.png\OpenWithList" /v "MRUList" /t REG_SZ /d "a" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.png\UserChoice" /v "Hash" /t REG_SZ /d "Evm7jp++AWA=" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.png\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.Png" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.tif\OpenWithList" /v "a" /t REG_SZ /d "PhotoViewer.dll" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.tif\OpenWithList" /v "MRUList" /t REG_SZ /d "a" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.tif\UserChoice" /v "Hash" /t REG_SZ /d "wEj9gLqtYH4=" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.tif\UserChoice" /v "ProgId" /t REG_SZ /d "TIFImage.Document" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.tiff\OpenWithList" /v "a" /t REG_SZ /d "PhotoViewer.dll" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.tiff\OpenWithList" /v "MRUList" /t REG_SZ /d "a" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.tiff\UserChoice" /v "Hash" /t REG_SZ /d "/r2V12Yryig=" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.tiff\UserChoice" /v "ProgId" /t REG_SZ /d "TIFImage.Document" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.wdp\OpenWithList" /v "a" /t REG_SZ /d "PhotoViewer.dll" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.wdp\OpenWithList" /v "MRUList" /t REG_SZ /d "a" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.wdp\UserChoice" /v "Hash" /t REG_SZ /d "/qcrPB0bhuI=" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.wdp\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.Wdp" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.bmp\UserChoice" /v "Hash" /t REG_SZ /d "rEigxhAPyos=" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.bmp\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.Bitmap" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.dib\UserChoice" /v "Hash" /t REG_SZ /d "R60f5QZs3Hg=" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.dib\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.Bitmap" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.gif\UserChoice" /v "Hash" /t REG_SZ /d "YcQO9pssSPU=" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.gif\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.Gif" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.jfif\UserChoice" /v "Hash" /t REG_SZ /d "5yjvWKb+Jns=" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.jfif\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.JFIF" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.jpe\UserChoice" /v "Hash" /t REG_SZ /d "TujD2rCi+po=" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.jpe\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.Jpeg" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.jpeg\UserChoice" /v "Hash" /t REG_SZ /d "wdZ9wQI4vW8=" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.jpeg\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.Jpeg" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.jpg\UserChoice" /v "Hash" /t REG_SZ /d "3xY0V0JOiFc=" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.jpg\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.Jpeg" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.jxr\UserChoice" /v "Hash" /t REG_SZ /d "ENXEd5Uzg84=" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.jxr\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.Wdp" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.png\UserChoice" /v "Hash" /t REG_SZ /d "SPesrUKrIFE=" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.png\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.Png" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.tif\UserChoice" /v "Hash" /t REG_SZ /d "bCXQRSAHD/I=" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.tif\UserChoice" /v "ProgId" /t REG_SZ /d "TIFImage.Document" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.tiff\UserChoice" /v "Hash" /t REG_SZ /d "7F/LfjhVnes=" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.tiff\UserChoice" /v "ProgId" /t REG_SZ /d "TIFImage.Document" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.wdp\UserChoice" /v "Hash" /t REG_SZ /d "tu0JqOen+Es=" /f >nul
		Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.wdp\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.Wdp" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Classes\Applications\photoviewer.dll\shell\open" /v "MuiVerb" /t REG_SZ /d "@photoviewer.dll,-3043" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Classes\Applications\photoviewer.dll\shell\open\command" /ve /t REG_EXPAND_SZ /d "%%SystemRoot%%\System32\rundll32.exe \"%%ProgramFiles%%\Windows Photo Viewer\PhotoViewer.dll\", ImageView_Fullscreen %%1" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Classes\Applications\photoviewer.dll\shell\open\DropTarget" /v "Clsid" /t REG_SZ /d "{FFE2A43C-56B9-4bf5-9A79-CC6D4285608A}" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Classes\Applications\photoviewer.dll\shell\print\command" /ve /t REG_EXPAND_SZ /d "%%SystemRoot%%\System32\rundll32.exe \"%%ProgramFiles%%\Windows Photo Viewer\PhotoViewer.dll\", ImageView_Fullscreen %%1" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Classes\Applications\photoviewer.dll\shell\print\DropTarget" /v "Clsid" /t REG_SZ /d "{60fd46de-f830-4894-a628-6fa81bc0190d}" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Bitmap" /v "FriendlyTypeName" /t REG_EXPAND_SZ /d "@%%ProgramFiles%%\Windows Photo Viewer\PhotoViewer.dll,-3056" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Bitmap" /v "ImageOptionFlags" /t REG_DWORD /d "1" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Bitmap\DefaultIcon" /ve /t REG_SZ /d "%%SystemRoot%%\System32\imageres.dll,-70" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Bitmap\shell\open\command" /ve /t REG_EXPAND_SZ /d "%%SystemRoot%%\System32\rundll32.exe \"%%ProgramFiles%%\Windows Photo Viewer\PhotoViewer.dll\", ImageView_Fullscreen %%1" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Bitmap\shell\open\DropTarget" /v "Clsid" /t REG_SZ /d "{FFE2A43C-56B9-4bf5-9A79-CC6D4285608A}" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Gif" /v "FriendlyTypeName" /t REG_EXPAND_SZ /d "@%%ProgramFiles%%\Windows Photo Viewer\PhotoViewer.dll,-3057" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Gif" /v "ImageOptionFlags" /t REG_DWORD /d "1" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Gif\DefaultIcon" /ve /t REG_SZ /d "%%SystemRoot%%\System32\imageres.dll,-83" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Gif\shell\open\command" /ve /t REG_EXPAND_SZ /d "%%SystemRoot%%\System32\rundll32.exe \"%%ProgramFiles%%\Windows Photo Viewer\PhotoViewer.dll\", ImageView_Fullscreen %%1" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Gif\shell\open\DropTarget" /v "Clsid" /t REG_SZ /d "{FFE2A43C-56B9-4bf5-9A79-CC6D4285608A}" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.JFIF" /v "EditFlags" /t REG_DWORD /d "65536" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.JFIF" /v "FriendlyTypeName" /t REG_EXPAND_SZ /d "@%%ProgramFiles%%\Windows Photo Viewer\PhotoViewer.dll,-3055" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.JFIF" /v "ImageOptionFlags" /t REG_DWORD /d "1" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.JFIF\DefaultIcon" /ve /t REG_SZ /d "%%SystemRoot%%\System32\imageres.dll,-72" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.JFIF\shell\open" /v "MuiVerb" /t REG_EXPAND_SZ /d "@%%ProgramFiles%%\Windows Photo Viewer\photoviewer.dll,-3043" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.JFIF\shell\open\command" /ve /t REG_EXPAND_SZ /d "%%SystemRoot%%\System32\rundll32.exe \"%%ProgramFiles%%\Windows Photo Viewer\PhotoViewer.dll\", ImageView_Fullscreen %%1" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.JFIF\shell\open\DropTarget" /v "Clsid" /t REG_SZ /d "{FFE2A43C-56B9-4bf5-9A79-CC6D4285608A}" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Jpeg" /v "EditFlags" /t REG_DWORD /d "65536" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Jpeg" /v "FriendlyTypeName" /t REG_EXPAND_SZ /d "@%%ProgramFiles%%\Windows Photo Viewer\PhotoViewer.dll,-3055" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Jpeg" /v "ImageOptionFlags" /t REG_DWORD /d "1" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Jpeg\DefaultIcon" /ve /t REG_SZ /d "%%SystemRoot%%\System32\imageres.dll,-72" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Jpeg\shell\open" /v "MuiVerb" /t REG_EXPAND_SZ /d "@%%ProgramFiles%%\Windows Photo Viewer\photoviewer.dll,-3043" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Jpeg\shell\open\command" /ve /t REG_EXPAND_SZ /d "%%SystemRoot%%\System32\rundll32.exe \"%%ProgramFiles%%\Windows Photo Viewer\PhotoViewer.dll\", ImageView_Fullscreen %%1" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Jpeg\shell\open\DropTarget" /v "Clsid" /t REG_SZ /d "{FFE2A43C-56B9-4bf5-9A79-CC6D4285608A}" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Png" /v "FriendlyTypeName" /t REG_EXPAND_SZ /d "@%%ProgramFiles%%\Windows Photo Viewer\PhotoViewer.dll,-3057" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Png" /v "ImageOptionFlags" /t REG_DWORD /d "1" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Png\DefaultIcon" /ve /t REG_SZ /d "%%SystemRoot%%\System32\imageres.dll,-71" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Png\shell\open\command" /ve /t REG_EXPAND_SZ /d "%%SystemRoot%%\System32\rundll32.exe \"%%ProgramFiles%%\Windows Photo Viewer\PhotoViewer.dll\", ImageView_Fullscreen %%1" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Png\shell\open\DropTarget" /v "Clsid" /t REG_SZ /d "{FFE2A43C-56B9-4bf5-9A79-CC6D4285608A}" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Tiff" /v "FriendlyTypeName" /t REG_EXPAND_SZ /d "@%%ProgramFiles%%\Windows Photo Viewer\PhotoViewer.dll,-3058" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Tiff" /v "ImageOptionFlags" /t REG_DWORD /d "1" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Tiff\DefaultIcon" /ve /t REG_SZ /d "%%SystemRoot%%\System32\imageres.dll,-122" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Tiff\shell\open" /v "MuiVerb" /t REG_EXPAND_SZ /d "@%%ProgramFiles%%\Windows Photo Viewer\photoviewer.dll,-3043" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Tiff\shell\open\command" /ve /t REG_EXPAND_SZ /d "%%SystemRoot%%\System32\rundll32.exe \"%%ProgramFiles%%\Windows Photo Viewer\PhotoViewer.dll\", ImageView_Fullscreen %%1" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Tiff\shell\open\DropTarget" /v "Clsid" /t REG_SZ /d "{FFE2A43C-56B9-4bf5-9A79-CC6D4285608A}" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Wdp" /v "EditFlags" /t REG_DWORD /d "65536" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Wdp" /v "ImageOptionFlags" /t REG_DWORD /d "1" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Wdp\DefaultIcon" /ve /t REG_SZ /d "%%SystemRoot%%\System32\wmphoto.dll,-400" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Wdp\shell\open" /v "MuiVerb" /t REG_EXPAND_SZ /d "@%%ProgramFiles%%\Windows Photo Viewer\photoviewer.dll,-3043" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Wdp\shell\open\command" /ve /t REG_EXPAND_SZ /d "%%SystemRoot%%\System32\rundll32.exe \"%%ProgramFiles%%\Windows Photo Viewer\PhotoViewer.dll\", ImageView_Fullscreen %%1" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Wdp\shell\open\DropTarget" /v "Clsid" /t REG_SZ /d "{FFE2A43C-56B9-4bf5-9A79-CC6D4285608A}" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows Photo Viewer\Capabilities" /v "ApplicationDescription" /t REG_SZ /d "@%%ProgramFiles%%\Windows Photo Viewer\photoviewer.dll,-3069" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows Photo Viewer\Capabilities" /v "ApplicationName" /t REG_SZ /d "@%%ProgramFiles%%\Windows Photo Viewer\photoviewer.dll,-3009" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows Photo Viewer\Capabilities\FileAssociations" /v ".bmp" /t REG_SZ /d "PhotoViewer.FileAssoc.Bitmap" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows Photo Viewer\Capabilities\FileAssociations" /v ".dib" /t REG_SZ /d "PhotoViewer.FileAssoc.Bitmap" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows Photo Viewer\Capabilities\FileAssociations" /v ".gif" /t REG_SZ /d "PhotoViewer.FileAssoc.Gif" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows Photo Viewer\Capabilities\FileAssociations" /v ".jfif" /t REG_SZ /d "PhotoViewer.FileAssoc.JFIF" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows Photo Viewer\Capabilities\FileAssociations" /v ".jpe" /t REG_SZ /d "PhotoViewer.FileAssoc.Jpeg" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows Photo Viewer\Capabilities\FileAssociations" /v ".jpeg" /t REG_SZ /d "PhotoViewer.FileAssoc.Jpeg" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows Photo Viewer\Capabilities\FileAssociations" /v ".jpg" /t REG_SZ /d "PhotoViewer.FileAssoc.Jpeg" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows Photo Viewer\Capabilities\FileAssociations" /v ".jxr" /t REG_SZ /d "PhotoViewer.FileAssoc.Wdp" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows Photo Viewer\Capabilities\FileAssociations" /v ".png" /t REG_SZ /d "PhotoViewer.FileAssoc.Png" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows Photo Viewer\Capabilities\FileAssociations" /v ".tif" /t REG_SZ /d "PhotoViewer.FileAssoc.Tiff" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows Photo Viewer\Capabilities\FileAssociations" /v ".tiff" /t REG_SZ /d "PhotoViewer.FileAssoc.Tiff" /f >nul
		Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows Photo Viewer\Capabilities\FileAssociations" /v ".wdp" /t REG_SZ /d "PhotoViewer.FileAssoc.Wdp" /f >nul
	)

	if "%Tweak%" equ "EnableFMP3ProCodec" (
		if "%ImageArchitecture%" equ "x86" (
			Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows NT\CurrentVersion\drivers.desc" /v "%%SystemRoot%%\System32\l3codecp.acm" /t REG_SZ /d "Fraunhofer IIS MPEG Layer-3 Codec (Professional)" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows NT\CurrentVersion\Drivers32" /v "msacm.l3acm" /t REG_EXPAND_SZ /d "%%SystemRoot%%\System32\l3codecp.acm" /f >nul
			Reg delete "HKLM\TK_SOFTWARE\Microsoft\Windows NT\CurrentVersion\drivers.desc" /f >nul 2>&1
		)

		if "%ImageArchitecture%" equ "x64" (
			Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows NT\CurrentVersion\drivers.desc" /v "%%SystemRoot%%\System32\l3codecp.acm" /t REG_SZ /d "Fraunhofer IIS MPEG Layer-3 Codec (Professional)" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows NT\CurrentVersion\Drivers32" /v "msacm.l3acm" /t REG_EXPAND_SZ /d "%%SystemRoot%%\System32\l3codecp.acm" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Wow6432Node\Microsoft\Windows NT\CurrentVersion\drivers.desc" /v "%%SystemRoot%%\SysWOW64\l3codecp.acm" /t REG_SZ /d "Fraunhofer IIS MPEG Layer-3 Codec (Professional)" /f >nul
			Reg add "HKLM\TK_SOFTWARE\Wow6432Node\Microsoft\Windows NT\CurrentVersion\Drivers32" /v "msacm.l3acm" /t REG_EXPAND_SZ /d "%%SystemRoot%%\SysWOW64\l3codecp.acm" /f >nul
			Reg delete "HKLM\TK_SOFTWARE\Microsoft\Windows NT\CurrentVersion\drivers.desc" /f >nul 2>&1
			Reg delete "HKLM\TK_SOFTWARE\Wow6432Node\Microsoft\Windows NT\CurrentVersion\drivers.desc" /f >nul 2>&1
		)
	)

	if "%Tweak%" equ "EnableFullResetBase" Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\SideBySide\Configuration" /v "DisableResetbase" /t REG_DWORD /d "0" /f >nul

	echo.Un-Mounting Image Registry...
	call :UnMountImageRegistry
)
echo.
echo.-------------------------------------------------------------------------------
echo.####Finished Applying Tweaks###################################################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set Tweaks=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Cleanup Source Images
::-------------------------------------------------------------------------------------------
:CleanupSource

cls
echo.===============================================================================
echo.   MSMG ToolKit - Cleanup Source Images with Component Cleanup ^& ResetBase
echo.===============================================================================
echo.
:: Unmount Image Registry if Mounted
call :UnMountImageRegistry
echo.-------------------------------------------------------------------------------
echo.####Starting Cleaning Up Source Images with Component Cleanup ^& ResetBase######
echo.-------------------------------------------------------------------------------
echo.
if "%IsBootImageSelected%" equ "Yes" (
	:: Performing [Boot.wim, Index : 1 and 2] Image Component Cleanup with ResetBase Option
	for /l %%j in (1, 1, 2) do (
		echo.-------------------------------------------------------------------------------
		echo.Performing [Boot.wim, Index : %%j] Image Component Cleanup...
		echo.-------------------------------------------------------------------------------
		call :CleanupImage "%BootMount%\%%j", "ComponentCleanupResetBase"
	)
)

if "%IsRecoveryImageSelected%" equ "Yes" (
	:: Performing [WinRE.wim] Image Component Cleanup with ResetBase Option
	echo.-------------------------------------------------------------------------------
	echo.Performing [WinRe.wim, Index : 1] Image Component Cleanup...
	echo.-------------------------------------------------------------------------------
	call :CleanupImage "%WinReMount%", "ComponentCleanupResetBase"	
) 

:: Performing [Install.wim] Image Component Clean-Up with ResetBase Option
if "%ImageIndexNo%" equ "*" (
	for /L %%k in (1, 1, %ImageCount%) do (
		if exist "%InstallMount%\%%k\Windows\WinSxS\pending.xml" (
			echo.-------------------------------------------------------------------------------
			echo.Performing [Install.wim, Index : %%k] Image Component Cleanup...
			echo.-------------------------------------------------------------------------------
			echo.
			echo.Cannot Perform Image Component Cleanup when Pending.xml is present...
			echo.
		)
		if not exist "%InstallMount%\%%k\Windows\WinSxS\pending.xml" (
			echo.-------------------------------------------------------------------------------
			echo.Performing [Install.wim, Index : %%k] Image Component Cleanup...
			echo.-------------------------------------------------------------------------------
			call :CleanupImage "%InstallMount%\%%k", "ComponentCleanupResetBase"
		)
	)
) else (
	if exist "%InstallMount%\Windows\WinSxS\pending.xml" (
		echo.-------------------------------------------------------------------------------
		echo.Performing [Install.wim, Index : %ImageIndexNo%] Image Component Cleanup...
		echo.-------------------------------------------------------------------------------
		echo.
		echo.Cannot Perform Image Component Cleanup when Pending.xml is present...
		echo.
	)
	if not exist "%InstallMount%\Windows\WinSxS\pending.xml" (
		echo.-------------------------------------------------------------------------------
		echo.Performing [Install.wim, Index : %ImageIndexNo%] Image Component Cleanup...
		echo.-------------------------------------------------------------------------------
		call :CleanupImage "%InstallMount%", "ComponentCleanupResetBase"
	)
)
echo.-------------------------------------------------------------------------------
echo.####Finished Cleaning Up Source Images with Component Cleanup ^& ResetBase######
echo.-------------------------------------------------------------------------------
echo.

:Stop
echo.===============================================================================
echo.
pause

goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Apply and Save Changes to the Source Images
::-------------------------------------------------------------------------------------------
:SaveSource

cls
echo.===============================================================================
echo.         MSMG ToolKit - Apply ^& Save Changes to the Source Images
echo.===============================================================================
echo.
:: Unmount Image Registry if Mounted
call :UnMountImageRegistry
echo.-------------------------------------------------------------------------------
echo.####Starting Applying ^& Saving Changes to Source Images########################
echo.-------------------------------------------------------------------------------
echo.
choice /C:YN /N /M "Do you want to cleanup Image Windows folder ? ['Y'es/'N'o] : "
if "%errorlevel%" equ "1" (
	echo.
	echo.Cleaning up Image Windows folder...
	:: Performing [Boot.wim, Index : 1 and 2] Image Windows folder cleanup
	if "%IsBootImageSelected%" equ "Yes" (
		for /l %%j in (1, 1, 2) do (
			if exist "%BootMount%\%%j\Windows\WinSxS\Backup\*.*" del /f /q "%InstallMount%\Windows\WinSxS\Backup\*.*" >nul 2>&1
			if exist "%BootMount%\%%j\Windows\WinSxS\ManifestCache\*.bin" del /f /q "%BootMount%\%%j\Windows\WinSxS\ManifestCache\*.bin" >nul 2>&1
			if exist "%BootMount%\%%j\Windows\WinSxS\Temp\PendingDeletes\*" del /f /q "%BootMount%\%%j\Windows\WinSxS\Temp\PendingDeletes\*" >nul 2>&1
			if exist "%BootMount%\%%j\Windows\WinSxS\Temp\TransformerRollbackData\*" del /s /f /q "%BootMount%\%%j\Windows\WinSxS\Temp\TransformerRollbackData\*" >nul 2>&1
			if exist "%BootMount%\%%j\Windows\inf\*.log" del /f /q "%BootMount%\%%j\Windows\inf\*.log" >nul 2>&1
			if exist "%BootMount%\%%j\Windows\CbsTemp\*" (
				for /f %%i in ('"dir /s /b /ad "%BootMount%\%%j\Windows\CbsTemp\*"" 2^>nul') do (rd /q /s %%i >nul 2>&1)
				del /s /f /q "%BootMount%\%%j\Windows\CbsTemp\*" >nul 2>&1
			)
		)
	)

	:: Performing [WinRE.wim, Index : 1] Image Windows folder cleanup
	if "%IsRecoveryImageSelected%" equ "Yes" (
		if exist "%WinReMount%\Windows\WinSxS\Backup\*.*" del /f /q "%InstallMount%\Windows\WinSxS\Backup\*.*" >nul 2>&1
		if exist "%WinReMount%\Windows\WinSxS\ManifestCache\*.bin" del /f /q "%WinReMount%\Windows\WinSxS\ManifestCache\*.bin" >nul 2>&1
		if exist "%WinReMount%\Windows\WinSxS\Temp\PendingDeletes\*" del /f /q "%WinReMount%\Windows\WinSxS\Temp\PendingDeletes\*" >nul 2>&1
		if exist "%WinReMount%\Windows\WinSxS\Temp\TransformerRollbackData\*" del /s /f /q "%WinReMount%\Windows\WinSxS\Temp\TransformerRollbackData\*" >nul 2>&1
		if exist "%WinReMount%\Windows\inf\*.log" del /f /q "%WinReMount%\Windows\inf\*.log" >nul 2>&1
		if exist "%WinReMount%\Windows\CbsTemp\*" (
			for /f %%i in ('"dir /s /b /ad "%WinReMount%\Windows\CbsTemp\*"" 2^>nul') do (rd /q /s %%i >nul 2>&1)
			del /s /f /q "%WinReMount%\Windows\CbsTemp\*" >nul 2>&1
		)
	) 

	:: Performing [Install.wim] Image Windows folder cleanup
	if "%ImageIndexNo%" equ "*" (
		for /L %%k in (1, 1, %ImageCount%) do (
			if exist "%InstallMount%\%%k\$Recycle.Bin" rd /q /s "%InstallMount%\%%k\$Recycle.Bin" >nul 2>&1
			if exist "%InstallMount%\%%k\PerfLogs" rd /q /s "%InstallMount%\%%k\PerfLogs" >nul 2>&1
			if exist "%InstallMount%\%%k\Windows\WinSxS\Backup\*.*" del /f /q "%InstallMount%\%%k\Windows\WinSxS\Backup\*.*" >nul 2>&1
			if exist "%InstallMount%\%%k\Windows\WinSxS\ManifestCache\*.bin" del /f /q "%InstallMount%\%%k\Windows\WinSxS\ManifestCache\*.bin" >nul 2>&1
			if exist "%InstallMount%\%%k\Windows\WinSxS\Temp\PendingDeletes\*" del /f /q "%InstallMount%\%%k\Windows\WinSxS\Temp\PendingDeletes\*" >nul 2>&1
			if exist "%InstallMount%\%%k\Windows\WinSxS\Temp\TransformerRollbackData\*" del /f /q "%InstallMount%\%%k\Windows\WinSxS\Temp\TransformerRollbackData\*" >nul 2>&1
			if exist "%InstallMount%\%%k\Windows\inf\*.log" del /f /q "%InstallMount%\%%k\Windows\inf\*.log" >nul 2>&1		
			if exist "%InstallMount%\%%k\Windows\CbsTemp\*" (
				for /f %%i in ('"dir /s /b /ad "%InstallMount%\%%k\Windows\CbsTemp\*"" 2^>nul') do (rd /q /s %%i >nul 2>&1)
				del /s /f /q "%InstallMount%\%%k\Windows\CbsTemp\*" >nul 2>&1
			)
		)
	) else (
		if exist "%InstallMount%\$Recycle.Bin" rd /q /s "%InstallMount%\$Recycle.Bin" >nul 2>&1
		if exist "%InstallMount%\PerfLogs" rd /q /s "%InstallMount%\PerfLogs" >nul 2>&1
		if exist "%InstallMount%\Windows\WinSxS\Backup\*.*" del /f /q "%InstallMount%\Windows\WinSxS\Backup\*.*" >nul 2>&1
		if exist "%InstallMount%\Windows\WinSxS\ManifestCache\*.bin" del /f /q "%InstallMount%\Windows\WinSxS\ManifestCache\*.bin" >nul 2>&1
		if exist "%InstallMount%\Windows\WinSxS\Temp\PendingDeletes\*" del /f /q "%InstallMount%\Windows\WinSxS\Temp\PendingDeletes\*" >nul 2>&1
		if exist "%InstallMount%\Windows\WinSxS\Temp\TransformerRollbackData\*" del /f /q "%InstallMount%\Windows\WinSxS\Temp\TransformerRollbackData\*" >nul 2>&1
		if exist "%InstallMount%\Windows\inf\*.log" del /f /q "%InstallMount%\Windows\inf\*.log" >nul 2>&1
		if exist "%InstallMount%\Windows\CbsTemp\*" (
			for /f %%i in ('"dir /s /b /ad "%InstallMount%\Windows\CbsTemp\*"" 2^>nul') do (rd /q /s %%i >nul 2>&1)
			del /s /f /q "%InstallMount%\Windows\CbsTemp\*" >nul 2>&1
		)	
	)
)

echo.

:: Saving & Un-Mounting Source Boot Images	
if "%IsBootImageSelected%" equ "Yes" (
	echo.-------------------------------------------------------------------------------
	echo.Applying Changes ^& Un-Mounting Source [Boot.wim, Index : 1] Image...
	echo.-------------------------------------------------------------------------------
	call :UnMountImage "%BootMount%\1", "Commit"
	echo.-------------------------------------------------------------------------------
	echo.Applying Changes ^& Un-Mounting Source [Boot.wim, Index : 2] Image...
	echo.-------------------------------------------------------------------------------
	call :UnMountImage "%BootMount%\2", "Commit"
)

:: Saving & Un-Mounting Source Install & Recovery Images
if "%ImageIndexNo%" equ "*" (
	if "%IsRecoveryImageSelected%" equ "Yes" (
		echo.-------------------------------------------------------------------------------
		echo.Applying Changes ^& Un-Mounting Source [WinRE.wim, Index : 1] Image...
		echo.-------------------------------------------------------------------------------
		call :UnMountImage "%WinReMount%", "Commit"

		:: Re-Building Source Recovery Image with Maximum Compression.
		echo.-------------------------------------------------------------------------------
		echo.Re-Building Source [WinRE.wim] Image with Maximum Compression...
		echo.-------------------------------------------------------------------------------
		call :ExportImage "%InstallMount%\1\%WinReWim%", "%Temp%\rebuild.wim", "WIM", "No"
		move /y "%Temp%\rebuild.wim" "%InstallMount%\1\%WinReWim%" >nul
		echo.-------------------------------------------------------------------------------
		echo.Copying Source Windows Recovery Image to Source Install Image...
		echo.-------------------------------------------------------------------------------
		echo.
		for /L %%i in (2, 1, %ImageCount%) do (
			echo.Copying Source [WinRe.wim] Image to Source [Install.wim, Index : %%i] Image...
			%XCopy% "%InstallMount%\1\%WinReWim%" "%InstallMount%\%%i\%WinReWim%" >nul
		)
		echo.
		echo.-------------------------------------------------------------------------------
	)
	for /L %%i in (1, 1, %ImageCount%) do (
		echo.-------------------------------------------------------------------------------
		echo.Applying Changes ^& Un-Mounting Source [Install.wim, Index : %%i] Image...
		echo.-------------------------------------------------------------------------------
		call:UnMountImage "%InstallMount%\%%i", "Commit"
			call :RemoveFolder "%InstallMount%\%%i"
	)
) else (
	if "%IsRecoveryImageSelected%" equ "Yes" if exist "%InstallMount%\%WinReWim%" (
		echo.-------------------------------------------------------------------------------
		echo.Applying Changes ^& Un-Mounting Source [WinRE.wim, Index : 1] Image...
		echo.-------------------------------------------------------------------------------
		call :UnMountImage "%WinReMount%", "Commit"

		:: Re-Building Source Recovery Image with Maximum Compression.
		echo.-------------------------------------------------------------------------------
		echo.Re-Building Source [WinRE.wim] Image with Maximum Compression...
		echo.-------------------------------------------------------------------------------
		call :ExportImage "%InstallMount%\%WinReWim%", "%Temp%\rebuild.wim", "WIM", "No"
		move /y "%Temp%\rebuild.wim" "%InstallMount%\%WinReWim%" >nul		
	)
	echo.-------------------------------------------------------------------------------
	echo.Applying Changes ^& Un-Mounting Source [Install.wim, Index : %ImageIndexNo%] Image...
	echo.-------------------------------------------------------------------------------
	call :UnMountImage "%InstallMount%", "Commit"
)
echo.-------------------------------------------------------------------------------
echo.####Finished Applying ^& Saving Changes to Source Images########################
echo.-------------------------------------------------------------------------------
echo.
set IsSourceSelected=No
set IsBootImageSelected=No
set IsRecoveryImageSelected=No
set SelectedSourceOS=

:Stop
echo.===============================================================================
echo.
pause

goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Discard Changes & Unmount Source Images
::-------------------------------------------------------------------------------------------
:DiscardSource

cls
echo.===============================================================================
echo.            MSMG ToolKit - Discard Changes ^& Unmount Source Images
echo.===============================================================================
echo.
:: Unmount Image Registry if Mounted
call :UnMountImageRegistry
echo.-------------------------------------------------------------------------------
echo.####Starting Discarding Changes ^& Un-Mounting Source Images####################
echo.-------------------------------------------------------------------------------
echo.
:: Discarding ^& Un-Mounting Source Boot Images
if "%IsBootImageSelected%" equ "Yes" (
	echo.-------------------------------------------------------------------------------
	echo.Un-Mounting Source [Boot.wim, Index : 1] Image...
	echo.-------------------------------------------------------------------------------
	call :UnMountImage "%BootMount%\1", "Discard"
	echo.-------------------------------------------------------------------------------
	echo.Un-Mounting Source [Boot.wim, Index : 2] Image...
	echo.-------------------------------------------------------------------------------
	call :UnMountImage "%BootMount%\2", "Discard"
)

:: Discarding ^& Un-Mounting Source Install & Recovery Images
if "%ImageIndexNo%" equ "*" (
	if "%IsRecoveryImageSelected%" equ "Yes" (
		echo.-------------------------------------------------------------------------------
		echo.Un-Mounting Source [WinRE.wim, Index : 1] Image...
		echo.-------------------------------------------------------------------------------
		call :UnMountImage "%WinReMount%", "Discard"
	)
	for /L %%i in (1, 1, %ImageCount%) do (
		echo.-------------------------------------------------------------------------------
		echo.Un-Mounting Source [Install.wim, Index : %%i] Image...
		echo.-------------------------------------------------------------------------------
		call :UnMountImage "%InstallMount%\%%i", "Discard"
			call :RemoveFolder "%InstallMount%\%%i"
	)
) else (
	if "%IsRecoveryImageSelected%" equ "Yes" if exist "%InstallMount%\%WinReWim%" (
		echo.-------------------------------------------------------------------------------
		echo.Un-Mounting Source [WinRE.wim, Index : 1] Image...
		echo.-------------------------------------------------------------------------------
		call :UnMountImage "%WinReMount%", "Discard"		
	)
	echo.-------------------------------------------------------------------------------
	echo.Un-Mounting Source [Install.wim, Index : %ImageIndexNo%] Image...
	echo.-------------------------------------------------------------------------------
	call :UnMountImage "%InstallMount%", "Discard"
)
echo.-------------------------------------------------------------------------------
echo.####Finished Discarding Changes ^& Un-Mounting Source Images####################
echo.-------------------------------------------------------------------------------
echo.
set IsSourceSelected=No
set IsBootImageSelected=No
set IsRecoveryImageSelected=No
set SelectedSourceOS=

:Stop
echo.===============================================================================
echo.
pause

goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Re-Build Source Images
::-------------------------------------------------------------------------------------------
:RebuildSource

cls
echo.===============================================================================
echo. 	              MSMG ToolKit - Re-Build Source Images
echo.===============================================================================
echo.
:: Checking whether Windows Source Boot Image exist
if not exist "%BootWim%" (
	echo.Cannot find Windows Setup "Boot.wim" Image in ^<DVD\Sources^> folder...
	echo.
	echo.Please copy Windows Setup "Boot.wim" Image to ^<DVD\Sources^> folder...
	goto :Stop
)

:: Checking whether Windows Source Install Image exist
if not exist "%InstallWim%" (
	echo.Cannot find Windows Setup "Install.wim" Image in ^<DVD\Sources^> folder...
	echo.
	echo.Please copy Windows Setup "Install.wim" Image to ^<DVD\Sources^> folder...
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Starting Re-Building Source Images#########################################
echo.-------------------------------------------------------------------------------
echo.
:: Re-Building Source Boot Image with Maximum Compression.
echo.-------------------------------------------------------------------------------
echo.Re-Building Source [Boot.wim] Image with Maximum Compression...
echo.-------------------------------------------------------------------------------
call :ExportImage "%BootWim%", "%Temp%\rebuild.wim", "WIM", "No"
move /y "%Temp%\rebuild.wim" "%BootWim%" >nul

:: Re-Building Source Install Image with Maximum Compression.
echo.-------------------------------------------------------------------------------
echo.Re-Building Source [Install.wim] Image with Maximum Compression...
echo.-------------------------------------------------------------------------------
call :ExportImage "%InstallWim%", "%Temp%\rebuild.wim", "WIM", "No"
move /y "%Temp%\rebuild.wim" "%InstallWim%" >nul
echo.-------------------------------------------------------------------------------
echo.####Finished Re-Building Source Images#########################################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Make a DVD ISO Image for Burning to DVD Disc
::-------------------------------------------------------------------------------------------
:MakeISO

setlocal

set "BIOSBoot=%DVD%\boot\etfsboot.com"
set "UEFIBoot=%DVD%\efi\microsoft\boot\efisys.bin"
set ISOLabel=
set ISOFileName=

cls
echo.===============================================================================
echo.                     MSMG ToolKit - Make a DVD ISO Image
echo.===============================================================================
echo.

:: Checking whether Source is Applied
if "%IsSourceSelected%" equ "Yes" (
	echo.Can't use this feature when the Source OS is selected...
	goto :Stop
)

:: Checking whether Windows Source DVD folder is empty
if not exist "%BIOSBoot%" (
	echo.Windows Installation Source folder ^<DVD^> is empty...
	echo.
	echo.Please copy Installation Source files to ^<DVD^> folder...
	goto :Stop
)

:: Checking whether Windows Source DVD folder is empty
if not exist "%BootWim%" (
	echo.Windows Installation Source folder ^<DVD^> is empty...
	echo.
	echo.Please copy Installation Source files to ^<DVD^> folder...
	goto :Stop
)

:: Checking whether Windows Source DVD folder is empty
if not exist "%InstallWim%" if not exist "%InstallEsd%" if not exist "%DVD%\sources\*.swm" (
	echo.Windows Installation Source folder ^<DVD^> is empty...
	echo.
	echo.Please copy Installation Source files to ^<DVD^> folder...
	goto :Stop
)

call :CreateFolder "%ISO%"

echo.-------------------------------------------------------------------------------
echo.####Starting Building a DVD ISO Image##########################################
echo.-------------------------------------------------------------------------------
echo.
echo.-------------------------------------------------------------------------------
echo.####Getting DVD ISO Image Details##############################################
echo.-------------------------------------------------------------------------------
echo.
:: Getting ISO Label Name
set /p ISOLabel=Enter the ISO Volume Label : 
echo.

:: Getting ISO File Name
set /p ISOFileName=Enter the ISO File Name : 
echo.

:: Building a DVD ISO Image for Booting with BIOS/UEFI Systems.
echo.-------------------------------------------------------------------------------
echo.####Building a DVD ISO Image###################################################
echo.-------------------------------------------------------------------------------
if "%ISOLabel%" equ "" (
	if exist "%UEFIBoot%" "%Oscdimg%" -bootdata:2#p0,e,b"%BIOSBoot%"#pEF,e,b"%UEFIBoot%" -o -h -m -u2 -udfver102 "%DVD%" "%ISO%\%ISOFileName%.iso"
	if not exist "%UEFIBoot%" "%Oscdimg%" -bootdata:1#p0,e,b"%BIOSBoot%" -o -h -m -u2 -udfver102 "%DVD%" "%ISO%\%ISOFileName%.iso"
)

if "%ISOLabel%" neq "" (
	if exist "%UEFIBoot%" "%Oscdimg%" -bootdata:2#p0,e,b"%BIOSBoot%"#pEF,e,b"%UEFIBoot%" -o -h -m -u2 -udfver102 -l"%ISOLabel%" "%DVD%" "%ISO%\%ISOFileName%.iso"
	if not exist "%UEFIBoot%" "%Oscdimg%" -bootdata:1#p0,e,b"%BIOSBoot%" -o -h -m -u2 -udfver102 -l"%ISOLabel%" "%DVD%" "%ISO%\%ISOFileName%.iso"
)
echo.
echo.-------------------------------------------------------------------------------
echo.####Finished Building a DVD ISO Image##########################################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set BIOSBoot=
set UEFIBoot=
set ISOLabel=
set ISOFileName=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Burn a DVD ISO Image to DVD Disc
::-------------------------------------------------------------------------------------------
:BurnISO

setlocal

set DvdDrive=
set ISOFileName=

cls
echo.===============================================================================
echo.             MSMG ToolKit - Burn a DVD ISO Image to a DVD Disc
echo.===============================================================================
echo.

:: Checking whether ISO folder is empty
if not exist "%ISO%\*.iso" (
	echo.ISO Image folder ^<ISO^> is empty...
	echo.
	echo.Please copy ISO Images to ^<ISO^> folder...
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Starting Burning a DVD ISO Image to a DVD Disc#############################
echo.-------------------------------------------------------------------------------
echo.
echo.-------------------------------------------------------------------------------
echo.####Getting DVD Drive ^& DVD ISO Image Details##################################
echo.-------------------------------------------------------------------------------
echo.
:: Getting ISO File Name
set /p ISOFileName=Enter the ISO File Name : 
echo.
:: Getting DVD Drive Letter
set /p DvdDrive=Enter the DVD Drive Letter : 
echo.
echo.-------------------------------------------------------------------------------
echo.####Burning a DVD ISO Image to DVD Disc########################################
echo.-------------------------------------------------------------------------------
echo.
echo.Burning ISO Image file [%ISOFileName%.iso] to DVD Drive [%DvdDrive%:]...
echo.
%DvdBurn% "%DvdDrive%:" "%ISO%\%ISOFileName%.iso"
echo.
echo.-------------------------------------------------------------------------------
echo.####Finished Burning a DVD ISO Image to a DVD Disc#############################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set DvdDrive=
set ISOFileName=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Copy Source Folder to USB Flash Drive
::-------------------------------------------------------------------------------------------
:CopyUSB

setlocal

set USBDriveLetter=
set USBDriveLabel=

cls
echo.===============================================================================
echo.             MSMG ToolKit - Copy Source Folder to USB Flash Drive
echo.===============================================================================
echo.

:: Checking whether Source is Applied
if "%IsSourceSelected%" equ "Yes" (
	echo.Can't use this feature when the Source OS is selected...
	goto :Stop
)

:: Checking whether Windows Source DVD folder is empty
if not exist "%BootWim%" (
	echo.Windows Installation Source folder ^<DVD^> is empty...
	echo.
	echo.Please copy Installation Source files to ^<DVD^> folder...
	goto :Stop
)

:: Checking whether Windows Source DVD folder is empty
if not exist "%InstallWim%" if not exist "%InstallEsd%" (
	echo.Windows Installation Source folder ^<DVD^> is empty...
	echo.
	echo.Please copy Installation Source files to ^<DVD^> folder...
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Starting Copying Source Folder to USB Flash Drive##########################
echo.-------------------------------------------------------------------------------
echo.
echo.-------------------------------------------------------------------------------
echo.####Getting USB Flash Drive Options############################################
echo.-------------------------------------------------------------------------------
echo.
:: Show Available USB Flash Drivers.
echo.Listing Available USB Flash Drives...
call :ListDisks

:: Getting USB Flash Drive Letter
set /p USBDriveLetter=Enter USB Flash Drive Letter :
 
:: Setting USB Flash Drive Letter
set "USBDriveLetter=%USBDriveLetter%:"
echo.
echo.-------------------------------------------------------------------------------
echo.####Copying Source Folder to USB Flash Drive###################################
echo.-------------------------------------------------------------------------------
echo.
echo.-------------------------------------------------------------------------------
echo.Copying Source files and folders, Please Wait...
echo.-------------------------------------------------------------------------------
echo.
echo.Source Drive : "%DVD%"		
echo.Target Drive : %USBDriveLetter%
echo.
%XCopy% "%DVD%" %USBDriveLetter% >nul
echo.-------------------------------------------------------------------------------
echo.####Finished Copying Source Folder to USB Flash Drive##########################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set USBDriveLetter=
set USBDriveLabel=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Sync Source Boot and Install Images to USB Flash Drive
::-------------------------------------------------------------------------------------------
:SyncUSB

setlocal

set USBDriveLetter=
set USBDriveLabel=

cls
echo.===============================================================================
echo.     MSMG ToolKit - Sync Source Boot ^& Install Images to USB Flash Drive
echo.===============================================================================
echo.

:: Checking whether Source is Applied
if "%IsSourceSelected%" equ "Yes" (
	echo.Can't use this feature when the Source OS is selected...
	goto :Stop
)

:: Checking whether Windows Source DVD folder is empty
if not exist "%BootWim%" (
	echo.Windows Installation Source folder ^<DVD^> is empty...
	echo.
	echo.Please copy Installation Source files to ^<DVD^> folder...
	goto :Stop
)

:: Checking whether Windows Source DVD folder is empty
if not exist "%InstallWim%" if not exist "%InstallEsd%" (
	echo.Windows Installation Source folder ^<DVD^> is empty...
	echo.
	echo.Please copy Installation Source files to ^<DVD^> folder...
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Starting Syncing Source Boot ^& Install Images to USB Flash Drive###########
echo.-------------------------------------------------------------------------------
echo.
echo.-------------------------------------------------------------------------------
echo.####Getting USB Flash Drive Options############################################
echo.-------------------------------------------------------------------------------
echo.
:: Show Available USB Flash Drivers.
echo.Listing Available USB Flash Drives...
call :ListDisks

:: Getting USB Flash Drive Letter
set /p USBDriveLetter=Enter USB Flash Drive Letter : 

:: Setting USB Flash Drive Letter
set "USBDriveLetter=%USBDriveLetter%:"
echo.
echo.-------------------------------------------------------------------------------
echo.####Syncing Source Boot ^& Install Images to USB Flash Drive####################
echo.-------------------------------------------------------------------------------
echo.
echo.-------------------------------------------------------------------------------
echo.Copying Source Boot ^& Install Image files, Please Wait...
echo.-------------------------------------------------------------------------------
echo.
echo.Source : ^<\DVD\Sources\Boot.wim^>
if exist "%DVD%\Sources\install.wim" echo.         ^<\DVD\Sources\Install.wim^>
if exist "%DVD%\Sources\install.esd" echo.         ^<\DVD\Sources\Install.esd^>
echo.Target : ^<%USBDriveLetter%\Sources^>
echo.
call :RemoveFile %USBDriveLetter%\Sources\Boot.wim
call :RemoveFile %USBDriveLetter%\Sources\Install.wim
call :RemoveFile %USBDriveLetter%\Sources\Install.esd

%XCopy% "%DVD%\Sources\boot.wim" %USBDriveLetter%\Sources
if exist "%DVD%\Sources\install.wim" %XCopy% "%DVD%\Sources\install.wim" %USBDriveLetter%\Sources
if exist "%DVD%\Sources\install.esd" %XCopy% "%DVD%\Sources\install.esd" %USBDriveLetter%\Sources
echo.
echo.-------------------------------------------------------------------------------
echo.####Finished Syncing Source Boot ^& Install Images to USB Flash Drive###########
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set USBDriveLetter=
set USBDriveLabel=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Burn a ISO Image to USB Flash Drive
::-------------------------------------------------------------------------------------------
:BurnUSB

setlocal

set ISOFileName=
set USBDriveLetter=

cls
echo.===============================================================================
echo.                MSMG ToolKit - Burn a ISO Image to USB Flash Drive
echo.===============================================================================
echo.

:: Checking whether ISO folder is empty
if not exist "%ISO%\*.iso" (
	echo.ISO Image folder ^<ISO^> is empty...
	echo.
	echo.Please copy ISO Images to ^<ISO^> folder...
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Starting Burning a ISO Image to USB Flash Drive############################
echo.-------------------------------------------------------------------------------
echo.
echo.-------------------------------------------------------------------------------
echo.####Getting ISO Image Options##################################################
echo.-------------------------------------------------------------------------------
echo.
:: Getting ISO File Name
set /p ISOFileName=Enter the ISO File Name : 

:: Setting ISO File Name
set "ISOFileName=%ISOFileName%.iso"
echo.
echo.-------------------------------------------------------------------------------
echo.####Getting USB Flash Drive Options############################################
echo.-------------------------------------------------------------------------------
echo.
:: Show Available USB Flash Drivers.
echo.Listing Available USB Flash Drives...
call :ListDisks

:: Getting USB Flash Drive Letter
set /p USBDriveLetter=Enter USB Flash Drive Letter : 

:: Setting USB Flash Drive Letter
set "USBDriveLetter=%USBDriveLetter%:"

echo.
echo.-------------------------------------------------------------------------------
echo.####Burning ISO Image to USB Flash Drive#######################################
echo.-------------------------------------------------------------------------------
echo.
echo.-------------------------------------------------------------------------------
echo.Copying ISO Image file Contents to USB Flash Drive, Please Wait...
echo.-------------------------------------------------------------------------------
echo.
echo.Source ISO        : %ISOFileName%
echo.Target Drive      : %USBDriveLetter%
echo.
%Zip% x -y "%ISO%\%ISOFileName%" -o"%USBDriveLetter%"
echo.
echo.-------------------------------------------------------------------------------
echo.####Finished Burning a ISO Image to USB Flash Drive############################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set ISOFileName=
set USBDriveLetter=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Format a USB Flash Drive
::-------------------------------------------------------------------------------------------
:FormatUSB

setlocal

set USBDriveLetter=
set USBDriveLabel=

cls
echo.===============================================================================
echo.                     MSMG ToolKit - Format USB Flash Drive
echo.===============================================================================
echo.
echo.-------------------------------------------------------------------------------
echo.####Starting Formatting USB Flash Drive########################################
echo.-------------------------------------------------------------------------------
echo.
echo.-------------------------------------------------------------------------------
echo.####Getting USB Flash Drive Options############################################
echo.-------------------------------------------------------------------------------
echo.
:: Show Available USB Flash Drivers.
echo.Listing Available USB Flash Drives...
call :ListDisks

:: Getting USB Flash Drive Letter
set /p USBDriveLetter=Enter USB Flash Drive Letter : 
echo.

:: Setting USB Flash Drive Letter
set "USBDriveLetter=%USBDriveLetter%:"

:: Checking whether the Specified USB Flash Drive exist
cd /d %USBDriveLetter% 2>nul
if errorlevel 1 (
	echo.Invalid USB Flash Drive specified, please try again...
	goto :Stop
)

:: Getting USB Flash Drive Volume Label.
set /p USBDriveLabel=Enter USB Flash Drive Volume Label : 
echo.

:: Getting USB Boot Type (UEFI/BIOS/ALL).
choice /C 12 /N /M "Enter USB Flash Drive Boot Type [1=BIOS,2=BIOS/UEFI] : "
if errorlevel 2 goto :BIOS_UEFI
if errorlevel 1 goto :BIOS

:: Formatting USB Flash Drive in NTFS Format for BIOS Booting Systems.
:BIOS
	echo.
	choice /C:YN /N /M "Are you sure, you want to Format [%USBDriveLetter%]? ['Y'es/'N'o] : "
	if errorlevel 2 (
		echo.
		echo.Formatting USB Flash Drive [%USBDriveLetter%] cancelled...
		echo.
		echo.-------------------------------------------------------------------------------
		echo.####Stopped Formatting USB Flash Drive########################################
		echo.-------------------------------------------------------------------------------
		goto :Stop
	)
	if errorlevel 1 (
		call :FormatDisk %USBDriveLetter%, NTFS, %USBDriveLabel%
		echo.
		echo.-------------------------------------------------------------------------------
		echo.####Finished Formatting USB Flash Drive########################################
		echo.-------------------------------------------------------------------------------
		goto :Stop
	)

:: Formatting USB Flash Drive in FAT32 Format for BIOS and or UEFI Booting Systems.  
:BIOS_UEFI
	echo.
	choice /C:YN /N /M "Are you sure, you want to Format [%USBDriveLetter%]? ['Y'es/'N'o] : "
	if errorlevel 2 (
		echo.
		echo.Formatting USB Flash Drive [%USBDriveLetter%] cancelled...
		echo.
		echo.-------------------------------------------------------------------------------
		echo.####Stopped Formatting USB Flash Drive########################################
		echo.-------------------------------------------------------------------------------
		goto :Stop
	)
	if errorlevel 1 (
		call :FormatDisk %USBDriveLetter%, FAT32, %USBDriveLabel%
		echo.
		echo.-------------------------------------------------------------------------------
		echo.####Finished Formatting USB Flash Drive########################################
		echo.-------------------------------------------------------------------------------
		goto :Stop
	)

:Stop
echo.
echo.===============================================================================
echo.
pause

set USBDriveLetter=
set USBDriveLabel=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to List All the Disks and Volumes
:ListDisks

call :RemoveFile "%Temp%\DiskList.txt"
call :RemoveFile "%Temp%\DiskList1.txt"

echo.list volume>> "%Temp%\DiskList.txt"
diskpart /s "%Temp%\DiskList.txt" >> "%Temp%\DiskList1.txt"
call :RemoveFile "%Temp%\DiskList.txt"
echo.>> "%Temp%\DiskList.txt"

echo.===============================================================================>> "%Temp%\DiskList.txt"
if "%HostLanguage%" equ "en-US" echo.  Volume #  Letter Label      file Sys Type         Size    Status     Info>> "%Temp%\DiskList.txt"
if "%HostLanguage%" equ "fr-FR" echo.  N# volume   Ltr  Nom          Fs     Type        Taille   Statut     Info>> "%Temp%\DiskList.txt"
echo.------------------------------------------------------------------------------->> "%Temp%\DiskList.txt"
if "%HostLanguage%" equ "en-US" findstr "Removable" "%Temp%\DiskList1.txt" >> "%Temp%\DiskList.txt"
if "%HostLanguage%" equ "fr-FR" findstr "Amovible" "%Temp%\DiskList1.txt" >> "%Temp%\DiskList.txt"
echo.===============================================================================>> "%Temp%\DiskList.txt"

type "%Temp%\DiskList.txt"
call :RemoveFile "%Temp%\DiskList.txt"
call :RemoveFile "%Temp%\DiskList1.txt"
echo.

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Format a Disk/Volume
:: Input Parameters [ %~1 : USB Drive Letter, %~2 : Format Type, %~3 : Drive Label]
::-------------------------------------------------------------------------------------------
:FormatDisk

:: Writing DiskPart.txt Script File.
call :RemoveFile "%Temp%\DiskPart.txt"
echo.select volume ^%~1>> "%Temp%\DiskPart.txt"
echo.clean>> "%Temp%\DiskPart.txt"
echo.create partition primary>> "%Temp%\DiskPart.txt"
echo.select partition ^1>> "%Temp%\DiskPart.txt"
echo.active>> "%Temp%\DiskPart.txt"
echo.format fs=%~2 quick label=%~3>> "%Temp%\DiskPart.txt"
echo.exit>> "%Temp%\DiskPart.txt"
echo.exit>> "%Temp%\DiskPart.txt"
echo.
echo.-------------------------------------------------------------------------------
echo.####Formatting USB Flash Drive#################################################
echo.-------------------------------------------------------------------------------
echo.
:: Executing DiskPart.txt Script file With Diskpart.
echo.Formatting USB Flash Drive [%~1] in %~2 Format, Please wait...
start /B /wait diskpart /s "%Temp%\DiskPart.txt" >nul
echo.
echo.Formatting USB Flash Drive [%~1] in %~2 Format, complete...
call :RemoveFile "%Temp%\DiskPart.txt"

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: MSMG ToolKit - WIM Manager
::-------------------------------------------------------------------------------------------
:WIMManager

cls
echo.===============================================================================
echo.                          MSMG ToolKit - WIM Manager
echo.===============================================================================
echo.
:: Checking whether Source is Applied.
if "%IsSourceSelected%" equ "Yes" (
	echo.Can't use this feature when the Source OS is selected...
	echo.
	echo.===============================================================================
	echo.
	goto :Stop
)

echo.  [A]   Display
echo.  [B]   Rename
echo.  [C]   Delete
echo.  [D]   Export
echo.  [E]   Split
echo.  [F]   Merge
echo.  [G]   Upgrade
echo.  [H]   Capture
echo.  [I]   Apply
echo.  [J]   Cleanup
echo.
echo.
echo.
echo.
echo.
echo.  [X]   Go Back
echo.
echo.===============================================================================
echo.
choice /C:ABCDEFGHIJX /N /M "Enter Your Choice : "
if errorlevel 11 goto :ToolsMenu
if errorlevel 10 goto :WIMCleanUp
if errorlevel 9  goto :WIMApply
if errorlevel 8  goto :WIMCapture
if errorlevel 7  goto :WIMUpgrade
if errorlevel 6  goto :WIMMerge
if errorlevel 5  goto :WIMSplit
if errorlevel 4  goto :WIMExport
if errorlevel 3  goto :WIMDelete
if errorlevel 2  goto :WIMRename
if errorlevel 1  goto :WIMDisplay

::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Display WIM Image Information
::-------------------------------------------------------------------------------------------
:WIMDisplay

cls
echo.===============================================================================
echo.               MSMG ToolKit - Display WIM Image Information
echo.===============================================================================

:: Checking whether Windows Source Install Image file exist
if not exist "%InstallWim%" (
	echo.Cannot find Windows Setup Install Image ^<DVD\Sources\install.wim^> file...
	echo.
	echo.Please copy Windows Setup "Install.wim" Image to respective folder...
	echo.
	echo.===============================================================================
	echo.
	goto :Stop
)

:: Display Image Index Information
call :ShowImageInfo

:Stop

pause

goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Rename WIM Index
::-------------------------------------------------------------------------------------------
:WIMRename

setlocal

set NewImageName=
set NewImageDescription=

cls
echo.===============================================================================
echo.                  MSMG ToolKit - Rename WIM Image Index
echo.===============================================================================
echo.

:: Checking whether Windows Source Install Image file exist
if not exist "%InstallWim%" (
	echo.Cannot find Windows Setup Install Image ^<DVD\Sources\install.wim^> file...
	echo.
	echo.Please copy Windows Setup Install Image file to respective folder...
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Starting Renaming Source WIM Image Index###################################
echo.-------------------------------------------------------------------------------

:: Display Image Index Information
call :ShowImageInfo

:: Getting Image Index No to Rename
if "!ImageCount!" equ "1" ( 
	set /p ImageIndexNo=Enter the WIM Image Index # : 
) else set /p ImageIndexNo=Enter the WIM Image Index's # [Range : 1-!ImageCount!] : 

if "!ImageIndexNo!" lss "1" (
	echo.
	echo.Invalid Index # Entered, Valid Range is [1-!ImageCount!]
	echo.
	echo.Press Enter to Try Again...
	pause >nul

	goto :WIMRename
)

if "!ImageIndexNo!" gtr "!ImageCount!" (
	echo.
	echo.Invalid Index # Entered, Valid Range is [1-!ImageCount!]
	echo.
	echo.Press Enter to Try Again...
	pause >nul

	goto :WIMRename
)

echo.
set /p NewImageName=Enter WIM Index Name : 
echo.
set /p NewImageDescription=Enter WIM Index Description : 

echo.
echo.-------------------------------------------------------------------------------
echo.Renaming Source WIM Image [Install.wim, Index : %ImageIndexNo%] Information...
echo.-------------------------------------------------------------------------------
echo.
%WimLibImagex% info "%InstallWim%" %ImageIndexNo% "%NewImageName%" "%NewImageDescription%" --image-property DISPLAYNAME="%NewImageName%" --image-property DISPLAYDESCRIPTION="%NewImageDescription%"
echo.
echo.-------------------------------------------------------------------------------
echo.####Finished Renaming Source WIM Image Index###################################
echo.-------------------------------------------------------------------------------
:Stop
echo.
echo.===============================================================================
echo.
pause

set NewImageName=
set NewImageDescription=
set ImageIndexNo=

endlocal

goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Delete WIM Index
::-------------------------------------------------------------------------------------------
:WIMDelete

cls
echo.===============================================================================
echo.                       MSMG ToolKit - Delete WIM Index
echo.===============================================================================
echo.
:: Checking whether Windows Source Install Image file exist
if not exist "%InstallWim%" (
	echo.Cannot find Windows Setup Install Image ^<DVD\Sources\install.wim^> file...
	echo.
	echo.Please copy Windows Setup Install Image file to respective folder...
	goto :Stop
)
echo.-------------------------------------------------------------------------------
echo.####Starting Deleting Source WIM Image Index###################################
echo.-------------------------------------------------------------------------------

:: Display Image Information
call :ShowImageInfo

:: Get Image Index No to Delete
if "!ImageCount!" equ "1" ( 
	set /p ImageIndexNo=Enter the WIM Image Index # : 
) else set /p ImageIndexNo=Enter the WIM Image Index's # [Range : 1-!ImageCount!] : 

if "!ImageIndexNo!" lss "1" (
	echo.
	echo.Invalid Index # Entered, Valid Range is [1-!ImageCount!]
	echo.
	echo.Press Enter to Try Again...
	pause >nul

	goto :WIMDelete
)

if "!ImageIndexNo!" gtr "!ImageCount!" (
	echo.
	echo.Invalid Index # Entered, Valid Range is [1-!ImageCount!]
	echo.
	echo.Press Enter to Try Again...
	pause >nul

	goto :WIMDelete
)

echo.
echo.-------------------------------------------------------------------------------
echo.Deleting Source WIM Image [Install.wim, Index : %ImageIndexNo%]...
echo.-------------------------------------------------------------------------------

call :DeleteImage "%InstallWim%", %ImageIndexNo%

echo.-------------------------------------------------------------------------------
echo.####Finished Deleting Source WIM Image Index###################################
echo.-------------------------------------------------------------------------------
:Stop
echo.
echo.===============================================================================
echo.
pause

goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Export WIM Index to Source WIM Image or New WIM Image
::-------------------------------------------------------------------------------------------
:WIMExport

setlocal

set WimImageFileName=
 
cls
echo.===============================================================================
echo.                       MSMG ToolKit - Export WIM Index
echo.===============================================================================
echo.
:: Checking whether Windows Source Install Image file exist
if not exist "%InstallWim%" (
	echo.Cannot find Windows Setup Install Image ^<DVD\Sources\install.wim^> file...
	echo.
	echo.Please copy Windows Setup Install Image file to respective folder...
	goto :Stop
)
echo.-------------------------------------------------------------------------------
echo.####Starting Exporting Source WIM Image Index##################################
echo.-------------------------------------------------------------------------------

:: Display Image Information
call :ShowImageInfo

:: Get Image Index No to Export
if "!ImageCount!" equ "1" ( 
	set /p ImageIndexNo=Enter the WIM Image Index # : 
) else set /p ImageIndexNo=Enter the WIM Image Index's # [Range : 1-!ImageCount!] : 

if "!ImageIndexNo!" lss "1" (
	echo.
	echo.Invalid Index # Entered, Valid Range is [1-!ImageCount!]
	echo.
	echo.Press Enter to Try Again...
	pause >nul

	goto :WIMExport
)

if "!ImageIndexNo!" gtr "!ImageCount!" (
	echo.
	echo.Invalid Index # Entered, Valid Range is [1-!ImageCount!]
	echo.
	echo.Press Enter to Try Again...
	pause >nul

	goto :WIMExport
)

echo.
choice /C:YN /N /M "Do you want to Export to New WIM Image ? ['Y'es/'N'o] : "
if errorlevel 2 goto :Export2SameImage
if not errorlevel 2 goto :Export2NewImage

:Export2SameImage
	set "WimImageFileName=%InstallWim%"
	echo.
	echo.-------------------------------------------------------------------------------
	echo.Exporting Source WIM Image [Install.wim, Index : %ImageIndexNo%] to [Install.wim]...
	echo.-------------------------------------------------------------------------------
	call :ExportImageIndex "%InstallWim%", %ImageIndexNo%, %WimImageFileName%, "WIM", "No"
	goto :Continue

:Export2NewImage
	echo.
	set /p WimImageFileName=Enter WIM Image Filename without [.wim] : 
	set "WimImageFileName=%WimImageFileName%.wim"
	echo.	  
	echo.-------------------------------------------------------------------------------
	echo.Exporting Source WIM Image [Install.wim, Index : %ImageIndexNo%] to [%WimImageFileName%]...
	echo.-------------------------------------------------------------------------------
	call :ExportImageIndex "%InstallWim%", %ImageIndexNo%, "%DVD%\sources\%WimImageFileName%", "WIM", "No"
	goto :Continue
	
:Continue
	echo.-------------------------------------------------------------------------------
	echo.####Finished Exporting Source WIM Image Index##################################
	echo.-------------------------------------------------------------------------------
:Stop
echo.
echo.===============================================================================
echo.
pause

set WimImageFileName=

endlocal

goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Split WIM Image
::-------------------------------------------------------------------------------------------
:WIMSplit

setlocal

set WimImageSplitFileSize=

cls
echo.===============================================================================
echo.                      MSMG ToolKit - Split WIM Image
echo.===============================================================================
echo.
:: Checking whether Windows Source Install Image file exist
if not exist "%InstallWim%" (
	echo.Cannot find Windows Setup Install Image ^<DVD\Sources\install.wim^> file...
	echo.
	echo.Please copy Windows Setup Install Image file to respective folder...
	goto :Stop
)
echo.-------------------------------------------------------------------------------
echo.####Starting Spliting Source WIM Image#########################################
echo.-------------------------------------------------------------------------------
echo.
set /p WimImageSplitFileSize=Enter WIM Image Split File Size in MB : 
echo.
echo.-------------------------------------------------------------------------------
echo.Spliting Source WIM Image [Install.wim]...
echo.-------------------------------------------------------------------------------

call :SplitImage "%InstallWim%", "%DVD%\sources\install.swm", %WimImageSplitFileSize%
call :RemoveFile "%InstallWim%"

echo.-------------------------------------------------------------------------------
echo.####Finished Spliting Source WIM Image#########################################
echo.-------------------------------------------------------------------------------
:Stop
echo.
echo.===============================================================================
echo.
pause

set WimImageSplitFileSize=

endlocal

goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Merge Splitted WIM Image
::-------------------------------------------------------------------------------------------
:WIMMerge

cls
echo.===============================================================================
echo.                   MSMG ToolKit - Merge Splitted WIM Image
echo.===============================================================================
echo.
:: Checking whether Windows Source Install Image file exist
if not exist "%InstallWim%" (
	echo.Cannot find Windows Setup Install Image ^<DVD\Sources\install.wim^> file...
	echo.
	echo.Please copy Windows Setup Install Image file to respective folder...
	goto :Stop
)
echo.-------------------------------------------------------------------------------
echo.####Starting Merging Splitted Source WIM Image#################################
echo.-------------------------------------------------------------------------------
echo.
echo.-------------------------------------------------------------------------------
echo.Merging Splitted Source WIM Image [Install.swm] to [Install.wim]...
echo.-------------------------------------------------------------------------------

call :MergeImage "%DVD%\sources\install", "%InstallWim%"
call :RemoveFile "%DVD%\sources\*.swm"

echo.-------------------------------------------------------------------------------
echo.####Finished Merging Splitted Source WIM Image#################################
echo.-------------------------------------------------------------------------------
:Stop
echo.
echo.===============================================================================
echo.
pause

goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Upgrade WIM Index Edition
::-------------------------------------------------------------------------------------------
:WIMUpgrade

setlocal

set SourceEdition=
set TargetEdition=
set Flag=
set Edition=
set Name=
set Description=
set DisplayName=
set DisplayDescription=

cls
echo.===============================================================================
echo.                     MSMG ToolKit - Upgrade WIM Edition
echo.===============================================================================

:: Checking whether Windows Source Install Image file exist
if not exist "%InstallWim%" (
	echo.
	echo.Cannot find Windows Setup Install Image ^<DVD\Sources\install.wim^> file...
	echo.
	echo.Please copy Windows Setup Install Image file to respective folder...
	goto :Stop
)

:: Getting Image Index Number to Service
call :GetImageIndexNo "!InstallWim!"

:: Checking for Image Index Validation
if "!ImageIndexNo!" equ "" (
	echo.
	echo.Invalid Index # Entered, Valid Range is [1-!ImageCount!]
	echo.
	echo.Press Enter to Try Again...
	pause >nul
	goto :SelectSourceDVD
)

:: Checking for Image Index Validation
if "!ImageIndexNo!" neq "*" if "!ImageIndexNo!" lss "1" (
	echo.
	echo.Invalid Index # Entered, Valid Range is [1-!ImageCount!]
	echo.
	echo.Press Enter to Try Again...
	pause >nul
	goto :SelectSourceDVD
)

:: Checking for Image Index Validation
if "!ImageIndexNo!" neq "*" if "!ImageIndexNo!" gtr "!ImageCount!" (
	echo.
	echo.Invalid Index # Entered, Valid Range is [1-!ImageCount!]
	echo.
	echo.Press Enter to Try Again...
	pause >nul
	goto :SelectSourceDVD
)

:: Getting selected Image Index Information
if "%ImageIndexNo%" equ "*" call :GetImageIndexInfo "%InstallWim%", 1 >nul
if "%ImageIndexNo%" neq "*" call :GetImageIndexInfo "%InstallWim%", %ImageIndexNo% >nul

:: Setting selected Source OS version
if "%ImageVersion%" equ "6.1.7601" set "SelectedSourceOS=w7"
if "%ImageVersion%" equ "6.3.9600" set "SelectedSourceOS=w81"
if "%ImageVersion:~0,-6%" equ "10.0" set "SelectedSourceOS=w10"

echo.

:: Checking whether the selected Source OS is a Windows 7 Enterprise Edition
if "%SelectedSourceOS%" equ "w7" if "%ImageFlag%" equ "Enterprise" (
	echo.Windows 7 Enterprise Edition can't be Upgraded...
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu
)

:: Checking whether the selected Source OS is a Windows 7 Enterprise N Edition
if "%SelectedSourceOS%" equ "w7" if "%ImageFlag%" equ "EnterpriseN" (
	echo.Windows 7 Enterprise N Edition can't be Upgraded...
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu
)

:: Checking whether the selected Source OS is a Windows 7 Enterprise K Edition
if "%SelectedSourceOS%" equ "w7" if "%ImageFlag%" equ "EnterpriseK" (
	echo.Windows 7 Enterprise K Edition can't be Upgraded...
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu
)

:: Checking whether the selected Source OS is a Windows 7 Enterprise KN Edition
if "%SelectedSourceOS%" equ "w7" if "%ImageFlag%" equ "EnterpriseKN" (
	echo.Windows 7 Enterprise KN Edition can't be Upgraded...
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu
)

:: Checking whether the selected Source OS is a Windows 7 Ultimate Edition
if "%SelectedSourceOS%" equ "w7" if "%ImageFlag%" equ "Ultimate" (
	echo.Windows 7 Ultimate Edition can't be Upgraded...
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu
)

:: Checking whether the selected Source OS is a Windows 7 Ultimate N Edition
if "%SelectedSourceOS%" equ "w7" if "%ImageFlag%" equ "UltimateN" (
	echo.Windows 7 Ultimate N Edition can't be Upgraded...
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu
)

:: Checking whether the selected Source OS is a Windows 7 Ultimate K Edition
if "%SelectedSourceOS%" equ "w7" if "%ImageFlag%" equ "UltimateK" (
	echo.Windows 7 Ultimate K Edition can't be Upgraded...
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu
)

:: Checking whether the selected Source OS is a Windows 7 Ultimate KN Edition
if "%SelectedSourceOS%" equ "w7" if "%ImageFlag%" equ "UltimateKN" (
	echo.Windows 7 Ultimate KN Edition can't be Upgraded...
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu
)

:: Checking whether the selected Source OS is a Windows 8.1 Pro with Media Center Edition
if "%ImageFlag%" equ "ProfessionalWMC" (
	echo.Windows 8.1 Pro with Media Center Edition can't be Upgraded...
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu
)

:: Checking whether the selected Source OS is a Windows 8.1 Pro N Edition
if "%SelectedSourceOS%" equ "w81" if "%ImageFlag%" equ "ProfessionalN" (
	echo.Windows 8.1 Pro N Edition can't be Upgraded...
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu
)

:: Checking whether the selected Source OS is a Windows 8.1 Enterprise Edition
if "%SelectedSourceOS%" equ "w81" if "%ImageFlag%" equ "Enterprise" (
	echo.Windows 8.1 Enterprise Edition can't be Upgraded...
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu
)

:: Checking whether the selected Source OS is a Windows 8.1 Enterprise N Edition
if "%SelectedSourceOS%" equ "w81" if "%ImageFlag%" equ "EnterpriseN" (
	echo.Windows 8.1 Enterprise N Edition can't be Upgraded...
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu
)

:: Checking whether the selected Source OS is a Windows 8.1 Embedded Industry Pro/Enterprise Edition
if "%SelectedSourceOS%" equ "w81" if "%ImageFlag%" equ "EmbeddedIndustry" (
	echo.Windows Embedded 8.1 Industry Pro Edition can't be Upgraded...
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu
)

:: Checking whether the selected Source OS is a Windows 8.1 Embedded Industry Enterprise Edition
if "%SelectedSourceOS%" equ "w81" if "%ImageFlag%" equ "EmbeddedIndustryE" (
	echo.Windows Embedded 8.1 Industry Enterprise Edition can't be Upgraded...
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu
)

:: Checking whether the selected Source OS is a Windows Server 2012 R2 Datacenter Core Edition
if "%SelectedSourceOS%" equ "w81" if "%ImageFlag%" equ "ServerDataCenterCore" (
	echo.Windows Server 2012 R2 Datacenter Core Edition can't be Upgraded...
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu
)

:: Checking whether the selected Source OS is a Windows Server 2012 R2 Datacenter Edition
if "%SelectedSourceOS%" equ "w81" if "%ImageFlag%" equ "ServerDataCenter" (
	echo.Windows Server 2012 R2 Datacenter Edition can't be Upgraded...
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu
)

:: Checking whether the selected Source OS is a Windows Server 2012 R2 Foundation Edition
if "%SelectedSourceOS%" equ "w81" if "%ImageFlag%" equ "ServerWinFoundation" (
	echo.Windows Server 2012 R2 Foundation Edition can't be Upgraded...
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu
)

:: Checking whether the selected Source OS is a Windows Storage Server 2012 R2 Standard Edition
if "%SelectedSourceOS%" equ "w81" if "%ImageFlag%" equ "ServerStorageStandard" (
	echo.Windows Storage Server 2012 R2 Standard Edition can't be Upgraded...
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu
)

:: Checking whether the selected Source OS is a Windows Storage Server 2012 R2 Workgroup Edition
if "%SelectedSourceOS%" equ "w81" if "%ImageFlag%" equ "ServerStorageWorkgroup" (
	echo.Windows Storage Server 2012 R2 Workgroup Edition can't be Upgraded...
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu
)
	
:: Checking whether the selected Source OS is a Windows 10 Enterprise Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "10240" if "%ImageFlag%" equ "Enterprise" (
	echo.Windows 10 Enterprise Edition can't be Upgraded...
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu
)

:: Checking whether the selected Source OS is a Windows 10 Enterprise N Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "10240" if "%ImageFlag%" equ "EnterpriseN" (
	echo.Windows 10 Enterprise N Edition can't be Upgraded...
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu
)

:: Checking whether the selected Source OS is a Windows 10 S Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "16299" if "%ImageEdition%" equ "Cloud" (
	echo.Windows 10 S Edition can't be Upgraded...
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu
)

:: Checking whether the selected Source OS is a Windows 10 S N Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "16299" if "%ImageEdition%" equ "CloudN" (
	echo.Windows 10 S N Edition can't be Upgraded...
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu
)
	
:: Checking whether the selected Source OS is a Windows 10 Professional Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "16299" if "%ImageFlag%" equ "Professional" (
	echo.Windows 10 Professional Edition can't be Upgraded...
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu
)
	
:: Checking whether the selected Source OS is a Windows 10 Professional N Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "16299" if "%ImageFlag%" equ "ProfessionalN" (
	echo.Windows 10 Professional N Edition can't be Upgraded...
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu
)
		
:: Checking whether the selected Source OS is a Windows 10 Enterprise G Edition
if "%ImageFlag%" equ "EnterpriseG" (
	echo.Windows 10 Enterprise G Edition can't be Upgraded...
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu
)

:: Checking whether the selected Source OS is a Windows 10 Enterprise GN Edition
if "%ImageFlag%" equ "EnterpriseGN" (
	echo.Windows 10 Enterprise GN Edition can't be Upgraded...
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu
)

:: Checking whether the selected Source OS is a Windows 10 Enterprise LTSB Edition
if "%ImageFlag%" equ "EnterpriseS" (
	if "%ImageBuild%" equ "10240" echo.Windows 10 Enterprise 2015 LTSB Edition can't be Upgraded...
	if "%ImageBuild%" equ "14393" echo.Windows 10 Enterprise 2016 LTSB Edition can't be Upgraded...
	if "%ImageBuild%" equ "17763" echo.Windows 10 Enterprise 2019 LTSB Edition can't be Upgraded...
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu
)

:: Checking whether the selected Source OS is a Windows 10 Enterprise N LTSB Edition
if "%ImageFlag%" equ "EnterpriseSN" (
	if "%ImageBuild%" equ "10240" echo.Windows 10 Enterprise N 2015 LTSB Edition can't be Upgraded...
	if "%ImageBuild%" equ "14393" echo.Windows 10 Enterprise N 2016 LTSB Edition can't be Upgraded...
	if "%ImageBuild%" equ "17763" echo.Windows 10 Enterprise N 2019 LTSB Edition can't be Upgraded...
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu
)

:: Checking whether the selected Source OS is a Windows 10 Education Edition
if "%ImageFlag%" equ "Education" (
	echo.Windows 10 Education Edition can't be Upgraded...
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu
)

:: Checking whether the selected Source OS is a Windows 10 Education N Edition
if "%ImageFlag%" equ "EducationN" (
	echo.Windows 10 Education N Edition can't be Upgraded...
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu
)

:: Checking whether the selected Source OS is a Windows Hyper Server 2016 Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageFlag%" equ "ServerHyper" (
	echo.Windows Hyper-V Server 2016 Edition can't be Upgraded...
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu 
)   

:: Checking whether the selected Source OS is a Windows Server 2016 Azure Core Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageFlag%" equ "ServerAzureCor" (
	echo.Windows Server 2016 Azure Core Edition can't be Upgraded...
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu 
)

:: Checking whether the selected Source OS is a Windows Server 2016 Datacenter Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageFlag%" equ "ServerDatacenter" (
	echo.Windows Server 2016 Datacenter Edition can't be Upgraded...
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu 
)

:: Checking whether the selected Source OS is a Windows Storage Server 2016 Standard Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageFlag%" equ "ServerStorageStandard" (
	echo.Windows Storage Server 2016 Standard Edition can't be Upgraded...
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu
)

:: Checking whether the selected Source OS is a Windows Storage Server 2016 Workgroup Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageFlag%" equ "ServerStorageWorkgroup" (
	echo.Windows Storage Server 2016 Workgroup Edition can't be Upgraded...
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu 
)

set SourceEdition=%ImageFlag%

echo.-------------------------------------------------------------------------------
echo.####Starting Upgrading WIM Image Edition#######################################
echo.-------------------------------------------------------------------------------
echo.
echo.-------------------------------------------------------------------------------
echo.Mounting [Install.wim, Index : %ImageIndexNo%] Image at ^<\Mount\Install^>...
echo.-------------------------------------------------------------------------------
call :MountImage "%InstallWim%", %ImageIndexNo%, "%InstallMount%"
echo.-------------------------------------------------------------------------------
echo.
echo.-------------------------------------------------------------------------------
echo.Getting Target Editions...
echo.-------------------------------------------------------------------------------
echo.
for /f "tokens=2 delims=:" %%a in ('%DISM% /Image:"%InstallMount%" /Get-TargetEditions ^| find "Target Edition"') do (echo. %%a)
echo.
:: Get Target Edition
set /p TargetEdition=Enter Target Edition : 
echo.

:: Checking whether the Selected Source OS is a Windows 8.1 Pro Retail Edition
if "%SelectedSourceOS%" equ "w81" if "%ImageEdition%" equ "Professional" if "%TargetEdition%" equ "ProfessionalWMC" (
	echo.Checking Whether Source Image is Windows 8.1 Pro Edition or Not...
	echo.
	%DISM% /Format:Table /Image:"%InstallMount%" /Get-Packages | findstr /c:"GVLK-Package" >nul
	if not errorlevel 1 (
		echo.Selected Source is Not a Windows 8.1 Pro Retail Edition..
		echo.
		echo.Please Use Windows 8.1 Pro Retail Edition Operating System as Source...
		goto :Stop
	)
)
echo.-------------------------------------------------------------------------------
if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType%" equ "Client" echo.Upgrading Windows 7 %SourceEdition% to %TargetEdition%...
if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType:~,6%" equ "Server" echo.Upgrading Windows Server 2008 R2 %SourceEdition% to %TargetEdition%...
if "%SelectedSourceOS%" equ "w81" if "%ImageInstallationType%" equ "Client" echo.Upgrading Windows 8.1 %SourceEdition% to %TargetEdition%...
if "%SelectedSourceOS%" equ "w81" if "%ImageInstallationType%" equ "Embedded" echo.Upgrading Windows 8.1 Embedded %SourceEdition% to %TargetEdition%...
if "%SelectedSourceOS%" equ "w81" if "%ImageInstallationType:~,6%" equ "Server" echo.Upgrading Windows Server 2012 R2 %SourceEdition% to %TargetEdition%...
if "%SelectedSourceOS%" equ "w10" if "%ImageInstallationType%" equ "Client" echo.Upgrading Windows 10 %SourceEdition% to %TargetEdition%...
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "14393" if "%ImageInstallationType:~,6%" equ "Server" echo.Upgrading Windows Server 2016 %SourceEdition% to %TargetEdition%...
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "15063" if "%ImageInstallationType:~,6%" equ "Server" echo.Upgrading Windows Server v1709 %SourceEdition% to %TargetEdition%...
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "16299" if "%ImageInstallationType:~,6%" equ "Server" echo.Upgrading Windows Server v1803 %SourceEdition% to %TargetEdition%...
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "17134" if "%ImageInstallationType:~,6%" equ "Server" echo.Upgrading Windows Server v1809 %SourceEdition% to %TargetEdition%...
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "17763" if "%ImageInstallationType:~,6%" equ "Server" echo.Upgrading Windows Server 2019 %SourceEdition% to %TargetEdition%...
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "18362" if "%ImageInstallationType:~,6%" equ "Server" echo.Upgrading Windows Server v1903/v1909 %SourceEdition% to %TargetEdition%...

echo.-------------------------------------------------------------------------------
%DISM% /Image:"%InstallMount%" /Set-Edition:%TargetEdition%
echo.
echo.-------------------------------------------------------------------------------
echo.Un-Mounting Source [Install.wim, Index : %ImageIndexNo%] Image...
echo.-------------------------------------------------------------------------------
call :UnMountImage "%InstallMount%", "Commit"
echo.-------------------------------------------------------------------------------
echo.####Applying Target WIM Image Edition Properties###############################
echo.-------------------------------------------------------------------------------
echo.
if "%SelectedSourceOS%" equ "w7"  if "%TargetEdition%" equ "HomeBasic" (
	set "Flag=HomeBasic"
	set "Edition=HomeBasic"
	set "Name=Windows 7 HOMEBASIC"
	set "Description=Windows 7 HOMEBASIC"
	set "DisplayName=Windows 7 Home Basic"
	set "DisplayDescription=Windows 7 Home Basic"
)

if "%SelectedSourceOS%" equ "w7"  if "%TargetEdition%" equ "HomePremium" (
	set "Flag=HomePremium"
	set "Edition=HomePremium"
	set "Name=Windows 7 HOMEPREMIUM"
	set "Description=Windows 7 HOMEPREMIUM"
	set "DisplayName=Windows 7 Home Premium"
	set "DisplayDescription=Windows 7 Home Premium"
)

if "%SelectedSourceOS%" equ "w7"  if "%TargetEdition%" equ "Professional" (
	set "Flag=Professional"
	set "Edition=Professional"
	set "Name=Windows 7 PROFESSIONAL"
	set "Description=Windows 7 PROFESSIONAL"
	set "DisplayName=Windows 7 Professional"
	set "DisplayDescription=Windows 7 Professional"
)

if "%SelectedSourceOS%" equ "w7"  if "%TargetEdition%" equ "Ultimate" (
	set "Flag=Ultimate"
	set "Edition=Ultimate"
	set "Name=Windows 7 ULTIMATE"
	set "Description=Windows 7 ULTIMATE"
	set "DisplayName=Windows 7 Ultimate"
	set "DisplayDescription=Windows 7 Ultimate"
)

if "%SelectedSourceOS%" equ "w7"  if "%TargetEdition%" equ "HomeBasicN" (
	set "Flag=HomeBasicN"
	set "Edition=HomeBasicN"
	set "Name=Windows 7 HOMEBASICN"
	set "Description=Windows 7 HOMEBASICN"
	set "DisplayName=Windows 7 Home Basic N"
	set "DisplayDescription=Windows 7 Home Basic N"
)

if "%SelectedSourceOS%" equ "w7"  if "%TargetEdition%" equ "HomePremiumN" (
	set "Flag=HomePremiumN"
	set "Edition=HomePremiumN"
	set "Name=Windows 7 HOMEPREMIUMN"
	set "Description=Windows 7 HOMEPREMIUMN"
	set "DisplayName=Windows 7 Home Premium N"
	set "DisplayDescription=Windows 7 Home Premium N"
)

if "%SelectedSourceOS%" equ "w7"  if "%TargetEdition%" equ "ProfessionalN" (
	set "Flag=ProfessionalN"
	set "Edition=ProfessionalN"
	set "Name=Windows 7 PROFESSIONALN"
	set "Description=Windows 7 PROFESSIONALN"
	set "DisplayName=Windows 7 Professional N"
	set "DisplayDescription=Windows 7 Professional N"
)

if "%SelectedSourceOS%" equ "w7"  if "%TargetEdition%" equ "UltimateN" (
	set "Flag=UltimateN"
	set "Edition=UltimateN"
	set "Name=Windows 7 ULTIMATEN"
	set "Description=Windows 7 ULTIMATEN"
	set "DisplayName=Windows 7 Ultimate N"
	set "DisplayDescription=Windows 7 Ultimate N"
)

if "%SelectedSourceOS%" equ "w7"  if "%TargetEdition%" equ "HomeBasicK" (
	set "Flag=HomeBasicK"
	set "Edition=HomeBasicK"
	set "Name=Windows 7 HOMEBASICK"
	set "Description=Windows 7 HOMEBASICK"
	set "DisplayName=Windows 7 Home Basic K"
	set "DisplayDescription=Windows 7 Home Basic K"
)

if "%SelectedSourceOS%" equ "w7"  if "%TargetEdition%" equ "HomePremiumK" (
	set "Flag=HomePremiumK"
	set "Edition=HomePremiumK"
	set "Name=Windows 7 HOMEPREMIUMK"
	set "Description=Windows 7 HOMEPREMIUMK"
	set "DisplayName=Windows 7 Home Premium K"
	set "DisplayDescription=Windows 7 Home Premium K"
)

if "%SelectedSourceOS%" equ "w7"  if "%TargetEdition%" equ "ProfessionalK" (
	set "Flag=ProfessionalK"
	set "Edition=ProfessionalK"
	set "Name=Windows 7 PROFESSIONALK"
	set "Description=Windows 7 PROFESSIONALK"
	set "DisplayName=Windows 7 Professional K"
	set "DisplayDescription=Windows 7 Professional K"
)

if "%SelectedSourceOS%" equ "w7"  if "%TargetEdition%" equ "UltimateK" (
	set "Flag=UltimateK"
	set "Edition=UltimateK"
	set "Name=Windows 7 ULTIMATEK"
	set "Description=Windows 7 ULTIMATEK"
	set "DisplayName=Windows 7 Ultimate K"
	set "DisplayDescription=Windows 7 Ultimate K"
)

if "%SelectedSourceOS%" equ "w7"  if "%TargetEdition%" equ "HomeBasicKN" (
	set "Flag=HomeBasicKN"
	set "Edition=HomeBasicKN"
	set "Name=Windows 7 HOMEBASICKN"
	set "Description=Windows 7 HOMEBASICKN"
	set "DisplayName=Windows 7 Home Basic KN"
	set "DisplayDescription=Windows 7 Home Basic KN"
)

if "%SelectedSourceOS%" equ "w7"  if "%TargetEdition%" equ "HomePremiumKN" (
	set "Flag=HomePremiumKN"
	set "Edition=HomePremiumKN"
	set "Name=Windows 7 HOMEPREMIUMKN"
	set "Description=Windows 7 HOMEPREMIUMKN"
	set "DisplayName=Windows 7 Home Premium KN"
	set "DisplayDescription=Windows 7 Home Premium KN"
)

if "%SelectedSourceOS%" equ "w7"  if "%TargetEdition%" equ "ProfessionalKN" (
	set "Flag=ProfessionalKN"
	set "Edition=ProfessionalKN"
	set "Name=Windows 7 PROFESSIONALKN"
	set "Description=Windows 7 PROFESSIONALKN"
	set "DisplayName=Windows 7 Professional KN"
	set "DisplayDescription=Windows 7 Professional KN"
)

if "%SelectedSourceOS%" equ "w7"  if "%TargetEdition%" equ "UltimateKN" (
	set "Flag=UltimateKN"
	set "Edition=UltimateKN"
	set "Name=Windows 7 ULTIMATEKN"
	set "Description=Windows 7 ULTIMATEKN"
	set "DisplayName=Windows 7 Ultimate KN"
	set "DisplayDescription=Windows 7 Ultimate KN"
)

if "%SelectedSourceOS%" equ "w7" if "%TargetEdition%" equ "ServerStandardCore" (
	set "Flag=ServerStandardCore"
	set "Edition=ServerStandard"
	set "Name=Windows Server 2008 R2 SERVERSTANDARDCORE"
	set "Description=Windows Server 2008 R2 SERVERSTANDARDCORE"
	set "DisplayName=Windows Server 2008 R2 Standard ^(Server Core Installation^)"
	set "DisplayDescription=This option installs a minimal installation of Windows Server without the standard Windows user interface, and with a subset of server roles that can be managed from a command prompt, reducing management requirements and attack surface."
)

if "%SelectedSourceOS%" equ "w7" if "%TargetEdition%" equ "ServerEnterpriseCore" (
	set "Flag=ServerEnterpriseCore"
	set "Edition=ServerEnterprise"
	set "Name=Windows Server 2008 R2 SERVERENTERPRISECORE"
	set "Description=Windows Server 2008 R2 SERVERENTERPRISECORE"
	set "DisplayName=Windows Server 2008 R2 Enterprise ^(Server Core Installation^)"
	set "DisplayDescription=This option installs a minimal installation of Windows Server without the standard Windows user interface, and with a subset of server roles that can be managed from a command prompt, reducing management requirements and attack surface."
)

if "%SelectedSourceOS%" equ "w7" if "%TargetEdition%" equ "ServerDatacenterCore" (
	set "Flag=ServerDataCenterCore"
	set "Edition=ServerDatacenter"
	set "Name=Windows Server 2008 R2 SERVERDATACENTERCORE"
	set "Description=Windows Server 2008 R2 SERVERDATACENTERCORE"
	set "DisplayName=Windows Server 2008 R2 Datacenter ^(Server Core Installation^)"
	set "DisplayDescription=This option installs a minimal installation of Windows Server without the standard Windows user interface, and with a subset of server roles that can be managed from a command prompt, reducing management requirements and attack surface."
)

if "%SelectedSourceOS%" equ "w7" if "%TargetEdition%" equ "ServerStandard" (
	set "Flag=ServerStandard"
	set "Edition=ServerStandard"
	set "Name=Windows Server 2008 R2 SERVERSTANDARD"
	set "Description=Windows Server 2008 R2 SERVERSTANDARD"
	set "DisplayName=Windows Server 2008 R2 Standard ^(Full Installation^)"
	set "DisplayDescription=This option installs the complete installation of Windows Server. This installation includes the entire user interface, and it supports all of the server roles."
)

if "%SelectedSourceOS%" equ "w7" if "%TargetEdition%" equ "ServerEnterprise" (
	set "Flag=ServerEnterprise"
	set "Edition=ServerEnterprise"
	set "Name=Windows Server 2008 R2 SERVERENTERPRISE"
	set "Description=Windows Server 2008 R2 SERVERENTERPRISE"
	set "DisplayName=Windows Server 2008 R2 Enterprise ^(Full Installation^)"
	set "DisplayDescription=This option installs the complete installation of Windows Server. This installation includes the entire user interface, and it supports all of the server roles."
)

if "%SelectedSourceOS%" equ "w7" if "%TargetEdition%" equ "ServerDatacenter" (
	set "Flag=ServerDataCenter"
	set "Edition=ServerDatacenter"
	set "Name=Windows Server 2008 R2 SERVERDATACENTER"
	set "Description=Windows Server 2008 R2 SERVERDATACENTER"
	set "DisplayName=Windows Server 2008 R2 Datacenter ^(Full Installation^)"
	set "DisplayDescription=This option installs the complete installation of Windows Server. This installation includes the entire user interface, and it supports all of the server roles."
)

if "%SelectedSourceOS%" equ "w81" if "%TargetEdition%" equ "Core" (
	set "Flag=Core"
	set "Edition=Core"
	set "Name=Windows 8.1 Core"
	set "Description=Windows 8.1 Core"
	set "DisplayName=Windows 8.1 Core"
	set "DisplayDescription=Windows 8.1 Core"
)

if "%SelectedSourceOS%" equ "w81" if "%TargetEdition%" equ "Professional" (
	set "Flag=Professional"
	set "Edition=Professional"
	set "Name=Windows 8.1 Pro"
	set "Description=Windows 8.1 Pro"
	set "DisplayName=Windows 8.1 Pro"
	set "DisplayDescription=Windows 8.1 Pro"
)

if "%SelectedSourceOS%" equ "w81" if "%TargetEdition%" equ "ProfessionalWMC" (
	set "Flag=ProfessionalWMC"
	set "Edition=ProfessionalWMC"
	set "Name=Windows 8.1 Pro WMC"
	set "Description=Windows 8.1 Pro WMC"
	set "DisplayName=Windows 8.1 Pro with Media Center"
	set "DisplayDescription=Windows 8.1 Pro with Media Center"
)

if "%SelectedSourceOS%" equ "w81" if "%TargetEdition%" equ "ProfessionalN" (
	set "Flag=ProfessionalN"
	set "Edition=ProfessionalN"
	set "Name=Windows 8.1 Pro N"
	set "Description=Windows 8.1 Pro N"
	set "DisplayName=Windows 8.1 Pro N"
	set "DisplayDescription=Windows 8.1 Pro N"
)

if "%SelectedSourceOS%" equ "w81" if "%TargetEdition%" equ "ServerDatacenterCore" (
	set "Flag=ServerDatacenterCore"
	set "Edition=ServerDatacenterCore"
	set "Name=Windows Server 2012 R2 Datacenter ^(Server Core Installation^)"
	set "Description=This option ^(recommended^) reduces management and servicing by installing only what is needed to run most server roles and applications.It does not include a GUI, but you can fully manage the server locally or remotely with Windows PowerShell or other tools. You can switch to a different installation option later. See \"Windows Server Installation Options.\""
	set "DisplayName=Windows Server 2012 R2 Datacenter ^(Server Core Installation^)"
	set "DisplayDescription=This option ^(recommended^) reduces management and servicing by installing only what is needed to run most server roles and applications.It does not include a GUI, but you can fully manage the server locally or remotely with Windows PowerShell or other tools. You can switch to a different installation option later. See \"Windows Server Installation Options.\""
)

if "%SelectedSourceOS%" equ "w81" if "%TargetEdition%" equ "ServerStandard" (
	set "Flag=ServerStandard"
	set "Edition=ServerStandard"
	set "Name=Windows Server 2012 R2 Standard ^(Server with a GUI^)"
	set "Description=This option is useful when a GUI is required-for example, to provide backward compatibility for an application that cannot be run on a Server Core installation. All server roles and features are supported. You can switch to a different installation option later. See \"Windows Server Installation Options.\""
	set "DisplayName=Windows Server 2012 R2 Standard ^(Server with a GUI^)"
	set "DisplayDescription=This option is useful when a GUI is required-for example, to provide backward compatibility for an application that cannot be run on a Server Core installation. All server roles and features are supported. You can switch to a different installation option later. See \"Windows Server Installation Options.\""
)

if "%SelectedSourceOS%" equ "w81" if "%TargetEdition%" equ "ServerDatacenter" (
	set "Flag=ServerDatacenter"
	set "Edition=ServerDatacenter"
	set "Name=Windows Server 2012 R2 Datacenter ^(Server with a GUI^)"
	set "Description=This option is useful when a GUI is required-for example, to provide backward compatibility for an application that cannot be run on a Server Core installation. All server roles and features are supported. You can switch to a different installation option later. See \"Windows Server Installation Options.\""
	set "DisplayName=Windows Server 2012 R2 Datacenter ^(Server with a GUI^)"
	set "DisplayDescription=This option is useful when a GUI is required-for example, to provide backward compatibility for an application that cannot be run on a Server Core installation. All server roles and features are supported. You can switch to a different installation option later. See \"Windows Server Installation Options.\""
)

if "%SelectedSourceOS%" equ "w10" if "%TargetEdition%" equ "Core" (
	set "Flag=Core"
	set "Edition=Core"
	set "Name=Windows 10 Home"
	set "Description=Windows 10 Home"
	set "DisplayName=Windows 10 Home"
	set "DisplayDescription=Windows 10 Home"
)

if "%SelectedSourceOS%" equ "w10" if "%TargetEdition%" equ "CoreN" (
	set "Flag=CoreN"
	set "Edition=CoreN"
	set "Name=Windows 10 Home N"
	set "Description=Windows 10 Home N"
	set "DisplayName=Windows 10 Home N"
	set "DisplayDescription=Windows 10 Home N"
)

if "%SelectedSourceOS%" equ "w10" if "%TargetEdition%" equ "Professional" (
	set "Flag=Professional"
	set "Edition=Professional"
	set "Name=Windows 10 Pro"
	set "Description=Windows 10 Pro"
	set "DisplayName=Windows 10 Pro"
	set "DisplayDescription=Windows 10 Pro"
)

if "%SelectedSourceOS%" equ "w10" if "%TargetEdition%" equ "ProfessionalN" (
	set "Flag=ProfessionalN"
	set "Edition=ProfessionalN"
	set "Name=Windows 10 Pro N"
	set "Description=Windows 10 Pro N"
	set "DisplayName=Windows 10 Pro N"
	set "DisplayDescription=Windows 10 Pro N"
)

if "%SelectedSourceOS%" equ "w10" if "%TargetEdition%" equ "ProfessionalCountrySpecific" (
	set "Flag=ProfessionalCountrySpecific"
	set "Edition=ProfessionalCountrySpecific"
	set "Name=Windows 10 Pro CountrySpecific"
	set "Description=Windows 10 Pro CountrySpecific"
	set "DisplayName=Windows 10 Pro CountrySpecific"
	set "DisplayDescription=Windows 10 Pro CountrySpecific"
)

if "%SelectedSourceOS%" equ "w10" if "%TargetEdition%" equ "ProfessionalSingleLanguage" (
	set "Flag=ProfessionalSingleLanguage"
	set "Edition=ProfessionalSingleLanguage"
	set "Name=Windows 10 Pro Single Language"
	set "Description=Windows 10 Pro Single Language"
	set "DisplayName=Windows 10 Pro Single Language""
	set "DisplayDescription=Windows 10 Pro Single Language"
)

if "%SelectedSourceOS%" equ "w10" if "%TargetEdition%" equ "Education" (
	set "Flag=Education"
	set "Edition=Education"
	set "Name=Windows 10 Education"
	set "Description=Windows 10 Education"
	set "DisplayName=Windows 10 Education"
	set "DisplayDescription=Windows 10 Education"
)

if "%SelectedSourceOS%" equ "w10" if "%TargetEdition%" equ "EducationN" (
	set "Flag=EducationN"
	set "Edition=EducationN"
	set "Name=Windows 10 Education N"
	set "Description=Windows 10 Education N"
	set "DisplayName=Windows 10 Education N"
	set "DisplayDescription=Windows 10 Education N"
)

if "%SelectedSourceOS%" equ "w10" if "%TargetEdition%" equ "Enterprise" (
	set "Flag=Enterprise"
	set "Edition=Enterprise"
	set "Name=Windows 10 Enterprise"
	set "Description=Windows 10 Enterprise"
	set "DisplayName=Windows 10 Enterprise"
	set "DisplayDescription=Windows 10 Enterprise"
)

if "%SelectedSourceOS%" equ "w10" if "%TargetEdition%" equ "EnterpriseN" (
	set "Flag=EnterpriseN"
	set "Edition=EnterpriseN"
	set "Name=Windows 10 Enterprise N"
	set "Description=Windows 10 Enterprise N"
	set "DisplayName=Windows 10 Enterprise N"
	set "DisplayDescription=Windows 10 Enterprise N"
)

if "%SelectedSourceOS%" equ "w10" if "%TargetEdition%" equ "EnterpriseG" (
	set "Flag=EnterpriseG"
	set "Edition=EnterpriseG"
	set "Name=Windows 10 Enterprise G"
	set "Description=Windows 10 Enterprise G"
	set "DisplayName=Windows 10 Enterprise G"
	set "DisplayDescription=Windows 10 Enterprise G"
)

if "%SelectedSourceOS%" equ "w10" if "%TargetEdition%" equ "EnterpriseGN" (
	set "Flag=EnterpriseGN"
	set "Edition=EnterpriseGN"
	set "Name=Windows 10 Enterprise GN"
	set "Description=Windows 10 Enterprise GN"
	set "DisplayName=Windows 10 Enterprise GN"
	set "DisplayDescription=Windows 10 Enterprise GN"
)

if "%SelectedSourceOS%" equ "w10" if "%TargetEdition%" equ "ProfessionalEducation" (
	set "Flag=ProfessionalEducation"
	set "Edition=ProfessionalEducation"
	set "Name=Windows 10 Pro Education"
	set "Description=Windows 10 Pro Education"
	set "DisplayName=Windows 10 Pro Education"
	set "DisplayDescription=Windows 10 Pro Education"
)

if "%SelectedSourceOS%" equ "w10" if "%TargetEdition%" equ "ProfessionalEducationN" (
	set "Flag=ProfessionalEducationN"
	set "Edition=ProfessionalEducationN"
	set "Name=Windows 10 Pro EducationN"
	set "Description=Windows 10 Pro Education N"
	set "DisplayName=Windows 10 Pro Education N"
	set "DisplayDescription=Windows 10 Pro Education N"
)

if "%SelectedSourceOS%" equ "w10" if "%TargetEdition%" equ "ProfessionalWorkstation" (
	set "Flag=ProfessionalWorkstation"
	set "Edition=ProfessionalWorkstation"
	set "Name=Windows 10 Pro for Workstations"
	set "Description=Windows 10 Pro for Workstations"
	set "DisplayName=Windows 10 Pro for Workstations"
	set "DisplayDescription=Windows 10 Pro for Workstations"
)

if "%SelectedSourceOS%" equ "w10" if "%TargetEdition%" equ "ProfessionalWorkstationN" (
	set "Flag=ProfessionalWorkstationN"
	set "Edition=ProfessionalWorkstationN"
	set "Name=Windows 10 Pro N for Workstations"
	set "Description=Windows 10 Pro N for Workstations"
	set "DisplayName=Windows 10 Pro N for Workstations"
	set "DisplayDescription=Windows 10 Pro N for Workstations"
)

if "%SelectedSourceOS%" equ "w10" if "%TargetEdition%" equ "ServerRdsh" (
	set "Flag=ServerRdsh"
	set "Edition=ServerRdsh"
	set "Name=Windows 10 Enterprise for Remote Sessions"
	set "Description=Windows 10 Enterprise for Remote Sessions"
	set "DisplayName=Windows 10 Enterprise for Remote Sessions"
	set "DisplayDescription=Windows 10 Enterprise for Remote Sessions"
)

if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "14393" if "%ImageInstallationType%" equ "Server Core" if "%SourceEdition%" equ "ServerStandard" if "%TargetEdition%" equ "ServerAzureCor" (
	set "Flag=ServerAzureCor"
	set "Edition=ServerAzureCor"
	set "Name=Windows Server 2016 SERVERAZURECORE"
	set "Description=Windows Server 2016 SERVERAZURECORE"
	set "DisplayName=Windows Server 2016 Azure"
	set "DisplayDescription=This option ^(recommended^) reduces management and servicing by installing only what is needed to run most server roles and applications. It does not include a GUI, but you can fully manage the server locally or remotely with Windows PowerShell or other tools. For more details see \"Windows Server Installation Options.\""
)

if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "14393" if "%ImageInstallationType%" equ "Server Core" if "%SourceEdition%" equ "ServerStandard" if "%TargetEdition%" equ "ServerDatacenter" (
	set "Flag=ServerDataCenterCore"
	set "Edition=ServerDatacenter"
	set "Name=Windows Server 2016 SERVERDATACENTERCORE"
	set "Description=Windows Server 2016 SERVERDATACENTERCORE"
	set "DisplayName=Windows Server 2016 Datacenter"
	set "DisplayDescription=This option ^(recommended^) reduces management and servicing by installing only what is needed to run most server roles and applications.It does not include a GUI, but you can fully manage the server locally or remotely with Windows PowerShell or other tools. For more details see \"Windows Server Installation Options.\""
)

if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "14393" if "%ImageInstallationType%" equ "Server" if "%SourceEdition%" equ "ServerSolution" if "%TargetEdition%" equ "ServerStandard" (
	set "Flag=ServerStandard"
	set "Edition=ServerStandard"
	set "Name=Windows Server 2016 SERVERSTANDARD"
	set "Description=Windows Server 2016 SERVERSTANDARD"
	set "DisplayName=Windows Server 2016 Standard ^(Desktop Experience^)"
	set "DisplayDescription=This option is useful when a GUI is required-for example, to provide backward compatibility for an application that cannot be run on a Server Core installation. All server roles and features are supported. For more details see \"Windows Server Installation Options.\""
)

if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "14393" if "%ImageInstallationType%" equ "Server" if "%SourceEdition%" equ "ServerStandard" if "%TargetEdition%" equ "ServerDatacenter" (
	set "Flag=ServerDataCenter"
	set "Edition=ServerDatacenter"
	set "Name=Windows Server 2016 SERVERDATACENTER"
	set "Description=Windows Server 2016 SERVERDATACENTER"
	set "DisplayName=Windows Server 2016 Datacenter ^(Desktop Experience^)"
	set "DisplayDescription=This option is useful when a GUI is required-for example, to provide backward compatibility for an application that cannot be run on a Server Core installation. All server roles and features are supported. For more details see \"Windows Server Installation Options.\""
)

if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "17763" if "%ImageInstallationType%" equ "Server" if "%SourceEdition%" equ "ServerSolution" if "%TargetEdition%" equ "ServerStandard" (
	set "Flag=ServerStandard"
	set "Edition=ServerStandard"
	set "Name=Windows Server 2019 SERVERSTANDARD"
	set "Description=Windows Server 2019 SERVERSTANDARD"
	set "DisplayName=Windows Server 2019 Standard ^(Desktop Experience^)"
	set "DisplayDescription=This option installs the full Windows graphical environment, consuming extra drive space. It can be useful if you want to use the Windows desktop or have an app that requires it."
)

if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "17763" if "%ImageInstallationType%" equ "Server" if "%SourceEdition%" equ "ServerStandard" if "%TargetEdition%" equ "ServerDatacenter" (
	set "Flag=ServerDataCenter"
	set "Edition=ServerDatacenter"
	set "Name=Windows Server 2019 SERVERDATACENTER"
	set "Description=Windows Server 2019 SERVERDATACENTER"
	set "DisplayName=Windows Server 2019 Datacenter ^(Desktop Experience^)"
	set "DisplayDescription=This option installs the full Windows graphical environment, consuming extra drive space. It can be useful if you want to use the Windows desktop or have an app that requires it."
)
:: Setting Image Flag, Name and Description to reflect Target Edition
echo.Setting Image [Display Name] to "%DisplayName%"...
echo.Setting Image [Display Description] to "%DisplayDescription%"...
echo.Setting Image [Flag] to "%Flag%"...
echo.Setting Image [Edition] to "%Edition%"...
echo.
%WimLibImagex% info "%InstallWim%" %ImageIndexNo% "%Name%" "%Description%" --image-property DISPLAYNAME="%DisplayName%" --image-property DISPLAYDESCRIPTION="%DisplayDescription%" --image-property FLAGS="%Flag%" >nul
echo.-------------------------------------------------------------------------------
echo.####Copying EI.CFG Config file to ^<DVD\sources^> Folder#########################
echo.-------------------------------------------------------------------------------
echo.
echo.Copying "%TargetEdition%" Edition EI.CFG file to ^<DVD\sources^> folder.
if exist "%DVD%\sources\EI.CFG" del /f /q "%DVD%\sources\EI.CFG" >nul
(
	echo.[EditionID]
	echo.%TargetEdition%
	echo.
	echo.[Channel]
	echo.Retail
	echo.
	echo.[VL]
	echo.0
)>"%DVD%\sources\EI.CFG"
echo.
echo.-------------------------------------------------------------------------------
echo.####Finished Upgrading Source WIM Image Edition################################
echo.-------------------------------------------------------------------------------
:Stop
echo.
echo.===============================================================================
echo.
pause

set SourceEdition=
set TargetEdition=
set Flag=
set Edition=
set Name=
set Description=
set DisplayName=
set DisplayDescription=

endlocal

goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Capture a Drive or Folder to a WIM Image
::-------------------------------------------------------------------------------------------
:WIMCapture

setlocal

set SourceDriveFolder=
set TargetWimImageFileName=
set TargetWimImageName=
set TargetWimImageDescription=
set TargetWimImageEditionFlag=
set BootFlag=

cls
echo.===============================================================================
echo.            MSMG ToolKit - Capture Drive or Folder to WIM Image
echo.===============================================================================
echo.
echo.-------------------------------------------------------------------------------
echo.####Starting Capturing Drive or Folder to WIM Image############################
echo.-------------------------------------------------------------------------------
echo.
:: Get Source Drive or folder path to be Captuerd to WIM Image
set /p SourceDriveFolder=Enter a Valid Source Drive or folder path : 
echo.
:: Get Target WIM Image File Name
set /p TargetWimImageFileName=Enter Target WIM Image Filename : 
echo.
:: Get Target WIM Image Name
set /p TargetWimImageName=Enter Target WIM Image Name : 
echo.
:: Get Target WIM Image Description
set /p TargetWimImageDescription=Enter Target WIM Image Description : 
echo.
:: Get Target WIM Image Editon Flag
set /p TargetWimImageEditionFlag=Enter Target WIM Image Edition : 
echo.
:: Get Bootable Flag Status
choice /C:YN /N /M "Make Target WIM Image Bootable ? ['Y'es/'N'o] : "
if errorlevel 2 set BootFlag=No
if not errorlevel 2 set BootFlag=Yes
echo.
echo.-------------------------------------------------------------------------------
echo.####Capturing Drive or Folder to WIM Image#####################################
echo.-------------------------------------------------------------------------------
call :CaptureImage "%DVD%\sources\%TargetWimImageFileName%", "%SourceDriveFolder%", %TargetWimImageName%, %TargetWimImageDescription%, %BootFlag%
echo.-------------------------------------------------------------------------------
echo.####Setting Target WIM Image Flag, Name ^& Description##########################
echo.-------------------------------------------------------------------------------
echo.
:: Setting WIM Image Flag, Name and Description to reflect Target Edition
echo.Setting WIM Image [Name] to "%TargetWimImageName%"...
echo.
echo.Setting WIM Image [Description] to "%TargetWimImageDescription%"...
echo.
echo.Setting WIM Image [Flag] to "%TargetWimImageEditionFlag%"...
%Imagex% /Flags "%TargetWimImageEditionFlag%" /Info "%DVD%\sources\%TargetWimImageFileName%" 1 %TargetWimImageName% %TargetWimImageDescription% >nul
echo.
echo.-------------------------------------------------------------------------------
echo.####Finished Capturing Drive or Folder to WIM Image############################
echo.-------------------------------------------------------------------------------
:Stop
echo.
echo.===============================================================================
echo.
pause

set SourceDriveFolder=
set TargetWimImageFileName=
set TargetWimImageName=
set TargetWimImageDescription=
set TargetWimImageEditionFlag=
set BootFlag=

endlocal

goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Apply a WIM Image Index to a Drive or Folder
::-------------------------------------------------------------------------------------------
:WIMApply

setlocal

set TargetDriveFolder=

cls
echo.===============================================================================
echo.        MSMG ToolKit - Apply a WIM Image Index to a Drive or Folder
echo.===============================================================================
echo.
:: Checking whether Windows Source Install Image file exist
if not exist "%InstallWim%" (
	echo.Cannot find Windows Setup Install Image ^<DVD\Sources\install.wim^> file...
	echo.
	echo.Please copy Windows Setup Install Image file to respective folder...
	goto :Stop
)
echo.-------------------------------------------------------------------------------
echo.####Starting Applying a WIM Image Index to a Drive or Folder###################
echo.-------------------------------------------------------------------------------

:: Display Image Information
call :ShowImageInfo

:: Get Image Index No to Export
if "!ImageCount!" equ "1" ( 
	set /p ImageIndexNo=Enter the WIM Image Index # : 
) else set /p ImageIndexNo=Enter the WIM Image Index's # [Range : 1-!ImageCount!] : 

if "!ImageIndexNo!" lss "1" (
	echo.
	echo.Invalid Index # Entered, Valid Range is [1-!ImageCount!]
	echo.
	echo.Press Enter to Try Again...
	pause >nul

	goto :WIMApply
)

if "!ImageIndexNo!" gtr "!ImageCount!" (
	echo.
	echo.Invalid Index # Entered, Valid Range is [1-!ImageCount!]
	echo.
	echo.Press Enter to Try Again...
	pause >nul

	goto :WIMApply
)

:: Get Target Drive or folder path to Apply the WIM Image Index
echo.
set /p TargetDriveFolder=Enter Target Drive or folder path : 
echo.
echo.-------------------------------------------------------------------------------
echo.####Applying a WIM Image Index to a Drive or Folder############################
echo.-------------------------------------------------------------------------------
echo.
call :ApplyImage "%InstallWim%", %ImageIndexNo%, %TargetDriveFolder%
echo.-------------------------------------------------------------------------------
echo.####Finished Applying a WIM Image Index to a Drive or Folder###################
echo.-------------------------------------------------------------------------------
:Stop
echo.
echo.===============================================================================
echo.
pause

set TargetDriveFolder=

endlocal

goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Cleanup a WIM Image Index
::-------------------------------------------------------------------------------------------
:WIMCleanUp

setlocal

set CleanupOption=

cls
echo.===============================================================================
echo.                  MSMG ToolKit - Cleanup a WIM Image Index
echo.===============================================================================
echo.
:: Checking whether Windows Source Install Image file exist
if not exist "%InstallWim%" (
	echo.Cannot find Windows Setup Install Image ^<DVD\Sources\install.wim^> file...
	echo.
	echo.Please copy Windows Setup Install Image file to respective folder...
	goto :Stop
)
echo.  [1]  Cleanup Image
echo.
echo.  [2]  Cleanup Image with CheckHealth
echo.
echo.  [3]  Cleanup Image with ScanHealth
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.  [X]   Go Back
echo.
echo.===============================================================================
echo.
choice /C:123X /N /M "Enter Your Choice : "
if errorlevel 4 goto :ToolsMenu
if errorlevel 3 set "CleanupOption=ScanHealth"
if errorlevel 2 set "CleanupOption=CheckHealth"
if errorlevel 1 set "CleanupOption=CleanupImage"

cls
echo.===============================================================================
echo.                  MSMG ToolKit - Cleanup a WIM Image Index
echo.===============================================================================
echo.
echo.-------------------------------------------------------------------------------
if "%CleanupOption%" equ "CleanupImage" echo.####Starting Source WIM Image Cleanup##########################################
if "%CleanupOption%" equ "CheckHealth" echo.####Starting Source WIM Image Cleanup with Check Health########################
if "%CleanupOption%" equ "ScanHealth" echo.####Starting Source WIM Image Cleanup with Scan Health#########################
echo.-------------------------------------------------------------------------------

:: Display Image Information
call :ShowImageInfo

:: Get Image Index No to Clean
if "!ImageCount!" equ "1" ( 
	set /p ImageIndexNo=Enter the WIM Image Index # : 
) else set /p ImageIndexNo=Enter the WIM Image Index's # [Range : 1-!ImageCount!] : 

if "!ImageIndexNo!" lss "1" (
	echo.
	echo.Invalid Index # Entered, Valid Range is [1-!ImageCount!]
	echo.
	echo.Press Enter to Try Again...
	pause >nul

	goto :WIMApply
)

if "!ImageIndexNo!" gtr "!ImageCount!" (
	echo.
	echo.Invalid Index # Entered, Valid Range is [1-!ImageCount!]
	echo.
	echo.Press Enter to Try Again...
	pause >nul

	goto :WIMApply
)

:: Getting Selected Image Index Information
call :GetImageIndexInfo "%InstallWim%", %ImageIndexNo% >nul

:: Setting Selected Source OS
if "%ImageVersion%" equ "6.1.7601" set "SelectedSourceOS=w7"
if "%ImageVersion%" equ "6.3.9600" set "SelectedSourceOS=w81"
if "%ImageVersion:~0,-6%" equ "10.0" set "SelectedSourceOS=w10"

echo.
echo.-------------------------------------------------------------------------------
if "%CleanupOption%" equ "CleanupImage" echo.####Source WIM Image Cleanup###################################################
if "%CleanupOption%" equ "CheckHealth" echo.####Source WIM Image Cleanup with Check Health#################################
if "%CleanupOption%" equ "ScanHealth" echo.####Source WIM Image Cleanup with Scan Health##################################
echo.-------------------------------------------------------------------------------
echo.
echo.-------------------------------------------------------------------------------
echo.Mounting [Install.wim, Index : %ImageIndexNo%] WIM Image at ^<\Mount\Install^>...
echo.-------------------------------------------------------------------------------
call :MountImage "%InstallWim%", %ImageIndexNo%, "%InstallMount%"
echo.-------------------------------------------------------------------------------
echo.Performing [Install.wim, Index : %ImageIndexNo%] WIM Image CleanUp...
echo.-------------------------------------------------------------------------------
if "%CleanupOption%" equ "CleanupImage" (
	if "%SelectedSourceOS%" equ "w7" call :CleanupImage "%InstallMount%", "SPSupersededHideSP"
	if "%SelectedSourceOS%" neq "w7" call :CleanupImage "%InstallMount%", "ComponentCleanupResetBase"
) else (
	call :CleanupImage "%InstallMount%", "ComponentCleanup", "%CleanupOption%"
)
echo.-------------------------------------------------------------------------------
echo.Applying Changes ^& Un-Mounting Source [Install.wim, Index : %ImageIndexNo%] WIM Image...
echo.-------------------------------------------------------------------------------
call :UnMountImage "%InstallMount%", "Commit"
echo.-------------------------------------------------------------------------------
if "%CleanupOption%" equ "CleanupImage" echo.####Finished Source WIM Image Cleanup##########################################
if "%CleanupOption%" equ "CheckHealth" echo.####Finished Source WIM Image Cleanup with Check Health########################
if "%CleanupOption%" equ "ScanHealth" echo.####Finished Source WIM Image Cleanup with Scan Health#########################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set CleanupOption=

endlocal

goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Show MSMG ToolKit Debug Information
::-------------------------------------------------------------------------------------------
:Debug

cls
echo.===============================================================================
echo.                       MSMG ToolKit - Debug Information
echo.===============================================================================
echo. HostArchitecture=%HostArchitecture%
echo. SelectedSourceOS=%SelectedSourceOS%
echo. IsSourceSelected=%IsSourceSelected%
echo. IsDialogsEnabled=%IsDialogsEnabled%
echo. IsLogsEnabled=%IsLogsEnabled%
echo.
echo. ImageIndexNo=%ImageIndexNo%
if "%ImageIndexNo%" neq "*" (
	echo. ImageName=%ImageName%
	echo. ImageDescription=%ImageDescription%
)
echo. ImageArchitecture=%ImageArchitecture%
echo. ImageBuild=%ImageBuild%
echo. ImageVersion=%ImageVersion%
echo. ImageServicePackBuild=%ImageServicePackBuild%
echo. ImageServicePackLevel=%ImageServicePackLevel%
if "%ImageIndexNo%" neq "*" (
	echo. ImageEdition=%ImageEdition%
	echo. ImageFlag=%ImageFlag%
	echo. ImageInstallationType=%ImageInstallationType%
)
echo. ImageDefaultLanguage=%ImageDefaultLanguage%
echo. ImageCount=%ImageCount%
echo.===============================================================================
pause

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: MSMG ToolKit - Options Menu
::-------------------------------------------------------------------------------------------
:Options

cls
echo.===============================================================================
echo.                          MSMG ToolKit - Options Menu
echo.===============================================================================
echo.
echo.  [1]   Set ToolKit Color Settings
echo.
if "%IsDialogsEnabled%" equ "No" echo.  [2]   Enable ToolKit Info/Warning Dialogs
if "%IsDialogsEnabled%" equ "Yes" echo.  [2]   Disable ToolKit Info/Warning Dialogs
echo.
if "%IsLogsEnabled%" equ "No" echo.  [3]   Enable ToolKit Log Generation
if "%IsLogsEnabled%" equ "Yes" echo.  [3]   Disable ToolKit Log Generation
echo.
if "%IsImageRegistryLoaded%" equ "No" echo.  [4]   Load Image Registry
if "%IsImageRegistryLoaded%" equ "Yes" echo.  [4]   Unload Image Registry
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.  [X]   Go Back
echo.
echo.===============================================================================
echo.
choice /C:1234X /N /M "Enter Your Choice : "
if errorlevel 5 goto :ToolsMenu
if errorlevel 4 (
	if "%IsImageRegistryLoaded%" equ "No" (
		cls
		echo.===============================================================================
		echo.                          MSMG ToolKit - Image Registry
		echo.===============================================================================
		echo.
		:: Checking whether Source OS is Selected
		if "%IsSourceSelected%" equ "No" (
			echo.Source OS is not selected, please select from "Source" Menu..
			echo.
			echo.===============================================================================
			echo.
			pause
			goto :MainMenu
		)

		:: Checking whether Multi-Index Servicing Mode is Selected
		if "%ImageIndexNo%" equ "*" (
			echo.This feature is not available when Multi-Index servicing mode is enabled...
			echo.
			echo.Please Re-Choose Source with a Single Index...
			goto :Stop
		)
		echo.Loading Image Registry...
		call :MountImageRegistry "%InstallMount%"
		set "IsImageRegistryLoaded=Yes"
		echo.
		echo.[HKEY_LOCAL_MACHINE\TK_SOFTWARE]         -^> [HKEY_LOCAL_MACHINE\SOFTWARE]
		echo.[HKEY_LOCAL_MACHINE\TK_SOFTWARE\Classes] -^> [HKEY_CLASSES_ROOT]
		echo.[HKEY_LOCAL_MACHINE\TK_SYSTEM]           -^> [HKEY_LOCAL_MACHINE\SYSTEM]
		echo.[HKEY_LOCAL_MACHINE\TK_NTUSER]           -^> [HKEY_CURRENT_USER]
		echo.[HKEY_LOCAL_MACHINE\TK_DEFAULT]          -^> [HKEY_USERS\.Default]
		echo.
		echo.Loading Image Registry Complete...
		echo.
		echo.===============================================================================
		echo.
		pause
	)
	if "%IsImageRegistryLoaded%" equ "Yes" (
		cls
		echo.===============================================================================
		echo.                          MSMG ToolKit - Image Registry
		echo.===============================================================================
		echo.
		echo.Unloading Image Registry...
		call :UnMountImageRegistry
		set "IsImageRegistryLoaded=No"
		echo.
		echo.Unloading Image Registry Complete...
		echo.
		echo.===============================================================================
		echo.
		pause
	)
	goto :Toolsmenu
)
if errorlevel 3 (
	if "%IsLogsEnabled%" equ "No" set "IsLogsEnabled=Yes"
	if "%IsLogsEnabled%" equ "Yes" set "IsLogsEnabled=No"
	goto :Toolsmenu
)
if errorlevel 2 (
	if "%IsDialogsEnabled%" equ "No" set "IsDialogsEnabled=Yes"
	if "%IsDialogsEnabled%" equ "Yes" set "IsDialogsEnabled=No"
	goto :Toolsmenu
)
if errorlevel 1 goto :SetTkColor

::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Set ToolKit Color Settings
::-------------------------------------------------------------------------------------------
:SetTkColor

cls
echo.===============================================================================
echo.                   MSMG ToolKit - Set ToolKit Color Settings
echo.===============================================================================
echo. List of Available Background / Foreground Color :
echo.
echo.  [1]  Black - White                [F]  Aqua         - Blue
echo.  [2]  Black - Light Green          [G]  Aqua         - Light Blue
echo.  [3]  Black - Light Aqua           [H]  Aqua         - Light Yellow
echo.  [4]  Black - Light Red            [I]  Red          - Light Green
echo.  [5]  Black - Light Yellow         [J]  Red          - Light Aqua
echo.  [6]  Black - Bright White         [K]  Red          - Light Yellow
echo.  [7]  Blue  - White                [L]  Red          - Bright White
echo.  [8]  Blue  - Light Green          [M]  Light Blue   - White
echo.  [9]  Blue  - Light Aqua           [N]  Light Blue   - Light Green
echo.  [A]  Blue  - Light Red            [O]  Light Blue   - Light Aqua
echo.  [B]  Blue  - Light Purple         [P]  Light Blue   - Light Yellow
echo.  [C]  Blue  - Light Yellow         [Q]  Light Blue   - Bright White
echo.  [D]  Blue  - Bright White         [R]  Bright White - Black
echo.  [E]  Aqua  - Black                [S]  Bright White - Blue
echo.
echo.  [X]  Go Back
echo.===============================================================================
echo.
choice /C:123456789ABCDEFGHIJKLMNoPQRSX /N /M "Enter Your Choice : "
if errorlevel 29  goto :Options
if errorlevel 28  color F1 & goto :MainMenu
if errorlevel 27  color F0 & goto :MainMenu
if errorlevel 26  color 9F & goto :MainMenu
if errorlevel 25  color 9E & goto :MainMenu
if errorlevel 24  color 9B & goto :MainMenu
if errorlevel 23  color 9A & goto :MainMenu
if errorlevel 22  color 97 & goto :MainMenu
if errorlevel 21  color 4F & goto :MainMenu
if errorlevel 20  color 4E & goto :MainMenu
if errorlevel 19  color 4B & goto :MainMenu
if errorlevel 18  color 4A & goto :MainMenu
if errorlevel 17  color 3E & goto :MainMenu
if errorlevel 16  color 39 & goto :MainMenu
if errorlevel 15  color 31 & goto :MainMenu
if errorlevel 14  color 30 & goto :MainMenu
if errorlevel 13  color 1F & goto :MainMenu
if errorlevel 12  color 1E & goto :MainMenu
if errorlevel 11  color 1D & goto :MainMenu
if errorlevel 10  color 1C & goto :MainMenu
if errorlevel 9   color 1B & goto :MainMenu
if errorlevel 8   color 1A & goto :MainMenu
if errorlevel 7   color 17 & goto :MainMenu
if errorlevel 6   color 0F & goto :MainMenu
if errorlevel 5   color 0E & goto :MainMenu
if errorlevel 4   color 0C & goto :MainMenu
if errorlevel 3   color 0B & goto :MainMenu
if errorlevel 2   color 0A & goto :MainMenu
if errorlevel 1   color 07 & goto :MainMenu
::-------------------------------------------------------------------------------------------

:: ############################################################################################
:: MSMG ToolKit DISM Functions 
:: ############################################################################################

::-------------------------------------------------------------------------------------------
:: Function to get Image Index Count
:: Input Parameters [ %~1 : Image Filename ]
::-------------------------------------------------------------------------------------------
:GetImageCount

:: Finding total no of Indexes present in the Image.
for /f "tokens=2 delims=: " %%a in ('%DISM% /Get-ImageInfo /ImageFile:%~1 ^| findstr /i Index') do (set ImageCount=%%a)

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to display Image Information
::-------------------------------------------------------------------------------------------
:ShowImageInfo

set "ImageInfo=%Temp%\ImageInfo.txt"

call :RemoveFile %ImageInfo%

:: Get total no of Indexes present in the Image.
call :GetImageCount "%InstallWim%"

echo.
echo.Reading Image Information...
echo.
:: List all the Indexes in the Image.
echo.===============================================================================>>%ImageInfo%
echo.^| Index ^| Arch ^| Name>>%ImageInfo%
echo.===============================================================================>>%ImageInfo%
for /f "tokens=2 delims=: " %%a in ('%DISM% /Get-WimInfo /WimFile:%InstallWim% ^| findstr /i Index') do (
	for /f "tokens=2 delims=: " %%b in ('%DISM% /Get-WimInfo /WimFile:%InstallWim% /Index:%%a ^| findstr /i Architecture') do (
		for /f "tokens=2 delims=:" %%c in ('%DISM% /Get-WimInfo /WimFile:%InstallWim% /Index:%%a ^| findstr /i Name') do (
			if "%%b" neq "arm64" (
				if %%a leq 9 echo.^|   %%a   ^| %%b  ^|%%c>>%ImageInfo%
				if %%a gtr 9 if %%a lss 99 echo.^|   %%a  ^| %%b  ^|%%c>>%ImageInfo%
				if %%a gtr 99 echo.^|   %%a ^| %%b  ^|%%c>>%ImageInfo%
			)			
			if "%%b" equ "arm64" (
				if %%a leq 9 echo.^|   %%a   ^| %%b^|%%c>>%ImageInfo%
				if %%a gtr 9 if %%a lss 99 echo.^|   %%a  ^| %%b^|%%c>>%ImageInfo%
				if %%a gtr 99 echo.^|   %%a ^| %%b^|%%c>>%ImageInfo%
			)
		)
	)
)

type %ImageInfo%
call :RemoveFile %ImageInfo%

echo.===============================================================================
echo.

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to get Image Index number to service
:: Input Parameters [ %~1 : Image Filename ]
::-------------------------------------------------------------------------------------------
:GetImageIndexNo

:: Display the list of avaialble Image Indexes.
call :ShowImageInfo

if "%ImageCount%" equ "1" ( 
	set /p ImageIndexNo=Enter the Image Index # : 
) else set /p ImageIndexNo=Enter the Image Index's # [Range : 1-%ImageCount%, * - All] : 

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to get Image Index Architecture
:: Input Parameters [ %~1 : Image Filename, %~2 : Image Index No ]
::-------------------------------------------------------------------------------------------
:GetImageArchitecture

for /f "tokens=2 delims=: " %%a in ('%DISM% /Get-ImageInfo /ImageFile:"%~1" /Index:%~2 ^| findstr /i Architecture') do (set ImageArchitecture=%%a)

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to get Image Index Edition
:: Input Parameters [ %~1 : Image Filename, %~2 : Image Index No ]
::-------------------------------------------------------------------------------------------
:GetImageEdition

for /f "tokens=2 delims=: " %%f in ('%DISM% /Get-ImageInfo /ImageFile:"%~1" /Index:%~2 ^| findstr /i Edition') do (set ImageEdition=%%f)

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to get Image Index Information
:: Input Parameters [%~1 : Image Filename, %~2 : Image Index No]
::-------------------------------------------------------------------------------------------
:GetImageIndexInfo

for /f "tokens=2 delims=:" %%a in ('%DISM% /Get-ImageInfo /ImageFile:"%~1" /Index:%~2 ^| findstr /i Name') do (set ImageName=%%a)
for /f "tokens=2 delims=:" %%b in ('%DISM% /Get-ImageInfo /ImageFile:"%~1" /Index:%~2 ^| findstr /i Description') do (set ImageDescription=%%b)
for /f "tokens=2 delims=: " %%c in ('%DISM% /Get-ImageInfo /ImageFile:"%~1" /Index:%~2 ^| findstr /i Architecture') do (set ImageArchitecture=%%c)
for /f "tokens=2 delims=: " %%d in ('%DISM% /Get-ImageInfo /ImageFile:"%~1" /Index:%~2 ^| findstr /i Version') do (set ImageVersion=%%d)
for /f "tokens=2 delims=:" %%e in ('%DISM% /Get-ImageInfo /ImageFile:"%~1" /Index:%~2 ^| find "ServicePack Build"') do ( set ImageServicePackBuild=%%e)
for /f "tokens=2 delims=:" %%f in ('%DISM% /Get-ImageInfo /ImageFile:"%~1" /Index:%~2 ^| find "ServicePack Level"') do ( set ImageServicePackLevel=%%f)
for /f "tokens=2 delims=: " %%g in ('%DISM% /Get-ImageInfo /ImageFile:"%~1" /Index:%~2 ^| findstr /i Edition') do (set ImageEdition=%%g)
for /f "tokens=2 delims=:<> " %%h in ('%Imagex% /info "%~1" %~2 ^| findstr /i Flag') do (set ImageFlag=%%h)
for /f "tokens=2 delims=:" %%i in ('%DISM% /Get-ImageInfo /ImageFile:"%~1" /Index:%~2 ^| findstr /i Installation') do (set ImageInstallationType=%%i)
for /f "tokens=* delims=" %%j in ('%DISM% /Get-ImageInfo /ImageFile:"%~1" /Index:%~2 ^| findstr /i Default') do ( set ImageDefaultLanguage=%%j)

set "ImageName=%ImageName:~1%"
set "ImageDescription=%ImageDescription:~1%"
if "%ImageVersion:~0,-6%" neq "10.0" set "ImageBuild=%ImageVersion:~4,4%"
if "%ImageVersion:~0,-6%" equ "10.0" set "ImageBuild=%ImageVersion:~5,5%"
set "ImageServicePackBuild=%ImageServicePackBuild:~1%"
set "ImageServicePackLevel=%ImageServicePackLevel:~1%"
set "ImageInstallationType=%ImageInstallationType:~1%"
set "ImageDefaultLanguage=%ImageDefaultLanguage:~1,-10%"

if "%ImageFlag%" equ "" set "ImageFlag=%ImageEdition%"

if "%ImageInstallationType:~,6%" equ "Server" set "ImageDescription=%ImageDescription:(=[%"
if "%ImageInstallationType:~,6%" equ "Server" set "ImageDescription=%ImageDescription:)=]%"

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Mount a Image
:: Input Parameters [ %~1 : Image Filename, %~2 : Image Index No, %~3 : Image Mount folder ]
::-------------------------------------------------------------------------------------------
:MountImage

%DISM% /Mount-Image /ImageFile:%~1 /Index:%~2 /MountDir:%~3
echo.

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Un-Mount the Mounted Image
:: Input Parameters [ %~1 : Image Mount Folder, %~2 : Image Commit / Discard Option ]
::-------------------------------------------------------------------------------------------
:UnMountImage

%DISM% /Unmount-Image /MountDir:%~1 /%~2
echo.

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to delete a selected Image Index from a Image
:: Input Parameters [ %~1 : Image Filename, %~2 : Image Index No ]
::-------------------------------------------------------------------------------------------
:DeleteImage

%DISM% /Delete-Image /ImageFile:%~1 /Index:%~2
echo.

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to rename a selected Image Index Information
:: Input Parameters [ %~1 : Image Filename, %~2 : Image Index No, %~3 : Image Name, %~4 : Image Description ]
::-------------------------------------------------------------------------------------------
:RenameImage

%Imagex% /Info %~1 %~2 "%~3" "%~4"

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to split a Image
:: Input Parameters [ %~1 : Image Filename, %~2 : Image Split Filename, %~3 : Image Split Size in MB ]
::-------------------------------------------------------------------------------------------
:SplitImage

%DISM% /Split-Image /ImageFile:%~1 /SWMFile:%~2 /FileSize:%~3
echo.

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to merge a splitted Image
:: Input Parameters [ %~1 : Image Splitted Filename without Extension, %~2 : Image Filename ]
::-------------------------------------------------------------------------------------------
:MergeImage

%Imagex% /ref %~1*.swm /Check /Export %~1.swm * %~2

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to apply a Image to a drive or a folder
:: Input Parameters [ %~1 : Image Filename, %~2 : Image Index No, %~3 : Image Apply Drive or folder Name ]
::-------------------------------------------------------------------------------------------
:ApplyImage

%DISM% /Apply-Image /ImageFile:%~1 /Index:%~2 /ApplyDir:%~3\ /CheckIntegrity /Verify
echo.

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to capture a drive or a folder to a Image
:: Input Parameters [ %~1 : Image Filename, %~2 : Capture Drive or Folder Name, 
::                    %~3 : Index Name,  %~4 : Index Description, %~5 : Bootable or Not Options ]
::-------------------------------------------------------------------------------------------
:CaptureImage

if "%~5" equ "Yes" %DISM% /Capture-Image /Imagefile:%~1 /CaptureDir:%~2 /Name:"%~3" /Description:"%~4" /ConfigFile:%WimConfigFile% /Bootable /Compress:Max /CheckIntegrity /Verify 
if "%~5" equ "No" %DISM% /Capture-Image /Imagefile:%~1 /CaptureDir:%~2 /Name:"%~3" /Description:"%~4" /ConfigFile:%WimConfigFile% /Compress:Max /CheckIntegrity /Verify 
echo.

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to append another Image to Image
:: Input Parameters [ %~1 : Image Filename, %~2 : Capture Drive or Folder Name, 
::                    %~3 : Index Name,  %~4 : Index Description, %~5 : Bootable or Not Option ]
::-------------------------------------------------------------------------------------------
:AppendImage

if "%~5" equ "Yes" %DISM% /Append-Image /Imagefile:%~1 /CaptureDir:%~2 /Name:"%~3" /Description:"%~4" /ConfigFile:%WimConfigFile% /Bootable /CheckIntegrity /Verify 
if "%~5" equ "No" %DISM% /Append-Image /Imagefile:%~1 /CaptureDir:%~2 /Name:"%~3" /Description:"%~4" /ConfigFile:%WimConfigFile% /CheckIntegrity /Verify 
echo.

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to export a select Image Index with Maximum/Recovery compression
:: Input Parameters [ %~1 : Source Image Filename, %~2 : Source Image Index No,
::                    %~3 : Target Image Filename, %~4 : Image Format, %~5 : Bootable or Not Option ]
::-------------------------------------------------------------------------------------------
:ExportImageIndex

if "%~4" equ "WIM" if "%~5" equ "Yes" %DISM% /Export-Image /SourceImageFile:%~1 /SourceIndex:%~2 /DestinationImageFile:%~3 /CheckIntegrity /Compress:Max /Bootable
if "%~4" equ "WIM" if "%~5" equ "No" %DISM% /Export-Image /SourceImageFile:%~1 /SourceIndex:%~2 /DestinationImageFile:%~3 /CheckIntegrity /Compress:Max
if "%~4" equ "ESD" if "%~5" equ "Yes" %DISM% /Export-Image /SourceImageFile:%~1 /SourceIndex:%~2 /DestinationImageFile:%~3 /CheckIntegrity /Compress:Recovery /Bootable
if "%~4" equ "ESD" if "%~5" equ "No" %DISM% /Export-Image /SourceImageFile:%~1 /SourceIndex:%~2 /DestinationImageFile:%~3 /CheckIntegrity /Compress:Recovery
echo.

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to export all Image Indexes with Maximum/Recovery compression
:: Input Parameters [ %~1 : Source Image Filename, %~2 : Target Image Filename, %~3 : Image Format, %~4 : Bootable or Not Option ]
::-------------------------------------------------------------------------------------------
:ExportImage

if "%~3" equ "WIM" if "%~4" equ "Yes" %DISM% /Export-Image /SourceImageFile:%~1 /All /DestinationImageFile:%~2 /CheckIntegrity /Compress:Max /Bootable
if "%~3" equ "WIM" if "%~4" equ "No" %DISM% /Export-Image /SourceImageFile:%~1 /All /DestinationImageFile:%~2 /CheckIntegrity /Compress:Max
if "%~3" equ "ESD" if "%~4" equ "Yes" %DISM% /Export-Image /SourceImageFile:%~1 /All /DestinationImageFile:%~2 /CheckIntegrity /Compress:Recovery /Bootable
if "%~3" equ "ESD" if "%~4" equ "No" %DISM% /Export-Image /SourceImageFile:%~1 /All /DestinationImageFile:%~2 /CheckIntegrity /Compress:Recovery
echo.

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to cleanup a Image
:: Input Parameters [ %~1 : Image Mount Path, %~2 : Option  ]
::-------------------------------------------------------------------------------------------
:CleanupImage

setlocal

set "CleanupOption=%~2"

if "%CleanupOption%" equ "SPSupersededHideSP" (
	%DISM% /Image:%~1 /Cleanup-Image /SPSuperseded /HideSP
)

if "%CleanupOption%" equ "ComponentCleanupResetBase" (
	%DISM% /Image:%~1 /Cleanup-Image /StartComponentCleanup /ResetBase
)

if "%CleanupOption%" equ "CheckHealth" (
	%DISM% /Image:%~1 /Cleanup-Image /CheckHealth
)

if "%CleanupOption%" equ "ScanHealth" (
	%DISM% /Image:%~1 /Cleanup-Image /ScanHealth
)

echo.

endlocal

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to add driver packages to Image
:: Input Parameters [ %~1 : Image Mount Path, %~2 : Drivers Packages Path ]
::-------------------------------------------------------------------------------------------
:AddDriver

%DISM% /Image:%~1 /Add-Driver /Driver:%~2 /ForceUnsigned /Recurse
echo.

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to enable a feature inside a Image
:: Input Parameters [ %~1 : Image Mount Path, %~2 : Feature Name ]
::-------------------------------------------------------------------------------------------
:EnableFeature

%DISM% /Image:%~1 /Enable-Feature /FeatureName:%~2
echo.

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to disable a feature inside a Image
:: Input Parameters [ %~1 : Image Mount Path, %~2 : Feature Name ]
::-------------------------------------------------------------------------------------------
:DisableFeature

%DISM% /Image:%~1 /Disable-Feature /FeatureName:%~2
echo.

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to export a list of packages present inside a Image to a file
:: Input Parameters [ %~1 : Image Mount Path, %~2 : Filename ]
::-------------------------------------------------------------------------------------------
:GetPackages

%DISM% /Get-Packages /Image:%~1 > %Logs%\%~2

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to export the list of features present inside a Image to a file
:: Input Parameters [ %~1 : Image Mount Path, %~2 : Filename ]
::-------------------------------------------------------------------------------------------
:GetFeatures

%DISM% /Get-Features /Format:Table /Image:%~1 > %Logs%\%~2

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to add a Package to Image
:: Input Parameters [ %~1 : Image Mount Path, %~2 : Packages Path / Package Name ]
::-------------------------------------------------------------------------------------------
:AddPackage

%DISM% /Image:%~1 /Add-Package /PackagePath:%~2
echo.

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to remove a Package from a Image
:: Input Parameters [ %~1 : Image Mount Path, %~2 : Packages Path / Package Name ]
::-------------------------------------------------------------------------------------------
:RemovePackage

%DISM% /Image:%~1 /Remove-Package /PackageName:%~2
echo.

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to add a provisioned appx package to a Image
:: Input Parameters [ %~1 : Image Mount Path, %~2 : App Name, %~3 : App Package Path, %~4 : App License Path, %~5 : App Dependency Packages Path ]
::-------------------------------------------------------------------------------------------
:AddProvisionedAppxPackage

echo.-------------------------------------------------------------------------------
echo.Integrating %~2 Provisioned Appx Package...
echo.-------------------------------------------------------------------------------
%DISM% /Image:%~1 /Add-ProvisionedAppxPackage /PackagePath:%~3 /LicensePath:%~4 %~5
echo.

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to remove provisioned appx package from the Image
:: Input Parameters [ %~1 : Image Mount Path, %~2 : App Name, %~3 : Package Name ]
::-------------------------------------------------------------------------------------------
:RemoveProvisionedAppxPackage

setlocal

set PackageName=

echo.-------------------------------------------------------------------------------
echo.Removing %~2 Provisioned Appx Package...
echo.-------------------------------------------------------------------------------

:: Getting Provisioned Appx Package list
for /f "tokens=2 delims=: " %%a in ('%DISM% /Image:%~1 /Get-ProvisionedAppxPackages ^| find /I "PackageName : %~3"') do (set PackageName=%%a)

if "%PackageName%" equ "" (
	echo.
	echo.The specified Provisioned Appx Package has already been removed...
) else (
	:: Removing Provisioned Appx Package from the Image
	%DISM% /Image:%~1 /Remove-ProvisionedAppxPackage /PackageName:%PackageName%
)

echo.

set PackageName=

endlocal

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to remove the default application associations from the Windows image
:: Input Parameters [ %~1 : Image Mount Path ]
::-------------------------------------------------------------------------------------------
:RemoveDefaultAppAssociations

%DISM% /Image:%~1 /Remove-DefaultAppAssociations

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to import a set of default application associations to a Windows image
:: Input Parameters [ %~1 : Image Mount Path, %~2 : App Association XML Filename ]
::-------------------------------------------------------------------------------------------
:ImportDefaultAppAssociations

%DISM% /Image:%~1 /Import-DefaultAppAssociations:%~2

goto :eof
::-------------------------------------------------------------------------------------------

:: ############################################################################################
:: MSMG ToolKit Misc Functions 
:: ############################################################################################

::-------------------------------------------------------------------------------------------
:: Function to remove a Locked/Hidden Windows Package from the Image
:: Input Parameters [ %~1 : Image Mount Path, %~2 : Package Description, %~3 : Package Name ]
::-------------------------------------------------------------------------------------------
:RemoveLockedPackage

setlocal

set PackageName=

echo.-------------------------------------------------------------------------------
echo.Removing %~2 Package...
echo.-------------------------------------------------------------------------------

:: Making Locked/Hidden Windows Package visible
call :UnHidePackage "%~1", %~3

:: Getting Windows Package List
for /f "tokens=2 delims=:" %%a in ('%DISM% /Image:%~1 /Get-Packages ^| find /I "%~3"') do ( set PackageName=%%a )

if "%PackageName%" neq "" (
	if "%SelectedSourceOS%" equ "w7" (
		for /f "tokens=* delims= " %%a in ("%PackageName%") do set PackageName=%%a
		for /l %%a in (1,1,31) do if "!PackageName:~-1!" equ " " set PackageName=!PackageName:~0,-1!
	)
	if "%SelectedSourceOS%" neq "w7" set PackageName=%PackageName:~1,-1%
)

if "%PackageName%" equ "" (
	echo.
	echo.The specified package has already been removed...
	echo.
) else (
	:: Removing Windows Package from the Image
	%DISM% /Image:%~1 /Remove-Package /PackageName:%PackageName%
	echo.
)

set PackageName=

endlocal

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to remove a Windows Component from the Image using ToolKitHelper.exe
:: Input Parameters [ %~1 : Image Mount Path, %~2 : Component Description, %~3 : Component Name ]
::-------------------------------------------------------------------------------------------
:RemoveWindowsComponent

setlocal

set ComponentName=

echo.-------------------------------------------------------------------------------
echo.Removing %~2 Package...
echo.-------------------------------------------------------------------------------
%ToolKitHelper% %~1 %~3
echo.

:: Unmount Image Registry if Mounted/Abandoned
call :UnMountImageRegistry

set ComponentName=

endlocal

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to mount Image Registry
:: Input Parameters [ %~1 : Image Mount Path ]
::-------------------------------------------------------------------------------------------
:MountImageRegistry

:: Mounting Image Registry for Offline Editing
reg load HKLM\TK_COMPONENTS "%~1\Windows\System32\config\COMPONENTS" >nul
reg load HKLM\TK_DEFAULT "%~1\Windows\System32\config\default" >nul
reg load HKLM\TK_NTUSER "%~1\Users\Default\ntuser.dat" >nul
reg load HKLM\TK_SOFTWARE "%~1\Windows\System32\config\SOFTWARE" >nul
reg load HKLM\TK_SYSTEM "%~1\Windows\System32\config\SYSTEM" >nul

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to unmount Image Registry
:: Input Parameters [ None ]
::-------------------------------------------------------------------------------------------
:UnMountImageRegistry

:: Un-Mounting Image Registry
reg unload HKLM\TK_COMPONENTS >nul 2>&1
reg unload HKLM\TK_DRIVERS >nul 2>&1
reg unload HKLM\TK_DEFAULT >nul 2>&1
reg unload HKLM\TK_NTUSER >nul 2>&1
reg unload HKLM\TK_SCHEMA >nul 2>&1
reg unload HKLM\TK_SOFTWARE >nul 2>&1
reg unload HKLM\TK_SYSTEM >nul 2>&1

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to import registry settings to Image Registry
:: Input Parameters [ %~1 : Import Registry file Name ]
::-------------------------------------------------------------------------------------------
:ImportRegistry2Image

:: Importing registry settings to Image Registry
reg import "%~1"

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Create a Folder
:: Input Parameters [ %~1 : Foldername ]
::-------------------------------------------------------------------------------------------
:CreateFolder

if not exist "%~1" md "%~1" >nul

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to delete a file(s)
:: Input Parameters [ %~1 : Filename ]
::-------------------------------------------------------------------------------------------
:RemoveFile

if exist "%~1" del /f /q "%~1" >nul

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to delete a folder(s)
:: Input Parameters [ %~1 : Foldername ]
::-------------------------------------------------------------------------------------------
:RemoveFolder

if exist "%~1" rd /q /s "%~1" >nul

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to unhide a Windows Component Package
:: Input Parameters [ %~1 : Image Mount Path, %~2 : Package Name ]
::-------------------------------------------------------------------------------------------
:UnHidePackage

setlocal

set RegistryKey=

:: Mounting Image Registry
call :MountImageRegistry "%~1" >nul

:: Retriving Package Registry Key Path
for /f "tokens=* delims=" %%a in ('reg query "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages" /f "%~2" ^| find /I "%~2"') do ( set "RegistryKey=%%a" )

:: Making Windows Components Package visible
reg add "%RegistryKey%" /v Visibility /t REG_DWORD /d 1 /f >nul 2>&1
reg add "%RegistryKey%" /v DefVis /t REG_DWORD /d 2 /f >nul 2>&1
reg delete "%RegistryKey%\Owners" /f >nul 2>&1

:: Un-Mounting Image Registry
call :UnMountImageRegistry

set RegistryKey=

endlocal

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Cleanup MSMG Toolkit's temporary files and folders
::-------------------------------------------------------------------------------------------
:CleanUp

echo.Starting Cleaning Up...
echo.
echo.Cleaning Up Image Registry Mount Points...
call :UnMountImageRegistry
echo.
echo.Cleaning Up Image Mount Points...
Dism.exe /English /Quiet /Unmount-Wim /MountDir:"%BootMount%\1" /Discard >nul
Dism.exe /English /Quiet /Unmount-Wim /MountDir:"%BootMount%\2" /Discard >nul

if exist "%WinReMount%\Windows" Dism.exe /English /Unmount-Wim /MountDir:"%WinReMount%" /Discard >nul
if exist "%InstallMount%\Windows" Dism.exe /English /Unmount-Wim /MountDir:"%InstallMount%" /Discard >nul

if not exist "%InstallMount%\Windows" (
	for /L %%i in (1, 1, 25) do (
		if exist "%InstallMount%\%%i\Windows" Dism.exe /English /Unmount-Wim /MountDir:"%InstallMount%\%%i" /Discard >nul
	)
)

Dism.exe /English /Cleanup-Mountpoints >nul
Dism.exe /English /Cleanup-Wim >nul

:: Cleaning Up Images Mount Points Folders
call :RemoveFolder "%BootMount%"
call :CreateFolder "%BootMount%\1"
call :CreateFolder "%BootMount%\2"
call :RemoveFolder "%InstallMount%"
call :CreateFolder "%InstallMount%"
call :RemoveFolder "%WinReMount%"
call :CreateFolder "%WinReMount%"
echo.

:: Cleaning Up Logs Folders
echo.Cleaning Up Logs files...
call :RemoveFolder "%Logs%"
call :CreateFolder "%Logs%"
echo.

:: Cleaning Up Temporary files Folders
echo.Cleaning Up Temporary files...
call :RemoveFolder "%Temp%"
call :CreateFolder "%Temp%"

echo.
echo.Finished Cleaning Up...
echo.

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to quit MSMG Toolkit
::-------------------------------------------------------------------------------------------
:Quit

cls
echo.===============================================================================
echo. 	                    MSMG ToolKit - Quit
echo.===============================================================================
echo.
if "%IsSourceSelected%" equ "Yes" (
	echo.Source OS is selected, please do choose Save/Discard from "Apply" Main Menu..
	echo.
	echo.===============================================================================
	echo.
	pause
	
	goto :Mainmenu
)
echo.Performing Post-cleanup operation, please wait...
echo.
call :CleanUp
echo.Thanks ^& Credits to Everyone at MDL...
echo.
echo.Quitting MSMG ToolKit...
echo.
echo.===============================================================================
echo.
pause

:: Restoring DOS Window Size
reg delete "HKCU\Console\%%SystemRoot%%_system32_cmd.exe" /f >nul

color 00
endlocal EnableExtensions
endlocal EnableDelayedExpansion

exit